#pragma once

#include "codegenv2.h"

struct Instr_Def InstrTableV2[] = {

  /* | mnemonic | operand count | operand types | encoding group | flags | opcode len | opcode bytes | op size | modRM | sib | OSO | ASO | Valid segment modes | opnd direction | mandatory prefix type | immediate Operand? | memory Operand? | CPU mode | */

  /* No operand gp instructions */
  { "aaa",    0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0x37, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "aad",    0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xd5, 0x0a, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "aad",    1, { IMM8,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0xd5, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32), NO_DST, NO_PREFIX, IMM_OPND_0, NO_MEM, P_86, 0, NULL },
  { "aam",    0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xd4, 0x0a, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "aam",    1, { IMM8,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0xd4, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32), NO_DST, NO_PREFIX, IMM_OPND_0, NO_MEM, P_86, 0, NULL },
  { "aas",    0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0x3f, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "clc",    0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0xf8, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "cld",    0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0xfc, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "cli",    0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0xfa, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "clts",   0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x06, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "cmc",    0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0xf5, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "cpuid",  0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0xa2, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "popa",   0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0x61, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "popad",  0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0x61, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "popaw",  0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0x61, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "popfd",  0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0x9d, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "pushd",  1, { R32_EAX,          }, GP4,  (F_OPCODE_REG),									               NO_VEX, NO_EVEX, 1, 1, { 0x50, 0x00, 0x00 }, 4,  0, NO_MOD,      0, 0, 0,                        (X16 | X32), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
  { "pushd",  1, { R32,              }, GP4,  (F_OPCODE_REG),									               NO_VEX, NO_EVEX, 1, 1, { 0x50, 0x00, 0x00 }, 4,  0, NO_MOD,      0, 0, 0,                        (X16 | X32), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
  { "pushd",  1, { R_SEG,            }, GP4,  (F_OPCODE_REG),							                   NO_VEX, NO_EVEX, 1, 1, { 0x06, 0x00, 0x00 }, 1,  0, NO_MOD,      0, 0, 0,                        (X16 | X32), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
  { "pushd",  1, { M32,              }, GP4,   ALLOW_SEG,                                    NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 4,  0, 0x30, 0, 0, ADDR_SIZE_OVERRIDE,              (X16 | X32), RM_DST,   NO_PREFIX,  NO_IMM,      MEM_OPND_0, P_86,  0, NULL },
  { "pushd",  1, { M_ANY,            }, GP4,   ALLOW_SEG,                                    NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 4,  0, 0x30, 0, 0, ADDR_SIZE_OVERRIDE,              (X16 | X32), RM_DST,   NO_PREFIX,  NO_IMM,      MEM_OPND_0, P_86,  0, NULL },
  { "pushd",  1, { R16_AX,           }, GP4,  (F_OPCODE_REG),									               NO_VEX, NO_EVEX, 1, 1, { 0x50, 0x00, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,         (X16 | X32), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
  { "pushd",  1, { R16,              }, GP4,  (F_OPCODE_REG),									               NO_VEX, NO_EVEX, 1, 1, { 0x50, 0x00, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,         (X16 | X32), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
  { "pushd",  1, { M16,              }, GP4,   ALLOW_SEG,                                    NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 2,  0, 0x30,        0, OP_SIZE_OVERRIDE, 0,         (X16 | X32), RM_DST,   NO_PREFIX,  NO_IMM,      MEM_OPND_0, P_486, 0, NULL },
  { "pushd",  1, { M_ANY,            }, GP4,   ALLOW_SEG,                                    NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 8,  0, 0x30,        0, 0, ADDR_SIZE_OVERRIDE,       (X16 | X32), RM_DST,   NO_PREFIX,  NO_IMM,      MEM_OPND_0, P_64,  0, NULL },
  { "pushd",  1, { IMM8,             }, GP4,  0,		                                         NO_VEX, NO_EVEX, 1, 1, { 0x6a, 0x00, 0x00 }, 1,  0, MOD_MEM_IMM, 0, 0, 0,                        (X16 | X32), NO_DST,   NO_PREFIX, IMM_OPND_0,   NO_MEM,     P_86,  0, NULL },
  { "pushd",  1, { IMM32,            }, GP4,  0,		                                         NO_VEX, NO_EVEX, 1, 1, { 0x68, 0x00, 0x00 }, 4,  0, MOD_MEM_IMM, 0, 0, 0,                              (X32), NO_DST,   NO_PREFIX, IMM_OPND_0,   NO_MEM,     P_386, 0, NULL },
  { "pusha",  0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0x60, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "pushad", 0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0x60, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "pushaw", 0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0x60, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "pushfd", 0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0x9c, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "daa",    0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0x27, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "das",    0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0x2f, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "hlt",    0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0xf4, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "invd",   0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x08, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "lahf",   0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0x9f, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "leave",  0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0xc9, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "stc",    0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0xf9, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "std",    0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0xfd, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "sti",    0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0xfb, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  //CBW, CWDE, 98 REX.W + 98 CDQE
  { "cbw",    0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0x98, 0x00, 0x00 }, 2, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "cwd",    0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0x99, 0x00, 0x00 }, 2, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "cdq",    0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0x99, 0x00, 0x00 }, 4, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "cwde",   0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0x98, 0x00, 0x00 }, 4, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "cdqe",   0, { OP_N,     OP_N    }, GP1, (REX | REXW),														NO_VEX, NO_EVEX, 1, 1, { 0x98, 0x00, 0x00 }, 8, 0, NO_MOD,      0, 0,                0,                              (X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_64, 0, NULL },

  //CLAC NP 0F 01 CA vmload
  { "clac",   0, { OP_N,     OP_N    }, GP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0x01, 0xca, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, PFX_0xF, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "clts",   0, { OP_N,     OP_N    }, GP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x06, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, PFX_0xF, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "into",   0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0xce, 0x00, 0x00 }, 4, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "iret",   0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0xcf, 0x00, 0x00 }, 4, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "iretd",  0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0xcf, 0x00, 0x00 }, 4, 0, NO_MOD,      0, 0,                0,                  (X16 | X32), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_386, 0, NULL },
  { "iretf",  0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0xcf, 0x00, 0x00 }, 4, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "iretdf", 0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0xcf, 0x00, 0x00 }, 4, 0, NO_MOD,      0, 0,                0,                  (X16 | X32), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_386, 0, NULL },
  { "nop",    0, { OP_N,     OP_N    }, GP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0x90, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
  { "rdmsr",  0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0x32, 0x00, 0x00 }, 4, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, PFX_0xF, NO_IMM, NO_MEM, P_586, 0, NULL },
  { "rdpmc",  0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0x33, 0x00, 0x00 }, 4, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, PFX_0xF, NO_IMM, NO_MEM, P_586, 0, NULL },
  { "rdtsc",  0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0x31, 0x00, 0x00 }, 4, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, PFX_0xF, NO_IMM, NO_MEM, P_586, 0, NULL },
  { "rdtscp", 0, { OP_N,     OP_N    }, GP1, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0x01, 0xf9, 0x00 }, 4, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, PFX_0xF, NO_IMM, NO_MEM, P_686, 0, NULL },
 
  { "wait",   0, { OP_N,     OP_N    }, GP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0x9b, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86,  0, NULL },
  { "ud2",    0, { OP_N,     OP_N    }, GP2, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0x0b, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, PFX_0xF,   NO_IMM, NO_MEM, P_686, 0, NULL },
  { "wbinvd", 0, { OP_N,     OP_N    }, GP2, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0x09, 0x00, 0x00 }, 4, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, PFX_0xF,   NO_IMM, NO_MEM, P_486, 0, NULL },
  { "wrmsr",  0, { OP_N,     OP_N    }, GP2, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0x30, 0x00, 0x00 }, 4, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, PFX_0xF,   NO_IMM, NO_MEM, P_586, 0, NULL },
  //14 ib ADC AL, imm8
  { "adc",    2, { R8_AL,    IMM8    }, GP0, (F_OPCODE_REG),												                                  NO_VEX, NO_EVEX, 1, 1, { 0x14, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,				         0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
  //15 iw ADC AX, imm16 I Valid Valid ADC imm16 to AX.
  //15 id ADC EAX, imm32 I Valid Valid ADC imm32 to EAX.
  //REX.W + 15 id ADC RAX, imm32 I Valid N.E.ADC imm32 sign extended to 64 - bits to RAX.
  { "adc",    2, { R16_AX,   IMM16   }, GP0, (F_OPCODE_REG),												                                  NO_VEX, NO_EVEX, 1, 1, { 0x15, 0x00, 0x00 }, 2, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
  { "adc",    2, { R32_EAX,  IMM32   }, GP0, (F_OPCODE_REG),												                                  NO_VEX, NO_EVEX, 1, 1, { 0x15, 0x00, 0x00 }, 4, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
  { "adc",    2, { R64_RAX,  IMM32   }, GP3, (REX | REXW) | (F_OPCODE_REG),						                                NO_VEX, NO_EVEX, 1, 1, { 0x15, 0x00, 0x00 }, 4, 0, NO_MOD,      0, 0,				         0,                              (X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
  //80 / 2 ib ADC r / m8, imm8 MI Valid Valid ADC imm8 to r / m8.
  //REX + 80 / 2 ib ADC r / m8 * , imm8 MI Valid N.E.ADC imm8 to r / m8.
  { "adc",    2, { R8,       IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),		                      NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x02, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,	               0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
  { "adc",    2, { R8H,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                        NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x02, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,	               0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
  { "adc",    2, { R8U,      IMM8    }, GP3, REX | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),									  NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x02, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,				         0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
  { "adc",    2, { R8E,      IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),				  NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x02, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,				         0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
  { "adc",    2, { M8,       IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									        NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x02, 0x00 }, 1, 0, MOD_MEM_IMM, 0, 0,	               ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
  //81 / 2 iw ADC r / m16, imm16
  //81 / 2 id ADC r / m32, imm32
  //REX.W + 81 / 2 id ADC r / m64, imm32
{ "adc",    2, { R16,      IMM16   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x02, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "adc",    2, { R16E,     IMM16   }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),								      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x02, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "adc",    2, { M16,      IMM16   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x02, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "adc",    2, { R32,      IMM32   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x02, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "adc",    2, { R32E,     IMM32   }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),								      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x02, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "adc",    2, { R32,      IMM16   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x02, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "adc",    2, { R32E,     IMM16   }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),								      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x02, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "adc",    2, { M32,      IMM32   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x02, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "adc",    2, { R64,      IMM32   }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),                      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x02, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "adc",    2, { R64,      IMM16   }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),                      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x02, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "adc",    2, { R64E,     IMM32   }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),               NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x02, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "adc",    2, { R64E,     IMM16   }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),               NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x02, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "adc",    2, { M64,      IMM32   }, GP3, REXW | (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                          NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x02, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_64,  0, NULL },
//83 / 2 ib ADC r / m16, imm8
//83 / 2 ib ADC r / m32, imm8
//REX.W + 83 / 2 ib ADC r / m64, imm8
{ "adc",    2, { R16,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x02, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "adc",    2, { R16E,     IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x02, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "adc",    2, { M16,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x02, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "adc",    2, { R32,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x02, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "adc",    2, { R32E,     IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x02, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "adc",    2, { M32,      IMM8    }, GP0, ALLOW_SEG | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	            NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x02, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "adc",    2, { R64,      IMM8    }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),          NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x02, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "adc",    2, { R64E,     IMM8    }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),   NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x02, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,				         0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "adc",    2, { M64,      IMM8    }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),		      NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x02, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0,ADDR_SIZE_OVERRIDE,                             (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_64,  0, NULL },
//10 / r ADC r / m8, r8
//REX + 10 / r ADC r / m8 *, r8 *
{ "adc",    2, { M_ANY,    R8      }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0x10, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "adc",    2, { M_ANY,    R8H     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0x10, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "adc",    2, { M_ANY,    R8E     }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x10, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "adc",    2, { M_ANY,    R8U     }, GP3, ALLOW_SEG | (REX) | (F_MODRM | F_MODRM_REG),						                  NO_VEX, NO_EVEX, 1, 1, { 0x10, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
//11 / r ADC r / m16, r16
//11 / r ADC r / m32, r32
//REX.W + 11 / r ADC r / m64, r64
{ "adc",     2, { M_ANY,    R16     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x11, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "adc",     2, { M_ANY,    R16E    }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x11, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "adc",     2, { M_ANY,    R32     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x11, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "adc",     2, { M_ANY,    R32E    }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x11, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "adc",     2, { M_ANY,    R64     }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),			                NO_VEX, NO_EVEX, 1, 1, { 0x11, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "adc",     2, { M_ANY,    R64E    }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	            NO_VEX, NO_EVEX, 1, 1, { 0x11, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
//12 / r ADC r8, r / m8
//REX + 12 / r ADC r8*, r / m8 *
{ "adc",     2, { R8,       R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),          NO_VEX, NO_EVEX, 1, 1, { 0x12, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "adc",     2, { R8,       R8H     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		      NO_VEX, NO_EVEX, 1, 1, { 0x12, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "adc",     2, { R8H,      R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		      NO_VEX, NO_EVEX, 1, 1, { 0x12, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "adc",     2, { R8H,      R8H     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		      NO_VEX, NO_EVEX, 1, 1, { 0x12, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "adc",     2, { R8E,      R8E     }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	            NO_VEX, NO_EVEX, 1, 1, { 0x12, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "adc",     2, { R8,       R8E     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x12, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "adc",     2, { R8E,      R8      }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x12, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "adc",     2, { R8U,      R8      }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					                  NO_VEX, NO_EVEX, 1, 1, { 0x12, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "adc",     2, { R8U,      R8E     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					          NO_VEX, NO_EVEX, 1, 1, { 0x12, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "adc",     2, { R8,       R8U     }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					                  NO_VEX, NO_EVEX, 1, 1, { 0x12, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "adc",     2, { R8,       M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x12, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "adc",     2, { R8H,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x12, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "adc",     2, { R8E,      M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x12, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,                            (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "adc",     2, { R8U,      M_ANY   }, GP3, ALLOW_SEG | (REX) | (F_MODRM | F_MODRM_REG),						                NO_VEX, NO_EVEX, 1, 1, { 0x12, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,                            (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
//13 / r ADC r16, r / m16
//13 / r ADC r32, r / m32
//REX.W + 13 / r ADC r64, r / m64
{ "adc",     2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                      NO_VEX, NO_EVEX, 1, 1, { 0x13, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "adc",     2, { R16E,     R16E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),             NO_VEX, NO_EVEX, 1, 1, { 0x13, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "adc",     2, { R16E,     R16     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x13, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "adc",     2, { R16,      R16E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x13, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "adc",     2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                      NO_VEX, NO_EVEX, 1, 1, { 0x13, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "adc",     2, { R32E,     R32E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	            NO_VEX, NO_EVEX, 1, 1, { 0x13, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "adc",     2, { R32E,     R32     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x13, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "adc",     2, { R32,      R32E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x13, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "adc",     2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                NO_VEX, NO_EVEX, 1, 1, { 0x13, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "adc",     2, { R64E,     R64E    }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),      NO_VEX, NO_EVEX, 1, 1, { 0x13, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "adc",     2, { R64,      R64E    }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x13, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "adc",     2, { R64E,     R64     }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x13, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "adc",     2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x13, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "adc",     2, { R16E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x13, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "adc",     2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x13, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "adc",     2, { R32E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x13, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "adc",     2, { R64,      M_ANY   }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				              NO_VEX, NO_EVEX, 1, 1, { 0x13, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "adc",     2, { R64E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	            NO_VEX, NO_EVEX, 1, 1, { 0x13, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },

//04 ib ADD AL, imm8 I Valid Valid Add imm8 to AL.
{ "add",    2, { R8_AL,    IMM8    }, GP0, (F_OPCODE_REG),												                                  NO_VEX, NO_EVEX, 1, 1, { 0x04, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,				         0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
//05 iw ADD AX, imm16 I Valid Valid Add imm16 to AX.
//05 id ADD EAX, imm32 I Valid Valid Add imm32 to EAX.
//REX.W + 05 id ADD RAX, imm32 I Valid N.E.Add imm32 sign - extended to 64 - bits to RAX.
{ "add",    2, { R16_AX,   IMM16   }, GP0, (F_OPCODE_REG),												                                  NO_VEX, NO_EVEX, 1, 1, { 0x05, 0x00, 0x00 }, 2, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "add",    2, { R32_EAX,  IMM32   }, GP0, (F_OPCODE_REG),												                                  NO_VEX, NO_EVEX, 1, 1, { 0x05, 0x00, 0x00 }, 4, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "add",    2, { R64_RAX,  IMM32   }, GP3, (REX | REXW) | (F_OPCODE_REG),						                                NO_VEX, NO_EVEX, 1, 1, { 0x05, 0x00, 0x00 }, 4, 0, NO_MOD,      0, 0,				         0,                  (X64), NO_DST,              NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
//80 / 0 ib ADD r / m8, imm8 MI Valid Valid Add imm8 to r / m8.
//REX + 80 / 0 ib ADD r / m8 * , imm8 MI Valid N.E.Add sign - extended imm8 to r / m8.
{ "add",    2, { R8,       IMM8    }, GP0, REX | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),		                NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,	               0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "add",    2, { R8H,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                        NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,	               0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "add",    2, { R8U,      IMM8    }, GP3, REX | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),									  NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,				         0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "add",    2, { R8E,      IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),				  NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,				         0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "add",    2, { M8,       IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									        NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x00, 0x00 }, 1, 0, MOD_MEM_IMM, 0, 0,	               ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
//81 / 0 iw ADD r / m16, imm16 MI Valid Valid Add imm16 to r / m16.
//81 / 0 id ADD r / m32, imm32 MI Valid Valid Add imm32 to r / m32.
//REX.W + 81 / 0 id ADD r / m64, imm32 MI Valid N.E.Add imm32 sign - extended to 64 - bits to r / m64.
{ "add",    2, { R16,      IMM16   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "add",    2, { R16E,     IMM16   }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),								      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "add",    2, { M16,      IMM16   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x00, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "add",    2, { R32,      IMM32   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "add",    2, { R32E,     IMM32   }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),								      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "add",    2, { R32,      IMM16   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "add",    2, { R32E,     IMM16   }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),								      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "add",    2, { M32,      IMM32   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "add",    2, { R64,      IMM32   }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),                      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "add",    2, { R64,      IMM16   }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),                      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "add",    2, { R64E,     IMM16   }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),               NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "add",    2, { R64E,     IMM32   }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),               NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "add",    2, { M64,      IMM32   }, GP3, REXW | (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                          NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_64,  0, NULL },
//83 / 0 ib ADD r / m16, imm8 MI Valid Valid Add sign - extended imm8 to r / m16.
//83 / 0 ib ADD r / m32, imm8 MI Valid Valid Add sign - extended imm8 to r / m32.
//REX.W + 83 / 0 ib ADD r / m64, imm8 MI Valid N.E.Add sign - extended imm8 to r / m64.
{ "add",    2, { R16,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "add",    2, { R16E,     IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "add",    2, { M16,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x00, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "add",    2, { R32,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "add",    2, { R32E,     IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "add",    2, { M32,      IMM8    }, GP0, ALLOW_SEG | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	            NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "add",    2, { R64,      IMM8    }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),          NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "add",    2, { R64E,     IMM8    }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),   NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,				         0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "add",    2, { M64,      IMM8    }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),		      NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0,ADDR_SIZE_OVERRIDE,                             (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_64,  0, NULL },
//00 / r ADD r8, r / m8                   
//REX + 00 / r ADD r / m8 * , r8*  
{ "add",    2, { M_ANY,    R8      }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0x00, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "add",    2, { M_ANY,    R8H     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0x00, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "add",    2, { M_ANY,    R8E     }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x00, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "add",    2, { M_ANY,    R8U     }, GP3, ALLOW_SEG | (REX) | (F_MODRM | F_MODRM_REG),						                  NO_VEX, NO_EVEX, 1, 1, { 0x00, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
//01 / r ADD r / m16, r16 MR Valid Valid Add r16 to r / m16.
//01 / r ADD r / m32, r32 MR Valid Valid Add r32 to r / m32.
//REX.W + 01 / r ADD r / m64, r64 MR Valid N.E.Add r64 to r / m64.
{ "add",     2, { M_ANY,    R16     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x01, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "add",     2, { M_ANY,    R16E    }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x01, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "add",     2, { M_ANY,    R32     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x01, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "add",     2, { M_ANY,    R32E    }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x01, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "add",     2, { M_ANY,    R64     }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),			                NO_VEX, NO_EVEX, 1, 1, { 0x01, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "add",     2, { M_ANY,    R64E    }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	            NO_VEX, NO_EVEX, 1, 1, { 0x01, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
//02 / r ADD r8, r / m8            OR r8, r / m8
//REX + 02 / r ADD r8*, r / m8 *   OR r8*, r / m8 *
{ "add",     2, { R8,       R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),          NO_VEX, NO_EVEX, 1, 1, { 0x02, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "add",     2, { R8,       R8H     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		      NO_VEX, NO_EVEX, 1, 1, { 0x02, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "add",     2, { R8H,      R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		      NO_VEX, NO_EVEX, 1, 1, { 0x02, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "add",     2, { R8H,      R8H     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		      NO_VEX, NO_EVEX, 1, 1, { 0x02, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "add",     2, { R8E,      R8E     }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	            NO_VEX, NO_EVEX, 1, 1, { 0x02, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "add",     2, { R8,       R8E     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x02, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "add",     2, { R8E,      R8      }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x02, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "add",     2, { R8U,      R8      }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					                  NO_VEX, NO_EVEX, 1, 1, { 0x02, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "add",     2, { R8U,      R8E     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					          NO_VEX, NO_EVEX, 1, 1, { 0x02, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "add",     2, { R8,       R8U     }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					                  NO_VEX, NO_EVEX, 1, 1, { 0x02, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "add",     2, { R8,       M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x02, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "add",     2, { R8H,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x02, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "add",     2, { R8E,      M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x02, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,                            (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "add",     2, { R8U,      M_ANY   }, GP3, ALLOW_SEG | (REX) | (F_MODRM | F_MODRM_REG),						                NO_VEX, NO_EVEX, 1, 1, { 0x02, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,                            (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
//03 / r ADD r16, r / m16 RM Valid Valid Add r / m16 to r16.
//03 / r ADD r32, r / m32 RM Valid Valid Add r / m32 to r32.
//REX.W + 03 / r ADD r64, r / m64 RM Valid N.E.Add r / m64 to r64.  { "add",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                  NO_VEX, NO_EVEX, 1, 1, { 0x13, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "add",     2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                      NO_VEX, NO_EVEX, 1, 1, { 0x03, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "add",     2, { R16E,     R16E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),             NO_VEX, NO_EVEX, 1, 1, { 0x03, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "add",     2, { R16E,     R16     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x03, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "add",     2, { R16,      R16E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x03, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "add",     2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                      NO_VEX, NO_EVEX, 1, 1, { 0x03, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "add",     2, { R32E,     R32E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	            NO_VEX, NO_EVEX, 1, 1, { 0x03, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "add",     2, { R32E,     R32     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x03, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "add",     2, { R32,      R32E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x03, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "add",     2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                NO_VEX, NO_EVEX, 1, 1, { 0x03, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "add",     2, { R64E,     R64E    }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),      NO_VEX, NO_EVEX, 1, 1, { 0x03, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "add",     2, { R64,      R64E    }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x03, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "add",     2, { R64E,     R64     }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x03, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "add",     2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x03, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "add",     2, { R16E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x03, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "add",     2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x03, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "add",     2, { R32E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x03, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "add",     2, { R64,      M_ANY   }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				              NO_VEX, NO_EVEX, 1, 1, { 0x03, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "add",     2, { R64E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	            NO_VEX, NO_EVEX, 1, 1, { 0x03, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },

//0C ib           	OR AL, imm8
{ "or",     2, { R8_AL,    IMM8    }, GP0, (F_OPCODE_REG),												                                  NO_VEX, NO_EVEX, 1, 1, { 0x0c, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,				         0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
//0D iw           	OR AX, imm16
//0D id           	OR EAX, imm32
//REX.W + 0D id   	OR RAX, imm32
{ "or",     2, { R16_AX,   IMM16   }, GP0, (F_OPCODE_REG),												                                  NO_VEX, NO_EVEX, 1, 1, { 0x0d, 0x00, 0x00 }, 2, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "or",     2, { R32_EAX,  IMM32   }, GP0, (F_OPCODE_REG),												                                  NO_VEX, NO_EVEX, 1, 1, { 0x0d, 0x00, 0x00 }, 4, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "or",     2, { R64_RAX,  IMM32   }, GP3, (REX | REXW) | (F_OPCODE_REG),						                                NO_VEX, NO_EVEX, 1, 1, { 0x0d, 0x00, 0x00 }, 4, 0, NO_MOD,      0, 0,				         0,                  (X64), NO_DST,              NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
//80 / 1 ib        	OR r / m8, imm8
//REX + 80 / 1 ib  	OR r / m8 *, imm8
{ "or",     2, { R8,       IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),		                      NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x01, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,	               0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "or",     2, { R8H,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                        NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x01, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,	               0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "or",     2, { R8U,      IMM8    }, GP3, REX | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),									  NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x01, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,				         0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "or",     2, { R8E,      IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),				  NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x01, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,				         0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "or",     2, { M8,       IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									        NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x01, 0x00 }, 1, 0, MOD_MEM_IMM, 0, 0,	               ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
//81 / 1 iw        	OR r / m16, imm16
//81 / 1 id        	OR r / m32, imm32
//REX.W + 81 / 1 id	OR r / m64, imm32
{ "or",     2, { R16,      IMM16   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x01, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "or",     2, { R16E,     IMM16   }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),								      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x01, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "or",     2, { M16,      IMM16   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x01, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "or",     2, { R32,      IMM32   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x01, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "or",     2, { R32E,     IMM32   }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),								      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x01, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "or",     2, { R32,      IMM16   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x01, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "or",     2, { R32E,     IMM16   }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),								      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x01, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "or",     2, { M32,      IMM32   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x01, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "or",     2, { R64,      IMM32   }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),                      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x01, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "or",     2, { R64,      IMM16   }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),                      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x01, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "or",     2, { R64E,     IMM32   }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),                      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x01, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "or",     2, { R64E,     IMM16   }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),                      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x01, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "or",     2, { M64,      IMM32   }, GP3, REXW | (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                          NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x01, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_64,  0, NULL },
//83 / 1 ib        	OR r / m16, imm8
//83 / 1 ib        	OR r / m32, imm8
//REX.W + 83 / 1 ib	OR r / m64, imm8
{ "or",     2, { R16,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x01, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "or",     2, { R16E,     IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x01, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "or",     2, { M16,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x01, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "or",     2, { R32,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x01, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "or",     2, { R32E,     IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x01, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "or",     2, { M32,      IMM8    }, GP0, ALLOW_SEG | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	            NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x01, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "or",     2, { R64,      IMM8    }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),          NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x01, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "or",     2, { R64E,     IMM8    }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),   NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x01, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,				         0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "or",     2, { M64,      IMM8    }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),		      NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x01, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0,ADDR_SIZE_OVERRIDE,                             (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_64,  0, NULL },
//08 / r OR r / m8, r8
//REX + 08 / r OR r / m8 *, r8*
{ "or",     2, { M_ANY,    R8      }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0x08, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "or",     2, { M_ANY,    R8H     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0x08, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "or",     2, { M_ANY,    R8E     }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x08, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "or",     2, { M_ANY,    R8U     }, GP3, ALLOW_SEG | (REX) | (F_MODRM | F_MODRM_REG),						                  NO_VEX, NO_EVEX, 1, 1, { 0x08, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
//09 / r           	OR r / m16, r16
//09 / r           	OR r / m32, r32
//REX.W + 09 / r   	OR r / m64, r64
{ "or",     2, { M_ANY,    R16     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0x09, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "or",     2, { M_ANY,    R16E    }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x09, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "or",     2, { M_ANY,    R32     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0x09, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "or",     2, { M_ANY,    R32E    }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x09, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "or",     2, { M_ANY,    R64     }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),			                NO_VEX, NO_EVEX, 1, 1, { 0x09, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "or",     2, { M_ANY,    R64E    }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 1, 1, { 0x09, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
//0A / r           	OR r8, r / m8
//REX + 0A / r     	OR r8*, r / m8 *
{ "or",     2, { R8,       R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),           NO_VEX, NO_EVEX, 1, 1, { 0x0a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "or",     2, { R8,       R8H     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		        NO_VEX, NO_EVEX, 1, 1, { 0x0a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "or",     2, { R8H,      R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		        NO_VEX, NO_EVEX, 1, 1, { 0x0a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "or",     2, { R8H,      R8H     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		        NO_VEX, NO_EVEX, 1, 1, { 0x0a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "or",     2, { R8E,      R8E     }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	            NO_VEX, NO_EVEX, 1, 1, { 0x0a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "or",     2, { R8,       R8E     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				              NO_VEX, NO_EVEX, 1, 1, { 0x0a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "or",     2, { R8E,      R8      }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				              NO_VEX, NO_EVEX, 1, 1, { 0x0a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "or",     2, { R8U,      R8      }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					                  NO_VEX, NO_EVEX, 1, 1, { 0x0a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "or",     2, { R8U,      R8E     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					            NO_VEX, NO_EVEX, 1, 1, { 0x0a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "or",     2, { R8,       R8U     }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					                  NO_VEX, NO_EVEX, 1, 1, { 0x0a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "or",     2, { R8,       M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0x0a, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "or",     2, { R8H,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0x0a, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "or",     2, { R8E,      M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x0a, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,                            (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "or",     2, { R8U,      M_ANY   }, GP3, ALLOW_SEG | (REX) | (F_MODRM | F_MODRM_REG),						                  NO_VEX, NO_EVEX, 1, 1, { 0x0a, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,                            (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
//0B / r           	OR r16, r / m16
//0B / r           	OR r32, r / m32
//REX.W + 0B / r   	OR r64, r / m64
{ "or",     2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                      NO_VEX, NO_EVEX, 1, 1, { 0x0b, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "or",     2, { R16E,     R16E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),              NO_VEX, NO_EVEX, 1, 1, { 0x0b, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "or",     2, { R16E,     R16     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				              NO_VEX, NO_EVEX, 1, 1, { 0x0b, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "or",     2, { R16,      R16E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				              NO_VEX, NO_EVEX, 1, 1, { 0x0b, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "or",     2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                      NO_VEX, NO_EVEX, 1, 1, { 0x0b, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "or",     2, { R32E,     R32E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	            NO_VEX, NO_EVEX, 1, 1, { 0x0b, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "or",     2, { R32E,     R32     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				              NO_VEX, NO_EVEX, 1, 1, { 0x0b, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "or",     2, { R32,      R32E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				              NO_VEX, NO_EVEX, 1, 1, { 0x0b, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "or",     2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                  NO_VEX, NO_EVEX, 1, 1, { 0x0b, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "or",     2, { R64E,     R64E    }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),       NO_VEX, NO_EVEX, 1, 1, { 0x0b, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "or",     2, { R64,      R64E    }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x0b, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "or",     2, { R64E,     R64     }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x0b, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "or",     2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0x0b, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "or",     2, { R16E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x0b, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "or",     2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0x0b, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "or",     2, { R32E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x0b, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "or",     2, { R64,      M_ANY   }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				              NO_VEX, NO_EVEX, 1, 1, { 0x0b, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "or",     2, { R64E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 1, 1, { 0x0b, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
//34 ib XOR AL, imm8
{ "xor",     2, { R8_AL,    IMM8    }, GP0, (F_OPCODE_REG),												                                  NO_VEX, NO_EVEX, 1, 1, { 0x34, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,				         0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
//35 iw XOR AX, imm16
//35 id XOR EAX, imm32
//REX.W + 35 id XOR RAX, imm32
{ "xor",     2, { R16_AX,   IMM16   }, GP0, (F_OPCODE_REG),												                                  NO_VEX, NO_EVEX, 1, 1, { 0x35, 0x00, 0x00 }, 2, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "xor",     2, { R32_EAX,  IMM32   }, GP0, (F_OPCODE_REG),												                                  NO_VEX, NO_EVEX, 1, 1, { 0x35, 0x00, 0x00 }, 4, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "xor",     2, { R64_RAX,  IMM32   }, GP3, (REX | REXW) | (F_OPCODE_REG),					                                NO_VEX, NO_EVEX, 1, 1, { 0x35, 0x00, 0x00 }, 4, 0, NO_MOD,      0, 0,				         0,                  (X64), NO_DST,              NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
//80 / 6 ib XOR r / m8, imm8
//REX + 80 / 6 ib XOR r / m8 *, imm8
{ "xor",    2, { R8,       IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),		                      NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x06, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,	               0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "xor",    2, { R8H,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                        NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x06, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,	               0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "xor",    2, { R8U,      IMM8    }, GP3, REX | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),									  NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x06, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,				         0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "xor",    2, { R8E,      IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),				  NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x06, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,				         0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "xor",    2, { M8,       IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									        NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x06, 0x00 }, 1, 0, MOD_MEM_IMM, 0, 0,	               ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
//81 / 6 iw XOR r / m16, imm16
//81 / 6 id XOR r / m32, imm32
//REX.W + 81 / 6 id XOR r / m64, imm32
{ "xor",    2, { R16,      IMM16   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x06, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "xor",    2, { R16E,     IMM16   }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),								      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x06, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "xor",    2, { M16,      IMM16   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x06, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "xor",    2, { R32,      IMM32   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x06, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "xor",    2, { R32E,     IMM32   }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),								      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x06, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "xor",    2, { R32,      IMM16   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x06, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "xor",    2, { R32E,     IMM16   }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),								      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x06, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "xor",    2, { M32,      IMM32   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x06, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "xor",    2, { R64,      IMM32   }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),                      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x06, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "xor",    2, { R64,      IMM16   }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),                      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x06, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "xor",    2, { R64E,     IMM32   }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),                      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x06, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "xor",    2, { R64E,     IMM16   }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),                      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x06, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "xor",    2, { M64,      IMM32   }, GP3, REXW | (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                          NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x06, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_64,  0, NULL },
//83 / 6 ib XOR r / m16, imm8
//83 / 6 ib XOR r / m32, imm8
//REX.W + 83 / 6 ib XOR r / m64, imm8
{ "xor",    2, { R16,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x06, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "xor",    2, { R16E,     IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x06, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "xor",    2, { M16,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x06, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "xor",    2, { R32,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x06, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "xor",    2, { R32E,     IMM8    }, GP0, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x06, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "xor",    2, { M32,      IMM8    }, GP0, ALLOW_SEG | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	            NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x06, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "xor",    2, { R64,      IMM8    }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),          NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x06, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "xor",    2, { R64E,     IMM8    }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),   NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x06, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,				         0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "xor",    2, { M64,      IMM8    }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),		      NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x06, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0,ADDR_SIZE_OVERRIDE,                             (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_64,  0, NULL },
//30 / r XOR r / m8, r8
//REX + 30 / r XOR r / m8 *, r8*
{ "xor",    2, { M_ANY,    R8      }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0x30, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "xor",    2, { M_ANY,    R8H     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0x30, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "xor",    2, { M_ANY,    R8E     }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x30, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "xor",    2, { M_ANY,    R8U     }, GP3, ALLOW_SEG | (REX) | (F_MODRM | F_MODRM_REG),						                  NO_VEX, NO_EVEX, 1, 1, { 0x30, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
//31 / r XOR r / m16, r16
//31 / r XOR r / m32, r32
//REX.W + 31 / r XOR r / m64, r64
{ "xor",     2, { M_ANY,    R16     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x31, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "xor",     2, { M_ANY,    R16E    }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x31, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "xor",     2, { M_ANY,    R32     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x31, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "xor",     2, { M_ANY,    R32E    }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x31, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "xor",     2, { M_ANY,    R64     }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),			                NO_VEX, NO_EVEX, 1, 1, { 0x31, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "xor",     2, { M_ANY,    R64E    }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	            NO_VEX, NO_EVEX, 1, 1, { 0x31, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
//32 / r XOR r8, r / m8
//REX + 32 / r XOR r8*, r / m8 *
{ "xor",     2, { R8,       R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),          NO_VEX, NO_EVEX, 1, 1, { 0x32, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "xor",     2, { R8,       R8H     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		      NO_VEX, NO_EVEX, 1, 1, { 0x32, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "xor",     2, { R8H,      R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		      NO_VEX, NO_EVEX, 1, 1, { 0x32, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "xor",     2, { R8H,      R8H     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		      NO_VEX, NO_EVEX, 1, 1, { 0x32, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "xor",     2, { R8E,      R8E     }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	            NO_VEX, NO_EVEX, 1, 1, { 0x32, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xor",     2, { R8,       R8E     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x32, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xor",     2, { R8E,      R8      }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x32, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xor",     2, { R8U,      R8      }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					                  NO_VEX, NO_EVEX, 1, 1, { 0x32, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xor",     2, { R8U,      R8E     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					          NO_VEX, NO_EVEX, 1, 1, { 0x32, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xor",     2, { R8,       R8U     }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					                  NO_VEX, NO_EVEX, 1, 1, { 0x32, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xor",     2, { R8,       M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x32, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "xor",     2, { R8H,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x32, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "xor",     2, { R8E,      M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x32, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,                            (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "xor",     2, { R8U,      M_ANY   }, GP3, ALLOW_SEG | (REX) | (F_MODRM | F_MODRM_REG),						                NO_VEX, NO_EVEX, 1, 1, { 0x32, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,                            (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
//33 / r XOR r16, r / m16
//33 / r XOR r32, r / m32
//REX.W + 33 / r XOR r64, r / m64
{ "xor",     2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                      NO_VEX, NO_EVEX, 1, 1, { 0x33, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "xor",     2, { R16E,     R16E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),             NO_VEX, NO_EVEX, 1, 1, { 0x33, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xor",     2, { R16E,     R16     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x33, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xor",     2, { R16,      R16E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x33, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xor",     2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                      NO_VEX, NO_EVEX, 1, 1, { 0x33, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "xor",     2, { R32E,     R32E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	            NO_VEX, NO_EVEX, 1, 1, { 0x33, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xor",     2, { R32E,     R32     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x33, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xor",     2, { R32,      R32E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x33, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xor",     2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                NO_VEX, NO_EVEX, 1, 1, { 0x33, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xor",     2, { R64E,     R64E    }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),      NO_VEX, NO_EVEX, 1, 1, { 0x33, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xor",     2, { R64,      R64E    }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x33, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xor",     2, { R64E,     R64     }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x33, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xor",     2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x33, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "xor",     2, { R16E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x33, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "xor",     2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x33, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "xor",     2, { R32E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x33, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "xor",     2, { R64,      M_ANY   }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				              NO_VEX, NO_EVEX, 1, 1, { 0x33, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "xor",     2, { R64E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	            NO_VEX, NO_EVEX, 1, 1, { 0x33, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },

//24 ib AND AL, imm8 I Valid Valid AND imm8 to AL.
{ "and",    2, { R8_AL,    IMM8    }, GP0, (F_OPCODE_REG),												                                  NO_VEX, NO_EVEX, 1, 1, { 0x24, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,				         0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
//25 iw AND AX, imm16 I Valid Valid AND imm16 to AX.
//25 id AND EAX, imm32 I Valid Valid AND imm32 to EAX.
//REX.W + 25 id AND RAX, imm32 I Valid N.E.AND imm32 sign extended to 64 - bits to RAX.
{ "and",    2, { R16_AX,   IMM16   }, GP0, (F_OPCODE_REG),												                                  NO_VEX, NO_EVEX, 1, 1, { 0x25, 0x00, 0x00 }, 2, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "and",    2, { R32_EAX,  IMM32   }, GP0, (F_OPCODE_REG),												                                  NO_VEX, NO_EVEX, 1, 1, { 0x25, 0x00, 0x00 }, 4, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "and",    2, { R64_RAX,  IMM32   }, GP3, (REX | REXW) | (F_OPCODE_REG),						                                NO_VEX, NO_EVEX, 1, 1, { 0x25, 0x00, 0x00 }, 4, 0, NO_MOD,      0, 0,				         0,                              (X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
//80 / 2 ib AND r / m8, imm8 MI Valid Valid AND imm8 to r / m8.
//REX + 80 / 2 ib AND r / m8 * , imm8 MI Valid N.E.AND imm8 to r / m8.
{ "and",    2, { R8,       IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),		                      NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x04, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,	               0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "and",    2, { R8H,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                        NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x04, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,	               0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "and",    2, { R8U,      IMM8    }, GP3, REX | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),									  NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x04, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,				         0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "and",    2, { R8E,      IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),				  NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x04, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,				         0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "and",    2, { M8,       IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									        NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x04, 0x00 }, 1, 0, MOD_MEM_IMM, 0, 0,	               ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "and",    2, { M_ANY,    IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									        NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x04, 0x00 }, 1, 0, MOD_MEM_IMM, 0, 0,	               ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
//83 / 2 ib AND r / m16, imm8 MI Valid Valid AND with CF sign - extended imm8 to r / m16.
//83 / 2 ib AND r / m32, imm8 MI Valid Valid AND with CF sign - extended imm8 into r / m32.
//REX.W + 83 / 2 ib AND r / m64, imm8 MI Valid N.E.AND with CF sign - extended imm8 into r / m64.
{ "and",    2, { R16,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x04, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "and",    2, { R16E,     IMM8    }, GP0, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x04, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "and",    2, { M16,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x04, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "and",    2, { M_ANY,    IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x04, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "and",    2, { R32,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x04, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "and",    2, { R32E,     IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x04, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "and",    2, { M32,      IMM8    }, GP0, ALLOW_SEG | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	            NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x04, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "and",    2, { M_ANY,    IMM8    }, GP0, ALLOW_SEG | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	            NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x04, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "and",    2, { R64,      IMM8    }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),          NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x04, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "and",    2, { R64E,     IMM8    }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),   NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x04, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,				         0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "and",    2, { M64,      IMM8    }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),		      NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x04, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0,ADDR_SIZE_OVERRIDE,                             (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_64,  0, NULL },
{ "and",    2, { M_ANY,    IMM8    }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),		      NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x04, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0,ADDR_SIZE_OVERRIDE,                             (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_64,  0, NULL },
//81 / 2 iw AND r / m16, imm16 MI Valid Valid AND imm16 to r / m16.
//81 / 2 id AND r / m32, imm32 MI Valid Valid AND with CF imm32 to r / m32.
//REX.W + 81 / 2 id AND r / m64, imm32 MI Valid N.E.AND with CF imm32 sign extended to 64 - bits to r / m64.
{ "and",    2, { R16,      IMM16   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x04, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "and",    2, { R16E,     IMM16   }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),								      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x04, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "and",    2, { M16,      IMM16   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x04, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "and",    2, { M_ANY,    IMM16   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x04, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "and",    2, { R32,      IMM32   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x04, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "and",    2, { R32E,     IMM32   }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),								      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x04, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "and",    2, { R32,      IMM16   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x04, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "and",    2, { R32E,     IMM16   }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),								      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x04, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "and",    2, { M32,      IMM32   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x04, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "and",    2, { M_ANY,    IMM32   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x04, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "and",    2, { R64,      IMM32   }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),                      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x04, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "and",    2, { R64,      IMM16   }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),                      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x04, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "and",    2, { R64E,     IMM32   }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),               NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x04, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "and",    2, { R64E,     IMM16   }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),               NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x04, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "and",    2, { M64,      IMM32   }, GP3, REXW | (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                          NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x04, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_64,  0, NULL },
{ "and",    2, { M_ANY,    IMM32   }, GP3, REXW | (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                          NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x04, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_64,  0, NULL },
//20 / r AND r / m8, r8 MR Valid Valid AND byte register to r / m8.
//REX + 20 / r AND r / m8 * , r8* MR Valid N.E.AND byte register to r / m64.
{ "and",    2, { M_ANY,    R8      }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0x20, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "and",    2, { M_ANY,    R8H     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0x20, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "and",    2, { M_ANY,    R8E     }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x20, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "and",    2, { M_ANY,    R8U     }, GP3, ALLOW_SEG | (REX) | (F_MODRM | F_MODRM_REG),						                  NO_VEX, NO_EVEX, 1, 1, { 0x20, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
//21 / r AND r / m16, r16 MR Valid Valid AND r16 to r / m16.
//21 / r AND r / m32, r32 MR Valid Valid AND with CF r32 to r / m32.
//REX.W + 21 / r AND r / m64, r64 MR Valid N.E.AND with CF r64 to r / m64.
{ "and",     2, { M_ANY,    R16     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x21, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "and",     2, { M_ANY,    R16E    }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x21, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "and",     2, { M_ANY,    R32     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x21, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "and",     2, { M_ANY,    R32E    }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x21, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "and",     2, { M_ANY,    R64     }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),			                NO_VEX, NO_EVEX, 1, 1, { 0x21, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "and",     2, { M_ANY,    R64E    }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	            NO_VEX, NO_EVEX, 1, 1, { 0x21, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
//22 / r AND r8, r / m8 RM Valid Valid AND r / m8 to byte register.
//REX + 22 / r AND r8*, r / m8 * RM Valid N.E.AND r / m64 to byte register.
{ "and",     2, { R8,       R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),          NO_VEX, NO_EVEX, 1, 1, { 0x22, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "and",     2, { R8,       R8H     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		      NO_VEX, NO_EVEX, 1, 1, { 0x22, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "and",     2, { R8H,      R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		      NO_VEX, NO_EVEX, 1, 1, { 0x22, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "and",     2, { R8H,      R8H     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		      NO_VEX, NO_EVEX, 1, 1, { 0x22, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "and",     2, { R8E,      R8E     }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	            NO_VEX, NO_EVEX, 1, 1, { 0x22, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "and",     2, { R8,       R8E     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x22, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "and",     2, { R8E,      R8      }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x22, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "and",     2, { R8U,      R8      }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					                  NO_VEX, NO_EVEX, 1, 1, { 0x22, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "and",     2, { R8U,      R8E     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					          NO_VEX, NO_EVEX, 1, 1, { 0x22, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "and",     2, { R8,       R8U     }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					                  NO_VEX, NO_EVEX, 1, 1, { 0x22, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "and",     2, { R8,       M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x22, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "and",     2, { R8H,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x22, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "and",     2, { R8E,      M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x22, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,                            (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "and",     2, { R8U,      M_ANY   }, GP3, ALLOW_SEG | (REX) | (F_MODRM | F_MODRM_REG),						                NO_VEX, NO_EVEX, 1, 1, { 0x22, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,                            (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
//2and3 / r AND r16, r / m16 RM Valid Valid AND r / m16 to r16.
//23 / r AND r32, r / m32 RM Valid Valid AND with CF r / m32 to r32.
//REX.W + 23 / r AND r64, r / m64 RM Valid N.E.AND with CF r / m64 to r64. 
{ "and",     2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                      NO_VEX, NO_EVEX, 1, 1, { 0x23, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "and",     2, { R16E,     R16E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),             NO_VEX, NO_EVEX, 1, 1, { 0x23, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "and",     2, { R16E,     R16     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x23, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "and",     2, { R16,      R16E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x23, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "and",     2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                      NO_VEX, NO_EVEX, 1, 1, { 0x23, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "and",     2, { R32E,     R32E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	            NO_VEX, NO_EVEX, 1, 1, { 0x23, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "and",     2, { R32E,     R32     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x23, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "and",     2, { R32,      R32E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x23, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "and",     2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                NO_VEX, NO_EVEX, 1, 1, { 0x23, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "and",     2, { R64E,     R64E    }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),      NO_VEX, NO_EVEX, 1, 1, { 0x23, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "and",     2, { R64,      R64E    }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x23, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "and",     2, { R64E,     R64     }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x23, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "and",     2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x23, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "and",     2, { R16E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x23, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "and",     2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x23, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "and",     2, { R32E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x23, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "and",     2, { R64,      M_ANY   }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				              NO_VEX, NO_EVEX, 1, 1, { 0x23, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "and",     2, { R64E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	            NO_VEX, NO_EVEX, 1, 1, { 0x23, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
//1C ib SBB AL, imm8
{ "sbb",    2, { R8_AL,    IMM8    }, GP0, (F_OPCODE_REG),												                                  NO_VEX, NO_EVEX, 1, 1, { 0x1c, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,				         0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
//1D iw SBB AX, imm16
//1D id SBB EAX, imm32
//REX.W + 1D id SBB RAX, imm32
{ "sbb",    2, { R16_AX,   IMM16   }, GP0, (F_OPCODE_REG),												                                  NO_VEX, NO_EVEX, 1, 1, { 0x1d, 0x00, 0x00 }, 2, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sbb",    2, { R32_EAX,  IMM32   }, GP0, (F_OPCODE_REG),												                                  NO_VEX, NO_EVEX, 1, 1, { 0x1d, 0x00, 0x00 }, 4, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sbb",    2, { R64_RAX,  IMM32   }, GP3, (REX | REXW) | (F_OPCODE_REG),						                                NO_VEX, NO_EVEX, 1, 1, { 0x1d, 0x00, 0x00 }, 4, 0, NO_MOD,      0, 0,				         0,                  (X64), NO_DST,              NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
//80 / 3 ib SBB r / m8, imm8
//REX + 80 / 3 ib SBB r / m8 *, imm8
{ "sbb",     2, { R8,       IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),		                    NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x03, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,	               0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sbb",     2, { R8H,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                      NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x03, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,	               0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sbb",     2, { R8U,      IMM8    }, GP3, REX | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),					        NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x03, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,				         0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "sbb",     2, { R8E,      IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),         NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x03, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,				         0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "sbb",     2, { M8,       IMM8    }, GP3, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									        NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x03, 0x00 }, 1, 0, MOD_MEM_IMM, 0, 0,	               ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
//81 / 3 iw SBB r / m16, imm16
//81 / 3 id SBB r / m32, imm32
//REX.W + 81 / 3 id SBB r / m64, imm32
{ "sbb",    2, { R16,      IMM16   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x03, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sbb",    2, { R16E,     IMM16   }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),                      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x03, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "sbb",    2, { M16,      IMM16   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x03, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "sbb",    2, { R32,      IMM32   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x03, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sbb",    2, { R32E,     IMM32   }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),								      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x03, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                               (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "sbb",    2, { R32,      IMM16   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x03, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sbb",    2, { R32E,     IMM16   }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),								      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x03, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                               (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "sbb",    2, { M32,      IMM32   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x03, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "sbb",    2, { R64,      IMM32   }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),                      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x03, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "sbb",    2, { R64,      IMM16   }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),                      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x03, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "sbb",    2, { R64E,     IMM16   }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),                      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x03, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "sbb",    2, { R64E,     IMM32   }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),                      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x03, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "sbb",    2, { M64,      IMM32   }, GP3, REXW | (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                          NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x03, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0,	               0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_64,  0, NULL },
//83 / 3 ib SBB r / m16, imm8
//83 / 3 ib SBB r / m32, imm8
//REX.W + 83 / 3 ib SBB r / m64, imm8
{ "sbb",    2, { R16,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                         NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x03, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sbb",    2, { R16E,     IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	         NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x03, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "sbb",    2, { M16,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                         NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x03, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "sbb",    2, { R32,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                         NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x03, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sbb",    2, { R32E,     IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	         NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x03, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sbb",    2, { M32,      IMM8    }, GP0, ALLOW_SEG | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	             NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x03, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "sbb",    2, { R64,      IMM8    }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),           NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x03, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                             (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "sbb",    2, { R64E,     IMM8    }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),    NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x03, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,				         0,                             (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "sbb",    2, { M64,      IMM8    }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),		       NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x03, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0,ADDR_SIZE_OVERRIDE,                             (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_64,  0, NULL },
//18 / r SBB r / m8, r8                  D byte register to r / m8.
//REX + 18 / r SBB r / m8 *, r8
{ "sbb",    2, { M_ANY,    R8      }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0x18, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "sbb",    2, { M_ANY,    R8H     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0x18, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "sbb",    2, { M_ANY,    R8E     }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x18, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "sbb",    2, { M_ANY,    R8U     }, GP3, ALLOW_SEG | (REX) | (F_MODRM | F_MODRM_REG),						                  NO_VEX, NO_EVEX, 1, 1, { 0x18, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
//19 / r SBB r / m16, r16
//19 / r SBB r / m32, r32
//REX.W + 19 / r SBB r / m64, r64
{ "sbb",     2, { M_ANY,    R16     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x19, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "sbb",     2, { M_ANY,    R16E    }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x19, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "sbb",     2, { M_ANY,    R32     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x19, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "sbb",     2, { M_ANY,    R32E    }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x19, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "sbb",     2, { M_ANY,    R64     }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),			                NO_VEX, NO_EVEX, 1, 1, { 0x19, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "sbb",     2, { M_ANY,    R64E    }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	            NO_VEX, NO_EVEX, 1, 1, { 0x19, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
//1A / r SBB r8, r / m8
//REX + 1A / r SBB r8*, r / m8 *
{ "sbb",     2, { R8,       R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),          NO_VEX, NO_EVEX, 1, 1, { 0x1a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sbb",     2, { R8,       R8H     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		      NO_VEX, NO_EVEX, 1, 1, { 0x1a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sbb",     2, { R8H,      R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		      NO_VEX, NO_EVEX, 1, 1, { 0x1a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sbb",     2, { R8H,      R8H     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		      NO_VEX, NO_EVEX, 1, 1, { 0x1a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sbb",     2, { R8E,      R8E     }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	            NO_VEX, NO_EVEX, 1, 1, { 0x1a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sbb",     2, { R8,       R8E     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x1a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sbb",     2, { R8E,      R8      }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x1a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sbb",     2, { R8U,      R8      }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					                  NO_VEX, NO_EVEX, 1, 1, { 0x1a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sbb",     2, { R8U,      R8E     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					          NO_VEX, NO_EVEX, 1, 1, { 0x1a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sbb",     2, { R8,       R8U     }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					                  NO_VEX, NO_EVEX, 1, 1, { 0x1a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sbb",     2, { R8,       M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x1a, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "sbb",     2, { R8H,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x1a, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "sbb",     2, { R8E,      M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x1a, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,                            (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "sbb",     2, { R8U,      M_ANY   }, GP3, ALLOW_SEG | (REX) | (F_MODRM | F_MODRM_REG),						                NO_VEX, NO_EVEX, 1, 1, { 0x1a, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,                            (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
//1B / r SBB r16, r / m16
//1B / r SBB r32, r / m32
//REX.W + 1B / r SBB r64, r / m64
{ "sbb",     2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                      NO_VEX, NO_EVEX, 1, 1, { 0x1b, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sbb",     2, { R16E,     R16E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),             NO_VEX, NO_EVEX, 1, 1, { 0x1b, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sbb",     2, { R16E,     R16     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x1b, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sbb",     2, { R16,      R16E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x1b, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sbb",     2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                      NO_VEX, NO_EVEX, 1, 1, { 0x1b, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sbb",     2, { R32E,     R32E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	            NO_VEX, NO_EVEX, 1, 1, { 0x1b, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sbb",     2, { R32E,     R32     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x1b, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sbb",     2, { R32,      R32E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x1b, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sbb",     2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                NO_VEX, NO_EVEX, 1, 1, { 0x1b, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sbb",     2, { R64E,     R64E    }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),      NO_VEX, NO_EVEX, 1, 1, { 0x1b, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sbb",     2, { R64,      R64E    }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x1b, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sbb",     2, { R64E,     R64     }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x1b, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sbb",     2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x1b, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "sbb",     2, { R16E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x1b, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "sbb",     2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x1b, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "sbb",     2, { R32E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x1b, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "sbb",     2, { R64,      M_ANY   }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				              NO_VEX, NO_EVEX, 1, 1, { 0x1b, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "sbb",     2, { R64E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	            NO_VEX, NO_EVEX, 1, 1, { 0x1b, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
//2C ib SUB AL, imm8 I Valid Valid SUB imm8 to AL.
{ "sub",    2, { R8_AL,    IMM8    }, GP0, (F_OPCODE_REG),												                                  NO_VEX, NO_EVEX, 1, 1, { 0x2c, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,				         0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
//25 iw SUB AX, imm16 I Valid Valid SUB imm16 to AX.
//25 id SUB EAX, imm32 I Valid Valid SUB imm32 to EAX.
//REX.W + 25 id SUB RAX, imm32 I Valid N.E.SUB imm32 sign extended to 64 - bits to RAX.
{ "sub",    2, { R16_AX,   IMM16   }, GP0, (F_OPCODE_REG),												                                  NO_VEX, NO_EVEX, 1, 1, { 0x2d, 0x00, 0x00 }, 2, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sub",    2, { R32_EAX,  IMM32   }, GP0, (F_OPCODE_REG),												                                  NO_VEX, NO_EVEX, 1, 1, { 0x2d, 0x00, 0x00 }, 4, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sub",    2, { R64_RAX,  IMM32   }, GP3, (REX | REXW) | (F_OPCODE_REG),						                                        NO_VEX, NO_EVEX, 1, 1, { 0x2d, 0x00, 0x00 }, 4, 0, NO_MOD,      0, 0,				         0,                              (X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
//80 / 5 ib SUB r / m8, imm8 MI Valid Valid SUB imm8 to r / m8.
//REX + 80 / 2 ib SUB r / m8 * , imm8 MI Valid N.E.SUB imm8 to r / m8.
{ "sub",    2, { R8,       IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),		                NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x05, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,	               0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sub",    2, { R8H,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                  NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x05, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,	               0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sub",    2, { R8U,      IMM8    }, GP3, REX | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),									  NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x05, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,				         0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "sub",    2, { R8E,      IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),				  NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x05, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,				         0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "sub",    2, { M8,       IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									        NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x05, 0x00 }, 1, 0, MOD_MEM_IMM, 0, 0,	               ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
//81 / 5 iw SUB r / m16, imm16 MI Valid Valid SUB imm16 to r / m16.
//81 / 5 id SUB r / m32, imm32 MI Valid Valid SUB with CF imm32 to r / m32.
//REX.W + 81 / 5 id SUB r / m64, imm32 MI Valid N.E.SUB with CF imm32 sign extended to 64 - bits to r / m64.
{ "sub",    2, { R16,      IMM16   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x05, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sub",    2, { R16E,     IMM16   }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),								      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x05, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "sub",    2, { M16,      IMM16   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x05, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "sub",    2, { R32,      IMM32   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x05, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sub",    2, { R32E,     IMM32   }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),								      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x05, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "sub",    2, { R32,      IMM16   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x05, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sub",    2, { R32E,     IMM16   }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),								      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x05, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "sub",    2, { M32,      IMM32   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x05, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "sub",    2, { R64,      IMM32   }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),                      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x05, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "sub",    2, { R64,      IMM16   }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),                      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x05, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "sub",    2, { R64E,     IMM32   }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),                      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x05, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "sub",    2, { R64E,     IMM16   }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),                      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x05, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "sub",    2, { M64,      IMM32   }, GP3, REXW | (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                          NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x05, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_64,  0, NULL },
//83 / 5 ib SUB r / m16, imm8 MI Valid Valid SUB with CF sign - extended imm8 to r / m16.
//83 / 5 ib SUB r / m32, imm8 MI Valid Valid SUB with CF sign - extended imm8 into r / m32.
//REX.W + 83 / 5 ib SUB r / m64, imm8 MI Valid N.E.SUB with CF sign - extended imm8 into r / m64.
{ "sub",    2, { R16,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x05, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sub",    2, { R16E,     IMM8    }, GP0, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x05, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sub",    2, { M16,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x05, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "sub",    2, { R32,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x05, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sub",    2, { R32E,     IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x05, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sub",    2, { M32,      IMM8    }, GP0, ALLOW_SEG | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	            NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x05, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "sub",    2, { R64,      IMM8    }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),          NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x05, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "sub",    2, { R64E,     IMM8    }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),   NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x05, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,				         0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "sub",    2, { M64,      IMM8    }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),		      NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x05, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0,ADDR_SIZE_OVERRIDE,                             (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_64,  0, NULL },
//28 / r SUB r / m8, r8 MR Valid Valid SUB byte register to r / m8.
//REX + 28 / r SUB r / m8 * , r8* MR Valid N.E.SUB byte register to r / m64.
{ "sub",    2, { M_ANY,    R8      }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0x28, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "sub",    2, { M_ANY,    R8H     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0x28, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "sub",    2, { M_ANY,    R8E     }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x28, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "sub",    2, { M_ANY,    R8U     }, GP3, ALLOW_SEG | (REX) | (F_MODRM | F_MODRM_REG),						                  NO_VEX, NO_EVEX, 1, 1, { 0x28, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
//29 / r SUB r / m16, r16 MR Valid Valid SUB r16 to r / m16.
//29 / r SUB r / m32, r32 MR Valid Valid SUB with CF r32 to r / m32.
//REX.W + 29 / r SUB r / m64, r64 MR Valid N.E.SUB with CF r64 to r / m64.
{ "sub",     2, { M_ANY,    R16     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x29, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "sub",     2, { M_ANY,    R16E    }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x29, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "sub",     2, { M_ANY,    R32     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x29, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "sub",     2, { M_ANY,    R32E    }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x29, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "sub",     2, { M_ANY,    R64     }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),			                NO_VEX, NO_EVEX, 1, 1, { 0x29, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "sub",     2, { M_ANY,    R64E    }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	            NO_VEX, NO_EVEX, 1, 1, { 0x29, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
//2A / r SUB r8, r / m8 RM Valid Valid SUB r / m8 to byte register.
//REX + 2A / r SUB r8*, r / m8 * RM Valid N.E.SUB r / m64 to byte register.
{ "sub",     2, { R8,       R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),          NO_VEX, NO_EVEX, 1, 1, { 0x2a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sub",     2, { R8,       R8H     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		      NO_VEX, NO_EVEX, 1, 1, { 0x2a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sub",     2, { R8H,      R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		      NO_VEX, NO_EVEX, 1, 1, { 0x2a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sub",     2, { R8H,      R8H     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		      NO_VEX, NO_EVEX, 1, 1, { 0x2a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sub",     2, { R8E,      R8E     }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	            NO_VEX, NO_EVEX, 1, 1, { 0x2a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sub",     2, { R8,       R8E     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x2a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sub",     2, { R8E,      R8      }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x2a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sub",     2, { R8U,      R8      }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					                  NO_VEX, NO_EVEX, 1, 1, { 0x2a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sub",     2, { R8U,      R8E     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					          NO_VEX, NO_EVEX, 1, 1, { 0x2a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sub",     2, { R8,       R8U     }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					                  NO_VEX, NO_EVEX, 1, 1, { 0x2a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sub",     2, { R8,       M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x2a, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "sub",     2, { R8H,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x2a, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "sub",     2, { R8E,      M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x2a, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,                            (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "sub",     2, { R8U,      M_ANY   }, GP3, ALLOW_SEG | (REX) | (F_MODRM | F_MODRM_REG),						                NO_VEX, NO_EVEX, 1, 1, { 0x2a, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,                            (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
//2and3 / r SUB r16, r / m16 RM Valid Valid SUB r / m16 to r16.
//2B / r SUB r32, r / m32 RM Valid Valid SUB with CF r / m32 to r32.
//REX.W + 2B / r SUB r64, r / m64 RM Valid N.E.SUB with CF r / m64 to r64. 
{ "sub",     2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                      NO_VEX, NO_EVEX, 1, 1, { 0x2b, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sub",     2, { R16E,     R16E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),             NO_VEX, NO_EVEX, 1, 1, { 0x2b, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sub",     2, { R16E,     R16     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x2b, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sub",     2, { R16,      R16E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x2b, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sub",     2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                      NO_VEX, NO_EVEX, 1, 1, { 0x2b, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sub",     2, { R32E,     R32E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	            NO_VEX, NO_EVEX, 1, 1, { 0x2b, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sub",     2, { R32E,     R32     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x2b, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sub",     2, { R32,      R32E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x2b, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sub",     2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                NO_VEX, NO_EVEX, 1, 1, { 0x2b, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sub",     2, { R64E,     R64E    }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),      NO_VEX, NO_EVEX, 1, 1, { 0x2b, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sub",     2, { R64,      R64E    }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x2b, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sub",     2, { R64E,     R64     }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x2b, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sub",     2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x2b, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "sub",     2, { R16E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x2b, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "sub",     2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x2b, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "sub",     2, { R32E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x2b, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "sub",     2, { R64,      M_ANY   }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				              NO_VEX, NO_EVEX, 1, 1, { 0x2b, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "sub",     2, { R64E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	            NO_VEX, NO_EVEX, 1, 1, { 0x2b, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
//3C ib CMP AL, imm8
{ "cmp",    2, { R8_AL,    IMM8    }, GP0, (F_OPCODE_REG),												                                  NO_VEX, NO_EVEX, 1, 1, { 0x3c, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,				         0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
//25 iw CMP AX, imm16 I Valid Valid CMP imm16 to AX.
//25 id CMP EAX, imm32 I Valid Valid CMP imm32 to EAX.
//REX.W + 25 id CMP RAX, imm32 I Valid N.E.CMP imm32 sign extended to 64 - bits to RAX.
{ "cmp",    2, { R16_AX,   IMM16   }, GP0, (F_OPCODE_REG),												                                  NO_VEX, NO_EVEX, 1, 1, { 0x3d, 0x00, 0x00 }, 2, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "cmp",    2, { R32_EAX,  IMM32   }, GP0, (F_OPCODE_REG),												                                  NO_VEX, NO_EVEX, 1, 1, { 0x3d, 0x00, 0x00 }, 4, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "cmp",    2, { R64_RAX,  IMM32   }, GP3, (REX | REXW) | (F_OPCODE_REG),						                                        NO_VEX, NO_EVEX, 1, 1, { 0x3d, 0x00, 0x00 }, 4, 0, NO_MOD,      0, 0,				         0,                              (X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
//80 / 5 ib CMP r / m8, imm8 MI Valid Valid CMP imm8 to r / m8.
//REX + 80 / 2 ib CMP r / m8 * , imm8 MI Valid N.E.CMP imm8 to r / m8.
{ "cmp",    2, { R8,       IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),		                NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x07, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,	               0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "cmp",    2, { R8H,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                  NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x07, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,	               0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "cmp",    2, { R8U,      IMM8    }, GP3, REX | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),									  NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x07, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,				         0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "cmp",    2, { R8E,      IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),				  NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x07, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,				         0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "cmp",    2, { M8,       IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									        NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x07, 0x00 }, 1, 0, MOD_MEM_IMM, 0, 0,	               ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "cmp",    2, { M_ANY,    IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									        NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x07, 0x00 }, 1, 0, MOD_MEM_IMM, 0, 0,	               ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
//81 / 7 iw CMP r / m16, imm16
//81 / 7 id CMP r / m32, imm32
//REX.W + 81 / 7 id CMP r / m64, imm32
{ "cmp",    2, { R16,      IMM16   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x07, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "cmp",    2, { R16E,     IMM16   }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),								      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x07, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "cmp",    2, { M16,      IMM16   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x07, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "cmp",    2, { M_ANY,    IMM16   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x07, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "cmp",    2, { R32,      IMM32   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x07, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "cmp",    2, { R32,      IMM16   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x07, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "cmp",    2, { R32E,     IMM32   }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),								      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x07, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "cmp",    2, { M32,      IMM32   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x07, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "cmp",    2, { M_ANY,    IMM32   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x07, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "cmp",    2, { R32E,     IMM16   }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),								      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x07, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "cmp",    2, { R64,      IMM32   }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),                      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x07, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "cmp",    2, { R64,      IMM16   }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),                      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x07, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "cmp",    2, { R64E,     IMM32   }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),                      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x07, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "cmp",    2, { R64E,     IMM16   }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),                      NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x07, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "cmp",    2, { M64,      IMM32   }, GP3, REXW | (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                          NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x07, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_64,  0, NULL },
{ "cmp",    2, { M_ANY,    IMM32   }, GP3, REXW | (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                          NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x07, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_64,  0, NULL },
//83 / 7 ib CMP r / m16, imm8
//83 / 7 ib CMP r / m32, imm8
//REX.W + 83 / 7 ib CMP r / m64, imm8
{ "cmp",    2, { R16,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x07, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "cmp",    2, { R16E,     IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x07, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "cmp",    2, { M16,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x07, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "cmp",    2, { M_ANY,    IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x07, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "cmp",    2, { R32,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x07, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "cmp",    2, { R32E,     IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	        NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x07, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "cmp",    2, { M32,      IMM8    }, GP0, ALLOW_SEG | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	            NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x07, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "cmp",    2, { M_ANY,    IMM8    }, GP0, ALLOW_SEG | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	            NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x07, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "cmp",    2, { R64,      IMM8    }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),          NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x07, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "cmp",    2, { R64E,     IMM8    }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),   NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x07, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,				         0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "cmp",    2, { M64,      IMM8    }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),		      NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x07, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0,ADDR_SIZE_OVERRIDE,                             (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_64,  0, NULL },
{ "cmp",    2, { M_ANY,    IMM8    }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),		      NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x07, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0,ADDR_SIZE_OVERRIDE,                             (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_64,  0, NULL },
//38 / r CMP r / m8, r8
//REX + 38 / r CMP r / m8 *, r8 *
{ "cmp",    2, { M_ANY,    R8      }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0x38, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "cmp",    2, { M_ANY,    R8H     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0x38, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "cmp",    2, { M_ANY,    R8E     }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x38, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "cmp",    2, { M_ANY,    R8U     }, GP3, ALLOW_SEG | (REX) | (F_MODRM | F_MODRM_REG),						                  NO_VEX, NO_EVEX, 1, 1, { 0x38, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
//39 / r CMP r / m16, r16
//39 / r CMP r / m32, r32
//REX.W + 39 / r CMP r / m64, r64
{ "cmp",     2, { M_ANY,    R16     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x39, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "cmp",     2, { M_ANY,    R16E    }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x39, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "cmp",     2, { M_ANY,    R32     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x39, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "cmp",     2, { M_ANY,    R32E    }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x39, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "cmp",     2, { M_ANY,    R64     }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),			                NO_VEX, NO_EVEX, 1, 1, { 0x39, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "cmp",     2, { M_ANY,    R64E    }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	            NO_VEX, NO_EVEX, 1, 1, { 0x39, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
//3A / r CMP r8, r / m8
//REX + 3A / r CMP r8*, r / m8 *
{ "cmp",     2, { R8,       R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),          NO_VEX, NO_EVEX, 1, 1, { 0x3a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmp",     2, { R8,       R8H     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		      NO_VEX, NO_EVEX, 1, 1, { 0x3a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmp",     2, { R8H,      R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		      NO_VEX, NO_EVEX, 1, 1, { 0x3a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmp",     2, { R8H,      R8H     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		      NO_VEX, NO_EVEX, 1, 1, { 0x3a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmp",     2, { R8E,      R8E     }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	            NO_VEX, NO_EVEX, 1, 1, { 0x3a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmp",     2, { R8,       R8E     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x3a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmp",     2, { R8E,      R8      }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x3a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmp",     2, { R8U,      R8      }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					                  NO_VEX, NO_EVEX, 1, 1, { 0x3a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmp",     2, { R8U,      R8E     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					          NO_VEX, NO_EVEX, 1, 1, { 0x3a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmp",     2, { R8,       R8U     }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					                  NO_VEX, NO_EVEX, 1, 1, { 0x3a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmp",     2, { R8,       M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x3a, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "cmp",     2, { R8H,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x3a, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "cmp",     2, { R8E,      M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x3a, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,                            (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "cmp",     2, { R8U,      M_ANY   }, GP3, ALLOW_SEG | (REX) | (F_MODRM | F_MODRM_REG),						                NO_VEX, NO_EVEX, 1, 1, { 0x3a, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,                            (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
//3B / r CMP r16, r / m16
//3B / r CMP r32, r / m32
//REX.W + 3B / r CMP r64, r / m64
{ "cmp",     2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                      NO_VEX, NO_EVEX, 1, 1, { 0x3b, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmp",     2, { R16E,     R16E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),             NO_VEX, NO_EVEX, 1, 1, { 0x3b, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmp",     2, { R16E,     R16     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x3b, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmp",     2, { R16,      R16E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x3b, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmp",     2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                      NO_VEX, NO_EVEX, 1, 1, { 0x3b, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmp",     2, { R32E,     R32E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	            NO_VEX, NO_EVEX, 1, 1, { 0x3b, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmp",     2, { R32E,     R32     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x3b, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmp",     2, { R32,      R32E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x3b, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmp",     2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                NO_VEX, NO_EVEX, 1, 1, { 0x3b, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmp",     2, { R64E,     R64E    }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),      NO_VEX, NO_EVEX, 1, 1, { 0x3b, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmp",     2, { R64,      R64E    }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x3b, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmp",     2, { R64E,     R64     }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x3b, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmp",     2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x3b, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "cmp",     2, { R16E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x3b, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "cmp",     2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x3b, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "cmp",     2, { R32E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x3b, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "cmp",     2, { R64,      M_ANY   }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				              NO_VEX, NO_EVEX, 1, 1, { 0x3b, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "cmp",     2, { R64E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	            NO_VEX, NO_EVEX, 1, 1, { 0x3b, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
//66 0F 38 F6 / r ADCX r32, r/m32 RM V / V ADX Unsigned addition of r32 with CF, r / m32 to r32, writes CF.
//66 REX.w 0F38 F6 / r ADCX r64, r/m64 RM V / NE ADX Unsigned addition of r64 with CF, r / m64 to r64, writes CF.
{ "adcx",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                  NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,            (X32 | X64), REG_DST,  PFX_0x66F38, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "adcx",    2, { R32E,     R32E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	        NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,            (X32 | X64), REG_DST,  PFX_0x66F38, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "adcx",    2, { R32E,     R32     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,            (X32 | X64), REG_DST,  PFX_0x66F38, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "adcx",    2, { R32,      R32E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,            (X32 | X64), REG_DST,  PFX_0x66F38, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "adcx",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		            NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0x66F38, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "adcx",    2, { R64E,     R64E    }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),  NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0x66F38, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "adcx",    2, { R64,      R64E    }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		      NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0x66F38, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "adcx",    2, { R64E,     R64     }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		      NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0x66F38, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "adcx",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,       (X32 | X64), REG_DST, PFX_0x66F38, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "adcx",    2, { R32E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,       (X32 | X64), REG_DST, PFX_0x66F38, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "adcx",    2, { R64,      M_ANY   }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				          NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,       (X64), REG_DST, PFX_0x66F38, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "adcx",    2, { R64E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	        NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,       (X64), REG_DST, PFX_0x66F38, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
//F30F38 F6 / r ADOX r32, r / m32 RM V / V ADX Unsigned addition of r32 with OF, r / m32 to r32, writes OF.
//F3 REX.w 0F38 F6 / r ADOX r64, r / m64 RM V / NE ADX Unsigned addition of r64 with OF, r / m64 to r64, writes OF.
{ "adox",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                  NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,            (X32 | X64), REG_DST,  PFX_0xF3F38, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "adox",    2, { R32E,     R32E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	        NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,            (X32 | X64), REG_DST,  PFX_0xF3F38, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "adox",    2, { R32E,     R32     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,            (X32 | X64), REG_DST,  PFX_0xF3F38, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "adox",    2, { R32,      R32E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,            (X32 | X64), REG_DST,  PFX_0xF3F38, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "adox",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		            NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF3F38, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "adox",    2, { R64E,     R64E    }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),  NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF3F38, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "adox",    2, { R64,      R64E    }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		      NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF3F38, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "adox",    2, { R64E,     R64     }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		      NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF3F38, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "adox",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,       (X32 | X64), REG_DST, PFX_0xF3F38, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "adox",    2, { R32E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,       (X32 | X64), REG_DST, PFX_0xF3F38, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "adox",    2, { R64,      M_ANY   }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				          NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,       (X64), REG_DST, PFX_0xF3F38, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "adox",    2, { R64E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	        NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,       (X64), REG_DST, PFX_0xF3F38, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
//ARPL r / m16, r16 63 / r 
{ "arpl",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							          NO_VEX, NO_EVEX, 1, 1, { 0x63, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, 0, 0,                   (X16 | X32), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "arpl",    2, { M_ANY,    R16     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                NO_VEX, NO_EVEX, 1, 1, { 0x63, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, 0, 0, (X16 | X32), RM_DST,  NO_PREFIX, NO_IMM    , MEM_OPND_0, P_86,  0, NULL },
//BOUND r16, m16 & 16 62 / r 
//BOUND r32, m32 & 32 62 / r 
{ "bound",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                  NO_VEX, NO_EVEX, 1, 1, { 0x62, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32), REG_DST, NO_PREFIX, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "bound",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                  NO_VEX, NO_EVEX, 1, 1, { 0x62, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32), REG_DST, NO_PREFIX, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
//BSF r16, r / m16 0F BC / r
//BSF r32, r / m32 0F BC / r
//BSF r64, r / m64 REX.W + 0F BC / r
{ "bsf",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0xbc, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "bsf",    2, { R16E,     R16E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),        NO_VEX, NO_EVEX, 1, 1, { 0xbc, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "bsf",    2, { R16E,     R16     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0xbc, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "bsf",    2, { R16,      R16E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0xbc, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "bsf",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0xbc, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "bsf",    2, { R32E,     R32E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	      NO_VEX, NO_EVEX, 1, 1, { 0xbc, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "bsf",    2, { R32E,     R32     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0xbc, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "bsf",    2, { R32,      R32E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0xbc, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "bsf",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		            NO_VEX, NO_EVEX, 1, 1, { 0xbc, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "bsf",    2, { R64E,     R64E    }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM), NO_VEX, NO_EVEX, 1, 1, { 0xbc, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "bsf",    2, { R64,      R64E    }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		    NO_VEX, NO_EVEX, 1, 1, { 0xbc, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "bsf",    2, { R64E,     R64     }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		    NO_VEX, NO_EVEX, 1, 1, { 0xbc, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "bsf",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0xbc, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "bsf",    2, { R16E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 1, 1, { 0xbc, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "bsf",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0xbc, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "bsf",    2, { R32E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 1, 1, { 0xbc, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "bsf",    2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0xbc, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "bsf",    2, { R64E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	        NO_VEX, NO_EVEX, 1, 1, { 0xbc, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
//BSR r16, r / m16 0F BD / r 
//BSR r32, r / m32 0F BD / r 
//BSR r64, r / m64 REX.W + 0F BD / r 
{ "bsr",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0xbd, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "bsr",    2, { R16E,     R16E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),        NO_VEX, NO_EVEX, 1, 1, { 0xbd, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "bsr",    2, { R16E,     R16     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0xbd, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "bsr",    2, { R16,      R16E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0xbd, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "bsr",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0xbd, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "bsr",    2, { R32E,     R32E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	      NO_VEX, NO_EVEX, 1, 1, { 0xbd, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "bsr",    2, { R32E,     R32     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0xbd, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "bsr",    2, { R32,      R32E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0xbd, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "bsr",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		            NO_VEX, NO_EVEX, 1, 1, { 0xbd, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "bsr",    2, { R64E,     R64E    }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM), NO_VEX, NO_EVEX, 1, 1, { 0xbd, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "bsr",    2, { R64,      R64E    }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		    NO_VEX, NO_EVEX, 1, 1, { 0xbd, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "bsr",    2, { R64E,     R64     }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		    NO_VEX, NO_EVEX, 1, 1, { 0xbd, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST, PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "bsr",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0xbd, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "bsr",    2, { R16E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 1, 1, { 0xbd, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "bsr",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0xbd, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "bsr",    2, { R32E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 1, 1, { 0xbd, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "bsr",    2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0xbd, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "bsr",    2, { R64E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	        NO_VEX, NO_EVEX, 1, 1, { 0xbd, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
//BSWAP r32 0F C8 + rd 
//BSWAP r64 REX.W + 0F C8 + rd
{ "bswap",    1, { R32,         }, GP0, (F_MODRM_REG | F_MODRM_RM),							                  NO_VEX, NO_EVEX, 1, 1, { 0xc8, 0x00, 0x00 }, 4, 0, NO_MOD, 0, 0,                0,      (X16 | X32 | X64), NO_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "bswap",    1, { R32E,        }, GP3, (REX | REXB | REXR) | (F_MODRM_REG | F_MODRM_RM),	        NO_VEX, NO_EVEX, 1, 1, { 0xc8, 0x00, 0x00 }, 4, 0, NO_MOD, 0, 0,                0,                  (X64), NO_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "bswap",    1, { R64,         }, GP3, (REX | REXW) | (F_MODRM_REG | F_MODRM_RM),		            NO_VEX, NO_EVEX, 1, 1, { 0xc8, 0x00, 0x00 }, 8, 0, NO_MOD, 0, 0,                0,                  (X64), NO_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "bswap",    1, { R64E,        }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM_REG | F_MODRM_RM),  NO_VEX, NO_EVEX, 1, 1, { 0xc8, 0x00, 0x00 }, 8, 0, NO_MOD, 0, 0,                0,                  (X64), NO_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
//BT r / m16, r16 0F A3 / r 
//BT r / m32, r32 0F A3 / r 
//BT r / m64, r64 REX.W + 0F A3 / r 
{ "bt",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                  NO_VEX, NO_EVEX, 1, 1, { 0xa3, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "bt",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                  NO_VEX, NO_EVEX, 1, 1, { 0xa3, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "bt",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		            NO_VEX, NO_EVEX, 1, 1, { 0xa3, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "bt",    2, { M_ANY,    R16     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0xa3, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM    , MEM_OPND_0, P_86,  0, NULL },
{ "bt",    2, { M_ANY,    R32     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0xa3, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM    , MEM_OPND_0, P_86,  0, NULL },
{ "bt",    2, { M_ANY,    R64     }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),			            NO_VEX, NO_EVEX, 1, 1, { 0xa3, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE,                       (X64), RM_DST,  PFX_0xF, NO_IMM    , MEM_OPND_0, P_64,  0, NULL },
//BT r / m16, imm8 0F BA / 4 ib 
//BT r / m32, imm8 0F BA / 4 ib 
//BT r / m64, imm8 REX.W + 0F BA / 4 ib 
{ "bt",    2, { R16,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                    NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x04, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "bt",    2, { M16,      IMM8    }, GP0, ALLOW_LOCK | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	        NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x04, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "bt",    2, { M_ANY,    IMM8    }, GP0, ALLOW_LOCK | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	        NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x04, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "bt",    2, { R32,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                    NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x04, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE,                  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "bt",    2, { M32,      IMM8    }, GP0, ALLOW_LOCK | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	        NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x04, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE,                  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "bt",    2, { M_ANY,    IMM8    }, GP0, ALLOW_LOCK | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	        NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x04, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE,                  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "bt",    2, { R64,      IMM8    }, GP3, REXW | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	              NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x04, 0x00 }, 8, 0, MOD_REG_IMM, 0, 0,	               0,  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "bt",    2, { M64,      IMM8    }, GP3, REXW | ALLOW_LOCK | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x04, 0x00 }, 8, 0, MOD_MEM_IMM, 0, 0,	               0,  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, MEM_OPND_0, P_64,  0, NULL },
{ "bt",    2, { M_ANY,    IMM8    }, GP3, REXW | ALLOW_LOCK | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x04, 0x00 }, 8, 0, MOD_MEM_IMM, 0, 0,	               0,  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, MEM_OPND_0, P_64,  0, NULL },
//BTC r / m16, r16   0F BB / r             
//BTC r / m32, r32   0F BB / r             
//BTC r / m64, r64   REX.W + 0F BB / r     
{ "btc",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                  NO_VEX, NO_EVEX, 1, 1, { 0xbb, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "btc",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                  NO_VEX, NO_EVEX, 1, 1, { 0xbb, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "btc",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		              NO_VEX, NO_EVEX, 1, 1, { 0xbb, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "btc",    2, { M_ANY,    R16     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                          NO_VEX, NO_EVEX, 1, 1, { 0xbb, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM    , MEM_OPND_0, P_86,  0, NULL },
{ "btc",    2, { M_ANY,    R32     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                          NO_VEX, NO_EVEX, 1, 1, { 0xbb, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM    , MEM_OPND_0, P_86,  0, NULL },
{ "btc",    2, { M_ANY,    R64     }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),			            NO_VEX, NO_EVEX, 1, 1, { 0xbb, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE,                       (X64), RM_DST,  PFX_0xF, NO_IMM    , MEM_OPND_0, P_64,  0, NULL },
//BTC r / m16, imm8  0F BA / 7 ib          
//BTC r / m32, imm8  0F BA / 7 ib          
//BTC r / m64, imm8  REX.W + 0F BA / 7 ib  
{ "btc",    2, { R16,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                    NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x07, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "btc",    2, { M16,      IMM8    }, GP0, ALLOW_LOCK | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	      NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x07, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "btc",    2, { M_ANY,    IMM8    }, GP0, ALLOW_LOCK | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	      NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x07, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "btc",    2, { R32,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                    NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x07, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "btc",    2, { M32,      IMM8    }, GP0, ALLOW_LOCK | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	      NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x07, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "btc",    2, { M_ANY,    IMM8    }, GP0, ALLOW_LOCK | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	      NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x07, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "btc",    2, { R64,      IMM8    }, GP3, REXW | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	            NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x07, 0x00 }, 8, 0, MOD_REG_IMM, 0, 0,	               0,  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "btc",    2, { M64,      IMM8    }, GP3, REXW | ALLOW_LOCK | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x07, 0x00 }, 8, 0, MOD_MEM_IMM, 0, 0,	               0,  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, MEM_OPND_0, P_64,  0, NULL },
{ "btc",    2, { M_ANY,    IMM8    }, GP3, REXW | ALLOW_LOCK | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x07, 0x00 }, 8, 0, MOD_MEM_IMM, 0, 0,	               0,  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, MEM_OPND_0, P_64,  0, NULL },
//BTR r / m16, r16 0F B3 / r 
//BTR r / m32, r32 0F B3 / r 
//BTR r / m64, r64 REX.W + 0F B3 / r 
{ "btr",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                  NO_VEX, NO_EVEX, 1, 1, { 0xb3, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "btr",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                  NO_VEX, NO_EVEX, 1, 1, { 0xb3, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "btr",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		              NO_VEX, NO_EVEX, 1, 1, { 0xb3, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "btr",    2, { M_ANY,    R16     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                          NO_VEX, NO_EVEX, 1, 1, { 0xb3, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM    , MEM_OPND_0, P_86,  0, NULL },
{ "btr",    2, { M_ANY,    R32     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                          NO_VEX, NO_EVEX, 1, 1, { 0xb3, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM    , MEM_OPND_0, P_86,  0, NULL },
{ "btr",    2, { M_ANY,    R64     }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),			            NO_VEX, NO_EVEX, 1, 1, { 0xb3, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE,                       (X64), RM_DST,  PFX_0xF, NO_IMM    , MEM_OPND_0, P_64,  0, NULL },
//BTR r / m16, imm8 0F BA /          6 ib 
//BTR r / m32, imm8 0F BA /          6 ib 
//BTR r / m64, imm8 REX.W + 0F BA /  6 ib 
{ "btr",    2, { R16,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                    NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x06, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "btr",    2, { M16,      IMM8    }, GP0, ALLOW_LOCK | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	      NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x06, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "btr",    2, { M_ANY,    IMM8    }, GP0, ALLOW_LOCK | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	      NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x06, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "btr",    2, { R32,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                    NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x06, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "btr",    2, { M32,      IMM8    }, GP0, ALLOW_LOCK | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	      NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x06, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "btr",    2, { M_ANY,    IMM8    }, GP0, ALLOW_LOCK | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	      NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x06, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "btr",    2, { R64,      IMM8    }, GP3, REXW | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	            NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x06, 0x00 }, 8, 0, MOD_REG_IMM, 0, 0,	               0,  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "btr",    2, { M64,      IMM8    }, GP3, REXW | ALLOW_LOCK | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x06, 0x00 }, 8, 0, MOD_MEM_IMM, 0, 0,	               0,  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, MEM_OPND_0, P_64,  0, NULL },
{ "btr",    2, { M_ANY,    IMM8    }, GP3, REXW | ALLOW_LOCK | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x06, 0x00 }, 8, 0, MOD_MEM_IMM, 0, 0,	               0,  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, MEM_OPND_0, P_64,  0, NULL },
//BTS r / m16, r16  0F AB / r 
//BTS r / m32, r32  0F AB / r 
//BTS r / m64, r64  REX.W + 0F AB / r 
{ "bts",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                  NO_VEX, NO_EVEX, 1, 1, { 0xab, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "bts",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                  NO_VEX, NO_EVEX, 1, 1, { 0xab, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "bts",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		              NO_VEX, NO_EVEX, 1, 1, { 0xab, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "bts",    2, { M_ANY,    R16     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                          NO_VEX, NO_EVEX, 1, 1, { 0xab, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM    , MEM_OPND_0, P_86,  0, NULL },
{ "bts",    2, { M_ANY,    R32     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                          NO_VEX, NO_EVEX, 1, 1, { 0xab, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM    , MEM_OPND_0, P_86,  0, NULL },
{ "bts",    2, { M_ANY,    R64     }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),			            NO_VEX, NO_EVEX, 1, 1, { 0xab, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE,                       (X64), RM_DST,  PFX_0xF, NO_IMM    , MEM_OPND_0, P_64,  0, NULL },
//BTS r / m16, imm8  0F BA /          5 ib 
//BTS r / m32, imm8  0F BA /          5 ib 
//BTS r / m64, imm8  REX.W + 0F BA /  5 ib 
{ "bts",    2, { R16,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	        NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x05, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "bts",    2, { M16,      IMM8    }, GP0, ALLOW_LOCK | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	        NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x05, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "bts",    2, { M_ANY,    IMM8    }, GP0, ALLOW_LOCK | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	        NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x05, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "bts",    2, { R32,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	        NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x05, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "bts",    2, { M32,      IMM8    }, GP0, ALLOW_LOCK | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	        NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x05, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "bts",    2, { M_ANY,    IMM8    }, GP0, ALLOW_LOCK | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	        NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x05, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "bts",    2, { R64,      IMM8    }, GP3, REXW | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x05, 0x00 }, 8, 0, MOD_REG_IMM, 0, 0,	               0,                  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "bts",    2, { M64,      IMM8    }, GP3, REXW | ALLOW_LOCK | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x05, 0x00 }, 8, 0, MOD_MEM_IMM, 0, 0,	               0,                  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, MEM_OPND_0, P_64,  0, NULL },
{ "bts",    2, { M_ANY,    IMM8    }, GP3, REXW | ALLOW_LOCK | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	NO_VEX, NO_EVEX, 1, 1, { 0xba, 0x05, 0x00 }, 8, 0, MOD_MEM_IMM, 0, 0,	               0,                  (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_1, MEM_OPND_0, P_64,  0, NULL },
//ins(SETcc, seta, OpCls(R8_M08, NONE, NONE), F_0F, 0, no_WDS, 0x97, 0x00, P_386, 0)
{ "seta",   1, { R8,         }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x97, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "seta",   1, { R8H,        }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x97, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "seta",   1, { M8,         }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x97, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "setae",  1, { R8,         }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x93, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setae",  1, { R8H,        }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x93, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setae",  1, { M8,         }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x93, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "setb",   1, { R8,         }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x92, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setb",   1, { R8H,        }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x92, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setb",   1, { M8,         }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x92, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "setbe",  1, { R8,         }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x96, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setbe",  1, { R8H,        }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x96, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setbe",  1, { M8,         }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x96, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "setc",   1, { R8,         }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x92, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setc",   1, { R8H,        }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x92, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setc",   1, { M8,         }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x92, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "sete",   1, { R8,         }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x94, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sete",   1, { R8H,        }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x94, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sete",   1, { M8,         }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x94, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "setg",   1, { R8,         }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9f, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setg",   1, { R8H,        }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9f, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setg",   1, { M8,         }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9f, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "setge",  1, { R8,         }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9d, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setge",  1, { R8H,        }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9d, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setge",  1, { M8,         }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9d, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "setl",   1, { R8,         }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9c, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setl",   1, { R8H,        }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9c, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setl",   1, { M8,         }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9c, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "setle",  1, { R8,         }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9e, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setle",  1, { R8H,        }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9e, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setle",  1, { M8,         }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9e, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "setna",  1, { R8,         }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x96, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setna",  1, { R8H,        }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x96, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setna",  1, { M8,         }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x96, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "setnae", 1, { R8,         }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x92, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setnae", 1, { R8H,        }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x92, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setnae", 1, { M8,         }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x92, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "setnb",  1, { R8,         }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x93, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setnb",  1, { R8H,        }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x93, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setnb",  1, { M8,         }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x93, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "setnbe", 1, { R8,         }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x97, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setnbe", 1, { R8H,        }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x97, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setnbe", 1, { M8,         }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x97, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "setnc",  1, { R8,         }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x93, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setnc",  1, { R8H,        }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x93, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setnc",  1, { M8,         }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x93, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "setne",  1, { R8,         }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x95, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setne",  1, { R8H,        }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x95, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setne",  1, { M8,         }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x95, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "setng",  1, { R8,         }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9e, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setng",  1, { R8H,        }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9e, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setng",  1, { M8,         }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9e, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "setnge", 1, { R8,         }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9c, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setnge", 1, { R8H,        }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9c, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setnge", 1, { M8,         }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9c, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "setnl",  1, { R8,         }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9d, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setnl",  1, { R8H,        }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9d, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setnl",  1, { M8,         }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9d, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "setnle", 1, { R8,         }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9f, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setnle", 1, { R8H,        }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9f, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setnle", 1, { M8,         }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9f, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "setno",  1, { R8,         }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x91, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setno",  1, { R8H,        }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x91, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setno",  1, { M8,         }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x91, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "setnp",  1, { R8,         }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9b, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setnp",  1, { R8H,        }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9b, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setnp",  1, { M8,         }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9b, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "setns",  1, { R8,         }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x99, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setns",  1, { R8H,        }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x99, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setns",  1, { M8,         }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x99, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "setnz",  1, { R8,         }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x95, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setnz",  1, { R8H,        }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x95, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setnz",  1, { M8,         }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x95, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "seto",   1, { R8,         }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x90, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "seto",   1, { R8H,        }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x90, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "seto",   1, { M8,         }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x90, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "setp",   1, { R8,         }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9a, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setp",   1, { R8H,        }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9a, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setp",   1, { M8,         }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9a, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "setpe",  1, { R8,         }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9a, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setpe",  1, { R8H,        }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9a, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setpe",  1, { M8,         }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9a, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "setpo",  1, { R8,         }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9b, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setpo",  1, { R8H,        }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9b, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setpo",  1, { M8,         }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x9b, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "sets",   1, { R8,         }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x98, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sets",   1, { R8H,        }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x98, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sets",   1, { M8,         }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x98, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "setz",   1, { R8,         }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x94, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setz",   1, { R8H,        }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),							  NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x94, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                                 (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "setz",   1, { M8,         }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x94, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE,                (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
//cmov(A, 0x47, a)
{ "cmova",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x47, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmova",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x47, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmova",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		            NO_VEX, NO_EVEX, 1, 1, { 0x47, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmova",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0x47, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmova",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0x47, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmova",    2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x47, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "cmovae",   2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x43, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovae",   2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x43, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovae",   2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		            NO_VEX, NO_EVEX, 1, 1, { 0x43, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmovae",   2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0x43, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovae",   2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0x43, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovae",   2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x43, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "cmovb",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x42, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovb",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x42, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovb",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		            NO_VEX, NO_EVEX, 1, 1, { 0x42, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmovb",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0x42, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovb",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0x42, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovb",    2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x42, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "cmovbe",   2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x46, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovbe",   2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x46, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovbe",   2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		            NO_VEX, NO_EVEX, 1, 1, { 0x46, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmovbe",   2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0x46, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovbe",   2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0x46, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovbe",   2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x46, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "cmovc",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x42, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovc",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x42, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovc",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		            NO_VEX, NO_EVEX, 1, 1, { 0x42, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmovc",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0x42, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovc",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0x42, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovc",    2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x42, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "cmove",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x44, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmove",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x44, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmove",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		            NO_VEX, NO_EVEX, 1, 1, { 0x44, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmove",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0x44, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmove",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0x44, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmove",    2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x44, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "cmovg",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x4f, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovg",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x4f, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovg",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		            NO_VEX, NO_EVEX, 1, 1, { 0x4f, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmovg",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0x4f, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovg",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0x4f, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovg",    2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x4f, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "cmovge",   2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x4d, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovge",   2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x4d, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovge",   2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		            NO_VEX, NO_EVEX, 1, 1, { 0x4d, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmovge",   2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0x4d, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovge",   2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0x4d, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovge",   2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x4d, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "cmovl",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x4c, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovl",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x4c, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovl",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		            NO_VEX, NO_EVEX, 1, 1, { 0x4c, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmovl",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0x4c, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovl",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0x4c, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovl",    2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x4c, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "cmovle",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x4e, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovle",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x4e, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovle",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x4e, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmovle",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x4e, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovle",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x4e, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovle",    2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x4e, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "cmovna",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x46, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovna",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x46, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovna",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x46, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmovna",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x46, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovna",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x46, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovna",    2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x46, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "cmovnae",   2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x42, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovnae",   2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x42, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovnae",   2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x42, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmovnae",   2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x42, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovnae",   2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x42, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovnae",   2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x42, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "cmovnb",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x43, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovnb",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x43, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovnb",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x43, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmovnb",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x43, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovnb",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x43, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovnb",    2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x43, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "cmovnbe",   2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x47, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovnbe",   2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x47, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovnbe",   2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x47, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmovnbe",   2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x47, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovnbe",   2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x47, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovnbe",   2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x47, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "cmovnc",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x43, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovnc",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x43, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovnc",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x43, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmovnc",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x43, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovnc",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x43, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovnc",    2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x43, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "cmovne",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x45, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovne",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x45, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovne",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x45, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmovne",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x45, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovne",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x45, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovne",    2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x45, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "cmovng",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x4e, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovng",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x4e, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovng",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x4e, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmovng",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x4e, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovng",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x4e, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovng",    2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x4e, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "cmovnge",   2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x4c, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovnge",   2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x4c, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovnge",   2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x4c, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmovnge",   2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x4c, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovnge",   2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x4c, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovnge",   2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x4c, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "cmovnl",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x4d, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovnl",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x4d, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovnl",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x4d, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmovnl",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x4d, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovnl",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x4d, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovnl",    2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x4d, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "cmovnle",   2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x4f, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovnle",   2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x4f, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovnle",   2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x4f, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmovnle",   2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x4f, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovnle",   2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x4f, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovnle",   2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x4f, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "cmovno",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x41, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovno",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x41, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovno",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x41, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmovno",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x41, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovno",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x41, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovno",    2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x41, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "cmovnp",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x4b, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovnp",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x4b, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovnp",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x4b, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmovnp",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x4b, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovnp",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x4b, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovnp",    2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x4b, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "cmovns",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x49, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovns",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x49, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovns",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x49, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmovns",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x49, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovns",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x49, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovns",    2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x49, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "cmovnz",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x45, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovnz",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x45, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovnz",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x45, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmovnz",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x45, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovnz",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x45, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovnz",    2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x45, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "cmovo",     2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x00, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovo",     2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x00, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovo",     2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x00, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmovo",     2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x00, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovo",     2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x00, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovo",     2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x00, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "cmovp",     2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x4a, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovp",     2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x4a, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovp",     2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x4a, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmovp",     2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x4a, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovp",     2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x4a, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovp",     2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x4a, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "cmovpe",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x4a, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovpe",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x4a, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovpe",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x4a, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmovpe",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x4a, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovpe",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x4a, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovpe",    2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x4a, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "cmovpo",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x4b, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovpo",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x4b, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovpo",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x4b, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmovpo",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x4b, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovpo",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x4b, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovpo",    2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x4b, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "cmovs",     2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x48, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovs",     2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x48, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovs",     2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x48, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmovs",     2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x48, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovs",     2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x48, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovs",     2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x48, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "cmovz",     2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x44, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovz",     2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x44, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,      (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmovz",     2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x44, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmovz",     2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x44, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovz",     2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                      NO_VEX, NO_EVEX, 1, 1, { 0x44, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "cmovz",     2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x44, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "ret",       1, { IMM16,            }, GP0, (NO_FLAGS),	                                                      NO_VEX, NO_EVEX, 1, 1, { 0xc2, 0x00, 0x00 }, 2, 0, NO_MOD, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "ret",       0, { OP_N,     OP_N    }, GP0, (NO_FLAGS),                                                       NO_VEX, NO_EVEX, 1, 1, { 0xc3, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "retn",      1, { IMM16,            }, GP0, (NO_FLAGS),	                                                      NO_VEX, NO_EVEX, 1, 1, { 0xc2, 0x00, 0x00 }, 2, 0, NO_MOD, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "retn",      0, { OP_N,     OP_N    }, GP0, (NO_FLAGS),                                                       NO_VEX, NO_EVEX, 1, 1, { 0xc3, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "retf",      1, { IMM16,            }, GP0, (NO_FLAGS),	                                                      NO_VEX, NO_EVEX, 1, 1, { 0xca, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "retf",      0, { OP_N,     OP_N    }, GP0, (NO_FLAGS),                                                       NO_VEX, NO_EVEX, 1, 1, { 0xcb, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "rsm",       0, { OP_N,     OP_N    }, GP0, (NO_FLAGS),                                                       NO_VEX, NO_EVEX, 1, 1, { 0xaa, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, PFX_0xF,   NO_IMM, NO_MEM, P_586, 0, NULL },
{ "sahf",      0, { OP_N,     OP_N    }, GP0, (NO_FLAGS),                                                       NO_VEX, NO_EVEX, 1, 1, { 0x9e, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_586, 0, NULL },
//0F 01 / 0 SGDT m M Valid Valid
{ "sgdt",    1, { M_ANY,         }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),                       NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x01, 0x00 }, 4, 0, 0x04,     0, 0, ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_286, 0, NULL },
//0F 01 / 1 SIDT m M Valid Valid
{ "sidt",    1, { M_ANY,         }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),                       NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x01, 0x00 }, 4, 0, 0x0c,     0, 0, ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_286, 0, NULL },

//CALL rel16       E8 cw           M N.S.    Valid
//CALL rel32       E8 cd           M Valid   Valid
{ "call",    1, { IMM16,       }, GP4, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0xe8, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,   (X16 | X32), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "call",    1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0xe8, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_386, 0, NULL },
//CALL r/m16       FF /2           M N.E.    Valid
//CALL r/m32       FF /2           M N.E.    Valid
//CALL r/m64       FF /2           M Valid   N.E. 
{ "call",    1, { R16,         }, GP4, (F_OPCODE2_REG),					                                              NO_VEX, NO_EVEX, 1, 2, { 0xff, 0xd0, 0x00 }, 2, 0, NO_MOD, 0,       0,                0,       (X16 | X32), NO_DST, NO_PREFIX, NO_IMM, NO_MEM,     P_86,  0, NULL },
{ "call",    1, { R32,         }, GP4, (F_OPCODE2_REG),					                                              NO_VEX, NO_EVEX, 1, 2, { 0xff, 0xd0, 0x00 }, 4, 0, NO_MOD, 0,       0,                0,       (X16 | X32), NO_DST, NO_PREFIX, NO_IMM, NO_MEM,     P_386, 0, NULL },
{ "call",    1, { R64,         }, GP3, (F_OPCODE2_REG),		                                                    NO_VEX, NO_EVEX, 1, 2, { 0xff, 0xd0, 0x00 }, 8, 0, NO_MOD, 0,       0,                0,             (X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM,     P_64,  0, NULL },
{ "call",    1, { M16,         }, GP4, ALLOW_SEG,                                                             NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 2, 0, 0x10,     0, OP_SIZE_OVERRIDE, 0,  (X16 | X32), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "call",    1, { M32,         }, GP4, ALLOW_SEG,                                                             NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 4, 0, 0x10,     0, 0, ADDR_SIZE_OVERRIDE,  (X16 | X32), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_386, 0, NULL },
{ "call",    1, { M64,         }, GP3, ALLOW_SEG | (REX | REXW),                                              NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 8, 0, 0x10,     0, 0, ADDR_SIZE_OVERRIDE,        (X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
//CALL ptr16:16    9A cd           D Invalid Valid
//CALL ptr16:32    9A cp           D Invalid Valid
{ "call",    1, { IMM16,       }, GP4, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x9a, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "call",    1, { IMM48,       }, GP4, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x9a, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X32), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_386,  0, NULL },
//CALL m16:16      FF /3           M Valid   Valid
//CALL m16:32      FF /3           M Valid   Valid
//CALL m16:64      REX.W + FF /3   M Valid   N.E. 
{ "call",    1, { M32,       }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),		                      NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 4, 0, 0x18,     0, 0, 0,  (X16 | X32), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_86, 0, NULL },
{ "call",    1, { M48,       }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),	                        NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 4, 0, 0x18,     0, 0, 0,  (X16 | X32), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_386, 0, NULL },
{ "call",    1, { M80,       }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM | OPCODE_EXT),          NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 8, 0, 0x18,     0, 0, 0,        (X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_64, 0, NULL },
//JMP rel8        EB cb           D   Valid   Valid   Jump short, RIP = RIP + 8-bit displacement sign extended to 64-bits                          
//JMP rel16       E9 cw           D   N.S.    Valid   Jump near, relative, displacement relative to next instruction. Not supported in 64-bit mode.
//JMP rel32       E9 cd           D   Valid   Valid   Jump near, relative, RIP = RIP + 32-bit displacement sign extended to 64-bits                
{ "jmp",    1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0xeb, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jmp",    1, { IMM16,       }, GP4, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0xe9, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                        (X16 | X32), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jmp",    1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0xe9, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_386, 0, NULL },
//JMP r/m16       FF /4           M   N.S.    Valid   Jump near, absolute indirect, address = zeroextended r/m16. Not supported in 64-bit mode.    
//JMP r/m32       FF /4           M   N.S.    Valid   Jump near, absolute indirect, address given in r/m32. Not supported in 64-bit mode.          
//JMP r/m64       FF /4           M   Valid   N.E.    Jump near, absolute indirect, RIP = 64-Bit offset from register or memory                    

{ "jmp",    1, { R16,         }, GP4, (F_OPCODE2_REG),					                                              NO_VEX, NO_EVEX, 1, 2, { 0xff, 0xe0, 0x00 }, 2, 0, NO_MOD, 0,       0,                0,       (X16 | X32), NO_DST, NO_PREFIX, NO_IMM, NO_MEM,     P_86,  0, NULL },
{ "jmp",    1, { R32,         }, GP4, (F_OPCODE2_REG),					                                              NO_VEX, NO_EVEX, 1, 2, { 0xff, 0xe0, 0x00 }, 4, 0, NO_MOD, 0,       0,                0,       (X16 | X32), NO_DST, NO_PREFIX, NO_IMM, NO_MEM,     P_386, 0, NULL },
{ "jmp",    1, { M16,         }, GP4, ALLOW_SEG,                                                              NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 2, 0, 0x20,   0, OP_SIZE_OVERRIDE, 0,             (X16 | X32), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "jmp",    1, { M32,         }, GP4, ALLOW_SEG,                                                              NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 4, 0, 0x20,   0,       0, ADDR_SIZE_OVERRIDE,     (X16 | X32), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_386, 0, NULL },
{ "jmp",    1, { R64,         }, GP3, (F_OPCODE2_REG),		                                                    NO_VEX, NO_EVEX, 1, 2, { 0xff, 0xe0, 0x00 }, 8, 0, NO_MOD, 0,       0,                0,             (X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM,     P_64,  0, NULL },
{ "jmp",    1, { M64,         }, GP3, ALLOW_SEG | REXW,                                                       NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 8, 0, 0x20,   0,       0, ADDR_SIZE_OVERRIDE,           (X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },

//JMP ptr16:16    EA cd           D   Inv.    Valid   Jump far, absolute, address given in operand                                                 
//JMP ptr16:32    EA cp           D   Inv.    Valid   Jump far, absolute, address given in operand                                                 

{ "jmp",    1, { IMM16,       }, GP4, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0xea, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32), NO_DST,  PFX_0xF, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jmp",    1, { IMM48,       }, GP4, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0xea, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X32), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_386,  0, NULL },
//JMP m16:16      FF /5           D   Valid   Valid   Jump far, absolute indirect, address given in m16:16                                         
//JMP m16:32      FF /5           D   Valid   Valid   Jump far, absolute indirect, address given in m16:32.                                        
//JMP m16:64      REX.W + FF /5   D   Valid   N.E.    Jump far, absolute indirect, address given in m16:64.                                        
{ "jmp",    1, { M32,       }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),		                      NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 2, 0, 0x28,     0, 0, 0,  (X16 | X32 | X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_86, 0, NULL },
{ "jmp",    1, { M48,       }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),	                        NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 4, 0, 0x28,     0, 0, 0,  (X16 | X32 | X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_386, 0, NULL },
{ "jmp",    1, { M80,       }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM | OPCODE_EXT),           NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 8, 0, 0x28,     0, 0, 0,              (X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_64, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */

{ "ja",    1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x77, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "ja",    1, { IMM16,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x87, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "ja",    1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x87, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jae",   1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x73, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jae",   1, { IMM16,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jae",   1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jb",    1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x72, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jb",    1, { IMM16,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x82, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jb",    1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x82, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jbe",   1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x76, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jbe",   1, { IMM16,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x86, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jbe",   1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x86, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jc",    1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x72, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jc",    1, { IMM16,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x82, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jc",    1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x82, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "je",    1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x74, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "je",    1, { IMM16,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x84, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "je",    1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x84, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jg",    1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x7f, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jg",    1, { IMM16,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x8f, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jg",    1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x8f, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jge",   1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x7d, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jge",   1, { IMM16,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x8d, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jge",   1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x8d, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jl",    1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x7c, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jl",    1, { IMM16,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x8c, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jl",    1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x8c, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jle",   1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x7e, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jle",   1, { IMM16,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x8e, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jle",   1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x8e, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jna",   1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x76, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jna",   1, { IMM16,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x86, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jna",   1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x86, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jnae",  1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x72, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jnae",  1, { IMM16,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x82, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jnae",  1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x82, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jnb",   1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x73, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jnb",   1, { IMM16,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jnb",   1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jnbe",  1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x77, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jnbe",  1, { IMM16,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x87, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jnbe",  1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x87, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jnc",   1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x73, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jnc",   1, { IMM16,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jnc",   1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x83, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jne",   1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x75, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jne",   1, { IMM16,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x85, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jne",   1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x85, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jng",   1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x7e, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jng",   1, { IMM16,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x8e, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jng",   1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x8e, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jnge",  1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x7c, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jnge",  1, { IMM16,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x8c, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jnge",  1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x8c, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jnl",   1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x7d, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jnl",   1, { IMM16,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x8d, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jnl",   1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x8d, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jnle",  1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x7f, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jnle",  1, { IMM16,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x8f, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jnle",  1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x8f, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jno",   1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x71, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jno",   1, { IMM16,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jno",   1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jnp",   1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x7b, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jnp",   1, { IMM16,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x8b, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jnp",   1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x8b, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jns",   1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x79, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jns",   1, { IMM16,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x89, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jns",   1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x89, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jnz",   1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x75, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jnz",   1, { IMM16,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x85, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jnz",   1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x85, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jo",    1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x70, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jo",    1, { IMM16,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jo",    1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jp",    1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x7a, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jp",    1, { IMM16,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x8a, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jp",    1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x8a, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jpe",   1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x7a, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jpe",   1, { IMM16,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x8a, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jpe",   1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x8a, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jpo",   1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x7b, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jpo",   1, { IMM16,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x8b, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jpo",   1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x8b, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "js",    1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x78, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "js",    1, { IMM16,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x88, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "js",    1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x88, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jz",    1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x74, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jz",    1, { IMM16,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x84, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "jz",    1, { IMM32,       }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0x84, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF,   IMM_OPND_0, NO_MEM, P_386, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//RCL r / m8, 1       D0 / 2                 M1 Valid Valid Rotate 9 bits(CF, r / m8) left once.
//RCL r / m8*, 1      REX + D0 / 2           M1 Valid N.E.Rotate 9 bits(CF, r / m8) left once.
//RCL r / m8, CL      D2 / 2                 MC Valid Valid Rotate 9 bits(CF, r / m8) left CL times.
//RCL r / m8*, CL     REX + D2 / 2           MC Valid N.E.Rotate 9 bits(CF, r / m8) left CL times.
//RCL r / m8, imm8    C0 / 2 ib              MI Valid Valid Rotate 9 bits(CF, r / m8) left imm8 times.
//RCL r / m8*, imm8   REX + C0 / 2 ib        MI Valid N.E.Rotate 9 bits(CF, r / m8) left imm8 times.
//RCL r / m16, 1      D1 / 2                 M1 Valid Valid Rotate 17 bits(CF, r / m16) left once.
//RCL r / m16, CL     D3 / 2                 MC Valid Valid Rotate 17 bits(CF, r / m16) left CL times.
//RCL r / m16, imm8   C1 / 2 ib              MI Valid Valid Rotate 17 bits(CF, r / m16) left imm8 times.
//RCL r / m32, 1      D1 / 2                 M1 Valid Valid Rotate 33 bits(CF, r / m32) left once.
//RCL r / m64, 1      REX.W + D1 / 2         M1 Valid N.E.Rotate 65 bits(CF, r / m64) left once.Uses a 6bit count.
//RCL r / m32, CL     D3 / 2                 MC Valid Valid Rotate 33 bits(CF, r / m32) left CL times.
//RCL r / m64, CL     REX.W + D3 / 2         MC Valid N.E.Rotate 65 bits(CF, r / m64) left CL times.Uses 6 bit count.
//RCL r / m32, imm8   C1 / 2 ib              MI Valid Valid Rotate 33 bits(CF, r / m32) left imm8 times.
//RCL r / m64, imm8   REX.W + C1 / 2 ib      MI Valid N.E.Rotate 65 bits(CF, r / m64) left imm8 times.Uses a 6 bit count.
/* ----------------------------------------------------------------------------------------------- */
{ "rcl",    2, { R8,       IMM_1   }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xd0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcl",    2, { R8H,      IMM_1   }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xd0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL }, 
{ "rcl",    2, { R8U,      IMM_1   }, GP3, REX | (F_OPCODE2_REG),												                              NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xd0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcl",    2, { R8E,      IMM_1   }, GP3, (REX | REXB) | (F_OPCODE2_REG),												                    NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xd0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcl",    2, { R8,       R8      }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xd0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcl",    2, { R8H,      R8      }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xd0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcl",    2, { R8U,      R8      }, GP3, REX | (F_OPCODE2_REG),												                              NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xd0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcl",    2, { R8E,      R8      }, GP3, (REX | REXB) | (F_OPCODE2_REG),												                    NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xd0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcl",    2, { R8,       IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x02, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "rcl",    2, { R8H,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x02, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "rcl",    2, { R8U,      IMM8    }, GP3, REX | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                    NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x02, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "rcl",    2, { R8E,      IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x02, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "rcl",    2, { M8,       IMM_1   }, GP0, ALLOW_SEG | (F_OPCODE2_REG),                                               NO_VEX, NO_EVEX, 1, 1, { 0xd0, 0x10, 0x00 }, 1, 0, 0x00, 0, 0,	           ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,P_86,  0, NULL },
{ "rcl",    2, { M8,       R8_CL   }, GP0, ALLOW_SEG | (F_OPCODE2_REG),									                              NO_VEX, NO_EVEX, 1, 1, { 0xd2, 0x10, 0x00 }, 1, 0, 0x00, 0, 0,	           ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,P_86,  0, NULL },
{ "rcl",    2, { M8,       IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x02, 0x00 }, 1, 0, MOD_MEM_IMM, 0, 0,	     ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "rcl",    2, { R16,      IMM_1   }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xd0, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcl",    2, { R16E,     IMM_1   }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xd0, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcl",    2, { R16,      R8      }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0xd0, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcl",    2, { R16E,     R8      }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0xd0, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcl",    2, { R16,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 2, 0, 0xd0,        0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "rcl",    2, { R16E,     IMM8    }, GP0, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 2, 0, 0xd0,        0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "rcl",    2, { R32,      IMM_1   }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xd0, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcl",    2, { R32E,     IMM_1   }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xd0, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcl",    2, { R32,      R8      }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xd0, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcl",    2, { R32E,     R8      }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xd0, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcl",    2, { R32,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),                           NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 4, 0, 0xd0,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "rcl",    2, { R32E,     IMM8    }, GP0, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),            NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 4, 0, 0xd0,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "rcl",    2, { R64,      IMM_1   }, GP3, (REX | REXW) | (F_OPCODE2_REG),                                            NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xd0, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "rcl",    2, { R64E,     IMM_1   }, GP3, (REX | REXW | REXB) | (F_OPCODE2_REG),                                     NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xd0, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "rcl",    2, { R64,      R8      }, GP3, (REX | REXW) | (F_OPCODE2_REG),                                            NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xd0, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "rcl",    2, { R64E,     R8      }, GP3, (REX | REXW | REXB) | (F_OPCODE2_REG),                                     NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xd0, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "rcl",    2, { R64,      IMM8    }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),            NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 8, 0, 0xd0,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "rcl",    2, { R64E,     IMM8    }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),     NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 8, 0, 0xd0,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "rcl",    2, { M16,      IMM_1   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),                            NO_VEX, NO_EVEX, 1, 1, { 0xd1, 0x02, 0x00 }, 2, 0, MOD_MEM_IMM, 0,     OP_SIZE_OVERRIDE,	0,    (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "rcl",    2, { M16,      R8_CL   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0x02, 0x00 }, 2, 0, MOD_MEM_IMM, 0,     OP_SIZE_OVERRIDE,  0,    (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "rcl",    2, { M16,      IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x02, 0x00 }, 2, 0, MOD_MEM_IMM, 0,     OP_SIZE_OVERRIDE, 	0,    (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "rcl",    2, { M32,      IMM_1   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),                            NO_VEX, NO_EVEX, 1, 1, { 0xd1, 0x02, 0x00 }, 4, 0, MOD_MEM_IMM, 0,     0,	 ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "rcl",    2, { M32,      R8_CL   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0x02, 0x00 }, 4, 0, MOD_MEM_IMM, 0,     0,  ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "rcl",    2, { M32,      IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x02, 0x00 }, 4, 0, MOD_MEM_IMM, 0,     0,  ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "rcl",    2, { M64,      IMM_1   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | OPCODE_EXT | IMM8_ONLY),             NO_VEX, NO_EVEX, 1, 1, { 0xd1, 0x02, 0x00 }, 8, 0, MOD_MEM_IMM, 0,     0,	 0,                   (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "rcl",    2, { M64,      R8_CL   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | OPCODE_EXT | IMM8_ONLY),						  NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0x02, 0x00 }, 8, 0, MOD_MEM_IMM, 0,     0,  0,                   (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "rcl",    2, { M64,      IMM8    }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | OPCODE_EXT | IMM8_ONLY),						  NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x02, 0x00 }, 8, 0, MOD_MEM_IMM, 0,     0,  0,                   (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },


/* ----------------------------------------------------------------------------------------------- */
//RCR r / m8, 1       D0 / 3                 M1 Valid Valid Rotate 9 bits(CF, r / m8) right once.
//RCR r / m8*, 1      REX + D0 / 3           M1 Valid N.E.Rotate 9 bits(CF, r / m8) right once.
//RCR r / m8, CL      D2 / 3                 MC Valid Valid Rotate 9 bits(CF, r / m8) right CL times.
//RCR r / m8*, CL     REX + D2 / 3           MC Valid N.E.Rotate 9 bits(CF, r / m8) right CL times.
//RCR r / m8, imm8    C0 / 3 ib              MI Valid Valid Rotate 9 bits(CF, r / m8) right imm8 times.
//RCR r / m8*, imm8   REX + C0 / 3 ib        MI Valid N.E.Rotate 9 bits(CF, r / m8) right imm8 times.
//RCR r / m16, 1      D1 / 3                 M1 Valid Valid Rotate 17 bits(CF, r / m16) right once.
//RCR r / m16, CL     D3 / 3                 MC Valid Valid Rotate 17 bits(CF, r / m16) right CL times.
//RCR r / m16, imm8   C1 / 3 ib              MI Valid Valid Rotate 17 bits(CF, r / m16) right imm8 times.
//RCR r / m32, 1      D1 / 3                 M1 Valid Valid Rotate 33 bits(CF, r / m32) right once.Uses a 6 bit count.
//RCR r / m64, 1      REX.W + D1 / 3         M1 Valid N.E.Rotate 65 bits(CF, r / m64) right once.Uses a 6 bit count.
//RCR r / m32, CL     D3 / 3                 MC Valid Valid Rotate 33 bits(CF, r / m32) right CL times.
//RCR r / m64, CL     REX.W + D3 / 3         MC Valid N.E.Rotate 65 bits(CF, r / m64) right CL times.Uses a 6 bit count.
//RCR r / m32, imm8   C1 / 3 ib              MI Valid Valid Rotate 33 bits(CF, r / m32) right imm8 times.
//RCR r / m64, imm8   REX.W + C1 / 3 ib      MI Valid N.E.Rotate 65 bits(CF, r / m64) right imm8 times.Uses a 6 bit count.
/* ----------------------------------------------------------------------------------------------- */
{ "rcr",    2, { R8,       IMM_1   }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xd8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcr",    2, { R8H,      IMM_1   }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xd8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcr",    2, { R8U,      IMM_1   }, GP3, REX | (F_OPCODE2_REG),												                              NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xd8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcr",    2, { R8E,      IMM_1   }, GP3, (REX | REXB) | (F_OPCODE2_REG),												                    NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xd8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcr",    2, { R8,       R8      }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xd8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcr",    2, { R8H,      R8      }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xd8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcr",    2, { R8U,      R8      }, GP3, REX | (F_OPCODE2_REG),												                              NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xd8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcr",    2, { R8E,      R8      }, GP3, (REX | REXB) | (F_OPCODE2_REG),												                    NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xd8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcr",    2, { R8,       IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x03, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "rcr",    2, { R8H,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x03, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "rcr",    2, { R8U,      IMM8    }, GP3, REX | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                    NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x03, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "rcr",    2, { R8E,      IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x03, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "rcr",    2, { M8,       IMM_1   }, GP0, ALLOW_SEG | (F_OPCODE2_REG),                                               NO_VEX, NO_EVEX, 1, 1, { 0xd0, 0x18, 0x00 }, 1, 0, 0x00, 0, 0,	           ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,P_86,  0, NULL },
{ "rcr",    2, { M8,       R8_CL   }, GP0, ALLOW_SEG | (F_OPCODE2_REG),									                              NO_VEX, NO_EVEX, 1, 1, { 0xd2, 0x18, 0x00 }, 1, 0, 0x00, 0, 0,	           ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,P_86,  0, NULL },
{ "rcr",    2, { M8,       IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x03, 0x00 }, 1, 0, MOD_MEM_IMM, 0, 0,	     ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "rcr",    2, { R16,      IMM_1   }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xd8, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcr",    2, { R16E,     IMM_1   }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xd8, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcr",    2, { R16,      R8      }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0xd8, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcr",    2, { R16E,     R8      }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0xd8, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcr",    2, { R16,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 2, 0, 0xd8,        0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "rcr",    2, { R16E,     IMM8    }, GP0, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 2, 0, 0xd8,        0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "rcr",    2, { R32,      IMM_1   }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xd8, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcr",    2, { R32E,     IMM_1   }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xd8, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcr",    2, { R32,      R8      }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xd8, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcr",    2, { R32E,     R8      }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xd8, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rcr",    2, { R32,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),                           NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 4, 0, 0xd8,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "rcr",    2, { R32E,     IMM8    }, GP0, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),            NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 4, 0, 0xd8,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "rcr",    2, { R64,      IMM_1   }, GP3, (REX | REXW) | (F_OPCODE2_REG),                                            NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xd8, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "rcr",    2, { R64E,     IMM_1   }, GP3, (REX | REXW | REXB) | (F_OPCODE2_REG),                                     NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xd8, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "rcr",    2, { R64,      R8      }, GP3, (REX | REXW) | (F_OPCODE2_REG),                                            NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xd8, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "rcr",    2, { R64E,     R8      }, GP3, (REX | REXW | REXB) | (F_OPCODE2_REG),                                     NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xd8, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "rcr",    2, { R64,      IMM8    }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),            NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 8, 0, 0xd8,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "rcr",    2, { R64E,     IMM8    }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),     NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 8, 0, 0xd8,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "rcr",    2, { M16,      IMM_1   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),                            NO_VEX, NO_EVEX, 1, 1, { 0xd1, 0x03, 0x00 }, 2, 0, MOD_MEM_IMM, 0,     OP_SIZE_OVERRIDE,	0,    (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "rcr",    2, { M16,      R8_CL   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0x03, 0x00 }, 2, 0, MOD_MEM_IMM, 0,     OP_SIZE_OVERRIDE,  0,    (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "rcr",    2, { M16,      IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x03, 0x00 }, 2, 0, MOD_MEM_IMM, 0,     OP_SIZE_OVERRIDE, 	0,    (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "rcr",    2, { M32,      IMM_1   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),                            NO_VEX, NO_EVEX, 1, 1, { 0xd1, 0x03, 0x00 }, 4, 0, MOD_MEM_IMM, 0,     0,	 ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "rcr",    2, { M32,      R8_CL   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0x03, 0x00 }, 4, 0, MOD_MEM_IMM, 0,     0,  ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "rcr",    2, { M32,      IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x03, 0x00 }, 4, 0, MOD_MEM_IMM, 0,     0,  ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "rcr",    2, { M64,      IMM_1   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | OPCODE_EXT | IMM8_ONLY),             NO_VEX, NO_EVEX, 1, 1, { 0xd1, 0x03, 0x00 }, 8, 0, MOD_MEM_IMM, 0,     0,	 0,                   (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "rcr",    2, { M64,      R8_CL   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | OPCODE_EXT | IMM8_ONLY),						  NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0x03, 0x00 }, 8, 0, MOD_MEM_IMM, 0,     0,  0,                   (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "rcr",    2, { M64,      IMM8    }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | OPCODE_EXT | IMM8_ONLY),						  NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x03, 0x00 }, 8, 0, MOD_MEM_IMM, 0,     0,  0,                   (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },


/* ----------------------------------------------------------------------------------------------- */
//ROL r / m8, 1       D0 / 0                 M1 Valid Valid Rotate 8 bits r / m8 left once.
//ROL r / m8*, 1      REX + D0 / 0           M1 Valid N.E.Rotate 8 bits r / m8 left once
//ROL r / m8, CL      D2 / 0                 MC Valid Valid Rotate 8 bits r / m8 left CL times.
//ROL r / m8*, CL     REX + D2 / 0           MC Valid N.E.Rotate 8 bits r / m8 left CL times.
//ROL r / m8, imm8    C0 / 0 ib              MI Valid Valid Rotate 8 bits r / m8 left imm8 times.
//ROL r / m8*, imm8   REX + C0 / 0 ib        MI Valid N.E.Rotate 8 bits r / m8 left imm8 times.
//ROL r / m16, 1      D1 / 0                 M1 Valid Valid Rotate 16 bits r / m16 left once.
//ROL r / m16, CL     D3 / 0                 MC Valid Valid Rotate 16 bits r / m16 left CL times.
//ROL r / m16, imm8   C1 / 0 ib              MI Valid Valid Rotate 16 bits r / m16 left imm8 times.
//ROL r / m32, 1      D1 / 0                 M1 Valid Valid Rotate 32 bits r / m32 left once.
//ROL r / m64, 1      REX.W + D1 / 0         M1 Valid N.E.Rotate 64 bits r / m64 left once.Uses a 6 bit count.
//ROL r / m32, CL     D3 / 0                 MC Valid Valid Rotate 32 bits r / m32 left CL times.
//ROL r / m64, CL     REX.W + D3 / 0         MC Valid N.E.Rotate 64 bits r / m64 left CL times.Uses a 6 bit count.
//ROL r / m32, imm8   C1 / 0 ib              MI Valid Valid Rotate 32 bits r / m32 left imm8 times.
//ROL r / m64, imm8   REX.W + C1 / 0 ib      MI Valid N.E.Rotate 64 bits r / m64 left imm8 times.Uses a 6 bit count.
/* ----------------------------------------------------------------------------------------------- */
{ "rol",    2, { R8,       IMM_1   }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xc0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rol",    2, { R8H,      IMM_1   }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xc0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rol",    2, { R8U,      IMM_1   }, GP3, REX | (F_OPCODE2_REG),												                              NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xc0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rol",    2, { R8E,      IMM_1   }, GP3, (REX | REXB) | (F_OPCODE2_REG),												                    NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xc0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rol",    2, { R8,       R8      }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xc0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rol",    2, { R8H,      R8      }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xc0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rol",    2, { R8U,      R8      }, GP3, REX | (F_OPCODE2_REG),												                              NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xc0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rol",    2, { R8E,      R8      }, GP3, (REX | REXB) | (F_OPCODE2_REG),												                    NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xc0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rol",    2, { R8,       IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x00, 0x00 }, 1, 0, 0xc0, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "rol",    2, { R8H,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x00, 0x00 }, 1, 0, 0xc0, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "rol",    2, { R8U,      IMM8    }, GP3, REX | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                    NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x00, 0x00 }, 1, 0, 0xc0, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "rol",    2, { R8E,      IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x00, 0x00 }, 1, 0, 0xc0, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "rol",    2, { M8,       IMM_1   }, GP0, ALLOW_SEG | (F_OPCODE2_REG),                                               NO_VEX, NO_EVEX, 1, 1, { 0xd0, 0x00, 0x00 }, 1, 0, 0xc0, 0, 0,	           ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,P_86,  0, NULL },
{ "rol",    2, { M8,       R8_CL   }, GP0, ALLOW_SEG | (F_OPCODE2_REG),									                              NO_VEX, NO_EVEX, 1, 1, { 0xd2, 0x00, 0x00 }, 1, 0, 0xc0, 0, 0,	           ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,P_86,  0, NULL },
{ "rol",    2, { M8,       IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x00, 0x00 }, 1, 0, MOD_MEM_IMM, 0, 0,	     ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },

{ "rol",    2, { R16,      IMM_1   }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xc0, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rol",    2, { R16E,     IMM_1   }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xc0, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rol",    2, { R16,      R8      }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0xc0, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rol",    2, { R16E,     R8      }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0xc0, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rol",    2, { R16,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 2, 0, 0xc0,        0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "rol",    2, { R16E,     IMM8    }, GP0, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 2, 0, 0xc0,        0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "rol",    2, { R32,      IMM_1   }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xc0, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rol",    2, { R32E,     IMM_1   }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xc0, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rol",    2, { R32,      R8      }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xc0, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rol",    2, { R32E,     R8      }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xc0, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "rol",    2, { R32,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),                           NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 4, 0, 0xc0,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "rol",    2, { R32E,     IMM8    }, GP0, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),            NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 4, 0, 0xc0,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "rol",    2, { R64,      IMM_1   }, GP3, (REX | REXW) | (F_OPCODE2_REG),                                            NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xc0, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "rol",    2, { R64E,     IMM_1   }, GP3, (REX | REXW | REXB) | (F_OPCODE2_REG),                                     NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xc0, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "rol",    2, { R64,      R8      }, GP3, (REX | REXW) | (F_OPCODE2_REG),                                            NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xc0, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "rol",    2, { R64E,     R8      }, GP3, (REX | REXW | REXB) | (F_OPCODE2_REG),                                     NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xc0, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "rol",    2, { R64,      IMM8    }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),            NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 8, 0, 0xc0,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "rol",    2, { R64E,     IMM8    }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),     NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 8, 0, 0xc0,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },

{ "rol",    2, { M16,      IMM_1   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),                            NO_VEX, NO_EVEX, 1, 1, { 0xd1, 0x00, 0x00 }, 2, 0, MOD_MEM_IMM, 0,     OP_SIZE_OVERRIDE,	0,    (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "rol",    2, { M16,      R8_CL   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0x00, 0x00 }, 2, 0, MOD_MEM_IMM, 0,     OP_SIZE_OVERRIDE,  0,    (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "rol",    2, { M16,      IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 2, 0, MOD_MEM_IMM, 0,     OP_SIZE_OVERRIDE, 	0,    (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "rol",    2, { M32,      IMM_1   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),                            NO_VEX, NO_EVEX, 1, 1, { 0xd1, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0,     0,	 ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "rol",    2, { M32,      R8_CL   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0,     0,  ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "rol",    2, { M32,      IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0,     0,  ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "rol",    2, { M64,      IMM_1   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | OPCODE_EXT | IMM8_ONLY),             NO_VEX, NO_EVEX, 1, 1, { 0xd1, 0x00, 0x00 }, 8, 0, MOD_MEM_IMM, 0,     0,	 0,                   (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "rol",    2, { M64,      R8_CL   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | OPCODE_EXT | IMM8_ONLY),						  NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0x00, 0x00 }, 8, 0, MOD_MEM_IMM, 0,     0,  0,                   (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "rol",    2, { M64,      IMM8    }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | OPCODE_EXT | IMM8_ONLY),						  NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 8, 0, MOD_MEM_IMM, 0,     0,  0,                   (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },


/* ----------------------------------------------------------------------------------------------- */
//ROR r / m8, 1       D0 / 1                 M1 Valid Valid Rotate 8 bits r / m8 right once.
//ROR r / m8*, 1      REX + D0 / 1           M1 Valid N.E.Rotate 8 bits r / m8 right once.
//ROR r / m8, CL      D2 / 1                 MC Valid Valid Rotate 8 bits r / m8 right CL times.
//ROR r / m8*, CL     REX + D2 / 1           MC Valid N.E.Rotate 8 bits r / m8 right CL times.
//ROR r / m8, imm8    C0 / 1 ib              MI Valid Valid Rotate 8 bits r / m16 right imm8 times.
//ROR r / m8*, imm8   REX + C0 / 1 ib        MI Valid N.E.Rotate 8 bits r / m16 right imm8 times.
//ROR r / m16, 1      D1 / 1                 M1 Valid Valid Rotate 16 bits r / m16 right once.
//ROR r / m16, CL     D3 / 1                 MC Valid Valid Rotate 16 bits r / m16 right CL times.
//ROR r / m16, imm8   C1 / 1 ib              MI Valid Valid Rotate 16 bits r / m16 right imm8 times.
//ROR r / m32, 1      D1 / 1                 M1 Valid Valid Rotate 32 bits r / m32 right once.
//ROR r / m64, 1      REX.W + D1 / 1         M1 Valid N.E.Rotate 64 bits r / m64 right once.Uses a 6 bit count.
//ROR r / m32, CL     D3 / 1                 MC Valid Valid Rotate 32 bits r / m32 right CL times.
//ROR r / m64, CL     REX.W + D3 / 1         MC Valid N.E.Rotate 64 bits r / m64 right CL times.Uses a 6 bit count.
//ROR r / m32, imm8   C1 / 1 ib              MI Valid Valid Rotate 32 bits r / m32 right imm8 times.
//ROR r / m64, imm8   REX.W + C1 / 1 ib      MI Valid N.E.Rotate 64 bits r / m64 right imm8 times.Uses a 6 bit count.
/* ----------------------------------------------------------------------------------------------- */
{ "ror",    2, { R8,       IMM_1   }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xc8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "ror",    2, { R8H,      IMM_1   }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xc8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "ror",    2, { R8U,      IMM_1   }, GP3, REX | (F_OPCODE2_REG),												                              NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xc8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "ror",    2, { R8E,      IMM_1   }, GP3, (REX | REXB) | (F_OPCODE2_REG),												                    NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xc8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "ror",    2, { R8,       R8      }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xc8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "ror",    2, { R8H,      R8      }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xc8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "ror",    2, { R8U,      R8      }, GP3, REX | (F_OPCODE2_REG),												                              NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xc8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "ror",    2, { R8E,      R8      }, GP3, (REX | REXB) | (F_OPCODE2_REG),												                    NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xc8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "ror",    2, { R8,       IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x00, 0x00 }, 1, 0, 0xc8, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "ror",    2, { R8H,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x00, 0x00 }, 1, 0, 0xc8, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "ror",    2, { R8U,      IMM8    }, GP3, REX | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                    NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x00, 0x00 }, 1, 0, 0xc8, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "ror",    2, { R8E,      IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x00, 0x00 }, 1, 0, 0xc8, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "ror",    2, { M8,       IMM_1   }, GP0, ALLOW_SEG | (F_OPCODE2_REG),                                               NO_VEX, NO_EVEX, 1, 1, { 0xd0, 0x00, 0x00 }, 1, 0, 0xc8, 0, 0,	           ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,P_86,  0, NULL },
{ "ror",    2, { M8,       R8_CL   }, GP0, ALLOW_SEG | (F_OPCODE2_REG),									                              NO_VEX, NO_EVEX, 1, 1, { 0xd2, 0x00, 0x00 }, 1, 0, 0xc8, 0, 0,	           ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,P_86,  0, NULL },
{ "ror",    2, { M8,       IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x00, 0x00 }, 1, 0, MOD_MEM_IMM, 0, 0,	     ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "ror",    2, { R16,      IMM_1   }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xc8, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "ror",    2, { R16E,     IMM_1   }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xc8, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "ror",    2, { R16,      R8      }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0xc8, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "ror",    2, { R16E,     R8      }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0xc8, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "ror",    2, { R16,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 2, 0, 0xc8,        0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "ror",    2, { R16E,     IMM8    }, GP0, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 2, 0, 0xc8,        0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "ror",    2, { R32,      IMM_1   }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xc8, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "ror",    2, { R32E,     IMM_1   }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xc8, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "ror",    2, { R32,      R8      }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xc8, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "ror",    2, { R32E,     R8      }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xc8, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "ror",    2, { R32,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),                           NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 4, 0, 0xc8,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "ror",    2, { R32E,     IMM8    }, GP0, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),            NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 4, 0, 0xc8,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "ror",    2, { R64,      IMM_1   }, GP3, (REX | REXW) | (F_OPCODE2_REG),                                            NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xc8, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "ror",    2, { R64E,     IMM_1   }, GP3, (REX | REXW | REXB) | (F_OPCODE2_REG),                                     NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xc8, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "ror",    2, { R64,      R8      }, GP3, (REX | REXW) | (F_OPCODE2_REG),                                            NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xc8, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "ror",    2, { R64E,     R8      }, GP3, (REX | REXW | REXB) | (F_OPCODE2_REG),                                     NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xc8, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "ror",    2, { R64,      IMM8    }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),            NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 8, 0, 0xc8,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "ror",    2, { R64E,     IMM8    }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),     NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 8, 0, 0xc8,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "ror",    2, { M16,      IMM_1   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),                            NO_VEX, NO_EVEX, 1, 1, { 0xd1, 0x00, 0x00 }, 2, 0, MOD_MEM_IMM, 0,     OP_SIZE_OVERRIDE,	0,    (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "ror",    2, { M16,      R8_CL   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0x00, 0x00 }, 2, 0, MOD_MEM_IMM, 0,     OP_SIZE_OVERRIDE,  0,    (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "ror",    2, { M16,      IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 2, 0, MOD_MEM_IMM, 0,     OP_SIZE_OVERRIDE, 	0,    (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "ror",    2, { M32,      IMM_1   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),                            NO_VEX, NO_EVEX, 1, 1, { 0xd1, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0,     0,	 ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "ror",    2, { M32,      R8_CL   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0,     0,  ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "ror",    2, { M32,      IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0,     0,  ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "ror",    2, { M64,      IMM_1   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | OPCODE_EXT | IMM8_ONLY),             NO_VEX, NO_EVEX, 1, 1, { 0xd1, 0x00, 0x00 }, 8, 0, MOD_MEM_IMM, 0,     0,	 0,                   (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "ror",    2, { M64,      R8_CL   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | OPCODE_EXT | IMM8_ONLY),						  NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0x00, 0x00 }, 8, 0, MOD_MEM_IMM, 0,     0,  0,                   (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "ror",    2, { M64,      IMM8    }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | OPCODE_EXT | IMM8_ONLY),						  NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 8, 0, MOD_MEM_IMM, 0,     0,  0,                   (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//SAL r/m8, 1          D0 / 4                 M1 Valid Valid Multiply r / m8 by 2, once.
//SAL r/m8**, 1        REX + D0 / 4           M1 Valid N.E.Multiply r / m8 by 2, once.
//SAL r/m8, CL         D2 / 4                 MC Valid Valid Multiply r / m8 by 2, CL times.
//SAL r/m8**, CL       REX + D2 / 4           MC Valid N.E.Multiply r / m8 by 2, CL times.
//SAL r/m8, imm8       C0 / 4 ib              MI Valid Valid Multiply r / m8 by 2, imm8 times.
//SAL r/m8**, imm8     REX + C0 / 4 ib        MI Valid N.E.Multiply r / m8 by 2, imm8 times.
//SAL r/m16, 1         D1 / 4                 M1 Valid Valid Multiply r / m16 by 2, once.
//SAL r/m16, CL        D3 / 4                 MC Valid Valid Multiply r / m16 by 2, CL times.
//SAL r/m16, imm8      C1 / 4 ib              MI Valid Valid Multiply r / m16 by 2, imm8 times.
//SAL r/m32, 1         D1 / 4                 M1 Valid Valid Multiply r / m32 by 2, once.
//SAL r/m64, 1         REX.W + D1 / 4         M1 Valid N.E.Multiply r / m64 by 2, once.
//SAL r/m32, CL        D3 / 4                 MC Valid Valid Multiply r / m32 by 2, CL times.
//SAL r/m64, CL        REX.W + D3 / 4         MC Valid N.E.Multiply r / m64 by 2, CL times.
//SAL r/m32, imm8      C1 / 4 ib              MI Valid Valid Multiply r / m32 by 2, imm8 times.
//SAL r/m64, imm8      REX.W + C1 / 4 ib      MI Valid N.E.Multiply r / m64 by 2, imm8 times.
/* ----------------------------------------------------------------------------------------------- */
{ "sal",    2, { R8,       IMM_1   }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xe0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sal",    2, { R8H,      IMM_1   }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xe0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sal",    2, { R8U,      IMM_1   }, GP3, REX | (F_OPCODE2_REG),												                              NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xe0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sal",    2, { R8E,      IMM_1   }, GP3, (REX | REXB) | (F_OPCODE2_REG),												                    NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xe0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sal",    2, { R8,       R8      }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xe0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sal",    2, { R8H,      R8      }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xe0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sal",    2, { R8U,      R8      }, GP3, REX | (F_OPCODE2_REG),												                              NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xe0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sal",    2, { R8E,      R8      }, GP3, (REX | REXB) | (F_OPCODE2_REG),												                    NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xe0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sal",    2, { R8,       IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x04, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sal",    2, { R8H,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x04, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sal",    2, { R8U,      IMM8    }, GP3, REX | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                    NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x04, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sal",    2, { R8E,      IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x04, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sal",    2, { M8,       IMM_1   }, GP0, ALLOW_SEG | (F_OPCODE2_REG),                                               NO_VEX, NO_EVEX, 1, 1, { 0xd0, 0x20, 0x00 }, 1, 0, 0x00, 0, 0,	           ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,P_86,  0, NULL },
{ "sal",    2, { M8,       R8_CL   }, GP0, ALLOW_SEG | (F_OPCODE2_REG),									                              NO_VEX, NO_EVEX, 1, 1, { 0xd2, 0x20, 0x00 }, 1, 0, 0x00, 0, 0,	           ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,P_86,  0, NULL },
{ "sal",    2, { M8,       IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x04, 0x00 }, 1, 0, MOD_MEM_IMM, 0, 0,	     ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "sal",    2, { R16,      IMM_1   }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xe0, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sal",    2, { R16E,     IMM_1   }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xe0, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sal",    2, { R16,      R8      }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0xe0, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sal",    2, { R16E,     R8      }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0xe0, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sal",    2, { R16,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 2, 0, 0xe0,        0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sal",    2, { R16E,     IMM8    }, GP0, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 2, 0, 0xe0,        0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sal",    2, { R32,      IMM_1   }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xe0, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sal",    2, { R32E,     IMM_1   }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xe0, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sal",    2, { R32,      R8      }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xe0, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sal",    2, { R32E,     R8      }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xe0, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sal",    2, { R32,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),                           NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 4, 0, 0xe0,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sal",    2, { R32E,     IMM8    }, GP0, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),            NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 4, 0, 0xe0,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sal",    2, { R64,      IMM_1   }, GP3, (REX | REXW) | (F_OPCODE2_REG),                                            NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xe0, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sal",    2, { R64E,     IMM_1   }, GP3, (REX | REXW | REXB) | (F_OPCODE2_REG),                                     NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xe0, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sal",    2, { R64,      R8      }, GP3, (REX | REXW) | (F_OPCODE2_REG),                                            NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xe0, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sal",    2, { R64E,     R8      }, GP3, (REX | REXW | REXB) | (F_OPCODE2_REG),                                     NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xe0, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sal",    2, { R64,      IMM8    }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),            NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 8, 0, 0xe0,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sal",    2, { R64E,     IMM8    }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),     NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 8, 0, 0xe0,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sal",    2, { M16,      IMM_1   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),                            NO_VEX, NO_EVEX, 1, 1, { 0xd1, 0x04, 0x00 }, 2, 0, MOD_MEM_IMM, 0,     OP_SIZE_OVERRIDE,	0,    (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "sal",    2, { M16,      R8_CL   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0x04, 0x00 }, 2, 0, MOD_MEM_IMM, 0,     OP_SIZE_OVERRIDE,  0,    (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "sal",    2, { M16,      IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x04, 0x00 }, 2, 0, MOD_MEM_IMM, 0,     OP_SIZE_OVERRIDE, 	0,    (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "sal",    2, { M32,      IMM_1   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),                            NO_VEX, NO_EVEX, 1, 1, { 0xd1, 0x04, 0x00 }, 4, 0, MOD_MEM_IMM, 0,     0,	 ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "sal",    2, { M32,      R8_CL   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0x04, 0x00 }, 4, 0, MOD_MEM_IMM, 0,     0,  ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "sal",    2, { M32,      IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x04, 0x00 }, 4, 0, MOD_MEM_IMM, 0,     0,  ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "sal",    2, { M64,      IMM_1   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | OPCODE_EXT | IMM8_ONLY),             NO_VEX, NO_EVEX, 1, 1, { 0xd1, 0x04, 0x00 }, 8, 0, MOD_MEM_IMM, 0,     0,	 0,                   (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "sal",    2, { M64,      R8_CL   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | OPCODE_EXT | IMM8_ONLY),						  NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0x04, 0x00 }, 8, 0, MOD_MEM_IMM, 0,     0,  0,                   (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "sal",    2, { M64,      IMM8    }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | OPCODE_EXT | IMM8_ONLY),						  NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x04, 0x00 }, 8, 0, MOD_MEM_IMM, 0,     0,  0,                   (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//SAR r/m8, 1          D0 / 7                 M1 Valid Valid Signed divide * r / m8 by 2, once.
//SAR r/m8**, 1        REX + D0 / 7           M1 Valid N.E.Signed divide * r / m8 by 2, once.
//SAR r/m8, CL         D2 / 7                 MC Valid Valid Signed divide * r / m8 by 2, CL times.
//SAR r/m8**, CL       REX + D2 / 7           MC Valid N.E.Signed divide * r / m8 by 2, CL times.
//SAR r/m8, imm8       C0 / 7 ib              MI Valid Valid Signed divide * r / m8 by 2, imm8 time.
//SAR r/m8**, imm8     REX + C0 / 7 ib        MI Valid N.E.Signed divide * r / m8 by 2, imm8 times.
//SAR r/m16, 1         D1 / 7                 M1 Valid Valid Signed divide * r / m16 by 2, once.
//SAR r/m16, CL        D3 / 7                 MC Valid Valid Signed divide * r / m16 by 2, CL times.
//SAR r/m16, imm8      C1 / 7 ib              MI Valid Valid Signed divide * r / m16 by 2, imm8 times.
//SAR r/m32, 1         D1 / 7                 M1 Valid Valid Signed divide * r / m32 by 2, once.
//SAR r/m64, 1         REX.W + D1 / 7         M1 Valid N.E.Signed divide * r / m64 by 2, once.
//SAR r/m32, CL        D3 / 7                 MC Valid Valid Signed divide * r / m32 by 2, CL times.
//SAR r/m64, CL        REX.W + D3 / 7         MC Valid N.E.Signed divide * r / m64 by 2, CL times.
//SAR r/m32, imm8      C1 / 7 ib              MI Valid Valid Signed divide * r / m32 by 2, imm8 times.
//SAR r/m64, imm8      REX.W + C1 / 7 ib      MI Valid N.E.Signed divide * r / m64 by 2, imm8 times
/* ----------------------------------------------------------------------------------------------- */
{ "sar",    2, { R8,       IMM_1   }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xf8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sar",    2, { R8H,      IMM_1   }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xf8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sar",    2, { R8U,      IMM_1   }, GP3, REX | (F_OPCODE2_REG),												                              NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xf8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sar",    2, { R8E,      IMM_1   }, GP3, (REX | REXB) | (F_OPCODE2_REG),												                    NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xf8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sar",    2, { R8,       R8      }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xf8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sar",    2, { R8H,      R8      }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xf8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sar",    2, { R8U,      R8      }, GP3, REX | (F_OPCODE2_REG),												                              NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xf8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sar",    2, { R8E,      R8      }, GP3, (REX | REXB) | (F_OPCODE2_REG),												                    NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xf8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sar",    2, { R8,       IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x07, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sar",    2, { R8H,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x07, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sar",    2, { R8U,      IMM8    }, GP3, REX | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                    NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x07, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sar",    2, { R8E,      IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x07, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sar",    2, { M8,       IMM_1   }, GP0, ALLOW_SEG | (F_OPCODE2_REG),                                               NO_VEX, NO_EVEX, 1, 1, { 0xd0, 0x38, 0x00 }, 1, 0, 0x00, 0, 0,	           ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,P_86,  0, NULL },
{ "sar",    2, { M8,       R8_CL   }, GP0, ALLOW_SEG | (F_OPCODE2_REG),									                              NO_VEX, NO_EVEX, 1, 1, { 0xd2, 0x38, 0x00 }, 1, 0, 0x00, 0, 0,	           ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,P_86,  0, NULL },
{ "sar",    2, { M8,       IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x07, 0x00 }, 1, 0, MOD_MEM_IMM, 0, 0,	     ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "sar",    2, { R16,      IMM_1   }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xf8, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sar",    2, { R16E,     IMM_1   }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xf8, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sar",    2, { R16,      R8      }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0xf8, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sar",    2, { R16E,     R8      }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0xf8, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sar",    2, { R16,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 2, 0, 0xf8,        0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sar",    2, { R16E,     IMM8    }, GP0, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 2, 0, 0xf8,        0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sar",    2, { R32,      IMM_1   }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xf8, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sar",    2, { R32E,     IMM_1   }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xf8, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sar",    2, { R32,      R8      }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xf8, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sar",    2, { R32E,     R8      }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xf8, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "sar",    2, { R32,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),                           NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 4, 0, 0xf8,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sar",    2, { R32E,     IMM8    }, GP0, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),            NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 4, 0, 0xf8,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sar",    2, { R64,      IMM_1   }, GP3, (REX | REXW) | (F_OPCODE2_REG),                                            NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xf8, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sar",    2, { R64E,     IMM_1   }, GP3, (REX | REXW | REXB) | (F_OPCODE2_REG),                                     NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xf8, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sar",    2, { R64,      R8      }, GP3, (REX | REXW) | (F_OPCODE2_REG),                                            NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xf8, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sar",    2, { R64E,     R8      }, GP3, (REX | REXW | REXB) | (F_OPCODE2_REG),                                     NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xf8, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "sar",    2, { R64,      IMM8    }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),            NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 8, 0, 0xf8,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sar",    2, { R64E,     IMM8    }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),     NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 8, 0, 0xf8,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "sar",    2, { M16,      IMM_1   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),                            NO_VEX, NO_EVEX, 1, 1, { 0xd1, 0x07, 0x00 }, 2, 0, MOD_MEM_IMM, 0,     OP_SIZE_OVERRIDE,	0,    (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "sar",    2, { M16,      R8_CL   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0x07, 0x00 }, 2, 0, MOD_MEM_IMM, 0,     OP_SIZE_OVERRIDE,  0,    (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "sar",    2, { M16,      IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x07, 0x00 }, 2, 0, MOD_MEM_IMM, 0,     OP_SIZE_OVERRIDE, 	0,    (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "sar",    2, { M32,      IMM_1   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),                            NO_VEX, NO_EVEX, 1, 1, { 0xd1, 0x07, 0x00 }, 4, 0, MOD_MEM_IMM, 0,     0,	 ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "sar",    2, { M32,      R8_CL   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0x07, 0x00 }, 4, 0, MOD_MEM_IMM, 0,     0,  ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "sar",    2, { M32,      IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x07, 0x00 }, 4, 0, MOD_MEM_IMM, 0,     0,  ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "sar",    2, { M64,      IMM_1   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | OPCODE_EXT | IMM8_ONLY),             NO_VEX, NO_EVEX, 1, 1, { 0xd1, 0x07, 0x00 }, 8, 0, MOD_MEM_IMM, 0,     0,	 0,                   (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "sar",    2, { M64,      R8_CL   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | OPCODE_EXT | IMM8_ONLY),						  NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0x07, 0x00 }, 8, 0, MOD_MEM_IMM, 0,     0,  0,                   (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "sar",    2, { M64,      IMM8    }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | OPCODE_EXT | IMM8_ONLY),						  NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x07, 0x00 }, 8, 0, MOD_MEM_IMM, 0,     0,  0,                   (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//SHL r/m8, 1          D0 / 4                 M1 Valid Valid Multiply r / m8 by 2, once.
//SHL r/m8**, 1        REX + D0 / 4           M1 Valid N.E.Multiply r / m8 by 2, once.
//SHL r/m8, CL         D2 / 4                 MC Valid Valid Multiply r / m8 by 2, CL times.
//SHL r/m8**, CL       REX + D2 / 4           MC Valid N.E.Multiply r / m8 by 2, CL times.
//SHL r/m8, imm8       C0 / 4 ib              MI Valid Valid Multiply r / m8 by 2, imm8 times.
//SHL r/m8**, imm8     REX + C0 / 4 ib        MI Valid N.E.Multiply r / m8 by 2, imm8 times.
//SHL r/m16, 1         D1 / 4                 M1 Valid Valid Multiply r / m16 by 2, once.
//SHL r/m16, CL        D3 / 4                 MC Valid Valid Multiply r / m16 by 2, CL times.
//SHL r/m16, imm8      C1 / 4 ib              MI Valid Valid Multiply r / m16 by 2, imm8 times.
//SHL r/m32, 1         D1 / 4                 M1 Valid Valid Multiply r / m32 by 2, once.
//SHL r/m64,1          REX.W + D1 /4          M1 Valid N.E.Multiply r / m64 by 2, once.
//SHL r/m32, CL        D3 /4                  MC Valid Valid Multiply r / m32 by 2, CL times.
//SHL r/m64, CL        REX.W + D3 /4          MC Valid N.E.Multiply r / m64 by 2, CL times.
//SHL r/m32, imm8      C1 /4 ib               MI Valid Valid Multiply r / m32 by 2, imm8 times.
//SHL r/m64, imm8      REX.W + C1 /4 ib       MI Valid N.E.Multiply r / m64 by 2, imm8 times.
/* ----------------------------------------------------------------------------------------------- */
{ "shl",    2, { R8,       IMM_1   }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xe0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shl",    2, { R8H,      IMM_1   }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xe0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shl",    2, { R8U,      IMM_1   }, GP3, REX | (F_OPCODE2_REG),												                              NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xe0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shl",    2, { R8E,      IMM_1   }, GP3, (REX | REXB) | (F_OPCODE2_REG),												                    NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xe0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shl",    2, { R8,       R8      }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xe0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shl",    2, { R8H,      R8      }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xe0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shl",    2, { R8U,      R8      }, GP3, REX | (F_OPCODE2_REG),												                              NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xe0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shl",    2, { R8E,      R8      }, GP3, (REX | REXB) | (F_OPCODE2_REG),												                    NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xe0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shl",    2, { R8,       IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x04, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "shl",    2, { R8H,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x04, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "shl",    2, { R8U,      IMM8    }, GP3, REX | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                    NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x04, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "shl",    2, { R8E,      IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x04, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "shl",    2, { M8,       IMM_1   }, GP0, ALLOW_SEG | (F_OPCODE2_REG),                                               NO_VEX, NO_EVEX, 1, 1, { 0xd0, 0x20, 0x00 }, 1, 0, 0x00, 0, 0,	           ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,P_86,  0, NULL },
{ "shl",    2, { M8,       R8_CL   }, GP0, ALLOW_SEG | (F_OPCODE2_REG),									                              NO_VEX, NO_EVEX, 1, 1, { 0xd2, 0x20, 0x00 }, 1, 0, 0x00, 0, 0,	           ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,P_86,  0, NULL },
{ "shl",    2, { M8,       IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x04, 0x00 }, 1, 0, MOD_MEM_IMM, 0, 0,	     ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "shl",    2, { R16,      IMM_1   }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xe0, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shl",    2, { R16E,     IMM_1   }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xe0, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shl",    2, { R16,      R8      }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0xe0, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shl",    2, { R16E,     R8      }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0xe0, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shl",    2, { R16,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 2, 0, 0xe0,        0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "shl",    2, { R16E,     IMM8    }, GP0, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 2, 0, 0xe0,        0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "shl",    2, { R32,      IMM_1   }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xe0, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shl",    2, { R32E,     IMM_1   }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xe0, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shl",    2, { R32,      R8      }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xe0, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shl",    2, { R32E,     R8      }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xe0, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shl",    2, { R32,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),                           NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 4, 0, 0xe0,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "shl",    2, { R32E,     IMM8    }, GP0, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),            NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 4, 0, 0xe0,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "shl",    2, { R64,      IMM_1   }, GP3, (REX | REXW) | (F_OPCODE2_REG),                                            NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xe0, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shl",    2, { R64E,     IMM_1   }, GP3, (REX | REXW | REXB) | (F_OPCODE2_REG),                                     NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xe0, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shl",    2, { R64,      R8      }, GP3, (REX | REXW) | (F_OPCODE2_REG),                                            NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xe0, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shl",    2, { R64E,     R8      }, GP3, (REX | REXW | REXB) | (F_OPCODE2_REG),                                     NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xe0, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shl",    2, { R64,      IMM8    }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),            NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 8, 0, 0xe0,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "shl",    2, { R64E,     IMM8    }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),     NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 8, 0, 0xe0,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "shl",    2, { M16,      IMM_1   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),                            NO_VEX, NO_EVEX, 1, 1, { 0xd1, 0x04, 0x00 }, 2, 0, MOD_MEM_IMM, 0,     OP_SIZE_OVERRIDE,	0,    (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "shl",    2, { M16,      R8_CL   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0x04, 0x00 }, 2, 0, MOD_MEM_IMM, 0,     OP_SIZE_OVERRIDE,  0,    (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "shl",    2, { M16,      IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x04, 0x00 }, 2, 0, MOD_MEM_IMM, 0,     OP_SIZE_OVERRIDE, 	0,    (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "shl",    2, { M32,      IMM_1   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),                            NO_VEX, NO_EVEX, 1, 1, { 0xd1, 0x04, 0x00 }, 4, 0, MOD_MEM_IMM, 0,     0,	 ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "shl",    2, { M32,      R8_CL   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0x04, 0x00 }, 4, 0, MOD_MEM_IMM, 0,     0,  ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "shl",    2, { M32,      IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x04, 0x00 }, 4, 0, MOD_MEM_IMM, 0,     0,  ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "shl",    2, { M64,      IMM_1   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | OPCODE_EXT | IMM8_ONLY),             NO_VEX, NO_EVEX, 1, 1, { 0xd1, 0x04, 0x00 }, 8, 0, MOD_MEM_IMM, 0,     0,	 0,                   (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "shl",    2, { M64,      R8_CL   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | OPCODE_EXT | IMM8_ONLY),						  NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0x04, 0x00 }, 8, 0, MOD_MEM_IMM, 0,     0,  0,                   (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "shl",    2, { M64,      IMM8    }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | OPCODE_EXT | IMM8_ONLY),						  NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x04, 0x00 }, 8, 0, MOD_MEM_IMM, 0,     0,  0,                   (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//SHR r/m8,1           D0 /5                  M1 Valid Valid Unsigned divide r / m8 by 2, once.
//SHR r/m8**, 1        REX + D0 /5            M1 Valid N.E.Unsigned divide r / m8 by 2, once.
//SHR r/m8, CL         D2 /5                  MC Valid Valid Unsigned divide r / m8 by 2, CL times.
//SHR r/m8**, CL       REX + D2 /5            MC Valid N.E.Unsigned divide r / m8 by 2, CL times.
//SHR r/m8, imm8       C0 /5 ib               MI Valid Valid Unsigned divide r / m8 by 2, imm8 times.
//SHR r/m8**, imm8     REX + C0 /5 ib         MI Valid N.E.Unsigned divide r / m8 by 2, imm8 times.
//SHR r/m16, 1         D1 /5                  M1 Valid Valid Unsigned divide r / m16 by 2, once.
//SHR r/m16, CL        D3 /5                  MC Valid Valid Unsigned divide r / m16 by 2, CL times
//SHR r/m16, imm8      C1 /5 ib               MI Valid Valid Unsigned divide r / m16 by 2, imm8 times.
//SHR r/m32, 1         D1 /5                  M1 Valid Valid Unsigned divide r / m32 by 2, once.
//SHR r/m64, 1         REX.W + D1 /5          M1 Valid N.E.Unsigned divide r / m64 by 2, once.
//SHR r/m32, CL        D3 /5                  MC Valid Valid Unsigned divide r / m32 by 2, CL times.
//SHR r/m64, CL        REX.W + D3 /5          MC Valid N.E.Unsigned divide r / m64 by 2, CL times.
//SHR r/m32, imm8      C1 /5 ib               MI Valid Valid Unsigned divide r / m32 by 2, imm8 times.
//SHR r/m64, imm8      REX.W + C1 /5 ib       MI Valid N.E.Unsigned divide r / m64 by 2, imm8 times.
/* ----------------------------------------------------------------------------------------------- */
{ "shr",    2, { R8,       IMM_1   }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xe8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shr",    2, { R8H,      IMM_1   }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xe8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shr",    2, { R8U,      IMM_1   }, GP3, REX | (F_OPCODE2_REG),												                              NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xe8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shr",    2, { R8E,      IMM_1   }, GP3, (REX | REXB) | (F_OPCODE2_REG),												                    NO_VEX, NO_EVEX, 1, 2, { 0xd0, 0xe8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shr",    2, { R8,       R8      }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xe8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shr",    2, { R8H,      R8      }, GP0, (F_OPCODE2_REG),												                                    NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xe8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shr",    2, { R8U,      R8      }, GP3, REX | (F_OPCODE2_REG),												                              NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xe8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shr",    2, { R8E,      R8      }, GP3, (REX | REXB) | (F_OPCODE2_REG),												                    NO_VEX, NO_EVEX, 1, 2, { 0xd2, 0xe8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                       (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shr",    2, { R8,       IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x05, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "shr",    2, { R8H,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x05, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "shr",    2, { R8U,      IMM8    }, GP3, REX | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                    NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x05, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "shr",    2, { R8E,      IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x05, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                       (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "shr",    2, { M8,       IMM_1   }, GP0, ALLOW_SEG | (F_OPCODE2_REG),                                               NO_VEX, NO_EVEX, 1, 1, { 0xd0, 0x28, 0x00 }, 1, 0, 0x00, 0, 0,	           ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,P_86,  0, NULL },
{ "shr",    2, { M8,       R8_CL   }, GP0, ALLOW_SEG | (F_OPCODE2_REG),									                              NO_VEX, NO_EVEX, 1, 1, { 0xd2, 0x28, 0x00 }, 1, 0, 0x00, 0, 0,	           ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,P_86,  0, NULL },
{ "shr",    2, { M8,       IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x05, 0x00 }, 1, 0, MOD_MEM_IMM, 0, 0,	     ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "shr",    2, { R16,      IMM_1   }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xe8, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shr",    2, { R16E,     IMM_1   }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xe8, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shr",    2, { R16,      R8      }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0xe8, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shr",    2, { R16E,     R8      }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0xe8, 0x00 }, 2, 0, NO_MOD,      0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shr",    2, { R16,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 2, 0, 0xe8,        0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "shr",    2, { R16E,     IMM8    }, GP0, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 2, 0, 0xe8,        0,    OP_SIZE_OVERRIDE, 0,      (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "shr",    2, { R32,      IMM_1   }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xe8, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shr",    2, { R32E,     IMM_1   }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xe8, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shr",    2, { R32,      R8      }, GP0, (F_OPCODE2_REG),									                                          NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xe8, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shr",    2, { R32E,     R8      }, GP0, (REX | REXB) | (F_OPCODE2_REG),									                          NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xe8, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                        (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shr",    2, { R32,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),                           NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 4, 0, 0xe8,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "shr",    2, { R32E,     IMM8    }, GP0, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),            NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 4, 0, 0xe8,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "shr",    2, { R64,      IMM_1   }, GP3, (REX | REXW) | (F_OPCODE2_REG),                                            NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xe8, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shr",    2, { R64E,     IMM_1   }, GP3, (REX | REXW | REXB) | (F_OPCODE2_REG),                                     NO_VEX, NO_EVEX, 1, 2, { 0xd1, 0xe8, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shr",    2, { R64,      R8      }, GP3, (REX | REXW) | (F_OPCODE2_REG),                                            NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xe8, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shr",    2, { R64E,     R8      }, GP3, (REX | REXW | REXB) | (F_OPCODE2_REG),                                     NO_VEX, NO_EVEX, 1, 2, { 0xd3, 0xe8, 0x00 }, 8, 0, NO_MOD,      0, 0, 0,                                    (X64), NO_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shr",    2, { R64,      IMM8    }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),            NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 8, 0, 0xe8,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "shr",    2, { R64E,     IMM8    }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),     NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 8, 0, 0xe8,        0, 0, 0,                        (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "shr",    2, { M16,      IMM_1   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),                            NO_VEX, NO_EVEX, 1, 1, { 0xd1, 0x05, 0x00 }, 2, 0, MOD_MEM_IMM, 0,     OP_SIZE_OVERRIDE,	0,    (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "shr",    2, { M16,      R8_CL   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0x05, 0x00 }, 2, 0, MOD_MEM_IMM, 0,     OP_SIZE_OVERRIDE,  0,    (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "shr",    2, { M16,      IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x05, 0x00 }, 2, 0, MOD_MEM_IMM, 0,     OP_SIZE_OVERRIDE, 	0,    (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "shr",    2, { M32,      IMM_1   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),                            NO_VEX, NO_EVEX, 1, 1, { 0xd1, 0x05, 0x00 }, 4, 0, MOD_MEM_IMM, 0,     0,	 ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "shr",    2, { M32,      R8_CL   }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0x05, 0x00 }, 4, 0, MOD_MEM_IMM, 0,     0,  ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "shr",    2, { M32,      IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x05, 0x00 }, 4, 0, MOD_MEM_IMM, 0,     0,  ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "shr",    2, { M64,      IMM_1   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | OPCODE_EXT | IMM8_ONLY),             NO_VEX, NO_EVEX, 1, 1, { 0xd1, 0x05, 0x00 }, 8, 0, MOD_MEM_IMM, 0,     0,	 0,                   (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "shr",    2, { M64,      R8_CL   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | OPCODE_EXT | IMM8_ONLY),						  NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0x05, 0x00 }, 8, 0, MOD_MEM_IMM, 0,     0,  0,                   (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,P_86,  0, NULL },
{ "shr",    2, { M64,      IMM8    }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | OPCODE_EXT | IMM8_ONLY),						  NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x05, 0x00 }, 8, 0, MOD_MEM_IMM, 0,     0,  0,                   (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//TEST AL, imm8 I Valid Valid      A8 ib
{ "test",    2, { R8_AL,    IMM8    }, GP0, (F_OPCODE_REG),												                                   NO_VEX, NO_EVEX, 1, 1, { 0xa8, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,				         0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
//TEST AX, imm16 I Valid Valid     A9 iw
//TEST EAX, imm32 I Valid Valid     A9 id
//TEST RAX, imm32 I Valid N.E.REX.W + A9 id
{ "test",    2, { R16_AX,   IMM16   }, GP0, (F_OPCODE_REG),												                                   NO_VEX, NO_EVEX, 1, 1, { 0xa9, 0x00, 0x00 }, 2, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "test",    2, { R32_EAX,  IMM32   }, GP0, (F_OPCODE_REG),												                                   NO_VEX, NO_EVEX, 1, 1, { 0xa9, 0x00, 0x00 }, 4, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "test",    2, { R64_RAX,  IMM32   }, GP3, (REX | REXW) | (F_OPCODE_REG),						                               NO_VEX, NO_EVEX, 1, 1, { 0xa9, 0x00, 0x00 }, 4, 0, NO_MOD,      0, 0,				         0,                              (X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
//TEST r / m8, imm8 MI Valid Valid     F6 / 0 ib
//TEST r / m8*, imm8 MI Valid N.E.REX + F6 / 0 ib
{ "test",    2, { R8,       IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),		                     NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,	               0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "test",    2, { R8H,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),	                       NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,	               0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "test",    2, { R8U,      IMM8    }, GP3, REX | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),									 NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,				         0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "test",    2, { R8E,      IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT | IMM8_ONLY),				   NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0,				         0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "test",    2, { M8,       IMM8    }, GP0, ALLOW_SEG | (F_MODRM | OPCODE_EXT | IMM8_ONLY),									         NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 1, 0, MOD_MEM_IMM, 0, 0,	               ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
//TEST r / m16, imm16 MI Valid Valid    F7 / 0 iw
//TEST r / m32, imm32 MI Valid Valid    F7 / 0 id
//TEST r / m64, imm32 MI Valid N.E.REX.W + F7 / 0 id
{ "test",    2, { R16,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                 NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "test",    2, { R16,      IMM16   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                 NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "test",    2, { R16E,     IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),								       NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "test",    2, { R16E,     IMM16   }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),								       NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 2, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "test",    2, { M16,      IMM16   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                 NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "test",    2, { R32,      IMM8    }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                 NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "test",    2, { R32,      IMM32   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                 NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "test",    2, { R32E,     IMM8    }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),								       NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "test",    2, { R32E,     IMM32   }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),								       NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "test",    2, { R32,      IMM16   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                 NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "test",    2, { R32E,     IMM16   }, GP3, (REX | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),								       NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "test",    2, { M32,      IMM32   }, GP0, (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                                 NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_86,  0, NULL },
{ "test",    2, { R64,      IMM32   }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),                      NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "test",    2, { R64,      IMM8    }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),                      NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "test",    2, { R64,      IMM16   }, GP3, (REX | REXW) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),                      NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "test",    2, { R64E,     IMM32   }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),               NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "test",    2, { R64E,     IMM16   }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),               NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "test",    2, { R64E,     IMM8    }, GP3, (REX | REXW | REXB) | (F_MODRM_RM | F_MODRM | OPCODE_EXT),               NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "test",    2, { M64,      IMM32   }, GP3, REXW | (F_MODRM_RM | F_MODRM | OPCODE_EXT),		                           NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, 0,	               0,                              (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0, P_64,  0, NULL },
//TEST r / m8, r8 MR Valid Valid       84 / r
//TEST r / m8*, r8* MR Valid N.E.REX + 84 / r
{ "test",    2, { R8,       R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),                               NO_VEX, NO_EVEX, 1, 1, { 0x84, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "test",    2, { R8,       R8H     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                            NO_VEX, NO_EVEX, 1, 1, { 0x84, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "test",    2, { R8H,      R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                            NO_VEX, NO_EVEX, 1, 1, { 0x84, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "test",    2, { R8H,      R8H     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                            NO_VEX, NO_EVEX, 1, 1, { 0x84, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "test",    2, { R8E,      R8E     }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		      NO_VEX, NO_EVEX, 1, 1, { 0x84, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "test",    2, { R8,       R8E     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0x84, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "test",    2, { R8E,      R8      }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0x84, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "test",    2, { R8U,      R8      }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					              NO_VEX, NO_EVEX, 1, 1, { 0x84, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "test",    2, { R8U,      R8E     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					      NO_VEX, NO_EVEX, 1, 1, { 0x84, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "test",    2, { R8,       R8U     }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					              NO_VEX, NO_EVEX, 1, 1, { 0x84, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },

{ "test",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                  NO_VEX, NO_EVEX, 1, 1, { 0x85, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "test",    2, { R16E,     R16E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		      NO_VEX, NO_EVEX, 1, 1, { 0x85, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "test",    2, { R16E,     R16     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0x85, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "test",    2, { R16,      R16E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0x85, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "test",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                  NO_VEX, NO_EVEX, 1, 1, { 0x85, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "test",    2, { R32E,     R32E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		      NO_VEX, NO_EVEX, 1, 1, { 0x85, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "test",    2, { R32E,     R32     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0x85, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "test",    2, { R32,      R32E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0x85, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "test",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		            NO_VEX, NO_EVEX, 1, 1, { 0x85, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "test",    2, { R64E,     R64E    }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),  NO_VEX, NO_EVEX, 1, 1, { 0x85, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "test",    2, { R64,      R64E    }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		      NO_VEX, NO_EVEX, 1, 1, { 0x85, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "test",    2, { R64E,     R64     }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		      NO_VEX, NO_EVEX, 1, 1, { 0x85, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },


{ "test",    2, { M_ANY,    R8      }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0x84, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "test",    2, { M_ANY,    R8H     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0x84, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "test",    2, { M_ANY,    R8E     }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                      NO_VEX, NO_EVEX, 1, 1, { 0x84, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "test",    2, { M_ANY,    R8U     }, GP3, ALLOW_SEG | (REX) | (F_MODRM | F_MODRM_REG),						                  NO_VEX, NO_EVEX, 1, 1, { 0x84, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
//TEST r / m16, r16 MR Valid Valid      85 / r
//TEST r / m32, r32 MR Valid Valid      85 / r
//TEST r / m64, r64 MR Valid N.E.REX.W + 85 / r
{ "test",     2, { M_ANY,    R16     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0x85, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "test",     2, { M_ANY,    R16E    }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x85, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "test",     2, { M_ANY,    R32     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0x85, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "test",     2, { M_ANY,    R32E    }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x85, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "test",     2, { M_ANY,    R64     }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),			                NO_VEX, NO_EVEX, 1, 1, { 0x85, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "test",     2, { M_ANY,    R64E    }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 1, 1, { 0x85, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//SHLD r / m16, r16, imm8 MRI Valid Valid   0F A4 / r ib          
//SHLD r / m16, r16, CL   MRC Valid Valid   0F A5 / r             
//SHLD r / m32, r32, imm8 MRI Valid Valid   0F A4 / r ib          
//SHLD r / m64, r64, imm8 MRI Valid N.E.    REX.W + 0F A4 / r ib  
//SHLD r / m32, r32, CL   MRC Valid Valid   0F A5 / r             
//SHLD r / m64, r64, CL   MRC Valid N.E.    REX.W + 0F A5 / r     
/* ----------------------------------------------------------------------------------------------- */
{ "shld",    3, { R16,      R16_AX, IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 2, 1, { 0xa4, 0x00, 0x00 }, 1, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "shld",    3, { R16_AX,   R16,    IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 2, 1, { 0xa4, 0x00, 0x00 }, 1, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "shld",    3, { R16_AX,   R16_AX, IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 2, 1, { 0xa4, 0x00, 0x00 }, 1, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "shld",    3, { R16,      R16,    IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 2, 1, { 0xa4, 0x00, 0x00 }, 1, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "shld",    3, { R16E,     R16E,   IMM8 }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),           NO_VEX, NO_EVEX, 2, 1, { 0xa4, 0x00, 0x00 }, 1, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                               (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "shld",    3, { R16E,     R16,    IMM8 }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),				          NO_VEX, NO_EVEX, 2, 1, { 0xa4, 0x00, 0x00 }, 1, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                               (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "shld",    3, { R16,      R16E,   IMM8 }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),				          NO_VEX, NO_EVEX, 2, 1, { 0xa4, 0x00, 0x00 }, 1, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                               (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "shld",    3, { R32,      R32,    IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 4, 1, { 0xa4, 0x00, 0x00 }, 1, 1, MOD_REG_IMM, 0, 0,                0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "shld",    3, { R32_EAX,  R32,    IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 4, 1, { 0xa4, 0x00, 0x00 }, 1, 1, MOD_REG_IMM, 0, 0,                0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "shld",    3, { R32_EAX,  R32_EAX,IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 4, 1, { 0xa4, 0x00, 0x00 }, 1, 1, MOD_REG_IMM, 0, 0,                0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "shld",    3, { R32,      R32_EAX,IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 4, 1, { 0xa4, 0x00, 0x00 }, 1, 1, MOD_REG_IMM, 0, 0,                0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "shld",    3, { R32E,     R32E,   IMM8 }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | IMM8_ONLY),	                      NO_VEX, NO_EVEX, 4, 1, { 0xa4, 0x00, 0x00 }, 1, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "shld",    3, { R32E,     R32,    IMM8 }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),				          NO_VEX, NO_EVEX, 4, 1, { 0xa4, 0x00, 0x00 }, 1, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "shld",    3, { R32,      R32E,   IMM8 }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),				          NO_VEX, NO_EVEX, 4, 1, { 0xa4, 0x00, 0x00 }, 1, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "shld",    3, { R64,      R64,    IMM8 }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		              NO_VEX, NO_EVEX, 1, 1, { 0xa4, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "shld",    3, { R64_RAX,  R64,    IMM8 }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		              NO_VEX, NO_EVEX, 1, 1, { 0xa4, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "shld",    3, { R64,      R64_RAX,IMM8 }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		              NO_VEX, NO_EVEX, 1, 1, { 0xa4, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "shld",    3, { R64_RAX,  R64_RAX,IMM8 }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		              NO_VEX, NO_EVEX, 1, 1, { 0xa4, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "shld",    3, { R64E,     R64E,   IMM8 }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | IMM8_ONLY),                 NO_VEX, NO_EVEX, 1, 1, { 0xa4, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "shld",    3, { R64,      R64E,   IMM8 }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		        NO_VEX, NO_EVEX, 1, 1, { 0xa4, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "shld",    3, { R64E,     R64,    IMM8 }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		        NO_VEX, NO_EVEX, 1, 1, { 0xa4, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "shld",    3, { M_ANY,    R16,    IMM8 }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG | OPCODE_EXT | IMM8_ONLY),				                          NO_VEX, NO_EVEX, 1, 1, { 0xa4, 0x00, 0x00 }, 2, 1, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_2,     MEM_OPND_0, P_86,  0, NULL },
{ "shld",    3, { M_ANY,    R16_AX, IMM8 }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG | OPCODE_EXT | IMM8_ONLY),				                          NO_VEX, NO_EVEX, 1, 1, { 0xa4, 0x00, 0x00 }, 2, 1, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_2,     MEM_OPND_0, P_86,  0, NULL },
{ "shld",    3, { M_ANY,    R16E,   IMM8 }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG | IMM8_ONLY),	                              NO_VEX, NO_EVEX, 1, 1, { 0xa4, 0x00, 0x00 }, 2, 1, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     MEM_OPND_0, P_64,  0, NULL },
{ "shld",    3, { M_ANY,    R32,    IMM8 }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG | OPCODE_EXT | IMM8_ONLY),				                          NO_VEX, NO_EVEX, 1, 1, { 0xa4, 0x00, 0x00 }, 4, 1, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_2,     MEM_OPND_0, P_86,  0, NULL },
{ "shld",    3, { M_ANY,    R32_EAX,IMM8 }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG | OPCODE_EXT | IMM8_ONLY),				                          NO_VEX, NO_EVEX, 1, 1, { 0xa4, 0x00, 0x00 }, 4, 1, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_2,     MEM_OPND_0, P_86,  0, NULL },
{ "shld",    3, { M_ANY,    R32E,   IMM8 }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG | OPCODE_EXT | IMM8_ONLY),	                  NO_VEX, NO_EVEX, 1, 1, { 0xa4, 0x00, 0x00 }, 4, 1, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     MEM_OPND_0, P_64,  0, NULL },
{ "shld",    3, { M_ANY,    R64,    IMM8 }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG | OPCODE_EXT | IMM8_ONLY),				            NO_VEX, NO_EVEX, 1, 1, { 0xa4, 0x00, 0x00 }, 8, 1, MOD_MEM_IMM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_2,     MEM_OPND_0, P_64,  0, NULL },
{ "shld",    3, { M_ANY,    R64_RAX,IMM8 }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG | OPCODE_EXT | IMM8_ONLY),				            NO_VEX, NO_EVEX, 1, 1, { 0xa4, 0x00, 0x00 }, 8, 1, MOD_MEM_IMM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_2,     MEM_OPND_0, P_64,  0, NULL },
{ "shld",    3, { M_ANY,    R64E,   IMM8 }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG | OPCODE_EXT | IMM8_ONLY),	          NO_VEX, NO_EVEX, 1, 1, { 0xa4, 0x00, 0x00 }, 8, 1, MOD_MEM_IMM, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     MEM_OPND_0, P_64,  0, NULL },
{ "shld",    3, { R16,      R16,    R8   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM ),							                                            NO_VEX, NO_EVEX, 1, 1, { 0xa5, 0x00, 0x00 }, 2, 1, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shld",    3, { R16,      R16_AX, R8   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM ),							                                            NO_VEX, NO_EVEX, 1, 1, { 0xa5, 0x00, 0x00 }, 2, 1, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shld",    3, { R16_AX,   R16,    R8   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM ),							                                            NO_VEX, NO_EVEX, 1, 1, { 0xa5, 0x00, 0x00 }, 2, 1, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shld",    3, { R16_AX,   R16_AX, R8   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM ),							                                            NO_VEX, NO_EVEX, 1, 1, { 0xa5, 0x00, 0x00 }, 2, 1, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shld",    3, { R16E,     R16E,   R8   }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                                    NO_VEX, NO_EVEX, 1, 1, { 0xa5, 0x00, 0x00 }, 2, 1, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shld",    3, { R16E,     R16,    R8   }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				                                    NO_VEX, NO_EVEX, 1, 1, { 0xa5, 0x00, 0x00 }, 2, 1, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shld",    3, { R16,      R16E,   R8   }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				                                    NO_VEX, NO_EVEX, 1, 1, { 0xa5, 0x00, 0x00 }, 2, 1, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shld",    3, { R32,      R32,    R8   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                                            NO_VEX, NO_EVEX, 1, 1, { 0xa5, 0x00, 0x00 }, 4, 1, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shld",    3, { R32_EAX,  R32,    R8   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                                            NO_VEX, NO_EVEX, 1, 1, { 0xa5, 0x00, 0x00 }, 4, 1, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shld",    3, { R32_EAX,  R32_EAX,R8   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                                            NO_VEX, NO_EVEX, 1, 1, { 0xa5, 0x00, 0x00 }, 4, 1, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shld",    3, { R32,      R32_EAX,R8   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                                            NO_VEX, NO_EVEX, 1, 1, { 0xa5, 0x00, 0x00 }, 4, 1, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shld",    3, { R32E,     R32E,   R8   }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                                  NO_VEX, NO_EVEX, 1, 1, { 0xa5, 0x00, 0x00 }, 4, 1, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shld",    3, { R32E,     R32,    R8   }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				                                    NO_VEX, NO_EVEX, 1, 1, { 0xa5, 0x00, 0x00 }, 4, 1, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shld",    3, { R32,      R32E,   R8   }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				                                    NO_VEX, NO_EVEX, 1, 1, { 0xa5, 0x00, 0x00 }, 4, 1, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shld",    3, { R64,      R64,    R8   }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                                        NO_VEX, NO_EVEX, 1, 1, { 0xa5, 0x00, 0x00 }, 8, 1, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shld",    3, { R64_RAX,  R64,    R8   }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                                        NO_VEX, NO_EVEX, 1, 1, { 0xa5, 0x00, 0x00 }, 8, 1, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shld",    3, { R64,      R64_RAX,R8   }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                                        NO_VEX, NO_EVEX, 1, 1, { 0xa5, 0x00, 0x00 }, 8, 1, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shld",    3, { R64_RAX,  R64_RAX,R8   }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                                        NO_VEX, NO_EVEX, 1, 1, { 0xa5, 0x00, 0x00 }, 8, 1, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shld",    3, { R64E,     R64E,   R8   }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                             NO_VEX, NO_EVEX, 1, 1, { 0xa5, 0x00, 0x00 }, 8, 1, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shld",    3, { R64,      R64E,   R8   }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                                NO_VEX, NO_EVEX, 1, 1, { 0xa5, 0x00, 0x00 }, 8, 1, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shld",    3, { R64E,     R64,    R8   }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                                NO_VEX, NO_EVEX, 1, 1, { 0xa5, 0x00, 0x00 }, 8, 1, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shld",    3, { M_ANY,    R16,    R8   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                                                    NO_VEX, NO_EVEX, 1, 1, { 0xa5, 0x00, 0x00 }, 2, 1, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     MEM_OPND_0, P_86,  0, NULL },
{ "shld",    3, { M_ANY,    R16_AX, R8   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                                                    NO_VEX, NO_EVEX, 1, 1, { 0xa5, 0x00, 0x00 }, 2, 1, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     MEM_OPND_0, P_86,  0, NULL },
{ "shld",    3, { M_ANY,    R16E,   R8   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                                          NO_VEX, NO_EVEX, 1, 1, { 0xa5, 0x00, 0x00 }, 2, 1, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  PFX_0xF, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "shld",    3, { M_ANY,    R32,    R8   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                                                    NO_VEX, NO_EVEX, 1, 1, { 0xa5, 0x00, 0x00 }, 4, 1, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     MEM_OPND_0, P_86,  0, NULL },
{ "shld",    3, { M_ANY,    R32_EAX,R8   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                                                    NO_VEX, NO_EVEX, 1, 1, { 0xa5, 0x00, 0x00 }, 4, 1, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     MEM_OPND_0, P_86,  0, NULL },
{ "shld",    3, { M_ANY,    R32E,   R8   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                                          NO_VEX, NO_EVEX, 1, 1, { 0xa5, 0x00, 0x00 }, 4, 1, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  PFX_0xF, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "shld",    3, { M_ANY,    R64,    R8   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				                                    NO_VEX, NO_EVEX, 1, 1, { 0xa5, 0x00, 0x00 }, 8, 1, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "shld",    3, { M_ANY,    R64_RAX,R8   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				                                    NO_VEX, NO_EVEX, 1, 1, { 0xa5, 0x00, 0x00 }, 8, 1, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "shld",    3, { M_ANY,    R64E,   R8   }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	                                    NO_VEX, NO_EVEX, 1, 1, { 0xa5, 0x00, 0x00 }, 8, 1, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  PFX_0xF, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//SHRD r / m16, r16, imm8 MRI Valid Valid   0F AC / r ib          
//SHRD r / m16, r16, CL   MRC Valid Valid   0F AD / r             
//SHRD r / m32, r32, imm8 MRI Valid Valid   0F AC / r ib          
//SHRD r / m64, r64, imm8 MRI Valid N.E.    REX.W + 0F AC / r ib  
//SHRD r / m32, r32, CL   MRC Valid Valid   0F AD / r             
//SHRD r / m64, r64, CL   MRC Valid N.E.    REX.W + 0F AD / r     
/* ----------------------------------------------------------------------------------------------- */
{ "shrd",    3, { R16,      R16_AX, IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 2, 1, { 0xac, 0x00, 0x00 }, 1, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "shrd",    3, { R16_AX,   R16,    IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 2, 1, { 0xac, 0x00, 0x00 }, 1, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "shrd",    3, { R16_AX,   R16_AX, IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 2, 1, { 0xac, 0x00, 0x00 }, 1, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "shrd",    3, { R16,      R16,    IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 2, 1, { 0xac, 0x00, 0x00 }, 1, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "shrd",    3, { R16E,     R16E,   IMM8 }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),           NO_VEX, NO_EVEX, 2, 1, { 0xac, 0x00, 0x00 }, 1, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                               (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "shrd",    3, { R16E,     R16,    IMM8 }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),				          NO_VEX, NO_EVEX, 2, 1, { 0xac, 0x00, 0x00 }, 1, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                               (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "shrd",    3, { R16,      R16E,   IMM8 }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),				          NO_VEX, NO_EVEX, 2, 1, { 0xac, 0x00, 0x00 }, 1, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                               (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "shrd",    3, { R32,      R32,    IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 4, 1, { 0xac, 0x00, 0x00 }, 1, 1, MOD_REG_IMM, 0, 0,                0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "shrd",    3, { R32_EAX,  R32,    IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 4, 1, { 0xac, 0x00, 0x00 }, 1, 1, MOD_REG_IMM, 0, 0,                0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "shrd",    3, { R32_EAX,  R32_EAX,IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 4, 1, { 0xac, 0x00, 0x00 }, 1, 1, MOD_REG_IMM, 0, 0,                0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "shrd",    3, { R32,      R32_EAX,IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 4, 1, { 0xac, 0x00, 0x00 }, 1, 1, MOD_REG_IMM, 0, 0,                0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "shrd",    3, { R32E,     R32E,   IMM8 }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | IMM8_ONLY),	                      NO_VEX, NO_EVEX, 4, 1, { 0xac, 0x00, 0x00 }, 1, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "shrd",    3, { R32E,     R32,    IMM8 }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),				          NO_VEX, NO_EVEX, 4, 1, { 0xac, 0x00, 0x00 }, 1, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "shrd",    3, { R32,      R32E,   IMM8 }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),				          NO_VEX, NO_EVEX, 4, 1, { 0xac, 0x00, 0x00 }, 1, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "shrd",    3, { R64,      R64,    IMM8 }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		              NO_VEX, NO_EVEX, 1, 1, { 0xac, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "shrd",    3, { R64_RAX,  R64,    IMM8 }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		              NO_VEX, NO_EVEX, 1, 1, { 0xac, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "shrd",    3, { R64,      R64_RAX,IMM8 }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		              NO_VEX, NO_EVEX, 1, 1, { 0xac, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "shrd",    3, { R64_RAX,  R64_RAX,IMM8 }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		              NO_VEX, NO_EVEX, 1, 1, { 0xac, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "shrd",    3, { R64E,     R64E,   IMM8 }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | IMM8_ONLY),                 NO_VEX, NO_EVEX, 1, 1, { 0xac, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "shrd",    3, { R64,      R64E,   IMM8 }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		        NO_VEX, NO_EVEX, 1, 1, { 0xac, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "shrd",    3, { R64E,     R64,    IMM8 }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		        NO_VEX, NO_EVEX, 1, 1, { 0xac, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "shrd",    3, { M_ANY,    R16,    IMM8 }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG | OPCODE_EXT | IMM8_ONLY),				                          NO_VEX, NO_EVEX, 1, 1, { 0xac, 0x00, 0x00 }, 2, 1, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_2,     MEM_OPND_0, P_86,  0, NULL },
{ "shrd",    3, { M_ANY,    R16_AX, IMM8 }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG | OPCODE_EXT | IMM8_ONLY),				                          NO_VEX, NO_EVEX, 1, 1, { 0xac, 0x00, 0x00 }, 2, 1, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_2,     MEM_OPND_0, P_86,  0, NULL },
{ "shrd",    3, { M_ANY,    R16E,   IMM8 }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG | IMM8_ONLY),	                              NO_VEX, NO_EVEX, 1, 1, { 0xac, 0x00, 0x00 }, 2, 1, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     MEM_OPND_0, P_64,  0, NULL },
{ "shrd",    3, { M_ANY,    R32,    IMM8 }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG | OPCODE_EXT | IMM8_ONLY),				                          NO_VEX, NO_EVEX, 1, 1, { 0xac, 0x00, 0x00 }, 4, 1, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_2,     MEM_OPND_0, P_86,  0, NULL },
{ "shrd",    3, { M_ANY,    R32_EAX,IMM8 }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG | OPCODE_EXT | IMM8_ONLY),				                          NO_VEX, NO_EVEX, 1, 1, { 0xac, 0x00, 0x00 }, 4, 1, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_2,     MEM_OPND_0, P_86,  0, NULL },
{ "shrd",    3, { M_ANY,    R32E,   IMM8 }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG | OPCODE_EXT | IMM8_ONLY),	                  NO_VEX, NO_EVEX, 1, 1, { 0xac, 0x00, 0x00 }, 4, 1, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     MEM_OPND_0, P_64,  0, NULL },
{ "shrd",    3, { M_ANY,    R64,    IMM8 }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG | OPCODE_EXT | IMM8_ONLY),				            NO_VEX, NO_EVEX, 1, 1, { 0xac, 0x00, 0x00 }, 8, 1, MOD_MEM_IMM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_2,     MEM_OPND_0, P_64,  0, NULL },
{ "shrd",    3, { M_ANY,    R64_RAX,IMM8 }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG | OPCODE_EXT | IMM8_ONLY),				            NO_VEX, NO_EVEX, 1, 1, { 0xac, 0x00, 0x00 }, 8, 1, MOD_MEM_IMM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, IMM_OPND_2,     MEM_OPND_0, P_64,  0, NULL },
{ "shrd",    3, { M_ANY,    R64E,   IMM8 }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG | OPCODE_EXT | IMM8_ONLY),	          NO_VEX, NO_EVEX, 1, 1, { 0xac, 0x00, 0x00 }, 8, 1, MOD_MEM_IMM, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  PFX_0xF, IMM_OPND_2,     MEM_OPND_0, P_64,  0, NULL },
{ "shrd",    3, { R16,      R16,    R8   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                                            NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 2, 1, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shrd",    3, { R16,      R16_AX, R8   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                                            NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 2, 1, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shrd",    3, { R16_AX,   R16,    R8   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                                            NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 2, 1, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shrd",    3, { R16_AX,   R16_AX, R8   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                                            NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 2, 1, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shrd",    3, { R16E,     R16E,   R8   }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                                    NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 2, 1, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shrd",    3, { R16E,     R16,    R8   }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				                                    NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 2, 1, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shrd",    3, { R16,      R16E,   R8   }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				                                    NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 2, 1, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shrd",    3, { R32,      R32,    R8   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                                            NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 4, 1, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shrd",    3, { R32_EAX,  R32,    R8   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                                            NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 4, 1, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shrd",    3, { R32_EAX,  R32_EAX,R8   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                                            NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 4, 1, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shrd",    3, { R32,      R32_EAX,R8   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                                            NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 4, 1, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "shrd",    3, { R32E,     R32E,   R8   }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                                  NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 4, 1, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shrd",    3, { R32E,     R32,    R8   }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				                                    NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 4, 1, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shrd",    3, { R32,      R32E,   R8   }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				                                    NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 4, 1, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shrd",    3, { R64,      R64,    R8   }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                                        NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 8, 1, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shrd",    3, { R64_RAX,  R64,    R8   }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                                        NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 8, 1, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shrd",    3, { R64,      R64_RAX,R8   }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                                        NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 8, 1, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shrd",    3, { R64_RAX,  R64_RAX,R8   }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                                        NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 8, 1, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shrd",    3, { R64E,     R64E,   R8   }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                             NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 8, 1, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shrd",    3, { R64,      R64E,   R8   }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                                NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 8, 1, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shrd",    3, { R64E,     R64,    R8   }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                                NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 8, 1, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "shrd",    3, { M_ANY,    R16,    R8   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                                                    NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 2, 1, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     MEM_OPND_0, P_86,  0, NULL },
{ "shrd",    3, { M_ANY,    R16_AX, R8   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                                                    NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 2, 1, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     MEM_OPND_0, P_86,  0, NULL },
{ "shrd",    3, { M_ANY,    R16E,   R8   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                                          NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 2, 1, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  PFX_0xF, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "shrd",    3, { M_ANY,    R32,    R8   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                                                    NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 4, 1, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     MEM_OPND_0, P_86,  0, NULL },
{ "shrd",    3, { M_ANY,    R32_EAX,R8   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                                                    NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 4, 1, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     MEM_OPND_0, P_86,  0, NULL },
{ "shrd",    3, { M_ANY,    R32E,   R8   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                                          NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 4, 1, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  PFX_0xF, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "shrd",    3, { M_ANY,    R64,    R8   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				                                    NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 8, 1, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "shrd",    3, { M_ANY,    R64_RAX,R8   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				                                    NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 8, 1, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "shrd",    3, { M_ANY,    R64E,   R8   }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	                                    NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 8, 1, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  PFX_0xF, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//SYSENTER ZO  0F 34   Valid Valid Fast call to privilege level 0 system procedures
//SYSEXIT 0F 35 ZO Valid Valid
//SYSEXIT REX.W + 0F 35 ZO Valid Valid
/* ----------------------------------------------------------------------------------------------- */
{ "sysenter",    0, { OP_N,     OP_N    }, GP2, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0x34, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, PFX_0xF, NO_IMM, NO_MEM, P_686, 0, NULL },
{ "sysexit",     0, { OP_N,     OP_N    }, GP4, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 1, { 0x35, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, PFX_0xF, NO_IMM, NO_MEM, P_686, 0, NULL },
{ "sysexit",     0, { OP_N,     OP_N    }, GP3, (REX | REXW),														NO_VEX, NO_EVEX, 1, 1, { 0x35, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, PFX_0xF, NO_IMM, NO_MEM, P_64, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//XADD r/m8,   r8   0F C0 /r             MR Valid Valid Exchange r8 and r/m8; load sum into r/m8.
//XADD r/m8*, r8*   REX + 0F C0 /r       MR Valid N.E.  Exchange r8 and r/m8; load sum into r/m8.
//XADD r/m16, r16   0F C1 /r             MR Valid Valid Exchange r16 and r/m16; load sum into r/m16.
//XADD r/m32, r32   0F C1 /r             MR Valid Valid Exchange r32 and r/m32; load sum into r/m32.
//XADD r/m64, r64   REX.W + 0F C1 /r     MR Valid N.E.  Exchange r64 and r/m64; load sum into r/m64.
/* ----------------------------------------------------------------------------------------------- */
{ "xadd",    2, { R8,       R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),                                   NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "xadd",    2, { R8,       R8H     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                                NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "xadd",    2, { R8H,      R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                                NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "xadd",    2, { R8H,      R8H     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                                NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "xadd",    2, { R8E,      R8E     }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xadd",    2, { R8,       R8E     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xadd",    2, { R8E,      R8      }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xadd",    2, { R8U,      R8      }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					                  NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xadd",    2, { R8U,      R8U     }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					                  NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xadd",    2, { R8U,      R8E     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xadd",    2, { R8E,      R8U     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					          NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xadd",    2, { R8,       R8U     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					                  NO_VEX, NO_EVEX, 1, 1, { 0xc0, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xadd",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                      NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "xadd",    2, { R16E,     R16E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xadd",    2, { R16E,     R16     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xadd",    2, { R16,      R16E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xadd",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                      NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "xadd",    2, { R32E,     R32E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xadd",    2, { R32E,     R32     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xadd",    2, { R32,      R32E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xadd",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xadd",    2, { R64E,     R64E    }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),      NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xadd",    2, { R64,      R64E    }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xadd",    2, { R64E,     R64     }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xadd",    2, { M_ANY,    R8      }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,   PFX_0xF, NO_IMM,     MEM_OPND_0, P_86,  0, NULL },
{ "xadd",    2, { M_ANY,    R8H     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,   PFX_0xF, NO_IMM,     MEM_OPND_0, P_86,  0, NULL },
{ "xadd",    2, { M_ANY,    R8E     }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), RM_DST,   PFX_0xF, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "xadd",    2, { M_ANY,    R8U     }, GP3, ALLOW_SEG | (REX) | (F_MODRM | F_MODRM_REG),						                NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), RM_DST,   PFX_0xF, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "xadd",    2, { M_ANY,    R16     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,   PFX_0xF, NO_IMM,     MEM_OPND_0, P_86,  0, NULL },
{ "xadd",    2, { M_ANY,    R16E    }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,   PFX_0xF, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "xadd",    2, { M_ANY,    R32     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,   PFX_0xF, NO_IMM,     MEM_OPND_0, P_86,  0, NULL },
{ "xadd",    2, { M_ANY,    R32E    }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,   PFX_0xF, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "xadd",    2, { M_ANY,    R64     }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),			                NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), RM_DST,   PFX_0xF, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "xadd",    2, { M_ANY,    R64E    }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	            NO_VEX, NO_EVEX, 1, 1, { 0xc1, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), RM_DST,   PFX_0xF, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//XCHG AX,  r16      90+rw             O  Valid Valid        Exchange r16 with AX.
//XCHG EAX, r32      90+rd             O  Valid Valid        Exchange r32 with EAX.
//XCHG RAX, r64      REX.W + 90+rd     O  Valid N.E.         Exchange r64 with RAX.
//XCHG r16, AX       90+rw             O  Valid Valid        Exchange AX with r16.
//XCHG r32, EAX      90+rd             O  Valid Valid        Exchange EAX with r32.
//XCHG r64, RAX      REX.W + 90+rd     O  Valid N.E.         Exchange RAX with r64.
//XCHG r/m8, r8      86 /r             MR Valid Valid        Exchange r8r/m8. (byte register) with byte from
//XCHG r/m8*, r8*    REX + 86 /r       MR Valid N.E.         Exchange r8r/m8. (byte register) with byte from
//XCHG r8, r/m8      86 /r             RM Valid Valid        Exchange byte from r/m8 with r8 (byte register).
//XCHG r8*, r/m8*    REX + 86 /r       RM Valid N.E.         Exchange byte from r/m8 with r8 (byte register).
//XCHG r/m16, r16    87 /r             MR Valid Valid        Exchange r16 with word from r/m16.
//XCHG r16, r/m16    87 /r             RM Valid Valid        Exchange word from r/m16 with r16.
//XCHG r/m32, r32    87 /r             MR Valid Valid        Exchange r32 with doubleword from r/m32.
//XCHG r/m64, r64    REX.W + 87 /r     MR Valid N.E.         Exchange r64 with quadword from r/m64.
//XCHG r32, r/m32    87 /r             RM Valid Valid        Exchange doubleword from r/m32 with r32.
//XCHG r64, r/m64    REX.W + 87 /r     RM Valid N.E.         Exchange quadword from r/m64 with r64.
/* ----------------------------------------------------------------------------------------------- */
{ "xchg",    2, { R16_AX,   R16     }, GP0, (F_OPCODE_REG2),												                                NO_VEX, NO_EVEX, 1, 1, { 0x90, 0x00, 0x00 }, 2, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_86,  0, NULL },
{ "xchg",    2, { R16_AX,   R16E    }, GP0, (REX | REXB) | (F_OPCODE_REG2),												                  NO_VEX, NO_EVEX, 1, 1, { 0x90, 0x00, 0x00 }, 2, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_86,  0, NULL },
{ "xchg",    2, { R32_EAX,  R32     }, GP0, (F_OPCODE_REG2),												                                NO_VEX, NO_EVEX, 1, 1, { 0x90, 0x00, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                                 (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_86,  0, NULL },
{ "xchg",    2, { R32_EAX,  R32E    }, GP0, (REX | REXB) | (F_OPCODE_REG2),												                  NO_VEX, NO_EVEX, 1, 1, { 0x90, 0x00, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                                 (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_86,  0, NULL },
{ "xchg",    2, { R64_RAX,  R64     }, GP3, (REX | REXW) | (F_OPCODE_REG2),						                              NO_VEX, NO_EVEX, 1, 1, { 0x90, 0x00, 0x00 }, 8, 0, NO_MOD,      0, 0,				        0,                               (X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_64,  0, NULL },
{ "xchg",    2, { R64_RAX,  R64E    }, GP3, (REX | REXW | REXB) | (F_OPCODE_REG2),						                      NO_VEX, NO_EVEX, 1, 1, { 0x90, 0x00, 0x00 }, 8, 0, NO_MOD,      0, 0,				        0,                               (X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_64,  0, NULL },
{ "xchg",    2, { R16,   R16_AX     }, GP0, (F_OPCODE_REG),												                                  NO_VEX, NO_EVEX, 1, 1, { 0x90, 0x00, 0x00 }, 2, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_86,  0, NULL },
{ "xchg",    2, { R16E,  R16_AX     }, GP0, (REX | REXB)|(F_OPCODE_REG),												                    NO_VEX, NO_EVEX, 1, 1, { 0x90, 0x00, 0x00 }, 2, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_86,  0, NULL },
{ "xchg",    2, { R32,   R32_EAX    }, GP0, (F_OPCODE_REG),												                                  NO_VEX, NO_EVEX, 1, 1, { 0x90, 0x00, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                                 (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_86,  0, NULL },
{ "xchg",    2, { R32E,  R32_EAX    }, GP0, (REX | REXB) | (F_OPCODE_REG),												                  NO_VEX, NO_EVEX, 1, 1, { 0x90, 0x00, 0x00 }, 4, 0, NO_MOD,      0, 0, 0,                                 (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_86,  0, NULL },
{ "xchg",    2, { R64,   R64_RAX    }, GP3, (REX | REXW) | (F_OPCODE_REG),						                              NO_VEX, NO_EVEX, 1, 1, { 0x90, 0x00, 0x00 }, 4, 0, NO_MOD,      0, 0,				        0,                               (X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_64,  0, NULL },
{ "xchg",    2, { R64E,  R64_RAX    }, GP3, (REX | REXW | REXB) | (F_OPCODE_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0x90, 0x00, 0x00 }, 4, 0, NO_MOD,      0, 0,				        0,                               (X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_64,  0, NULL },
{ "xchg",    2, { R8,       R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),                                   NO_VEX, NO_EVEX, 1, 1, { 0x86, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "xchg",    2, { R8,       R8H     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                                NO_VEX, NO_EVEX, 1, 1, { 0x86, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "xchg",    2, { R8H,      R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                                NO_VEX, NO_EVEX, 1, 1, { 0x86, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "xchg",    2, { R8H,      R8H     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                                NO_VEX, NO_EVEX, 1, 1, { 0x86, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "xchg",    2, { R8E,      R8E     }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x86, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xchg",    2, { R8,       R8E     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x86, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xchg",    2, { R8E,      R8      }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x86, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xchg",    2, { R8U,      R8      }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					                  NO_VEX, NO_EVEX, 1, 1, { 0x86, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xchg",    2, { R8U,      R8U     }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					                  NO_VEX, NO_EVEX, 1, 1, { 0x86, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xchg",    2, { R8U,      R8E     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					          NO_VEX, NO_EVEX, 1, 1, { 0x86, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xchg",    2, { R8E,      R8U     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					          NO_VEX, NO_EVEX, 1, 1, { 0x86, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xchg",    2, { R8,       R8U     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					          NO_VEX, NO_EVEX, 1, 1, { 0x86, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xchg",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                      NO_VEX, NO_EVEX, 1, 1, { 0x87, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "xchg",    2, { R16E,     R16E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                NO_VEX, NO_EVEX, 1, 1, { 0x87, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xchg",    2, { R16E,     R16     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x87, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xchg",    2, { R16,      R16E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x87, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xchg",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                      NO_VEX, NO_EVEX, 1, 1, { 0x87, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "xchg",    2, { R32E,     R32E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x87, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xchg",    2, { R32E,     R32     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x87, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xchg",    2, { R32,      R32E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				            NO_VEX, NO_EVEX, 1, 1, { 0x87, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xchg",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                NO_VEX, NO_EVEX, 1, 1, { 0x87, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xchg",    2, { R64E,     R64E    }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),      NO_VEX, NO_EVEX, 1, 1, { 0x87, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xchg",    2, { R64,      R64E    }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x87, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xchg",    2, { R64E,     R64     }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0x87, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "xchg",    2, { M_ANY,    R8      }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x86, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,   NO_PREFIX, NO_IMM,     MEM_OPND_0, P_86,  0, NULL },
{ "xchg",    2, { M_ANY,    R8H     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x86, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,   NO_PREFIX, NO_IMM,     MEM_OPND_0, P_86,  0, NULL },
{ "xchg",    2, { M_ANY,    R8E     }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x86, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), RM_DST,   NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "xchg",    2, { M_ANY,    R8U     }, GP3, ALLOW_SEG | (REX) | (F_MODRM | F_MODRM_REG),						                NO_VEX, NO_EVEX, 1, 1, { 0x86, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), RM_DST,   NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "xchg",    2, { M_ANY,    R16     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x87, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,   NO_PREFIX, NO_IMM,     MEM_OPND_0, P_86,  0, NULL },
{ "xchg",    2, { M_ANY,    R16E    }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x87, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,   NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "xchg",    2, { M_ANY,    R32     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x87, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,   NO_PREFIX, NO_IMM,     MEM_OPND_0, P_86,  0, NULL },
{ "xchg",    2, { M_ANY,    R32E    }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x87, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,   NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "xchg",    2, { M_ANY,    R64     }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),			                NO_VEX, NO_EVEX, 1, 1, { 0x87, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), RM_DST,   NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "xchg",    2, { M_ANY,    R64E    }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	            NO_VEX, NO_EVEX, 1, 1, { 0x87, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), RM_DST,   NO_PREFIX, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "xchg",    2, { R8,       M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x86, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "xchg",    2, { R8H,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x86, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "xchg",    2, { R8E,      M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x86, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "xchg",    2, { R8U,      M_ANY   }, GP3, ALLOW_SEG | (REX) | (F_MODRM | F_MODRM_REG),						                NO_VEX, NO_EVEX, 1, 1, { 0x86, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "xchg",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x87, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "xchg",    2, { R16E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x87, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "xchg",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                            NO_VEX, NO_EVEX, 1, 1, { 0x87, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "xchg",    2, { R32E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0x87, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "xchg",    2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				              NO_VEX, NO_EVEX, 1, 1, { 0x87, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				ADDR_SIZE_OVERRIDE,           (X16 | X32 | X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "xchg",    2, { R64E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	            NO_VEX, NO_EVEX, 1, 1, { 0x87, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				ADDR_SIZE_OVERRIDE,                       (X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//XLAT m8 ZO D7          Valid Valid Set AL to memory byte DS : [(E)BX + unsigned AL] .
//XLATB   ZO D7          Valid Valid Set AL to memory byte DS : [(E)BX + unsigned AL] .
//XLATB   ZO REX.W + D7  Valid N.E.  Set AL to memory byte[RBX + unsigned AL].
/* ----------------------------------------------------------------------------------------------- */
{ "xlat",    0, { OP_N,     OP_N    }, GP0, (NO_FLAGS),          NO_VEX, NO_EVEX, 1, 1, { 0xd7, 0x00, 0x00 }, 1, 1, NO_MOD, 0, 0, 0, (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "xlat",    1, { M_ANY,    OP_N    }, GP0, (NO_FLAGS),          NO_VEX, NO_EVEX, 1, 1, { 0xd7, 0x00, 0x00 }, 1, 1, NO_MOD, 0, 0, 0, (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "xlatb",   0, { OP_N,     OP_N    }, GP0, (NO_FLAGS),          NO_VEX, NO_EVEX, 1, 1, { 0xd7, 0x00, 0x00 }, 1, 1, NO_MOD, 0, 0, 0, (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "xlatb",   1, { M_ANY,    OP_N    }, GP0, (NO_FLAGS),          NO_VEX, NO_EVEX, 1, 1, { 0xd7, 0x00, 0x00 }, 1, 1, NO_MOD, 0, 0, 0, (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
  /* FPU no operand instructions */
{ "f2xm1",    0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xf0, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "fabs",     0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xe1, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "fchs",     0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xe0, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "fclex",    0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 3, { 0x9b, 0xdb, 0xe2 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "fnclex",   0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xdb, 0xe2, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "fcos",     0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xff, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "fdecstp",  0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xf6, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "fincstp",  0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xf7, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "finit",    0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 3, { 0x9b, 0xdb, 0xe3 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "fninit",   0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xdb, 0xe3, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "fld1",     0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xe8, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "fldl2t",   0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xe9, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "fldl2e",   0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xea, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "fldpi",    0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xeb, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "fldlg2",   0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xec, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "fldln2",   0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xed, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "fldz",     0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xee, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "fnop",     0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xd0, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "fpatan",   0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xf3, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "fprem",    0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xf8, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "fprem1",   0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xf5, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "fptan",    0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xf2, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "frndint",  0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xfc, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "fscale",   0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xfd, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "fsin",     0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xfe, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "fsincos",  0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xfb, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "fsqrt",    0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xfa, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "ftst",     0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xe4, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "fxam",     0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xe5, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "fxtract",  0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xf4, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "fyl2x",    0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xf1, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "fyl2xp1",  0, { OP_N,     OP_N    }, FP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xf9, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
//FCMOVB ST(0),  ST(i) DA C0 + i  Valid Valid Move if below(CF = 1).
//FCMOVE ST(0),  ST(i) DA C8 + i  Valid Valid Move if equal(ZF = 1).
//FCMOVBE ST(0), ST(i) DA D0 + i  Valid Valid Move if below or equal(CF = 1 or ZF = 1).
//FCMOVU ST(0),  ST(i) DA D8 + i  Valid Valid Move if unordered(PF = 1).
//FCMOVNB ST(0), ST(i) DB C0 + i  Valid Valid Move if not below(CF = 0).
//FCMOVNE ST(0), ST(i) DB C8 + i  Valid Valid Move if not equal(ZF = 0).
//FCMOVNBE ST(0),ST(i) DB D0 + i  Valid Valid Move if not below or equal(CF = 0 and ZF = 0).
//FCMOVNU ST(0), ST(i) DB D8 + i  Valid Valid Move if not unordered(PF = 0).
/* ----------------------------------------------------------------------------------------------- */
{ "fcmovb",   2, { R_ST,    R_STI    }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xda, 0xc0, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fcmovbe",  2, { R_ST,    R_STI    }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xda, 0xd0, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fcmove",   2, { R_ST,    R_STI    }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xda, 0xc8, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fcmovnb",  2, { R_ST,    R_STI    }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xdb, 0xc0, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fcmovnbe", 2, { R_ST,    R_STI    }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xdb, 0xd0, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fcmovne",  2, { R_ST,    R_STI    }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xdb, 0xc8, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fcmovnu",  2, { R_ST,    R_STI    }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xdb, 0xd8, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fcmovu",   2, { R_ST,    R_STI    }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xda, 0xd8, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
{ "fcom",     1, { R_STI,   OP_N     }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xd8, 0xd0, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fcom",     1, { M32,     OP_N     }, FP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                               NO_VEX, NO_EVEX, 1, 1, { 0xd8, 0x00, 0x00 }, 4, 1, 0x10,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fcom",     1, { M64,     OP_N     }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xdc, 0x00, 0x00 }, 8, 1, 0x10,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fcom",     0, { OP_N,    OP_N     }, FP0, (NO_FLAGS),														                           NO_VEX, NO_EVEX, 1, 2, { 0xd8, 0xd1, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
{ "fucom",    1, { R_STI,   OP_N     }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xdd, 0xe0, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fucom",    0, { OP_N,    OP_N     }, FP0, (NO_FLAGS),														                           NO_VEX, NO_EVEX, 1, 2, { 0xdd, 0xe1, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
{ "fucomp",   1, { R_STI,   OP_N     }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xdd, 0xe8, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fucomp",   0, { OP_N,    OP_N     }, FP0, (NO_FLAGS),														                           NO_VEX, NO_EVEX, 1, 2, { 0xdd, 0xe9, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
{ "fucompp",  0, { OP_N,    OP_N     }, FP0, (NO_FLAGS),														                           NO_VEX, NO_EVEX, 1, 2, { 0xda, 0xe9, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
{ "fcomi",    2, { R_ST,    R_STI    }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xdb, 0xf0, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fcomip",   2, { R_ST,    R_STI    }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xdf, 0xf0, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fucomi",   2, { R_ST,    R_STI    }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xdb, 0xe8, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fucomip",  2, { R_ST,    R_STI    }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xdf, 0xe0, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },

/* ----------------------------------------------------------------------------------------------- */
{ "fadd",   2, { R_ST,    R_STI    }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xd8, 0xc8, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL},
{ "fadd",   2, { R_STI,   R_ST     }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xdc, 0xc0, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fadd",   1, { M32,     OP_N     }, FP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                               NO_VEX, NO_EVEX, 1, 1, { 0xd8, 0x00, 0x00 }, 4, 1, 0x00,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fadd",   1, { M64,     OP_N     }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xdc, 0x00, 0x00 }, 8, 1, 0x00,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fadd",   0, { OP_N,    OP_N     }, FP0, (NO_FLAGS),														                           NO_VEX, NO_EVEX, 1, 2, { 0xd8, 0xc1, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "faddp",  2, { R_STI,   R_ST     }, FP0, (F_OPCODE2_STI),												                         NO_VEX, NO_EVEX, 1, 2, { 0xde, 0xc1, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,       P_87,  0, NULL },
{ "faddp",  0, { OP_N,    OP_N     }, FP0, (NO_FLAGS),														                           NO_VEX, NO_EVEX, 1, 2, { 0xd8, 0xc8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
{ "fmul",   2, { R_ST,    R_STI    }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xd8, 0xc8, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fmul",   2, { R_STI,   R_ST     }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xdc, 0xc8, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fmul",   1, { M32,     OP_N     }, FP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                               NO_VEX, NO_EVEX, 1, 1, { 0xd8, 0x00, 0x00 }, 4, 1, 0x08,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fmul",   1, { M64,     OP_N     }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xdc, 0x00, 0x00 }, 8, 1, 0x08,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fmul",   0, { OP_N,    OP_N     }, FP0, (NO_FLAGS),														                           NO_VEX, NO_EVEX, 1, 2, { 0xde, 0xc9, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fmulp",  2, { R_STI,   R_ST     }, FP0, (F_OPCODE2_STI),												                         NO_VEX, NO_EVEX, 1, 2, { 0xde, 0xc8, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,       P_87,  0, NULL },
{ "fmulp",  0, { OP_N,    OP_N     }, FP0, (NO_FLAGS),														                           NO_VEX, NO_EVEX, 1, 2, { 0xde, 0xc9, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
{ "fdiv",   2, { R_ST,    R_STI    }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xd8, 0xf0, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fdiv",   2, { R_STI,   R_ST     }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xdc, 0xf8, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fdiv",   1, { M32,     OP_N     }, FP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                               NO_VEX, NO_EVEX, 1, 1, { 0xd8, 0x00, 0x00 }, 4, 1, 0x30,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fdiv",   1, { M64,     OP_N     }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xdc, 0x00, 0x00 }, 8, 1, 0x30,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fdiv",   0, { OP_N,    OP_N     }, FP0, (NO_FLAGS),														                           NO_VEX, NO_EVEX, 1, 2, { 0xde, 0xf9, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fdivp",  2, { R_STI,   R_ST     }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xde, 0xf8, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fdivp",  0, { OP_N,    OP_N     }, FP0, (NO_FLAGS),														                           NO_VEX, NO_EVEX, 1, 2, { 0xde, 0xf9, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
{ "fdivr",  2, { R_ST,    R_STI    }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xd8, 0xf8, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fdivr",  2, { R_STI,   R_ST     }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xdc, 0xf0, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fdivr",  1, { M32,     OP_N     }, FP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                               NO_VEX, NO_EVEX, 1, 1, { 0xd8, 0x00, 0x00 }, 4, 1, 0x38,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fdivr",  1, { M64,     OP_N     }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xdc, 0x00, 0x00 }, 8, 1, 0x38,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fdivr",  0, { OP_N,    OP_N     }, FP0, (NO_FLAGS),														                           NO_VEX, NO_EVEX, 1, 2, { 0xde, 0xf1, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fdivrp", 2, { R_STI,   R_ST     }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xde, 0xf0, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fdivrp", 0, { OP_N,    OP_N     }, FP0, (NO_FLAGS),														                           NO_VEX, NO_EVEX, 1, 2, { 0xde, 0xf1, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
{ "fsub",   2, { R_ST,    R_STI    }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xd8, 0xe0, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fsub",   2, { R_STI,   R_ST     }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xdc, 0xe8, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fsub",   1, { M32,     OP_N     }, FP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                               NO_VEX, NO_EVEX, 1, 1, { 0xd8, 0x00, 0x00 }, 4, 1, 0x20,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fsub",   1, { M64,     OP_N     }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xdc, 0x00, 0x00 }, 8, 1, 0x20,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fsub",   0, { OP_N,    OP_N     }, FP0, (NO_FLAGS),														                           NO_VEX, NO_EVEX, 1, 2, { 0xde, 0xe9, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fsubp",  2, { R_STI,   R_ST     }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xde, 0xe8, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fsubp",  0, { OP_N,    OP_N     }, FP0, (NO_FLAGS),														                           NO_VEX, NO_EVEX, 1, 2, { 0xde, 0xe9, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
{ "fsubr",  2, { R_ST,    R_STI    }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xd8, 0xe8, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fsubr",  2, { R_STI,   R_ST     }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xdc, 0xe0, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fsubr",  1, { M32,     OP_N     }, FP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                               NO_VEX, NO_EVEX, 1, 1, { 0xd8, 0x00, 0x00 }, 4, 1, 0x28,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fsubr",  1, { M64,     OP_N     }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xdc, 0x00, 0x00 }, 8, 1, 0x28,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fsubr",  0, { OP_N,    OP_N     }, FP0, (NO_FLAGS),														                           NO_VEX, NO_EVEX, 1, 2, { 0xde, 0xe1, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fsubrp", 2, { R_STI,   R_ST     }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xde, 0xe0, 0x00 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fsubrp", 0, { OP_N,    OP_N     }, FP0, (NO_FLAGS),														                           NO_VEX, NO_EVEX, 1, 2, { 0xde, 0xe1, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
{ "fiadd",   1, { M32,     OP_N     }, FP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                               NO_VEX, NO_EVEX, 1, 1, { 0xda, 0x00, 0x00 }, 4, 1, 0x00,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fiadd",   1, { M16,     OP_N     }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xde, 0x00, 0x00 }, 8, 1, 0x00,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "ficom",   1, { M32,     OP_N     }, FP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                               NO_VEX, NO_EVEX, 1, 1, { 0xda, 0x00, 0x00 }, 4, 1, 0x10,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "ficom",   1, { M16,     OP_N     }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xde, 0x00, 0x00 }, 8, 1, 0x10,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "ficomp",  1, { M32,     OP_N     }, FP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                               NO_VEX, NO_EVEX, 1, 1, { 0xda, 0x00, 0x00 }, 4, 1, 0x18,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "ficomp",  1, { M16,     OP_N     }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xde, 0x00, 0x00 }, 8, 1, 0x18,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fidiv",   1, { M32,     OP_N     }, FP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                               NO_VEX, NO_EVEX, 1, 1, { 0xda, 0x00, 0x00 }, 4, 1, 0x30,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fidiv",   1, { M16,     OP_N     }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xde, 0x00, 0x00 }, 8, 1, 0x30,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fidivr",  1, { M32,     OP_N     }, FP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                               NO_VEX, NO_EVEX, 1, 1, { 0xda, 0x00, 0x00 }, 4, 1, 0x38,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fidivr",  1, { M16,     OP_N     }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xde, 0x00, 0x00 }, 8, 1, 0x38,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fimul",   1, { M32,     OP_N     }, FP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                               NO_VEX, NO_EVEX, 1, 1, { 0xda, 0x00, 0x00 }, 4, 1, 0x08,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fimul",   1, { M16,     OP_N     }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xde, 0x00, 0x00 }, 8, 1, 0x08,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fisub",   1, { M32,     OP_N     }, FP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                               NO_VEX, NO_EVEX, 1, 1, { 0xda, 0x00, 0x00 }, 4, 1, 0x20,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fisub",   1, { M16,     OP_N     }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xde, 0x00, 0x00 }, 8, 1, 0x20,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fisubr",  1, { M32,     OP_N     }, FP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                               NO_VEX, NO_EVEX, 1, 1, { 0xda, 0x00, 0x00 }, 4, 1, 0x28,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fisubr",  1, { M16,     OP_N     }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xde, 0x00, 0x00 }, 8, 1, 0x28,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
{ "fild",    1, { M32,     OP_N     }, FP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                               NO_VEX, NO_EVEX, 1, 1, { 0xdb, 0x00, 0x00 }, 4, 1, 0x00,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fild",    1, { M64,     OP_N     }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xdf, 0x00, 0x00 }, 8, 1, 0x28,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fild",    1, { M16,     OP_N     }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xdf, 0x00, 0x00 }, 8, 1, 0x00,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fistp",   1, { M32,     OP_N     }, FP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                               NO_VEX, NO_EVEX, 1, 1, { 0xdb, 0x00, 0x00 }, 4, 1, 0x18,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fistp",   1, { M64,     OP_N     }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xdf, 0x00, 0x00 }, 8, 1, 0x38,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fistp",   1, { M16,     OP_N     }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xdf, 0x00, 0x00 }, 8, 1, 0x18,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fist",    1, { M32,     OP_N     }, FP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                               NO_VEX, NO_EVEX, 1, 1, { 0xdb, 0x00, 0x00 }, 4, 1, 0x10,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fist",    1, { M16,     OP_N     }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xdf, 0x00, 0x00 }, 8, 1, 0x10,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
{ "fld",    1, { R_STI,   OP_N     }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xe0, 0xc0 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fld",    1, { M32,     OP_N     }, FP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                               NO_VEX, NO_EVEX, 1, 1, { 0xd9, 0x00, 0x00 }, 4, 1, 0x00,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fld",    1, { M64,     OP_N     }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xdd, 0x00, 0x00 }, 8, 1, 0x00,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fld",    1, { M80,     OP_N     }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xdb, 0x00, 0x00 }, 8, 1, 0x28,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fstp",   1, { R_STI,   OP_N     }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xdd, 0xe0, 0xd8 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fstp",   1, { M32,     OP_N     }, FP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                               NO_VEX, NO_EVEX, 1, 1, { 0xd9, 0x00, 0x00 }, 4, 1, 0x18,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fstp",   1, { M64,     OP_N     }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xdd, 0x00, 0x00 }, 8, 1, 0x18,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fstp",   1, { M80,     OP_N     }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xdb, 0x00, 0x00 }, 8, 1, 0x28,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fst",    1, { R_STI,   OP_N     }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xdd, 0xe0, 0xd0 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fst",    1, { M32,     OP_N     }, FP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                               NO_VEX, NO_EVEX, 1, 1, { 0xd9, 0x00, 0x00 }, 4, 1, 0x10,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fst",    1, { M64,     OP_N     }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xdd, 0x00, 0x00 }, 8, 1, 0x10,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
{ "fldenv",   1, {  M_ANY,   OP_N   }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xd9, 0x00, 0x00 }, 8, 1, 0x20,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,   0, NULL },
{ "fldenvd",  1, {  M_ANY,   OP_N   }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xd9, 0x00, 0x00 }, 8, 1, 0x20,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_387,  0, NULL },
{ "fldenvw",  1, {  M_ANY,   OP_N   }, FP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                               NO_VEX, NO_EVEX, 1, 1, { 0xd9, 0x00, 0x00 }, 4, 1, 0x20,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,   0, NULL },
{ "fnsave",   1, {  M_ANY,   OP_N   }, FP0, ALLOW_SEG | (NO_FWAIT) | (REX | REXW) | (F_MODRM | F_MODRM_RM),   NO_VEX, NO_EVEX, 1, 1, { 0xdd, 0x00, 0x00 }, 8, 1, 0x30,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,   0, NULL },
{ "fnsaved",  1, {  M_ANY,   OP_N   }, FP0, ALLOW_SEG | (NO_FWAIT) | (REX | REXW) | (F_MODRM | F_MODRM_RM),   NO_VEX, NO_EVEX, 1, 1, { 0xdd, 0x00, 0x00 }, 8, 1, 0x30,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_387,  0, NULL },
{ "fnsavew",  1, {  M_ANY,   OP_N   }, FP0, ALLOW_SEG | (NO_FWAIT) | (F_MODRM | F_MODRM_RM),                  NO_VEX, NO_EVEX, 1, 1, { 0xdd, 0x00, 0x00 }, 4, 1, 0x30,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,   0, NULL },
{ "fnstenv",  1, {  M_ANY,   OP_N   }, FP0, ALLOW_SEG | (NO_FWAIT) | (REX | REXW) | (F_MODRM | F_MODRM_RM),   NO_VEX, NO_EVEX, 1, 1, { 0xd9, 0x00, 0x00 }, 8, 1, 0x30,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,   0, NULL },
{ "fnstenvd", 1, {  M_ANY,   OP_N   }, FP0, ALLOW_SEG | (NO_FWAIT) | (REX | REXW) | (F_MODRM | F_MODRM_RM),   NO_VEX, NO_EVEX, 1, 1, { 0xd9, 0x00, 0x00 }, 8, 1, 0x30,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_387,  0, NULL },
{ "fnstenvw", 1, {  M_ANY,   OP_N   }, FP0, ALLOW_SEG | (NO_FWAIT) | (F_MODRM | F_MODRM_RM),                  NO_VEX, NO_EVEX, 1, 1, { 0xd9, 0x00, 0x00 }, 4, 1, 0x30,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,   0, NULL },
{ "frstor",   1, {  M_ANY,   OP_N   }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xdd, 0x00, 0x00 }, 8, 1, 0x20,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,   0, NULL },
{ "frstord",  1, {  M_ANY,   OP_N   }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xdd, 0x00, 0x00 }, 8, 1, 0x20,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_387,  0, NULL },
{ "frstorw",  1, {  M_ANY,   OP_N   }, FP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                               NO_VEX, NO_EVEX, 1, 1, { 0xdd, 0x00, 0x00 }, 4, 1, 0x20,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,   0, NULL },
{ "fsave",    1, {  M_ANY,   OP_N   }, FP0, ALLOW_SEG | (ALLOW_FWAIT) | (REX | REXW) | (F_MODRM | F_MODRM_RM),      NO_VEX, NO_EVEX, 1, 1, { 0xdd, 0x00, 0x00 }, 8, 1, 0x30,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,   0, NULL },
{ "fsaved",   1, {  M_ANY,   OP_N   }, FP0, ALLOW_SEG | (ALLOW_FWAIT) | (REX | REXW) | (F_MODRM | F_MODRM_RM),      NO_VEX, NO_EVEX, 1, 1, { 0xdd, 0x00, 0x00 }, 8, 1, 0x30,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_387,  0, NULL },
{ "fsavew",   1, {  M_ANY,   OP_N   }, FP0, ALLOW_SEG | (ALLOW_FWAIT) | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 1, { 0xdd, 0x00, 0x00 }, 4, 1, 0x30,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,   0, NULL },
{ "fstenv",   1, {  M_ANY,   OP_N   }, FP0, ALLOW_SEG | (ALLOW_FWAIT) | (REX | REXW) | (F_MODRM | F_MODRM_RM),      NO_VEX, NO_EVEX, 1, 1, { 0xd9, 0x00, 0x00 }, 8, 1, 0x30,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,   0, NULL },
{ "fstenvd",  1, {  M_ANY,   OP_N   }, FP0, ALLOW_SEG | (ALLOW_FWAIT) | (REX | REXW) | (F_MODRM | F_MODRM_RM),      NO_VEX, NO_EVEX, 1, 1, { 0xd9, 0x00, 0x00 }, 8, 1, 0x30,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_387,  0, NULL },
{ "fstenvw",  1, {  M_ANY,   OP_N   }, FP0, ALLOW_SEG | (ALLOW_FWAIT) | (F_MODRM | F_MODRM_RM),                     NO_VEX, NO_EVEX, 1, 1, { 0xd9, 0x00, 0x00 }, 4, 1, 0x30,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,   0, NULL },
/* ----------------------------------------------------------------------------------------------- */
{ "fldcw",   1, { M16,     OP_N     }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                          NO_VEX, NO_EVEX, 1, 1, { 0xd9, 0x00, 0x00 }, 8, 1, 0x28,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,   0, NULL },
{ "fnstcw",  1, { M16,     OP_N     }, FP0, ALLOW_SEG | (NO_FWAIT) | (REX | REXW) | (F_MODRM | F_MODRM_RM),             NO_VEX, NO_EVEX, 1, 1, { 0xd9, 0x00, 0x00 }, 8, 1, 0x38,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,   0, NULL },
{ "fnstsw",  1, { R16_AX,  OP_N     }, FP0, (NO_FWAIT) | (F_OPCODE2_REG),													                      NO_VEX, NO_EVEX, 1, 2, { 0xdf, 0xE0, 0x00 }, 2,  0, NO_MOD,     0, OP_SIZE_OVERRIDE, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM, P_287,  0, NULL },
{ "fnstsw",  1, { M16,     OP_N     }, FP0, ALLOW_SEG | (NO_FWAIT) | (REX | REXW) | (F_MODRM | F_MODRM_RM),             NO_VEX, NO_EVEX, 1, 1, { 0xdd, 0x00, 0x00 }, 8, 1, 0x38,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,   0, NULL },
{ "fstcw",   1, { M16,     OP_N     }, FP0, ALLOW_SEG | (ALLOW_FWAIT) | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xd9, 0x00, 0x00 }, 8, 1, 0x38,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,   0, NULL },
{ "fstsw",   1, { R16_AX,  OP_N     }, FP0, (ALLOW_FWAIT) | (F_OPCODE2_REG),													                        NO_VEX, NO_EVEX, 1, 2, { 0xdf, 0xE0, 0x00 }, 2,  0, NO_MOD,     0, OP_SIZE_OVERRIDE, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM, P_287,  0, NULL },
{ "fstsw",   1, { M16,     OP_N     }, FP0, ALLOW_SEG | (ALLOW_FWAIT) | (REX | REXW) | (F_MODRM | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0xdd, 0x00, 0x00 }, 8, 1, 0x38,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,   0, NULL },
/* ----------------------------------------------------------------------------------------------- */
{ "fbld",    1, { M80,     OP_N     }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                 NO_VEX, NO_EVEX, 1, 1, { 0xdf, 0x00, 0x00 }, 8, 1, 0x20,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "fbstp",   1, { M80,     OP_N     }, FP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM),                 NO_VEX, NO_EVEX, 1, 1, { 0xdf, 0x00, 0x00 }, 8, 1, 0x30,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
{ "ffree",   1, { R_STI,   OP_N     }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xdd, 0xc0, 0xd0 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "ffreep",  1, { R_STI,   OP_N     }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xdf, 0xc0, 0xd0 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fxch",    1, { R_STI,   OP_N     }, FP0, (F_OPCODE2_STI),												                           NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xc8, 0xd0 }, 2, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fxch",    0, { OP_N,    OP_N     }, FP0, (NO_FLAGS),                                                        NO_VEX, NO_EVEX, 1, 2, { 0xd9, 0xc9, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, NO_IMM, NO_MEM,     P_87,  0, NULL },
{ "fxrstor", 1, { M_ANY,   OP_N     }, FP0, ALLOW_SEG | (ALLOW_FWAIT) | (REX | REXW) | (F_MODRM | F_MODRM_RM), NO_VEX, NO_EVEX, 1, 1, { 0xae, 0x00, 0x00 }, 8, 1, 0x08,        0, 0, 0,                        (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_87,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* MMX/SSE related opcodes (except SSE instructions CMPSD and MOVSD) */
{ "emms",       0, { OP_N,    OP_N     }, GP0, (NO_FLAGS),                                                  NO_VEX, NO_EVEX, 1, 2, { 0x77, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF, NO_IMM, NO_MEM,     P_686 | P_MMX,  0, NULL },
{ "clflush",    1, { M_ANY,   OP_N     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                          NO_VEX, NO_EVEX, 1, 1, { 0xae, 0x00, 0x00 }, 8, 1, 0x38, 0, 0, ADDR_SIZE_OVERRIDE,              (X32 | X64), RM_DST,  PFX_0xF, NO_IMM, MEM_OPND_0, P_686 | P_SSE2, 0, NULL },
{ "clflushopt", 1, { M_ANY,            }, GP3, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                          NO_VEX, NO_EVEX, 1, 1, { 0xae, 0x00, 0x00 }, 8, 0, 0x38, 0, 0, ADDR_SIZE_OVERRIDE,              (X32 | X64), RM_DST, PFX_0x66F,NO_IMM, MEM_OPND_0, P_686 | P_SSE2, 0, NULL },
{ "ldmxcsr",    1, { M_ANY,   OP_N     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                          NO_VEX, NO_EVEX, 1, 1, { 0xae, 0x00, 0x00 }, 4, 1, 0x10, 0, 0, ADDR_SIZE_OVERRIDE,              (X32 | X64), RM_DST,  PFX_0xF, NO_IMM, MEM_OPND_0, P_686 | P_SSE2, 0, NULL },
{ "stmxcsr",    1, { M_ANY,   OP_N     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                          NO_VEX, NO_EVEX, 1, 1, { 0xae, 0x00, 0x00 }, 4, 1, 0x18, 0, 0, ADDR_SIZE_OVERRIDE,              (X32 | X64), RM_DST,  PFX_0xF, NO_IMM, MEM_OPND_0, P_686 | P_SSE2, 0, NULL },
{ "lfence",     0, { OP_N,    OP_N     }, GP0, (NO_FLAGS),                                                  NO_VEX, NO_EVEX, 1, 2, { 0xae, 0xe8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF, NO_IMM, NO_MEM,     P_686 | P_SSE2, 0, NULL },
{ "mfence",     0, { OP_N,    OP_N     }, GP0, (NO_FLAGS),                                                  NO_VEX, NO_EVEX, 1, 2, { 0xae, 0xf0, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF, NO_IMM, NO_MEM,     P_686 | P_SSE2, 0, NULL },
{ "sfence",     0, { OP_N,    OP_N     }, GP0, (NO_FLAGS),                                                  NO_VEX, NO_EVEX, 1, 2, { 0xae, 0xf8, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF, NO_IMM, NO_MEM,     P_686 | P_SSE1, 0, NULL },
{ "prefetchnta",1, { M_ANY,   OP_N     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                          NO_VEX, NO_EVEX, 1, 1, { 0x18, 0x00, 0x00 }, 8, 1, 0x00, 0, 0, ADDR_SIZE_OVERRIDE,              (X32 | X64), RM_DST,  PFX_0xF, NO_IMM, MEM_OPND_0, P_686 | P_SSE2, 0, NULL },
{ "prefetcht0", 1, { M_ANY,   OP_N     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                          NO_VEX, NO_EVEX, 1, 1, { 0x18, 0x00, 0x00 }, 8, 1, 0x08, 0, 0, ADDR_SIZE_OVERRIDE,              (X32 | X64), RM_DST,  PFX_0xF, NO_IMM, MEM_OPND_0, P_686 | P_SSE2, 0, NULL },
{ "prefetcht1", 1, { M_ANY,   OP_N     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                          NO_VEX, NO_EVEX, 1, 1, { 0x18, 0x00, 0x00 }, 8, 1, 0x10, 0, 0, ADDR_SIZE_OVERRIDE,              (X32 | X64), RM_DST,  PFX_0xF, NO_IMM, MEM_OPND_0, P_686 | P_SSE2, 0, NULL },
{ "prefetcht2", 1, { M_ANY,   OP_N     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM),                          NO_VEX, NO_EVEX, 1, 1, { 0x18, 0x00, 0x00 }, 8, 1, 0x18, 0, 0, ADDR_SIZE_OVERRIDE,              (X32 | X64), RM_DST,  PFX_0xF, NO_IMM, MEM_OPND_0, P_686 | P_SSE2, 0, NULL },
{ "pause",      0, { OP_N,    OP_N     }, GP0, (NO_FLAGS),                                                  NO_VEX, NO_EVEX, 1, 1, { 0x90, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  PFX_0xF3,NO_IMM, NO_MEM,     P_686 | P_MMX,  0, NULL },

//{ "clac",   0, { OP_N,     OP_N    }, GP0, (NO_FLAGS),														  NO_VEX, NO_EVEX, 1, 2, { 0x01, 0xca, 0x00 }, 1, 0, NO_MOD,      0, 0,                0,                  (X16 | X32 | X64), NO_DST, PFX_0xF, NO_IMM, NO_MEM, P_86, 0, NULL },
  //CLFLUSH m8 NP 0F AE / 7 
{ "clwb", 1,       { M_ANY,        }, GP3, ALLOW_SEG | REXW | (F_MODRM | F_MODRM_RM | OPCODE_EXT),            NO_VEX, NO_EVEX, 1, 1, { 0xae, 0x06, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0, ADDR_SIZE_OVERRIDE, (X32 | X64), RM_DST, PFX_0x66F, NO_IMM, MEM_OPND_0, P_686 | P_SSE2, 0, NULL },

/* General Purpose Reg->Reg moves (We use 8a/8b(masm) instead of 88/89(gcc) */
{ "mov",    2, { R8_CL,    R8_AL   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),                                        NO_VEX, NO_EVEX, 1, 1, { 0x8a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "mov",    2, { R8,       R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),                                        NO_VEX, NO_EVEX, 1, 1, { 0x8a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "mov",    2, { R8,       R8_AL   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),                                        NO_VEX, NO_EVEX, 1, 1, { 0x8a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "mov",    2, { R8,       R8_CL   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),                                        NO_VEX, NO_EVEX, 1, 1, { 0x8a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "mov",    2, { R8_CL,    R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),                                        NO_VEX, NO_EVEX, 1, 1, { 0x8a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "mov",    2, { R8_AL,    R8_CL   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),                                        NO_VEX, NO_EVEX, 1, 1, { 0x8a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "mov",    2, { R8,       R8H     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                          NO_VEX, NO_EVEX, 1, 1, { 0x8a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "mov",    2, { R8H,      R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                          NO_VEX, NO_EVEX, 1, 1, { 0x8a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "mov",    2, { R8H,      R8H     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                          NO_VEX, NO_EVEX, 1, 1, { 0x8a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "mov",    2, { R8E,      R8E     }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		    NO_VEX, NO_EVEX, 1, 1, { 0x8a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R8,       R8E     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0x8a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R8E,      R8      }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0x8a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R8U,      R8      }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					            NO_VEX, NO_EVEX, 1, 1, { 0x8a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R8U,      R8E     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					      NO_VEX, NO_EVEX, 1, 1, { 0x8a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R8,       R8U     }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					            NO_VEX, NO_EVEX, 1, 1, { 0x8a, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x8b, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "mov",    2, { R16E,     R16E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		    NO_VEX, NO_EVEX, 1, 1, { 0x8b, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R16E,     R16     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0x8b, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R16,      R16E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0x8b, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x8b, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "mov",    2, { R32E,     R32E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		    NO_VEX, NO_EVEX, 1, 1, { 0x8b, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R32E,     R32     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0x8b, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R32,      R32E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0x8b, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		            NO_VEX, NO_EVEX, 1, 1, { 0x8b, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R64E,     R64E    }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM), NO_VEX, NO_EVEX, 1, 1, { 0x8b, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R64,      R64E    }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		    NO_VEX, NO_EVEX, 1, 1, { 0x8b, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R64E,     R64     }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		    NO_VEX, NO_EVEX, 1, 1, { 0x8b, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
/* CR0-CR8 register moves */
{ "mov",    2, { R32,      R_CR    }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x20, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "mov",    2, { R64,      R_CR    }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x20, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R64E,     R_CR    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),			          NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x20, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R64,      R_CR8   }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x20, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R64E,     R_CR8   }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	      NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x20, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R_CR,     R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x22, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "mov",    2, { R_CR,     R64     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x22, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R_CR,     R64E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x22, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R_CR8,    R64     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x22, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R_CR8,    R64E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		    NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x22, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
/* DR0-DR7 register moves */
{ "mov",    2, { R32,      R_DR    }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x21, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "mov",    2, { R64,      R_DR    }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x21, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R64E,     R_DR    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),			          NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x21, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R_DR,     R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x23, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                  (X16 | X32), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "mov",    2, { R_DR,     R64     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x23, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R_DR,     R64E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	              NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x23, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                  (X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
/* Segment register to register moves */
{ "mov",    2, { R16,      R_SEG   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x8c, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "mov",    2, { R16,      R_SEGE  }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x8c, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_386, 0, NULL },
{ "mov",    2, { R32,      R_SEG   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x8c, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_386, 0, NULL },
{ "mov",    2, { R32,      R_SEGE  }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x8c, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_386, 0, NULL },
{ "mov",    2, { R64,      R_SEG   }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0x8c, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,				0,                  (X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R64,      R_SEGE  }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0x8c, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,				0,                  (X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R16E,     R_SEG   }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0x8c, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R16E,     R_SEGE  }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0x8c, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R32E,     R_SEG   }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0x8c, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R32E,     R_SEGE  }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0x8c, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R64E,     R_SEG   }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		    NO_VEX, NO_EVEX, 1, 1, { 0x8c, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,				0,                  (X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R64E,     R_SEGE  }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		    NO_VEX, NO_EVEX, 1, 1, { 0x8c, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,				0,                  (X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R_SEG,    R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x8e, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "mov",    2, { R_SEGE,   R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x8e, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_386, 0, NULL },
{ "mov",    2, { R_SEG,    R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x8e, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_386, 0, NULL },
{ "mov",    2, { R_SEGE,   R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0x8e, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_386, 0, NULL },
{ "mov",    2, { R_SEG,    R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0x8e, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,				0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R_SEGE,   R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0x8e, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,				0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R_SEG,    R16E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0x8e, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R_SEGE,   R16E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0x8e, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R_SEG,    R32E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0x8e, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,	   NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R_SEGE,   R32E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 1, { 0x8e, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R_SEG,    R64E    }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),        NO_VEX, NO_EVEX, 1, 1, { 0x8e, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,				0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R_SEGE,   R64E    }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),        NO_VEX, NO_EVEX, 1, 1, { 0x8e, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,				0,                  (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
/* Reg->Immediate moves */
{ "mov",    2, { R8,       IMM8    }, GP0, (F_OPCODE_REG),												                            NO_VEX, NO_EVEX, 1, 1, { 0xb0, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,				0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "mov",    2, { R8H,      IMM8    }, GP0, (F_OPCODE_REG),													                          NO_VEX, NO_EVEX, 1, 1, { 0xb0, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,				0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "mov",    2, { R8U,      IMM8    }, GP3, (REX) | (F_OPCODE_REG),											                      NO_VEX, NO_EVEX, 1, 1, { 0xb0, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,				0,                  (X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R8E,      IMM8    }, GP3, (REX | REXB) | (F_OPCODE_REG),							                        NO_VEX, NO_EVEX, 1, 1, { 0xb0, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,				0,                  (X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R16,      IMM8    }, GP0, (F_OPCODE_REG),												                            NO_VEX, NO_EVEX, 1, 1, { 0xb8, 0x00, 0x00 }, 2, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "mov",    2, { R16E,     IMM8    }, GP3, (REX | REXB) | (F_OPCODE_REG),								                      NO_VEX, NO_EVEX, 1, 1, { 0xb8, 0x00, 0x00 }, 2, 0, NO_MOD,      0, OP_SIZE_OVERRIDE,	0,                  (X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R16,      IMM16   }, GP0, (F_OPCODE_REG),												                            NO_VEX, NO_EVEX, 1, 1, { 0xb8, 0x00, 0x00 }, 2, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "mov",    2, { R16E,     IMM16   }, GP3, (REX | REXB) | (F_OPCODE_REG),								                      NO_VEX, NO_EVEX, 1, 1, { 0xb8, 0x00, 0x00 }, 2, 0, NO_MOD,      0, OP_SIZE_OVERRIDE,	0,                  (X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R32,      IMM8    }, GP0, (F_OPCODE_REG),												                            NO_VEX, NO_EVEX, 1, 1, { 0xb8, 0x00, 0x00 }, 4, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "mov",    2, { R32E,     IMM8    }, GP3, (REX | REXB) | (F_OPCODE_REG),								                      NO_VEX, NO_EVEX, 1, 1, { 0xb8, 0x00, 0x00 }, 4, 0, NO_MOD,      0, OP_SIZE_OVERRIDE,	0,                  (X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R32,      IMM16   }, GP0, (F_OPCODE_REG),												                            NO_VEX, NO_EVEX, 1, 1, { 0xb8, 0x00, 0x00 }, 4, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "mov",    2, { R32E,     IMM16   }, GP3, (REX | REXB) | (F_OPCODE_REG),								                      NO_VEX, NO_EVEX, 1, 1, { 0xb8, 0x00, 0x00 }, 4, 0, NO_MOD,      0, OP_SIZE_OVERRIDE,	0,                  (X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R32,      IMM32   }, GP0, (F_OPCODE_REG),												                            NO_VEX, NO_EVEX, 1, 1, { 0xb8, 0x00, 0x00 }, 4, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_86,  0, NULL },
{ "mov",    2, { R32E,     IMM32   }, GP3, (REX | REXB) | (F_OPCODE_REG),								                      NO_VEX, NO_EVEX, 1, 1, { 0xb8, 0x00, 0x00 }, 4, 0, NO_MOD,      0, OP_SIZE_OVERRIDE,	0,                  (X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R64,      IMM64   }, GP3, (REX | REXW) | (F_OPCODE_REG),								                      NO_VEX, NO_EVEX, 1, 1, { 0xb8, 0x00, 0x00 }, 8, 0, NO_MOD,      0, 0,				0,                  (X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R64E,     IMM64   }, GP3, (REX | REXW | REXB) | (F_OPCODE_REG),						                  NO_VEX, NO_EVEX, 1, 1, { 0xb8, 0x00, 0x00 }, 8, 0, NO_MOD,      0, 0,				0,                  (X64), NO_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,     P_64,  0, NULL },
{ "mov",    2, { R64,      IMM8    }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_RM),						                  NO_VEX, NO_EVEX, 1, 1, { 0xc7, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,				0,                  (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,	   P_64,  0, NULL },
{ "mov",    2, { R64E,     IMM8    }, GP3, (REX | REXW | REXB) | (F_MODRM | F_MODRM_RM),					            NO_VEX, NO_EVEX, 1, 1, { 0xc7, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,				0,                  (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,	   P_64,  0, NULL },
{ "mov",    2, { R64,      IMM16   }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0xc7, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,				0,                  (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,	   P_64,  0, NULL },
{ "mov",    2, { R64E,     IMM16   }, GP3, (REX | REXW | REXB) | (F_MODRM | F_MODRM_RM),					            NO_VEX, NO_EVEX, 1, 1, { 0xc7, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,				0,                  (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,	   P_64,  0, NULL },
{ "mov",    2, { R64,      IMM32   }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 1, { 0xc7, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,				0,                  (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,	   P_64,  0, NULL },
{ "mov",    2, { R64E,     IMM32   }, GP3, (REX | REXW | REXB) | (F_MODRM | F_MODRM_RM),					            NO_VEX, NO_EVEX, 1, 1, { 0xc7, 0x00, 0x00 }, 4, 0, MOD_REG_IMM, 0, 0,				0,                  (X64), RM_DST,  NO_PREFIX, IMM_OPND_1, NO_MEM,	   P_64,  0, NULL },
/* Mem->Reg moves */
{ "mov",    2, { R8,       M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0x8a, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,				ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "mov",    2, { R8H,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0x8a, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,				ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "mov",    2, { R8E,      M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 1, 1, { 0x8a, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,				ADDR_SIZE_OVERRIDE, (X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "mov",    2, { R8U,      M_ANY   }, GP3, ALLOW_SEG | (REX) | (F_MODRM | F_MODRM_REG),						            NO_VEX, NO_EVEX, 1, 1, { 0x8a, 0x00, 0x00 }, 1, 0, MOD_REG_MEM, 0, 0,				ADDR_SIZE_OVERRIDE, (X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "mov",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0x8b, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "mov",    2, { R16E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 1, 1, { 0x8b, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "mov",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0x8b, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "mov",    2, { R32E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 1, 1, { 0x8b, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "mov",    2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 1, { 0x8b, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "mov",    2, { R64E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	        NO_VEX, NO_EVEX, 1, 1, { 0x8b, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				ADDR_SIZE_OVERRIDE, (X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "mov",    2, { M_ANY,    R8      }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0x88, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "mov",    2, { M_ANY,    R8H     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0x88, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "mov",    2, { M_ANY,    R8E     }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 1, 1, { 0x88, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE, (X64), RM_DST,  NO_PREFIX,  NO_IMM,    MEM_OPND_0, P_64,  0, NULL },
{ "mov",    2, { M_ANY,    R8U     }, GP3, ALLOW_SEG | (REX) | (F_MODRM | F_MODRM_REG),						            NO_VEX, NO_EVEX, 1, 1, { 0x88, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE, (X64), RM_DST,  NO_PREFIX,  NO_IMM,    MEM_OPND_0, P_64,  0, NULL },
{ "mov",    2, { M_ANY,    R16     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0x89, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM    , MEM_OPND_0, P_86,  0, NULL },
{ "mov",    2, { M_ANY,    R16E    }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 1, 1, { 0x89, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X64), RM_DST,  NO_PREFIX, NO_IMM    , MEM_OPND_0, P_64,  0, NULL },
{ "mov",    2, { M_ANY,    R32     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0x89, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM    , MEM_OPND_0, P_86,  0, NULL },
{ "mov",    2, { M_ANY,    R32E    }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 1, 1, { 0x89, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X64), RM_DST,  NO_PREFIX, NO_IMM    , MEM_OPND_0, P_64,  0, NULL },
{ "mov",    2, { M_ANY,    R64     }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),			          NO_VEX, NO_EVEX, 1, 1, { 0x89, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE, (X64), RM_DST,  NO_PREFIX, NO_IMM    , MEM_OPND_0, P_64,  0, NULL },
{ "mov",    2, { M_ANY,    R64E    }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	        NO_VEX, NO_EVEX, 1, 1, { 0x89, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE, (X64), RM_DST,  NO_PREFIX, NO_IMM    , MEM_OPND_0, P_64,  0, NULL },
/* Moffset moves */
{ "mov",    2, { R8_AL,    M_ANY   }, GP0, (ALLOW_SEG | ALLOW_SEGX) | (DSPW) | NO_MEM_REG,				            NO_VEX, NO_EVEX, 1, 1, { 0xa0, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,				0,                  (X16 | X32 | X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_ABS_1, P_86,  0, NULL },
{ "mov",    2, { R8_AL,    M8      }, GP0, (ALLOW_SEG | ALLOW_SEGX) | (DSPW) | NO_MEM_REG,				            NO_VEX, NO_EVEX, 1, 1, { 0xa0, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,				0,                  (X16 | X32 | X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_ABS_1, P_86,  0, NULL },
{ "mov",    2, { M_ANY,    R8_AL   }, GP0, (ALLOW_SEG | ALLOW_SEGX) | (DSPW) | NO_MEM_REG,				            NO_VEX, NO_EVEX, 1, 1, { 0xa2, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,				0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM    , MEM_ABS_0, P_86,  0, NULL },
{ "mov",    2, { M8,       R8_AL   }, GP0, (ALLOW_SEG | ALLOW_SEGX) | (DSPW) | NO_MEM_REG,				            NO_VEX, NO_EVEX, 1, 1, { 0xa2, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,				0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM    , MEM_ABS_0, P_86,  0, NULL },
{ "mov",    2, { R16_AX,   M_ANY   }, GP0, (ALLOW_SEG | ALLOW_SEGX) | (DSPW) | NO_MEM_REG,				            NO_VEX, NO_EVEX, 1, 1, { 0xa1, 0x00, 0x00 }, 2, 0, NO_MOD,      0, OP_SIZE_OVERRIDE,	0,					(X16 | X32 | X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_ABS_1, P_86,  0, NULL },
{ "mov",    2, { M_ANY,    R16_AX  }, GP0, (ALLOW_SEG | ALLOW_SEGX) | (DSPW) | NO_MEM_REG,				            NO_VEX, NO_EVEX, 1, 1, { 0xa3, 0x00, 0x00 }, 2, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM    , MEM_ABS_0, P_86,  0, NULL },
{ "mov",    2, { R16_AX,   M16     }, GP0, (ALLOW_SEG | ALLOW_SEGX) | (DSPW) | NO_MEM_REG,				            NO_VEX, NO_EVEX, 1, 1, { 0xa1, 0x00, 0x00 }, 2, 0, NO_MOD,      0, OP_SIZE_OVERRIDE,	0,					(X16 | X32 | X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_ABS_1, P_86,  0, NULL },
{ "mov",    2, { M16,      R16_AX  }, GP0, (ALLOW_SEG | ALLOW_SEGX) | (DSPW) | NO_MEM_REG,				            NO_VEX, NO_EVEX, 1, 1, { 0xa3, 0x00, 0x00 }, 2, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM    , MEM_ABS_0, P_86,  0, NULL },
{ "mov",    2, { R32_EAX,  M_ANY   }, GP0, (ALLOW_SEG | ALLOW_SEGX) | (DSPW) | NO_MEM_REG,                    NO_VEX, NO_EVEX, 1, 1, { 0xa1, 0x00, 0x00 }, 4, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_ABS_1, P_86,  0, NULL },
{ "mov",    2, { M_ANY,    R32_EAX }, GP0, (ALLOW_SEG | ALLOW_SEGX) | (DSPW) | NO_MEM_REG,		                NO_VEX, NO_EVEX, 1, 1, { 0xa3, 0x00, 0x00 }, 4, 0, NO_MOD,      0, OP_SIZE_OVERRIDE,	0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM    , MEM_ABS_0, P_86,  0, NULL },
{ "mov",    2, { R32_EAX,  M32     }, GP0, (ALLOW_SEG | ALLOW_SEGX) | (DSPW) | NO_MEM_REG,                    NO_VEX, NO_EVEX, 1, 1, { 0xa1, 0x00, 0x00 }, 4, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_ABS_1, P_86,  0, NULL },
{ "mov",    2, { M32,      R32_EAX }, GP0, (ALLOW_SEG | ALLOW_SEGX) | (DSPW) | NO_MEM_REG,		                NO_VEX, NO_EVEX, 1, 1, { 0xa3, 0x00, 0x00 }, 4, 0, NO_MOD,      0, OP_SIZE_OVERRIDE,	0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM    , MEM_ABS_0, P_86,  0, NULL },
{ "mov",    2, { R64_RAX,  M_ANY   }, GP3, (ALLOW_SEG | ALLOW_SEGX) | (REX | REXW) | (DSPW) | NO_MEM_REG,     NO_VEX, NO_EVEX, 1, 1, { 0xa1, 0x00, 0x00 }, 8, 0, NO_MOD,      0, 0,				0,                  (X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_ABS_1, P_64,  0, NULL },
{ "mov",    2, { M_ANY,    R64_RAX }, GP3, (ALLOW_SEG | ALLOW_SEGX) | (REX | REXW) | (DSPW) | NO_MEM_REG,     NO_VEX, NO_EVEX, 1, 1, { 0xa3, 0x00, 0x00 }, 8, 0, NO_MOD,      0, 0,				0,                  (X64), RM_DST,  NO_PREFIX, NO_IMM    , MEM_ABS_0, P_64,  0, NULL },
{ "mov",    2, { R64_RAX,  M64     }, GP3, (ALLOW_SEG | ALLOW_SEGX) | (REX | REXW) | (DSPW) | NO_MEM_REG,     NO_VEX, NO_EVEX, 1, 1, { 0xa1, 0x00, 0x00 }, 8, 0, NO_MOD,      0, 0,				0,                  (X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_ABS_1, P_64,  0, NULL },
{ "mov",    2, { M64,      R64_RAX }, GP3, (ALLOW_SEG | ALLOW_SEGX) | (REX | REXW) | (DSPW) | NO_MEM_REG,     NO_VEX, NO_EVEX, 1, 1, { 0xa3, 0x00, 0x00 }, 8, 0, NO_MOD,      0, 0,				0,                  (X64), RM_DST,  NO_PREFIX, NO_IMM    , MEM_ABS_0, P_64,  0, NULL },
{ "movabs", 2, { R8_AL,    M_ANY   }, GP0, (ALLOW_SEG | ALLOW_SEGX) | (DSPW) | NO_MEM_REG,				            NO_VEX, NO_EVEX, 1, 1, { 0xa0, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,				0,                  (X16 | X32 | X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_ABS_1, P_86,  0, NULL },
{ "movabs", 2, { R8_AL,    M8      }, GP0, (ALLOW_SEG | ALLOW_SEGX) | (DSPW) | NO_MEM_REG,				            NO_VEX, NO_EVEX, 1, 1, { 0xa0, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,				0,                  (X16 | X32 | X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_ABS_1, P_86,  0, NULL },
{ "movabs", 2, { M_ANY,    R8_AL   }, GP0, (ALLOW_SEG | ALLOW_SEGX) | (DSPW) | NO_MEM_REG,				            NO_VEX, NO_EVEX, 1, 1, { 0xa2, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,				0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM    , MEM_ABS_0, P_86,  0, NULL },
{ "movabs", 2, { M8,       R8_AL   }, GP0, (ALLOW_SEG | ALLOW_SEGX) | (DSPW) | NO_MEM_REG,				            NO_VEX, NO_EVEX, 1, 1, { 0xa2, 0x00, 0x00 }, 1, 0, NO_MOD,      0, 0,				0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM    , MEM_ABS_0, P_86,  0, NULL },
{ "movabs", 2, { R16_AX,   M_ANY   }, GP0, (ALLOW_SEG | ALLOW_SEGX) | (DSPW) | NO_MEM_REG,				            NO_VEX, NO_EVEX, 1, 1, { 0xa1, 0x00, 0x00 }, 2, 0, NO_MOD,      0, OP_SIZE_OVERRIDE,	0,					(X16 | X32 | X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_ABS_1, P_86,  0, NULL },
{ "movabs", 2, { M_ANY,    R16_AX  }, GP0, (ALLOW_SEG | ALLOW_SEGX) | (DSPW) | NO_MEM_REG,				            NO_VEX, NO_EVEX, 1, 1, { 0xa3, 0x00, 0x00 }, 2, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM    , MEM_ABS_0, P_86,  0, NULL },
{ "movabs", 2, { R16_AX,   M16     }, GP0, (ALLOW_SEG | ALLOW_SEGX) | (DSPW) | NO_MEM_REG,				            NO_VEX, NO_EVEX, 1, 1, { 0xa1, 0x00, 0x00 }, 2, 0, NO_MOD,      0, OP_SIZE_OVERRIDE,	0,					(X16 | X32 | X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_ABS_1, P_86,  0, NULL },
{ "movabs", 2, { M16,      R16_AX  }, GP0, (ALLOW_SEG | ALLOW_SEGX) | (DSPW) | NO_MEM_REG,				            NO_VEX, NO_EVEX, 1, 1, { 0xa3, 0x00, 0x00 }, 2, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM    , MEM_ABS_0, P_86,  0, NULL },
{ "movabs", 2, { R32_EAX,  M_ANY   }, GP0, (ALLOW_SEG | ALLOW_SEGX) | (DSPW) | NO_MEM_REG,                    NO_VEX, NO_EVEX, 1, 1, { 0xa1, 0x00, 0x00 }, 4, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_ABS_1, P_86,  0, NULL },
{ "movabs", 2, { M_ANY,    R32_EAX }, GP0, (ALLOW_SEG | ALLOW_SEGX) | (DSPW) | NO_MEM_REG,		                NO_VEX, NO_EVEX, 1, 1, { 0xa3, 0x00, 0x00 }, 4, 0, NO_MOD,      0, OP_SIZE_OVERRIDE,	0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM    , MEM_ABS_0, P_86,  0, NULL },
{ "movabs", 2, { R32_EAX,  M32     }, GP0, (ALLOW_SEG | ALLOW_SEGX) | (DSPW) | NO_MEM_REG,                    NO_VEX, NO_EVEX, 1, 1, { 0xa1, 0x00, 0x00 }, 4, 0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_ABS_1, P_86,  0, NULL },
{ "movabs", 2, { M32,      R32_EAX }, GP0, (ALLOW_SEG | ALLOW_SEGX) | (DSPW) | NO_MEM_REG,		                NO_VEX, NO_EVEX, 1, 1, { 0xa3, 0x00, 0x00 }, 4, 0, NO_MOD,      0, OP_SIZE_OVERRIDE,	0,                  (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM    , MEM_ABS_0, P_86,  0, NULL },
{ "movabs", 2, { R64_RAX,  M_ANY   }, GP3, (ALLOW_SEG | ALLOW_SEGX) | (REX | REXW) | (DSPW) | NO_MEM_REG,     NO_VEX, NO_EVEX, 1, 1, { 0xa1, 0x00, 0x00 }, 8, 0, NO_MOD,      0, 0,				0,                  (X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_ABS_1, P_64,  0, NULL },
{ "movabs", 2, { M_ANY,    R64_RAX }, GP3, (ALLOW_SEG | ALLOW_SEGX) | (REX | REXW) | (DSPW) | NO_MEM_REG,     NO_VEX, NO_EVEX, 1, 1, { 0xa3, 0x00, 0x00 }, 8, 0, NO_MOD,      0, 0,				0,                  (X64), RM_DST,  NO_PREFIX, NO_IMM    , MEM_ABS_0, P_64,  0, NULL },
{ "movabs", 2, { R64_RAX,  M64     }, GP3, (ALLOW_SEG | ALLOW_SEGX) | (REX | REXW) | (DSPW) | NO_MEM_REG,     NO_VEX, NO_EVEX, 1, 1, { 0xa1, 0x00, 0x00 }, 8, 0, NO_MOD,      0, 0,				0,                  (X64), REG_DST, NO_PREFIX, NO_IMM    , MEM_ABS_1, P_64,  0, NULL },
{ "movabs", 2, { M64,      R64_RAX }, GP3, (ALLOW_SEG | ALLOW_SEGX) | (REX | REXW) | (DSPW) | NO_MEM_REG,     NO_VEX, NO_EVEX, 1, 1, { 0xa3, 0x00, 0x00 }, 8, 0, NO_MOD,      0, 0,				0,                  (X64), RM_DST,  NO_PREFIX, NO_IMM    , MEM_ABS_0, P_64,  0, NULL },
/* Mem->Immediate moves*/
//MOV r / m8, imm8     C6 / 0 ib          MI Valid Valid Move imm8 to r / m8.
//MOV r / m8***, imm8  REX + C6 / 0 ib    MI Valid N.E.Move imm8 to r / m8.
//MOV r / m16, imm16   C7 / 0 iw          MI Valid Valid Move imm16 to r / m16.
//MOV r / m32, imm32   C7 / 0 id          MI Valid Valid Move imm32 to r / m32.
//MOV r / m64, imm32   REX.W + C7 / 0 id  MI Valid N.E.Move imm32 sign extended to 64 - bits to r / m64.
{ "mov",    2, { M8,       IMM8    }, GP3, ALLOW_SEG | (F_MODRM),											          NO_VEX, NO_EVEX, 1, 1, { 0xc6, 0x00, 0x00 }, 1, 0, MOD_MEM_IMM, 0, 0,	            ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "mov",    2, { M16,      IMM8    }, GP3, ALLOW_SEG | (F_MODRM),											          NO_VEX, NO_EVEX, 1, 1, { 0xc7, 0x00, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "mov",    2, { M16,      IMM16   }, GP3, ALLOW_SEG | (F_MODRM),											          NO_VEX, NO_EVEX, 1, 1, { 0xc7, 0x00, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "mov",    2, { M32,      IMM8    }, GP3, ALLOW_SEG | (REXP_MEM) | (F_MODRM),								  NO_VEX, NO_EVEX, 1, 1, { 0xc7, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "mov",    2, { M32,      IMM16   }, GP3, ALLOW_SEG | (REXP_MEM) | (F_MODRM),								  NO_VEX, NO_EVEX, 1, 1, { 0xc7, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "mov",    2, { M32,      IMM32   }, GP3, ALLOW_SEG | (REXP_MEM) | (F_MODRM),								  NO_VEX, NO_EVEX, 1, 1, { 0xc7, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "mov",    2, { M64,      IMM8    }, GP3, ALLOW_SEG | (REXP_MEM) | (F_MODRM),								  NO_VEX, NO_EVEX, 1, 1, { 0xc7, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "mov",    2, { M64,      IMM16   }, GP3, ALLOW_SEG | (REXP_MEM) | (F_MODRM),								  NO_VEX, NO_EVEX, 1, 1, { 0xc7, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "mov",    2, { M64,      IMM32   }, GP3, ALLOW_SEG | (REXP_MEM) | (F_MODRM),								  NO_VEX, NO_EVEX, 1, 1, { 0xc7, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "mov",    2, { M_ANY,    IMM8    }, GP3, ALLOW_SEG | (REXP_MEM) | (F_MODRM),								  NO_VEX, NO_EVEX, 1, 1, { 0xc6, 0x00, 0x00 }, 1, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "mov",    2, { M_ANY,    IMM16   }, GP3, ALLOW_SEG | (REXP_MEM) | (F_MODRM),								  NO_VEX, NO_EVEX, 1, 1, { 0xc7, 0x00, 0x00 }, 2, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
{ "mov",    2, { M_ANY,    IMM32   }, GP3, ALLOW_SEG | (REXP_MEM) | (F_MODRM),								  NO_VEX, NO_EVEX, 1, 1, { 0xc7, 0x00, 0x00 }, 4, 0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, IMM_OPND_1, MEM_OPND_0,P_86,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//ENTER imm16, 0     C8 iw 00 
//ENTER imm16, 1     C8 iw 01 
//ENTER imm16, imm8  C8 iw ib 
/* ----------------------------------------------------------------------------------------------- */
{ "enter",    2, { IMM16,  IMM8    }, GP0, 0,		      NO_VEX, NO_EVEX, 1, 1, { 0xc8, 0x00, 0x00 }, 2, 0, NO_MOD, 0, 0, 0,                  (X16 | X32), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },

  //MOVAPD xmm1, xmm2 / m128 66 0F 28 / r
/* SSE */
{ "movaps",    2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0x28, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,    P_686 | P_SSE1, 0, NULL },
{ "movaps",    2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0x28, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,P_686 | P_SSE1, 0, NULL },
{ "movaps",    2, { M_ANY,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0x29, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0, 0, (X32 | X64), RM_DST,  PFX_0xF,    NO_IMM,     MEM_OPND_0,P_686 | P_SSE1, 0, NULL },
{ "movapd",    2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0x28, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "movapd",    2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0x28, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
{ "movapd",    2, { M_ANY,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0x29, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0, 0, (X32 | X64), RM_DST,  PFX_0x66F,  NO_IMM,     MEM_OPND_0,P_686 | P_SSE2, 0, NULL },
// MOVHPD xmm1, m64 66 0F 16 / r
// MOVHPD m64, xmm1 66 0F 17 / r
{ "movhpd",    2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 2, 1, { 0x16, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
{ "movhpd",    2, { M_ANY,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 2, 1, { 0x17, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0, 0, (X32 | X64), RM_DST,  PFX_0x66F,  NO_IMM,     MEM_OPND_0,P_686 | P_SSE2, 0, NULL },
//MOVHPS xmm1, m64 NP 0F 16 / r
//MOVHPS m64, xmm1 NP 0F 17 / r
{ "movhps",    2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 2, 1, { 0x16, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,P_686 | P_SSE1, 0, NULL },
{ "movhps",    2, { M_ANY,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 2, 1, { 0x17, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0, 0, (X32 | X64), RM_DST,  PFX_0xF,    NO_IMM,     MEM_OPND_0,P_686 | P_SSE1, 0, NULL },
//MOVLPD xmm1, m64    66 0F 12 / r
//MOVLPD m64, xmm1    66 0F 13 / r
{ "movlpd",    2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 2, 1, { 0x12, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
{ "movlpd",    2, { M_ANY,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 2, 1, { 0x13, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0, 0, (X32 | X64), RM_DST,  PFX_0x66F,  NO_IMM,     MEM_OPND_0,P_686 | P_SSE2, 0, NULL },
//MOVLPS xmm1, m64    NP 0F 12 / r
//MOVLPS m64, xmm1    0F 13 / r
{ "movlps",    2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 2, 1, { 0x12, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,P_686 | P_SSE1, 0, NULL },
{ "movlps",    2, { M_ANY,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 2, 1, { 0x13, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0, 0, (X32 | X64), RM_DST,  PFX_0xF,    NO_IMM,     MEM_OPND_0,P_686 | P_SSE1, 0, NULL },
//MOVHLPS xmm1, xmm2    NP 0F 12 / r
{ "movhlps",     2, { R_XMM,    R_XMM     }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0x12, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,    P_686 | P_SSE1, 0, NULL },
//MOVLHPS xmm1, xmm2    NP 0F 16 / r
{ "movlhps",     2, { R_XMM,    R_XMM     }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0x16, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,    P_686 | P_SSE1, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//MOVDQA xmm1, xmm2 / m128    66 0F 6F / r
//MOVDQA xmm2 / m128, xmm1    66 0F 7F / r
/* ----------------------------------------------------------------------------------------------- */
{ "movdqa", 2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX,  1, 1, { 0x6f, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F, NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "movdqa", 2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                            NO_VEX, NO_EVEX,  1, 1, { 0x6f, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F, NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
{ "movdqa", 2, { M_ANY,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),	                                      NO_VEX, NO_EVEX,  1, 1, { 0x7f, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), RM_DST,  PFX_0x66F, NO_IMM,     MEM_OPND_0,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//MOVDQU xmm1, xmm2 / m128    F3 0F 6F / r
//MOVDQU xmm2 / m128, xmm1    F3 0F 7F / r
/* ----------------------------------------------------------------------------------------------- */
{ "movdqu", 2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX,  1, 1, { 0x6f, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F, NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "movdqu", 2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                            NO_VEX, NO_EVEX,  1, 1, { 0x6f, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F, NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
{ "movdqu", 2, { M_ANY,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),	                                      NO_VEX, NO_EVEX,  1, 1, { 0x7f, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), RM_DST,  PFX_0xF30F, NO_IMM,     MEM_OPND_0,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//MOVDQ2Q mm, xmm F2 0F D6 / r
/* ----------------------------------------------------------------------------------------------- */
{ "movdq2q", 2, { MMX64,    R_XMM      }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX,  1, 1, { 0xd6, 0x00, 0x00 }, 8, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F, NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//MOVQ2DQ xmm, mm F3 0F D6 /r 
/* ----------------------------------------------------------------------------------------------- */
{ "movq2dq", 2, { R_XMM,   MMX64       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX,  1, 1, { 0xd6, 0x00, 0x00 }, 8, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F, NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//MOVMSKPD reg, xmm 66 0F 50 /r
/* ----------------------------------------------------------------------------------------------- */
{ "movmskpd",    2, { R32,    R_XMM       }, SSE0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),                                NO_VEX, NO_EVEX, 1, 1, { 0x50, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F, NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "movmskpd",    2, { R32E,   R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0x50, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F, NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "movmskpd",    2, { R64,    R_XMM       }, SSE0, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                 NO_VEX, NO_EVEX, 1, 1, { 0x50, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F, NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "movmskpd",    2, { R64E,   R_XMM       }, SSE0, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),          NO_VEX, NO_EVEX, 1, 1, { 0x50, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F, NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//MOVMSKPS reg, xmm    NP 0F 50 / r
/* ----------------------------------------------------------------------------------------------- */
{ "movmskps",    2, { R32,    R_XMM       }, SSE0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),                                NO_VEX, NO_EVEX, 1, 1, { 0x50, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF, NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "movmskps",    2, { R32E,   R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0x50, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF, NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "movmskps",    2, { R64,    R_XMM       }, SSE0, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                 NO_VEX, NO_EVEX, 1, 1, { 0x50, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF, NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "movmskps",    2, { R64E,   R_XMM       }, SSE0, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),          NO_VEX, NO_EVEX, 1, 1, { 0x50, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF, NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//MOVUPD xmm1, xmm2 / m128    66 0F 10 / r
//MOVUPD xmm2 / m128, xmm1    66 0F 11 / r
/* ----------------------------------------------------------------------------------------------- */
{ "movupd", 2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX,  1, 1, { 0x10, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F, NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "movupd", 2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                            NO_VEX, NO_EVEX,  1, 1, { 0x10, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F, NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
{ "movupd", 2, { M_ANY,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),	                                      NO_VEX, NO_EVEX,  1, 1, { 0x11, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), RM_DST,  PFX_0x66F, NO_IMM,     MEM_OPND_0,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//MOVUPS xmm1, xmm2 / m128    NP 0F 10 / r
//MOVUPS xmm2 / m128, xmm1    NP 0F 11 / r
/* ----------------------------------------------------------------------------------------------- */
{ "movups", 2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX,  1, 1, { 0x10, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "movups", 2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                            NO_VEX, NO_EVEX,  1, 1, { 0x10, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
{ "movups", 2, { M_ANY,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),	                                      NO_VEX, NO_EVEX,  1, 1, { 0x11, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), RM_DST,  PFX_0xF,    NO_IMM,     MEM_OPND_0,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//MASKMOVDQU xmm1, xmm2    66 0F F7 / r
/* ----------------------------------------------------------------------------------------------- */
{ "maskmovdqu", 2, { R_XMM,    R_XMM   }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX,  1, 1, { 0xf7, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F, NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//MASKMOVQ mm1, mm2 NP 0F F7 / r
/* ----------------------------------------------------------------------------------------------- */
{ "maskmovq", 2, { MMX64,    MMX64       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX,  1, 1, { 0xf7, 0x00, 0x00 }, 8, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//MOVNTDQ m128, xmm1    66 0F E7 / r
/* ----------------------------------------------------------------------------------------------- */
{ "movntdq", 2, { M_ANY,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),	                                    NO_VEX, NO_EVEX,  1, 1, { 0xe7, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), RM_DST,  PFX_0x66F, NO_IMM,     MEM_OPND_0, P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//MOVNTDQA xmm1, m128 66 0F 38 2A / r
/* ----------------------------------------------------------------------------------------------- */
{ "movntdqa", 2, { R_XMM,   M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),	                                    NO_VEX, NO_EVEX,  1, 1, { 0x2a, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0, 0, (X32 | X64), REG_DST,  PFX_0x66F38, NO_IMM,     MEM_OPND_1, P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//MOVNTI m32, r32  NP 0F C3 / r 
//MOVNTI m64, r64 NP REX.W + 0F C3 / r 
/* ----------------------------------------------------------------------------------------------- */
{ "movnti",    2, { M_ANY,    R32     }, GP0, (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0xc3, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, 0,	0, (X32 | X64),  RM_DST,  PFX_0xF, NO_IMM    , MEM_OPND_0, P_686 | P_SSE2,  0, NULL },
{ "movnti",    2, { M32,      R32_EAX }, GP0, (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0xc3, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, 0,	0, (X32 | X64),  RM_DST,  PFX_0xF, NO_IMM    , MEM_OPND_0, P_686 | P_SSE2,  0, NULL },
{ "movnti",    2, { M_ANY,    R32_EAX }, GP0, (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0xc3, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, 0,	0, (X32 | X64),  RM_DST,  PFX_0xF, NO_IMM    , MEM_OPND_0, P_686 | P_SSE2,  0, NULL },
{ "movnti",    2, { M_ANY,    R32E    }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG),	                      NO_VEX, NO_EVEX, 1, 1, { 0xc3, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, 0,	0, (X64),        RM_DST,  PFX_0xF, NO_IMM    , MEM_OPND_0, P_686 | P_SSE2,  0, NULL },
{ "movnti",    2, { M64,      R64_RAX }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG),			                  NO_VEX, NO_EVEX, 1, 1, { 0xc3, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,	0, (X64),        RM_DST,  PFX_0xF, NO_IMM    , MEM_OPND_0, P_686 | P_SSE2,  0, NULL },
{ "movnti",    2, { M_ANY,    R64_RAX }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG),			                  NO_VEX, NO_EVEX, 1, 1, { 0xc3, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,	0, (X64),        RM_DST,  PFX_0xF, NO_IMM    , MEM_OPND_0, P_686 | P_SSE2,  0, NULL },
{ "movnti",    2, { M_ANY,    R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG),			                  NO_VEX, NO_EVEX, 1, 1, { 0xc3, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,	0, (X64),        RM_DST,  PFX_0xF, NO_IMM    , MEM_OPND_0, P_686 | P_SSE2,  0, NULL },
{ "movnti",    2, { M_ANY,    R64E    }, GP3, (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 1, 1, { 0xc3, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,	0, (X64),        RM_DST,  PFX_0xF, NO_IMM    , MEM_OPND_0, P_686 | P_SSE2,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//MOVNTPD m128, xmm1 66 0F 2B / r
/* ----------------------------------------------------------------------------------------------- */
{ "movntpd", 2, { M_ANY,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),	                                    NO_VEX, NO_EVEX,  1, 1, { 0x2b, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), RM_DST,  PFX_0x66F, NO_IMM,     MEM_OPND_0, P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//MOVNTPS m128, xmm1 NP 0F 2B / r
{ "movntps", 2, { M_ANY,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),	                                    NO_VEX, NO_EVEX,  1, 1, { 0x2b, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), RM_DST,  PFX_0xF,   NO_IMM,     MEM_OPND_0, P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//MOVNTQ m64, mm NP 0F E7 / r
/* ----------------------------------------------------------------------------------------------- */
{ "movntq",    2, { M_ANY,    MMX64       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 2, 1, { 0xe7, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0, 0, (X32 | X64), RM_DST,  PFX_0xF,    NO_IMM,     MEM_OPND_0,P_686 | P_SSE1, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//INS m8,  DX 6C
//INS m16, DX 6D
//INS m32, DX 6D
/* ----------------------------------------------------------------------------------------------- */
{ "ins", 2, { M8,          R16_DX      }, GP0,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0x6c, 0x00, 0x00 }, 1,  2, NO_MOD,      0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_0,     P_386,           0, NULL },
{ "ins", 2, { M16,         R16_DX      }, GP2,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0x6d, 0x00, 0x00 }, 2,  2, NO_MOD,      0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_0,     P_386,           0, NULL },
{ "ins", 2, { M32,         R16_DX      }, GP2,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0x6d, 0x00, 0x00 }, 4,  2, NO_MOD,      0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_0,     P_386,           0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//INSB        6C
/* ----------------------------------------------------------------------------------------------- */
{ "insb", 0, { OP_N,     OP_N        }, GP1,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0x6c, 0x00, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "insb", 2, { M8,       R16_DX      }, GP2,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0x6c, 0x00, 0x00 }, 1,  2, NO_MOD,      0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_0,     P_386,           0, NULL },
{ "insb", 2, { M_ANY,    R16_DX      }, GP2,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0x6c, 0x00, 0x00 }, 1,  2, NO_MOD,      0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_0,     P_386,           0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//INSW        6D
/* ----------------------------------------------------------------------------------------------- */
{ "insw", 0, { OP_N,     OP_N        }, GP1,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0x6d, 0x00, 0x00 }, 2,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "insw", 2, { M16,      R16_DX      }, GP2,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0x6d, 0x00, 0x00 }, 2,  2, NO_MOD,      0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_0,     P_386,           0, NULL },
{ "insw", 2, { M_ANY,    R16_DX      }, GP2,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0x6d, 0x00, 0x00 }, 2,  2, NO_MOD,      0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_0,     P_386,           0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//INSD        6D
/* ----------------------------------------------------------------------------------------------- */
{ "insd", 0, { OP_N,     OP_N        }, GP1,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0x6d, 0x00, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "insd", 2, { M32,      R16_DX      }, GP2,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0x6d, 0x00, 0x00 }, 4,  2, NO_MOD,      0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_0,     P_386,           0, NULL },
{ "insd", 2, { M_ANY,    R16_DX      }, GP2,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0x6d, 0x00, 0x00 }, 4,  2, NO_MOD,      0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_0,     P_386,           0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//6E OUTS DX, m8
//6F OUTS DX, m16
//6F OUTS DX, m32
//6E OUTSB
//6F OUTSW
//6F OUTSD
/* ----------------------------------------------------------------------------------------------- */
{ "outs", 2, { R16_DX,       M8       }, GP0,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0x6e, 0x00, 0x00 }, 1,  2, NO_MOD,      0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_1,     P_386,           0, NULL },
{ "outs", 2, { R16_DX,       M16      }, GP2,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0x6f, 0x00, 0x00 }, 2,  2, NO_MOD,      0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_1,     P_386,           0, NULL },
{ "outs", 2, { R16_DX,       M32      }, GP2,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0x6f, 0x00, 0x00 }, 4,  2, NO_MOD,      0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_1,     P_386,           0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//INSB        6C
/* ----------------------------------------------------------------------------------------------- */
{ "outsb", 0, { OP_N,        OP_N     }, GP1,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0x6e, 0x00, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "outsb", 2, { R16_DX,      M8       }, GP2,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0x6e, 0x00, 0x00 }, 1,  2, NO_MOD,      0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_1,     P_386,           0, NULL },
{ "outsb", 2, { R16_DX,      M_ANY    }, GP2,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0x6e, 0x00, 0x00 }, 1,  2, NO_MOD,      0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_1,     P_386,           0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//INSW        6D
/* ----------------------------------------------------------------------------------------------- */
{ "outsw", 0, { OP_N,        OP_N     }, GP1,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0x6f, 0x00, 0x00 }, 2,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "outsw", 2, { R16_DX,      M16      }, GP2,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0x6f, 0x00, 0x00 }, 2,  2, NO_MOD,      0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_1,     P_386,           0, NULL },
{ "outsw", 2, { R16_DX,      M_ANY    }, GP2,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0x6f, 0x00, 0x00 }, 2,  2, NO_MOD,      0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_1,     P_386,           0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//OUT imm8, AL  I  Valid Valid    E6 ib
//OUT imm8, AX  I  Valid Valid    E7 ib
//OUT imm8, EAX I  Valid Valid    E7 ib
//OUT DX, AL    ZO Valid Valid    EE
//OUT DX, AX    ZO Valid Valid    EF
//OUT DX, EAX   ZO Valid Valid    EF
/* ----------------------------------------------------------------------------------------------- */
{ "out",    2, { IMM8,     R8_AL      }, GP0,  ALLOW_REP,												                                      NO_VEX, NO_EVEX,  1, 1, { 0xe6, 0x00, 0x00 }, 1,  2, NO_MOD,      0, 0, 0,                (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0,  NO_MEM,     P_86,  0, NULL },
{ "out",    2, { IMM8,     R16_AX     }, GP0,  ALLOW_REP,												                                      NO_VEX, NO_EVEX,  2, 1, { 0xe7, 0x00, 0x00 }, 1,  2, NO_MOD,      0, OP_SIZE_OVERRIDE, 0, (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0,  NO_MEM,     P_86,  0, NULL },
{ "out",    2, { IMM8,     R32_EAX    }, GP0,  ALLOW_REP,												                                      NO_VEX, NO_EVEX,  4, 1, { 0xe7, 0x00, 0x00 }, 1,  2, NO_MOD,      0, 0, 0,                (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0,  NO_MEM,     P_86,  0, NULL },
{ "out",    2, { R16_DX,   R8_AL      }, GP0,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0xee, 0x00, 0x00 }, 1,  2, NO_MOD,      0, 0, 0,                (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "out",    2, { R16_DX,   R16_AX     }, GP2,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  2, 1, { 0xef, 0x00, 0x00 }, 1,  2, NO_MOD,      0, OP_SIZE_OVERRIDE, 0, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "out",    2, { R16_DX,   R32_EAX    }, GP2,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  4, 1, { 0xef, 0x00, 0x00 }, 1,  2, NO_MOD,      0, 0, 0,                (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//OUTSD        6D
/* ----------------------------------------------------------------------------------------------- */
{ "outsd", 0, { OP_N,        OP_N     }, GP1,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0x6f, 0x00, 0x00 }, 1,  0, NO_MOD,      0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,         P_86,            0, NULL },
{ "outsd", 2, { R16_DX,      M32      }, GP2,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0x6f, 0x00, 0x00 }, 4,  2, NO_MOD,      0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_1,     P_386,           0, NULL },
{ "outsd", 2, { R16_DX,      M_ANY    }, GP2,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0x6f, 0x00, 0x00 }, 4,  2, NO_MOD,      0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_1,     P_386,           0, NULL },
/* ----------------------------------------------------------------------------------------------- */
// IN AL,   imm8  E4 ib
// IN AX,   imm8  E5 ib
// IN EAX,  imm8  E5 ib
/* ----------------------------------------------------------------------------------------------- */
{ "in",     2, { R8_AL,        IMM8    }, GP0,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0xe4, 0x00, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  IMM_OPND_1,     NO_MEM,     P_86,           0, NULL },
{ "in",     2, { R16_AX,       IMM8    }, GP0,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0xe5, 0x00, 0x00 }, 1,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  IMM_OPND_1,     NO_MEM,     P_86,           0, NULL },
{ "in",     2, { R32_EAX,      IMM8    }, GP0,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0xe5, 0x00, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  IMM_OPND_1,     NO_MEM,     P_86,           0, NULL },
/* ----------------------------------------------------------------------------------------------- */
// IN AL,   DX    EC
// IN AX,   DX    ED
// IN EAX,  DX    ED
/* ----------------------------------------------------------------------------------------------- */
{ "in",     2, { R8_AL,        R16_DX  }, GP0,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0xec, 0x00, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "in",     2, { R16_AX,       R16_DX  }, GP0,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0xed, 0x00, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "in",     2, { R32_EAX,      R16_DX  }, GP0,  ALLOW_REP,													                                    NO_VEX, NO_EVEX,  1, 1, { 0xed, 0x00, 0x00 }, 4,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
/* ----------------------------------------------------------------------------------------------- */
{ "int",     1, {  OP_N,   OP_N }, GP0,  (NO_FLAGS),													                                    NO_VEX, NO_EVEX,  1, 1, { 0xcc, 0x00, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "int",     1, {  IMM8,   OP_N }, GP0,  (NO_FLAGS),													                                    NO_VEX, NO_EVEX,  1, 1, { 0xcd, 0x00, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  IMM_OPND_0,     NO_MEM,     P_86,           0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//INVLPG, invlpg, OpCls(M_ANY, NONE, NONE), F_0F, 0, no_WDS, 0x01, 0x38, P_486, 0)
/* ----------------------------------------------------------------------------------------------- */
{ "invlpg", 1,  { M8,          }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),                    NO_VEX, NO_EVEX, 1, 1, { 0x1, 0x00, 0x00 }, 1, 1, 0x38, 0, 0, 0, (X32 | X64), RM_DST, PFX_0xF, NO_IMM, MEM_OPND_0, P_486, 0, NULL },
{ "invlpg", 1,  { M16,         }, GP2, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),                    NO_VEX, NO_EVEX, 2, 1, { 0x1, 0x00, 0x00 }, 1, 1, 0x38, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X32 | X64), RM_DST, PFX_0xF, NO_IMM, MEM_OPND_0, P_486, 0, NULL },
{ "invlpg", 1,  { M32,         }, GP2, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),                    NO_VEX, NO_EVEX, 4, 1, { 0x1, 0x00, 0x00 }, 1, 1, 0x38, 0, 0, ADDR_SIZE_OVERRIDE, (X32 | X64), RM_DST, PFX_0xF, NO_IMM, MEM_OPND_0, P_486, 0, NULL },
{ "invlpg", 1,  { M64,         }, GP3, ALLOW_SEG | (REX | REXW)| (F_MODRM | F_MODRM_RM | OPCODE_EXT),      NO_VEX, NO_EVEX, 8, 1, { 0x1, 0x00, 0x00 }, 1, 1, 0x38, 0, 0, 0, (X32 | X64), RM_DST, PFX_0xF, NO_IMM, MEM_OPND_0, P_486, 0, NULL },
{ "invlpg", 1,  { M_ANY,       }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),                    NO_VEX, NO_EVEX, 1, 1, { 0x1, 0x00, 0x00 }, 1, 1, 0x38, 0, 0, ADDR_SIZE_OVERRIDE, (X32 | X64), RM_DST, PFX_0xF, NO_IMM, MEM_OPND_0, P_486, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* DIV */
/* ----------------------------------------------------------------------------------------------- */
{ "div",    1, { R8_AL,    OP_N    }, GP0,  (F_OPCODE2_REG),													                              NO_VEX, NO_EVEX, 1, 2, { 0xf6, 0xf0, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "div",    1, { R8_CL,    OP_N    }, GP0,  (F_OPCODE2_REG),													                              NO_VEX, NO_EVEX, 1, 2, { 0xf6, 0xf0, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "div",    1, { R8,       OP_N    }, GP0,  (F_OPCODE2_REG),													                              NO_VEX, NO_EVEX, 1, 2, { 0xf6, 0xf0, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "div",    1, { R8E,      OP_N    }, GP3,  (REX | REXB) | (F_OPCODE2_REG),													                NO_VEX, NO_EVEX, 1, 2, { 0xf6, 0xf0, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "div",    1, { R8U,      OP_N    }, GP3,  (REX) | (F_OPCODE2_REG),													                      NO_VEX, NO_EVEX, 1, 2, { 0xf6, 0xf0, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "div",    1, { R16_AX,   OP_N    }, GP0,  (F_OPCODE2_REG),													                              NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xf0, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "div",    1, { R16,      OP_N    }, GP0,  (F_OPCODE2_REG),													                              NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xf0, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "div",    1, { R16E,     OP_N    }, GP3,  (REX | REXB) | (F_OPCODE2_REG),													                NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xf0, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0, (X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "div",    1, { R32,      OP_N    }, GP0,  (F_OPCODE2_REG),												                                NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xf0, 0x00 }, 4,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "div",    1, { R32_EAX,  OP_N    }, GP0,  (F_OPCODE2_REG),												                                NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xf0, 0x00 }, 4,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "div",    1, { R32E,     OP_N    }, GP3,  (REX | REXB) | (F_OPCODE2_REG),												                  NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xf0, 0x00 }, 4,  0, NO_MOD,      0, 0, 0, (X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "div",    1, { R64,      OP_N    }, GP3,  (REX | REXW) | (F_OPCODE2_REG),												                  NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xf0, 0x00 }, 8,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "div",    1, { R64_RAX,  OP_N    }, GP3,  (REX | REXW) | (F_OPCODE2_REG),												                  NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xf0, 0x00 }, 8,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "div",    1, { R64E,     OP_N    }, GP3,  (REX | REXW | REXB) | (F_OPCODE2_REG),												          NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xf0, 0x00 }, 8,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "div",    1, { M8,       OP_N    }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),                         NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 1, 1, 0x30, 0, 0, 0, (X32 | X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_486, 0, NULL },
{ "div",    1, { M16,      OP_N    }, GP2, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),                         NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 2, 1, 0x30, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X32 | X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_486, 0, NULL },
{ "div",    1, { M32,      OP_N    }, GP2, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),                         NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 4, 1, 0x30, 0, 0, ADDR_SIZE_OVERRIDE, (X32 | X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_486, 0, NULL },
{ "div",    1, { M64,      OP_N    }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM | OPCODE_EXT),          NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 8, 1, 0x30, 0, 0, 0, (X32 | X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_486, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* IDIV */
/* ----------------------------------------------------------------------------------------------- */
{ "idiv",    1, { R8_AL,    OP_N    }, GP0,  (F_OPCODE2_REG),													                                NO_VEX, NO_EVEX, 1, 2, { 0xf6, 0xf8, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "idiv",    1, { R8_CL,    OP_N    }, GP0,  (F_OPCODE2_REG),													                                NO_VEX, NO_EVEX, 1, 2, { 0xf6, 0xf8, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "idiv",    1, { R8,       OP_N    }, GP0,  (F_OPCODE2_REG),													                                NO_VEX, NO_EVEX, 1, 2, { 0xf6, 0xf8, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "idiv",    1, { R8E,      OP_N    }, GP3,  (REX | REXB) | (F_OPCODE2_REG),													                NO_VEX, NO_EVEX, 1, 2, { 0xf6, 0xf8, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "idiv",    1, { R8U,      OP_N    }, GP3,  (REX) | (F_OPCODE2_REG),													                        NO_VEX, NO_EVEX, 1, 2, { 0xf6, 0xf8, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "idiv",    1, { R16_AX,   OP_N    }, GP0,  (F_OPCODE2_REG),													                                NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xf8, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "idiv",    1, { R16,      OP_N    }, GP0,  (F_OPCODE2_REG),													                                NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xf8, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "idiv",    1, { R16E,     OP_N    }, GP3,  (REX | REXB) | (F_OPCODE2_REG),													                NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xf8, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0, (X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "idiv",    1, { R32,      OP_N    }, GP0,  (F_OPCODE2_REG),												                                  NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xf8, 0x00 }, 4,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "idiv",    1, { R32_EAX,  OP_N    }, GP0,  (F_OPCODE2_REG),												                                  NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xf8, 0x00 }, 4,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "idiv",    1, { R32E,     OP_N    }, GP3,  (REX | REXB) | (F_OPCODE2_REG),												                  NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xf8, 0x00 }, 4,  0, NO_MOD,      0, 0, 0, (X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "idiv",    1, { R64,      OP_N    }, GP3,  (REX | REXW) | (F_OPCODE2_REG),												                  NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xf8, 0x00 }, 8,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "idiv",    1, { R64_RAX,  OP_N    }, GP3,  (REX | REXW) | (F_OPCODE2_REG),												                  NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xf8, 0x00 }, 8,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "idiv",    1, { R64E,     OP_N    }, GP3,  (REX | REXW | REXB) | (F_OPCODE2_REG),												            NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xf8, 0x00 }, 8,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "idiv",    1, { M8,       OP_N    }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),                          NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 1, 1, 0x38, 0, 0, 0, (X32 | X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_486, 0, NULL },
{ "idiv",    1, { M16,      OP_N    }, GP2, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),                          NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 2, 1, 0x38, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X32 | X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_486, 0, NULL },
{ "idiv",    1, { M32,      OP_N    }, GP2, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),                          NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 4, 1, 0x38, 0, 0, ADDR_SIZE_OVERRIDE, (X32 | X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_486, 0, NULL },
{ "idiv",    1, { M64,      OP_N    }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM | OPCODE_EXT),           NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 8, 1, 0x38, 0, 0, 0, (X32 | X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_486, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
/* NEG */
/* ----------------------------------------------------------------------------------------------- */
{ "neg",    1, { R8_AL,    OP_N    }, GP0,  (F_OPCODE2_REG),													                              NO_VEX, NO_EVEX, 1, 2, { 0xf6, 0xd8, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "neg",    1, { R8_CL,    OP_N    }, GP0,  (F_OPCODE2_REG),													                              NO_VEX, NO_EVEX, 1, 2, { 0xf6, 0xd8, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "neg",    1, { R8,       OP_N    }, GP0,  (F_OPCODE2_REG),													                              NO_VEX, NO_EVEX, 1, 2, { 0xf6, 0xd8, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "neg",    1, { R8E,      OP_N    }, GP3,  (REX | REXB) | (F_OPCODE2_REG),													                NO_VEX, NO_EVEX, 1, 2, { 0xf6, 0xd8, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "neg",    1, { R8U,      OP_N    }, GP3,  (REX) | (F_OPCODE2_REG),													                      NO_VEX, NO_EVEX, 1, 2, { 0xf6, 0xd8, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "neg",    1, { R16_AX,   OP_N    }, GP0,  (F_OPCODE2_REG),													                              NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xd8, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "neg",    1, { R16,      OP_N    }, GP0,  (F_OPCODE2_REG),													                              NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xd8, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "neg",    1, { R16E,     OP_N    }, GP3,  (REX | REXB) | (F_OPCODE2_REG),													                NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xd8, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0, (X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "neg",    1, { R32,      OP_N    }, GP0,  (F_OPCODE2_REG),												                                NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xd8, 0x00 }, 4,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "neg",    1, { R32_EAX,  OP_N    }, GP0,  (F_OPCODE2_REG),												                                NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xd8, 0x00 }, 4,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "neg",    1, { R32E,     OP_N    }, GP3,  (REX | REXB) | (F_OPCODE2_REG),												                  NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xd8, 0x00 }, 4,  0, NO_MOD,      0, 0, 0, (X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "neg",    1, { R64,      OP_N    }, GP3,  (REX | REXW) | (F_OPCODE2_REG),												                  NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xd8, 0x00 }, 8,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "neg",    1, { R64_RAX,  OP_N    }, GP3,  (REX | REXW) | (F_OPCODE2_REG),												                  NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xd8, 0x00 }, 8,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "neg",    1, { R64E,     OP_N    }, GP3,  (REX | REXW | REXB) | (F_OPCODE2_REG),												          NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xd8, 0x00 }, 8,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "neg",    1, { M8,       OP_N    }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),                         NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 1, 1, 0x18, 0, 0, 0, (X32 | X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_486, 0, NULL },
{ "neg",    1, { M16,      OP_N    }, GP2, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),                         NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 2, 1, 0x18, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X32 | X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_486, 0, NULL },
{ "neg",    1, { M32,      OP_N    }, GP2, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),                         NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 4, 1, 0x18, 0, 0, ADDR_SIZE_OVERRIDE, (X32 | X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_486, 0, NULL },
{ "neg",    1, { M64,      OP_N    }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM | OPCODE_EXT),          NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 8, 1, 0x18, 0, 0, 0, (X32 | X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_486, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* NOT */
/* ----------------------------------------------------------------------------------------------- */

{ "not",    1, { R8_AL,    OP_N    }, GP0,  (F_OPCODE2_REG),													                              NO_VEX, NO_EVEX, 1, 2, { 0xf6, 0xd0, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "not",    1, { R8_CL,    OP_N    }, GP0,  (F_OPCODE2_REG),													                              NO_VEX, NO_EVEX, 1, 2, { 0xf6, 0xd0, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "not",    1, { R8,       OP_N    }, GP0,  (F_OPCODE2_REG),													                              NO_VEX, NO_EVEX, 1, 2, { 0xf6, 0xd0, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "not",    1, { R8E,      OP_N    }, GP3,  (REX | REXB) | (F_OPCODE2_REG),													                NO_VEX, NO_EVEX, 1, 2, { 0xf6, 0xd0, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "not",    1, { R8U,      OP_N    }, GP3,  (REX) | (F_OPCODE2_REG),													                      NO_VEX, NO_EVEX, 1, 2, { 0xf6, 0xd0, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "not",    1, { R16_AX,   OP_N    }, GP0,  (F_OPCODE2_REG),													                              NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xd0, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "not",    1, { R16,      OP_N    }, GP0,  (F_OPCODE2_REG),													                              NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xd0, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "not",    1, { R16E,     OP_N    }, GP3,  (REX | REXB) | (F_OPCODE2_REG),													                NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xd0, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0, (X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "not",    1, { R32,      OP_N    }, GP0,  (F_OPCODE2_REG),												                                NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xd0, 0x00 }, 4,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "not",    1, { R32_EAX,  OP_N    }, GP0,  (F_OPCODE2_REG),												                                NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xd0, 0x00 }, 4,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "not",    1, { R32E,     OP_N    }, GP3,  (REX | REXB) | (F_OPCODE2_REG),												                  NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xd0, 0x00 }, 4,  0, NO_MOD,      0, 0, 0, (X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "not",    1, { R64,      OP_N    }, GP3,  (REX | REXW) | (F_OPCODE2_REG),												                  NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xd0, 0x00 }, 8,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "not",    1, { R64_RAX,  OP_N    }, GP3,  (REX | REXW) | (F_OPCODE2_REG),												                  NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xd0, 0x00 }, 8,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "not",    1, { R64E,     OP_N    }, GP3,  (REX | REXW | REXB) | (F_OPCODE2_REG),												          NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xd0, 0x00 }, 8,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "not",    1, { M8,       OP_N    }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),                         NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 1, 1, 0x10, 0, 0, 0, (X32 | X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_486, 0, NULL },
{ "not",    1, { M16,      OP_N    }, GP2, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),                         NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 2, 1, 0x10, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X32 | X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_486, 0, NULL },
{ "not",    1, { M32,      OP_N    }, GP2, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),                         NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 4, 1, 0x10, 0, 0, ADDR_SIZE_OVERRIDE, (X32 | X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_486, 0, NULL },
{ "not",    1, { M64,      OP_N    }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM | OPCODE_EXT),          NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 8, 1, 0x10, 0, 0, 0, (X32 | X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_486, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
//MUL r / m8    F6 / 4             REX  = 40
//MUL r / m8 *  REX + F6 / 4       REXB =  1
//MUL r / m16   F7 / 4             REXX =  2
//MUL r / m32   F7 / 4             REXR =  4
//MUL r / m64   REX.W + F7 / 4     REXW =  8
/* ----------------------------------------------------------------------------------------------- */
{ "mul",    1, { R8_AL,    OP_N    }, GP0,  (F_OPCODE2_REG),													                              NO_VEX, NO_EVEX, 1, 2, { 0xf6, 0xe0, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "mul",    1, { R8_CL,    OP_N    }, GP0,  (F_OPCODE2_REG),													                              NO_VEX, NO_EVEX, 1, 2, { 0xf6, 0xe0, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "mul",    1, { R8,       OP_N    }, GP0,  (F_OPCODE2_REG),													                              NO_VEX, NO_EVEX, 1, 2, { 0xf6, 0xe0, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "mul",    1, { R8E,      OP_N    }, GP3,  (REX | REXB) | (F_OPCODE2_REG),													                NO_VEX, NO_EVEX, 1, 2, { 0xf6, 0xe0, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "mul",    1, { R8U,      OP_N    }, GP3,  (REX) | (F_OPCODE2_REG),													                      NO_VEX, NO_EVEX, 1, 2, { 0xf6, 0xe0, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "mul",    1, { R16_AX,   OP_N    }, GP0,  (F_OPCODE2_REG),													                              NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xe0, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "mul",    1, { R16,      OP_N    }, GP0,  (F_OPCODE2_REG),													                              NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xe0, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "mul",    1, { R16E,     OP_N    }, GP3,  (REX | REXB) | (F_OPCODE2_REG),													                NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xe0, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0, (X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "mul",    1, { R32,      OP_N    }, GP0,  (F_OPCODE2_REG),												                                NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xe0, 0x00 }, 4,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "mul",    1, { R32_EAX,  OP_N    }, GP0,  (F_OPCODE2_REG),												                                NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xe0, 0x00 }, 4,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "mul",    1, { R32E,     OP_N    }, GP3,  (REX | REXB) | (F_OPCODE2_REG),												                  NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xe0, 0x00 }, 4,  0, NO_MOD,      0, 0, 0, (X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "mul",    1, { R64,      OP_N    }, GP3,  (REX | REXW) | (F_OPCODE2_REG),												                  NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xe0, 0x00 }, 8,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "mul",    1, { R64_RAX,  OP_N    }, GP3,  (REX | REXW) | (F_OPCODE2_REG),												                  NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xe0, 0x00 }, 8,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "mul",    1, { R64E,     OP_N    }, GP3,  (REX | REXW | REXB) | (F_OPCODE2_REG),												          NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xe0, 0x00 }, 8,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "mul",    1, { M8,       OP_N    }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),                         NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 1, 1, 0x20, 0, 0, 0, (X32 | X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_486, 0, NULL },
{ "mul",    1, { M16,      OP_N    }, GP2, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),                         NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 2, 1, 0x20, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X32 | X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_486, 0, NULL },
{ "mul",    1, { M32,      OP_N    }, GP2, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),                         NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 4, 1, 0x20, 0, 0, ADDR_SIZE_OVERRIDE, (X32 | X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_486, 0, NULL },
{ "mul",    1, { M64,      OP_N    }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM | OPCODE_EXT),          NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 8, 1, 0x20, 0, 0, 0, (X32 | X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_486, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
//IMUL r/m8*              F6 /5             REX  = 40
//IMUL r/m16              F7 /5             REXB =  1
//IMUL r/m32              F7 /5             REXX =  2
//IMUL r/m64              REX.W + F7 /5     REXR =  4
//IMUL r16, r/m16         0F AF /r          REXW =  8
//IMUL r32, r/m32         0F AF /r          
//IMUL r64, r/m64 REX.W + 0F AF /r  
//IMUL r16, r/m16, imm8   6B /r ib          
//IMUL r32, r/m32, imm8   6B /r ib          
//IMUL r64, r/m64, imm8   REX.W + 6B /r ib  
//IMUL r16, r/m16, imm16  69 /r iw          
//IMUL r32, r/m32, imm32  69 /r id          
//IMUL r64, r/m64, imm32  REX.W + 69 /r id  
/* ----------------------------------------------------------------------------------------------- */
{ "imul",    1, { R8_AL,    OP_N    }, GP0,  (F_OPCODE2_REG),													                                NO_VEX, NO_EVEX, 1, 2, { 0xf6, 0xe8, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "imul",    1, { R8_CL,    OP_N    }, GP0,  (F_OPCODE2_REG),													                                NO_VEX, NO_EVEX, 1, 2, { 0xf6, 0xe8, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "imul",    1, { R8,       OP_N    }, GP0,  (F_OPCODE2_REG),													                                NO_VEX, NO_EVEX, 1, 2, { 0xf6, 0xe8, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "imul",    1, { R8E,      OP_N    }, GP3,  (REX | REXB) | (F_OPCODE2_REG),													                NO_VEX, NO_EVEX, 1, 2, { 0xf6, 0xe8, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "imul",    1, { R8U,      OP_N    }, GP3,  (REX) | (F_OPCODE2_REG),													                        NO_VEX, NO_EVEX, 1, 2, { 0xf6, 0xe8, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "imul",    1, { R16_AX,   OP_N    }, GP0,  (F_OPCODE2_REG),													                                NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xe8, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "imul",    1, { R16,      OP_N    }, GP0,  (F_OPCODE2_REG),													                                NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xe8, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "imul",    1, { R16E,     OP_N    }, GP3,  (REX | REXB) | (F_OPCODE2_REG),													                NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xe8, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0, (X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "imul",    1, { R32,      OP_N    }, GP0,  (F_OPCODE2_REG),												                                  NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xe8, 0x00 }, 4,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "imul",    1, { R32_EAX,  OP_N    }, GP0,  (F_OPCODE2_REG),												                                  NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xe8, 0x00 }, 4,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "imul",    1, { R32E,     OP_N    }, GP3,  (REX | REXB) | (F_OPCODE2_REG),												                  NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xe8, 0x00 }, 4,  0, NO_MOD,      0, 0, 0, (X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "imul",    1, { R64,      OP_N    }, GP3,  (REX | REXW) | (F_OPCODE2_REG),												                  NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xe8, 0x00 }, 8,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "imul",    1, { R64_RAX,  OP_N    }, GP3,  (REX | REXW) | (F_OPCODE2_REG),												                  NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xe8, 0x00 }, 8,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "imul",    1, { R64E,     OP_N    }, GP3,  (REX | REXW | REXB) | (F_OPCODE2_REG),												            NO_VEX, NO_EVEX, 1, 2, { 0xf7, 0xe8, 0x00 }, 8,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_64,           0, NULL },
{ "imul",    1, { M8,       OP_N    }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),                          NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 1, 1, 0x28, 0, 0, 0, (X32 | X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_486, 0, NULL },
{ "imul",    1, { M16,      OP_N    }, GP2, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),                          NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 2, 1, 0x28, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X32 | X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_486, 0, NULL },
{ "imul",    1, { M32,      OP_N    }, GP2, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),                          NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 4, 1, 0x28, 0, 0, ADDR_SIZE_OVERRIDE, (X32 | X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_486, 0, NULL },
{ "imul",    1, { M64,      OP_N    }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM | OPCODE_EXT),           NO_VEX, NO_EVEX, 1, 1, { 0xf7, 0x00, 0x00 }, 8, 1, 0x28, 0, 0, 0, (X32 | X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_486, 0, NULL },
{ "imul",    2, { R16,      R16_AX  }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                                               (X16 | X32 | X64), REG_DST,  PFX_0xF,       NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "imul",    2, { R16_AX,   R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                                               (X16 | X32 | X64), REG_DST,  PFX_0xF,       NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "imul",    2, { R16_AX,   R16_AX  }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                                               (X16 | X32 | X64), REG_DST,  PFX_0xF,       NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "imul",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                                               (X16 | X32 | X64), REG_DST,  PFX_0xF,       NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "imul",    2, { R16E,     R16E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),               NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                                                           (X64), REG_DST,  PFX_0xF,       NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "imul",    2, { R16E,     R16     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				              NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                                                           (X64), REG_DST,  PFX_0xF,       NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "imul",    2, { R16,      R16E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				              NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                                                           (X64), REG_DST,  PFX_0xF,       NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "imul",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                                               (X16 | X32 | X64), REG_DST,  PFX_0xF,       NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "imul",    2, { R32_EAX,  R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                                               (X16 | X32 | X64), REG_DST,  PFX_0xF,       NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "imul",    2, { R32_EAX,  R32_EAX }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                                               (X16 | X32 | X64), REG_DST,  PFX_0xF,       NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "imul",    2, { R32,      R32_EAX }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                                               (X16 | X32 | X64), REG_DST,  PFX_0xF,       NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "imul",    2, { R32E,     R32E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	              NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                                                           (X64), REG_DST,  PFX_0xF,       NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "imul",    2, { R32E,     R32     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				              NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                                                           (X64), REG_DST,  PFX_0xF,       NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "imul",    2, { R32,      R32E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				              NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                                                           (X64), REG_DST,  PFX_0xF,       NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "imul",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                  NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                                                           (X64), REG_DST,  PFX_0xF,       NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "imul",    2, { R64_RAX,  R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                  NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                                                           (X64), REG_DST,  PFX_0xF,       NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "imul",    2, { R64,      R64_RAX }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                  NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                                                           (X64), REG_DST,  PFX_0xF,       NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "imul",    2, { R64_RAX,  R64_RAX }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                  NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                                                           (X64), REG_DST,  PFX_0xF,       NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "imul",    2, { R64E,     R64E    }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),        NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                                                           (X64), REG_DST,  PFX_0xF,       NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "imul",    2, { R64,      R64E    }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		            NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                                                           (X64), REG_DST,  PFX_0xF,       NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "imul",    2, { R64E,     R64     }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		            NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                                                           (X64), REG_DST,  PFX_0xF,       NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "imul",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,                             (X16 | X32 | X64), REG_DST,  PFX_0xF,       NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "imul",    2, { R16_AX,   M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,                             (X16 | X32 | X64), REG_DST,  PFX_0xF,       NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "imul",    2, { R16E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                      NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,                                         (X64), REG_DST,  PFX_0xF,       NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "imul",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,                             (X16 | X32 | X64), REG_DST,  PFX_0xF,       NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "imul",    2, { R32_EAX,  M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,                             (X16 | X32 | X64), REG_DST,  PFX_0xF,       NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "imul",    2, { R32E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                      NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,                                         (X64), REG_DST,  PFX_0xF,       NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "imul",    2, { R64,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				                NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,                             (X16 | X32 | X64), REG_DST,  PFX_0xF,       NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "imul",    2, { R64_RAX,  M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				                NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,                             (X16 | X32 | X64), REG_DST,  PFX_0xF,       NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "imul",    2, { R64E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,                                         (X64), REG_DST,  PFX_0xF,       NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "imul",    3, { R16,      R16_AX, IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE,   0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R16_AX,   R16,    IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE,   0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R16_AX,   R16_AX, IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE,   0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R16,      R16,    IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE,   0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R16E,     R16E,   IMM8 }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),           NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE,   0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R16E,     R16,    IMM8 }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),				          NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE,   0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R16,      R16E,   IMM8 }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),				          NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE,   0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R32,      R32,    IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                  0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R32_EAX,  R32,    IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                  0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R32_EAX,  R32_EAX,IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                  0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R32,      R32_EAX,IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                  0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R32E,     R32E,   IMM8 }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | IMM8_ONLY),	                      NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                  0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R32E,     R32,    IMM8 }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),				          NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                  0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R32,      R32E,   IMM8 }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),				          NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                  0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R64,      R64,    IMM8 }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		              NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,                  0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R64_RAX,  R64,    IMM8 }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		              NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,                  0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R64,      R64_RAX,IMM8 }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		              NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,                  0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R64_RAX,  R64_RAX,IMM8 }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		              NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,                  0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R64E,     R64E,   IMM8 }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | IMM8_ONLY),                 NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,                  0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R64,      R64E,   IMM8 }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		        NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,                  0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R64E,     R64,    IMM8 }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		        NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,                  0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R16,      M_ANY,  IMM8 }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG | OPCODE_EXT | IMM8_ONLY),				                          NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE,	  ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     MEM_OPND_1, P_86,  0, NULL },
{ "imul",    3, { R16_AX,   M_ANY,  IMM8 }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG | OPCODE_EXT | IMM8_ONLY),				                          NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE,	  ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     MEM_OPND_1, P_86,  0, NULL },
{ "imul",    3, { R16E,     M_ANY,  IMM8 }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG | IMM8_ONLY),	                              NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE,	  ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     MEM_OPND_1, P_64,  0, NULL },
{ "imul",    3, { R32,      M_ANY,  IMM8 }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG | OPCODE_EXT | IMM8_ONLY),				                          NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE,	  ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     MEM_OPND_1, P_86,  0, NULL },
{ "imul",    3, { R32_EAX,  M_ANY,  IMM8 }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG | OPCODE_EXT | IMM8_ONLY),				                          NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE,	  ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     MEM_OPND_1, P_86,  0, NULL },
{ "imul",    3, { R32E,     M_ANY,  IMM8 }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG | OPCODE_EXT | IMM8_ONLY),	                  NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE,	  ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     MEM_OPND_1, P_64,  0, NULL },
{ "imul",    3, { R64,      M_ANY,  IMM8 }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG | OPCODE_EXT | IMM8_ONLY),				            NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,				            ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     MEM_OPND_1, P_64,  0, NULL },
{ "imul",    3, { R64_RAX,  M_ANY,  IMM8 }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG | OPCODE_EXT | IMM8_ONLY),				            NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,				            ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     MEM_OPND_1, P_64,  0, NULL },
{ "imul",    3, { R64E,     M_ANY,  IMM8 }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG | OPCODE_EXT | IMM8_ONLY),	          NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,				            ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     MEM_OPND_1, P_64,  0, NULL },
{ "imul",    3, { R16,      R16_AX, IMM16 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),							                  NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE,               0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R16_AX,   R16,    IMM16 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),							                  NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE,               0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R16_AX,   R16_AX, IMM16 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),							                  NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE,               0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R16,      R16,    IMM16 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),							                  NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE,               0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R16E,     R16E,   IMM16 }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),          NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE,               0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R16E,     R16,    IMM16 }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),				          NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE,               0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R16,      R16E,   IMM16 }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),				          NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE,               0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R32,      R32,    IMM32 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),							                  NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                              0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R32_EAX,  R32,    IMM32 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),							                  NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                              0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R32_EAX,  R32_EAX,IMM32 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),							                  NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                              0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R32,      R32_EAX,IMM32 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),							                  NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                              0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R32E,     R32E,   IMM32 }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                              0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R32E,     R32,    IMM32 }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),				          NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                              0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R32,      R32E,   IMM32 }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),				          NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                              0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R64,      R64,    IMM32 }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),		              NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                              0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R64_RAX,  R64,    IMM32 }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),		              NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                              0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R64,      R64_RAX,IMM32 }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),		              NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                              0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R64_RAX,  R64_RAX,IMM32 }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),		              NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                              0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R64E,     R64E,   IMM32 }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                              0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R64,      R64E,   IMM32 }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),		      NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                              0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R64E,     R64,    IMM32 }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),		      NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                              0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_2,     NO_MEM,     P_64,  0, NULL },
 /* first register used for first and second operand */                                          
{ "imul",    3, { R16,               IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R16_AX,            IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R16_AX,            IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R16,               IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R16E,              IMM8 }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),            NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R16E,              IMM8 }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),				            NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R16,               IMM8 }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),				            NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R32,               IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R32_EAX,           IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R32_EAX,           IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R32,               IMM8 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),							                    NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R32E,              IMM8 }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | IMM8_ONLY),	                        NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R32E,              IMM8 }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),				            NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R32,               IMM8 }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),				            NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R64,               IMM8 }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		                NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R64_RAX,           IMM8 }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		                NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R64,               IMM8 }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		                NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R64_RAX,           IMM8 }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		                NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R64E,              IMM8 }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | IMM8_ONLY),                  NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R64,               IMM8 }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		        NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R64E,              IMM8 }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		        NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 8, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R16,               IMM16 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),							                                NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R16_AX,            IMM16 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),							                                NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R16_AX,            IMM16 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),							                                NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R16,               IMM16 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),							                                NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R16E,              IMM16 }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),                       NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R16E,              IMM16 }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),				                      NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R16,               IMM16 }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),				                      NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 2, 1, MOD_REG_IMM, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R32,               IMM32 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),							                                NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R32_EAX,           IMM32 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),							                                NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R32_EAX,           IMM32 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),							                                NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R32,               IMM32 }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),							                                NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_86,  0, NULL },
{ "imul",    3, { R32E,              IMM32 }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                                  NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R32E,              IMM32 }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),				                      NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R32,               IMM32 }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),				                      NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R64,               IMM32 }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),		                          NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R64_RAX,           IMM32 }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),		                          NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R64,               IMM32 }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),		                          NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R64_RAX,           IMM32 }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),		                          NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R64E,              IMM32 }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                             NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R64,               IMM32 }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),		                    NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_64,  0, NULL },
{ "imul",    3, { R64E,              IMM32 }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT),		                    NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 4, 1, MOD_REG_IMM, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, IMM_OPND_1,     NO_MEM,     P_64,  0, NULL },
//* ----------------------------------------------------------------------------------------------- */
//INC r/m8    FE /0         
//INC r/m8*   REX + FE /0   
//INC r/m16   FF /0         
//INC r/m32   FF /0         
//INC r/m64   REX.W + FF /0 
//INC r16    40+ rw**      
//INC r32    40+ rd        
/* ----------------------------------------------------------------------------------------------- */
{ "inc",    1, { R16_AX,           }, GP4,  (F_OPCODE_REG),									              NO_VEX, NO_EVEX, 1, 1, { 0x40, 0x00, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,  (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "inc",    1, { R16,              }, GP4,  (F_OPCODE_REG),									              NO_VEX, NO_EVEX, 1, 1, { 0x40, 0x00, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,  (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "inc",    1, { R32_EAX,          }, GP4,  (F_OPCODE_REG),									              NO_VEX, NO_EVEX, 1, 1, { 0x40, 0x00, 0x00 }, 4,  0, NO_MOD,      0, 0, 0,                 (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "inc",    1, { R32,              }, GP4,  (F_OPCODE_REG),									              NO_VEX, NO_EVEX, 1, 1, { 0x40, 0x00, 0x00 }, 4,  0, NO_MOD,      0, 0, 0,                 (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "inc",    1, { R16_AX,           }, GP0,  (F_OPCODE2_REG),									            NO_VEX, NO_EVEX, 1, 2, { 0xff, 0xc0, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,  (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "inc",    1, { R16,              }, GP0,  (F_OPCODE2_REG),									            NO_VEX, NO_EVEX, 1, 2, { 0xff, 0xc0, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,  (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "inc",    1, { R16E,             }, GP3,  (F_OPCODE2_REG),									            NO_VEX, NO_EVEX, 1, 2, { 0xff, 0xc0, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,  (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_64,  0, NULL },
{ "inc",    1, { R32_EAX,          }, GP0,  (F_OPCODE2_REG),									            NO_VEX, NO_EVEX, 1, 2, { 0xff, 0xc0, 0x00 }, 4,  0, NO_MOD,      0, 0, 0,                 (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "inc",    1, { R32,              }, GP0,  (F_OPCODE2_REG),									            NO_VEX, NO_EVEX, 1, 2, { 0xff, 0xc0, 0x00 }, 4,  0, NO_MOD,      0, 0, 0,                 (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "inc",    1, { R32E,             }, GP3,  (REX | REXB) | (F_OPCODE2_REG),						    NO_VEX, NO_EVEX, 1, 2, { 0xff, 0xc0, 0x00 }, 4,  0, NO_MOD,      0, 0, 0,                 (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_64,  0, NULL },
{ "inc",    1, { R8_AL,            }, GP0,  (F_OPCODE2_REG),									            NO_VEX, NO_EVEX, 1, 2, { 0xfe, 0xc0, 0x00 }, 1,  0, NO_MOD,      0, 0, 0,                 (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "inc",    1, { R8_CL,            }, GP0,  (F_OPCODE2_REG),									            NO_VEX, NO_EVEX, 1, 2, { 0xfe, 0xc0, 0x00 }, 1,  0, NO_MOD,      0, 0, 0,                 (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "inc",    1, { R8,               }, GP0,  (F_OPCODE2_REG),									            NO_VEX, NO_EVEX, 1, 2, { 0xfe, 0xc0, 0x00 }, 1,  0, NO_MOD,      0, 0, 0,                 (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "inc",    1, { R8E,              }, GP3,  (REX | REXB) | (F_OPCODE2_REG),			          NO_VEX, NO_EVEX, 1, 2, { 0xfe, 0xc0, 0x00 }, 1,  0, NO_MOD,      0, 0, 0,                 (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_64,  0, NULL },
{ "inc",    1, { R8U,              }, GP3,  (REX) | (F_OPCODE2_REG),							        NO_VEX, NO_EVEX, 1, 2, { 0xfe, 0xc0, 0x00 }, 1,  0, NO_MOD,      0, 0, 0,                 (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_64,  0, NULL },
{ "inc",    1, { R16_AX,           }, GP0,  (F_OPCODE2_REG),									            NO_VEX, NO_EVEX, 1, 2, { 0xff, 0xc0, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,  (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "inc",    1, { R16,              }, GP0,  (F_OPCODE2_REG),									            NO_VEX, NO_EVEX, 1, 2, { 0xff, 0xc0, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,  (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "inc",    1, { R16E,             }, GP3,  (F_OPCODE2_REG),									            NO_VEX, NO_EVEX, 1, 2, { 0xff, 0xc0, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,  (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_64,  0, NULL },
{ "inc",    1, { R32_EAX,          }, GP0,  (F_OPCODE2_REG),									            NO_VEX, NO_EVEX, 1, 2, { 0xff, 0xc0, 0x00 }, 4,  0, NO_MOD,      0, 0, 0,                 (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "inc",    1, { R32,              }, GP0,  (F_OPCODE2_REG),									            NO_VEX, NO_EVEX, 1, 2, { 0xff, 0xc0, 0x00 }, 4,  0, NO_MOD,      0, 0, 0,                 (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "inc",    1, { R32E,             }, GP3,  (REX | REXB) | (F_OPCODE2_REG),						    NO_VEX, NO_EVEX, 1, 2, { 0xff, 0xc0, 0x00 }, 4,  0, NO_MOD,      0, 0, 0,                 (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_64,  0, NULL },
{ "inc",    1, { R64_RAX,          }, GP3,  (REX | REXW) | (F_OPCODE2_REG),		            NO_VEX, NO_EVEX, 1, 2, { 0xff, 0xc0, 0x00 }, 8,  0, NO_MOD,      0, 0, 0,                 (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_64,  0, NULL },
{ "inc",    1, { R64,              }, GP3,  (REX | REXW) | (F_OPCODE2_REG),		            NO_VEX, NO_EVEX, 1, 2, { 0xff, 0xc0, 0x00 }, 8,  0, NO_MOD,      0, 0, 0,                 (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_64,  0, NULL },
{ "inc",    1, { R64E,             }, GP3,  (REX | REXW | REXB) | (F_OPCODE2_REG),		    NO_VEX, NO_EVEX, 1, 2, { 0xff, 0xc0, 0x00 }, 8,  0, NO_MOD,      0, 0, 0,                 (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_64,  0, NULL },
{ "inc",    1, { M8,               }, GP0,   ALLOW_SEG | (F_MODRM | F_MODRM_REG),                 NO_VEX, NO_EVEX, 1, 1, { 0xfe, 0x00, 0x00 }, 1,  0, 0x00,        0, 0, 0,                       (X32 | X64), NO_DST,   NO_PREFIX,  NO_IMM,      MEM_OPND_0, P_486, 0, NULL },
{ "inc",    1, { M16,              }, GP2,   ALLOW_SEG | (F_MODRM | F_MODRM_REG),                 NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 2,  0, 0x00,        0, OP_SIZE_OVERRIDE, 0,        (X32 | X64), NO_DST,   NO_PREFIX,  NO_IMM,      MEM_OPND_0, P_486, 0, NULL },
{ "inc",    1, { M32,              }, GP2,   ALLOW_SEG | (F_MODRM | F_MODRM_REG),                 NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 4,  0, 0x00,        0, 0, ADDR_SIZE_OVERRIDE,      (X32 | X64), NO_DST,   NO_PREFIX,  NO_IMM,      MEM_OPND_0, P_486, 0, NULL },
{ "inc",    1, { M64,              }, GP3,   ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),  NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 8,  0, 0x00,        0, 0, ADDR_SIZE_OVERRIDE,      (X32 | X64), NO_DST,   NO_PREFIX,  NO_IMM,      MEM_OPND_0, P_64,  0, NULL },

/* ----------------------------------------------------------------------------------------------- */
//DEC r/m8    FE /1         
//DEC r/m8*   REX + FE /1   
//DEC r/m16   FF /1         
//DEC r/m32   FF /1         
//DEC r/m64   REX.W + FF /1 
//DEC r16    48+ rw**      
//DEC r32    48+ rd        
/* ----------------------------------------------------------------------------------------------- */
//{ "dec",    1, { R16_AX,           }, GP0,  (F_OPCODE_REG),									              NO_VEX, NO_EVEX, 1, 1, { 0x48, 0x00, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,  (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
//{ "dec",    1, { R16,              }, GP0,  (F_OPCODE_REG),									              NO_VEX, NO_EVEX, 1, 1, { 0x48, 0x00, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,  (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
//{ "dec",    1, { R32_EAX,          }, GP0,  (F_OPCODE_REG),									              NO_VEX, NO_EVEX, 1, 1, { 0x48, 0x00, 0x00 }, 4,  0, NO_MOD,      0, 0, 0,                 (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
//{ "dec",    1, { R32,              }, GP0,  (F_OPCODE_REG),									              NO_VEX, NO_EVEX, 1, 1, { 0x48, 0x00, 0x00 }, 4,  0, NO_MOD,      0, 0, 0,                 (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
{ "dec",    1, { R8_AL,            }, GP0,  (F_OPCODE2_REG),									            NO_VEX, NO_EVEX, 1, 2, { 0xfe, 0xc8, 0x00 }, 1,  0, NO_MOD,      0, 0, 0,                 (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "dec",    1, { R8_CL,            }, GP0,  (F_OPCODE2_REG),									            NO_VEX, NO_EVEX, 1, 2, { 0xfe, 0xc8, 0x00 }, 1,  0, NO_MOD,      0, 0, 0,                 (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "dec",    1, { R8,               }, GP0,  (F_OPCODE2_REG),									            NO_VEX, NO_EVEX, 1, 2, { 0xfe, 0xc8, 0x00 }, 1,  0, NO_MOD,      0, 0, 0,                 (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "dec",    1, { R8E,              }, GP3,  (REX | REXB) | (F_OPCODE2_REG),			          NO_VEX, NO_EVEX, 1, 2, { 0xfe, 0xc8, 0x00 }, 1,  0, NO_MOD,      0, 0, 0,                 (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_64,  0, NULL },
{ "dec",    1, { R8U,              }, GP3,  (REX) | (F_OPCODE2_REG),							        NO_VEX, NO_EVEX, 1, 2, { 0xfe, 0xc8, 0x00 }, 1,  0, NO_MOD,      0, 0, 0,                 (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_64,  0, NULL },
{ "dec",    1, { R16_AX,           }, GP0,  (F_OPCODE2_REG),									            NO_VEX, NO_EVEX, 1, 2, { 0xff, 0xc8, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,  (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "dec",    1, { R16,              }, GP0,  (F_OPCODE2_REG),									            NO_VEX, NO_EVEX, 1, 2, { 0xff, 0xc8, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,  (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "dec",    1, { R16E,             }, GP3,  (F_OPCODE2_REG),									            NO_VEX, NO_EVEX, 1, 2, { 0xff, 0xc8, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,  (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_64,  0, NULL },
{ "dec",    1, { R32_EAX,          }, GP0,  (F_OPCODE2_REG),									            NO_VEX, NO_EVEX, 1, 2, { 0xff, 0xc8, 0x00 }, 4,  0, NO_MOD,      0, 0, 0,                 (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "dec",    1, { R32,              }, GP0,  (F_OPCODE2_REG),									            NO_VEX, NO_EVEX, 1, 2, { 0xff, 0xc8, 0x00 }, 4,  0, NO_MOD,      0, 0, 0,                 (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "dec",    1, { R32E,             }, GP3,  (REX | REXB) | (F_OPCODE2_REG),						    NO_VEX, NO_EVEX, 1, 2, { 0xff, 0xc8, 0x00 }, 4,  0, NO_MOD,      0, 0, 0,                 (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_64,  0, NULL },
{ "dec",    1, { R64_RAX,          }, GP3,  (REX | REXW) | (F_OPCODE2_REG),		            NO_VEX, NO_EVEX, 1, 2, { 0xff, 0xc8, 0x00 }, 8,  0, NO_MOD,      0, 0, 0,                 (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_64,  0, NULL },
{ "dec",    1, { R64,              }, GP3,  (REX | REXW) | (F_OPCODE2_REG),		            NO_VEX, NO_EVEX, 1, 2, { 0xff, 0xc8, 0x00 }, 8,  0, NO_MOD,      0, 0, 0,                 (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_64,  0, NULL },
{ "dec",    1, { R64E,             }, GP3,  (REX | REXW | REXB) | (F_OPCODE2_REG),		    NO_VEX, NO_EVEX, 1, 2, { 0xff, 0xc8, 0x00 }, 8,  0, NO_MOD,      0, 0, 0,                 (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_64,  0, NULL },
{ "dec",    1, { M8,               }, GP0,   ALLOW_SEG | (F_MODRM | F_MODRM_REG),                 NO_VEX, NO_EVEX, 1, 1, { 0xfe, 0x00, 0x00 }, 1,  0, 0x08,        0, 0, 0,                       (X32 | X64), NO_DST,   NO_PREFIX,  NO_IMM,      MEM_OPND_0, P_486, 0, NULL },
{ "dec",    1, { M16,              }, GP2,   ALLOW_SEG | (F_MODRM | F_MODRM_REG),                 NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 2,  0, 0x08,        0, OP_SIZE_OVERRIDE, 0,        (X32 | X64), NO_DST,   NO_PREFIX,  NO_IMM,      MEM_OPND_0, P_486, 0, NULL },
{ "dec",    1, { M32,              }, GP2,   ALLOW_SEG | (F_MODRM | F_MODRM_REG),                 NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 4,  0, 0x08,        0, 0, ADDR_SIZE_OVERRIDE,      (X32 | X64), NO_DST,   NO_PREFIX,  NO_IMM,      MEM_OPND_0, P_486, 0, NULL },
{ "dec",    1, { M64,              }, GP3,   ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),  NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 8,  0, 0x08,        0, 0, ADDR_SIZE_OVERRIDE,      (X32 | X64), NO_DST,   NO_PREFIX,  NO_IMM,      MEM_OPND_0, P_64,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PUSH r / m16    FF / 6     M   Valid     Valid Push r / m16.
//PUSH r / m32    FF / 6     M   N.E.      Valid Push r / m32.
//PUSH r / m64    FF / 6     M   Valid       N.E.Push r / m64.
//PUSH r16        50 + rw    O   Valid     Valid Push r16.
//PUSH r32        50 + rd    O   N.E.      Valid Push r32.
//PUSH r64        50 + rd    O   Valid       N.E.Push r64.
//PUSH imm8       6A ib      I   Valid     Valid Push imm8.
//PUSH imm16      68 iw      I   Valid     Valid Push imm16.
//PUSH imm32      68 id      I   Valid     Valid Push imm32.
//PUSH CS         0E         ZO  Invalid   Valid Push CS.         
//PUSH SS         16         ZO  Invalid   Valid Push SS.
//PUSH DS         1E         ZO  Invalid   Valid Push DS.
//PUSH ES         06         ZO  Invalid   Valid Push ES.
//PUSH FS         0F A0      ZO  Valid     Valid Push FS.
//PUSH GS         0F A8      ZO  Valid     Valid Push GS.
/* ----------------------------------------------------------------------------------------------- */
{ "push",    1, { R32_EAX,          }, GP4,  (F_OPCODE_REG),									              NO_VEX, NO_EVEX, 1, 1, { 0x50, 0x00, 0x00 }, 4,  0, NO_MOD,      0, 0, 0,                       (X16 | X32), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "push",    1, { R32,              }, GP4,  (F_OPCODE_REG),									              NO_VEX, NO_EVEX, 1, 1, { 0x50, 0x00, 0x00 }, 4,  0, NO_MOD,      0, 0, 0,                       (X16 | X32), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "push",    1, { R_SEG,            }, GP4,  (F_OPCODE_REG),							                  NO_VEX, NO_EVEX, 1, 1, { 0x06, 0x00, 0x00 }, 1,  0, NO_MOD,      0, 0, 0,                       (X16 | X32), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "push",    1, { M32,              }, GP4,   ALLOW_SEG,                                    NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 4,  0, 0x30, 0, 0, ADDR_SIZE_OVERRIDE,             (X16 | X32), RM_DST,   NO_PREFIX,  NO_IMM,      MEM_OPND_0, P_86,  0, NULL },
{ "push",    1, { M_ANY,            }, GP4,   ALLOW_SEG,                                    NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 4,  0, 0x30, 0, 0, ADDR_SIZE_OVERRIDE,             (X16 | X32), RM_DST,   NO_PREFIX,  NO_IMM,      MEM_OPND_0, P_86,  0, NULL },
{ "push",    1, { R_SEGE,           }, GP3,  (F_OPCODE_REG),							                  NO_VEX, NO_EVEX, 1, 1, { 0x80, 0x00, 0x00 }, 1,  0, NO_MOD,      0, 0, 0,                             (X64), REG_DST,  PFX_0xF,    NO_IMM,      NO_MEM,     P_64,  0, NULL },
{ "push",    1, { R16_AX,           }, GP0,  (F_OPCODE_REG),									              NO_VEX, NO_EVEX, 1, 1, { 0x50, 0x00, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,  (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "push",    1, { R16,              }, GP0,  (F_OPCODE_REG),									              NO_VEX, NO_EVEX, 1, 1, { 0x50, 0x00, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,  (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "push",    1, { R16E,             }, GP3,  (REX | REXB) | (F_OPCODE_REG),								  NO_VEX, NO_EVEX, 1, 1, { 0x50, 0x00, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,  (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "push",    1, { M16,              }, GP0,   ALLOW_SEG,                                    NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 2,  0, 0x30,        0, OP_SIZE_OVERRIDE, 0,  (X16 | X32 | X64), RM_DST,   NO_PREFIX,  NO_IMM,      MEM_OPND_0, P_486, 0, NULL },
{ "push",    1, { R64_RAX,          }, GP0,  (F_OPCODE_REG),		                            NO_VEX, NO_EVEX, 1, 1, { 0x50, 0x00, 0x00 }, 8,  0, NO_MOD,      0, 0, 0,                             (X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_64,  0, NULL },
{ "push",    1, { R64,              }, GP0,  (F_OPCODE_REG),		                            NO_VEX, NO_EVEX, 1, 1, { 0x50, 0x00, 0x00 }, 8,  0, NO_MOD,      0, 0, 0,                             (X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_64,  0, NULL },
{ "push",    1, { R64E,             }, GP3,  (REX | REXB) | (F_OPCODE_REG),		              NO_VEX, NO_EVEX, 1, 1, { 0x50, 0x00, 0x00 }, 8,  0, NO_MOD,      0, 0, 0,                             (X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_64,  0, NULL },
{ "push",    1, { M64,              }, GP3,   ALLOW_SEG,                                    NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 8,  0, 0x30,        0, 0, ADDR_SIZE_OVERRIDE,            (X64), RM_DST,   NO_PREFIX,  NO_IMM,      MEM_OPND_0, P_64,  0, NULL },
{ "push",    1, { M_ANY,            }, GP3,   ALLOW_SEG,                                    NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 8,  0, 0x30,        0, 0, ADDR_SIZE_OVERRIDE,            (X64), RM_DST,   NO_PREFIX,  NO_IMM,      MEM_OPND_0, P_64,  0, NULL },
{ "push",    1, { IMM8,             }, GP0, 0,		                                          NO_VEX, NO_EVEX, 1, 1, { 0x6a, 0x00, 0x00 }, 1,  0, MOD_MEM_IMM, 0, 0, 0,                 (X16 | X32 | X64), NO_DST,   NO_PREFIX, IMM_OPND_0,   NO_MEM,     P_86,  0, NULL },
{ "push",    1, { IMM16,            }, GP0, 0,		                                          NO_VEX, NO_EVEX, 1, 1, { 0x68, 0x00, 0x00 }, 2,  0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,  (X16 | X32 | X64), NO_DST,   NO_PREFIX, IMM_OPND_0,   NO_MEM, P_86,  0, NULL },
{ "push",    1, { IMM32,            }, GP0, 0,		                                          NO_VEX, NO_EVEX, 1, 1, { 0x68, 0x00, 0x00 }, 4,  0, MOD_MEM_IMM, 0, 0, 0,                       (X32 | X64), NO_DST,   NO_PREFIX, IMM_OPND_0,   NO_MEM,     P_386, 0, NULL },
{ "pushw",   1, { IMM8,             }, GP0, 0,		                                          NO_VEX, NO_EVEX, 1, 1, { 0x6a, 0x00, 0x00 }, 1,  0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,  (X16 | X32 | X64), NO_DST,   NO_PREFIX, IMM_OPND_0,   NO_MEM,     P_86,  0, NULL },
{ "pushw",   1, { IMM16,            }, GP0, 0,		                                          NO_VEX, NO_EVEX, 1, 1, { 0x68, 0x00, 0x00 }, 2,  0, MOD_MEM_IMM, 0, OP_SIZE_OVERRIDE, 0,  (X16 | X32 | X64), NO_DST,   NO_PREFIX, IMM_OPND_0,   NO_MEM, P_86,  0, NULL },
{ "pushq",   0, { OP_N,   OP_N }, GP3, (REX | REXW) | ALLOW_REP,                            NO_VEX, NO_EVEX, 8, 1, { 0x9c, 0x00, 0x00 }, 1, 0, NO_MOD, 0, 0, 0,                                       (X64),       NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_64, 0, NULL },
{ "cqo",     0, { OP_N,   OP_N }, GP3, (REX | REXW) | ALLOW_REP,                            NO_VEX, NO_EVEX, 8, 1, { 0x99, 0x00, 0x00 }, 1, 0, NO_MOD, 0, 0, 0,                                       (X64),       NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_64, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//POP r/m16 M   Valid   Valid    8F /0 
//POP r/m32 M   N.E.    Valid    8F /0 
//POP r/m64 M   Valid   N.E.     8F /0 
//POP r16   O   Valid   Valid    58+ rw
//POP r32   O   N.E.    Valid    58+ rd
//POP r64   O   Valid   N.E.     58+ rd
//POP DS   ZO   Invalid Valid    1F    
//POP ES   ZO   Invalid Valid    07    
//POP SS   ZO   Invalid Valid    17    
//POP FS   ZO   Valid   Valid    0F A1 
//POP FS   ZO   N.E.    Valid    0F A1 
//POP FS   ZO   Valid   N.E.     0F A1 
//POP GS   ZO   Valid   Valid    0F A9 
//POP GS   ZO   N.E.    Valid    0F A9 
//POP GS   ZO   Valid   N.E.     0F A9 
/* ----------------------------------------------------------------------------------------------- */
{ "pop",    1,  { R32_EAX,          }, GP4,  (F_OPCODE_REG),									              NO_VEX, NO_EVEX, 1, 1, { 0x58, 0x00, 0x00 }, 4,  0, NO_MOD,      0, 0, 0,                       (X16 | X32), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "pop",    1,  { R32,              }, GP4,  (F_OPCODE_REG),									              NO_VEX, NO_EVEX, 1, 1, { 0x58, 0x00, 0x00 }, 4,  0, NO_MOD,      0, 0, 0,                       (X16 | X32), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "pop",    1,  { R_SEG,            }, GP4,  (F_OPCODE_REG),							                  NO_VEX, NO_EVEX, 1, 1, { 0x07, 0x00, 0x00 }, 1,  0, NO_MOD,      0, 0, 0,                       (X16 | X32), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "pop",    1,  { M32,              }, GP4,   ALLOW_SEG,                                    NO_VEX, NO_EVEX, 1, 1, { 0x8f, 0x00, 0x00 }, 8,  0, 0x00, 0, 0, ADDR_SIZE_OVERRIDE,             (X16 | X32), RM_DST,   NO_PREFIX,  NO_IMM,      MEM_OPND_0, P_86,  0, NULL },
{ "pop",    1,  { M_ANY,            }, GP4,   ALLOW_SEG,                                    NO_VEX, NO_EVEX, 1, 1, { 0x8f, 0x00, 0x00 }, 8,  0, 0x00, 0, 0, ADDR_SIZE_OVERRIDE,             (X16 | X32), RM_DST,   NO_PREFIX,  NO_IMM,      MEM_OPND_0, P_86,  0, NULL },
{ "pop",    1,  { R_SEGE,           }, GP3,  (F_OPCODE_REG),							                  NO_VEX, NO_EVEX, 1, 1, { 0x81, 0x00, 0x00 }, 1,  0, NO_MOD,      0, 0, 0,                             (X64), REG_DST,  PFX_0xF,    NO_IMM,      NO_MEM,     P_64,  0, NULL },
{ "pop",    1,  { R16_AX,           }, GP0,  (F_OPCODE_REG),									              NO_VEX, NO_EVEX, 1, 1, { 0x58, 0x00, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,  (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "pop",    1,  { R16,              }, GP0,  (F_OPCODE_REG),									              NO_VEX, NO_EVEX, 1, 1, { 0x58, 0x00, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,  (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "pop",    1,  { R16E,             }, GP3,  (REX | REXB) | (F_OPCODE_REG),								  NO_VEX, NO_EVEX, 1, 1, { 0x58, 0x00, 0x00 }, 2,  0, NO_MOD,      0, OP_SIZE_OVERRIDE, 0,  (X16 | X32 | X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_86,  0, NULL },
{ "pop",    1,  { M16,              }, GP0,   ALLOW_SEG,                                    NO_VEX, NO_EVEX, 1, 1, { 0x8f, 0x00, 0x00 }, 2,  0, 0x00,        0, OP_SIZE_OVERRIDE, 0,  (X16 | X32 | X64), RM_DST,   NO_PREFIX,  NO_IMM,      MEM_OPND_0, P_486, 0, NULL },
{ "pop",    1,  { R64_RAX,          }, GP0,  (F_OPCODE_REG),		                            NO_VEX, NO_EVEX, 1, 1, { 0x58, 0x00, 0x00 }, 8,  0, NO_MOD,      0, 0, 0,                             (X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_64,  0, NULL },
{ "pop",    1,  { R64,              }, GP0,  (F_OPCODE_REG),		                            NO_VEX, NO_EVEX, 1, 1, { 0x58, 0x00, 0x00 }, 8,  0, NO_MOD,      0, 0, 0,                             (X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_64,  0, NULL },
{ "pop",    1,  { R64E,             }, GP3,  (REX | REXB) | (F_OPCODE_REG),		              NO_VEX, NO_EVEX, 1, 1, { 0x58, 0x00, 0x00 }, 8,  0, NO_MOD,      0, 0, 0,                             (X64), REG_DST,  NO_PREFIX,  NO_IMM,      NO_MEM,     P_64,  0, NULL },
{ "pop",    1,  { M64,              }, GP3,   ALLOW_SEG,                                    NO_VEX, NO_EVEX, 1, 1, { 0x8f, 0x00, 0x00 }, 8,  0, 0x00,        0, 0, ADDR_SIZE_OVERRIDE,            (X64), RM_DST,   NO_PREFIX,  NO_IMM,      MEM_OPND_0, P_64,  0, NULL },
{ "pop",    1,  { M_ANY,            }, GP3,   ALLOW_SEG,                                    NO_VEX, NO_EVEX, 1, 1, { 0x8f, 0x00, 0x00 }, 8,  0, 0x00,        0, 0, ADDR_SIZE_OVERRIDE,            (X64), RM_DST,   NO_PREFIX,  NO_IMM,      MEM_OPND_0, P_64,  0, NULL },
{ "popfq",  0,  { OP_N,   OP_N      }, GP3, (REX | REXW) | ALLOW_REP,                       NO_VEX, NO_EVEX, 8, 1, { 0x9d, 0x00, 0x00 }, 1, 0, NO_MOD, 0, 0, 0,                                       (X64),       NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_64, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//SCAS m8  ZO Valid Valid   AE          
//SCAS m16 ZO Valid Valid   AF          
//SCAS m32 ZO Valid Valid   AF          
//SCAS m64 ZO Valid N.E.    REX.W + AF  
//SCASB    ZO Valid Valid   AE          
//SCASW    ZO Valid Valid   AF          
//SCASD    ZO Valid Valid   AF          
//SCASQ    ZO Valid N.E.    REX.W + AF  
/* ----------------------------------------------------------------------------------------------- */
{ "scas",  1,  { M8,     OP_N }, GP1, (NO_FLAGS) | ALLOW_REP,                     NO_VEX, NO_EVEX, 1, 1, { 0xae, 0x00, 0x00 }, 1, 0, NO_MOD, 0, 0, 0,                                 (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "scas",  1,  { M16,    OP_N }, GP2, (NO_FLAGS) | ALLOW_REP,                     NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 2, 0, NO_MOD, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "scas",  1,  { M32,    OP_N }, GP2, (NO_FLAGS) | ALLOW_REP,                     NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 4, 0, NO_MOD, 0, 0, ADDR_SIZE_OVERRIDE,                (X32 | X64),       NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "scas",  1,  { M64,    OP_N }, GP3, (REX | REXW) | ALLOW_REP,                   NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 8, 0, NO_MOD, 0, 0, 0,                                       (X64),       NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_64, 0, NULL },
{ "scasb", 0,  { OP_N,   OP_N }, GP1, (NO_FLAGS) | ALLOW_REP,                     NO_VEX, NO_EVEX, 1, 1, { 0xae, 0x00, 0x00 }, 1, 0, NO_MOD, 0, 0, 0,                                 (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "scasw", 0,  { OP_N,   OP_N }, GP2, (NO_FLAGS) | ALLOW_REP,                     NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 2, 0, NO_MOD, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "scasd", 0,  { OP_N,   OP_N }, GP2, (NO_FLAGS) | ALLOW_REP,                     NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 4, 0, NO_MOD, 0, 0, ADDR_SIZE_OVERRIDE,                (X32 | X64),       NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "scasq", 0,  { OP_N,   OP_N }, GP3, (REX | REXW) | ALLOW_REP,                   NO_VEX, NO_EVEX, 1, 1, { 0xaf, 0x00, 0x00 }, 8, 0, NO_MOD, 0, 0, 0,                                       (X64),       NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_64, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//STOS m8  NA Valid Valid   AA          
//STOS m16 NA Valid Valid   AB          
//STOS m32 NA Valid Valid   AB          
//STOS m64 NA Valid N.E.    REX.W + AB  
//STOSB    NA Valid Valid   AA          
//STOSW    NA Valid Valid   AB          
//STOSD    NA Valid Valid   AB          
//STOSQ    NA Valid N.E.    REX.W + AB  
/* ----------------------------------------------------------------------------------------------- */
{ "stos",  1,  { M8,     OP_N }, GP1, (NO_FLAGS) | ALLOW_REP,                     NO_VEX, NO_EVEX, 1, 1, { 0xaa, 0x00, 0x00 }, 1, 0, NO_MOD, 0, 0, 0,                                 (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "stos",  1,  { M16,    OP_N }, GP2, (NO_FLAGS) | ALLOW_REP,                     NO_VEX, NO_EVEX, 1, 1, { 0xab, 0x00, 0x00 }, 2, 0, NO_MOD, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "stos",  1,  { M32,    OP_N }, GP2, (NO_FLAGS) | ALLOW_REP,                     NO_VEX, NO_EVEX, 1, 1, { 0xab, 0x00, 0x00 }, 4, 0, NO_MOD, 0, 0, ADDR_SIZE_OVERRIDE,                (X32 | X64),       NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "stos",  1,  { M64,    OP_N }, GP3, (REX | REXW) | ALLOW_REP,                   NO_VEX, NO_EVEX, 1, 1, { 0xab, 0x00, 0x00 }, 8, 0, NO_MOD, 0, 0, 0,                                       (X64),       NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_64, 0, NULL },
{ "stosb", 0,  { OP_N,   OP_N }, GP1, (NO_FLAGS) | ALLOW_REP,                     NO_VEX, NO_EVEX, 1, 1, { 0xaa, 0x00, 0x00 }, 1, 0, NO_MOD, 0, 0, 0,                                 (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "stosw", 0,  { OP_N,   OP_N }, GP2, (NO_FLAGS) | ALLOW_REP,                     NO_VEX, NO_EVEX, 1, 1, { 0xab, 0x00, 0x00 }, 2, 0, NO_MOD, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "stosd", 0,  { OP_N,   OP_N }, GP2, (NO_FLAGS) | ALLOW_REP,                     NO_VEX, NO_EVEX, 1, 1, { 0xab, 0x00, 0x00 }, 4, 0, NO_MOD, 0, 0, ADDR_SIZE_OVERRIDE,                (X32 | X64),       NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "stosq", 0,  { OP_N,   OP_N }, GP3, (REX | REXW) | ALLOW_REP,                   NO_VEX, NO_EVEX, 1, 1, { 0xab, 0x00, 0x00 }, 8, 0, NO_MOD, 0, 0, 0,                                       (X64),       NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_64, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//LODS m8  ZO Valid Valid  AC          
//LODS m16 ZO Valid Valid  AD          
//LODS m32 ZO Valid Valid  AD          
//LODS m64 ZO Valid N.E.   REX.W + AD  
//LODSB    ZO Valid Valid  AC          
//LODSW    ZO Valid Valid  AD          
//LODSD    ZO Valid Valid  AD          
//LODSQ    ZO Valid N.E.   REX.W + AD  
/* ----------------------------------------------------------------------------------------------- */
{ "lods",  1,  { M8,     OP_N }, GP1, (NO_FLAGS) | ALLOW_REP,                     NO_VEX, NO_EVEX, 1, 1, { 0xac, 0x00, 0x00 }, 1, 0, NO_MOD, 0, 0, 0,                                 (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "lods",  1,  { M16,    OP_N }, GP2, (NO_FLAGS) | ALLOW_REP,                     NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 2, 0, NO_MOD, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "lods",  1,  { M32,    OP_N }, GP2, (NO_FLAGS) | ALLOW_REP,                     NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 4, 0, NO_MOD, 0, 0, ADDR_SIZE_OVERRIDE,                (X32 | X64),       NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "lods",  1,  { M64,    OP_N }, GP3, (REX | REXW) | ALLOW_REP,                   NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 8, 0, NO_MOD, 0, 0, 0,                                       (X64),       NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_64, 0, NULL },
{ "lodsb", 0,  { OP_N,   OP_N }, GP1, (NO_FLAGS) | ALLOW_REP,                     NO_VEX, NO_EVEX, 1, 1, { 0xac, 0x00, 0x00 }, 1, 0, NO_MOD, 0, 0, 0,                                 (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "lodsw", 0,  { OP_N,   OP_N }, GP2, (NO_FLAGS) | ALLOW_REP,                     NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 2, 0, NO_MOD, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "lodsd", 0,  { OP_N,   OP_N }, GP2, (NO_FLAGS) | ALLOW_REP,                     NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 4, 0, NO_MOD, 0, 0, ADDR_SIZE_OVERRIDE,                (X32 | X64),       NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "lodsq", 0,  { OP_N,   OP_N }, GP3, (REX | REXW) | ALLOW_REP,                   NO_VEX, NO_EVEX, 1, 1, { 0xad, 0x00, 0x00 }, 8, 0, NO_MOD, 0, 0, 0,                                       (X64),       NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_64, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//LOOP rel8   D Valid Valid  E2 cb 
//LOOPE rel8  D Valid Valid  E1 cb 
//LOOPNE rel8 D Valid Valid  E0 cb 
/* ----------------------------------------------------------------------------------------------- */
{ "loop",       1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0xe2, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "loope",      1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0xe1, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "loopz",      1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0xe1, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "loopne",     1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0xe0, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "loopnz",     1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0xe0, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                  (X16 | X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "loopd",      1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0xe2, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32),       NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "looped",     1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0xe1, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32),       NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "loopzd",     1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0xe1, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32),       NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "loopned",    1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0xe0, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32),       NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "loopnzd",    1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0xe0, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32),       NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_386, 0, NULL },
{ "loopw",      1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0xe2, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32),       NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "loopew",     1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0xe1, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32),       NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "loopzw",     1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0xe1, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32),       NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "loopnew",    1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0xe0, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32),       NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "loopnzw",    1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0xe0, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32),       NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jcxz",       1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0xe3, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, ADDR_SIZE_OVERRIDE,       (X16 | X32), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jecxz",      1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0xe3, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, ADDR_SIZE_OVERRIDE,       (X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_86,  0, NULL },
{ "jrcxz",      1, { IMM8,        }, GP0, 0,		                                                                  NO_VEX, NO_EVEX, 1, 1, { 0xe3, 0x00, 0x00 }, 1, 0, MOD_REG_IMM, 0, 0, 0,                        (X32 | X64), NO_DST,  NO_PREFIX, IMM_OPND_0, NO_MEM, P_64,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//ARPL r/m16, r16  63 /r  ZO N. E. Valid
/* ----------------------------------------------------------------------------------------------- */
{ "arpl",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                  NO_VEX, NO_EVEX, 1, 1, { 0x63, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "arpl",    2, { R16_AX,   R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                  NO_VEX, NO_EVEX, 1, 1, { 0x63, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "arpl",    2, { R16,      R16_AX  }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                  NO_VEX, NO_EVEX, 1, 1, { 0x63, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "arpl",    2, { M_ANY,    R16     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0x63, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32), RM_DST,   NO_PREFIX, NO_IMM,     MEM_OPND_0, P_86,  0, NULL },
{ "arpl",    2, { M_ANY,    R16_AX  }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0x63, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32), RM_DST,   NO_PREFIX, NO_IMM,     MEM_OPND_0, P_86,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
{ "lldt",    1, { R16_AX,           }, GP0,  (F_OPCODE2_REG),									             NO_VEX, NO_EVEX, 1, 2, { 0x00, 0xd0, 0x00 }, 2,  0, NO_MOD,      0, 0, 0,  (X16 | X32), REG_DST,  PFX_0xF,  NO_IMM,      NO_MEM,     P_86, 0, NULL },
{ "lldt",    1, { R16,              }, GP0,  (F_OPCODE2_REG),									             NO_VEX, NO_EVEX, 1, 2, { 0x00, 0xd0, 0x00 }, 2,  0, NO_MOD,      0, 0, 0,  (X16 | X32), REG_DST,  PFX_0xF,  NO_IMM,      NO_MEM,     P_86, 0, NULL },
{ "lldt",    1, { M_ANY,            }, GP0,   ALLOW_SEG,                                   NO_VEX, NO_EVEX, 1, 1, { 0x00, 0x00, 0x00 }, 2,  0, 0x10,        0, 0, 0,  (X16 | X32), RM_DST,   PFX_0xF,  NO_IMM,      MEM_OPND_0, P_86, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
{ "lmsw",    1, { R16_AX,           }, GP0,  (F_OPCODE2_REG),									             NO_VEX, NO_EVEX, 1, 2, { 0x01, 0xf0, 0x00 }, 2,  0, NO_MOD,      0, 0, 0,  (X16 | X32), REG_DST,  PFX_0xF,  NO_IMM,      NO_MEM,     P_86, 0, NULL },
{ "lmsw",    1, { R16,              }, GP0,  (F_OPCODE2_REG),									             NO_VEX, NO_EVEX, 1, 2, { 0x01, 0xf0, 0x00 }, 2,  0, NO_MOD,      0, 0, 0,  (X16 | X32), REG_DST,  PFX_0xF,  NO_IMM,      NO_MEM,     P_86, 0, NULL },
{ "lmsw",    1, { M_ANY,            }, GP0,   ALLOW_SEG,                                   NO_VEX, NO_EVEX, 1, 1, { 0x01, 0x00, 0x00 }, 2,  0, 0x30,        0, 0, 0,  (X16 | X32), RM_DST,   PFX_0xF,  NO_IMM,      MEM_OPND_0, P_86, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
{ "ltr",    1, { R16_AX,           }, GP0,  (F_OPCODE2_REG),									             NO_VEX, NO_EVEX, 1, 2, { 0x00, 0xd8, 0x00 }, 2,  0, NO_MOD,      0, 0, 0,  (X16 | X32), REG_DST,  PFX_0xF,  NO_IMM,      NO_MEM,     P_86, 0, NULL },
{ "ltr",    1, { R16,              }, GP0,  (F_OPCODE2_REG),									             NO_VEX, NO_EVEX, 1, 2, { 0x00, 0xd8, 0x00 }, 2,  0, NO_MOD,      0, 0, 0,  (X16 | X32), REG_DST,  PFX_0xF,  NO_IMM,      NO_MEM,     P_86, 0, NULL },
{ "ltr",    1, { M_ANY,            }, GP0,   ALLOW_SEG,                                    NO_VEX, NO_EVEX, 1, 1, { 0x00, 0x00, 0x00 }, 2,  0, 0x18,        0, 0, 0,  (X16 | X32), RM_DST,   PFX_0xF,  NO_IMM,      MEM_OPND_0, P_86, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
{ "sldt",    1, { R16_AX,           }, GP0,  (F_OPCODE2_REG),									             NO_VEX, NO_EVEX, 1, 2, { 0x00, 0xc0, 0x00 }, 2,  0, NO_MOD,      0, 0, 0,  (X16 | X32), REG_DST,  PFX_0xF,  NO_IMM,      NO_MEM,     P_86, 0, NULL },
{ "sldt",    1, { R16,              }, GP0,  (F_OPCODE2_REG),									             NO_VEX, NO_EVEX, 1, 2, { 0x00, 0xc0, 0x00 }, 2,  0, NO_MOD,      0, 0, 0,  (X16 | X32), REG_DST,  PFX_0xF,  NO_IMM,      NO_MEM,     P_86, 0, NULL },
{ "sldt",    1, { M_ANY,            }, GP0,   ALLOW_SEG,                                   NO_VEX, NO_EVEX, 1, 1, { 0x00, 0x00, 0x00 }, 2,  0, 0x00,        0, 0, 0,  (X16 | X32), RM_DST,   PFX_0xF,  NO_IMM,      MEM_OPND_0, P_86, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
{ "smsw",    1, { R16_AX,           }, GP0,  (F_OPCODE2_REG),									             NO_VEX, NO_EVEX, 1, 2, { 0x01, 0xe0, 0x00 }, 2,  0, NO_MOD,      0, 0, 0,  (X16 | X32), REG_DST,  PFX_0xF,  NO_IMM,      NO_MEM,     P_86, 0, NULL },
{ "smsw",    1, { R16,              }, GP0,  (F_OPCODE2_REG),									             NO_VEX, NO_EVEX, 1, 2, { 0x01, 0xe0, 0x00 }, 2,  0, NO_MOD,      0, 0, 0,  (X16 | X32), REG_DST,  PFX_0xF,  NO_IMM,      NO_MEM,     P_86, 0, NULL },
{ "smsw",    1, { M_ANY,            }, GP0,   ALLOW_SEG,                                   NO_VEX, NO_EVEX, 1, 1, { 0x01, 0x00, 0x00 }, 2,  0, 0x20,        0, 0, 0,  (X16 | X32), RM_DST,   PFX_0xF,  NO_IMM,      MEM_OPND_0, P_86, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
{ "str",    1, { R16_AX,           }, GP0,  (F_OPCODE2_REG),									             NO_VEX, NO_EVEX, 1, 2, { 0x00, 0xc8, 0x00 }, 2,  0, NO_MOD,      0, 0, 0,  (X16 | X32), REG_DST,  PFX_0xF,  NO_IMM,      NO_MEM,     P_86, 0, NULL },
{ "str",    1, { R16,              }, GP0,  (F_OPCODE2_REG),									             NO_VEX, NO_EVEX, 1, 2, { 0x00, 0xc8, 0x00 }, 2,  0, NO_MOD,      0, 0, 0,  (X16 | X32), REG_DST,  PFX_0xF,  NO_IMM,      NO_MEM,     P_86, 0, NULL },
{ "str",    1, { M_ANY,            }, GP0,   ALLOW_SEG,                                    NO_VEX, NO_EVEX, 1, 1, { 0x00, 0x00, 0x00 }, 2,  0, 0x08,        0, 0, 0,  (X16 | X32), RM_DST,   PFX_0xF,  NO_IMM,      MEM_OPND_0, P_86, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
{ "verr",    1, { R16_AX,           }, GP0,  (F_OPCODE2_REG),									             NO_VEX, NO_EVEX, 1, 2, { 0x00, 0xe0, 0x00 }, 2,  0, NO_MOD,      0, 0, 0,  (X16 | X32), REG_DST,  PFX_0xF,  NO_IMM,      NO_MEM,     P_86, 0, NULL },
{ "verr",    1, { R16,              }, GP0,  (F_OPCODE2_REG),									             NO_VEX, NO_EVEX, 1, 2, { 0x00, 0xe0, 0x00 }, 2,  0, NO_MOD,      0, 0, 0,  (X16 | X32), REG_DST,  PFX_0xF,  NO_IMM,      NO_MEM,     P_86, 0, NULL },
{ "verr",    1, { M_ANY,            }, GP0,   ALLOW_SEG,                                   NO_VEX, NO_EVEX, 1, 1, { 0x00, 0x00, 0x00 }, 2,  0, 0x20,        0, 0, 0,  (X16 | X32), RM_DST,   PFX_0xF,  NO_IMM,      MEM_OPND_0, P_86, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
{ "verw",    1, { R16_AX,           }, GP0,  (F_OPCODE2_REG),									             NO_VEX, NO_EVEX, 1, 2, { 0x00, 0xe8, 0x00 }, 2,  0, NO_MOD,      0, 0, 0,  (X16 | X32), REG_DST,  PFX_0xF,  NO_IMM,      NO_MEM,     P_86, 0, NULL },
{ "verw",    1, { R16,              }, GP0,  (F_OPCODE2_REG),									             NO_VEX, NO_EVEX, 1, 2, { 0x00, 0xe8, 0x00 }, 2,  0, NO_MOD,      0, 0, 0,  (X16 | X32), REG_DST,  PFX_0xF,  NO_IMM,      NO_MEM,     P_86, 0, NULL },
{ "verw",    1, { M_ANY,            }, GP0,   ALLOW_SEG,                                   NO_VEX, NO_EVEX, 1, 1, { 0x00, 0x00, 0x00 }, 2,  0, 0x28,        0, 0, 0,  (X16 | X32), RM_DST,   PFX_0xF,  NO_IMM,      MEM_OPND_0, P_86, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//MOVBE r16, m16 RM Valid Valid    0F 38 F0 / r          
//MOVBE r32, m32 RM Valid Valid    0F 38 F0 / r          
//MOVBE r64, m64 RM Valid N.E.     REX.W + 0F 38 F0 / r  
//MOVBE m16, r16 MR Valid Valid    0F 38 F1 / r          
//MOVBE m32, r32 MR Valid Valid    0F 38 F1 / r          
//MOVBE m64, r64 MR Valid N.E.     REX.W + 0F 38 F1 / r  
/* ----------------------------------------------------------------------------------------------- */
{ "movbe",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),	                              NO_VEX, NO_EVEX, 1, 3, { 0x0f, 0x38, 0xf0 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1, P_86,  0, NULL },
{ "movbe",    2, { R16E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 1, 3, { 0x0f, 0x38, 0xf0 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1, P_64,  0, NULL },
{ "movbe",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 3, { 0x0f, 0x38, 0xf0 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1, P_86,  0, NULL },
{ "movbe",    2, { R32E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 1, 3, { 0x0f, 0x38, 0xf0 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1, P_64,  0, NULL },
{ "movbe",    2, { R64,      M_ANY   }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 3, { 0x0f, 0x38, 0xf0 }, 8, 0, MOD_REG_MEM, 0, 0,				ADDR_SIZE_OVERRIDE,           (X16 | X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1, P_64,  0, NULL },
{ "movbe",    2, { R64E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	        NO_VEX, NO_EVEX, 1, 3, { 0x0f, 0x38, 0xf0 }, 8, 0, MOD_REG_MEM, 0, 0,				ADDR_SIZE_OVERRIDE,                       (X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1, P_64,  0, NULL },
{ "movbe",    2, { M_ANY,    R16     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 3, { 0x0f, 0x38, 0xf1 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "movbe",    2, { M_ANY,    R16E    }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 1, 3, { 0x0f, 0x38, 0xf1 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "movbe",    2, { M_ANY,    R32     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 3, { 0x0f, 0x38, 0xf1 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_86,  0, NULL },
{ "movbe",    2, { M_ANY,    R32E    }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 1, 3, { 0x0f, 0x38, 0xf1 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "movbe",    2, { M_ANY,    R64     }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),			          NO_VEX, NO_EVEX, 1, 3, { 0x0f, 0x38, 0xf1 }, 8, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE,                       (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
{ "movbe",    2, { M_ANY,    R64E    }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	        NO_VEX, NO_EVEX, 1, 3, { 0x0f, 0x38, 0xf1 }, 8, 0, MOD_MEM_REG, 0, 0,				ADDR_SIZE_OVERRIDE,                       (X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//LAR r16, r16 / m16   RM Valid Valid   0F 02 / r
//LAR reg, r32 / m16   RM Valid Valid   0F 02 / r
/* ----------------------------------------------------------------------------------------------- */
{ "lar",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x02, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "lar",    2, { R16E,     R16E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		    NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x02, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "lar",    2, { R16E,     R16     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x02, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "lar",    2, { R16,      R16E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x02, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "lar",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 2, 2, { 0x0f, 0x02, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "lar",    2, { R32E,     R32E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		    NO_VEX, NO_EVEX, 2, 2, { 0x0f, 0x02, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "lar",    2, { R32E,     R32     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 2, 2, { 0x0f, 0x02, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "lar",    2, { R32,      R32E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 2, 2, { 0x0f, 0x02, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "lar",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		            NO_VEX, NO_EVEX, 4, 2, { 0x0f, 0x02, 0x00 }, 2, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "lar",    2, { R64E,     R64E    }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM), NO_VEX, NO_EVEX, 4, 2, { 0x0f, 0x02, 0x00 }, 2, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "lar",    2, { R64,      R64E    }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		    NO_VEX, NO_EVEX, 4, 2, { 0x0f, 0x02, 0x00 }, 2, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "lar",    2, { R64E,     R64     }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		    NO_VEX, NO_EVEX, 4, 2, { 0x0f, 0x02, 0x00 }, 2, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "lar",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),	                              NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x02, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "lar",    2, { R16E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x02, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "lar",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 2, 2, { 0x0f, 0x02, 0x00 }, 2, 0, MOD_REG_MEM, 0, 0,	                ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "lar",    2, { R32E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 2, 2, { 0x0f, 0x02, 0x00 }, 2, 0, MOD_REG_MEM, 0, 0,	                ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "lar",    2, { R64,      M_ANY   }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 4, 2, { 0x0f, 0x02, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "lar",    2, { R64E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	        NO_VEX, NO_EVEX, 4, 2, { 0x0f, 0x02, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//LSL r16, r16 / m16 RM Valid Valid     0F 03 / r
//LSL r32, r32 / m16 * RM Valid Valid   0F 03 / r
//LSL r64, r32 / m16 * RM Valid Valid   REX.W + 0F 03 / r
/* ----------------------------------------------------------------------------------------------- */
{ "lsl",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x03, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "lsl",    2, { R16E,     R16E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		    NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x03, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "lsl",    2, { R16E,     R16     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x03, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "lsl",    2, { R16,      R16E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x03, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "lsl",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                NO_VEX, NO_EVEX, 2, 2, { 0x0f, 0x03, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "lsl",    2, { R32E,     R32E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		    NO_VEX, NO_EVEX, 2, 2, { 0x0f, 0x03, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "lsl",    2, { R32E,     R32     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 2, 2, { 0x0f, 0x03, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "lsl",    2, { R32,      R32E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 2, 2, { 0x0f, 0x03, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "lsl",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		            NO_VEX, NO_EVEX, 4, 2, { 0x0f, 0x03, 0x00 }, 2, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "lsl",    2, { R64E,     R64E    }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM), NO_VEX, NO_EVEX, 4, 2, { 0x0f, 0x03, 0x00 }, 2, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "lsl",    2, { R64,      R64E    }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		    NO_VEX, NO_EVEX, 4, 2, { 0x0f, 0x03, 0x00 }, 2, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "lsl",    2, { R64E,     R64     }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		    NO_VEX, NO_EVEX, 4, 2, { 0x0f, 0x03, 0x00 }, 2, 0, MOD_REG_REG, 0, 0,                0,                               (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "lsl",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),	                              NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x03, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "lsl",    2, { R16E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x03, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "lsl",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 2, 2, { 0x0f, 0x03, 0x00 }, 2, 0, MOD_REG_MEM, 0, 0,	                ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "lsl",    2, { R32E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 2, 2, { 0x0f, 0x03, 0x00 }, 2, 0, MOD_REG_MEM, 0, 0,	                ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "lsl",    2, { R64,      M_ANY   }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 4, 2, { 0x0f, 0x03, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "lsl",    2, { R64E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	        NO_VEX, NO_EVEX, 4, 2, { 0x0f, 0x03, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//LEA r16, m RM Valid Valid   8D / r          
//LEA r32, m RM Valid Valid   8D / r          
//LEA r64, m RM Valid N.E.    REX.W + 8D / r  
/* ----------------------------------------------------------------------------------------------- */
{ "lea",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),	                              NO_VEX, NO_EVEX, 1, 1, { 0x8d, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "lea",    2, { R16E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 1, 1, { 0x8d, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "lea",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 2, 1, { 0x8d, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, 0,	                ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "lea",    2, { R32E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 2, 1, { 0x8d, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, 0,	                ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "lea",    2, { R64,      M_ANY   }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 4, 1, { 0x8d, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "lea",    2, { R64E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	        NO_VEX, NO_EVEX, 4, 1, { 0x8d, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//LDS r16,m16:16 RM Invalid Valid     C5 /r           
//LDS r32,m16:32 RM Invalid Valid     C5 /r           
/* ----------------------------------------------------------------------------------------------- */
{ "lds",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),	                              NO_VEX, NO_EVEX, 1, 1, { 0xc5, 0x00, 0x00 }, 2,   0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "lds",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0xc5, 0x00, 0x00 }, 4,   0, MOD_REG_MEM, 0, 0,	                0, (X16 | X32), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//LES r16,m16:16 RM Invalid Valid     C4 /r           
//LES r32,m16:32 RM Invalid Valid     C4 /r           
/* ----------------------------------------------------------------------------------------------- */
{ "les",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),	                              NO_VEX, NO_EVEX, 1, 1, { 0xc4, 0x00, 0x00 }, 2,   0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "les",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 1, { 0xc4, 0x00, 0x00 }, 4,   0, MOD_REG_MEM, 0, 0,	                0, (X16 | X32), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//LFS r16,m16:16 RM Valid   Valid     0F B4 /r        
//LFS r32,m16:32 RM Valid   Valid     0F B4 /r        
//LFS r64,m16:64 RM Valid   N.E.      REX + 0F B4 /r  
/* ----------------------------------------------------------------------------------------------- */
{ "lfs",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),	                              NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0xb4, 0x00 }, 2,   0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "lfs",    2, { R16E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0xb4, 0x00 }, 2,   0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "lfs",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0xb4, 0x00 }, 4,   0, MOD_REG_MEM, 0, 0,	                ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "lfs",    2, { R32E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0xb4, 0x00 }, 4,   0, MOD_REG_MEM, 0, 0,	                ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "lfs",    2, { R64,      M_ANY   }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0xb4, 0x00 }, 8,   0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "lfs",    2, { R64E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	        NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0xb4, 0x00 }, 8,   0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//LGS r16,m16:16 RM Valid   Valid     0F B5 /r        
//LGS r32,m16:32 RM Valid   Valid     0F B5 /r        
//LGS r64,m16:64 RM Valid   N.E.      REX + 0F B5 /r  
/* ----------------------------------------------------------------------------------------------- */
{ "lgs",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),	                              NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0xb5, 0x00 }, 2,   0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "lgs",    2, { R16E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0xb5, 0x00 }, 2,   0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "lgs",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0xb5, 0x00 }, 4,   0, MOD_REG_MEM, 0, 0,	                ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "lgs",    2, { R32E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0xb5, 0x00 }, 4,   0, MOD_REG_MEM, 0, 0,	                ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "lgs",    2, { R64,      M_ANY   }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0xb5, 0x00 }, 8,   0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "lgs",    2, { R64E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	        NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0xb5, 0x00 }, 8,   0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//LSS r16,m16:16 RM Valid   Valid     0F B2 /r        
//LSS r32,m16:32 RM Valid   Valid     0F B2 /r        
//LSS r64,m16:64 RM Valid   N.E.      REX + 0F B2 /r  
/* ----------------------------------------------------------------------------------------------- */
{ "lss",    2, { R16,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),	                              NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0xb2, 0x00 }, 2,   0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "lss",    2, { R16E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0xb2, 0x00 }, 2,   0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "lss",    2, { R32,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                        NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0xb2, 0x00 }, 4,   0, MOD_REG_MEM, 0, 0,	                ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "lss",    2, { R32E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0xb2, 0x00 }, 4,   0, MOD_REG_MEM, 0, 0,	                ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "lss",    2, { R64,      M_ANY   }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				        NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0xb2, 0x00 }, 8,  0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "lss",    2, { R64E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	        NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0xb2, 0x00 }, 8,  0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//LGDT m16 & 32 M N.E.Valid    0F 01 / 2        Load m into GDTR.
//LIDT m16 & 32 M N.E.Valid    0F 01 / 3        Load m into IDTR.
//LGDT m16 & 64 M Valid N.E.   0F 01 / 2        Load m into GDTR.
//LIDT m16 & 64 M Valid N.E.   0F 01 / 3        Load m into IDTR.
/* ----------------------------------------------------------------------------------------------- */
{ "lgdt",    1, { M_ANY,          }, GP2, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),                         NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x01, 0x00 }, 2, 1, 0x14, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_86, 0, NULL },
{ "lgdt",    1, { M_ANY,          }, GP2, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),                         NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x01, 0x00 }, 4, 1, 0x14, 0, 0, 0,                                 (X16 | X32), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_86, 0, NULL },
{ "lidt",    1, { M_ANY,          }, GP2, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),                         NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x01, 0x00 }, 2, 1, 0x1c, 0, OP_SIZE_OVERRIDE, ADDR_SIZE_OVERRIDE, (X16 | X32), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_86, 0, NULL },
{ "lidt",    1, { M_ANY,          }, GP2, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),                         NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x01, 0x00 }, 4, 1, 0x1c, 0, 0, 0,                                 (X16 | X32), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_86, 0, NULL },
{ "lgdt",    1, { M_ANY,          }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM | OPCODE_EXT),          NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x01, 0x00 }, 8, 1, 0x14, 0, 0, 0,                                       (X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_64, 0, NULL },
{ "lidt",    1, { M_ANY,          }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_RM | OPCODE_EXT),          NO_VEX, NO_EVEX, 1, 2, { 0x0f, 0x01, 0x00 }, 8, 1, 0x1c, 0, 0, 0,                                       (X64), RM_DST, NO_PREFIX, NO_IMM, MEM_OPND_0, P_64, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//MOVS m8, m8    A4
//MOVS m16, m16  A5
//MOVS m32, m32  A5
//MOVS m64, m64 REX.W + A5 
/* ----------------------------------------------------------------------------------------------- */
{ "movs", 2, { M8,    M8       }, GP0,  ALLOW_REP,													                                            NO_VEX, NO_EVEX,  1, 1, { 0xa4, 0x00, 0x00 }, 1,  2, NO_MOD,      0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_0,     P_386,           0, NULL },
{ "movs", 2, { M16,   M16      }, GP2,  ALLOW_REP,													                                            NO_VEX, NO_EVEX,  1, 1, { 0xa5, 0x00, 0x00 }, 2,  2, NO_MOD,      0, OP_SIZE_OVERRIDE,   0, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_0,     P_386,           0, NULL },
{ "movs", 2, { M32,   M32      }, GP2,  ALLOW_REP,													                                            NO_VEX, NO_EVEX,  1, 1, { 0xa5, 0x00, 0x00 }, 4,  2, NO_MOD,      0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_0,     P_386,           0, NULL },
{ "movs", 2, { M64,   M64      }, GP3,  (REX | REXW) | ALLOW_REP,													                              NO_VEX, NO_EVEX,  1, 1, { 0xa5, 0x00, 0x00 }, 8,  2, NO_MOD,      0, 0,                  0,             (X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_0,     P_64,            0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//MOVSB          A4   
/* ----------------------------------------------------------------------------------------------- */
{ "movsb", 0, { OP_N,     OP_N        }, GP1,  ALLOW_REP,													                                      NO_VEX, NO_EVEX,  1, 1, { 0xa4, 0x00, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "movsb", 2, { M_ANY,    M_ANY       }, GP2,  ALLOW_REP,													                                      NO_VEX, NO_EVEX,  1, 1, { 0xa4, 0x00, 0x00 }, 1,  2, NO_MOD,      0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_0,     P_386,           0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//MOVSW          A5 
{ "movsw", 0, { OP_N,     OP_N        }, GP1,  ALLOW_REP,													                                      NO_VEX, NO_EVEX,  1, 1, { 0xa5, 0x00, 0x00 }, 2,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "movsw", 2, { M_ANY,    M_ANY       }, GP2,  ALLOW_REP,													                                      NO_VEX, NO_EVEX,  1, 1, { 0xa5, 0x00, 0x00 }, 2,  2, NO_MOD,      0, OP_SIZE_OVERRIDE, 0, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_0,     P_386,           0, NULL },
/* ----------------------------------------------------------------------------------------------- */
  //MOVSD xmm1, xmm2        F2 0F 10 / r
  //MOVSD xmm1, m64         F2 0F 10 / r
  //MOVSD xmm1 / m64, xmm2  F2 0F 11 / r
/* ----------------------------------------------------------------------------------------------- */
{ "movsd", 0, { OP_N,     OP_N        }, GP1,  ALLOW_REP,													                                      NO_VEX, NO_EVEX,  1, 1, { 0xa5, 0x00, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "movsd", 2, { M_ANY,    M_ANY       }, GP2,  ALLOW_REP,													                                      NO_VEX, NO_EVEX,  1, 1, { 0xa5, 0x00, 0x00 }, 4,  2, NO_MOD,      0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_0,     P_386,           0, NULL },
{ "movsd", 2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                          NO_VEX, NO_EVEX,  1, 1, { 0x10, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F, NO_IMM,     NO_MEM,     P_686 | P_SSE2, 0, NULL },
{ "movsd", 2, { M_ANY,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),	                                      NO_VEX, NO_EVEX,  2, 1, { 0x11, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), RM_DST,  PFX_0xF20F, NO_IMM,     MEM_OPND_0, P_686 | P_SSE2, 0, NULL },
{ "movsd", 2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),	                                      NO_VEX, NO_EVEX,  2, 1, { 0x10, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F, NO_IMM,     MEM_OPND_1, P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//MOVSQ REX.W +  A5 
/* ----------------------------------------------------------------------------------------------- */
{ "movsq", 0, { OP_N,     OP_N       }, GP3,  (REX | REXW) | ALLOW_REP,													                        NO_VEX, NO_EVEX,  1, 1, { 0xa5, 0x00, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X64), NO_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,         P_64,           0, NULL },
{ "movsq", 2, { M_ANY,    M_ANY      }, GP3,  (REX | REXW) | ALLOW_REP,													                        NO_VEX, NO_EVEX,  1, 1, { 0xa5, 0x00, 0x00 }, 8,  2, NO_MOD,      0, 0, 0, (X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_0,     P_64,           0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//MOVSX   r16, r / m8   RM Valid Valid 0F BE / r            
//MOVSX   r32, r / m8   RM Valid Valid 0F BE / r         
//MOVSX   r64, r / m8   RM Valid N.E.  REX.W + 0F BE / r 
//MOVSX   r32, r / m16  RM Valid Valid 0F BF / r           REX  = 40
//MOVSX   r64, r / m16  RM Valid N.E.  REX.W + 0F BF / r   REXB =  1
//MOVSXD  r16, r / m16  RM Valid Valid 63 / r *            REXX =  2
//MOVSXD  r32, r / m32  RM Valid Valid 63 / r *            REXR =  4
//MOVSXD  r64, r / m32  RM Valid N.E.  REX.W + 63 / r      REXW =  8
/* ----------------------------------------------------------------------------------------------- */
{ "movsx",     2, { R16,      R8_AL   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 2, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movsx",     2, { R16,      R8_CL   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 2, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movsx",     2, { R16,      R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 2, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movsx",     2, { R16_AX,   R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 2, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movsx",     2, { R16_AX,   R8_CL   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 2, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movsx",     2, { R16_AX,   R8U     }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				                      NO_VEX, NO_EVEX, 2, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movsx",     2, { R16,      R8U     }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				                      NO_VEX, NO_EVEX, 2, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movsx",     2, { R16_AX,   R8E     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				              NO_VEX, NO_EVEX, 2, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movsx",     2, { R16E,     R8      }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                      NO_VEX, NO_EVEX, 2, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movsx",     2, { R16E,     R8U     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                      NO_VEX, NO_EVEX, 2, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movsx",     2, { R16E,     R8E     }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),               NO_VEX, NO_EVEX, 2, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movsx",     2, { R32,      R8_AL   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 4, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movsx",     2, { R32,      R8_CL   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 4, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movsx",     2, { R32,      R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 4, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movsx",     2, { R32_EAX,  R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 4, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movsx",     2, { R32_EAX,  R8_CL   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 4, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movsx",     2, { R32_EAX,  R8U     }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				                      NO_VEX, NO_EVEX, 4, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movsx",     2, { R32,      R8U     }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				                      NO_VEX, NO_EVEX, 4, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movsx",     2, { R32_EAX,  R8E     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				              NO_VEX, NO_EVEX, 4, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movsx",     2, { R32E,     R8      }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                      NO_VEX, NO_EVEX, 4, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movsx",     2, { R32E,     R8U     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                      NO_VEX, NO_EVEX, 4, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movsx",     2, { R32E,     R8E     }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),               NO_VEX, NO_EVEX, 4, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movsx",     2, { R64,      R8_AL   }, GP0, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),							        NO_VEX, NO_EVEX, 8, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movsx",     2, { R64,      R8_CL   }, GP0, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),							        NO_VEX, NO_EVEX, 8, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movsx",     2, { R64,      R8      }, GP0, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),							        NO_VEX, NO_EVEX, 8, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movsx",     2, { R64_RAX,  R8      }, GP0, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),							        NO_VEX, NO_EVEX, 8, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movsx",     2, { R64_RAX,  R8_CL   }, GP0, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),							        NO_VEX, NO_EVEX, 8, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movsx",     2, { R64_RAX,  R8U     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				              NO_VEX, NO_EVEX, 8, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movsx",     2, { R64,      R8U     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				              NO_VEX, NO_EVEX, 8, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movsx",     2, { R64_RAX,  R8E     }, GP3, (REX | REXW | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 8, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movsx",     2, { R64E,     R8      }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                      NO_VEX, NO_EVEX, 8, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movsx",     2, { R64E,     R8U     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                      NO_VEX, NO_EVEX, 8, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movsx",     2, { R64E,     R8E     }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),               NO_VEX, NO_EVEX, 8, 1, { 0xbe, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movsx",     2, { R16,      M8      }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 2, 1, { 0xbe, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, 0, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "movsx",     2, { R16_AX,   M8      }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 2, 1, { 0xbe, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, 0, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "movsx",     2, { R16E,     M8      }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                      NO_VEX, NO_EVEX, 2, 1, { 0xbe, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  PFX_0xF, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "movsx",     2, { R32,      M8      }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 4, 1, { 0xbe, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "movsx",     2, { R32_EAX,  M8      }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 4, 1, { 0xbe, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "movsx",     2, { R32E,     M8      }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                      NO_VEX, NO_EVEX, 4, 1, { 0xbe, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  PFX_0xF, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "movsx",     2, { R64,      M8      }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				                NO_VEX, NO_EVEX, 8, 1, { 0xbe, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "movsx",     2, { R64_RAX,  M8      }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				                NO_VEX, NO_EVEX, 8, 1, { 0xbe, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "movsx",     2, { R64E,     M8      }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 8, 1, { 0xbe, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  PFX_0xF, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
{ "movsx",     2, { R32,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 1, 1, { 0xbf, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, 0, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movsx",     2, { R32_EAX,  R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 1, 1, { 0xbf, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, 0, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movsx",     2, { R32_EAX,  R16E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				              NO_VEX, NO_EVEX, 1, 1, { 0xbf, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, 0, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movsx",     2, { R32E,     R16     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                      NO_VEX, NO_EVEX, 1, 1, { 0xbf, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, 0, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movsx",     2, { R32E,     R16E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),               NO_VEX, NO_EVEX, 1, 1, { 0xbf, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, 0, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movsx",     2, { R64,      R16     }, GP0, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),							        NO_VEX, NO_EVEX, 4, 1, { 0xbf, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, 0, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movsx",     2, { R64_RAX,  R16     }, GP0, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),							        NO_VEX, NO_EVEX, 4, 1, { 0xbf, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, 0, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movsx",     2, { R64_RAX,  R16E    }, GP3, (REX | REXW | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 4, 1, { 0xbf, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, 0, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movsx",     2, { R64E,     R16     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                      NO_VEX, NO_EVEX, 4, 1, { 0xbf, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, 0, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movsx",     2, { R64E,     R16E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),               NO_VEX, NO_EVEX, 4, 1, { 0xbf, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, 0, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movsx",     2, { R32,      M16     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 2, 1, { 0xbf, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  PFX_0xF,   NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "movsx",     2, { R32_EAX,  M16     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 2, 1, { 0xbf, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  PFX_0xF,   NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "movsx",     2, { R32E,     M16     }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                      NO_VEX, NO_EVEX, 2, 1, { 0xbf, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  PFX_0xF,   NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "movsx",     2, { R64,      M16     }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				                NO_VEX, NO_EVEX, 4, 1, { 0xbf, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  PFX_0xF,   NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "movsx",     2, { R64_RAX,  M16     }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				                NO_VEX, NO_EVEX, 4, 1, { 0xbf, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  PFX_0xF,   NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "movsx",     2, { R64E,     M16     }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 4, 1, { 0xbf, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  PFX_0xF,   NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "movsxd",    2, { R64,      R32     }, GP0, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),							        NO_VEX, NO_EVEX, 4, 1, { 0x63, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, 0, 0,                                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movsxd",    2, { R64_RAX,  R32     }, GP0, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),							        NO_VEX, NO_EVEX, 4, 1, { 0x63, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, 0, 0,                                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movsxd",    2, { R64_RAX,  R32E    }, GP3, (REX | REXW | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 4, 1, { 0x63, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, 0, 0,                                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movsxd",    2, { R64E,     R32     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                      NO_VEX, NO_EVEX, 4, 1, { 0x63, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, 0, 0,                                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movsxd",    2, { R64E,     R32E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),               NO_VEX, NO_EVEX, 4, 1, { 0x63, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, 0, 0,                                              (X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movsxd",    2, { R64,      M_ANY   }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				                NO_VEX, NO_EVEX, 2, 1, { 0x63, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "movsxd",    2, { R64_RAX,  M_ANY   }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				                NO_VEX, NO_EVEX, 2, 1, { 0x63, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "movsxd",    2, { R64E,     M_ANY   }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 2, 1, { 0x63, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//MOVZX r16, r / m8   RM Valid Valid          0F B6 / r          
//MOVZX r32, r / m8   RM Valid Valid          0F B6 / r
//MOVZX r64, r / m8 * RM Valid N.E.   REX.W + 0F B6 / r
//MOVZX r32, r / m16  RM Valid Valid          0F B7 / r
//MOVZX r64, r / m16  RM Valid N.E.   REX.W + 0F B7 / r
/* ----------------------------------------------------------------------------------------------- */
{ "movzx",     2, { R16,      R8_AL   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 2, 1, { 0xb6, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movzx",     2, { R16,      R8_CL   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 2, 1, { 0xb6, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movzx",     2, { R16,      R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 2, 1, { 0xb6, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movzx",     2, { R16_AX,   R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 2, 1, { 0xb6, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movzx",     2, { R16_AX,   R8_CL   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 2, 1, { 0xb6, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movzx",     2, { R16_AX,   R8U     }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				                      NO_VEX, NO_EVEX, 2, 1, { 0xb6, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movzx",     2, { R16_AX,   R8E     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				              NO_VEX, NO_EVEX, 2, 1, { 0xb6, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movzx",     2, { R16E,     R8      }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                      NO_VEX, NO_EVEX, 2, 1, { 0xb6, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movzx",     2, { R16E,     R8U     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                      NO_VEX, NO_EVEX, 2, 1, { 0xb6, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movzx",     2, { R16E,     R8E     }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),               NO_VEX, NO_EVEX, 2, 1, { 0xb6, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movzx",     2, { R32,      R8_AL   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 4, 1, { 0xb6, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movzx",     2, { R32,      R8_CL   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 4, 1, { 0xb6, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movzx",     2, { R32,      R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 4, 1, { 0xb6, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movzx",     2, { R32_EAX,  R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 4, 1, { 0xb6, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movzx",     2, { R32_EAX,  R8_CL   }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 4, 1, { 0xb6, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movzx",     2, { R32_EAX,  R8U     }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				                      NO_VEX, NO_EVEX, 4, 1, { 0xb6, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movzx",     2, { R32_EAX,  R8E     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				              NO_VEX, NO_EVEX, 4, 1, { 0xb6, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movzx",     2, { R32E,     R8      }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                      NO_VEX, NO_EVEX, 4, 1, { 0xb6, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movzx",     2, { R32E,     R8U     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                      NO_VEX, NO_EVEX, 4, 1, { 0xb6, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movzx",     2, { R32E,     R8E     }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),               NO_VEX, NO_EVEX, 4, 1, { 0xb6, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movzx",     2, { R64,      R8_AL   }, GP0, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),							        NO_VEX, NO_EVEX, 8, 1, { 0xb6, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movzx",     2, { R64,      R8_CL   }, GP0, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),							        NO_VEX, NO_EVEX, 8, 1, { 0xb6, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movzx",     2, { R64,      R8      }, GP0, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),							        NO_VEX, NO_EVEX, 8, 1, { 0xb6, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movzx",     2, { R64_RAX,  R8      }, GP0, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),							        NO_VEX, NO_EVEX, 8, 1, { 0xb6, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movzx",     2, { R64_RAX,  R8_CL   }, GP0, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),							        NO_VEX, NO_EVEX, 8, 1, { 0xb6, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movzx",     2, { R64_RAX,  R8U     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				              NO_VEX, NO_EVEX, 8, 1, { 0xb6, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movzx",     2, { R64_RAX,  R8E     }, GP3, (REX | REXW | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 8, 1, { 0xb6, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movzx",     2, { R64E,     R8      }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                      NO_VEX, NO_EVEX, 8, 1, { 0xb6, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movzx",     2, { R64E,     R8U     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                      NO_VEX, NO_EVEX, 8, 1, { 0xb6, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movzx",     2, { R64E,     R8E     }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),               NO_VEX, NO_EVEX, 8, 1, { 0xb6, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movzx",     2, { R16,      M8      }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 2, 1, { 0xb6, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, 0, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "movzx",     2, { R16_AX,   M8      }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 2, 1, { 0xb6, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, 0, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "movzx",     2, { R16E,     M8      }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                      NO_VEX, NO_EVEX, 2, 1, { 0xb6, 0x00, 0x00 }, 2, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  PFX_0xF, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "movzx",     2, { R32,      M8      }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 4, 1, { 0xb6, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "movzx",     2, { R32_EAX,  M8      }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 4, 1, { 0xb6, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "movzx",     2, { R32E,     M8      }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                      NO_VEX, NO_EVEX, 4, 1, { 0xb6, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  PFX_0xF, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "movzx",     2, { R64,      M8      }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				                NO_VEX, NO_EVEX, 8, 1, { 0xb6, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "movzx",     2, { R64_RAX,  M8      }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				                NO_VEX, NO_EVEX, 8, 1, { 0xb6, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "movzx",     2, { R64E,     M8      }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 8, 1, { 0xb6, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  PFX_0xF, NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
{ "movzx",     2, { R32,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 1, 1, { 0xb7, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, 0, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movzx",     2, { R32_EAX,  R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                        NO_VEX, NO_EVEX, 1, 1, { 0xb7, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, 0, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movzx",     2, { R32_EAX,  R16E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				              NO_VEX, NO_EVEX, 1, 1, { 0xb7, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, 0, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movzx",     2, { R32E,     R16     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                      NO_VEX, NO_EVEX, 1, 1, { 0xb7, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, 0, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movzx",     2, { R32E,     R16E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),               NO_VEX, NO_EVEX, 1, 1, { 0xb7, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, 0, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movzx",     2, { R64,      R16     }, GP0, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),							        NO_VEX, NO_EVEX, 4, 1, { 0xb7, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, 0, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movzx",     2, { R64_RAX,  R16     }, GP0, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),							        NO_VEX, NO_EVEX, 4, 1, { 0xb7, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, 0, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "movzx",     2, { R64_RAX,  R16E    }, GP3, (REX | REXW | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				        NO_VEX, NO_EVEX, 4, 1, { 0xb7, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, 0, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movzx",     2, { R64E,     R16     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                      NO_VEX, NO_EVEX, 4, 1, { 0xb7, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, 0, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movzx",     2, { R64E,     R16E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),               NO_VEX, NO_EVEX, 4, 1, { 0xb7, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, 0, 0,                               (X64), REG_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "movzx",     2, { R32,      M16     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 2, 1, { 0xb7, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  PFX_0xF,   NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "movzx",     2, { R32_EAX,  M16     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 2, 1, { 0xb7, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST,  PFX_0xF,   NO_IMM,     MEM_OPND_1, P_86,  0, NULL },
{ "movzx",     2, { R32E,     M16     }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                      NO_VEX, NO_EVEX, 2, 1, { 0xb7, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  PFX_0xF,   NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "movzx",     2, { R64,      M16     }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				                NO_VEX, NO_EVEX, 4, 1, { 0xb7, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  PFX_0xF,   NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "movzx",     2, { R64_RAX,  M16     }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				                NO_VEX, NO_EVEX, 4, 1, { 0xb7, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  PFX_0xF,   NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
{ "movzx",     2, { R64E,     M16     }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 4, 1, { 0xb7, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,             (X64), REG_DST,  PFX_0xF,   NO_IMM,     MEM_OPND_1, P_64,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */

//MOVSS xmm1, xmm2  F3 0F 10 / r
//MOVSS xmm1,  m32  F3 0F 10 / r
/* ----------------------------------------------------------------------------------------------- */
{ "movss", 2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                          NO_VEX, NO_EVEX,  1, 1, { 0x10, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F, NO_IMM,     NO_MEM,     P_686 | P_SSE2, 0, NULL },
{ "movss", 2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),	                                      NO_VEX, NO_EVEX,  4, 1, { 0x10, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F, NO_IMM,     MEM_OPND_1, P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PACKSSWB mm1, mm2 / m64        	   NP 0F 63 / r1              A V / V MMX
//PACKSSWB xmm1, xmm2 / m128     	   66 0F 63 / r               A V / V SSE2
/* ----------------------------------------------------------------------------------------------- */
{ "packsswb",     2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                  NO_VEX, NO_EVEX, 1, 1, { 0x63, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "packsswb",     2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                              NO_VEX, NO_EVEX, 1, 1, { 0x63, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "packsswb",     2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                    NO_VEX, NO_EVEX, 1, 1, { 0x63, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "packsswb",     2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                      NO_VEX, NO_EVEX, 1, 1, { 0x63, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PACKSSDW mm1, mm2 / m64        	   NP 0F 6B / r1              A V / V MMX
//PACKSSDW xmm1, xmm2 / m128     	   66 0F 6B / r               A V / V SSE2
/* ----------------------------------------------------------------------------------------------- */
{ "packssdw",     2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                  NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "packssdw",     2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                              NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "packssdw",     2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                    NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "packssdw",     2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                      NO_VEX, NO_EVEX, 1, 1, { 0x6b, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PACKUSWB mm, mm / m64                     NP 0F 67 / r1               A V / V MMX
//PACKUSWB xmm1, xmm2 / m128                66 0F 67 / r                A V / V SSE2
{ "packuswb",     2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                  NO_VEX, NO_EVEX, 1, 1, { 0x67, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "packuswb",     2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                              NO_VEX, NO_EVEX, 1, 1, { 0x67, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "packuswb",     2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                    NO_VEX, NO_EVEX, 1, 1, { 0x67, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "packuswb",     2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                      NO_VEX, NO_EVEX, 1, 1, { 0x67, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PADDB mm, mm / m64     NP 0F FC / r1  A V / V MMX   Add packed byte integers from mm / m64 and mm.
//PADDW mm, mm / m64     NP 0F FD / r1  A V / V MMX   Add packed word integers from mm / m64 and mm.
//PADDD mm, mm / m64     NP 0F FE / r1  A V / V MMX   Add packed doubleword integers from mm / m64 and mm.
//PADDQ mm, mm / m64     NP 0F D4 / r1  A V / V MMX   Add packed quadword integers from mm / m64 and mm.
/* ----------------------------------------------------------------------------------------------- */
{ "paddb",     2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xfc, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "paddb",     2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                NO_VEX, NO_EVEX, 1, 1, { 0xfc, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "paddw",     2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xfd, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "paddw",     2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                NO_VEX, NO_EVEX, 1, 1, { 0xfd, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "paddd",     2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "paddd",     2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "paddq",     2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xd4, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "paddq",     2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                NO_VEX, NO_EVEX, 1, 1, { 0xd4, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PADDB xmm1, xmm2 / m128  66 0F FC / r  A V / V SSE2  Add packed byte integers from xmm2 / m128 and xmm1.
//PADDW xmm1, xmm2 / m128  66 0F FD / r  A V / V SSE2  Add packed word integers from xmm2 / m128 and xmm1.
//PADDD xmm1, xmm2 / m128  66 0F FE / r  A V / V SSE2  Add packed doubleword integers from xmm2 / m128 and xmm1.
//PADDQ xmm1, xmm2 / m128  66 0F D4 / r  A V / V SSE2  Add packed quadword integers from xmm2 / m128 and xmm1.
/* ----------------------------------------------------------------------------------------------- */
{ "paddb",     2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0xfc, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "paddb",     2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0xfc, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
{ "paddw",     2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0xfd, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "paddw",     2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0xfd, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
{ "paddd",     2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "paddd",     2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0xff, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
{ "paddq",     2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0xd4, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "paddq",     2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0xd4, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PADDSB mm, mm/m64                        NP 0F EC /r1                A V/V MMX              
//PADDSW mm, mm/m64                        NP 0F ED /r1                A V/V MMX              
{ "paddsb",     2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xec, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "paddsb",     2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                NO_VEX, NO_EVEX, 1, 1, { 0xec, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "paddsw",     2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xed, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "paddsw",     2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                NO_VEX, NO_EVEX, 1, 1, { 0xed, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
//PADDSB xmm1, xmm2/m128                   66 0F EC /r                 A V/V SSE2             
//PADDSW xmm1, xmm2/m128                   66 0F ED /r                 A V/V SSE2             
{ "paddsb",     2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0xec, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "paddsb",     2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                         NO_VEX, NO_EVEX, 1, 1, { 0xec, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
{ "paddsw",     2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0xed, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "paddsw",     2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                         NO_VEX, NO_EVEX, 1, 1, { 0xed, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PADDUSB mm, mm / m64      NP 0F DC / r1  A V / V MMX
//PADDUSW mm, mm / m64      NP 0F DD / r1  A V / V MMX
{ "paddusb",     2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xdc, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "paddusb",     2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                NO_VEX, NO_EVEX, 1, 1, { 0xdc, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "paddusw",     2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xdd, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "paddusw",     2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                NO_VEX, NO_EVEX, 1, 1, { 0xdd, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
//PADDUSB xmm1, xmm2 / m128 66 0F DC / r   A V / V SSE2
//PADDUSW xmm1, xmm2 / m128 66 0F DD / r   A V / V SSE2
{ "paddusb",     2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0xdc, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "paddusb",     2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0xdc, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
{ "paddusw",     2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0xdd, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "paddusw",     2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0xdd, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PAND mm, mm/m64        NP 0F DB /r1  A V/V MMX             
/* ----------------------------------------------------------------------------------------------- */
{ "pand",     2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xdb, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "pand",     2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                  NO_VEX, NO_EVEX, 1, 1, { 0xdb, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PAND xmm1, xmm2/m128   66 0F DB /r   A V/V SSE2            
/* ----------------------------------------------------------------------------------------------- */
{ "pand",     2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                        NO_VEX, NO_EVEX, 1, 1, { 0xdb, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pand",     2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1, 1, { 0xdb, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PANDN mm, mm / m64 NP 0F DF / r1     A V / V MMX            
/* ----------------------------------------------------------------------------------------------- */
{ "pandn",     2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xdf, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "pandn",     2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                NO_VEX, NO_EVEX, 1, 1, { 0xdf, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PANDN xmm1, xmm2 / m128 66 0F DF / r A V / V SSE2       
/* ----------------------------------------------------------------------------------------------- */
{ "pandn",     2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0xdf, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pandn",     2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0xdf, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PAVGB mm1, mm2/m64                        NP 0F E0 /r1                 A V/V SSE              
//PAVGB xmm1, xmm2/m128                     66 0F E0, /r                 A V/V SSE2             
/* ----------------------------------------------------------------------------------------------- */
{ "pavgb",     2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xe0, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "pavgb",     2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                NO_VEX, NO_EVEX, 1, 1, { 0xe0, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "pavgb",     2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0xe0, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pavgb",     2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0xe0, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
//PAVGW mm1, mm2/m64                        NP 0F E3 /r1                 A V/V SSE              
//PAVGW xmm1, xmm2/m128                     66 0F E3 /r                  A V/V SSE2             
/* ----------------------------------------------------------------------------------------------- */
{ "pavgw",     2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xe3, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "pavgw",     2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                NO_VEX, NO_EVEX, 1, 1, { 0xe3, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "pavgw",     2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0xe3, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pavgw",     2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0xe3, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PCMPEQB mm, mm/m64               NP 0F 74 /r1      A V/V MMX        
//PCMPEQB xmm1, xmm2/m128          66 0F 74 /r       A V/V SSE2       
/* ----------------------------------------------------------------------------------------------- */
{ "pcmpeqb",     2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0x74, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "pcmpeqb",     2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                NO_VEX, NO_EVEX, 1, 1, { 0x74, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "pcmpeqb",     2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0x74, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pcmpeqb",     2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0x74, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PCMPEQW mm, mm/m64               NP 0F 75 /r1      A V/V MMX        
//PCMPEQW xmm1, xmm2/m128          66 0F 75 /r       A V/V SSE2       
/* ----------------------------------------------------------------------------------------------- */
{ "pcmpeqw",     2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0x75, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "pcmpeqw",     2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                NO_VEX, NO_EVEX, 1, 1, { 0x75, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "pcmpeqw",     2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0x75, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pcmpeqw",     2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0x75, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PCMPEQD mm, mm/m64               NP 0F 76 /r1      A V/V MMX        
//PCMPEQD xmm1, xmm2/m128          66 0F 76 /r       A V/V SSE2       
/* ----------------------------------------------------------------------------------------------- */
{ "pcmpeqd",     2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0x76, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "pcmpeqd",     2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                NO_VEX, NO_EVEX, 1, 1, { 0x76, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "pcmpeqd",     2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0x76, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pcmpeqd",     2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0x76, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
//PEXTRW reg, mm, imm8       NP 0F C5 / r ib1                  A V / V SSE
//PEXTRW reg, xmm, imm8      66 0F C5 / r ib                   A V / V SSE2
//PEXTRW reg / m16, xmm, imm8 66 0F 3A 15 / r ib               B V / V SSE4_1
{ "pextrw",    3, { R32,   MMX64,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,               NO_VEX, NO_EVEX, 4, 1, { 0xc5, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,   IMM_OPND_2, NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pextrw",    3, { R32E,  MMX64,  IMM8 }, SSE0, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,         NO_VEX, NO_EVEX, 4, 1, { 0xc5, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,   IMM_OPND_2, NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pextrw",    3, { R64,   MMX64,  IMM8 }, SSE0, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,         NO_VEX, NO_EVEX, 4, 1, { 0xc5, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,   IMM_OPND_2, NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pextrw",    3, { R64E,  MMX64,  IMM8 }, SSE0, (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  NO_VEX, NO_EVEX, 4, 1, { 0xc5, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,   IMM_OPND_2, NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pextrw",    3, { R32,   R_XMM,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,               NO_VEX, NO_EVEX, 4, 1, { 0xc5, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F, IMM_OPND_2, NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pextrw",    3, { R32E,  R_XMM,  IMM8 }, SSE0, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,         NO_VEX, NO_EVEX, 4, 1, { 0xc5, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F, IMM_OPND_2, NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pextrw",    3, { R64,   R_XMM,  IMM8 }, SSE0, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,         NO_VEX, NO_EVEX, 4, 1, { 0xc5, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F, IMM_OPND_2, NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pextrw",    3, { R64E,  R_XMM,  IMM8 }, SSE0, (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  NO_VEX, NO_EVEX, 4, 1, { 0xc5, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F, IMM_OPND_2, NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pextrw",    3, { M_ANY, R_XMM,  IMM8 }, SSE0, (EREX) | ALLOW_SEG | (F_MODRM | F_MODRM_REG) | IMM8_ONLY,	              NO_VEX, NO_EVEX, 4, 1, { 0x15, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0, 0, (X32 | X64), RM_DST, PFX_0x66F3A,IMM_OPND_2, MEM_OPND_0,   P_686 | P_SSE4, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PEXTRB reg / m8, xmm2, imm8     66 0F 3A 14/ r ib
/* ----------------------------------------------------------------------------------------------- */
{ "pextrb",    3, { R32,   R_XMM,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,               NO_VEX, NO_EVEX, 16, 1, { 0x14, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST, PFX_0x66F3A, IMM_OPND_2, NO_MEM,      P_686 | P_SSE2, 0, NULL },
{ "pextrb",    3, { R32E,  R_XMM,  IMM8 }, SSE0, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,         NO_VEX, NO_EVEX, 16, 1, { 0x14, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST, PFX_0x66F3A, IMM_OPND_2, NO_MEM,      P_686 | P_SSE2, 0, NULL },
{ "pextrb",    3, { R64,   R_XMM,  IMM8 }, SSE0, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,         NO_VEX, NO_EVEX, 16, 1, { 0x14, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST, PFX_0x66F3A, IMM_OPND_2, NO_MEM,      P_686 | P_SSE2, 0, NULL },
{ "pextrb",    3, { R64E,  R_XMM,  IMM8 }, SSE0, (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  NO_VEX, NO_EVEX, 16, 1, { 0x14, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST, PFX_0x66F3A, IMM_OPND_2, NO_MEM,      P_686 | P_SSE2, 0, NULL },
{ "pextrb",    3, { M_ANY, R_XMM,  IMM8 }, SSE0, (EREX) | ALLOW_SEG | (F_MODRM | F_MODRM_REG) | IMM8_ONLY,	              NO_VEX, NO_EVEX, 16, 1, { 0x14, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0, 0, (X32 | X64), RM_DST, PFX_0x66F3A,IMM_OPND_2, MEM_OPND_0,   P_686 | P_SSE4, 0, NULL },
//PEXTRD r / m32, xmm2, imm8      66 0F 3A 16 / r ib
{ "pextrd",    3, { R32,   R_XMM,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,               NO_VEX, NO_EVEX, 4, 1, { 0x16, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST, PFX_0x66F3A, IMM_OPND_2, NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pextrd",    3, { R32E,  R_XMM,  IMM8 }, SSE0, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,         NO_VEX, NO_EVEX, 4, 1, { 0x16, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST, PFX_0x66F3A, IMM_OPND_2, NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pextrd",    3, { M_ANY, R_XMM,  IMM8 }, SSE0, (EREX) | ALLOW_SEG | (F_MODRM | F_MODRM_REG) | IMM8_ONLY,	              NO_VEX, NO_EVEX, 4, 1, { 0x16, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0, 0, (X32 | X64), RM_DST, PFX_0x66F3A,IMM_OPND_2, MEM_OPND_0,    P_686 | P_SSE4, 0, NULL },
//PEXTRQ r / m64, xmm2, imm8      66 REX.W 0F 3A 16 / r ib
{ "pextrq",    3, { R64,   R_XMM,  IMM8 }, SSE0, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,         NO_VEX, NO_EVEX, 2, 1, { 0x16, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST, PFX_0x66F3A, IMM_OPND_2, NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pextrq",    3, { R64E,  R_XMM,  IMM8 }, SSE0, (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  NO_VEX, NO_EVEX, 2, 1, { 0x16, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST, PFX_0x66F3A, IMM_OPND_2, NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pextrq",    3, { M_ANY, R_XMM,  IMM8 }, SSE0, (EREX) | ALLOW_SEG | (F_MODRM | F_MODRM_REG) | IMM8_ONLY,	              NO_VEX, NO_EVEX, 2, 1, { 0x16, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0, 0, (X32 | X64), RM_DST, PFX_0x66F3A,IMM_OPND_2, MEM_OPND_0,    P_686 | P_SSE4, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PINSRB xmm1, r32 / m8, imm8  66 0F 3A 20 / r ib                    A V / V SSE4_1
/* ----------------------------------------------------------------------------------------------- */
{ "pinsrb",    3, { R_XMM,  R32,   IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,               NO_VEX, NO_EVEX, 16, 1, { 0x20, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F3A, IMM_OPND_2, NO_MEM,      P_686 | P_SSE4, 0, NULL },
{ "pinsrb",    3, { R_XMM,  R32E,  IMM8 }, SSE0, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,         NO_VEX, NO_EVEX, 16, 1, { 0x20, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F3A, IMM_OPND_2, NO_MEM,      P_686 | P_SSE4, 0, NULL },
{ "pinsrb",    3, { R_XMM,  R64,   IMM8 }, SSE0, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,         NO_VEX, NO_EVEX, 16, 1, { 0x20, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F3A, IMM_OPND_2, NO_MEM,      P_686 | P_SSE4, 0, NULL },
{ "pinsrb",    3, { R_XMM,  R64E,  IMM8 }, SSE0, (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  NO_VEX, NO_EVEX, 16, 1, { 0x20, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F3A, IMM_OPND_2, NO_MEM,      P_686 | P_SSE4, 0, NULL },
{ "pinsrb",    3, { R_XMM,  M_ANY, IMM8 }, SSE0, (EREX) | ALLOW_SEG | (F_MODRM | F_MODRM_REG) | IMM8_ONLY,	              NO_VEX, NO_EVEX, 16, 1, { 0x20, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), RM_DST, PFX_0x66F3A,IMM_OPND_2, MEM_OPND_1,    P_686 | P_SSE4, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PINSRD xmm1, r / m32, imm8   66 0F 3A 22 / r ib                    A V / V SSE4_1
/* ----------------------------------------------------------------------------------------------- */
{ "pinsrd",    3, { R_XMM,  R32,   IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,               NO_VEX, NO_EVEX, 16, 1, { 0x20, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F3A, IMM_OPND_2, NO_MEM,      P_686 | P_SSE4, 0, NULL },
{ "pinsrd",    3, { R_XMM,  R32E,  IMM8 }, SSE0, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,         NO_VEX, NO_EVEX, 16, 1, { 0x20, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F3A, IMM_OPND_2, NO_MEM,      P_686 | P_SSE4, 0, NULL },
{ "pinsrd",    3, { R_XMM,  R64,   IMM8 }, SSE0, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,         NO_VEX, NO_EVEX, 16, 1, { 0x20, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F3A, IMM_OPND_2, NO_MEM,      P_686 | P_SSE4, 0, NULL },
{ "pinsrd",    3, { R_XMM,  R64E,  IMM8 }, SSE0, (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  NO_VEX, NO_EVEX, 16, 1, { 0x20, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F3A, IMM_OPND_2, NO_MEM,      P_686 | P_SSE4, 0, NULL },
{ "pinsrd",    3, { R_XMM,  M_ANY, IMM8 }, SSE0, (EREX) | ALLOW_SEG | (F_MODRM | F_MODRM_REG) | IMM8_ONLY,	              NO_VEX, NO_EVEX, 16, 1, { 0x20, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), RM_DST, PFX_0x66F3A,IMM_OPND_2, MEM_OPND_1,    P_686 | P_SSE4, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PINSRQ xmm1, r / m64, imm8   66 REX.W 0F 3A 22 / r ib              A V / N.E.SSE4_1
/* ----------------------------------------------------------------------------------------------- */
{ "pinsrq",    3, { R_XMM,  R32,   IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,               NO_VEX, NO_EVEX, 16, 1, { 0x20, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F3A, IMM_OPND_2, NO_MEM,      P_686 | P_SSE4, 0, NULL },
{ "pinsrq",    3, { R_XMM,  R32E,  IMM8 }, SSE0, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,         NO_VEX, NO_EVEX, 16, 1, { 0x20, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F3A, IMM_OPND_2, NO_MEM,      P_686 | P_SSE4, 0, NULL },
{ "pinsrq",    3, { R_XMM,  R64,   IMM8 }, SSE0, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,         NO_VEX, NO_EVEX, 16, 1, { 0x20, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F3A, IMM_OPND_2, NO_MEM,      P_686 | P_SSE4, 0, NULL },
{ "pinsrq",    3, { R_XMM,  R64E,  IMM8 }, SSE0, (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  NO_VEX, NO_EVEX, 16, 1, { 0x20, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F3A, IMM_OPND_2, NO_MEM,      P_686 | P_SSE4, 0, NULL },
{ "pinsrq",    3, { R_XMM,  M_ANY, IMM8 }, SSE0, (EREX) | ALLOW_SEG | (F_MODRM | F_MODRM_REG) | IMM8_ONLY,	              NO_VEX, NO_EVEX, 16, 1, { 0x20, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), RM_DST, PFX_0x66F3A,IMM_OPND_2, MEM_OPND_1,    P_686 | P_SSE4, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PINSRW mm, r32 / m16, imm8  NP 0F C4 / r ib1
//PINSRW xmm, r32 / m16, imm8 66 0F C4 / r ib
/* ----------------------------------------------------------------------------------------------- */
{ "pinsrw",    3, { MMX64,  R32,   IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,               NO_VEX, NO_EVEX, 4, 1, { 0xc4, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,   IMM_OPND_2, NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pinsrw",    3, { MMX64,  R32E,  IMM8 }, SSE0, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,         NO_VEX, NO_EVEX, 4, 1, { 0xc4, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,   IMM_OPND_2, NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pinsrw",    3, { MMX64,  R64,   IMM8 }, SSE0, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,         NO_VEX, NO_EVEX, 4, 1, { 0xc4, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,   IMM_OPND_2, NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pinsrw",    3, { MMX64,  R64E,  IMM8 }, SSE0, (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  NO_VEX, NO_EVEX, 4, 1, { 0xc4, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,   IMM_OPND_2, NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pinsrw",    3, { MMX64,  M_ANY, IMM8 }, SSE0, (EREX) | ALLOW_SEG | (F_MODRM | F_MODRM_REG) | IMM8_ONLY,	              NO_VEX, NO_EVEX, 4, 1, { 0xc4, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,   IMM_OPND_2, MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
{ "pinsrw",    3, { R_XMM,  R32,   IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,               NO_VEX, NO_EVEX, 4, 1, { 0xc4, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F, IMM_OPND_2, NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pinsrw",    3, { R_XMM,  R32E,  IMM8 }, SSE0, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,         NO_VEX, NO_EVEX, 4, 1, { 0xc4, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F, IMM_OPND_2, NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pinsrw",    3, { R_XMM,  R64,   IMM8 }, SSE0, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,         NO_VEX, NO_EVEX, 4, 1, { 0xc4, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F, IMM_OPND_2, NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pinsrw",    3, { R_XMM,  R64E,  IMM8 }, SSE0, (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  NO_VEX, NO_EVEX, 4, 1, { 0xc4, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F, IMM_OPND_2, NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pinsrw",    3, { R_XMM,  M_ANY, IMM8 }, SSE0, (EREX) | ALLOW_SEG | (F_MODRM | F_MODRM_REG) | IMM8_ONLY,	              NO_VEX, NO_EVEX, 4, 1, { 0xc4, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F, IMM_OPND_2, MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PMADDWD mm, mm / m64      NP 0F F5 / r1      A V / V MMX
//PMADDWD xmm1, xmm2 / m128 66 0F F5 / r       A V / V SSE2
{ "pmaddwd",     2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xf5, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "pmaddwd",     2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                NO_VEX, NO_EVEX, 1, 1, { 0xf5, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "pmaddwd",     2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0xf5, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pmaddwd",     2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0xf5, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PMAXSW mm1, mm2 / m64                               NP 0F EE / r1                 A V / V SSE
//PMAXSW xmm1, xmm2 / m128                            66 0F EE / r                  A V / V SSE2
/* ----------------------------------------------------------------------------------------------- */
{ "pmaxsw",      2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xee, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "pmaxsw",      2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                NO_VEX, NO_EVEX, 1, 1, { 0xee, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "pmaxsw",      2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0xee, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pmaxsw",      2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0xee, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PMAXSB xmm1, xmm2 / m128                            66 0F 38 3C / r               A V / V SSE4_1
/* ----------------------------------------------------------------------------------------------- */
{ "pmaxsb",      2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0x3c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F38,  NO_IMM,     NO_MEM,       P_686 | P_SSE4, 0, NULL },
{ "pmaxsb",      2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0x3c, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F38,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE4, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PMAXSD xmm1, xmm2 / m128                            66 0F 38 3D / r               A V / V SSE4_1
/* ----------------------------------------------------------------------------------------------- */
{ "pmaxsd",      2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0x3d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F38,  NO_IMM,     NO_MEM,       P_686 | P_SSE4, 0, NULL },
{ "pmaxsd",      2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0x3d, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F38,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE4, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PMAXUB mm1, mm2 / m64       NP 0F DE / r1                            A V / V SSE
//PMAXUB xmm1, xmm2 / m128    66 0F DE / r                             A V / V SSE2
/* ----------------------------------------------------------------------------------------------- */
{ "pmaxub",      2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xde, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "pmaxub",      2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                NO_VEX, NO_EVEX, 1, 1, { 0xde, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "pmaxub",      2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0xde, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pmaxub",      2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0xde, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PMAXUW xmm1, xmm2 / m128    66 0F 38 3E / r                          A V / V SSE4_1
/* ----------------------------------------------------------------------------------------------- */
{ "pmaxuw",      2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0x3e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F38,  NO_IMM,     NO_MEM,       P_686 | P_SSE4, 0, NULL },
{ "pmaxuw",      2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0x3e, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F38,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE4, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PMAXUD xmm1, xmm2 / m12866 0F 38 3F / r
/* ----------------------------------------------------------------------------------------------- */
{ "pmaxud",      2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0x3f, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F38,  NO_IMM,     NO_MEM,       P_686 | P_SSE4, 0, NULL },
{ "pmaxud",      2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0x3f, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F38,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE4, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PMINUB mm1, mm2 / m64     NP 0F DA / r1   SSE
//PMINUB xmm1, xmm2 / m128  66 0F DA / r    SSE2
/* ----------------------------------------------------------------------------------------------- */
{ "pminub",      2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xda, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "pminub",      2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                NO_VEX, NO_EVEX, 1, 1, { 0xda, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "pminub",      2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0xda, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pminub",      2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0xda, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PMINUW xmm1, xmm2 / m128  66 0F 38 3A / r SSE4_1
/* ----------------------------------------------------------------------------------------------- */
{ "pminuw",      2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0x3a, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F38,  NO_IMM,     NO_MEM,       P_686 | P_SSE4, 0, NULL },
{ "pminuw",      2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0x3a, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F38,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE4, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PMINUD xmm1, xmm2 / m128 66 0F 38 3B / r   SSE4_1
/* ----------------------------------------------------------------------------------------------- */
{ "pminud",      2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0x3b, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F38,  NO_IMM,     NO_MEM,       P_686 | P_SSE4, 0, NULL },
{ "pminud",      2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0x3b, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F38,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE4, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PMINSW mm1, mm2 / m64    NP 0F EA / r1
//PMINSW xmm1, xmm2 / m128 66 0F EA / r
/* ----------------------------------------------------------------------------------------------- */
{ "pminsw",      2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xea, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "pminsw",      2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                NO_VEX, NO_EVEX, 1, 1, { 0xea, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "pminsw",      2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0xea, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pminsw",      2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0xea, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PMINSB xmm1, xmm2 / m128 66 0F 38 38 / r
/* ----------------------------------------------------------------------------------------------- */
{ "pminsb",      2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0x38, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F38,  NO_IMM,     NO_MEM,       P_686 | P_SSE4, 0, NULL },
{ "pminsb",      2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0x38, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F38,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE4, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PMINSD xmm1, xmm2/m128 66 0F 38 39 /r
/* ----------------------------------------------------------------------------------------------- */
{ "pminsd",      2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0x39, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F38,  NO_IMM,     NO_MEM,       P_686 | P_SSE4, 0, NULL },
{ "pminsd",      2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0x39, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F38,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE4, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PMOVMSKB reg, mm  NP 0F D7 / r1
//PMOVMSKB reg, xmm 66 0F D7 / r
{ "pmovmskb", 2, { R32,      MMX64       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX,  2, 1, { 0xd7, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,    P_686 | P_MMX, 0, NULL },
{ "pmovmskb", 2, { R32E,     MMX64       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX,  2, 1, { 0xd7, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,    P_686 | P_MMX, 0, NULL },
{ "pmovmskb", 2, { R32,      R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX,  2, 1, { 0xd7, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F,  NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "pmovmskb", 2, { R32E,     R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX,  2, 1, { 0xd7, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F,  NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "pmovmskb", 2, { R64,      R_XMM       }, SSE0, (EREX) | (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	          NO_VEX, NO_EVEX,  2, 1, { 0xd7, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F,  NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "pmovmskb", 2, { R64E,     R_XMM       }, SSE0, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	            NO_VEX, NO_EVEX,  2, 1, { 0xd7, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F,  NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
//pmulhuw mm1, mm2 / m64    NP 0F E4 / r1
//PMULHUW xmm1, xmm2 / m128 66 0F E4 / r
/* ----------------------------------------------------------------------------------------------- */
{ "pmulhuw",  2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xe4, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "pmulhuw",  2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                  NO_VEX, NO_EVEX, 1, 1, { 0xe4, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "pmulhuw",  2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                        NO_VEX, NO_EVEX, 1, 1, { 0xe4, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pmulhuw",  2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1, 1, { 0xe4, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PMULHW mm, mm / m64      NP 0F E5 / r1
//PMULHW xmm1, xmm2 / m128 66 0F E5 / r
/* ----------------------------------------------------------------------------------------------- */
{ "pmulhw",   2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xe5, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "pmulhw",   2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                  NO_VEX, NO_EVEX, 1, 1, { 0xe5, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "pmulhw",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                        NO_VEX, NO_EVEX, 1, 1, { 0xe5, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pmulhw",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1, 1, { 0xe5, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PMULLW mm, mm / m64      NP 0F D5 / r1
//PMULLW xmm1, xmm2 / m128 66 0F D5 / r
/* ----------------------------------------------------------------------------------------------- */
{ "pmullw",   2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xd5, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "pmullw",   2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                  NO_VEX, NO_EVEX, 1, 1, { 0xd5, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "pmullw",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                        NO_VEX, NO_EVEX, 1, 1, { 0xd5, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pmullw",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1, 1, { 0xd5, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PMULUDQ mm1, mm2 / m64NP 0F F4 / r1
//PMULUDQ xmm1, xmm2 / m12866 0F F4 / r
/* ----------------------------------------------------------------------------------------------- */
{ "pmuludq",   2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xf4, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "pmuludq",   2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                NO_VEX, NO_EVEX, 1, 1, { 0xf4, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "pmuludq",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0xf4, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pmuludq",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0xf4, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//POR mm, mm / m64      NP 0F EB / r1
//POR xmm1, xmm2 / m128 66 0F EB / r
/* ----------------------------------------------------------------------------------------------- */
{ "por",   2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                          NO_VEX, NO_EVEX, 1, 1, { 0xeb, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "por",   2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                    NO_VEX, NO_EVEX, 1, 1, { 0xeb, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "por",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                           NO_VEX, NO_EVEX, 1, 1, { 0xeb, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "por",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                            NO_VEX, NO_EVEX, 1, 1, { 0xeb, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PXOR mm, mm / m64      NP 0F EF / r1
//PXOR xmm1, xmm2 / m128 66 0F EF / r
/* ----------------------------------------------------------------------------------------------- */
{ "pxor",   2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX, 1, 1, { 0xef, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "pxor",   2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                    NO_VEX, NO_EVEX, 1, 1, { 0xef, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "pxor",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                          NO_VEX, NO_EVEX, 1, 1, { 0xef, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pxor",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                            NO_VEX, NO_EVEX, 1, 1, { 0xef, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PSADBW mm1, mm2 / m64    NP 0F F6 / r1    A V / V SSE
//PSADBW xmm1, xmm2 / m128 66 0F F6 / r     A V / V SSE2
/* ----------------------------------------------------------------------------------------------- */
{ "psadbw",   2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "psadbw",   2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                  NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "psadbw",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                        NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "psadbw",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1, 1, { 0xf6, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PSLLW mm, mm / m64        NP 0F F1 / r1
//PSLLW xmm1, xmm2 / m128   66 0F F1 / r
/* ----------------------------------------------------------------------------------------------- */
{ "psllw",   2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX, 1, 1, { 0xf1, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "psllw",   2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                  NO_VEX, NO_EVEX, 1, 1, { 0xf1, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "psllw",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                         NO_VEX, NO_EVEX, 1, 1, { 0xf1, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "psllw",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1, 1, { 0xf1, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PSLLW mm1, imm8           NP 0F 71 / 6 ib
//PSLLW xmm1, imm8          66 0F 71 / 6 ib
{ "psllw",    2, { MMX64,   IMM8        }, SSE0, (EREX) | (F_OPCODE2_REG) | IMM8_ONLY,             NO_VEX, NO_EVEX, 4, 2, { 0x71, 0xf0, 0x00 }, 8,  0, MOD_REG_IMM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,   IMM_OPND_1, NO_MEM,       P_686 | P_MMX, 0, NULL },
{ "psllw",    2, { R_XMM,   IMM8        }, SSE0, (EREX) | (F_OPCODE2_REG) | IMM8_ONLY,             NO_VEX, NO_EVEX, 4, 2, { 0x71, 0xf0, 0x00 }, 16, 0, MOD_REG_IMM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,   IMM_OPND_1, NO_MEM,     P_686 | P_SSE2, 0, NULL },
//PSLLD mm, mm / m64        NP 0F F2 / r1
//PSLLD xmm1, xmm2 / m128   66 0F F2 / r
{ "pslld",   2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX, 1, 1, { 0xf2, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "pslld",   2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                  NO_VEX, NO_EVEX, 1, 1, { 0xf2, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "pslld",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                         NO_VEX, NO_EVEX, 1, 1, { 0xf2, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "pslld",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1, 1, { 0xf2, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
//PSLLD mm, imm8            NP 0F 72 / 6 ib1
//PSLLD xmm1, imm8          66 0F 72 / 6 ib
{ "pslld",    2, { MMX64,   IMM8        }, SSE0, (EREX) | (F_OPCODE2_REG) | IMM8_ONLY,             NO_VEX, NO_EVEX, 4, 1, { 0x72, 0xf0, 0x00 }, 8,  0, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,   IMM_OPND_1, NO_MEM,       P_686 | P_MMX, 0, NULL },
{ "pslld",    2, { R_XMM,   IMM8        }, SSE0, (EREX) | (F_OPCODE2_REG) | IMM8_ONLY,             NO_VEX, NO_EVEX, 4, 1, { 0x72, 0xf0, 0x00 }, 16, 0, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,   IMM_OPND_1, NO_MEM,     P_686 | P_SSE2, 0, NULL },
//PSLLQ mm, mm / m64        NP 0F F3 / r1
//PSLLQ xmm1, xmm2 / m128   66 0F F3 / r
{ "psllq",   2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX, 1, 1, { 0xf3, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "psllq",   2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                  NO_VEX, NO_EVEX, 1, 1, { 0xf3, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "psllq",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                         NO_VEX, NO_EVEX, 1, 1, { 0xf3, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "psllq",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1, 1, { 0xf3, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
//PSLLQ mm, imm8            NP 0F 73 / 6 ib1
//PSLLQ xmm1, imm8          66 0F 73 / 6 ib
{ "psllq",    2, { MMX64,   IMM8        }, SSE0, (EREX) | (F_OPCODE2_REG) | IMM8_ONLY,             NO_VEX, NO_EVEX, 4, 1, { 0x73, 0xf0, 0x00 }, 16, 0, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,   IMM_OPND_1, NO_MEM,       P_686 | P_MMX, 0, NULL },
{ "psllq",    2, { R_XMM,   IMM8        }, SSE0, (EREX) | (F_OPCODE2_REG) | IMM8_ONLY,             NO_VEX, NO_EVEX, 4, 1, { 0x73, 0xf0, 0x00 }, 16, 0, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,   IMM_OPND_1, NO_MEM,     P_686 | P_SSE2, 0, NULL },
//PSLLDQ xmm1, imm8 66 0F 73 / 7 ib
{ "pslldq",    2, { R_XMM,   IMM8       }, SSE0, (EREX) | (F_OPCODE2_REG) | IMM8_ONLY,             NO_VEX, NO_EVEX, 4, 1, { 0x73, 0xf8, 0x00 }, 16, 0, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,   IMM_OPND_1, NO_MEM,     P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PSRLDQ xmm1, imm8 66 0F 73 / 3 ib
{ "psrldq",    2, { R_XMM,   IMM8       }, SSE0, (EREX) | (F_OPCODE2_REG) | IMM8_ONLY,             NO_VEX, NO_EVEX, 4, 1, { 0x73, 0xd8, 0x00 }, 16, 0, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,   IMM_OPND_1, NO_MEM,     P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PSRAW mm, mm / m64      NP 0F E1 / r1
//PSRAW xmm1, xmm2 / m128 66 0F E1 / r
/* ----------------------------------------------------------------------------------------------- */
{ "psraw",   2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX, 1, 1, { 0xe1, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "psraw",   2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                  NO_VEX, NO_EVEX, 1, 1, { 0xe1, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "psraw",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                         NO_VEX, NO_EVEX, 1, 1, { 0xe1, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "psraw",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1, 1, { 0xe1, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PSRAW mm, imm8     NP 0F 71 / 4 ib1
//PSRAW xmm1, imm8 66 0F 71 / 4 ib
/* ----------------------------------------------------------------------------------------------- */
{ "psraw",    2, { MMX64,   IMM8        }, SSE0, (EREX) | (F_OPCODE2_REG) | IMM8_ONLY,             NO_VEX, NO_EVEX, 4, 2, { 0x71, 0xe0, 0x00 }, 8,  0, MOD_REG_IMM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,   IMM_OPND_1, NO_MEM,       P_686 | P_MMX, 0, NULL },
{ "psraw",    2, { R_XMM,   IMM8        }, SSE0, (EREX) | (F_OPCODE2_REG) | IMM8_ONLY,             NO_VEX, NO_EVEX, 4, 2, { 0x71, 0xe0, 0x00 }, 16, 0, MOD_REG_IMM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,   IMM_OPND_1, NO_MEM,     P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PSRAD mm, mm / m64NP 0F E2 / r1
//PSRAD xmm1, xmm2 / m12866 0F E2 / r
/* ----------------------------------------------------------------------------------------------- */
{ "psrad",   2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX, 1, 1, { 0xe2, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "psrad",   2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                  NO_VEX, NO_EVEX, 1, 1, { 0xe2, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "psrad",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                         NO_VEX, NO_EVEX, 1, 1, { 0xe2, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "psrad",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1, 1, { 0xe2, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PSRAD mm, imm8NP 0F 72 / 4 ib1
//PSRAD xmm1, imm866 0F 72 / 4 ib
/* ----------------------------------------------------------------------------------------------- */
{ "psrad",    2, { MMX64,   IMM8        }, SSE0, (EREX) | (F_OPCODE2_REG) | IMM8_ONLY,             NO_VEX, NO_EVEX, 4, 1, { 0x72, 0xe0, 0x00 }, 8,  0, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,   IMM_OPND_1, NO_MEM,       P_686 | P_MMX, 0, NULL },
{ "psrad",    2, { R_XMM,   IMM8        }, SSE0, (EREX) | (F_OPCODE2_REG) | IMM8_ONLY,             NO_VEX, NO_EVEX, 4, 1, { 0x72, 0xe0, 0x00 }, 16, 0, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,   IMM_OPND_1, NO_MEM,     P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PSRLW mm, mm / m64NP 0F D1 / r1
//PSRLW xmm1, xmm2 / m12866 0F D1 / r
/* ----------------------------------------------------------------------------------------------- */
{ "psrlw",   2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX, 1, 1, { 0xd1, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "psrlw",   2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                  NO_VEX, NO_EVEX, 1, 1, { 0xd1, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "psrlw",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                         NO_VEX, NO_EVEX, 1, 1, { 0xd1, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "psrlw",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1, 1, { 0xd1, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PSRLW mm, imm8    NP 0F 71 / 2 ib1
//PSRLW xmm1, imm8  66 0F 71 / 2 ib
{ "psrlw",    2, { MMX64,   IMM8        }, SSE0, (EREX) | (F_OPCODE2_REG) | IMM8_ONLY,             NO_VEX, NO_EVEX, 4, 2, { 0x71, 0xe0, 0x00 }, 8,  0, MOD_REG_IMM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,   IMM_OPND_1, NO_MEM,       P_686 | P_MMX, 0, NULL },
{ "psrlw",    2, { R_XMM,   IMM8        }, SSE0, (EREX) | (F_OPCODE2_REG) | IMM8_ONLY,             NO_VEX, NO_EVEX, 4, 2, { 0x71, 0xe0, 0x00 }, 16, 0, MOD_REG_IMM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,   IMM_OPND_1, NO_MEM,     P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PSRLD mm, mm / m64NP 0F D2 / r1
//PSRLD xmm1, xmm2 / m12866 0F D2 / r
/* ----------------------------------------------------------------------------------------------- */
{ "psrld",   2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX, 1, 1, { 0xd2, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "psrld",   2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                  NO_VEX, NO_EVEX, 1, 1, { 0xd2, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "psrld",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                         NO_VEX, NO_EVEX, 1, 1, { 0xd2, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "psrld",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1, 1, { 0xd2, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PSRLD mm, imm8 NP 0F 72 / 2 ib1
//PSRLD xmm1, imm8 66 0F 72 / 2 ib
/* ----------------------------------------------------------------------------------------------- */
{ "psrld",    2, { MMX64,   IMM8        }, SSE0, (EREX) | (F_OPCODE2_REG) | IMM8_ONLY,             NO_VEX, NO_EVEX, 4, 1, { 0x72, 0xe0, 0x00 }, 8,  0, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,   IMM_OPND_1, NO_MEM,       P_686 | P_MMX, 0, NULL },
{ "psrld",    2, { R_XMM,   IMM8        }, SSE0, (EREX) | (F_OPCODE2_REG) | IMM8_ONLY,             NO_VEX, NO_EVEX, 4, 1, { 0x72, 0xe0, 0x00 }, 16, 0, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,   IMM_OPND_1, NO_MEM,     P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PSRLQ mm, mm / m64NP 0F D3 / r1
//PSRLQ xmm1, xmm2 / m12866 0F D3 / r
{ "psrlq",   2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "psrlq",   2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                  NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "psrlq",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                         NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "psrlq",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1, 1, { 0xd3, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PSRLQ mm, imm8   NP 0F 73 / 2 ib1
//PSRLQ xmm1, imm8 66 0F 73 / 2 ib
/* ----------------------------------------------------------------------------------------------- */
{ "psrlq",    2, { MMX64,   IMM8        }, SSE0, (EREX) | (F_OPCODE2_REG) | IMM8_ONLY,             NO_VEX, NO_EVEX, 4, 1, { 0x73, 0xe0, 0x00 }, 16, 0, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,   IMM_OPND_1, NO_MEM,       P_686 | P_MMX, 0, NULL },
{ "psrlq",    2, { R_XMM,   IMM8        }, SSE0, (EREX) | (F_OPCODE2_REG) | IMM8_ONLY,             NO_VEX, NO_EVEX, 4, 1, { 0x73, 0xe0, 0x00 }, 16, 0, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,   IMM_OPND_1, NO_MEM,     P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PSUBB mm, mm / m64      NP 0F F8 / r1
//PSUBB xmm1, xmm2 / m128 66 0F F8 / r
/* ----------------------------------------------------------------------------------------------- */
{ "psubb",   2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX, 1, 1, { 0xf8, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "psubb",   2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                  NO_VEX, NO_EVEX, 1, 1, { 0xf8, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "psubb",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                         NO_VEX, NO_EVEX, 1, 1, { 0xf8, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "psubb",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1, 1, { 0xf8, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PSUBW mm, mm / m64      NP 0F F9 / r1
//PSUBW xmm1, xmm2 / m128 66 0F F9 / r
/* ----------------------------------------------------------------------------------------------- */
{ "psubw",   2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX, 1, 1, { 0xf9, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "psubw",   2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                  NO_VEX, NO_EVEX, 1, 1, { 0xf9, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "psubw",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                         NO_VEX, NO_EVEX, 1, 1, { 0xf9, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "psubw",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1, 1, { 0xf9, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PSUBD mm, mm / m64       NP 0F FA / r1
//PSUBD xmm1, xmm2 / m128  66 0F FA / r
/* ----------------------------------------------------------------------------------------------- */
{ "psubd",   2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX, 1, 1, { 0xfa, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "psubd",   2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                  NO_VEX, NO_EVEX, 1, 1, { 0xfa, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "psubd",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                         NO_VEX, NO_EVEX, 1, 1, { 0xfa, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "psubd",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1, 1, { 0xfa, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PSUBQ mm1, mm2 / m64    NP 0F FB / r1
//PSUBQ xmm1, xmm2 / m128 66 0F FB / r
/* ----------------------------------------------------------------------------------------------- */
{ "psubq",   2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX, 1, 1, { 0xfb, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "psubq",   2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                  NO_VEX, NO_EVEX, 1, 1, { 0xfb, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "psubq",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                         NO_VEX, NO_EVEX, 1, 1, { 0xfb, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "psubq",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1, 1, { 0xfb, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PSUBSB mm, mm / m64NP 0F E8 / r1
//PSUBSB xmm1, xmm2 / m12866 0F E8 / r
/* ----------------------------------------------------------------------------------------------- */
{ "psubsb",   2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xe8, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "psubsb",   2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                  NO_VEX, NO_EVEX, 1, 1, { 0xe8, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "psubsb",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                        NO_VEX, NO_EVEX, 1, 1, { 0xe8, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "psubsb",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1, 1, { 0xe8, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PSUBSW mm, mm / m64NP 0F E9 / r1
//PSUBSW xmm1, xmm2 / m12866 0F E9 / r
/* ----------------------------------------------------------------------------------------------- */
{ "psubsw",   2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xe9, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "psubsw",   2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                  NO_VEX, NO_EVEX, 1, 1, { 0xe9, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "psubsw",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                        NO_VEX, NO_EVEX, 1, 1, { 0xe9, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "psubsw",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1, 1, { 0xe9, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PSUBUSB mm, mm / m64NP 0F D8 / r1
//psubusb xmm1, xmm2 / m12866 0F D8 / r
/* ----------------------------------------------------------------------------------------------- */
{ "psubusb",   2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xd8, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "psubusb",   2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                NO_VEX, NO_EVEX, 1, 1, { 0xd8, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "psubusb",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0xd8, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "psubusb",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0xd8, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PSUBUSW mm, mm / m64NP 0F D9 / r1
//psubusw xmm1, xmm2 / m12866 0F D9 / r
/* ----------------------------------------------------------------------------------------------- */
{ "psubusw",   2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xd9, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "psubusw",   2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                NO_VEX, NO_EVEX, 1, 1, { 0xd9, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "psubusw",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0xd9, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "psubusw",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0xd9, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PUNPCKHBW mm, mm / m64      NP 0F 68 / r1
//punpckhbw xmm1, xmm2 / m128 66 0F 68 / r
/* ----------------------------------------------------------------------------------------------- */
{ "punpckhbw",   2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0x68, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "punpckhbw",   2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                NO_VEX, NO_EVEX, 1, 1, { 0x68, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "punpckhbw",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0x68, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "punpckhbw",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0x68, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PUNPCKHWD mm, mm / m64NP 0F 69 / r1
//punpckhwd xmm1, xmm2 / m12866 0F 69 / r
/* ----------------------------------------------------------------------------------------------- */
{ "punpckhwd",   2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "punpckhwd",   2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "punpckhwd",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "punpckhwd",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0x69, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PUNPCKHDQ mm, mm / m64NP 0F 6A / r1
//punpckhdq xmm1, xmm2 / m12866 0F 6A / r
/* ----------------------------------------------------------------------------------------------- */
{ "punpckhdq",   2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0x6a, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "punpckhdq",   2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                NO_VEX, NO_EVEX, 1, 1, { 0x6a, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "punpckhdq",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0x6a, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "punpckhdq",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0x6a, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PUNPCKHQDQ xmm1, xmm2 / m12866 0F 6D / r
/* ----------------------------------------------------------------------------------------------- */
{ "punpckhqdq",   2, { R_XMM,   R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0x6d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "punpckhqdq",   2, { R_XMM,   M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0x6d, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PUNPCKLBW mm, mm / m32NP 0F 60 / r1
//PUNPCKLBW xmm1, xmm2 / m12866 0F 60 / r
/* ----------------------------------------------------------------------------------------------- */
{ "punpcklbw",   2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0x60, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "punpcklbw",   2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                NO_VEX, NO_EVEX, 1, 1, { 0x60, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "punpcklbw",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0x60, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "punpcklbw",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0x60, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PUNPCKLWD mm, mm / m32NP 0F 61 / r1
//PUNPCKLWD xmm1, xmm2 / m12866 0F 61 / r
/* ----------------------------------------------------------------------------------------------- */
{ "punpcklwd",   2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0x61, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "punpcklwd",   2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                NO_VEX, NO_EVEX, 1, 1, { 0x61, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "punpcklwd",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0x61, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "punpcklwd",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0x61, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PUNPCKLDQ mm, mm / m32NP 0F 62 / r1
//PUNPCKLDQ xmm1, xmm2 / m12866 0F 62 / r
/* ----------------------------------------------------------------------------------------------- */
{ "punpckldq",   2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0x62, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_586 | P_MMX,  0, NULL },
{ "punpckldq",   2, { MMX64,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                NO_VEX, NO_EVEX, 1, 1, { 0x62, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_586 | P_MMX,  0, NULL },
{ "punpckldq",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0x62, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "punpckldq",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0x62, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PUNPCKLQDQ xmm1, xmm2 / m12866 0F 6C / r
/* ----------------------------------------------------------------------------------------------- */
{ "punpcklqdq",   2, { R_XMM,   R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0x6c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "punpcklqdq",   2, { R_XMM,   M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0x6c, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//RCPPS xmm1, xmm2 / m128NP 0F 53 / r
/* ----------------------------------------------------------------------------------------------- */
{ "rcpps",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                           NO_VEX, NO_EVEX, 1, 1, { 0x53, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "rcpps",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                            NO_VEX, NO_EVEX, 1, 1, { 0x53, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//RCPSS xmm1, xmm2 / m32F3 0F 53 / r
/* ----------------------------------------------------------------------------------------------- */
{ "rcpss",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                           NO_VEX, NO_EVEX, 1, 1, { 0x53, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "rcpss",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                            NO_VEX, NO_EVEX, 1, 1, { 0x53, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//RSQRTPS xmm1, xmm2 / m128 NP 0F 52 / r
/* ----------------------------------------------------------------------------------------------- */
{ "rsqrtps",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                         NO_VEX, NO_EVEX, 1, 1, { 0x52, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "rsqrtps",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1, 1, { 0x52, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//RSQRTSS xmm1, xmm2 / m32    F3 0F 52 / r
/* ----------------------------------------------------------------------------------------------- */
{ "rsqrtss",   2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                         NO_VEX, NO_EVEX, 1, 1, { 0x52, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F,  NO_IMM,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "rsqrtss",   2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1, 1, { 0x52, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//SHUFPD xmm1, xmm2 / m128, imm8    66 0F C6 / r ib
/* ----------------------------------------------------------------------------------------------- */
{ "shufpd",   2, { R_XMM,   R_XMM,   IMM8  }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                        NO_VEX, NO_EVEX, 1, 1, { 0x6c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  IMM_OPND_2,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "shufpd",   2, { R_XMM,   M_ANY,   IMM8  }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1, 1, { 0x6c, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  IMM_OPND_2,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//SHUFPS xmm1, xmm3 / m128, imm8    NP 0F C6 / r ib
/* ----------------------------------------------------------------------------------------------- */
{ "shufps",   2, { R_XMM,   R_XMM,   IMM8  }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                        NO_VEX, NO_EVEX, 1, 1, { 0x6c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,  IMM_OPND_2,     NO_MEM,       P_686 | P_SSE2, 0, NULL },
{ "shufps",   2, { R_XMM,   M_ANY,   IMM8  }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1, 1, { 0x6c, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,  IMM_OPND_2,     MEM_OPND_1,   P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//UCOMISD xmm1, xmm2 / m64 66 0F 2E / r
{ "ucomisd",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX, 2,  1, { 0x2e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F, NO_IMM,     NO_MEM,     P_686 | P_SSE2, 0, NULL },
{ "ucomisd",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 2,  1, { 0x2e, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F, NO_IMM,     MEM_OPND_1, P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//UCOMISS xmm1, xmm2/m32 NP 0F 2E /r
/* ----------------------------------------------------------------------------------------------- */
{ "ucomiss",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX, 4,  1, { 0x2e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF, NO_IMM,     NO_MEM,     P_686 | P_SSE2, 0, NULL },
{ "ucomiss",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                            NO_VEX, NO_EVEX, 4,  1, { 0x2e, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF, NO_IMM,     MEM_OPND_1, P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//UNPCKHPD xmm1, xmm2/m12866 0F 15 /r
{ "unpckhpd",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1,  1, { 0x15, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F, NO_IMM,     NO_MEM,     P_686 | P_SSE2, 0, NULL },
{ "unpckhpd",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1,  1, { 0x15, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F, NO_IMM,     MEM_OPND_1, P_686 | P_SSE2, 0, NULL },
//UNPCKHPS xmm1, xmm2/m128NP 0F 15 /r
{ "unpckhps",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1,  1, { 0x15, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF, NO_IMM,     NO_MEM,     P_686 | P_SSE2, 0, NULL },
{ "unpckhps",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1,  1, { 0x15, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF, NO_IMM,     MEM_OPND_1, P_686 | P_SSE2, 0, NULL },
//UNPCKLPD xmm1, xmm2/m12866 0F 14 /r
{ "unpcklpd",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1,  1, { 0x14, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F, NO_IMM,     NO_MEM,     P_686 | P_SSE2, 0, NULL },
{ "unpcklpd",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1,  1, { 0x14, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F, NO_IMM,     MEM_OPND_1, P_686 | P_SSE2, 0, NULL },
//UNPCKLPS xmm1, xmm2 / m128NP 0F 14 / r
{ "unpcklps",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1,  1, { 0x14, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF, NO_IMM,     NO_MEM,     P_686 | P_SSE2, 0, NULL },
{ "unpcklps",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1,  1, { 0x14, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF, NO_IMM,     MEM_OPND_1, P_686 | P_SSE2, 0, NULL },



//MULPS xmm1, xmm2 / m128 NP 0F 59 / r A V / V SSE
/* ----------------------------------------------------------------------------------------------- */
{ "mulps",     2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                       NO_VEX, NO_EVEX, 1, 1, { 0x59, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,       P_686 | P_SSE1, 0, NULL },
{ "mulps",     2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0x59, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,   P_686 | P_SSE1, 0, NULL },
{ "mulpd",     2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0x59, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,       P_686 | P_SSE1, 0, NULL },
{ "mulpd",     2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 1, 1, { 0x59, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,   P_686 | P_SSE1, 0, NULL },
{ "mulsd",     2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 2, 1, { 0x59, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F, NO_IMM,     NO_MEM,       P_686 | P_SSE1, 0, NULL },
{ "mulsd",     2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 2, 1, { 0x59, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F, NO_IMM,     MEM_OPND_1,   P_686 | P_SSE1, 0, NULL },
{ "mulss",     2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 4, 1, { 0x59, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F, NO_IMM,     NO_MEM,       P_686 | P_SSE1, 0, NULL },
{ "mulss",     2, { R_XMM,   M_ANY        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX, 4, 1, { 0x59, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F, NO_IMM,     MEM_OPND_1,   P_686 | P_SSE1, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//PSHUFD xmm1, xmm2 / m128, imm8 66 0F 70 / r ib
{ "pshufw",    3, { R_XMM,   R_XMM,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,           NO_VEX, NO_EVEX, 1, 1, { 0x70, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F, IMM_OPND_2, NO_MEM,    P_686 | P_SSE1, 0, NULL },
{ "pshufw",    3, { R_XMM,   M_ANY,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG) | IMM8_ONLY,	                      NO_VEX, NO_EVEX, 1, 1, { 0x70, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F, IMM_OPND_2, MEM_OPND_1,P_686 | P_SSE1, 0, NULL },
//PSHUFHW xmm1, xmm2 / m128, imm8 F3 0F 70 / r ib
{ "pshufw",    3, { R_XMM,   R_XMM,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,           NO_VEX, NO_EVEX, 1, 1, { 0x70, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F, IMM_OPND_2, NO_MEM,    P_686 | P_SSE1, 0, NULL },
{ "pshufw",    3, { R_XMM,   M_ANY,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG) | IMM8_ONLY,	                      NO_VEX, NO_EVEX, 1, 1, { 0x70, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F, IMM_OPND_2, MEM_OPND_1,P_686 | P_SSE1, 0, NULL },
//PSHUFW mm1, mm2 / m64, imm8 NP 0F 70 / r ib                                                                                            
{ "pshufw",    3, { MMX64,   MMX64,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,           NO_VEX, NO_EVEX, 1, 1, { 0x70, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    IMM_OPND_2, NO_MEM,    P_686 | P_SSE1, 0, NULL },
{ "pshufw",    3, { MMX64,   M_ANY,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG) | IMM8_ONLY,	                      NO_VEX, NO_EVEX, 1, 1, { 0x70, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    IMM_OPND_2, MEM_OPND_1,P_686 | P_SSE1, 0, NULL },
//PSHUFHW xmm1, xmm2 / m128, imm8 F3 0F 70 / r ib
{ "pshufhw",   3, { R_XMM,   R_XMM,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,           NO_VEX, NO_EVEX, 1, 1, { 0x70, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F, IMM_OPND_2, NO_MEM,    P_686 | P_SSE1, 0, NULL },
{ "pshufhw",   3, { R_XMM,   M_ANY,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG) | IMM8_ONLY,	                      NO_VEX, NO_EVEX, 1, 1, { 0x70, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F, IMM_OPND_2, MEM_OPND_1,P_686 | P_SSE1, 0, NULL },
//PSHUFLW xmm1, xmm2 / m128, imm8 F2 0F 70 / r ib                                                                                        
{ "pshuflw",   3, { R_XMM,   R_XMM,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,           NO_VEX, NO_EVEX, 1, 1, { 0x70, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F, IMM_OPND_2, NO_MEM,    P_686 | P_SSE1, 0, NULL },
{ "pshuflw",   3, { R_XMM,   M_ANY,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG) | IMM8_ONLY,                        NO_VEX, NO_EVEX, 1, 1, { 0x70, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F, IMM_OPND_2, MEM_OPND_1,P_686 | P_SSE1, 0, NULL },
//PSHUFB xmm1, xmm2 / m12866 0F 38 00 / r
{ "pshufb",    2, { R_XMM,   R_XMM        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0x00, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F38, NO_IMM, NO_MEM,       P_686 | P_SSE3, 0, NULL },
{ "pshufb",    2, { R_XMM,   M128         }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                NO_VEX, NO_EVEX, 1, 1, { 0x00, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F38, NO_IMM, MEM_OPND_1,   P_686 | P_SSE3, 0, NULL },
//PSHUFB mm1, mm2 / m64 NP 0F 38 00 / r1
{ "pshufb",    2, { MMX64,   MMX64        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0x00, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x0F38,  NO_IMM, NO_MEM,       P_686 | P_SSE3, 0, NULL },
{ "pshufb",    2, { MMX64,   M64          }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                                NO_VEX, NO_EVEX, 1, 1, { 0x00, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x0F38,  NO_IMM, MEM_OPND_1,   P_686 | P_SSE3, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* ADDPD xmm1, xmm2 / m128 66 0F 58 / r  */
/* ----------------------------------------------------------------------------------------------- */
{ "addpd",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX,  1,  1, { 0x58, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "addpd",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX,  1,  1, { 0x58, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* ADDPS xmm1, xmm2 / m128 NP 0F 58 /r */
/* ----------------------------------------------------------------------------------------------- */
{ "addps",  2, { R_XMM,  R_XMM          }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX,  1,  1, { 0x58, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX | PFX_0xF, NO_IMM,     NO_MEM,     P_686 | P_SSE2, 0, NULL },
{ "addps",  2, { R_XMM,  M_ANY          }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX,  1,  1, { 0x58, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX | PFX_0xF, NO_IMM,     MEM_OPND_1, P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* ADDSD xmm1, xmm2 / m128 F2 0F 58 /r   */
/* ----------------------------------------------------------------------------------------------- */
{ "addsd",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX,  1,  1, { 0x58, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "addsd",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX,  1,  1, { 0x58, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* ADDSS xmm1, xmm2 / m128 F3 0F 58 /r */
/* ----------------------------------------------------------------------------------------------- */
{ "addss",  2, { R_XMM,  R_XMM          }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	NO_VEX,                 NO_EVEX,          1,  1, { 0x58, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F, NO_IMM,     NO_MEM,     P_686 | P_SSE2, 0, NULL },
{ "addss",  2, { R_XMM,  M_ANY          }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						  NO_VEX,                 NO_EVEX,          1,  1, { 0x58, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F, NO_IMM,     MEM_OPND_1, P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* HADDPD xmm1, xmm2 / m128 66 0F 7C / r */
/* ----------------------------------------------------------------------------------------------- */
{ "haddpd",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX,  1,  1, { 0x7c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "haddpd",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX,  1,  1, { 0x7c, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* HADDPS xmm1, xmm2 / m128 F2 0F 7C / r  */
/* ----------------------------------------------------------------------------------------------- */
{ "haddps",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX,  1,  1, { 0x7c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "haddps",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX,  1,  1, { 0x7c, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* SUBPD xmm1, xmm2 / m128 66 0F 5C / r */
/* ----------------------------------------------------------------------------------------------- */
{ "subpd",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX,  1,  1, { 0x5c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "subpd",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX,  1,  1, { 0x5c, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* SUBPS xmm1, xmm2/m128 NP 0F 5C /r */
/* ----------------------------------------------------------------------------------------------- */
{ "subps",  2, { R_XMM,  R_XMM          }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX,  1,  1, { 0x5c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX | PFX_0xF, NO_IMM,     NO_MEM,     P_686 | P_SSE2, 0, NULL },
{ "subps",  2, { R_XMM,  M_ANY          }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX,  1,  1, { 0x5c, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX | PFX_0xF, NO_IMM,     MEM_OPND_1, P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* SUBSD xmm1, xmm2 / m64 F2 0F 5C / r */
/* ----------------------------------------------------------------------------------------------- */
{ "subsd",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX,  2,  1, { 0x5c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "subsd",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX,  2,  1, { 0x5c, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* SUBSS xmm1, xmm2 / m32 F3 0F 5C / r */
/* ----------------------------------------------------------------------------------------------- */
{ "subss",  2, { R_XMM,  R_XMM          }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX,  4,  1, { 0x5c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F, NO_IMM,     NO_MEM,     P_686 | P_SSE2, 0, NULL },
{ "subss",  2, { R_XMM,  M_ANY          }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX,  4,  1, { 0x5c, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F, NO_IMM,     MEM_OPND_1, P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* DIVPD xmm1, xmm2 / m128 66 0F 5E / r */
/* ----------------------------------------------------------------------------------------------- */
{ "divpd",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX,  1,  1, { 0x5e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "divpd",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX,  1,  1, { 0x5e, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* DIVPS xmm1, xmm2/m128 NP 0F 5C /r */
/* ----------------------------------------------------------------------------------------------- */
{ "divps",  2, { R_XMM,  R_XMM          }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX,  1,  1, { 0x5e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX | PFX_0xF, NO_IMM,     NO_MEM,     P_686 | P_SSE2, 0, NULL },
{ "divps",  2, { R_XMM,  M_ANY          }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX,  1,  1, { 0x5e, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX | PFX_0xF, NO_IMM,     MEM_OPND_1, P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* DIVSD xmm1, xmm2 / m64 F2 0F 5C / r */
/* ----------------------------------------------------------------------------------------------- */
{ "divsd",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX,  2,  1, { 0x5e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "divsd",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX,  2,  1, { 0x5e, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* DIVSS xmm1, xmm2 / m32 F3 0F 5C / r */
/* ----------------------------------------------------------------------------------------------- */
{ "divss",  2, { R_XMM,  R_XMM          }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX,  4,  1, { 0x5c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F, NO_IMM,     NO_MEM,     P_686 | P_SSE2, 0, NULL },
{ "divss",  2, { R_XMM,  M_ANY          }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX,  4,  1, { 0x5c, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F, NO_IMM,     MEM_OPND_1, P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* ADDSUBPD xmm1, xmm2 / m128 66 0F D0 / r  */
/* ----------------------------------------------------------------------------------------------- */
{ "addsubpd",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                    NO_VEX, NO_EVEX,  1,  1, { 0xd0, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "addsubpd",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX,  1,  1, { 0xd0, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* ADDSUBPS xmm1, xmm2 / m128 F2 0F D0 / r ADDSUBPS xmm1, xmm2/m128 NP 0F 5C /r */
/* ----------------------------------------------------------------------------------------------- */
{ "addsubps",  2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX,  1,  1, { 0xd0, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "addsubps",  2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                        NO_VEX, NO_EVEX,  1,  1, { 0xd0, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* SQRTPD xmm1, xmm2 / m128 66 0F 51 / r
/* ----------------------------------------------------------------------------------------------- */
{ "sqrtpd",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX,  1,  1, { 0x51, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "sqrtpd",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX,  1,  1, { 0x51, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* SQRTPS xmm1, xmm2/m128 NP 0F 51 /r*/
/* ----------------------------------------------------------------------------------------------- */
{ "sqrtps",  2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX,  1,  1, { 0x51, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX | PFX_0xF, NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "sqrtps",  2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX,  1,  1, { 0x51, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX | PFX_0xF, NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* SQRTSD xmm1, xmm2 / m64 F2 0F 51 / r */
/* ----------------------------------------------------------------------------------------------- */
{ "sqrtsd",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX,  2,  1, { 0x51, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "sqrtsd",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX,  2,  1, { 0x51, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* SQRTSS xmm1, xmm2 / m32 F3 0F 51 / r */
/* ----------------------------------------------------------------------------------------------- */
{ "sqrtss",  2, { R_XMM,  R_XMM          }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX,  4,  1, { 0x51, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F, NO_IMM,     NO_MEM,     P_686 | P_SSE2, 0, NULL },
{ "sqrtss",  2, { R_XMM,  M_ANY          }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX,  4,  1, { 0x51, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F, NO_IMM,     MEM_OPND_1, P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* MAXPD xmm1, xmm2 / m128 66 0F 5F / r                                                              */
/* -----------------------------------------------------------------------------------------------   */
{ "maxpd",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX,  1,  1, { 0x5f, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "maxpd",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX,  1,  1, { 0x5f, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* MAXPS xmm1, xmm2 / m128 NP 0F 5F / r  /r*/
/* ----------------------------------------------------------------------------------------------- */
{ "maxps",  2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX,  1,  1, { 0x5f, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX | PFX_0xF, NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "maxps",  2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                            NO_VEX, NO_EVEX,  1,  1, { 0x5f, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX | PFX_0xF, NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* MAXSD xmm1, xmm2 / m64 F2 0F 5F / r  r */
/* ----------------------------------------------------------------------------------------------- */
{ "maxsd",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX,  2,  1, { 0x5f, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "maxsd",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX,  2,  1, { 0x5f, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* MAXSS xmm1, xmm2 / m32 F3 0F 5F / r  r */
/* ----------------------------------------------------------------------------------------------- */
{ "maxss",  2, { R_XMM,  R_XMM          }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX,  4,  1, { 0x5f, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F, NO_IMM,     NO_MEM,     P_686 | P_SSE2, 0, NULL },
{ "maxss",  2, { R_XMM,  M_ANY          }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX,  4,  1, { 0x5f, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F, NO_IMM,     MEM_OPND_1, P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* MINPD xmm1, xmm2 / m128 66 0F 5D / r MAXPD xmm1, xmm2 / m128 66 0F 5F / r                       */
/* ----------------------------------------------------------------------------------------------- */
{ "minpd",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	NO_VEX,                 NO_EVEX,          1,  1, { 0x5d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "minpd",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						  NO_VEX,                 NO_EVEX,          1,  1, { 0x5d, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* MINPS xmm1, xmm2 / m128 NP 0F 5D / r   /r*/
/* ----------------------------------------------------------------------------------------------- */
{ "minps",  2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	NO_VEX,                 NO_EVEX,          1,  1, { 0x5d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX | PFX_0xF, NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "minps",  2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						    NO_VEX,                 NO_EVEX,          1,  1, { 0x5d, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX | PFX_0xF, NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* MINSD xmm1, xmm2 / m64 F2 0F 5D / r  */
/* ----------------------------------------------------------------------------------------------- */
{ "minsd",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	NO_VEX,                 NO_EVEX,          2,  1, { 0x5d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "minsd",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						  NO_VEX,                 NO_EVEX,          2,  1, { 0x5d, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* MINSS xmm1, xmm2 / m32 F3 0F 5D / r  */
/* ----------------------------------------------------------------------------------------------- */
{ "minss",  2, { R_XMM,  R_XMM          }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	NO_VEX,                 NO_EVEX,          4,  1, { 0x5d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F, NO_IMM,     NO_MEM,     P_686 | P_SSE2, 0, NULL },
{ "minss",  2, { R_XMM,  M_ANY          }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						  NO_VEX,                 NO_EVEX,          4,  1, { 0x5d, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F, NO_IMM,     MEM_OPND_1, P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* CMPPD xmm1, xmm2 / m128, imm8 66 0F C2 / r ib  */
/* ----------------------------------------------------------------------------------------------- */
{ "cmppd",    3, { R_XMM,   R_XMM,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,            NO_VEX, NO_EVEX,  1,  1, { 0xc2, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0 , 0, (X32 | X64), REG_DST, PFX_0x66F, IMM_OPND_2, NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "cmppd",    3, { R_XMM,   M_ANY,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG) | IMM8_ONLY,	 NO_VEX,                NO_EVEX,          1,  1, { 0xc2, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0 , 0, (X32 | X64), REG_DST, PFX_0x66F, IMM_OPND_2, MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* CMPPS xmm1, xmm2 / m128,imm8 NP 0F C2 / r ib */
/* ----------------------------------------------------------------------------------------------- */
{ "cmpps",   3, { R_XMM,   R_XMM,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,             NO_VEX, NO_EVEX,  1,  1, { 0xc2, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0 , 0, (X32 | X64), REG_DST, PFX_0xF,   IMM_OPND_2, NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "cmpps",   3, { R_XMM,   M_ANY,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG) | IMM8_ONLY,	                        NO_VEX, NO_EVEX,  1,  1, { 0xc2, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0 , 0, (X32 | X64), REG_DST, PFX_0xF,   IMM_OPND_2, MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//CMPS m8, m8    A6
//CMPS m16, m16  A7
//CMPS m32, m32  A7
//CMPS m64, m64 REX.W + A7 
/* ----------------------------------------------------------------------------------------------- */
{ "cmps", 2, { M8,    M8       }, GP0,  ALLOW_REP,													                                            NO_VEX, NO_EVEX,  1, 1, { 0xa6, 0x00, 0x00 }, 1,  2, NO_MOD,      0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_0,     P_386,           0, NULL },
{ "cmps", 2, { M16,   M16      }, GP2,  ALLOW_REP,													                                            NO_VEX, NO_EVEX,  1, 1, { 0xa7, 0x00, 0x00 }, 2,  2, NO_MOD,      0, OP_SIZE_OVERRIDE, 0, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_0,     P_386,           0, NULL },
{ "cmps", 2, { M32,   M32      }, GP2,  ALLOW_REP,													                                            NO_VEX, NO_EVEX,  1, 1, { 0xa7, 0x00, 0x00 }, 4,  2, NO_MOD,      0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_0,     P_386,           0, NULL },
{ "cmps", 2, { M64,   M64      }, GP3,  (REX | REXW) | ALLOW_REP,													                              NO_VEX, NO_EVEX,  1, 1, { 0xa7, 0x00, 0x00 }, 8,  2, NO_MOD,      0, 0, 0, (X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_0,     P_64,           0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//CMPSB          A6   
/* ----------------------------------------------------------------------------------------------- */
{ "cmpsb", 0, { OP_N,     OP_N        }, GP1,  ALLOW_REP,													                                      NO_VEX, NO_EVEX,  1, 1, { 0xa6, 0x00, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "cmpsb", 2, { M_ANY,    M_ANY       }, GP2,  ALLOW_REP,													                                      NO_VEX, NO_EVEX,  1, 1, { 0xa6, 0x00, 0x00 }, 1,  2, NO_MOD,      0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_0,     P_386,           0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//MOVSW          A7 
{ "cmpsw", 0, { OP_N,     OP_N        }, GP1,  ALLOW_REP,													                                      NO_VEX, NO_EVEX,  1, 1, { 0xa7, 0x00, 0x00 }, 2,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,     P_86,           0, NULL },
{ "cmpsw", 2, { M_ANY,    M_ANY       }, GP2,  ALLOW_REP,													                                      NO_VEX, NO_EVEX,  1, 1, { 0xa7, 0x00, 0x00 }, 2,  2, NO_MOD,      0, OP_SIZE_OVERRIDE, 0, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_0,     P_386,           0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* CMPSD A7 */
/* CMPSD xmm1, xmm2 / m64, imm8 F2 0F C2 / r ib */
/* ----------------------------------------------------------------------------------------------- */
{ "cmpsd",   0, { OP_N,     OP_N    }, GP1, ALLOW_REP,														                                      NO_VEX, NO_EVEX,  1,  1, { 0xa7, 0x00, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X16 | X32 | X64), NO_DST, NO_PREFIX, NO_IMM, NO_MEM, P_86, 0, NULL },
{ "cmpsd",   2, { M_ANY,    M_ANY   }, GP2, ALLOW_REP,													                                        NO_VEX, NO_EVEX,  1,  1, { 0xa7, 0x00, 0x00 }, 4,  2, NO_MOD,      0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_0,     P_386,           0, NULL },
{ "cmpsd",   3, { R_XMM,   R_XMM,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,             NO_VEX, NO_EVEX,  4,  1, { 0xc2, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F,   IMM_OPND_2, NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "cmpsd",   3, { R_XMM,   M_ANY,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG) | IMM8_ONLY,	                        NO_VEX, NO_EVEX,  4,  1, { 0xc2, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F,   IMM_OPND_2, MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//CMPSQ REX.W +  A5 
/* ----------------------------------------------------------------------------------------------- */
{ "cmpsq", 0, { OP_N,     OP_N       }, GP3,  (REX | REXW) | ALLOW_REP,													                        NO_VEX, NO_EVEX,  1, 1, { 0xa7, 0x00, 0x00 }, 1,  0, NO_MOD,      0, 0, 0, (X64), NO_DST,  NO_PREFIX,  NO_IMM,     NO_MEM,         P_64,           0, NULL },
{ "cmpsq", 2, { M_ANY,    M_ANY      }, GP3,  (REX | REXW) | ALLOW_REP,													                        NO_VEX, NO_EVEX,  1, 1, { 0xa7, 0x00, 0x00 }, 8,  2, NO_MOD,      0, 0, 0, (X64), NO_DST,  NO_PREFIX,  NO_IMM,     MEM_OPND_0,     P_64,           0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* CMPSS xmm1, xmm2/m32, imm8 F3 0F C2 /r ib  */
/* ----------------------------------------------------------------------------------------------- */
{ "cmpss",   3, { R_XMM,   R_XMM,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,             NO_VEX, NO_EVEX,  4,  1, { 0xc2, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F,   IMM_OPND_2, NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "cmpss",   3, { R_XMM,   M_ANY,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG) | IMM8_ONLY,	                        NO_VEX, NO_EVEX,  4,  1, { 0xc2, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F,   IMM_OPND_2, MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* PCLMULQDQ xmm1, xmm2/m32, imm8 66 0F 3A 44 /r ib  */
/* ----------------------------------------------------------------------------------------------- */
{ "pclmulqdq",   3, { R_XMM,   R_XMM,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,         NO_VEX, NO_EVEX,  4,  1, { 0x44, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F3A,   IMM_OPND_2, NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "pclmulqdq",   3, { R_XMM,   M_ANY,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG) | IMM8_ONLY,	                    NO_VEX, NO_EVEX,  4,  1, { 0x44, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F3A,   IMM_OPND_2, MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//CMPXCHG r/m8, r8           0F B0 / r
//CMPXCHG r/m8 * *, r8 REX + 0F B0 / r
//CMPXCHG r/m16, r16         0F B1 / r
//CMPXCHG r/m32, r32         0F B1 / r
//cmpxchg r/m64, r64 REX.W + 0F B1 / r
/* ----------------------------------------------------------------------------------------------- */
{ "cmpxchg",    2, { R8,       R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),           NO_VEX, NO_EVEX, 1, 1, { 0xb0, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmpxchg",    2, { R8,       R8H     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		        NO_VEX, NO_EVEX, 1, 1, { 0xb0, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmpxchg",    2, { R8H,      R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		        NO_VEX, NO_EVEX, 1, 1, { 0xb0, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmpxchg",    2, { R8H,      R8H     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | OPCODE_EXT | IMM8_ONLY),		        NO_VEX, NO_EVEX, 1, 1, { 0xb0, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmpxchg",    2, { R8E,      R8E     }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	            NO_VEX, NO_EVEX, 1, 1, { 0xb0, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmpxchg",    2, { R8,       R8E     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				              NO_VEX, NO_EVEX, 1, 1, { 0xb0, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmpxchg",    2, { R8E,      R8      }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				              NO_VEX, NO_EVEX, 1, 1, { 0xb0, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmpxchg",    2, { R8U,      R8      }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					                  NO_VEX, NO_EVEX, 1, 1, { 0xb0, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmpxchg",    2, { R8U,      R8E     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					            NO_VEX, NO_EVEX, 1, 1, { 0xb0, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmpxchg",    2, { R8,       R8U     }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),					                  NO_VEX, NO_EVEX, 1, 1, { 0xb0, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmpxchg",    2, { R16,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                      NO_VEX, NO_EVEX, 1, 1, { 0xb1, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmpxchg",    2, { R16E,     R16E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0xb1, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmpxchg",    2, { R16E,     R16     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				              NO_VEX, NO_EVEX, 1, 1, { 0xb1, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmpxchg",    2, { R16,      R16E    }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				              NO_VEX, NO_EVEX, 1, 1, { 0xb1, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmpxchg",    2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                      NO_VEX, NO_EVEX, 1, 1, { 0xb1, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                   (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "cmpxchg",    2, { R32E,     R32E    }, GP3, (REX | REXR | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0xb1, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmpxchg",    2, { R32E,     R32     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				              NO_VEX, NO_EVEX, 1, 1, { 0xb1, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmpxchg",    2, { R32,      R32E    }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				              NO_VEX, NO_EVEX, 1, 1, { 0xb1, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmpxchg",    2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                  NO_VEX, NO_EVEX, 1, 1, { 0xb1, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmpxchg",    2, { R64E,     R64E    }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),       NO_VEX, NO_EVEX, 1, 1, { 0xb1, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmpxchg",    2, { R64,      R64E    }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0xb1, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmpxchg",    2, { R64E,     R64     }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		          NO_VEX, NO_EVEX, 1, 1, { 0xb1, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                               (X64), RM_DST,  PFX_0xF, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "cmpxchg",    2, { M_ANY,    R8      }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0xb0, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,	                ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     MEM_OPND_0, P_86,  0, NULL },
{ "cmpxchg",    2, { M_ANY,    R8H     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0xb0, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,	                ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     MEM_OPND_0, P_86,  0, NULL },
{ "cmpxchg",    2, { M_ANY,    R8E     }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0xb0, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,	                            ADDR_SIZE_OVERRIDE, (X64), RM_DST,  PFX_0xF, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "cmpxchg",    2, { M_ANY,    R8U     }, GP3, ALLOW_SEG | (REX) | (F_MODRM | F_MODRM_REG),						                  NO_VEX, NO_EVEX, 1, 1, { 0xb0, 0x00, 0x00 }, 1, 0, MOD_MEM_REG, 0, 0,	                            ADDR_SIZE_OVERRIDE, (X64), RM_DST,  PFX_0xF, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "cmpxchg",    2, { M_ANY,    R16     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0xb1, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     MEM_OPND_0, P_86,  0, NULL },
{ "cmpxchg",    2, { M_ANY,    R16E    }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0xb1, 0x00, 0x00 }, 2, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	            ADDR_SIZE_OVERRIDE, (X64), RM_DST,  PFX_0xF, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "cmpxchg",    2, { M_ANY,    R32     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                              NO_VEX, NO_EVEX, 1, 1, { 0xb1, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), RM_DST,  PFX_0xF, NO_IMM,     MEM_OPND_0, P_86,  0, NULL },
{ "cmpxchg",    2, { M_ANY,    R32E    }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),	                    NO_VEX, NO_EVEX, 1, 1, { 0xb1, 0x00, 0x00 }, 4, 0, MOD_MEM_REG, 0, OP_SIZE_OVERRIDE,	            ADDR_SIZE_OVERRIDE, (X64), RM_DST,  PFX_0xF, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "cmpxchg",    2, { M_ANY,    R64     }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),			                NO_VEX, NO_EVEX, 1, 1, { 0xb1, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,				                      ADDR_SIZE_OVERRIDE, (X64), RM_DST,  PFX_0xF, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
{ "cmpxchg",    2, { M_ANY,    R64E    }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),	              NO_VEX, NO_EVEX, 1, 1, { 0xb1, 0x00, 0x00 }, 8, 0, MOD_MEM_REG, 0, 0,				                      ADDR_SIZE_OVERRIDE, (X64), RM_DST,  PFX_0xF, NO_IMM,     MEM_OPND_0, P_64,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//CMPXCHG8B m64           0F C7 / 1 m64   
//CMPXCHG16B m128 REX.W + 0F C7 / 1 m128   
/* ----------------------------------------------------------------------------------------------- */
{ "cmpxchg8b",    1, { M_ANY,         }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_RM | OPCODE_EXT),                            NO_VEX, NO_EVEX, 1, 1, { 0xc7, 0x01, 0x00 }, 8, 0, MOD_MEM_REG,    0, 0, ADDR_SIZE_OVERRIDE,        (X64), RM_DST, PFX_0xF, NO_IMM, MEM_OPND_0, P_686,  0, NULL },
{ "cmpxchg16b",   1, { M_ANY,         }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_RM | OPCODE_EXT),      NO_VEX, NO_EVEX, 1, 1, { 0xc7, 0x01, 0x00 }, 16,0, MOD_MEM_REG,    0, 0, ADDR_SIZE_OVERRIDE,        (X64), RM_DST, PFX_0xF, NO_IMM, MEM_OPND_0, P_64,  0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* COMISD xmm1, xmm2 / m64 66 0F 2F / r  */
/* ----------------------------------------------------------------------------------------------- */
{ "comisd",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 2,  1, { 0x2f, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F, NO_IMM,     NO_MEM,     P_686 | P_SSE2, 0, NULL },
{ "comisd",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 2,  1, { 0x2f, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F, NO_IMM,     MEM_OPND_1, P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* COMISS xmm1, xmm2 / m32  0F 2F / r  */
/* ----------------------------------------------------------------------------------------------- */
{ "comiss",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 4,  1, { 0x2f, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF, NO_IMM,     NO_MEM,     P_686 | P_SSE2, 0, NULL },
{ "comiss",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 4,  1, { 0x2f, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF, NO_IMM,     MEM_OPND_1, P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//CRC32 r32, r / m8      F2 0F 38 F0 / r          REX  = 40
//CRC32 r32, r / m8 *    F2 REX 0F 38 F0 / r      REXB =  1
//CRC32 r32, r / m16     F2 0F 38 F1 / r          REXX =  2
//CRC32 r32, r / m32     F2 0F 38 F1 / r          REXR =  4
//CRC32 r64, r / m8      F2 REX.W 0F 38 F0 / r    REXW =  8
//CRC32 r64, r / m64     F2 REX.W 0F 38 F1 / r
/* ----------------------------------------------------------------------------------------------- */
{ "crc32",   2, { R32,      R8      }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                          NO_VEX, NO_EVEX, 1, 1, { 0xf0, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, 0, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF2F38, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "crc32",   2, { R32,      R8H     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                                    NO_VEX, NO_EVEX, 1, 1, { 0xf0, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF2F38, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "crc32",   2, { R32,      R8E     }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xf0, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                               (X64), REG_DST,  PFX_0xF2F38, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "crc32",   2, { R32,      R8U     }, GP3, (REX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                            NO_VEX, NO_EVEX, 1, 1, { 0xf0, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0, 0,                               (X64), REG_DST,  PFX_0xF2F38, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "crc32",   2, { R32E,     R8      }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xf0, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                               (X64), REG_DST,  PFX_0xF2F38, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "crc32",   2, { R32E,     R8E     }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                NO_VEX, NO_EVEX, 1, 1, { 0xf0, 0x00, 0x00 }, 1, 0, MOD_REG_REG, 0, 0, 0,                               (X64), REG_DST,  PFX_0xF2F38, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "crc32",   2, { R32E,     R8U     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                    NO_VEX, NO_EVEX, 1, 1, { 0xf0, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0, 0,                               (X64), REG_DST,  PFX_0xF2F38, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "crc32",   2, { R64,      R8      }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),							          NO_VEX, NO_EVEX, 1, 1, { 0xf0, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, 0, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF2F38, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "crc32",   2, { R64,      R8E     }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		              NO_VEX, NO_EVEX, 1, 1, { 0xf0, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0, 0,                               (X64), REG_DST,  PFX_0xF2F38, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "crc32",   2, { R64,      R8U     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                    NO_VEX, NO_EVEX, 1, 1, { 0xf0, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0, 0,                               (X64), REG_DST,  PFX_0xF2F38, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "crc32",   2, { R64E,     R8      }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),							    NO_VEX, NO_EVEX, 1, 1, { 0xf0, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, 0, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF2F38, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "crc32",   2, { R64E,     R8U     }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		              NO_VEX, NO_EVEX, 1, 1, { 0xf0, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0, 0,                               (X64), REG_DST,  PFX_0xF2F38, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "crc32",   2, { R64E,     R8E     }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				  NO_VEX, NO_EVEX, 1, 1, { 0xf0, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, 0, 0,                   (X16 | X32 | X64), REG_DST,  PFX_0xF2F38, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "crc32",   2, { R32,      R16     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                          NO_VEX, NO_EVEX, 1, 1, { 0xf1, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE,   0,  (X16 | X32 | X64), REG_DST,  PFX_0xF2F38, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "crc32",   2, { R32E,     R16     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),							          NO_VEX, NO_EVEX, 1, 1, { 0xf1, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE,   0,  (X16 | X32 | X64), REG_DST,  PFX_0xF2F38, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "crc32",   2, { R32,      R16E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),							          NO_VEX, NO_EVEX, 1, 1, { 0xf1, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE,   0,  (X16 | X32 | X64), REG_DST,  PFX_0xF2F38, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "crc32",   2, { R32E,     R16E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),							    NO_VEX, NO_EVEX, 1, 1, { 0xf1, 0x00, 0x00 }, 2, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE,   0,  (X16 | X32 | X64), REG_DST,  PFX_0xF2F38, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "crc32",   2, { R32,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                          NO_VEX, NO_EVEX, 1, 1, { 0xf1, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                  (X16 | X32 | X64), REG_DST,  PFX_0xF2F38, NO_IMM,     NO_MEM,     P_86,  0, NULL },
{ "crc32",   2, { R32E,     R32E    }, GP3, (REX | REXB | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		              NO_VEX, NO_EVEX, 1, 1, { 0xf1, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                              (X64), REG_DST,  PFX_0xF2F38, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "crc32",   2, { R32E,     R32     }, GP3, (REX | REXR) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				                NO_VEX, NO_EVEX, 1, 1, { 0xf1, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                              (X64), REG_DST,  PFX_0xF2F38, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "crc32",   2, { R32,      R32E    }, GP3, (REX | REXB) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),				                NO_VEX, NO_EVEX, 1, 1, { 0xf1, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, OP_SIZE_OVERRIDE, 0,                              (X64), REG_DST,  PFX_0xF2F38, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "crc32",   2, { R64,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		                    NO_VEX, NO_EVEX, 1, 1, { 0xf1, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  PFX_0xF2F38, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "crc32",   2, { R64E,     R64E    }, GP3, (REX | REXR | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),          NO_VEX, NO_EVEX, 1, 1, { 0xf1, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  PFX_0xF2F38, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "crc32",   2, { R64,      R64E    }, GP3, (REX | REXB | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		              NO_VEX, NO_EVEX, 1, 1, { 0xf1, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  PFX_0xF2F38, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "crc32",   2, { R64E,     R64     }, GP3, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		              NO_VEX, NO_EVEX, 1, 1, { 0xf1, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                              (X64), REG_DST,  PFX_0xF2F38, NO_IMM,     NO_MEM,     P_64,  0, NULL },
{ "crc32",   2, { R32,      M8      }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                                NO_VEX, NO_EVEX, 4, 1, { 0xf0, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), REG_DST,  PFX_0xF2F38, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "crc32",   2, { R32,      M16     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                                NO_VEX, NO_EVEX, 2, 1, { 0xf1, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), REG_DST,  PFX_0xF2F38, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "crc32",   2, { R32,      M32     }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                                NO_VEX, NO_EVEX, 1, 1, { 0xf1, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), REG_DST,  PFX_0xF2F38, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "crc32",   2, { R64,      M8      }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				                  NO_VEX, NO_EVEX, 8, 1, { 0xf0, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), REG_DST,  PFX_0xF2F38, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "crc32",   2, { R64,      M64     }, GP3, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				                  NO_VEX, NO_EVEX, 1, 1, { 0xf1, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), REG_DST,  PFX_0xF2F38, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },
{ "crc32",   2, { R32E,     M8      }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),				                  NO_VEX, NO_EVEX, 4, 1, { 0xf0, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), REG_DST,  PFX_0xF2F38, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "crc32",   2, { R32E,     M16     }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),				                  NO_VEX, NO_EVEX, 2, 1, { 0xf1, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), REG_DST,  PFX_0xF2F38, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "crc32",   2, { R32E,     M32     }, GP3, ALLOW_SEG | (REX | REXR) | (F_MODRM | F_MODRM_REG),				                  NO_VEX, NO_EVEX, 1, 1, { 0xf1, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), REG_DST,  PFX_0xF2F38, NO_IMM    , MEM_OPND_1, P_86,  0, NULL },
{ "crc32",   2, { R64E,     M8      }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),                  NO_VEX, NO_EVEX, 8, 1, { 0xf0, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0, ADDR_SIZE_OVERRIDE, (X16 | X32 | X64), REG_DST, PFX_0xF2F38, NO_IMM, MEM_OPND_1, P_64, 0, NULL },
{ "crc32",   2, { R64E,     M64     }, GP3, ALLOW_SEG | (REX | REXW | REXR) | (F_MODRM | F_MODRM_REG),				          NO_VEX, NO_EVEX, 1, 1, { 0xf1, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,	ADDR_SIZE_OVERRIDE,  (X16 | X32 | X64), REG_DST,  PFX_0xF2F38, NO_IMM    , MEM_OPND_1, P_64,  0, NULL },

/* ----------------------------------------------------------------------------------------------- */
/* AESDEC xmm1, xmm2 / m128 66 0F 38 DE / r   */
/* ----------------------------------------------------------------------------------------------- */
{ "aesdec",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xde, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0  , 0, (X32 | X64), REG_DST, PFX_0x66F38  , NO_IMM,     NO_MEM,    P_686 | P_SSE3, 0, NULL },
{ "aesdec",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1, 1, { 0xde, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0  , 0, (X32 | X64), REG_DST, PFX_0x66F38  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE3, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* AESDECLAST xmm1, xmm2 / m128 66 0F 38 DF / r   */
/* ----------------------------------------------------------------------------------------------- */
{ "aesdeclast",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                  NO_VEX, NO_EVEX, 1, 1, { 0xdf, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0           , 0, (X32 | X64), REG_DST, PFX_0x66F38  , NO_IMM,     NO_MEM,    P_686 | P_SSE3, 0, NULL },
{ "aesdeclast",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                      NO_VEX, NO_EVEX, 1, 1, { 0xdf, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0           , 0, (X32 | X64), REG_DST, PFX_0x66F38  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE3, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* AESENC xmm1, xmm2 / m128 66 0F 38 DC / r   */
/* ----------------------------------------------------------------------------------------------- */
{ "aesenc",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xdc, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F38  , NO_IMM,     NO_MEM,    P_686 | P_SSE3, 0, NULL },
{ "aesenc",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1, 1, { 0xdc, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F38  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE3, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* AESENCLAST xmm1, xmm2 / m128 66 0F 38 DD / r  */
/* ----------------------------------------------------------------------------------------------- */
{ "aesenclast",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                  NO_VEX, NO_EVEX, 1, 1, { 0xdd, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0           , 0, (X32 | X64), REG_DST, PFX_0x66F38  , NO_IMM,     NO_MEM,    P_686 | P_SSE3, 0, NULL },
{ "aesenclast",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                      NO_VEX, NO_EVEX, 1, 1, { 0xdd, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0           , 0, (X32 | X64), REG_DST, PFX_0x66F38  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE3, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* AESIMC xmm1, xmm2 / m128 66 0F 38 DB / r   */
/* ----------------------------------------------------------------------------------------------- */
{ "aesimc",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX, 1, 1, { 0xdb, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F38  , NO_IMM,     NO_MEM,    P_686 | P_SSE3, 0, NULL },
{ "aesimc",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1, 1, { 0xdb, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F38  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE3, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* AESKEYGENASSIST xmm1, xmm2 / m128, imm8 66 0F 3A DF / r ib  */
/* ----------------------------------------------------------------------------------------------- */
{ "aeskeygenassist",    3, { R_XMM,   R_XMM,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  NO_VEX, NO_EVEX, 4, 1, { 0xdf, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F3A, IMM_OPND_2, NO_MEM,    P_686 | P_SSE1, 0, NULL },
{ "aeskeygenassist",    3, { R_XMM,   M_ANY,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG) | IMM8_ONLY,	              NO_VEX, NO_EVEX, 4, 1, { 0xdf, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F3A, IMM_OPND_2, MEM_OPND_1,P_686 | P_SSE1, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* ANDPD xmm1, xmm2 / m128A 66 0F 54 / r   */
/* ----------------------------------------------------------------------------------------------- */
{ "andpd",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX, 1, 1, { 0x54, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "andpd",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1, 1, { 0x54, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* ANDPS xmm1, xmm2 / m128 NP 0F 54 / r  */
/* ----------------------------------------------------------------------------------------------- */
{ "andps",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX, 1, 1, { 0x54, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF  , NO_IMM,     NO_MEM,    P_686 | P_SSE1, 0, NULL },
{ "andps",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX, 1, 1, { 0x54, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE1, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
/* ANDNPD xmm1, xmm2 / m128 66 0F 55 / r  */
/* ----------------------------------------------------------------------------------------------- */
{ "andnpd",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX,  1, 1, { 0x55, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "andnpd",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX,  1, 1, { 0x55, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* ANDNPS xmm1, xmm2 / m128 NP 0F 55 / r  */
/* ----------------------------------------------------------------------------------------------- */
{ "andnps",   2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX,  1, 1, { 0x55, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF  , NO_IMM,     NO_MEM,    P_686 | P_SSE1, 0, NULL },
{ "andnps",   2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX,  1, 1, { 0x55, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE1, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* CVTDQ2PD xmm1, xmm2 / m64    F3 0F E6 / r */
/* ----------------------------------------------------------------------------------------------- */
{ "cvtdq2pd", 2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX,  2, 1, { 0xe6, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "cvtdq2pd", 2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX,  2, 1, { 0xe6, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* CVTDQ2PS xmm1, xmm2 / m128    NP 0F 5B / r */
/* ----------------------------------------------------------------------------------------------- */
{ "cvtdq2ps", 2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX,  1, 1, { 0x5b, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "cvtdq2ps", 2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX,  1, 1, { 0x5b, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* CVTPD2DQ xmm1, xmm2 / m128    F2 0F E6 / r */
/* ----------------------------------------------------------------------------------------------- */
{ "cvtpd2dq", 2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX,  1, 1, { 0xe6, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "cvtpd2dq", 2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX,  1, 1, { 0xe6, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
/* CVTPD2PS xmm1, xmm2 / m128    66 0F 5A / r */
/* ----------------------------------------------------------------------------------------------- */
{ "cvtpdps", 2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX,  1, 1, { 0x5a, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "cvtpdps", 2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX,  1, 1, { 0x5a, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//CVTPS2PD xmm1, xmm2 / m64    NP 0F 5A / r
/* ----------------------------------------------------------------------------------------------- */
{ "cvtps2pd", 2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                      NO_VEX, NO_EVEX,  1, 1, { 0x5a, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "cvtps2pd", 2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                          NO_VEX, NO_EVEX,  2, 1, { 0x5a, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//CVTSD2SI r32, xmm1 / m64    F2 0F 2D / r
//CVTSD2SI r64, xmm1 / m64    F2 REX.W 0F 2D / r
/* ----------------------------------------------------------------------------------------------- */
{ "cvtsd2si", 2, { R32,      R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX,  2, 1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "cvtsd2si", 2, { R32E,     R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                        NO_VEX, NO_EVEX,  2, 1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "cvtsd2si", 2, { R32,      M64         }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                            NO_VEX, NO_EVEX,  2, 1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
{ "cvtsd2si", 2, { R32,      M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                            NO_VEX, NO_EVEX,  2, 1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
{ "cvtsd2si", 2, { R64,      R_XMM       }, SSE0, (EREX) | (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	          NO_VEX, NO_EVEX,  2, 1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "cvtsd2si", 2, { R64E,     R_XMM       }, SSE0, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	            NO_VEX, NO_EVEX,  2, 1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "cvtsd2si", 2, { R64,      M_ANY       }, SSE0, (EREX) | (REX | REXW) | (F_MODRM | F_MODRM_REG),						            NO_VEX, NO_EVEX,  2, 1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//CVTSD2SS xmm1, xmm2/m64    F2 0F 5A /r
/* ----------------------------------------------------------------------------------------------- */
{ "cvtsd2ss", 2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	NO_VEX, NO_EVEX,  1, 1, { 0x5a, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "cvtsd2ss", 2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						    NO_VEX, NO_EVEX,  2, 1, { 0x5a, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//CVTSS2SD xmm1, xmm2 / m32    F3 0F 5A / r
{ "cvtss2sd", 2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	NO_VEX, NO_EVEX,  1, 1, { 0x5a, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "cvtss2sd", 2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						    NO_VEX, NO_EVEX,  4, 1, { 0x5a, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//CVTSS2SI r32, xmm1 / m32    F3 0F 2D / r
//CVTSS2SI r64, xmm1 / m32    F3 REX.W 0F 2D / r
/* ----------------------------------------------------------------------------------------------- */
{ "cvtss2si", 2, { R32,      R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                          NO_VEX, NO_EVEX,  4, 1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "cvtss2si", 2, { R32E,     R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                          NO_VEX, NO_EVEX,  4, 1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "cvtss2si", 2, { R32,      M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                              NO_VEX, NO_EVEX,  4, 1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
{ "cvtss2si", 2, { R64,      R_XMM       }, SSE0, (EREX) | (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	            NO_VEX, NO_EVEX,  4, 1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "cvtss2si", 2, { R64E,     R_XMM       }, SSE0, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	              NO_VEX, NO_EVEX,  4, 1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "cvtss2si", 2, { R64,      M32         }, SSE0, (EREX) | (REX | REXW) | (F_MODRM | F_MODRM_REG),						              NO_VEX, NO_EVEX,  4, 1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
{ "cvtss2si", 2, { R64,      M_ANY       }, SSE0, (EREX) | (REX | REXW) | (F_MODRM | F_MODRM_REG),						              NO_VEX, NO_EVEX,  4, 1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//CVTTPD2DQ xmm1, xmm2 / m128    66 0F E6 / r
/* ----------------------------------------------------------------------------------------------- */
{ "cvttpd2dq", 2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	  NO_VEX, NO_EVEX,  1, 1, { 0xe6, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F, NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "cvttpd2dq", 2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						    NO_VEX, NO_EVEX,  1, 1, { 0xe6, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F, NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//CVTTPS2DQ xmm1, xmm2 / m128    F3 0F 5B / r
 /* ----------------------------------------------------------------------------------------------- */
{ "cvttps2dq", 2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	  NO_VEX, NO_EVEX,  1, 1, { 0x5b, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F, NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "cvttps2dq", 2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						    NO_VEX, NO_EVEX,  1, 1, { 0x5b, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F, NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//CVTTSD2SI r32, xmm1 / m64    F2 0F 2C / r
//CVTTSD2SI r64, xmm1 / m64    F2 REX.W 0F 2C / r
/* ----------------------------------------------------------------------------------------------- */
{ "cvttsd2si", 2, { R32,      R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                          NO_VEX, NO_EVEX,  2, 1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "cvttsd2si", 2, { R32E,     R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                          NO_VEX, NO_EVEX,  2, 1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "cvttsd2si", 2, { R32,      M64         }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                            NO_VEX, NO_EVEX,  2, 1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
{ "cvttsd2si", 2, { R32,      M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                            NO_VEX, NO_EVEX,  2, 1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
{ "cvttsd2si", 2, { R64,      R_XMM       }, SSE0, (EREX) | (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	          NO_VEX, NO_EVEX,  2, 1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "cvttsd2si", 2, { R64E,     R_XMM       }, SSE0, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	            NO_VEX, NO_EVEX,  2, 1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "cvttsd2si", 2, { R64,      M64         }, SSE0, (EREX) | (REX | REXW) | (F_MODRM | F_MODRM_REG),						              NO_VEX, NO_EVEX,  2, 1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
{ "cvttsd2si", 2, { R64,      M_ANY       }, SSE0, (EREX) | (REX | REXW) | (F_MODRM | F_MODRM_REG),						              NO_VEX, NO_EVEX,  2, 1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF20F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//CVTTSS2SI r32, xmm1/m32  F3 0F 2C /r
//CVTTSS2SI r64, xmm1/m32  F3 REX.W 0F 2C /r
/* ----------------------------------------------------------------------------------------------- */
{ "cvttss2si", 2, { R32,      R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                          NO_VEX, NO_EVEX,  4, 1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "cvttss2si", 2, { R32E,     R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	                          NO_VEX, NO_EVEX,  4, 1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "cvttss2si", 2, { R32,      M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						                            NO_VEX, NO_EVEX,  4, 1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
{ "cvttss2si", 2, { R64,      R_XMM       }, SSE0, (EREX) | (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	          NO_VEX, NO_EVEX,  4, 1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "cvttss2si", 2, { R64E,     R_XMM       }, SSE0, (REX | REXR | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	            NO_VEX, NO_EVEX,  4, 1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F  , NO_IMM,     NO_MEM,    P_686 | P_SSE2, 0, NULL },
{ "cvttss2si", 2, { R64,      M32         }, SSE0, (EREX) | (REX | REXW) | (F_MODRM | F_MODRM_REG),						              NO_VEX, NO_EVEX,  4, 1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
{ "cvttss2si", 2, { R64,      M_ANY       }, SSE0, (EREX) | (REX | REXW) | (F_MODRM | F_MODRM_REG),						              NO_VEX, NO_EVEX,  4, 1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//DPPD xmm1, xmm2 / m128, imm8    66 0F 3A 41 / r ib
/* ----------------------------------------------------------------------------------------------- */
{ "dppd",    3, { R_XMM,   R_XMM,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,   NO_VEX, NO_EVEX, 1, 1, { 0x41, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F3A, IMM_OPND_2, NO_MEM,    P_686 | P_SSE1, 0, NULL },
{ "dppd",    3, { R_XMM,   M_ANY,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG) | IMM8_ONLY,	              NO_VEX, NO_EVEX, 1, 1, { 0x41, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F3A, IMM_OPND_2, MEM_OPND_1,P_686 | P_SSE1, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//DPPS xmm1, xmm2 / m128, imm8 66 0F 3A 40 / r ib
/* ----------------------------------------------------------------------------------------------- */
{ "dpps",    3, { R_XMM,   R_XMM,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,   NO_VEX, NO_EVEX, 1, 1, { 0x40, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F3A, IMM_OPND_2, NO_MEM,    P_686 | P_SSE1, 0, NULL },
{ "dpps",    3, { R_XMM,   M_ANY,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG) | IMM8_ONLY,	              NO_VEX, NO_EVEX, 1, 1, { 0x40, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F3A, IMM_OPND_2, MEM_OPND_1,P_686 | P_SSE1, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//EXTRACTPS reg / m32, xmm1, imm8    66 0F 3A 17 / r ib
/* ----------------------------------------------------------------------------------------------- */
{ "extractps",    3, { R32,   R_XMM,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,                  NO_VEX, NO_EVEX, 4, 1, { 0x17, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST, PFX_0x66F3A, IMM_OPND_2, NO_MEM,     P_686 | P_SSE2, 0, NULL },
{ "extractps",    3, { R32E,  R_XMM,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,                  NO_VEX, NO_EVEX, 4, 1, { 0x17, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST, PFX_0x66F3A, IMM_OPND_2, NO_MEM,     P_686 | P_SSE2, 0, NULL },
{ "extractps",    3, { M32,   R_XMM,  IMM8 }, SSE0, (EREX) | ALLOW_SEG | (F_MODRM | F_MODRM_REG) | IMM8_ONLY,	                  NO_VEX, NO_EVEX, 4, 1, { 0x17, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0, 0, (X32 | X64), RM_DST, PFX_0x66F3A, IMM_OPND_2, MEM_OPND_0, P_686 | P_SSE2, 0, NULL },
{ "extractps",    3, { M_ANY, R_XMM,  IMM8 }, SSE0, (EREX) | ALLOW_SEG | (F_MODRM | F_MODRM_REG) | IMM8_ONLY,	                  NO_VEX, NO_EVEX, 4, 1, { 0x17, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0, 0, (X32 | X64), RM_DST, PFX_0x66F3A, IMM_OPND_2, MEM_OPND_0, P_686 | P_SSE2, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//INSERTPS xmm1, xmm2 / m32, imm8  66 0F 3A 21 / r ib
/* ----------------------------------------------------------------------------------------------- */
{ "insertps",    3, { R_XMM,   R_XMM,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,    NO_VEX, NO_EVEX, 4, 1, { 0x21, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F3A, IMM_OPND_2, NO_MEM,    P_686 | P_SSE1, 0, NULL },
{ "insertps",    3, { R_XMM,   M_ANY,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG) | IMM8_ONLY,	               NO_VEX, NO_EVEX, 4, 1, { 0x21, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F3A, IMM_OPND_2, MEM_OPND_1,P_686 | P_SSE1, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//MOVD mm, r / m32    NP 0F 6E / r
//MOVD r / m32, mm    NP 0F 7E / r
//MOVD xmm, r / m32    66 0F 6E / r
//MOVD r / m32, xmm    66 0F 7E / r
/* ----------------------------------------------------------------------------------------------- */
{ "movd",    2, { MMX64,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		          NO_VEX, NO_EVEX, 2, 1, { 0x6e, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_1,P_686 | P_MMX, 0, NULL },
{ "movd",    2, { MMX64,    R32E        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM), NO_VEX, NO_EVEX, 2, 1, { 0x6e, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,    P_686 | P_MMX, 0, NULL },
{ "movd",    2, { MMX64,    R32         }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM), NO_VEX, NO_EVEX, 2, 1, { 0x6e, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     NO_MEM,    P_686 | P_MMX, 0, NULL },
{ "movd",    2, { R32E,     MMX64       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	NO_VEX, NO_EVEX, 2, 1, { 0x7e, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST, PFX_0xF,     NO_IMM,     NO_MEM,    P_686 | P_MMX, 0, NULL },
{ "movd",    2, { R32,      MMX64       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	NO_VEX, NO_EVEX, 2, 1, { 0x7e, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST, PFX_0xF,     NO_IMM,     NO_MEM,    P_686 | P_MMX, 0, NULL },
{ "movd",    2, { M_ANY,    MMX64       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	NO_VEX, NO_EVEX, 2, 1, { 0x7e, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,    NO_IMM,     MEM_OPND_0,P_686 | P_MMX, 0, NULL },
{ "movd",    2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		          NO_VEX, NO_EVEX, 4, 1, { 0x6e, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_1,P_686 | P_SSE2,0, NULL },
{ "movd",    2, { R_XMM,    R32E        }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM), NO_VEX, NO_EVEX, 4, 1, { 0x6e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,    P_686 | P_SSE2,0, NULL },
{ "movd",    2, { R_XMM,    R32         }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM), NO_VEX, NO_EVEX, 4, 1, { 0x6e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     NO_MEM,    P_686 | P_SSE2,0, NULL },
{ "movd",    2, { R32E,     R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM), NO_VEX, NO_EVEX, 4, 1, { 0x7e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST,  PFX_0x66F,  NO_IMM,     NO_MEM,    P_686 | P_SSE2,0, NULL },
{ "movd",    2, { R32,      R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM), NO_VEX, NO_EVEX, 4, 1, { 0x7e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST,  PFX_0x66F,  NO_IMM,     NO_MEM,    P_686 | P_SSE2,0, NULL },
{ "movd",    2, { M_ANY,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	NO_VEX, NO_EVEX, 4, 1, { 0x7e, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,  NO_IMM,     MEM_OPND_0,P_686 | P_SSE2,0, NULL },
/* masm compatibility */
{ "movd",    2, { MMX64,    M64         }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                         NO_VEX, NO_EVEX, 1, 1, { 0x6f, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,     NO_IMM,     MEM_OPND_1,P_686 | P_MMX, 0, NULL },
{ "movd",    2, { MMX64,    R64         }, SSE0, (EREX) | (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM), NO_VEX, NO_EVEX, 1, 1, { 0x6e, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,     NO_IMM,     NO_MEM,    P_686 | P_MMX, 0, NULL },
{ "movd",    2, { MMX64,    R64E        }, SSE0, (EREX) | (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM), NO_VEX, NO_EVEX, 1, 1, { 0x6e, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,     NO_IMM,     NO_MEM,    P_686 | P_MMX, 0, NULL },
{ "movd",    2, { MMX64,    MMX64       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0x6f, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,     NO_IMM,     NO_MEM,    P_686 | P_MMX, 0, NULL },
{ "movd",    2, { R64,      MMX64       }, SSE0, (EREX) | (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM), NO_VEX, NO_EVEX, 1, 1, { 0x7e, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST,  PFX_0xF,     NO_IMM,     NO_MEM,    P_686 | P_MMX, 0, NULL },
{ "movd",    2, { R64E,     MMX64       }, SSE0, (EREX) | (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM), NO_VEX, NO_EVEX, 1, 1, { 0x7e, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST,  PFX_0xF,     NO_IMM,     NO_MEM,    P_686 | P_MMX, 0, NULL },
{ "movd",    2, { M_ANY,    MMX64       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0x7f, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), RM_DST,  PFX_0xF,     NO_IMM,     MEM_OPND_0,P_686 | P_MMX, 0, NULL },
{ "movd",    2, { R_XMM,    M64         }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                         NO_VEX, NO_EVEX, 2, 1, { 0x7e, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F,  NO_IMM,     MEM_OPND_1,P_686 | P_SSE2,0, NULL },
{ "movd",    2, { R_XMM,    R64         }, SSE0, (EREX) | (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM), NO_VEX, NO_EVEX, 2, 1, { 0x6e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,   NO_IMM,     NO_MEM,    P_686 | P_SSE2,0, NULL },
{ "movd",    2, { R_XMM,    R64E        }, SSE0, (EREX) | (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM), NO_VEX, NO_EVEX, 2, 1, { 0x6e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,   NO_IMM,     NO_MEM,    P_686 | P_SSE2,0, NULL },
{ "movd",    2, { R64,      R_XMM       }, SSE0, (EREX) | (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM), NO_VEX, NO_EVEX, 2, 1, { 0x7e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST,  PFX_0x66F,   NO_IMM,     NO_MEM,    P_686 | P_SSE2,0, NULL },
{ "movd",    2, { R64E,     R_XMM       }, SSE0, (EREX) | (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM), NO_VEX, NO_EVEX, 2, 1, { 0x7e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST,  PFX_0x66F,   NO_IMM,     NO_MEM,    P_686 | P_SSE2,0, NULL },
{ "movd",    2, { M_ANY,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                NO_VEX, NO_EVEX, 2, 1, { 0xd6, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0, 0, (X32 | X64), RM_DST,  PFX_0x66F,   NO_IMM,     MEM_OPND_0,P_686 | P_SSE2,0, NULL },
{ "movd",    2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0x7e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F,  NO_IMM,     NO_MEM,    P_686 | P_MMX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//CVTSI2SS xmm1, r/m32 F3 0F 2A /r
//CVTSI2SS xmm1, r/m64 F3 REX.W 0F 2A /r
  /* ----------------------------------------------------------------------------------------------- */
{ "cvtsi2ss",       2, { R_XMM,    R32                }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                     NO_VEX, NO_EVEX, 4, 1, { 0x2a, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F,  NO_IMM,     NO_MEM,    P_686 | P_SSE2,0, NULL },
{ "cvtsi2ss",       2, { R_XMM,    M32                }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                          NO_VEX, NO_EVEX, 4, 1, { 0x2a, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F,  NO_IMM,     MEM_OPND_1,P_686 | P_SSE2,0, NULL },
{ "cvtsi2ss",       2, { R_XMM,    M_ANY              }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                          NO_VEX, NO_EVEX, 4, 1, { 0x2a, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F,  NO_IMM,     MEM_OPND_1,P_686 | P_SSE2,0, NULL },
{ "cvtsi2ss",       2, { R_XMM,    R64                }, SSE0, (EREX | REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),        NO_VEX, NO_EVEX, 2, 1, { 0x2a, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X64),       REG_DST, PFX_0xF30F,  NO_IMM,     NO_MEM,    P_686 | P_SSE2,0, NULL },
{ "cvtsi2ss",       2, { R_XMM,    M64                }, SSE0, (EREX | REX | REXW) | (F_MODRM | F_MODRM_REG),		              NO_VEX, NO_EVEX, 2, 1, { 0x2a, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F,  NO_IMM,     MEM_OPND_1,P_686 | P_SSE2,0, NULL },
{ "cvtsi2ss",       2, { R_XMM,    R32E               }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                     NO_VEX, NO_EVEX, 4, 1, { 0x2a, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F,  NO_IMM,     NO_MEM,    P_686 | P_SSE2,0, NULL },
{ "cvtsi2ss",       2, { R_XMM,    R64E               }, SSE0, (EREX | REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),        NO_VEX, NO_EVEX, 4, 1, { 0x2a, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F,  NO_IMM,     NO_MEM,    P_686 | P_SSE2,0, NULL },//MOVQ mm, r / m64    NP REX.W + 0F 6E / r
   /* ----------------------------------------------------------------------------------------------- */
 //MOVQ r / m64, mm    NP REX.W + 0F 7E / r
  //MOVQ xmm, r / m64    66 REX.W 0F 6E / r
  //MOVQ r / m64, xmm    66 REX.W 0F 7E / r
  /* ----------------------------------------------------------------------------------------------- */
{ "movq",    2, { MMX64,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                         NO_VEX, NO_EVEX, 1, 1, { 0x6f, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,     NO_IMM,     MEM_OPND_1,P_686 | P_MMX, 0, NULL },
{ "movq",    2, { MMX64,    R64         }, SSE0, (EREX) | (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM), NO_VEX, NO_EVEX, 1, 1, { 0x6e, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,     NO_IMM,     NO_MEM,    P_686 | P_MMX, 0, NULL },
{ "movq",    2, { MMX64,    R64E        }, SSE0, (EREX) | (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM), NO_VEX, NO_EVEX, 1, 1, { 0x6e, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,     NO_IMM,     NO_MEM,    P_686 | P_MMX, 0, NULL },
{ "movq",    2, { MMX64,    MMX64       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0x6f, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF,     NO_IMM,     NO_MEM,    P_686 | P_MMX, 0, NULL },
{ "movq",    2, { R64,      MMX64       }, SSE0, (EREX) | (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM), NO_VEX, NO_EVEX, 1, 1, { 0x7e, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST,  PFX_0xF,     NO_IMM,     NO_MEM,    P_686 | P_MMX, 0, NULL },
{ "movq",    2, { R64E,     MMX64       }, SSE0, (EREX) | (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM), NO_VEX, NO_EVEX, 1, 1, { 0x7e, 0x00, 0x00 }, 8,  1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST,  PFX_0xF,     NO_IMM,     NO_MEM,    P_686 | P_MMX, 0, NULL },
{ "movq",    2, { M_ANY,    MMX64       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0x7f, 0x00, 0x00 }, 8,  1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), RM_DST,  PFX_0xF,     NO_IMM,     MEM_OPND_0,P_686 | P_MMX, 0, NULL },
{ "movq",    2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),		                         NO_VEX, NO_EVEX, 2, 1, { 0x7e, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F,  NO_IMM,     MEM_OPND_1,P_686 | P_SSE2,0, NULL },
{ "movq",    2, { R_XMM,    R64         }, SSE0, (EREX) | (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM), NO_VEX, NO_EVEX, 2, 1, { 0x6e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,   NO_IMM,     NO_MEM,    P_686 | P_SSE2,0, NULL },
{ "movq",    2, { R_XMM,    R64E        }, SSE0, (EREX) | (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM), NO_VEX, NO_EVEX, 2, 1, { 0x6e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F,   NO_IMM,     NO_MEM,    P_686 | P_SSE2,0, NULL },
{ "movq",    2, { R64,      R_XMM       }, SSE0, (EREX) | (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM), NO_VEX, NO_EVEX, 2, 1, { 0x7e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST,  PFX_0x66F,   NO_IMM,     NO_MEM,    P_686 | P_SSE2,0, NULL },
{ "movq",    2, { R64E,     R_XMM       }, SSE0, (EREX) | (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM), NO_VEX, NO_EVEX, 2, 1, { 0x7e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST,  PFX_0x66F,   NO_IMM,     NO_MEM,    P_686 | P_SSE2,0, NULL },
{ "movq",    2, { M_ANY,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                NO_VEX, NO_EVEX, 2, 1, { 0xd6, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0, 0, (X32 | X64), RM_DST,  PFX_0x66F,   NO_IMM,     MEM_OPND_0,P_686 | P_SSE2,0, NULL },
{ "movq",    2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),                NO_VEX, NO_EVEX, 1, 1, { 0x7e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0xF30F,  NO_IMM,     NO_MEM,    P_686 | P_MMX, 0, NULL },
//BLENDPS xmm1, xmm2 / m128, imm8 66 0F 3A 0C / r ib
{ "blendps",   3, { R_XMM,   R_XMM,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY, NO_VEX, NO_EVEX, 1, 1, { 0x0c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F3A  , IMM_OPND_2, NO_MEM,    P_686 | P_SSE4, 0, NULL },
{ "blendps",   3, { R_XMM,   M_ANY,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG) | IMM8_ONLY,	            NO_VEX, NO_EVEX, 1, 1, { 0x0c, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F3A  , IMM_OPND_2, MEM_OPND_1,P_686 | P_SSE4, 0, NULL },
//BLENDPD xmm1, xmm2 / m128, imm8 66 0F 3A 0D / r ib
{ "blendpd",   3, { R_XMM,   R_XMM,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY, NO_VEX, NO_EVEX, 1, 1, { 0x0d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F3A  , IMM_OPND_2, NO_MEM,    P_686 | P_SSE4, 0, NULL },
{ "blendpd",   3, { R_XMM,   M_ANY,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG) | IMM8_ONLY,	            NO_VEX, NO_EVEX, 1, 1, { 0x0d, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F3A  , IMM_OPND_2, MEM_OPND_1,P_686 | P_SSE4, 0, NULL },
//BLENDVPS xmm1, xmm2 / m128, <XMM0> 66 0F 38 14 / r
{ "blendvps",  2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),             NO_VEX, NO_EVEX, 1, 1, { 0x14, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F38  , NO_IMM,     NO_MEM,    P_686 | P_SSE4, 0, NULL },
{ "blendvps",  2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						              NO_VEX, NO_EVEX, 1, 1, { 0x14, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F38  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE4, 0, NULL },
//BLENDVPD xmm1, xmm2 / m128, <XMM0> 66 0F 38 15 / r
{ "blendvpd",  2, { R_XMM,    R_XMM       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),	            NO_VEX, NO_EVEX, 1, 1, { 0x15, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F38  , NO_IMM,     NO_MEM,    P_686 | P_SSE4, 0, NULL },
{ "blendvpd",  2, { R_XMM,    M_ANY       }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG),						              NO_VEX, NO_EVEX, 1, 1, { 0x15, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F38  , NO_IMM,     MEM_OPND_1,P_686 | P_SSE4, 0, NULL },
//MPSADBW xmm1, xmm2 / m128, imm8 66 0F 3A 42 / r ib
{ "mpsadbw",   3, { R_XMM,   R_XMM,  IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY, NO_VEX, NO_EVEX, 1, 1, { 0x42, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F3A  , IMM_OPND_2, NO_MEM,    P_686 | P_SSE4, 0, NULL },
{ "mpsadbw",   3, { R_XMM,    M_ANY, IMM8 }, SSE0, (EREX) | (F_MODRM | F_MODRM_REG) | IMM8_ONLY,              NO_VEX, NO_EVEX, 1, 1, { 0x42, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, PFX_0x66F3A  , IMM_OPND_2, MEM_OPND_1,P_686 | P_SSE4, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* VMOVD */
/* -----------------------------------------------------------------------------------------------
VMOVD xmm1, r32/m32	VEX.128.66.0F.W0 6E /
VMOVD r32/m32, xmm1	VEX.128.66.0F.W0 7E /r
VMOVD xmm1, r32/m32	EVEX.128.66.0F.W0 6E /r
VMOVD r32/m32, xmm1	EVEX.128.66.0F.W0 7E /r
*/
{ "vmovd", 2, { R_XMM,   R32_EAX                 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),  (VEX | VEX_66 | VEX_W0 | VEX_0F | VEX_2OPND | EVEX),           (EVEX_W0),			       1, 1, { 0x6e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmovd", 2, { R_XMM,   R32_ECX                 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),  (VEX | VEX_66 | VEX_W0 | VEX_0F | VEX_2OPND | EVEX),           (EVEX_W0),			       1, 1, { 0x6e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmovd", 2, { R_XMM,   R32                     }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),  (VEX | VEX_66 | VEX_W0 | VEX_0F | VEX_2OPND | EVEX),           (EVEX_W0),			       1, 1, { 0x6e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmovd", 2, { R_XMM,   R32E                    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),  (VEX | VEX_66 | VEX_W0 | VEX_0F | VEX_2OPND | EVEX),           (EVEX_W0),			       1, 1, { 0x6e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmovd", 2, { R_XMM,   M32                     }, AVX0, (F_MODRM | F_MODRM_REG),						   (VEX | VEX_66 | VEX_W0 | VEX_0F | VEX_2OPND | EVEX),           (EVEX_W0),             4, 1, { 0x6e, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vmovd", 2, { R_XMM,   M_ANY                   }, AVX0, (F_MODRM | F_MODRM_REG),						   (VEX | VEX_66 | VEX_W0 | VEX_0F | VEX_2OPND | EVEX),           (EVEX_W0),             4, 1, { 0x6e, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vmovd", 2, { M32,     R_XMM                   }, AVX0, (F_MODRM | F_MODRM_REG),						   (VEX | VEX_66 | VEX_W0 | VEX_0F | VEX_2OPND | EVEX),	          (EVEX_W0),             4, 1, { 0x7e, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0, 0, (X32 | X64), RM_DST,   NO_PREFIX, NO_IMM,     MEM_OPND_0, P_686 | P_AVX, 0, NULL },
{ "vmovd", 2, { M_ANY,   R_XMM                   }, AVX0, (F_MODRM | F_MODRM_REG),						   (VEX | VEX_66 | VEX_W0 | VEX_0F | VEX_2OPND | EVEX),	          (EVEX_W0),             4, 1, { 0x7e, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0, 0, (X32 | X64), RM_DST,   NO_PREFIX, NO_IMM,     MEM_OPND_0, P_686 | P_AVX, 0, NULL },
{ "vmovd", 2, { R32,     R_XMM                   }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),	 (VEX | VEX_66 | VEX_W0 | VEX_0F | VEX_2OPND | EVEX),           (EVEX_W0),             1, 1, { 0x7e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST,   NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmovd", 2, { R32E,    R_XMM                   }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),	 (VEX | VEX_66 | VEX_W0 | VEX_0F | VEX_2OPND | EVEX),           (EVEX_W0),             1, 1, { 0x7e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST,   NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmovd", 2, { R32_EAX, R_XMM                   }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),	 (VEX | VEX_66 | VEX_W0 | VEX_0F | VEX_2OPND | EVEX),           (EVEX_W0),             1, 1, { 0x7e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST,   NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmovd", 2, { R32_ECX, R_XMM                   }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),	 (VEX | VEX_66 | VEX_W0 | VEX_0F | VEX_2OPND | EVEX),           (EVEX_W0),             1, 1, { 0x7e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST,   NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
/* VMOVQ */
/* -----------------------------------------------------------------------------------------------
VMOVQ xmm1, r64/m64	VEX.128.66.0F.W1 6E /r       
VMOVQ r64/m64, xmm1	VEX.128.66.0F.W1 7E /r
VMOVQ xmm1, r64/m64	EVEX.128.66.0F.W1 6E /r
VMOVQ r64/m64, xmm1	EVEX.128.66.0F.W1 7E /r
*/
{ "vmovq", 2, { R_XMM,   R_XMME                  }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),	 (VEX | VEX_66 | VEX_WIG | VEX_0F | VEX_2OPND),                 (NO_EVEX),             1, 1, { 0xd6, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST,   NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmovq", 2, { R_XMM,   R64_RAX                 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),  (VEX | VEX_66 | VEX_W1 | VEX_0F | VEX_2OPND | EVEX),           (EVEX_W1),			       1, 1, { 0x6e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmovq", 2, { R_XMM,   R64_RCX                 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),  (VEX | VEX_66 | VEX_W1 | VEX_0F | VEX_2OPND | EVEX),           (EVEX_W1),			       1, 1, { 0x6e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmovq", 2, { R_XMM,   R64                     }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),  (VEX | VEX_66 | VEX_W1 | VEX_0F | VEX_2OPND | EVEX),           (EVEX_W1),			       1, 1, { 0x6e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmovq", 2, { R_XMM,   R64E                    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),  (VEX | VEX_66 | VEX_W1 | VEX_0F | VEX_2OPND | EVEX),           (EVEX_W1),			       1, 1, { 0x6e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmovq", 2, { R_XMM,   M64                     }, AVX0, (F_MODRM | F_MODRM_REG),						   (VEX | VEX_66 | VEX_W1 | VEX_0F | VEX_2OPND | EVEX),           (EVEX_W1),             2, 1, { 0x6e, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vmovq", 2, { R_XMM,   M_ANY                   }, AVX0, (F_MODRM | F_MODRM_REG),						   (VEX | VEX_66 | VEX_W1 | VEX_0F | VEX_2OPND | EVEX),           (EVEX_W1),             2, 1, { 0x6e, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vmovq", 2, { M64,     R_XMM                   }, AVX0, (F_MODRM | F_MODRM_REG),						   (VEX | VEX_66 | VEX_W1 | VEX_0F | VEX_2OPND | EVEX),	          (EVEX_W1),             2, 1, { 0x7e, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0, 0, (X32 | X64), RM_DST,   NO_PREFIX, NO_IMM,     MEM_OPND_0, P_686 | P_AVX, 0, NULL },
{ "vmovq", 2, { M_ANY,   R_XMM                   }, AVX0, (F_MODRM | F_MODRM_REG),						   (VEX | VEX_66 | VEX_W1 | VEX_0F | VEX_2OPND | EVEX),	          (EVEX_W1),             2, 1, { 0x7e, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0, 0, (X32 | X64), RM_DST,   NO_PREFIX, NO_IMM,     MEM_OPND_0, P_686 | P_AVX, 0, NULL },
{ "vmovq", 2, { R64,     R_XMM                   }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),	 (VEX | VEX_66 | VEX_W1 | VEX_0F | VEX_2OPND | EVEX),           (EVEX_W1),             1, 1, { 0x7e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST,   NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmovq", 2, { R64E,    R_XMM                   }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),	 (VEX | VEX_66 | VEX_W1 | VEX_0F | VEX_2OPND | EVEX),           (EVEX_W1),             1, 1, { 0x7e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST,   NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmovq", 2, { R64_RAX, R_XMM                   }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),	 (VEX | VEX_66 | VEX_W1 | VEX_0F | VEX_2OPND | EVEX),           (EVEX_W1),             1, 1, { 0x7e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST,   NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmovq", 2, { R64_RCX, R_XMM                   }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),	 (VEX | VEX_66 | VEX_W1 | VEX_0F | VEX_2OPND | EVEX),           (EVEX_W1),             1, 1, { 0x7e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST,   NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmovq", 2, { R_XMM,   R_XMM                   }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),	 (VEX | VEX_F3 | VEX_WIG | VEX_0F | VEX_2OPND | EVEX),          (EVEX_W1),             1, 1, { 0x7e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* VHADDPD */
/* ----------------------------------------------------------------------------------------------- */
{ "vhaddpd",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),            (NO_EVEX),             1,  1, { 0x7c, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vhaddpd",  3, { R_XMM,  R_XMM, M_ANY             }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),            (NO_EVEX),             1,  1, { 0x7c, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vhaddpd",  3, { R_YMM,  R_YMM, R_YMM             }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),            (NO_EVEX),             1,  1, { 0x7c, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vhaddpd",  3, { R_YMM,  R_YMM, M_ANY             }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),            (NO_EVEX),             1,  1, { 0x7c, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* special implicit NDS forms */
{ "vhaddpd",  2, { R_XMM,  R_XMM                    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_DUP_NDS),        (NO_EVEX),             1,  1, { 0x7c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vhaddpd",  2, { R_YMM,  R_YMM                    }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_DUP_NDS),        (NO_EVEX),             1,  1, { 0x7c, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* VHADDPS */
/* ----------------------------------------------------------------------------------------------- */
{ "vhaddps",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_F2 | VEX_WIG | VEX_0F | VEX_NDS | EVEX),     (NO_EVEX),             1,  1, { 0x58, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vhaddps",  3, { R_XMM,  R_XMM, M_ANY             }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_F2 | VEX_WIG | VEX_0F | VEX_NDS | EVEX),     (NO_EVEX),             1,  1, { 0x58, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vhaddps",  3, { R_YMM,  R_YMM, R_YMM             }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_F2 | VEX_WIG | VEX_0F | VEX_NDS | EVEX),     (NO_EVEX),             1,  1, { 0x58, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vhaddps",  3, { R_YMM,  R_YMM, M_ANY             }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_F2 | VEX_WIG | VEX_0F | VEX_NDS | EVEX),     (NO_EVEX),             1,  1, { 0x58, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* special implicit NDS forms */
{ "vhaddps",  2, { R_XMM,  R_XMM                    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_F2 | VEX_WIG | VEX_0F | VEX_DUP_NDS),        (NO_EVEX),             1,  1, { 0x58, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vhaddps",  2, { R_YMM,  R_YMM                    }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_F2 | VEX_WIG | VEX_0F | VEX_DUP_NDS),        (NO_EVEX),             1,  1, { 0x58, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
/* VADDPD */
/* -----------------------------------------------------------------------------------------------
 VADDPD xmm1, xmm2, xmm3 / m128  VEX.128.66.0F.WIG 58 / r
 VADDPD ymm1, ymm2, ymm3 / m256  VEX.256.66.0F.WIG 58 / r
 VADDPD xmm1{k1}{z}, xmm2, xmm3 / m128 / m64bcst EVEX.128.66.0F.W1 58 / r
 VADDPD ymm1{k1}{z}, ymm2, ymm3 / m256 / m64bcst EVEX.256.66.0F.W1 58 / r
 VADDPD zmm1{k1}{z}, zmm2, zmm3 / m512 / m64bcst{er}EVEX.512.66.0F.W1 58 / r
 */
{ "vaddpd",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x58, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vaddpd",  3, { R_XMM,  R_XMM, M128              }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x58, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vaddpd",  3, { R_XMM,  R_XMM, M_ANY             }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),             2,  1, { 0x58, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vaddpd",  3, { R_YMM,  R_YMM, R_YMM             }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x58, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vaddpd",  3, { R_YMM,  R_YMM, M256              }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x58, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vaddpd",  3, { R_YMM,  R_YMM, M_ANY             }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),             4,  1, { 0x58, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* special implicit NDS forms */
{ "vaddpd",  2, { R_XMM,  R_XMM                    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                             1,  1, { 0x58, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vaddpd",  2, { R_YMM,  R_YMM                    }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                             1,  1, { 0x58, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vaddpd",  3, { R_ZMM,  R_ZMM, R_ZMM             }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (EVEX | VEX_66 | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_RND), 1, 1, { 0x58, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vaddpd",  3, { R_ZMM,  R_ZMM, M512              }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),            1, 1, { 0x58, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vaddpd",  3, { R_ZMM,  R_ZMM, M_ANY             }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD), 8, 1, { 0x58, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VADDPS xmm1, xmm2, xmm3 / m128    VEX.128.0F.WIG 58 / r
//VADDPS ymm1, ymm2, ymm3 / m256    VEX.256.0F.WIG 58 / r
//VADDPS xmm1{k1}{z}, xmm2, xmm3 / m128 / m32bcst    EVEX.128.0F.W0 58 / r
//VADDPS ymm1{k1}{z}, ymm2, ymm3 / m256 / m32bcst    EVEX.256.0F.W0 58 / r
//VADDPS zmm1{k1}{z}, zmm2, zmm3 / m512 / m32bcst{er}    EVEX.512.0F.W0 58 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vaddps",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                                 1,  1, { 0x58, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vaddps",  3, { R_XMM,  R_XMM, M128              }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                                 1,  1, { 0x58, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vaddps",  3, { R_XMM,  R_XMM, M_ANY             }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),                      4,  1, { 0x58, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vaddps",  3, { R_YMM,  R_YMM, R_YMM             }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                                 1,  1, { 0x58, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vaddps",  3, { R_YMM,  R_YMM, M256              }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                                 1,  1, { 0x58, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vaddps",  3, { R_YMM,  R_YMM, M_ANY             }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),                      8,  1, { 0x58, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* special implicit NDS forms */
{ "vaddps",  2, { R_XMM,  R_XMM                    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                                      1,  1, { 0x58, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vaddps",  2, { R_YMM,  R_YMM                    }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                                      1,  1, { 0x58, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vaddps",  3, { R_ZMM,  R_ZMM, R_ZMM             }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (EVEX | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_RND),          1,  1, { 0x58, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vaddps",  3, { R_ZMM,  R_ZMM, M512              }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),                     1,  1, { 0x58, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vaddps",  3, { R_ZMM,  R_ZMM, M_ANY             }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),          16, 1, { 0x58, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* VADDSD xmm1 {k1}{z}, xmm2,xmm3/m64 {er} EVEX.LIG.F2.0F.W1 59 /r*/
/* ----------------------------------------------------------------------------------------------- */
{ "vaddsd",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_LIG | VEX_WIG | VEX_F2 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_RND),   1,  1, { 0x58, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vaddsd",  3, { R_XMM,  R_XMM, M_ANY             }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_LIG | VEX_WIG | VEX_F2 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),              2,  1, { 0x58, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* special implicit NDS forms */
{ "vaddsd",  2, { R_XMM,  R_XMM                    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_LIG | VEX_WIG | VEX_F2 | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                   1,  1, { 0x58, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
//VADDSS xmm1, xmm2, xmm3 / m32    VEX.LIG.F3.0F.WIG 58 / r
//VADDSS xmm1{k1}{z}, xmm2, xmm3 / m32{er}    EVEX.LIG.F3.0F.W0 58 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vaddss",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_LIG | VEX_WIG | VEX_F3 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_RND),   1,  1, { 0x58, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vaddss",  3, { R_XMM,  R_XMM, M_ANY             }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_LIG | VEX_WIG | VEX_F3 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),              4,  1, { 0x58, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* special implicit NDS forms */
{ "vaddss",  2, { R_XMM,  R_XMM                    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_LIG | VEX_WIG | VEX_F3 | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                   1,  1, { 0x58, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
 //VSUBPD xmm1, xmm2, xmm3 / m128    VEX.128.66.0F.WIG 5C / r
 //VSUBPD ymm1, ymm2, ymm3 / m256    VEX.256.66.0F.WIG 5C / r
 //VSUBPD xmm1{k1}{z}, xmm2, xmm3 / m128 / m64bcst    EVEX.128.66.0F.W1 5C / r
 //VSUBPD ymm1{k1}{z}, ymm2, ymm3 / m256 / m64bcst    EVEX.256.66.0F.W1 5C / r
 //VSUBPD zmm1{k1}{z}, zmm2, zmm3 / m512 / m64bcst{er}    EVEX.512.66.0F.W1 5C / r
 /* -----------------------------------------------------------------------------------------------*/
{ "vsubpd",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),                         1,  1, { 0x5c, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vsubpd",  3, { R_XMM,  R_XMM, M128              }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),                         1,  1, { 0x5c, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vsubpd",  3, { R_XMM,  R_XMM, M_ANY             }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),              2,  1, { 0x5c, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vsubpd",  3, { R_YMM,  R_YMM, R_YMM             }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),                         1,  1, { 0x5c, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vsubpd",  3, { R_YMM,  R_YMM, M256              }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),                         1,  1, { 0x5c, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vsubpd",  3, { R_YMM,  R_YMM, M_ANY             }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),              4,  1, { 0x5c, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* special implicit NDS forms */
{ "vsubpd",  2, { R_XMM,  R_XMM                    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                              1,  1, { 0x5c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vsubpd",  2, { R_YMM,  R_YMM                    }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                              1,  1, { 0x5c, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vsubpd",  3, { R_ZMM,  R_ZMM, R_ZMM             }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (EVEX | VEX_66 | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_RND),  1,  1, { 0x5c, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vsubpd",  3, { R_ZMM,  R_ZMM, M512              }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),             1,  1, { 0x5c, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vsubpd",  3, { R_ZMM,  R_ZMM, M_ANY             }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),  8,  1, { 0x5c, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VSUBPS xmm1,xmm2, xmm3/m128  VEX.128.0F.WIG 5C /r
//VSUBPS ymm1, ymm2, ymm3/m256 VEX.256.0F.WIG 5C /r
//VSUBPS xmm1 {k1}{z}, xmm2,xmm3/m128/m32bcst EVEX.128.0F.W0 5C /r
//VSUBPS ymm1 {k1}{z}, ymm2,ymm3/m256/m32bcst EVEX.256.0F.W0 5C /r
//VSUBPS zmm1 {k1}{z}, zmm2,zmm3/m512/m32bcst{er} EVEX.512.0F.W0 5C /r
/* ----------------------------------------------------------------------------------------------- */
{ "vsubps",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x5c, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vsubps",  3, { R_XMM,  R_XMM, M128              }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x5c, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vsubps",  3, { R_XMM,  R_XMM, M_ANY             }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),             4,  1, { 0x5c, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vsubps",  3, { R_YMM,  R_YMM, R_YMM             }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x5c, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vsubps",  3, { R_YMM,  R_YMM, M256              }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x5c, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vsubps",  3, { R_YMM,  R_YMM, M_ANY             }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),             8,  1, { 0x5c, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* special implicit NDS forms */
{ "vsubps",  2, { R_XMM,  R_XMM                    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                             1,  1, { 0x5c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vsubps",  2, { R_YMM,  R_YMM                    }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                             1,  1, { 0x5c, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vsubps",  3, { R_ZMM,  R_ZMM, R_ZMM             }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (EVEX | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_RND), 1,  1, { 0x5c, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vsubps",  3, { R_ZMM,  R_ZMM, M512              }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),            1,  1, { 0x5c, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vsubps",  3, { R_ZMM,  R_ZMM, M_ANY             }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD), 16, 1, { 0x5c, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* VSUBSD xmm1 {k1}{z}, xmm2,xmm3/m64 {er} EVEX.LIG.F2.0F.W1 59 /r*/
/* ----------------------------------------------------------------------------------------------- */
{ "vsubsd",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_LIG | VEX_F2 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_RND),             1,  1, { 0x5c, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vsubsd",  3, { R_XMM,  R_XMM, M_ANY             }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_LIG | VEX_F2 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),                        2,  1, { 0x5c, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* special implicit NDS forms */
{ "vsubsd",  2, { R_XMM,  R_XMM                    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_LIG | VEX_F2 | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                             1,  1, { 0x5c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
/* VSUBSS */
/* ----------------------------------------------------------------------------------------------- */
{ "vsubss",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_LIG | VEX_F3 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_RND),             1,  1, { 0x5c, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vsubss",  3, { R_XMM,  R_XMM, M_ANY             }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_LIG | VEX_F3 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                        4,  1, { 0x5c, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* special implicit NDS forms */
{ "vaddss",  2, { R_XMM,  R_XMM                    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_LIG | VEX_F3 | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                             1,  1, { 0x5c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
/*    VADDSUBPD xmm1, xmm2, xmm3 / m128 VEX.128.66.0F.WIG D0 / r                                   */
/*    VADDSUBPD ymm1, ymm2, ymm3 / m256 VEX.256.66.0F.WIG D0 / r                                   */
/* ----------------------------------------------------------------------------------------------- */

{ "vaddsubpd",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),            (NO_EVEX),             1,  1, { 0xd0, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vaddsubpd",  3, { R_XMM,  R_XMM, M_ANY             }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),            (NO_EVEX),             1,  1, { 0xd0, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vaddsubpd",  3, { R_YMM,  R_YMM, R_YMM             }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),            (NO_EVEX),             1,  1, { 0xd0, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vaddsubpd",  3, { R_YMM,  R_YMM, M_ANY             }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),            (NO_EVEX),             1,  1, { 0xd0, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* special implicit NDS forms */
{ "vaddsubpd",  2, { R_XMM,  R_XMM                    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_DUP_NDS),        (NO_EVEX),             1,  1, { 0xd0, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vaddsubpd",  2, { R_YMM,  R_YMM                    }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_DUP_NDS),        (NO_EVEX),             1,  1, { 0xd0, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
/*    VADDSUBPS xmm1, xmm2, xmm3 / m128 VEX.128.F2.0F.WIG D0 / r                                 */
/*    VADDSUBPS ymm1, ymm2, ymm3 / m256 VEX.256.F2.0F.WIG D0 / r                                 */
/* ----------------------------------------------------------------------------------------------- */
{ "vaddsubps",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_F2 | VEX_0F | VEX_NDS),            (NO_EVEX),             1,  1, { 0xd0, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vaddsubps",  3, { R_XMM,  R_XMM, M_ANY             }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_F2 | VEX_0F | VEX_NDS),            (NO_EVEX),             1,  1, { 0xd0, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vaddsubps",  3, { R_YMM,  R_YMM, R_YMM             }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_F2 | VEX_0F | VEX_NDS),            (NO_EVEX),             1,  1, { 0xd0, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vaddsubps",  3, { R_YMM,  R_YMM, M_ANY             }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_F2 | VEX_0F | VEX_NDS),            (NO_EVEX),             1,  1, { 0xd0, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* special implicit NDS forms */
{ "vaddsubps",  2, { R_XMM,  R_XMM                    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_F2 | VEX_0F | VEX_DUP_NDS),        (NO_EVEX),             1,  1, { 0xd0, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vaddsubps",  2, { R_YMM,  R_YMM                    }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_F2 | VEX_0F | VEX_DUP_NDS),        (NO_EVEX),             1,  1, { 0xd0, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
  //VMULPS xmm1,xmm2, xmm3/m128    VEX.128.0F.WIG 59 /r
  //VMULPS ymm1, ymm2, ymm3/m256    VEX.256.0F.WIG 59 /r
  //VMULPS xmm1 {k1}{z}, xmm2,xmm3/m128/m32bcst    EVEX.128.0F.W0 59 /r
  //VMULPS ymm1 {k1}{z}, ymm2,ymm3/m256/m32bcst    EVEX.256.0F.W0 59 /r
  //VMULPS zmm1 {k1}{z}, zmm2,zmm3/m512/m32bcst {er}    EVEX.512.0F.W0 59 /r
/* ----------------------------------------------------------------------------------------------- */
{ "vmulps",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                                 1,  1, { 0x59, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmulps",  3, { R_XMM,  R_XMM, M128              }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                                 1,  1, { 0x59, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vmulps",  3, { R_XMM,  R_XMM, M_ANY             }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),                      4,  1, { 0x59, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vmulps",  3, { R_YMM,  R_YMM, R_YMM             }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                                 1,  1, { 0x59, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmulps",  3, { R_YMM,  R_YMM, M256              }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                                 1,  1, { 0x59, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vmulps",  3, { R_YMM,  R_YMM, M_ANY             }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),                      8,  1, { 0x59, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* special implicit NDS forms */
{ "vmulps",  2, { R_XMM,  R_XMM                    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),                (VEX | VEX_WIG | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                                    1,  1, { 0x59, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmulps",  2, { R_YMM,  R_YMM                    }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),                (VEX | VEX_WIG | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                                    1,  1, { 0x59, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmulps",  3, { R_ZMM,  R_ZMM, R_ZMM             }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (EVEX | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_RND),          1,  1, { 0x59, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmulps",  3, { R_ZMM,  R_ZMM, M512              }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),                     1,  1, { 0x59, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vmulps",  3, { R_ZMM,  R_ZMM, M_ANY             }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),          16, 1, { 0x59, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
  //VMULPD xmm1,xmm2, xmm3/m128    VEX.128.66.0F.WIG 59 /r
  //VMULPD ymm1, ymm2, ymm3/m256    VEX.256.66.0F.WIG 59 /r
  //VMULPD xmm1 {k1}{z}, xmm2,xmm3/m128/m64bcst    EVEX.128.66.0F.W1 59 /r
  //VMULPD ymm1 {k1}{z}, ymm2,ymm3/m256/m64bcst    EVEX.256.66.0F.W1 59 /r
  //VMULPD zmm1 {k1}{z}, zmm2,zmm3/m512/m64bcst{er}    EVEX.512.66.0F.W1 59 /r
/* ----------------------------------------------------------------------------------------------- */
{ "vmulpd",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x59, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmulpd",  3, { R_XMM,  R_XMM, M128              }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x59, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vmulpd",  3, { R_XMM,  R_XMM, M_ANY             }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),             2,  1, { 0x59, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vmulpd",  3, { R_YMM,  R_YMM, R_YMM             }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x59, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmulpd",  3, { R_YMM,  R_YMM, M256              }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x59, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vmulpd",  3, { R_YMM,  R_YMM, M_ANY             }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),             4,  1, { 0x59, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* special implicit NDS forms */
{ "vmulpd",  2, { R_XMM,  R_XMM                    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                             1,  1, { 0x59, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmulpd",  2, { R_YMM,  R_YMM                    }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                             1,  1, { 0x59, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmulpd",  3, { R_ZMM,  R_ZMM, R_ZMM             }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (EVEX | VEX_66 | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_RND), 1, 1, { 0x59, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmulpd",  3, { R_ZMM,  R_ZMM, M512              }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),            1, 1, { 0x59, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vmulpd",  3, { R_ZMM,  R_ZMM, M_ANY             }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD), 8, 1, { 0x59, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* VMULSD xmm1 {k1}{z}, xmm2,xmm3/m64 {er} EVEX.LIG.F2.0F.W1 59 /r*/
/* ----------------------------------------------------------------------------------------------- */
{ "vmulsd",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_LIG | VEX_F2 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_RND),   1,  1, { 0x59, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmulsd",  3, { R_XMM,  R_XMM, M_ANY             }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_LIG | VEX_F2 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),              2,  1, { 0x59, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* special implicit NDS forms */
{ "vmulsd",  2, { R_XMM,  R_XMM                    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_LIG | VEX_F2 | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                   1,  1, { 0x59, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
  /* VMULSS */
  /* ----------------------------------------------------------------------------------------------- */
{ "vmulss",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_LIG | VEX_F3 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_RND),   1,  1, { 0x59, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmulss",  3, { R_XMM,  R_XMM, M_ANY             }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_LIG | VEX_F3 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),              4,  1, { 0x59, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* special implicit NDS forms */
{ "vmulss",  2, { R_XMM,  R_XMM                    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_LIG | VEX_F3 | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                   1,  1, { 0x59, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
//VDIVPS xmm1, xmm2, xmm3/m128  VEX.128.0F.WIG 5E /r
//VDIVPS ymm1, ymm2, ymm3/m256  VEX.256.0F.WIG 5E /r
//VDIVPS xmm1 {k1}{z}, xmm2,xmm3/m128/m32bcst  EVEX.128.0F.W0 5E /r
//VDIVPS ymm1 {k1}{z}, ymm2,ymm3/m256/m32bcst  EVEX.256.0F.W0 5E /r
//VDIVPS zmm1 {k1}{z}, zmm2,zmm3/m512/m32bcst{er}  EVEX.512.0F.W0 5E /r
/* ----------------------------------------------------------------------------------------------- */
{ "vdivps",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                                 1,  1, { 0x5e, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vdivps",  3, { R_XMM,  R_XMM, M128              }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                                 1,  1, { 0x5e, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vdivps",  3, { R_XMM,  R_XMM, M_ANY             }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),                      4,  1, { 0x5e, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vdivps",  3, { R_YMM,  R_YMM, R_YMM             }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                                 1,  1, { 0x5e, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vdivps",  3, { R_YMM,  R_YMM, M256              }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                                 1,  1, { 0x5e, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vdivps",  3, { R_YMM,  R_YMM, M_ANY             }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),                      8,  1, { 0x5e, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* special implicit NDS forms */
{ "vdivps",  2, { R_XMM,  R_XMM                    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                                      1,  1, { 0x5e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vdivps",  2, { R_YMM,  R_YMM                    }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                                      1,  1, { 0x5e, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vdivps",  3, { R_ZMM,  R_ZMM, R_ZMM             }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (EVEX | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_RND),          1,  1, { 0x5e, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vdivps",  3, { R_ZMM,  R_ZMM, M512              }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),                     1,  1, { 0x5e, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vdivps",  3, { R_ZMM,  R_ZMM, M_ANY             }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),          16, 1, { 0x5e, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* VDIVPD */
/* ----------------------------------------------------------------------------------------------- */
{ "vdivpd",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x5e, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vdivpd",  3, { R_XMM,  R_XMM, M128              }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x5e, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vdivpd",  3, { R_XMM,  R_XMM, M_ANY             }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),             2,  1, { 0x5e, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vdivpd",  3, { R_YMM,  R_YMM, R_YMM             }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x5e, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vdivpd",  3, { R_YMM,  R_YMM, M256              }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x5e, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vdivpd",  3, { R_YMM,  R_YMM, M_ANY             }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),             4,  1, { 0x5e, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* special implicit NDS forms */
{ "vdivpd",  2, { R_XMM,  R_XMM                    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                             1,  1, { 0x5e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vdivpd",  2, { R_YMM,  R_YMM                    }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                             1,  1, { 0x5e, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vdivpd",  3, { R_ZMM,  R_ZMM, R_ZMM             }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (EVEX | VEX_66 | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_RND), 1,  1, { 0x5e, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vdivpd",  3, { R_ZMM,  R_ZMM, M512             }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F | VEX_NDS),                             (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),            1,  1, { 0x5e, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vdivpd",  3, { R_ZMM,  R_ZMM, M_ANY             }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD), 8,  1, { 0x5e, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* VDIVSD xmm1 {k1}{z}, xmm2,xmm3/m64 {er} EVEX.LIG.F2.0F.W1 59 /r*/
/* ----------------------------------------------------------------------------------------------- */
{ "vdivsd",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_LIG | VEX_F2 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_RND),   1,  1, { 0x5e, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vdivsd",  3, { R_XMM,  R_XMM, M_ANY             }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_LIG | VEX_F2 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),              2,  1, { 0x5e, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* special implicit NDS forms */
{ "vdivsd",  2, { R_XMM,  R_XMM                    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_LIG | VEX_F2 | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                   1,  1, { 0x5e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
  /* VDIVSS */
  /* ----------------------------------------------------------------------------------------------- */
{ "vdivss",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_LIG | VEX_F3 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_RND),   1,  1, { 0x5e, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vdivss",  3, { R_XMM,  R_XMM, M_ANY             }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_LIG | VEX_F3 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),              4,  1, { 0x5e, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* special implicit NDS forms */
{ "vdivss",  2, { R_XMM,  R_XMM                    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_LIG | VEX_F3 | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                   1,  1, { 0x5e, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* VMAXPD */
/* ----------------------------------------------------------------------------------------------- */
{ "vmaxpd",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x5f, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmaxpd",  3, { R_XMM,  R_XMM, M128              }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x5f, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vmaxpd",  3, { R_XMM,  R_XMM, M_ANY             }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),             2,  1, { 0x5f, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vmaxpd",  3, { R_YMM,  R_YMM, R_YMM             }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x5f, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmaxpd",  3, { R_YMM,  R_YMM, M256              }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x5f, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vmaxpd",  3, { R_YMM,  R_YMM, M_ANY             }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),             4,  1, { 0x5f, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* special implicit NDS forms */
{ "vmaxpd",  2, { R_XMM,  R_XMM                    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                             1,  1, { 0x5f, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmaxpd",  2, { R_YMM,  R_YMM                    }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                             1,  1, { 0x5f, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmaxpd",  3, { R_ZMM,  R_ZMM, R_ZMM             }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (EVEX | VEX_66 | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_RND), 1,  1, { 0x5f, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmaxps",  3, { R_ZMM,  R_ZMM, M512              }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),                     (EVEX_W0 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x5f, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vmaxps",  3, { R_ZMM,  R_ZMM, M_ANY             }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),                     (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),             8,  1, { 0x5f, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* VMAXPS */
/* ----------------------------------------------------------------------------------------------- */
{ "vmaxps",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                                 1,  1, { 0x5f, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmaxps",  3, { R_XMM,  R_XMM, M128              }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                                 1,  1, { 0x5f, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vmaxps",  3, { R_XMM,  R_XMM, M_ANY             }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),                      4,  1, { 0x5f, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vmaxps",  3, { R_YMM,  R_YMM, R_YMM             }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                                 1,  1, { 0x5f, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmaxps",  3, { R_YMM,  R_YMM, M256              }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                                 1,  1, { 0x5f, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vmaxps",  3, { R_YMM,  R_YMM, M_ANY             }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),                      8,  1, { 0x5f, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* special implicit NDS forms */
{ "vmaxps",  2, { R_XMM,  R_XMM                    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                                      1,  1, { 0x5f, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmaxps",  2, { R_YMM,  R_YMM                    }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                                      1,  1, { 0x5f, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmaxps",  3, { R_ZMM,  R_ZMM, R_ZMM             }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (EVEX | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_RND),          1,  1, { 0x5f, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmaxps",  3, { R_ZMM,  R_ZMM, M512              }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),                     1,  1, { 0x5f, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vmaxps",  3, { R_ZMM,  R_ZMM, M_ANY             }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),          16, 1, { 0x5f, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* VMAXSD xmm1, xmm2, xmm3 / m64 VEX.LIG.F2.0F.WIG 5F / r                                          */
/* VMAXSD xmm1{k1}{z}, xmm2, xmm3 / m64{sae} EVEX.LIG.F2.0F.W1 5F / r                          */
/* ----------------------------------------------------------------------------------------------- */
{ "vmaxsd",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_LIG | VEX_WIG | VEX_F2 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_RND),   1,  1, { 0x5f, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmaxsd",  3, { R_XMM,  R_XMM, M_ANY             }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_LIG | VEX_WIG | VEX_F2 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),              2,  1, { 0x5f, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* special implicit NDS forms */
{ "vmaxsd",  2, { R_XMM,  R_XMM                    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_LIG | VEX_WIG | VEX_F2 | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                   1,  1, { 0x5f, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
  /* VMAXSS */
  /* ----------------------------------------------------------------------------------------------- */
{ "vmaxss",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_LIG | VEX_WIG | VEX_F3 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_RND),   1,  1, { 0x5f, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmaxss",  3, { R_XMM,  R_XMM, M_ANY             }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_LIG | VEX_WIG | VEX_F3 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),              4,  1, { 0x5f, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* special implicit NDS forms */
{ "vmaxss",  2, { R_XMM,  R_XMM                    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_LIG | VEX_WIG | VEX_F3 | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                   1,  1, { 0x5f, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },


/* ----------------------------------------------------------------------------------------------- */
/* VMINPD */
/* ----------------------------------------------------------------------------------------------- */
{ "vminpd",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x5d, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vminpd",  3, { R_XMM,  R_XMM, M128              }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x5d, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vminpd",  3, { R_XMM,  R_XMM, M_ANY             }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),             2,  1, { 0x5d, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vminpd",  3, { R_YMM,  R_YMM, R_YMM             }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x5d, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vminpd",  3, { R_YMM,  R_YMM, M256              }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x5d, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vminpd",  3, { R_YMM,  R_YMM, M_ANY             }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),             4,  1, { 0x5d, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* special implicit NDS forms */
{ "vminpd",  2, { R_XMM,  R_XMM                    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                             1,  1, { 0x5d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vminpd",  2, { R_YMM,  R_YMM                    }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                             1,  1, { 0x5d, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vminpd",  3, { R_ZMM,  R_ZMM, R_ZMM             }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (EVEX | VEX_66 | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_RND), 1,  1, { 0x5d, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vminpd",  3, { R_ZMM,  R_ZMM, M512              }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),            1,  1, { 0x5d, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vminpd",  3, { R_ZMM,  R_ZMM, M_ANY             }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD), 8,  1, { 0x5d, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* VMINPS */
/* ----------------------------------------------------------------------------------------------- */
{ "vminps",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x5d, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vminps",  3, { R_XMM,  R_XMM, M128              }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x5d, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vminps",  3, { R_XMM,  R_XMM, M_ANY             }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),             4,  1, { 0x5d, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vminps",  3, { R_YMM,  R_YMM, R_YMM             }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x5d, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vminps",  3, { R_YMM,  R_YMM, M256              }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x5d, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vminps",  3, { R_YMM,  R_YMM, M_ANY             }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),             8,  1, { 0x5d, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* special implicit NDS forms */
{ "vminps",  2, { R_YMM,  R_YMM                    }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                             1,  1, { 0x5d, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vminps",  3, { R_ZMM,  R_ZMM, R_ZMM             }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (EVEX | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_RND), 1,  1, { 0x5d, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vminps",  3, { R_ZMM,  R_ZMM, M512              }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),            1,  1, { 0x5d, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vminps",  3, { R_ZMM,  R_ZMM, M_ANY             }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_0F | VEX_NDS),                            (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD), 16, 1, { 0x5d, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* VMINSD xmm1, xmm2, xmm3 / m64 VEX.LIG.F2.0F.WIG 5D / r                                          */
/* VMINSD xmm1{k1}{z}, xmm2, xmm3 / m64{ sae } EVEX.LIG.F2.0F.W1 5D / r                          */
/* ----------------------------------------------------------------------------------------------- */
{ "vminsd",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_LIG | VEX_WIG | VEX_F2 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_SAE),             1,  1, { 0x5d, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vminsd",  3, { R_XMM,  R_XMM, M_ANY             }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_LIG | VEX_WIG | VEX_F2 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),                        2,  1, { 0x5d, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* special implicit NDS forms */
{ "vminsd",  2, { R_XMM,  R_XMM  }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),                                (VEX | VEX_LIG | VEX_WIG | VEX_F2 | VEX_0F | VEX_DUP_NDS),  (NO_EVEX),                                                          1,  1, { 0x5d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0 ,0 , (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
  /* VMINSS */
  /* ----------------------------------------------------------------------------------------------- */
{ "vminss",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_LIG | VEX_WIG | VEX_F3 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_SAE),             1,  1, { 0x5d, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vminss",  3, { R_XMM,  R_XMM, M_ANY             }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_LIG | VEX_WIG | VEX_F3 | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                        4,  1, { 0x5d, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* special implicit NDS forms */
{ "vminss",  2, { R_XMM,  R_XMM                    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_LIG | VEX_WIG | VEX_F3 | VEX_0F | VEX_DUP_NDS),               (NO_EVEX),                                             1,  1, { 0x5d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VCOMISD xmm1, xmm2 / m64  VEX.LIG.66.0F.WIG 2F / r
//VCOMISD xmm1, xmm2 / m64{ sae } EVEX.LIG.66.0F.W1 2F / r
/* ----------------------------------------------------------------------------------------------- */
{ "vcomisd",   2, { R_XMM,   R_XMM                  }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),  (VEX | VEX_66 | VEX_LIG | VEX_WIG | VEX_0F | VEX_2OPND | EVEX),          (EVEX_W1 | EVEX_SAE),	 1, 1, { 0x2f, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,         P_686 | P_AVX, 0, NULL },
{ "vcomisd",   2, { R_XMM,   M_ANY,                 }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_LIG | VEX_WIG | VEX_0F | EVEX),	         (EVEX_W1),							 2, 1, { 0x2f, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST,  NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VCOMISS xmm1, xmm2 / m32 VEX.LIG.0F.WIG 2F / r
//VCOMISS xmm1, xmm2 / m32{ sae } EVEX.LIG.0F.W0 2F / r
/* ----------------------------------------------------------------------------------------------- */
{ "vcomiss",   2, { R_XMM,   R_XMM                  }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),    (VEX | VEX_LIG | VEX_WIG | VEX_0F | VEX_2OPND | EVEX),                  (EVEX_W0 | EVEX_SAE),	 1, 1, { 0x2f, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST,  NO_PREFIX, NO_IMM,     NO_MEM,         P_686 | P_AVX, 0, NULL },
{ "vcomiss",   2, { R_XMM,   M_ANY,                 }, AVX0, (F_MODRM | F_MODRM_REG),                 (VEX | VEX_LIG | VEX_WIG | VEX_0F | EVEX),	                            (EVEX_W0),						 4, 1, { 0x2f, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST,  NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* VMOVAPS */
/* ----------------------------------------------------------------------------------------------- */
{ "vmovaps", 2, { R_XMM,   R_XMM                   }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | (SRCHDSTL),  (VEX | VEX_66 | VEX_WIG | VEX_0F | VEX_2OPND | EVEX),          (EVEX_W0 | EVEX_MASK | EVEX_Z),			       1, 1, { 0x29, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmovaps", 2, { R_YMM,   R_YMM                   }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | (SRCHDSTL),  (VEX | VEX_66 | VEX_WIG | VEX_0F | VEX_2OPND | EVEX),          (EVEX_W0 | EVEX_MASK | EVEX_Z),			       1, 1, { 0x29, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmovaps", 2, { R_XMM,   R_XMM                   }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),			          (VEX | VEX_66 | VEX_WIG | VEX_0F | VEX_2OPND | EVEX),          (EVEX_W0 | EVEX_MASK | EVEX_Z),             1, 1, { 0x28, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmovaps", 2, { R_YMM,   R_YMM                   }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),			          (VEX | VEX_66 | VEX_WIG | VEX_0F | VEX_2OPND | EVEX),          (EVEX_W0 | EVEX_MASK | EVEX_Z),             1, 1, { 0x28, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmovaps", 2, { R_XMM,   M_ANY                   }, AVX0, (F_MODRM | F_MODRM_REG),						                (VEX | VEX_66 | VEX_WIG | VEX_0F | VEX_2OPND | EVEX),          (EVEX_W0 | EVEX_MASK | EVEX_Z),             1, 1, { 0x28, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vmovaps", 2, { R_YMM,   M_ANY                   }, AVX1, (F_MODRM | F_MODRM_REG),						                (VEX | VEX_66 | VEX_WIG | VEX_0F | VEX_2OPND | EVEX),          (EVEX_W0 | EVEX_MASK | EVEX_Z),             1, 1, { 0x28, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vmovaps", 2, { M_ANY,   R_XMM                   }, AVX0, (F_MODRM | F_MODRM_REG),						                (VEX | VEX_66 | VEX_WIG | VEX_0F | VEX_2OPND | EVEX),	         (EVEX_W0 | EVEX_MASK),                      1, 1, { 0x29, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_686 | P_AVX, 0, NULL },
{ "vmovaps", 2, { M_ANY,   R_YMM                   }, AVX1, (F_MODRM | F_MODRM_REG),						                (VEX | VEX_66 | VEX_WIG | VEX_0F | VEX_2OPND | EVEX),	         (EVEX_W0 | EVEX_MASK),                      1, 1, { 0x29, 0x00, 0x00 }, 32, 1, MOD_MEM_REG, 0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_686 | P_AVX, 0, NULL },
{ "vmovaps", 2, { R_ZMM,   R_ZMM                   }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),			          (EVEX | VEX_66 | VEX_0F | VEX_2OPND),					                 (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z), 1, 1, { 0x28, 0x00, 0x00 }, 64, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmovaps", 2, { R_ZMM,   M_ANY                   }, EVX0, (F_MODRM | F_MODRM_REG),						                (EVEX | VEX_66 | VEX_0F | VEX_2OPND),					                 (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z), 1, 1, { 0x28, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vmovaps", 2, { M_ANY,   R_ZMM                   }, EVX0, (F_MODRM | F_MODRM_REG),						                (EVEX | VEX_0F | VEX_2OPND),					                         (EVEX_ONLY | EVEX_W0 | EVEX_MASK),          1, 1, { 0x29, 0x00, 0x00 }, 64, 1, MOD_MEM_REG, 0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
/* VMOVAPD */
/* ----------------------------------------------------------------------------------------------- */
{ "vmovapd", 2, { R_XMM,   R_XMM                   }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | (SRCHDSTL),  (VEX | VEX_66 | VEX_WIG | VEX_0F | VEX_2OPND | EVEX),          (EVEX_W1 | EVEX_MASK | EVEX_Z),			       1, 1, { 0x29, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmovapd", 2, { R_YMM,   R_YMM                   }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | (SRCHDSTL),  (VEX | VEX_66 | VEX_WIG | VEX_0F | VEX_2OPND | EVEX),          (EVEX_W1 | EVEX_MASK | EVEX_Z),			       1, 1, { 0x29, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmovapd", 2, { R_XMM,   R_XMM                   }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),			          (VEX | VEX_66 | VEX_WIG | VEX_0F | VEX_2OPND | EVEX),          (EVEX_W1 | EVEX_MASK | EVEX_Z),             1, 1, { 0x28, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmovapd", 2, { R_YMM,   R_YMM                   }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),			          (VEX | VEX_66 | VEX_WIG | VEX_0F | VEX_2OPND | EVEX),          (EVEX_W1 | EVEX_MASK | EVEX_Z),             1, 1, { 0x28, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmovapd", 2, { R_XMM,   M_ANY                   }, AVX0, (F_MODRM | F_MODRM_REG),						                (VEX | VEX_66 | VEX_WIG | VEX_0F | VEX_2OPND | EVEX),          (EVEX_W1 | EVEX_MASK | EVEX_Z),             1, 1, { 0x28, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vmovapd", 2, { R_YMM,   M_ANY                   }, AVX1, (F_MODRM | F_MODRM_REG),						                (VEX | VEX_66 | VEX_WIG | VEX_0F | VEX_2OPND | EVEX),          (EVEX_W1 | EVEX_MASK | EVEX_Z),             1, 1, { 0x28, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vmovapd", 2, { M_ANY,   R_XMM                   }, AVX0, (F_MODRM | F_MODRM_REG),						                (VEX | VEX_66 | VEX_WIG | VEX_0F | VEX_2OPND | EVEX),	         (EVEX_W1 | EVEX_MASK),                      1, 1, { 0x29, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_686 | P_AVX, 0, NULL },
{ "vmovapd", 2, { M_ANY,   R_YMM                   }, AVX1, (F_MODRM | F_MODRM_REG),						                (VEX | VEX_66 | VEX_WIG | VEX_0F | VEX_2OPND | EVEX),	         (EVEX_W1 | EVEX_MASK),                      1, 1, { 0x29, 0x00, 0x00 }, 32, 1, MOD_MEM_REG, 0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_686 | P_AVX, 0, NULL },
{ "vmovapd", 2, { R_ZMM,   R_ZMM                   }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),			          (EVEX | VEX_66 | VEX_0F | VEX_2OPND),					                 (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z), 1, 1, { 0x28, 0x00, 0x00 }, 64, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmovapd", 2, { R_ZMM,   M_ANY                   }, EVX0, (F_MODRM | F_MODRM_REG),						                (EVEX | VEX_66 | VEX_0F | VEX_2OPND),					                 (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z), 1, 1, { 0x28, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vmovapd", 2, { M_ANY,   R_ZMM                   }, EVX0, (F_MODRM | F_MODRM_REG),						                (EVEX | VEX_66 | VEX_0F | VEX_2OPND),					                 (EVEX_ONLY | EVEX_W1 | EVEX_MASK),          1, 1, { 0x29, 0x00, 0x00 }, 64, 1, MOD_MEM_REG, 0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
/* VPSHUFD */
/* ----------------------------------------------------------------------------------------------- */
{ "vpshufd",    3, { R_XMM,  R_XMM,  IMM8          }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_WIG | VEX_0F | VEX_66 | VEX_2OPND | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x70, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpshufd",    3, { R_XMM,  M128,   IMM8          }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_WIG | VEX_0F | VEX_66 | VEX_2OPND | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x70, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
{ "vpshufd",    3, { R_XMM,  M_ANY,  IMM8          }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_WIG | VEX_0F | VEX_66 | VEX_2OPND | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),             4,  1, { 0x70, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
{ "vpshufd",    3, { R_YMM,  R_YMM,  IMM8          }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_WIG | VEX_0F | VEX_66 | VEX_2OPND | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x70, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpshufd",    3, { R_YMM,  M_ANY,  IMM8          }, AVX1, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_WIG | VEX_0F | VEX_66 | VEX_2OPND | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x70, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
{ "vpshufd",    3, { R_YMM,  M256,   IMM8          }, AVX1, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_WIG | VEX_0F | VEX_66 | VEX_2OPND | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),             8,  1, { 0x70, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
{ "vpshufd",    3, { R_ZMM,  R_ZMM,  IMM8          }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_WIG | VEX_0F | VEX_66 | VEX_2OPND | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),            1,  1, { 0x70, 0x00, 0x00 }, 64, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpshufd",    3, { R_ZMM,  M512,   IMM8          }, EVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_WIG | VEX_0F | VEX_66 | VEX_2OPND | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),            1,  1, { 0x70, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
{ "vpshufd",    3, { R_ZMM,  M_ANY,  IMM8          }, EVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_WIG | VEX_0F | VEX_66 | VEX_2OPND | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD), 16, 1, { 0x70, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
  /* VPSHUFHW */
  /* ----------------------------------------------------------------------------------------------- */
{ "vpshufhw",    3, { R_XMM,  R_XMM,  IMM8         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_WIG | VEX_F3 | VEX_0F | VEX_2OPND | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x70, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpshufhw",    3, { R_XMM,  M_ANY,  IMM8         }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_WIG | VEX_F3 | VEX_0F | VEX_2OPND | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x70, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
{ "vpshufhw",    3, { R_YMM,  R_YMM,  IMM8         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_WIG | VEX_F3 | VEX_0F | VEX_2OPND | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x70, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpshufhw",    3, { R_YMM,  M_ANY,  IMM8         }, AVX1, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_WIG | VEX_F3 | VEX_0F | VEX_2OPND | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x70, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
{ "vpshufhw",    3, { R_ZMM,  R_ZMM,  IMM8         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_WIG | VEX_F3 | VEX_0F | VEX_2OPND | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),            1,  1, { 0x70, 0x00, 0x00 }, 64, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpshufhw",    3, { R_ZMM,  M_ANY,  IMM8         }, EVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_WIG | VEX_F3 | VEX_0F | VEX_2OPND | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),            1,  1, { 0x70, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
  /* VPSHUFLW */
  /* ----------------------------------------------------------------------------------------------- */
{ "vpshuflw",    3, { R_XMM,  R_XMM,  IMM8         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_WIG | VEX_F2 | VEX_0F | VEX_2OPND | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x70, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpshuflw",    3, { R_XMM,  M_ANY,  IMM8         }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_WIG | VEX_F2 | VEX_0F | VEX_2OPND | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x70, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
{ "vpshuflw",    3, { R_YMM,  R_YMM,  IMM8         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_WIG | VEX_F2 | VEX_0F | VEX_2OPND | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x70, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpshuflw",    3, { R_YMM,  M_ANY,  IMM8         }, AVX1, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_WIG | VEX_F2 | VEX_0F | VEX_2OPND | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x70, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
{ "vpshuflw",    3, { R_ZMM,  R_ZMM,  IMM8         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_WIG | VEX_F2 | VEX_0F | VEX_2OPND | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),            1,  1, { 0x70, 0x00, 0x00 }, 64, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpshuflw",    3, { R_ZMM,  M_ANY,  IMM8         }, EVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_WIG | VEX_F2 | VEX_0F | VEX_2OPND | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),            1,  1, { 0x70, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
/* VPSHUFB */
/* ----------------------------------------------------------------------------------------------- */
{ "vpshufb",    3, { R_XMM,  R_XMM,  R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),  (VEX | VEX_WIG | VEX_66 | VEX_NDS | VEX_0F38 | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                                    1,  1, { 0x00, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpshufb",    3, { R_XMM,  R_XMM,  M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),               (VEX | VEX_WIG | VEX_66 | VEX_NDS | VEX_0F38 | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                                    1,  1, { 0x00, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
{ "vpshufb",    3, { R_YMM,  R_YMM,  R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),  (VEX | VEX_WIG | VEX_66 | VEX_NDS | VEX_0F38 | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                                    1,  1, { 0x00, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpshufb",    3, { R_YMM,  R_YMM,  M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),               (VEX | VEX_WIG | VEX_66 | VEX_NDS | VEX_0F38 | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                                    1,  1, { 0x00, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
{ "vpshufb",    3, { R_ZMM,  R_ZMM,  R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),  (VEX | VEX_WIG | VEX_66 | VEX_NDS | VEX_0F38 | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x00, 0x00, 0x00 }, 64, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpshufb",    3, { R_ZMM,  R_ZMM,  M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),               (VEX | VEX_WIG | VEX_66 | VEX_NDS | VEX_0F38 | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x00, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
/* VGATHERDPS */
/* ----------------------------------------------------------------------------------------------- */
{ "vgatherdps", 3, { R_XMM,  M_ANY,  R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_0F38 | VEX_DDS | VEX_VSIB),		    (NO_EVEX),											                                  1,  1, { 0x92, 0x00, 0x00 }, 16, 2, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vgatherdps", 3, { R_YMM,  M_ANY,  R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_0F38 | VEX_DDS | VEX_VSIB),		    (NO_EVEX),											                                  1,  1, { 0x92, 0x00, 0x00 }, 32, 2, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vgatherdps", 2, { R_ZMM,  M_ANY                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),         1,  1, { 0x92, 0x00, 0x00 }, 64, 1, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vgatherdps", 2, { R_XMM,  M_ANY                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),         1,  1, { 0x92, 0x00, 0x00 }, 16, 1, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vgatherdps", 2, { R_YMM,  M_ANY                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),         1,  1, { 0x92, 0x00, 0x00 }, 32, 1, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
/* VGATHERDPS */
/* ----------------------------------------------------------------------------------------------- */
{ "vgatherdpd", 3, { R_XMM,  M_ANY,  R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_W1 | VEX_0F38 | VEX_DDS | VEX_VSIB),		      (NO_EVEX),											                         1,  1, { 0x92, 0x00, 0x00 }, 16, 2, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vgatherdpd", 3, { R_YMM,  M_ANY,  R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_W1 | VEX_0F38 | VEX_DDS | VEX_VSIB),		      (NO_EVEX),											                         1,  1, { 0x92, 0x00, 0x00 }, 32, 2, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vgatherdpd", 2, { R_ZMM,  M_ANY                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_W1 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_K | EVEX_VSIB), 1,  1, { 0x92, 0x00, 0x00 }, 64, 1, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vgatherdpd", 2, { R_XMM,  M_ANY                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_W1 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_K | EVEX_VSIB), 1,  1, { 0x92, 0x00, 0x00 }, 16, 1, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vgatherdpd", 2, { R_YMM,  M_ANY                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_W1 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_K | EVEX_VSIB), 1,  1, { 0x92, 0x00, 0x00 }, 32, 1, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
/* VGATHERQPD */
/* ----------------------------------------------------------------------------------------------- */
{ "vgatherqpd", 3, { R_XMM,  M_ANY,  R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_W1 | VEX_0F38 | VEX_DDS | VEX_VSIB),		      (NO_EVEX),											                          1,  1, { 0x93, 0x00, 0x00 }, 16, 2, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vgatherqpd", 3, { R_YMM,  M_ANY,  R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_W1 | VEX_0F38 | VEX_DDS | VEX_VSIB),		      (NO_EVEX),											                          1,  1, { 0x93, 0x00, 0x00 }, 32, 2, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vgatherqpd", 2, { R_ZMM,  M_ANY                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_W1 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_K | EVEX_VSIB),  1,  1, { 0x93, 0x00, 0x00 }, 64, 1, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vgatherqpd", 2, { R_XMM,  M_ANY                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_W1 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_K | EVEX_VSIB),  1,  1, { 0x93, 0x00, 0x00 }, 16, 1, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vgatherqpd", 2, { R_YMM,  M_ANY                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_W1 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_K | EVEX_VSIB),  1,  1, { 0x93, 0x00, 0x00 }, 32, 1, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
  /* VGATHERQPS */
  /* ----------------------------------------------------------------------------------------------- */
{ "vgatherqps", 3, { R_XMM,  M_ANY,  R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_0F38 | VEX_DDS | VEX_VSIB),		      (NO_EVEX),											                                  1,  1, { 0x93, 0x00, 0x00 }, 16, 2, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vgatherqps", 3, { R_YMM,  M_ANY,  R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_0F38 | VEX_DDS | VEX_VSIB),		      (NO_EVEX),											                                  1,  1, { 0x93, 0x00, 0x00 }, 32, 2, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vgatherqps", 2, { R_ZMM,  M_ANY                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),           1, 1, { 0x93, 0x00, 0x00 }, 64, 1, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vgatherqps", 2, { R_XMM,  M_ANY                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),           1,  1, { 0x93, 0x00, 0x00 }, 16, 1, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vgatherqps", 2, { R_YMM,  M_ANY                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),           1,  1, { 0x93, 0x00, 0x00 }, 32, 1, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
/* VPGATHERDD */
/* ----------------------------------------------------------------------------------------------- */
{ "vpgatherdd", 3, { R_XMM,  M_ANY,  R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_0F38 | VEX_DDS | VEX_VSIB),		      (NO_EVEX),											                                  1,  1, { 0x90, 0x00, 0x00 }, 16, 2, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vpgatherdd", 3, { R_YMM,  M_ANY,  R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_0F38 | VEX_DDS | VEX_VSIB),		      (NO_EVEX),											                                  1,  1, { 0x90, 0x00, 0x00 }, 32, 2, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vpgatherdd", 2, { R_ZMM,  M_ANY                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),           1,  1, { 0x90, 0x00, 0x00 }, 64, 1, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vpgatherdd", 2, { R_XMM,  M_ANY                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),           1,  1, { 0x90, 0x00, 0x00 }, 16, 1, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vpgatherdd", 2, { R_YMM,  M_ANY                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),           1,  1, { 0x90, 0x00, 0x00 }, 32, 1, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
/* VPGATHERQD */
/* ----------------------------------------------------------------------------------------------- */
{ "vpgatherqd", 3, { R_XMM,  M_ANY,  R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_0F38 | VEX_DDS | VEX_VSIB),		      (NO_EVEX),											                                   1,  1, { 0x91, 0x00, 0x00 }, 16, 2, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vpgatherqd", 3, { R_YMM,  M_ANY,  R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_0F38 | VEX_DDS | VEX_VSIB),		      (NO_EVEX),											                                   1,  1, { 0x91, 0x00, 0x00 }, 32, 2, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vpgatherqd", 2, { R_ZMM,  M_ANY                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),            1,  1, { 0x91, 0x00, 0x00 }, 64, 1, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vpgatherqd", 2, { R_XMM,  M_ANY                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),            1,  1, { 0x91, 0x00, 0x00 }, 16, 1, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vpgatherqd", 2, { R_YMM,  M_ANY                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),            1,  1, { 0x91, 0x00, 0x00 }, 32, 1, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
  /* VPGATHERQQ */
  /* ----------------------------------------------------------------------------------------------- */
{ "vpgatherqq", 3, { R_XMM,  M_ANY,  R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_W1 | VEX_0F38 | VEX_DDS | VEX_VSIB),		      (NO_EVEX),											                            1,  1, { 0x91, 0x00, 0x00 }, 16, 2, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vpgatherqq", 3, { R_YMM,  M_ANY,  R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_W1 | VEX_0F38 | VEX_DDS | VEX_VSIB),		      (NO_EVEX),											                            1,  1, { 0x91, 0x00, 0x00 }, 32, 2, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vpgatherqq", 2, { R_ZMM,  M_ANY                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_W1 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_K | EVEX_VSIB),    1,  1, { 0x91, 0x00, 0x00 }, 64, 1, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vpgatherqq", 2, { R_XMM,  M_ANY                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_W1 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_K | EVEX_VSIB),    1,  1, { 0x91, 0x00, 0x00 }, 16, 1, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vpgatherqq", 2, { R_YMM,  M_ANY                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_W1 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_K | EVEX_VSIB),    1,  1, { 0x91, 0x00, 0x00 }, 32, 1, NO_MOD,      0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
/* VPSCATTERDD vm32x{k1}, xmm1 EVEX.128.66.0F38.W0 A0 / vsib */
/* ----------------------------------------------------------------------------------------------- */
{ "vpscatterdd", 2, { M_ANY,  R_XMM                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),           1,  1, { 0xa0, 0x00, 0x00 }, 16, 1, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vpscatterdd", 2, { M_ANY,  R_YMM                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),           1,  1, { 0xa0, 0x00, 0x00 }, 32, 1, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vpscatterdd", 2, { M_ANY,  R_ZMM                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),           1,  1, { 0xa0, 0x00, 0x00 }, 64, 1, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
  /* VPSCATTERDQ vm32x{k1}, xmm1 EVEX.128.66.0F38.W0 A0 / vsib */
  /* ----------------------------------------------------------------------------------------------- */
{ "vpscatterdq", 2, { M_ANY,  R_XMM                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_K | EVEX_VSIB),           1,  1, { 0xa0, 0x00, 0x00 }, 16, 1, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vpscatterdq", 2, { M_ANY,  R_YMM                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_K | EVEX_VSIB),           1,  1, { 0xa0, 0x00, 0x00 }, 32, 1, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vpscatterdq", 2, { M_ANY,  R_ZMM                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_K | EVEX_VSIB),           1,  1, { 0xa0, 0x00, 0x00 }, 64, 1, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
  /* VPSCATTERQD vm32x{k1}, xmm1 EVEX.128.66.0F38.W0 A0 / vsib */
  /* ----------------------------------------------------------------------------------------------- */
{ "vpscatterqd", 2, { M_ANY,  R_XMM                 }, EVX0, (F_MODRM | F_MODRM_REG),                          (EVEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),            1,  1, { 0xa1, 0x00, 0x00 }, 16, 1, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vpscatterqd", 2, { M_ANY,  R_YMM                 }, EVX0, (F_MODRM | F_MODRM_REG),                          (EVEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),            1,  1, { 0xa1, 0x00, 0x00 }, 32, 1, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vpscatterqd", 2, { M_ANY,  R_ZMM                 }, EVX0, (F_MODRM | F_MODRM_REG),                          (EVEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),            1,  1, { 0xa1, 0x00, 0x00 }, 64, 1, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
  /* VPSCATTERQQ vm32x{k1}, xmm1 EVEX.128.66.0F38.W0 A0 / vsib */
  /* ----------------------------------------------------------------------------------------------- */
{ "vpscatterqq", 2, { M_ANY,  R_XMM                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_K | EVEX_VSIB),           1,  1, { 0xa1, 0x00, 0x00 }, 16, 1, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vpscatterqq", 2, { M_ANY,  R_YMM                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_K | EVEX_VSIB),           1,  1, { 0xa1, 0x00, 0x00 }, 32, 1, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vpscatterqq", 2, { M_ANY,  R_ZMM                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_K | EVEX_VSIB),           1,  1, { 0xa1, 0x00, 0x00 }, 64, 1, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
  /*VSCATTERDPS vm32x{k1}, xmm1 EVEX.128.66.0F38.W0 A2 / vsib                                      */
  /*VSCATTERDPS vm32y{k1}, ymm1 EVEX.256.66.0F38.W0 A2 / vsib                                      */
  /*VSCATTERDPS vm32z{k1}, zmm1 EVEX.512.66.0F38.W0 A2 / vsib                                      */
  /* ----------------------------------------------------------------------------------------------- */
{ "vscatterdps", 2, { M_ANY,  R_XMM                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),           1,  1, { 0xa2, 0x00, 0x00 }, 16, 1, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vscatterdps", 2, { M_ANY,  R_YMM                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),           1,  1, { 0xa2, 0x00, 0x00 }, 32, 1, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vscatterdps", 2, { M_ANY,  R_ZMM                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),           1,  1, { 0xa2, 0x00, 0x00 }, 64, 1, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
  /*VSCATTERDPD vm32x{k1}, xmm1 EVEX.128.66.0F38.W1 A2 / vsib                                      */
  /*VSCATTERDPD vm32x{k1}, ymm1 EVEX.256.66.0F38.W1 A2 / vsib                                      */
  /*VSCATTERDPD vm32y{k1}, zmm1 EVEX.512.66.0F38.W1 A2 / vsib                                      */
  /* ----------------------------------------------------------------------------------------------- */
{ "vscatterdpd", 2, { M_ANY,  R_XMM                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_K | EVEX_VSIB),           1,  1, { 0xa2, 0x00, 0x00 }, 16, 1, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vscatterdpd", 2, { M_ANY,  R_YMM                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_K | EVEX_VSIB),           1,  1, { 0xa2, 0x00, 0x00 }, 32, 1, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vscatterdpd", 2, { M_ANY,  R_ZMM                 }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_K | EVEX_VSIB),           1,  1, { 0xa2, 0x00, 0x00 }, 64, 1, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
  /*VSCATTERQPS vm64x{k1}, xmm1 EVEX.128.66.0F38.W0 A3 / vsib                                      */
  /*VSCATTERQPS vm64y{k1}, xmm1 EVEX.256.66.0F38.W0 A3 / vsib                                      */
  /*VSCATTERQPS vm64z{k1}, ymm1 EVEX.512.66.0F38.W0 A3 / vsib                                      */
  /* ----------------------------------------------------------------------------------------------- */
{ "vscatterqps", 2, { M_ANY,  R_XMM                }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),           1,  1, { 0xa3, 0x00, 0x00 }, 16, 1, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vscatterqps", 2, { M_ANY,  R_YMM                }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),           1,  1, { 0xa3, 0x00, 0x00 }, 32, 1, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vscatterqps", 2, { M_ANY,  R_ZMM                }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),           1,  1, { 0xa3, 0x00, 0x00 }, 64, 1, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
  /*VSCATTERQPD vm64x{k1}, xmm1 EVEX.128.66.0F38.W1 A3 / vsib                                      */
  /*VSCATTERQPD vm64y{k1}, ymm1 EVEX.256.66.0F38.W1 A3 / vsib                                      */
  /*VSCATTERQPD vm64z{k1}, zmm1 EVEX.512.66.0F38.W1 A3 / vsib                                      */
  /* ----------------------------------------------------------------------------------------------- */
{ "vscatterqpd", 2, { M_ANY,  R_XMM                }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_K | EVEX_VSIB),           1,  1, { 0xa3, 0x00, 0x00 }, 16, 1, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vscatterqpd", 2, { M_ANY,  R_YMM                }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_K | EVEX_VSIB),           1,  1, { 0xa3, 0x00, 0x00 }, 32, 1, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vscatterqpd", 2, { M_ANY,  R_ZMM                }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_66 | VEX_0F38 | VEX_2OPND | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_K | EVEX_VSIB),           1,  1, { 0xa3, 0x00, 0x00 }, 64, 1, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
  /*VGATHERPF0DPS vm32z {k1}  EVEX.512.66.0F38.W0 C6 /1 /vsib                                      */
  /* ----------------------------------------------------------------------------------------------- */
{ "vgatherpf0dps", 1, { M_ANY, OP_N               }, EVX0, (F_MODRM | OPCODE_EXT),                           (EVEX | VEX_66 | VEX_0F38 | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),                        1, 1, { 0xc6, 0x01, 0x00 }, 64, 0, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
  /* VGATHERPF0QPS vm64z {k1}  EVEX.512.66.0F38.W0 C7 /1 /vsib                                      */
  /* ----------------------------------------------------------------------------------------------- */
{ "vgatherpf0qps", 1, { M_ANY, OP_N               }, EVX0, (F_MODRM | OPCODE_EXT),                           (EVEX | VEX_66 | VEX_0F38 | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),                        1, 1, { 0xc7, 0x01, 0x00 }, 64, 0, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
  /* VGATHERPF0DPD vm32y {k1}  EVEX.512.66.0F38.W1 C6 /1 /vsib                                     */
  /* ----------------------------------------------------------------------------------------------- */
{ "vgatherpf0dpd", 1, { M_ANY, OP_N               }, EVX0, (F_MODRM | OPCODE_EXT),                            (EVEX | VEX_66 | VEX_0F38 | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_K | EVEX_VSIB),                       1, 1,  { 0xc6, 0x01, 0x00 }, 64, 0, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
  /* VGATHERPF0QPD vm64z {k1   EVEX.512.66.0F38.W1 C7 /1 /vsib                                      */
  /* ----------------------------------------------------------------------------------------------- */
{ "vgatherpf0qpd", 1, { M_ANY, OP_N               }, EVX0, (F_MODRM | OPCODE_EXT),                           (EVEX | VEX_66 | VEX_0F38 | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_K | EVEX_VSIB),                        1, 1,  { 0xc7, 0x01, 0x00 }, 64, 0, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
  /* VGATHERPF1DPS vm32z {k1}  EVEX.512.66.0F38.W0 C6 /2 /vsib                                      */
  /* ----------------------------------------------------------------------------------------------- */
{ "vgatherpf1dps", 1, { M_ANY, OP_N               }, EVX0, (F_MODRM | OPCODE_EXT),                           (EVEX | VEX_66 | VEX_0F38 | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),                        1, 1, { 0xc6, 0x02, 0x00 }, 64, 0, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
  /* VGATHERPF1QPS vm64z {k1}  EVEX.512.66.0F38.W0 C7 /2 /vsib                                     */
  /* ----------------------------------------------------------------------------------------------- */
{ "vgatherpf1qps", 1, { M_ANY, OP_N               }, EVX0, (F_MODRM | OPCODE_EXT),                           (EVEX | VEX_66 | VEX_0F38 | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),                        1, 1, { 0xc7, 0x02, 0x00 }, 64, 0, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
  /* VGATHERPF1DPD vm32y {k1}  EVEX.512.66.0F38.W1 C6 /2 /vsib                                      */
  /* ----------------------------------------------------------------------------------------------- */
{ "vgatherpf1dpd", 1, { M_ANY, OP_N               }, EVX0, (F_MODRM | OPCODE_EXT),                            (EVEX | VEX_66 | VEX_0F38 | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_K | EVEX_VSIB),                       1, 1, { 0xc6, 0x02, 0x00 }, 64, 0, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
  /* VGATHERPF1QPD vm64z {k1}  EVEX.512.66.0F38.W1 C7 /2 /vsib                                      */
  /* ----------------------------------------------------------------------------------------------- */
{ "vgatherpf1qpd", 1, { M_ANY, OP_N               }, EVX0, (F_MODRM | OPCODE_EXT),                           (EVEX | VEX_66 | VEX_0F38 | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_K | EVEX_VSIB),                        1, 1, { 0xc7, 0x02, 0x00 }, 64, 0, NO_MOD,       0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
  /*VSCATTERPF0DPS vm32z{k1}EVEX.512.66.0F38.W0 C6 / 5 / vsib                                      */
  /* ----------------------------------------------------------------------------------------------- */
{ "vscatterpf0dps", 1, { M_ANY, OP_N               }, EVX0, (F_MODRM | OPCODE_EXT),                           (EVEX | VEX_66 | VEX_0F38 | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),                        1, 1, { 0xc6, 0x05, 0x00 }, 64, 0, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
  /*VSCATTERPF0QPS vm64z{k1}EVEX.512.66.0F38.W0 C7 / 5 / vsib                                      */
  /* ----------------------------------------------------------------------------------------------- */
{ "vscatterpf0qps", 1, { M_ANY, OP_N               }, EVX0, (F_MODRM | OPCODE_EXT),                           (EVEX | VEX_66 | VEX_0F38 | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),                        1, 1, { 0xc7, 0x05, 0x00 }, 64, 0, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
  /*VSCATTERPF0DPD vm32y{k1}EVEX.512.66.0F38.W1 C6 / 5 / vsib                                      */
  /* ----------------------------------------------------------------------------------------------- */
{ "vscatterpf0dpd", 1, { M_ANY, OP_N               }, EVX0, (F_MODRM | OPCODE_EXT),                            (EVEX | VEX_66 | VEX_0F38 | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_K | EVEX_VSIB),                       1, 1,  { 0xc6, 0x05, 0x00 }, 64, 0, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
  /*VSCATTERPF0QPD vm64z{k1}EVEX.512.66.0F38.W1 C7 / 5 / vsib                                      */
  /* ----------------------------------------------------------------------------------------------- */
{ "vscatterpf0qpd", 1, { M_ANY, OP_N               }, EVX0, (F_MODRM | OPCODE_EXT),                           (EVEX | VEX_66 | VEX_0F38 | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_K | EVEX_VSIB),                        1, 1,  { 0xc7, 0x05, 0x00 }, 64, 0, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
  /*VSCATTERPF0DPS vm32z{k1}EVEX.512.66.0F38.W0 C6 / 6 / vsib                                      */
  /* ----------------------------------------------------------------------------------------------- */
{ "vscatterpf1dps", 1, { M_ANY, OP_N               }, EVX0, (F_MODRM | OPCODE_EXT),                           (EVEX | VEX_66 | VEX_0F38 | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),                        1, 1, { 0xc6, 0x06, 0x00 }, 64, 0, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
  /*VSCATTERPF1QPS vm64z{k1}EVEX.512.66.0F38.W0 C7 / 6 / vsib                                      */
  /* ----------------------------------------------------------------------------------------------- */
{ "vscatterpf1qps", 1, { M_ANY, OP_N               }, EVX0, (F_MODRM | OPCODE_EXT),                           (EVEX | VEX_66 | VEX_0F38 | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_K | EVEX_VSIB),                        1, 1, { 0xc7, 0x06, 0x00 }, 64, 0, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
  /*VSCATTERPF1DPD vm32y{k1}EVEX.512.66.0F38.W1 C6 / 6 / vsib                                      */
  /* ----------------------------------------------------------------------------------------------- */
{ "vscatterpf1dpd", 1, { M_ANY, OP_N               }, EVX0, (F_MODRM | OPCODE_EXT),                            (EVEX | VEX_66 | VEX_0F38 | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_K | EVEX_VSIB),                       1, 1, { 0xc6, 0x06, 0x00 }, 64, 0, NO_MOD,      0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
  /*VSCATTERPF1QPD vm64z{k1}EVEX.512.66.0F38.W1 C7 / 6 / vsib                                      */
  /* ----------------------------------------------------------------------------------------------- */
{ "vscatterpf1qpd", 1, { M_ANY, OP_N               }, EVX0, (F_MODRM | OPCODE_EXT),                           (EVEX | VEX_66 | VEX_0F38 | VEX_VSIB | EVEX), (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_K | EVEX_VSIB),                        1, 1, { 0xc7, 0x06, 0x00 }, 64, 0, NO_MOD,       0, 0, 0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* VBLENDVPS */
/* ----------------------------------------------------------------------------------------------- */
{ "vblendvps",  4, { R_XMM,  R_XMM, R_XMM,  R_XMM  }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_66 | VEX_0F3A | VEX_NDS | VEX_4OPND | VEX_W0), (NO_EVEX),												1,  1, { 0x4a, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vblendvps",  4, { R_XMM,  R_XMM, M_ANY,  R_XMM  }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_66 | VEX_0F3A | VEX_NDS | VEX_4OPND | VEX_W0), (NO_EVEX),												1,  1, { 0x4a, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vblendvps",  4, { R_YMM,  R_YMM, R_YMM,  R_YMM  }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_66 | VEX_0F3A | VEX_NDS | VEX_4OPND | VEX_W0), (NO_EVEX),												1,  1, { 0x4a, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vblendvps",  4, { R_YMM,  R_YMM, M_ANY,  R_YMM  }, AVX1, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_66 | VEX_0F3A | VEX_NDS | VEX_4OPND | VEX_W0), (NO_EVEX),												1,  1, { 0x4a, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
/* VBLENDVPD */
/* ----------------------------------------------------------------------------------------------- */
{ "vblendvpd",  4, { R_XMM,  R_XMM, R_XMM,  R_XMM  }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_66 | VEX_0F3A | VEX_NDS | VEX_4OPND | VEX_W0), (NO_EVEX),												1,  1, { 0x4b, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vblendvpd",  4, { R_XMM,  R_XMM, M_ANY,  R_XMM  }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_66 | VEX_0F3A | VEX_NDS | VEX_4OPND | VEX_W0), (NO_EVEX),												1,  1, { 0x4b, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vblendvpd",  4, { R_YMM,  R_YMM, R_YMM,  R_YMM  }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_66 | VEX_0F3A | VEX_NDS | VEX_4OPND | VEX_W0), (NO_EVEX),												1,  1, { 0x4b, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vblendvpd",  4, { R_YMM,  R_YMM, M_ANY,  R_YMM  }, AVX1, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_66 | VEX_0F3A | VEX_NDS | VEX_4OPND | VEX_W0), (NO_EVEX),												1,  1, { 0x4b, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* VBLENDPS */
/* ----------------------------------------------------------------------------------------------- */
{ "vblendps",   4, { R_XMM,  R_XMM, R_XMM, IMM8    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_66 | VEX_WIG | VEX_0F3A | VEX_NDS),	         (NO_EVEX),												  1,  1, { 0x0c, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vblendps",   4, { R_XMM,  R_XMM, M_ANY, IMM8    }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_66 | VEX_WIG | VEX_0F3A | VEX_NDS),          (NO_EVEX),												  1,  1, { 0x0c, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vblendps",   4, { R_YMM,  R_YMM, R_YMM, IMM8    }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_66 | VEX_WIG | VEX_0F3A | VEX_NDS),	         (NO_EVEX),												  1,  1, { 0x0c, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vblendps",   4, { R_YMM,  R_YMM, M_ANY, IMM8    }, AVX1, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_66 | VEX_WIG | VEX_0F3A | VEX_NDS),	         (NO_EVEX),												  1,  1, { 0x0c, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
  /* VBLENDPD */
  /* ----------------------------------------------------------------------------------------------- */
{ "vblendpd",   4, { R_XMM,  R_XMM, R_XMM, IMM8    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_66 | VEX_WIG | VEX_0F3A | VEX_NDS),	         (NO_EVEX),												  1,  1, { 0x0d, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vblendpd",   4, { R_XMM,  R_XMM, M_ANY, IMM8    }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_66 | VEX_WIG | VEX_0F3A | VEX_NDS),          (NO_EVEX),												  1,  1, { 0x0d, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vblendpd",   4, { R_YMM,  R_YMM, R_YMM, IMM8    }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_66 | VEX_WIG | VEX_0F3A | VEX_NDS),	         (NO_EVEX),												  1,  1, { 0x0d, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vblendpd",   4, { R_YMM,  R_YMM, M_ANY, IMM8    }, AVX1, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_66 | VEX_WIG | VEX_0F3A | VEX_NDS),	         (NO_EVEX),												  1,  1, { 0x0d, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
/* VMPSADBW */
/* ----------------------------------------------------------------------------------------------- */
{ "vmpsadbw",   4, { R_XMM,  R_XMM, R_XMM, IMM8    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_66 | VEX_WIG | VEX_0F3A | VEX_NDS),	         (NO_EVEX),													1,  1, { 0x42, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmpsadbw",   4, { R_XMM,  R_XMM, M_ANY, IMM8    }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_66 | VEX_WIG | VEX_0F3A | VEX_NDS),          (NO_EVEX),													1,  1, { 0x42, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vmpsadbw",   4, { R_YMM,  R_YMM, R_YMM, IMM8    }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_66 | VEX_WIG | VEX_0F3A | VEX_NDS),	         (NO_EVEX),													1,  1, { 0x42, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmpsadbw",   4, { R_YMM,  R_YMM, M_ANY, IMM8    }, AVX1, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_66 | VEX_WIG | VEX_0F3A | VEX_NDS),	         (NO_EVEX),													1,  1, { 0x42, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
/* Implicit NDS forms */
{ "vmpsadbw",   3, { R_XMM,  R_XMM,  IMM8      }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_66 | VEX_WIG | VEX_0F3A | VEX_DUP_NDS),	       (NO_EVEX),													1,  1, { 0x42, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmpsadbw",   3, { R_YMM,  R_YMM,  IMM8      }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_66 | VEX_WIG | VEX_0F3A | VEX_DUP_NDS),	       (NO_EVEX),													1,  1, { 0x42, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,        P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
/* VPMOVZXBQ */
/* ----------------------------------------------------------------------------------------------- */
{ "vpmovzxbq",   2, { R_XMM,  R_XMM,                  }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_66 | VEX_WIG | VEX_2OPND | VEX_0F38 | EVEX), 	 (EVEX_MASK | EVEX_Z),									  2, 1, { 0x32, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vpmovzxbq",   2, { R_XMM,  M_ANY,                  }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_WIG | VEX_2OPND | VEX_0F38 | EVEX),	 (EVEX_MASK | EVEX_Z),									    2, 1, { 0x32, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vpmovzxbq",   2, { R_YMM,  R_XMM,                  }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_66 | VEX_WIG | VEX_2OPND | VEX_0F38 | EVEX), 	 (EVEX_MASK | EVEX_Z),									  4, 1, { 0x32, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vpmovzxbq",   2, { R_YMM,  M_ANY,                  }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_WIG | VEX_2OPND | VEX_0F38 | EVEX),	 (EVEX_MASK | EVEX_Z),									    4, 1, { 0x32, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vpmovzxbq",   2, { R_ZMM,  R_XMM,                  }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_66 | VEX_WIG | VEX_2OPND | VEX_0F38 | EVEX), 	 (EVEX_ONLY | EVEX_MASK | EVEX_Z),				8, 1, { 0x32, 0x00, 0x00 }, 64, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vpmovzxbq",   2, { R_ZMM,  M_ANY,                  }, EVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_66 | VEX_WIG | VEX_2OPND | VEX_0F38 | EVEX),	 (EVEX_ONLY | EVEX_MASK | EVEX_Z),					8, 1, { 0x32, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
/* VBROADCASTSD */
/* ----------------------------------------------------------------------------------------------- */
{ "vbroadcastsd",   2, { R_YMM,  M_ANY,               }, AVX1, (F_MODRM | F_MODRM_REG),                        (VEX | VEX_66 | VEX_2OPND | VEX_0F38 | VEX_W0 | EVEX), (EVEX_MASK | EVEX_Z | EVEX_W1),							    4,  1, { 0x19, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vbroadcastsd",   2, { R_YMM,  R_XMM,               }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),           (VEX | VEX_66 | VEX_2OPND | VEX_0F38 | VEX_W0 | EVEX), (EVEX_MASK | EVEX_Z | EVEX_W1),							    4,  1, { 0x19, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vbroadcastsd",   2, { R_ZMM,  R_XMM,               }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),           (VEX | VEX_66 | VEX_2OPND | VEX_0F38 | VEX_W0 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),			8,  1, { 0x19, 0x00, 0x00 }, 64, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vbroadcastsd",   2, { R_ZMM,  M_ANY,               }, EVX0, (F_MODRM | F_MODRM_REG),                        (VEX | VEX_66 | VEX_2OPND | VEX_0F38 | VEX_W0 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),			8,  1, { 0x19, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
/* VBROADCASTSS */
/* ----------------------------------------------------------------------------------------------- */
{ "vbroadcastss",   2, { R_YMM,  M_ANY,               }, AVX1, (F_MODRM | F_MODRM_REG),                        (VEX | VEX_66 | VEX_2OPND | VEX_0F38 | VEX_W0 | EVEX), (EVEX_MASK | EVEX_Z | EVEX_W1),							    8,  1, { 0x18, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0, 0, (X32), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vbroadcastss",   2, { R_YMM,  R_XMM,               }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),           (VEX | VEX_66 | VEX_2OPND | VEX_0F38 | VEX_W0 | EVEX), (EVEX_MASK | EVEX_Z | EVEX_W1),							    8,  1, { 0x18, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vbroadcastss",   2, { R_ZMM,  R_XMM,               }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),           (VEX | VEX_66 | VEX_2OPND | VEX_0F38 | VEX_W0 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),			16, 1, { 0x18, 0x00, 0x00 }, 64, 1, MOD_REG_REG, 0, 0, 0, (X32), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vbroadcastss",   2, { R_ZMM,  M_ANY,               }, EVX0, (F_MODRM | F_MODRM_REG),                        (VEX | VEX_66 | VEX_2OPND | VEX_0F38 | VEX_W0 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),			16, 1, { 0x18, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0, 0, (X32), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* VBROADCASF32x2 */
/* ----------------------------------------------------------------------------------------------- */
{ "vbroadcastf32x2",   2, { R_YMM,  M_ANY,            }, EVX0, (F_MODRM | F_MODRM_REG),                        (VEX | VEX_66 | VEX_2OPND | VEX_0F38 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),							4,  1, { 0x19, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vbroadcastf32x2",   2, { R_YMM,  R_XMM,            }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),           (VEX | VEX_66 | VEX_2OPND | VEX_0F38 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),							4,  1, { 0x19, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vbroadcastf32x2",   2, { R_ZMM,  R_XMM,            }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),           (VEX | VEX_66 | VEX_2OPND | VEX_0F38 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),							8,  1, { 0x19, 0x00, 0x00 }, 64, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vbroadcastf32x2",   2, { R_ZMM,  M_ANY,            }, EVX0, (F_MODRM | F_MODRM_REG),                        (VEX | VEX_66 | VEX_2OPND | VEX_0F38 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),							8,  1, { 0x19, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* VBROADCASF32x4 */
/* ----------------------------------------------------------------------------------------------- */
{ "vbroadcastf32x4",   2, { R_YMM,  M_ANY,            }, EVX0, (F_MODRM | F_MODRM_REG),                        (VEX | VEX_66 | VEX_2OPND | VEX_0F38 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),							2,  1, { 0x1A, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vbroadcastf32x4",   2, { R_ZMM,  M_ANY,            }, EVX0, (F_MODRM | F_MODRM_REG),                        (VEX | VEX_66 | VEX_2OPND | VEX_0F38 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),							4,  1, { 0x1A, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
/* VBROADCASF64x2 */
/* ----------------------------------------------------------------------------------------------- */
{ "vbroadcastf64x2",   2, { R_YMM,  M_ANY,            }, EVX0, (F_MODRM | F_MODRM_REG),                        (VEX | VEX_66 | VEX_2OPND | VEX_0F38 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),							2,  1, { 0x1A, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vbroadcastf64x2",   2, { R_ZMM,  M_ANY,            }, EVX0, (F_MODRM | F_MODRM_REG),                        (VEX | VEX_66 | VEX_2OPND | VEX_0F38 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),							4,  1, { 0x1A, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
/* VBROADCASF32x8 */
/* ----------------------------------------------------------------------------------------------- */
{ "vbroadcastf32x8",   2, { R_ZMM,  M_ANY,            }, EVX0, (F_MODRM | F_MODRM_REG),                        (VEX | VEX_66 | VEX_2OPND | VEX_0F38 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),							2,  1, { 0x1B, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* VBROADCASF64x4 */
/* ----------------------------------------------------------------------------------------------- */
{ "vbroadcastf64x4",   2, { R_ZMM,  M_ANY,            }, EVX0, (F_MODRM | F_MODRM_REG),                        (VEX | VEX_66 | VEX_2OPND | VEX_0F38 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),							2,  1, { 0x1B, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* VBLENDMPD */
/* ----------------------------------------------------------------------------------------------- */
{ "vblendmpd",      3, { R_XMM,  R_XMM,  R_XMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),           (VEX | VEX_66 | VEX_NDS | VEX_0F38 | VEX_W0 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),					      1,  1, { 0x65, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vblendmpd",      3, { R_YMM,  R_YMM,  R_YMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),           (VEX | VEX_66 | VEX_NDS | VEX_0F38 | VEX_W0 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),					      1,  1, { 0x65, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vblendmpd",      3, { R_ZMM,  R_ZMM,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),           (VEX | VEX_66 | VEX_NDS | VEX_0F38 | VEX_W0 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),					      1,  1, { 0x65, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vblendmpd",      3, { R_XMM,  R_XMM,  M128         }, EVX0, (F_MODRM | F_MODRM_REG),						             (VEX | VEX_66 | VEX_NDS | VEX_0F38 | VEX_W0 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),		            1,  1, { 0x65, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },
{ "vblendmpd",      3, { R_XMM,  R_XMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						             (VEX | VEX_66 | VEX_NDS | VEX_0F38 | VEX_W0 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),		2,  1, { 0x65, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },
{ "vblendmpd",      3, { R_YMM,  R_YMM,  M256         }, EVX0, (F_MODRM | F_MODRM_REG),						             (VEX | VEX_66 | VEX_NDS | VEX_0F38 | VEX_W0 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),		            1,  1, { 0x65, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },
{ "vblendmpd",      3, { R_YMM,  R_YMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						             (VEX | VEX_66 | VEX_NDS | VEX_0F38 | VEX_W0 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),		4,  1, { 0x65, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },
{ "vblendmpd",      3, { R_ZMM,  R_ZMM,  M512         }, EVX0, (F_MODRM | F_MODRM_REG),						             (VEX | VEX_66 | VEX_NDS | VEX_0F38 | VEX_W0 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),		            1,  1, { 0x65, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },
{ "vblendmpd",      3, { R_ZMM,  R_ZMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						             (VEX | VEX_66 | VEX_NDS | VEX_0F38 | VEX_W0 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),		8,  1, { 0x65, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* VBLENDMPS */
/* ----------------------------------------------------------------------------------------------- */
{ "vblendmps",      3, { R_XMM,  R_XMM,  R_XMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),           (VEX | VEX_66 | VEX_NDS | VEX_0F38 | VEX_W0 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),					      1,  1, { 0x65, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vblendmps",      3, { R_YMM,  R_YMM,  R_YMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),           (VEX | VEX_66 | VEX_NDS | VEX_0F38 | VEX_W0 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),					      1,  1, { 0x65, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vblendmps",      3, { R_ZMM,  R_ZMM,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),           (VEX | VEX_66 | VEX_NDS | VEX_0F38 | VEX_W0 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),					      1,  1, { 0x65, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vblendmps",      3, { R_XMM,  R_XMM,  M128         }, EVX0, (F_MODRM | F_MODRM_REG),						             (VEX | VEX_66 | VEX_NDS | VEX_0F38 | VEX_W0 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),		            1,  1, { 0x65, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },
{ "vblendmps",      3, { R_XMM,  R_XMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						             (VEX | VEX_66 | VEX_NDS | VEX_0F38 | VEX_W0 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0 | EVEX_BRD),		4,  1, { 0x65, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },
{ "vblendmps",      3, { R_YMM,  R_YMM,  M256         }, EVX0, (F_MODRM | F_MODRM_REG),						             (VEX | VEX_66 | VEX_NDS | VEX_0F38 | VEX_W0 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),		            1,  1, { 0x65, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },
{ "vblendmps",      3, { R_YMM,  R_YMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						             (VEX | VEX_66 | VEX_NDS | VEX_0F38 | VEX_W0 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0 | EVEX_BRD),		8,  1, { 0x65, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },
{ "vblendmps",      3, { R_ZMM,  R_ZMM,  M512         }, EVX0, (F_MODRM | F_MODRM_REG),						             (VEX | VEX_66 | VEX_NDS | VEX_0F38 | VEX_W0 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),	              1, 1, { 0x65, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },
{ "vblendmps",      3, { R_ZMM,  R_ZMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						             (VEX | VEX_66 | VEX_NDS | VEX_0F38 | VEX_W0 | EVEX), (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0 | EVEX_BRD),	  16, 1, { 0x65, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
/* VAESDEC xmm1, xmm2, xmm3 / m128 VEX.128.66.0F38.WIG DE / r */
/* ----------------------------------------------------------------------------------------------- */
{ "vaesdec",      3, { R_XMM,  R_XMM,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),           (VEX | VEX_66 | VEX_NDS | VEX_0F38 | VEX_WIG), (NO_EVEX),   1,  1, { 0xde, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vaesdec",      3, { R_XMM,  R_XMM,  M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						             (VEX | VEX_66 | VEX_NDS | VEX_0F38 | VEX_WIG), (NO_EVEX),	 1,  1, { 0xde, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
  /* VAESDECLAST xmm1, xmm2, xmm3 / m128 VEX.128.66.0F38.WIG DF / r */
  /* ----------------------------------------------------------------------------------------------- */
  { "vaesdeclast",      3, { R_XMM,  R_XMM,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),      (VEX | VEX_66 | VEX_NDS | VEX_0F38 | VEX_WIG), (NO_EVEX),   1,  1, { 0xdf, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
  { "vaesdeclast",      3, { R_XMM,  R_XMM,  M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						        (VEX | VEX_66 | VEX_NDS | VEX_0F38 | VEX_WIG), (NO_EVEX),		1,  1, { 0xdf, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },

  /* ----------------------------------------------------------------------------------------------- */
    /* VAESENC xmm1, xmm2, xmm3 / m128 VEX.128.66.0F38.WIG DC / r */
    /* ----------------------------------------------------------------------------------------------- */
    { "vaesenc",      3, { R_XMM,  R_XMM,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),          (VEX | VEX_66 | VEX_NDS | VEX_0F38 | VEX_WIG), (NO_EVEX),   1,  1, { 0xdc, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
    { "vaesenc",      3, { R_XMM,  R_XMM,  M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						            (VEX | VEX_66 | VEX_NDS | VEX_0F38 | VEX_WIG), (NO_EVEX),		1,  1, { 0xdc, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },

    /* ----------------------------------------------------------------------------------------------- */
      /* VAESENCLAST xmm1, xmm2, xmm3 / m128 VEX.128.66.0F38.WIG DD / r */
      /* ----------------------------------------------------------------------------------------------- */
      { "vaesdeclast",      3, { R_XMM,  R_XMM,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),       (VEX | VEX_66 | VEX_NDS | VEX_0F38 | VEX_WIG), (NO_EVEX),   1,  1, { 0xdd, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
      { "vaesdeclast",      3, { R_XMM,  R_XMM,  M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						        (VEX | VEX_66 | VEX_NDS | VEX_0F38 | VEX_WIG), (NO_EVEX),		 1,  1, { 0xdd, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },

      /* ----------------------------------------------------------------------------------------------- */
        /* VAESIMC xmm1, xmm2 / m128 VEX.128.66.0F38.WIG DB / r */
        /* ----------------------------------------------------------------------------------------------- */
        { "vaesimc",      2, { R_XMM,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),           (VEX | VEX_66 | VEX_0F38 | VEX_WIG), (NO_EVEX),    1,  1, { 0xdb, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
        { "vaesimc",      2, { R_XMM,  M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						             (VEX | VEX_66 | VEX_0F38 | VEX_WIG), (NO_EVEX),		1,  1, { 0xdb, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },

        /* ----------------------------------------------------------------------------------------------- */
          /* VAESKEYGENASSIST xmm1, xmm2 / m128, imm8 VEX.128.66.0F3A.WIG DF / r ib */
          /* ----------------------------------------------------------------------------------------------- */
          { "vaeskeygenassist",    3, { R_XMM,  R_XMM,  IMM8          }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_WIG | VEX_0F3A | VEX_66 | VEX_2OPND), (NO_EVEX),             1,  1, { 0xdf, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
          { "vaeskeygenassist",    3, { R_XMM,  M_ANY,  IMM8          }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_WIG | VEX_0F3A | VEX_66 | VEX_2OPND), (NO_EVEX),             1,  1, { 0xdf, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
          /* ================================================================================================== */
          /* VEX-ENCODED GPR INSTRUCTIONS */
          /* ----------------------------------------------------------------------------------------------- */
          //ANDN r32a, r32b, r / m32 VEX.LZ.0F38.W0 F2 / r2 
          //ANDN r64a, r64b, r / m64 VEX.LZ. 0F38.W1 F2 / r
          { "andn",      3, { R32,  R32,  R32        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),           (VEX | VEX_W0 | VEX_NDS | VEX_0F38), (NO_EVEX),  1,  1, { 0xf2, 0x00, 0x00 }, 4, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
          { "andn",      3, { R32,  R32,  M_ANY      }, AVX0, (F_MODRM | F_MODRM_REG),						            (VEX | VEX_W0 | VEX_NDS | VEX_0F38), (NO_EVEX),	 1,  1, { 0xf2, 0x00, 0x00 }, 4, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },
          { "andn",      3, { R64,  R64,  R64        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),           (VEX | VEX_W1 | VEX_NDS | VEX_0F38), (NO_EVEX),  1,  1, { 0xf2, 0x00, 0x00 }, 8, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
          { "andn",      3, { R64,  R64,  M_ANY      }, AVX0, (F_MODRM | F_MODRM_REG),						            (VEX | VEX_W1 | VEX_NDS | VEX_0F38), (NO_EVEX),	 1,  1, { 0xf2, 0x00, 0x00 }, 8, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },

          //BEXTR r32a, r / m32, r32b VEX.LZ.0F38.W0 F7 / r
          //BEXTR r64a, r / m64, r64b VEX.LZ.0F38.W1 F7 / r
          { "bextr",     3, { R32,  R32,     R32     }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),          (VEX | VEX_W0 | VEX_0F38 | VEX_3RD_OP), (NO_EVEX), 1,  1, { 0xf7, 0x00, 0x00 }, 4, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
          { "bextr",     3, { R32,  M_ANY,   R32     }, AVX0, (F_MODRM | F_MODRM_REG),					             (VEX | VEX_W0 | VEX_0F38 | VEX_3RD_OP), (NO_EVEX), 1,  1, { 0xf7, 0x00, 0x00 }, 4, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
          { "bextr",     3, { R64,  R64,     R64     }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),          (VEX | VEX_W1 | VEX_0F38 | VEX_3RD_OP), (NO_EVEX), 1,  1, { 0xf7, 0x00, 0x00 }, 8, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
          { "bextr",     3, { R64,  M_ANY,   R64     }, AVX0, (F_MODRM | F_MODRM_REG),					             (VEX | VEX_W1 | VEX_0F38 | VEX_3RD_OP), (NO_EVEX), 1,  1, { 0xf7, 0x00, 0x00 }, 8, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },

          //BLSI r32, r / m32 VEX.LZ.0F38.W0 F3 / 3 
          //BLSI r64, r / m64 VEX.LZ.0F38.W1 F3 / 3
          { "blsi",      2, { R32,  R32,      }, AVX0, (F_MODRM_REG | F_MODRM_RM | F_MODRM | SRCHDSTL),      (VEX | VEX_W0 | VEX_0F38 | VEX_DDS), (NO_EVEX), 1,  1, { 0xf3, 0x03, 0x00 }, 4, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
          { "blsi",      2, { R32,  M_ANY,    }, AVX0, (F_MODRM_REG | F_MODRM | SRCHDSTL),					         (VEX | VEX_W0 | VEX_0F38 | VEX_DDS), (NO_EVEX), 1,  1, { 0xf3, 0x03, 0x00 }, 4, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
          { "blsi",      2, { R64,  R64,      }, AVX0, (F_MODRM_REG | F_MODRM_RM | F_MODRM | SRCHDSTL),      (VEX | VEX_W1 | VEX_0F38 | VEX_DDS), (NO_EVEX), 1,  1, { 0xf3, 0x03, 0x00 }, 8, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
          { "blsi",      2, { R64,  M_ANY,    }, AVX0, (F_MODRM_REG | F_MODRM | SRCHDSTL),					         (VEX | VEX_W1 | VEX_0F38 | VEX_DDS), (NO_EVEX), 1,  1, { 0xf3, 0x03, 0x00 }, 8, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },

          //BLSMSK r32, r / m32 VEX.LZ.0F38.W0 F3 / 2
          //BLSMSK r64, r / m64 VEX.LZ.0F38.W1 F3 / 2
          { "blsmsk",   2, { R32,  R32,      }, AVX0, (F_MODRM_REG | F_MODRM_RM | F_MODRM | SRCHDSTL),      (VEX | VEX_W0 | VEX_0F38 | VEX_DDS), (NO_EVEX), 1,  1, { 0xf3, 0x02, 0x00 }, 4, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
          { "blsmsk",   2, { R32,  M_ANY,    }, AVX0, (F_MODRM_REG | F_MODRM | SRCHDSTL),					          (VEX | VEX_W0 | VEX_0F38 | VEX_DDS), (NO_EVEX), 1,  1, { 0xf3, 0x02, 0x00 }, 4, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
          { "blsmsk",   2, { R64,  R64,      }, AVX0, (F_MODRM_REG | F_MODRM_RM | F_MODRM | SRCHDSTL),      (VEX | VEX_W1 | VEX_0F38 | VEX_DDS), (NO_EVEX), 1,  1, { 0xf3, 0x02, 0x00 }, 8, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
          { "blsmsk",   2, { R64,  M_ANY,    }, AVX0, (F_MODRM_REG | F_MODRM | SRCHDSTL),					          (VEX | VEX_W1 | VEX_0F38 | VEX_DDS), (NO_EVEX), 1,  1, { 0xf3, 0x02, 0x00 }, 8, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },

          //BLSR r32, r / m32 VEX.LZ.0F38.W0 F3 / 1   
          //BLSR r64, r / m64 VEX.LZ.0F38.W1 F3 / 1
          { "blsr",      2, { R32,  R32,      }, AVX0, (F_MODRM_REG | F_MODRM_RM | F_MODRM | SRCHDSTL),      (VEX | VEX_W0 | VEX_0F38 | VEX_DDS), (NO_EVEX), 1,  1, { 0xf3, 0x01, 0x00 }, 4, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
          { "blsr",      2, { R32,  M_ANY,    }, AVX0, (F_MODRM_REG | F_MODRM | SRCHDSTL),					         (VEX | VEX_W0 | VEX_0F38 | VEX_DDS), (NO_EVEX), 1,  1, { 0xf3, 0x01, 0x00 }, 4, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
          { "blsr",      2, { R64,  R64,      }, AVX0, (F_MODRM_REG | F_MODRM_RM | F_MODRM | SRCHDSTL),      (VEX | VEX_W1 | VEX_0F38 | VEX_DDS), (NO_EVEX), 1,  1, { 0xf3, 0x01, 0x00 }, 8, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
          { "blsr",      2, { R64,  M_ANY,    }, AVX0, (F_MODRM_REG | F_MODRM | SRCHDSTL),					         (VEX | VEX_W1 | VEX_0F38 | VEX_DDS), (NO_EVEX), 1,  1, { 0xf3, 0x01, 0x00 }, 8, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },

          //BZHI r32a, r / m32, r32b VEX.LZ.0F38.W0 F5 / r
          //BZHI r64a, r / m64, r64b VEX.LZ.0F38.W1 F5 / r
          { "bzhi",     3, { R32,  R32,     R32     }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),          (VEX | VEX_W0 | VEX_0F38 | VEX_3RD_OP), (NO_EVEX), 1,  1, { 0xf5, 0x00, 0x00 }, 4, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
          { "bzhi",     3, { R32,  M_ANY,   R32     }, AVX0, (F_MODRM | F_MODRM_REG),					              (VEX | VEX_W0 | VEX_0F38 | VEX_3RD_OP), (NO_EVEX), 1,  1, { 0xf5, 0x00, 0x00 }, 4, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
          { "bzhi",     3, { R64,  R64,     R64     }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),          (VEX | VEX_W1 | VEX_0F38 | VEX_3RD_OP), (NO_EVEX), 1,  1, { 0xf5, 0x00, 0x00 }, 8, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
          { "bzhi",     3, { R64,  M_ANY,   R64     }, AVX0, (F_MODRM | F_MODRM_REG),					              (VEX | VEX_W1 | VEX_0F38 | VEX_3RD_OP), (NO_EVEX), 1,  1, { 0xf5, 0x00, 0x00 }, 8, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },

          //PDEP r32a, r32b, r / m32 VEX.LZ.F2.0F38.W0 F5 / r
          //PDEP r64a, r64b, r / m64 VEX.LZ.F2.0F38.W1 F5 / r
          { "pdep",      3, { R32,  R32,  R32        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),           (VEX | VEX_W0 | VEX_0F38 | VEX_NDS | VEX_F2), (NO_EVEX),   1,  1, { 0xf5, 0x00, 0x00 }, 4, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
          { "pdep",      3, { R32,  R32,  M_ANY      }, AVX0, (F_MODRM | F_MODRM_REG),						            (VEX | VEX_W0 | VEX_0F38 | VEX_NDS | VEX_F2), (NO_EVEX),	 1,  1, { 0xf5, 0x00, 0x00 }, 4, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },
          { "pdep",      3, { R64,  R64,  R64        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),           (VEX | VEX_W1 | VEX_0F38 | VEX_NDS | VEX_F2), (NO_EVEX),   1,  1, { 0xf5, 0x00, 0x00 }, 8, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
          { "pdep",      3, { R64,  R64,  M_ANY      }, AVX0, (F_MODRM | F_MODRM_REG),						            (VEX | VEX_W1 | VEX_0F38 | VEX_NDS | VEX_F2), (NO_EVEX),	 1,  1, { 0xf5, 0x00, 0x00 }, 8, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },

          //PEXT r32a, r32b, r / m32 VEX.LZ.F3.0F38.W0 F5 / r
          //PEXT r64a, r64b, r / m64 VEX.LZ.F3.0F38.W1 F5 / r
          { "pext",      3, { R32,  R32,  R32        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),           (VEX | VEX_W0 | VEX_0F38 | VEX_NDS | VEX_F3), (NO_EVEX),   1,  1, { 0xf5, 0x00, 0x00 }, 4, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
          { "pext",      3, { R32,  R32,  M_ANY      }, AVX0, (F_MODRM | F_MODRM_REG),						            (VEX | VEX_W0 | VEX_0F38 | VEX_NDS | VEX_F3), (NO_EVEX),	 1,  1, { 0xf5, 0x00, 0x00 }, 4, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },
          { "pext",      3, { R64,  R64,  R64        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),           (VEX | VEX_W1 | VEX_0F38 | VEX_NDS | VEX_F3), (NO_EVEX),   1,  1, { 0xf5, 0x00, 0x00 }, 8, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
          { "pext",      3, { R64,  R64,  M_ANY      }, AVX0, (F_MODRM | F_MODRM_REG),						            (VEX | VEX_W1 | VEX_0F38 | VEX_NDS | VEX_F3), (NO_EVEX),	 1,  1, { 0xf5, 0x00, 0x00 }, 8, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },

          //RORX r32, r / m32, imm8 VEX.LZ.F2.0F3A.W0 F0 / r ib
          //RORX r64, r / m64, imm8 VEX.LZ.F2.0F3A.W1 F0 / r ib
          { "rorx",   3, { R32,   R32,    IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | SRCHDSTL) | IMM8_ONLY, (VEX | VEX_W0 | VEX_0F3A | VEX_NDS | VEX_F2), (NO_EVEX),   1, 1, { 0xf0, 0x00, 0x00 }, 4, 1, MOD_REG_REG, 0, 0   , 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
          { "rorx",   3, { R32,   M_ANY,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | SRCHDSTL) | IMM8_ONLY,	             (VEX | VEX_W0 | VEX_0F3A | VEX_NDS | VEX_F2), (NO_EVEX),   1, 1, { 0xf0, 0x00, 0x00 }, 4, 1, MOD_REG_MEM, 0, 0   , 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
          { "rorx",   3, { R64,   R64,    IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | SRCHDSTL) | IMM8_ONLY, (VEX | VEX_W1 | VEX_0F3A | VEX_NDS | VEX_F2), (NO_EVEX),   1, 1, { 0xf0, 0x00, 0x00 }, 8, 1, MOD_REG_REG, 0, 0   , 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
          { "rorx",   3, { R64,   M_ANY,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | SRCHDSTL) | IMM8_ONLY,	             (VEX | VEX_W1 | VEX_0F3A | VEX_NDS | VEX_F2), (NO_EVEX),   1, 1, { 0xf0, 0x00, 0x00 }, 8, 1, MOD_REG_MEM, 0, 0   , 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
          /* END VEX-ENCODED GPR INSTRUCTIONS */
          /* ================================================================================================== */

          //BNDCL bnd, r / m32 F3 0F 1A / r
          //BNDCL bnd, r / m64 F3 0F 1A / r
          //{ "bndcl",    2, { BND,      R32     }, GP0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),							                  NO_VEX, NO_EVEX, 1, 1, { 0x1A, 0x00, 0x00 }, 4, 0, MOD_REG_REG, 0, 0,                0,                         (X32 | X64), REG_DST,  PFX_0xF30F, NO_IMM,      NO_MEM,     P_686 | P_SSE4,  0, NULL },
          //{ "bndcl",    2, { BND,      R64     }, GP3, (REX | REXW) | (F_MODRM | F_MODRM_REG | F_MODRM_RM),		              NO_VEX, NO_EVEX, 1, 1, { 0x1A, 0x00, 0x00 }, 8, 0, MOD_REG_REG, 0, 0,                0,                         (X64),       REG_DST,  PFX_0xF30F, NO_IMM,      NO_MEM,     P_686 | P_SSE4,  0, NULL },
          //{ "bndcl",    2, { BND,      M_ANY   }, GP0, ALLOW_SEG | (F_MODRM | F_MODRM_REG),				                          NO_VEX, NO_EVEX, 1, 1, { 0x1A, 0x00, 0x00 }, 4, 0, MOD_REG_MEM, 0, OP_SIZE_OVERRIDE,	ADDR_SIZE_OVERRIDE,       (X32 | X64), REG_DST,  PFX_0xF30F, NO_IMM,      MEM_OPND_1, P_686 | P_SSE4,  0, NULL },
          //{ "bndcl",    2, { BND,      M_ANY   }, GP0, ALLOW_SEG | (REX | REXW) | (F_MODRM | F_MODRM_REG),				          NO_VEX, NO_EVEX, 1, 1, { 0x1A, 0x00, 0x00 }, 8, 0, MOD_REG_MEM, 0, 0,				          ADDR_SIZE_OVERRIDE,       (X64),       REG_DST,  PFX_0xF30F, NO_IMM,      MEM_OPND_1, P_686 | P_SSE4,  0, NULL },
          /* ----------------------------------------------------------------------------------------------- */
        //VANDPD xmm1, xmm2, xmm3/m128 VEX.128.66.0F 54 /r                     
        //VANDPD ymm1, ymm2, ymm3/m256 VEX.256.66.0F 54 /r                     
        //VANDPD xmm1 {k1}{z}, xmm2, xmm3/m128/m64bcst EVEX.128.66.0F.W1 54 /r 
        //VANDPD ymm1 {k1}{z}, ymm2, ymm3/m256/m64bcst EVEX.256.66.0F.W1 54 /r 
        //VANDPD zmm1 {k1}{z}, zmm2, zmm3/m512/m64bcst EVEX.512.66.0F.W1 54 /r 
          /* ----------------------------------------------------------------------------------------------- */
        { "vandpd",      3, { R_XMM,  R_XMM,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_66 | VEX_NDS | VEX_0F | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1),					                2,  1, { 0x54, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
        { "vandpd",      3, { R_XMM,  R_XMM,  M128         }, AVX0, (F_MODRM | F_MODRM_REG),						             (VEX | VEX_66 | VEX_NDS | VEX_0F | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1),		                      1,  1, { 0x54, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },
        { "vandpd",      3, { R_XMM,  R_XMM,  M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						             (VEX | VEX_66 | VEX_NDS | VEX_0F | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),		          2,  1, { 0x54, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },
        { "vandpd",      3, { R_YMM,  R_YMM,  R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_66 | VEX_NDS | VEX_0F | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1),					                4,  1, { 0x54, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
        { "vandpd",      3, { R_YMM,  R_YMM,  M256         }, AVX1, (F_MODRM | F_MODRM_REG),						             (VEX | VEX_66 | VEX_NDS | VEX_0F | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1),		                      1,  1, { 0x54, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },
        { "vandpd",      3, { R_YMM,  R_YMM,  M_ANY        }, AVX1, (F_MODRM | F_MODRM_REG),						             (VEX | VEX_66 | VEX_NDS | VEX_0F | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),		          4,  1, { 0x54, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },
        { "vandpd",      3, { R_ZMM,  R_ZMM,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_NDS | VEX_0F),          (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),					    8,  1, { 0x54, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
        { "vandpd",      3, { R_ZMM,  R_ZMM,  M512         }, EVX0, (F_MODRM | F_MODRM_REG),						             (EVEX | VEX_66 | VEX_NDS | VEX_0F),          (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),	            1,  1, { 0x54, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },
        { "vandpd",      3, { R_ZMM,  R_ZMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						             (EVEX | VEX_66 | VEX_NDS | VEX_0F),          (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),	8,  1, { 0x54, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },
        /* ----------------------------------------------------------------------------------------------- */
        //VANDPS xmm1, xmm2, xmm3 / m128  VEX.128.0F 54 / r
        //VANDPS ymm1, ymm2, ymm3 / m256 VEX.256.0F 54 / r
        //VANDPS xmm1{k1}{z}, xmm2, xmm3 / m128 / m32bcst EVEX.128.0F.W0 54 / r
        //VANDPS ymm1{k1}{z}, ymm2, ymm3 / m256 / m32bcst EVEX.256.0F.W0 54 / r
        //VANDPS zmm1{k1}{z}, zmm2, zmm3 / m512 / m32bcst EVEX.512.0F.W0 54 / r
        /* ----------------------------------------------------------------------------------------------- */
      { "vandps",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                        4,  1, { 0x54, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
      { "vandps",  3, { R_XMM,  R_XMM, M128              }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x54, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
      { "vandps",  3, { R_XMM,  R_XMM, M_ANY             }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),             4,  1, { 0x54, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
      { "vandps",  3, { R_YMM,  R_YMM, R_YMM             }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                        8,  1, { 0x54, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
      { "vandps",  3, { R_YMM,  R_YMM, M256              }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                        1,  1, { 0x54, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
      { "vandps",  3, { R_YMM,  R_YMM, M_ANY             }, AVX1, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),             8,  1, { 0x54, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
      { "vandps",  3, { R_ZMM,  R_ZMM, R_ZMM             }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (EVEX | VEX_0F | VEX_NDS),                  (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),            16, 1, { 0x54, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
      { "vandps",  3, { R_ZMM,  R_ZMM, M512              }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_0F | VEX_NDS),                  (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),            1,  1, { 0x54, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
      { "vandps",  3, { R_ZMM,  R_ZMM, M_ANY             }, EVX0, (F_MODRM | F_MODRM_REG),                           (EVEX | VEX_0F | VEX_NDS),                  (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD), 16, 1, { 0x54, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
      /* ----------------------------------------------------------------------------------------------- */
      //VANDNPD xmm1, xmm2,xmm3 / m128 VEX.128.66.0F 55 / r
      //VANDNPD ymm1, ymm2,ymm3 / m256 VEX.256.66.0F 55 / r
      //VANDNPD xmm1{k1}{z}, xmm2,xmm3 / m128 / m64bcst EVEX.128.66.0F.W1 55 / r
      //VANDNPD ymm1{k1}{z}, ymm2,ymm3 / m256 / m64bcst EVEX.256.66.0F.W1 55 / r
      //VANDNPD zmm1{k1}{z}, zmm2,zmm3 / m512 / m64bcst EVEX.512.66.0F.W1 55 / r
      /* ----------------------------------------------------------------------------------------------- */
    { "vandnpd",      3, { R_XMM,  R_XMM,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_66 | VEX_NDS | VEX_0F | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1),					                2,  1, { 0x55, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
    { "vandnpd",      3, { R_XMM,  R_XMM,  M128         }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_66 | VEX_NDS | VEX_0F | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1),		                      1,  1, { 0x55, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },
    { "vandnpd",      3, { R_XMM,  R_XMM,  M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_66 | VEX_NDS | VEX_0F | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),		            2,  1, { 0x55, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },
    { "vandnpd",      3, { R_YMM,  R_YMM,  R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_66 | VEX_NDS | VEX_0F | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1),					                4,  1, { 0x55, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
    { "vandnpd",      3, { R_YMM,  R_YMM,  M256         }, AVX1, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_66 | VEX_NDS | VEX_0F | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1),		                      1,  1, { 0x55, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },
    { "vandnpd",      3, { R_YMM,  R_YMM,  M_ANY        }, AVX1, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_66 | VEX_NDS | VEX_0F | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),		            4,  1, { 0x55, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },
    { "vandnpd",      3, { R_ZMM,  R_ZMM,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_NDS | VEX_0F),          (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),					    8,  1, { 0x55, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
    { "vandnpd",      3, { R_ZMM,  R_ZMM,  M512         }, EVX0, (F_MODRM | F_MODRM_REG),						              (EVEX | VEX_66 | VEX_NDS | VEX_0F),          (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),	            1,  1, { 0x55, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },
    { "vandnpd",      3, { R_ZMM,  R_ZMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						              (EVEX | VEX_66 | VEX_NDS | VEX_0F),          (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),	  8,  1, { 0x55, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,         P_686 | P_AVX, 0, NULL },
    /* ----------------------------------------------------------------------------------------------- */
    //VANDNPS xmm1, xmm2,xmm3 / m128 VEX.128.0F 55 / r
    //VANDNPS ymm1, ymm2,ymm3 / m256 VEX.256.0F 55 / r
    //VANDNPS xmm1{k1}{z},xmm2, xmm3 / m128 / m32bcst EVEX.128.0F.W0 55 / r
    //VANDNPS ymm1{k1}{z},ymm2, ymm3 / m256 / m32bcst EVEX.256.0F.W0 55 / r
    //VANDNPS zmm1{k1}{z},zmm2, zmm3 / m512 / m32bcst EVEX.512.0F.W0 55 / r
    /* ----------------------------------------------------------------------------------------------- */
  { "vandnps",      3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                           4,  1, { 0x55, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
  { "vandnps",      3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                           1,  1, { 0x55, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
  { "vandnps",      3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),                4,  1, { 0x55, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
  { "vandnps",      3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                           8,  1, { 0x55, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
  { "vandnps",      3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                           1,  1, { 0x55, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
  { "vandnps",      3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),                8,  1, { 0x55, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
  { "vandnps",      3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_0F | VEX_NDS),                  (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               16, 1, { 0x55, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
  { "vandnps",      3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_0F | VEX_NDS),                  (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0x55, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
  { "vandnps",      3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_0F | VEX_NDS),                  (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),    16, 1, { 0x55, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
  /* ----------------------------------------------------------------------------------------------- */
    //VCMPPD xmm1, xmm2, xmm3 / m128, imm8 VEX.128.66.0F.WIG C2 / r ib
    //VCMPPD ymm1, ymm2, ymm3 / m256, imm8 VEX.256.66.0F.WIG C2 / r ib
    //VCMPPD k1{k2}, xmm2, xmm3 / m128 / m64bcst, imm8 EVEX.128.66.0F.W1 C2 / r ib
    //VCMPPD k1{k2}, ymm2, ymm3 / m256 / m64bcst, imm8 EVEX.256.66.0F.W1 C2 / r ib
    //VCMPPD k1{k2}, zmm2, zmm3 / m512 / m64bcst{ sae }, imm8 EVEX.512.66.0F.W1 C2 / r ib
    /* ----------------------------------------------------------------------------------------------- */
{ "vcmppd",   4, { R_XMM,  R_XMM, R_XMM, IMM8    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_66 | VEX_WIG | VEX_0F | VEX_NDS),	         (NO_EVEX),												       4,  1, { 0xc2, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vcmppd",   4, { R_XMM,  R_XMM, M128,  IMM8    }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_66 | VEX_WIG | VEX_0F | VEX_NDS),          (NO_EVEX),												       1,  1, { 0xc2, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vcmppd",   4, { R_XMM,  R_XMM, M_ANY, IMM8    }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_66 | VEX_WIG | VEX_0F | VEX_NDS),          (NO_EVEX),												       4,  1, { 0xc2, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vcmppd",   4, { R_YMM,  R_YMM, R_YMM, IMM8    }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_66 | VEX_WIG | VEX_0F | VEX_NDS),	         (NO_EVEX),												       8,  1, { 0xc2, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vcmppd",   4, { R_YMM,  R_YMM, M256,  IMM8    }, AVX1, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_66 | VEX_WIG | VEX_0F | VEX_NDS),	         (NO_EVEX),												       1,  1, { 0xc2, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vcmppd",   4, { R_YMM,  R_YMM, M_ANY, IMM8    }, AVX1, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_66 | VEX_WIG | VEX_0F | VEX_NDS),	         (NO_EVEX),												       8,  1, { 0xc2, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vcmppd",   4, { R_K,    R_XMM, R_XMM, IMM8    }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_66 | VEX_0F | VEX_NDS),   (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),              2,  1, { 0xc2, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vcmppd",   4, { R_K,    R_XMM, M_ANY, IMM8    }, EVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_66 | VEX_0F | VEX_NDS),   (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),              1,  1, { 0xc2, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vcmppd",   4, { R_K,    R_XMM, M128,  IMM8    }, EVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_66 | VEX_0F | VEX_NDS),   (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),   2,  1, { 0xc2, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vcmppd",   4, { R_K,    R_YMM, R_YMM, IMM8    }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_66 | VEX_0F | VEX_NDS),   (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),              4,  1, { 0xc2, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vcmppd",   4, { R_K,    R_YMM, M256,  IMM8    }, EVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_66 | VEX_0F | VEX_NDS),   (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),              1,  1, { 0xc2, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vcmppd",   4, { R_K,    R_YMM, M_ANY, IMM8    }, EVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_66 | VEX_0F | VEX_NDS),   (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),   4,  1, { 0xc2, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vcmppd",   4, { R_K,    R_ZMM, R_ZMM, IMM8    }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_66 | VEX_0F | VEX_NDS),   (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_SAE),   8,  1, { 0xc2, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vcmppd",   4, { R_K,    R_ZMM, M512,  IMM8    }, EVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_66 | VEX_0F | VEX_NDS),   (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),              1,  1, { 0xc2, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vcmppd",   4, { R_K,    R_ZMM, M_ANY, IMM8    }, EVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_66 | VEX_0F | VEX_NDS),   (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),   8,  1, { 0xc2, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
  //VCMPPS xmm1, xmm2, xmm3 / m128, imm8      VEX.128.0F.WIG C2 / r ib
  //VCMPPS ymm1, ymm2, ymm3 / m256, imm8      VEX.256.0F.WIG C2 / r ib
  //VCMPPS k1{k2}, xmm2, xmm3 / m128 / m32bcst, imm8      EVEX.128.0F.W0 C2 / r ib
  //VCMPPS k1{k2}, ymm2, ymm3 / m256 / m32bcst, imm8      EVEX.256.0F.W0 C2 / r ib
  //VCMPPS k1{k2}, zmm2, zmm3 / m512 / m32bcst{ sae }, imm8      EVEX.512.0F.W0 C2 / r ib
  /* ----------------------------------------------------------------------------------------------- */
{ "vcmpps",   4, { R_XMM,  R_XMM, R_XMM, IMM8    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_WIG | VEX_0F | VEX_NDS),	         (NO_EVEX),			                        2,  1, { 0xc2, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vcmpps",   4, { R_XMM,  R_XMM, M128,  IMM8    }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_WIG | VEX_0F | VEX_NDS),           (NO_EVEX),			                        1,  1, { 0xc2, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vcmpps",   4, { R_XMM,  R_XMM, M_ANY, IMM8    }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_WIG | VEX_0F | VEX_NDS),           (NO_EVEX),			                        2,  1, { 0xc2, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vcmpps",   4, { R_YMM,  R_YMM, R_YMM, IMM8    }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_WIG | VEX_0F | VEX_NDS),	         (NO_EVEX),			                        4,  1, { 0xc2, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vcmpps",   4, { R_YMM,  R_YMM, M256,  IMM8    }, AVX1, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_WIG | VEX_0F | VEX_NDS),	         (NO_EVEX),			                        1,  1, { 0xc2, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vcmpps",   4, { R_YMM,  R_YMM, M_ANY, IMM8    }, AVX1, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_WIG | VEX_0F | VEX_NDS),	         (NO_EVEX),			                        4,  1, { 0xc2, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vcmpps",   4, { R_K,    R_XMM, R_XMM, IMM8    }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_0F | VEX_NDS),   (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),              4,  1, { 0xc2, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vcmpps",   4, { R_K,    R_XMM, M128,  IMM8    }, EVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_0F | VEX_NDS),   (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),              1,  1, { 0xc2, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vcmpps",   4, { R_K,    R_XMM, M_ANY, IMM8    }, EVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_0F | VEX_NDS),   (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),   4,  1, { 0xc2, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vcmpps",   4, { R_K,    R_YMM, R_YMM, IMM8    }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_0F | VEX_NDS),   (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),              8,  1, { 0xc2, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vcmpps",   4, { R_K,    R_YMM, M256,  IMM8    }, EVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_0F | VEX_NDS),   (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),              1,  1, { 0xc2, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vcmpps",   4, { R_K,    R_YMM, M_ANY, IMM8    }, EVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_0F | VEX_NDS),   (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),   8,  1, { 0xc2, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vcmpps",   4, { R_K,    R_ZMM, R_ZMM, IMM8    }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_0F | VEX_NDS),   (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_SAE),  16,  1, { 0xc2, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vcmpps",   4, { R_K,    R_ZMM, M512,  IMM8    }, EVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_0F | VEX_NDS),   (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),              1,  1, { 0xc2, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vcmpps",   4, { R_K,    R_ZMM, M_ANY, IMM8    }, EVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_0F | VEX_NDS),   (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),  16,  1, { 0xc2, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VCMPSD xmm1, xmm2, xmm3 / m64, imm8    VEX.LIG.F2.0F.WIG C2 / r ib
//VCMPSD k1{k2}, xmm2, xmm3 / m64{ sae }, imm8    EVEX.LIG.F2.0F.W1 C2 / r ib
/* ----------------------------------------------------------------------------------------------- */
{ "vcmpsd",   4, { R_XMM,  R_XMM, R_XMM, IMM8    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_WIG | VEX_F2 | VEX_0F | VEX_NDS),	         (NO_EVEX),			                                        2,  1, { 0xc2, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vcmpsd",   4, { R_XMM,  R_XMM, M_ANY, IMM8    }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_WIG | VEX_F2 | VEX_0F | VEX_NDS),          (NO_EVEX),			                                        2,  1, { 0xc2, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vcmpsd",   4, { R_K,    R_XMM, R_XMM, IMM8    }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_LIG | VEX_F2 | VEX_0F | VEX_NDS),   (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_SAE),        2,  1, { 0xc2, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vcmpsd",   4, { R_K,    R_XMM, M_ANY, IMM8    }, EVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_LIG | VEX_F2 | VEX_0F | VEX_NDS),   (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                   2,  1, { 0xc2, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VCMPSS xmm1, xmm2, xmm3 / m32, imm8 VEX.LIG.F3.0F.WIG C2 / r ib
//VCMPSS k1{k2}, xmm2, xmm3 / m32{ sae }, imm8 EVEX.LIG.F3.0F.W0 C2 / r ib
/* ----------------------------------------------------------------------------------------------- */
{ "vcmpss",   4, { R_XMM,  R_XMM, R_XMM, IMM8    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_WIG | VEX_F3 | VEX_0F | VEX_NDS),	         (NO_EVEX),			                                        4,  1, { 0xc2, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vcmpss",   4, { R_XMM,  R_XMM, M_ANY, IMM8    }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_WIG | VEX_F3 | VEX_0F | VEX_NDS),          (NO_EVEX),			                                        4,  1, { 0xc2, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vcmpss",   4, { R_K,    R_XMM, R_XMM, IMM8    }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_LIG | VEX_F3 | VEX_0F | VEX_NDS),   (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_SAE),        4,  1, { 0xc2, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vcmpss",   4, { R_K,    R_XMM, M_ANY, IMM8    }, EVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_LIG | VEX_F3 | VEX_0F | VEX_NDS),   (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),                   4,  1, { 0xc2, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPCLMULQDQ xmm1, xmm2, xmm3 / m128, imm8 VEX.128.66.0F3A.WIG 44 / r ib
/* ----------------------------------------------------------------------------------------------- */
{ "vpclmulqdq",   4, { R_XMM,  R_XMM, R_XMM, IMM8    }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_66 | VEX_WIG | VEX_0F3A | VEX_NDS),	          (NO_EVEX),			                                1,  1, { 0x44, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vpclmulqdq",   4, { R_XMM,  R_XMM, M_ANY, IMM8    }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_66 | VEX_WIG | VEX_0F3A | VEX_NDS),           (NO_EVEX),			                                1,  1, { 0x44, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VCVTDQ2PD xmm1, xmm2 / m64                        VEX.128.F3.0F.WIG E6 / r
//VCVTDQ2PD ymm1, xmm2 / m128                       VEX.256.F3.0F.WIG E6 / r
//VCVTDQ2PD xmm1{k1}{z},xmm2 / m128 / m32bcst    EVEX.128.F3.0F.W0 E6 / r
//VCVTDQ2PD ymm1{k1}{z},xmm2 / m128 / m32bcst    EVEX.256.F3.0F.W0 E6 / r 
//VCVTDQ2PD zmm1{k1}{z},ymm2 / m256 / m32bcst    EVEX.512.F3.0F.W0 E6 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vcvtdq2pd",      2, { R_XMM,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F3 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0),					                1,  1, { 0xe6, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvtdq2pd",      2, { R_XMM,  M128         }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_F3 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0),		                      1,  1, { 0xe6, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtdq2pd",      2, { R_XMM,  M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_F3 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0 | EVEX_BRD),		            4,  1, { 0xe6, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtdq2pd",      2, { R_YMM,  R_XMM        }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F3 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0),					                2,  1, { 0xe6, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvtdq2pd",      2, { R_YMM,  M128         }, AVX1, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_F3 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0),		                      2,  1, { 0xe6, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtdq2pd",      2, { R_YMM,  M_ANY        }, AVX1, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_F3 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0 | EVEX_BRD),		            8,  1, { 0xe6, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtdq2pd",      2, { R_ZMM,  R_YMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_F3 | VEX_0F | VEX_2OPND),        (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),					                2,  1, { 0xe6, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvtdq2pd",      2, { R_ZMM,  M256         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_F3 | VEX_0F | VEX_2OPND),        (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),                          2,  1, { 0xe6, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtdq2pd",      2, { R_ZMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						              (EVEX | VEX_F3 | VEX_0F | VEX_2OPND),        (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0 | EVEX_BRD),	              16, 1, { 0xe6, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VCVTDQ2PS xmm1, xmm2 / m128    VEX.128.0F.WIG 5B / r
//VCVTDQ2PS ymm1, ymm2 / m256    VEX.256.0F.WIG 5B / r
//VCVTDQ2PS xmm1{k1}{z},xmm2 / m128 / m32bcst    EVEX.128.0F.W0 5B / r
//VCVTDQ2PS ymm1{k1}{z},ymm2 / m256 / m32bcst    EVEX.256.0F.W0 5B / r
//VCVTDQ2PS zmm1{k1}{z},zmm2 / m512 / m32bcst{ er }    EVEX.512.0F.W0 5B / r
/* ----------------------------------------------------------------------------------------------- */
{ "vcvtdq2ps",      2, { R_XMM,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0),					                        4,  1, { 0x5b, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvtdq2ps",      2, { R_XMM,  M128         }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0),		                                1,  1, { 0x5b, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtdq2ps",      2, { R_XMM,  M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0 | EVEX_BRD),		                    4,  1, { 0x5b, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtdq2ps",      2, { R_YMM,  R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0),					                        8,  1, { 0x5b, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvtdq2ps",      2, { R_YMM,  M256         }, AVX1, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0),		                                1,  1, { 0x5b, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtdq2ps",      2, { R_YMM,  M_ANY        }, AVX1, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0 | EVEX_BRD),		                    8,  1, { 0x5b, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtdq2ps",      2, { R_ZMM,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0 | EVEX_RND),					             16,  1, { 0x5b, 0x00, 0x00 }, 64, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvtdq2ps",      2, { R_ZMM,  M512         }, EVX0, (F_MODRM | F_MODRM_REG),						              (EVEX | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),	                                1,  1, { 0x5b, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtdq2ps",      2, { R_ZMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						              (EVEX | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0 | EVEX_BRD),	                     16,  1, { 0x5b, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
//VCVTPD2DQ xmm1, xmm2 / m128    VEX.128.F2.0F.WIG E6 / r
//VCVTPD2DQ xmm1, ymm2 / m256    VEX.256.F2.0F.WIG E6 / r
//VCVTPD2DQ xmm1{k1}{z},xmm2 / m128 / m64bcst    EVEX.128.F2.0F.W1 E6 / r
//VCVTPD2DQ xmm1{k1}{z},ymm2 / m256 / m64bcst    EVEX.256.F2.0F.W1 E6 / r
//VCVTPD2DQ ymm1{k1}{z},zmm2 / m512 / m64bcst{er}EVEX.512.F2.0F.W1 E6 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vcvtpd2dq",      2, { R_XMM,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F2 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1),					                2,  1, { 0xe6, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvtpd2dq",      2, { R_XMM,  M128         }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_F2 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),		            2,  1, { 0xe6, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtpd2dq",      2, { R_XMM,  R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F2 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1),					                4,  1, { 0xe6, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvtpd2dq",      2, { R_XMM,  M256         }, AVX1, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_F2 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),		            4,  1, { 0xe6, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtpd2dq",      2, { R_YMM,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_F2 | VEX_0F | VEX_2OPND),        (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_RND),					      8,  1, { 0xe6, 0x00, 0x00 }, 64, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvtpd2dq",      2, { R_YMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						              (EVEX | VEX_F2 | VEX_0F | VEX_2OPND),        (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),	              8,  1, { 0xe6, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtpd2dq",      2, { R_YMM,  M512         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_F2 | VEX_0F | VEX_2OPND),        (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),                         16,  1, { 0xe6, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VCVTPD2PS xmm1, xmm2 / m128    VEX.128.66.0F.WIG 5A / r
//VCVTPD2PS xmm1, ymm2 / m256    VEX.256.66.0F.WIG 5A / r
//VCVTPD2PS xmm1{k1}{z},xmm2 / m128 / m64bcst    EVEX.128.66.0F.W1 5A / r
//VCVTPD2PS xmm1{k1}{z},ymm2 / m256 / m64bcst    EVEX.256.66.0F.W1 5A / r
//VCVTPD2PS ymm1{k1}{z},zmm2 / m512 / m64bcst{er}    EVEX.512.66.0F.W1 5A / r
/* ----------------------------------------------------------------------------------------------- */
{ "vcvtpd2ps",      2, { R_XMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_0F | VEX_66 | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),		                   2,  1, { 0x5a, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtpd2ps",      2, { R_XMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_0F | VEX_66 | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),		                   4,  1, { 0x5a, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtpd2ps",      2, { R_YMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						              (EVEX | VEX_0F | VEX_66 | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),	                   8,  1, { 0x5a, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtpd2ps",      2, { R_XMM,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),             (VEX | VEX_0F | VEX_66 | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1),					                       1,  1, { 0x5a, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvtpd2ps",      2, { R_XMM,  M128         }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_0F | VEX_66 | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),		                   1,  1, { 0x5a, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtpd2ps",      2, { R_XMM,  R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),             (VEX | VEX_0F | VEX_66 | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1),					                       1,  1, { 0x5a, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvtpd2ps",      2, { R_XMM,  M256         }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_0F | VEX_66 | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1),		                             4,  1, { 0x5a, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtpd2ps",      2, { R_YMM,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),             (EVEX | VEX_0F | VEX_66 | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_RND),					           1,  1, { 0x5a, 0x00, 0x00 }, 64, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvtpd2ps",      2, { R_YMM,  M512         }, EVX0, (F_MODRM | F_MODRM_REG),						              (EVEX | VEX_0F | VEX_66 | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),		                 1,  1, { 0x5a, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VCVTPS2PD xmm1, xmm2 / m64    VEX.128.0F.WIG 5A / r
//VCVTPS2PD ymm1, xmm2 / m128    VEX.256.0F.WIG 5A / r
//VCVTPS2PD xmm1{k1}{z},xmm2 / m64 / m32bcst    EVEX.128.0F.W0 5A / r
//VCVTPS2PD ymm1{k1}{z},xmm2 / m128 / m32bcst    EVEX.256.0F.W0 5A / r
//VCVTPS2PD zmm1{k1}{z},ymm2 / m256 / m32bcst{ sae }    EVEX.512.0F.W0 5A / r
/* ----------------------------------------------------------------------------------------------- */
{ "vcvtps2pd",      2, { R_XMM,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0),					                          1,  1, { 0x5a, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvtps2pd",      2, { R_XMM,  M64          }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (NO_EVEX),		                                                    2,  1, { 0x5a, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtps2pd",      2, { R_XMM,  M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0 | EVEX_BRD),		                    4,  1, { 0x5a, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtps2pd",      2, { R_YMM,  R_XMM        }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0),					                          8,  1, { 0x5a, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvtps2pd",      2, { R_YMM,  M128         }, AVX1, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (NO_EVEX),		                                                    2,  1, { 0x5a, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtps2pd",      2, { R_YMM,  M_ANY        }, AVX1, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0 | EVEX_BRD),		                    8,  1, { 0x5a, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtps2pd",      2, { R_ZMM,  R_YMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0 | EVEX_SAE),					             16,  1, { 0x5a, 0x00, 0x00 }, 64, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvtps2pd",      2, { R_ZMM,  M256         }, EVX0, (F_MODRM | F_MODRM_REG),						              (EVEX | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),	                                2,  1, { 0x5a, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtps2pd",      2, { R_ZMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						              (EVEX | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0 | EVEX_BRD),	                     16,  1, { 0x5a, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VCVTSD2SI r32, xmm1 / m64    VEX.LIG.F2.0F.W0 2D / r 
//VCVTSD2SI r64, xmm1 / m64    VEX.LIG.F2.0F.W1 2D / r 
//VCVTSD2SI r32, xmm1 / m64{er}    EVEX.LIG.F2.0F.W0 2D / r
//VCVTSD2SI r64, xmm1 / m64{er}    EVEX.LIG.F2.0F.W1 2D / r
/* ----------------------------------------------------------------------------------------------- */
{ "vcvtsd2si",      2, { R32,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),           (VEX | VEX_F2 | VEX_0F | VEX_LIG | VEX_W0 | VEX_2OPND | EVEX),    (EVEX_W0 | EVEX_RND),			 4,  1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvtsd2si",      2, { R32,  M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_F2 | VEX_0F | VEX_LIG | VEX_W0 | VEX_2OPND | EVEX),    (EVEX_W0),		             4,  1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtsd2si",      2, { R32E, R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F2 | VEX_0F | VEX_LIG | VEX_W0 | VEX_2OPND | EVEX),    (EVEX_W0 | EVEX_RND),			 4,  1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvtsd2si",      2, { R32E, M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_F2 | VEX_0F | VEX_LIG | VEX_W0 | VEX_2OPND | EVEX),    (EVEX_W0),		             4,  1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtsd2si",      2, { R64,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F2 | VEX_0F | VEX_LIG | VEX_W1 | VEX_2OPND | EVEX),    (EVEX_W1 | EVEX_RND),			 4,  1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvtsd2si",      2, { R64,  M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_F2 | VEX_0F | VEX_LIG | VEX_W1 | VEX_2OPND | EVEX),    (EVEX_W1),		             4,  1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtsd2si",      2, { R64E, R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F2 | VEX_0F | VEX_LIG | VEX_W1 | VEX_2OPND | EVEX),    (EVEX_W1 | EVEX_RND),			 4,  1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvtsd2si",      2, { R64E, M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_F2 | VEX_0F | VEX_LIG | VEX_W1 | VEX_2OPND | EVEX),    (EVEX_W1),		             4,  1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VCVTSD2SS xmm1,xmm2,xmm3/m64                  VEX.LIG.F2.0F.WIG 5A /r
//VCVTSD2SS xmm1 {k1}{z}, xmm2,xmm3/m64{er}    EVEX.LIG.F2.0F.W1  5A /r
/* ----------------------------------------------------------------------------------------------- */
{ "vcvtsd2ss",      3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F2 | VEX_0F | VEX_LIG | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_RND),     4,  1, { 0x5a, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vcvtsd2ss",      3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_F2 | VEX_0F | VEX_LIG | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),                4,  1, { 0x5a, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VCVTSS2SD xmm1, xmm2,xmm3 / m32                     VEX.LIG.F3.0F.WIG 5A / r
//VCVTSS2SD xmm1{k1}{z}, xmm2,xmm3 / m32{ sae }    EVEX.LIG.F3.0F.W0  5A / r
/* ----------------------------------------------------------------------------------------------- */
{ "vcvtss2sd",      3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F3 | VEX_0F | VEX_LIG | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_SAE),     4,  1, { 0x5a, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vcvtss2sd",      3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_F3 | VEX_0F | VEX_LIG | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                4,  1, { 0x5a, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VCVTSS2SI r32, xmm1/m32         VEX.LIG.F3.0F.W0 2D / r 1
//VCVTSS2SI r64, xmm1/m32         VEX.LIG.F3.0F.W1 2D / r 1
//VCVTSS2SI r32, xmm1/m32{er}    EVEX.LIG.F3.0F.W0 2D / r
//VCVTSS2SI r64, xmm1/m32{er}    EVEX.LIG.F3.0F.W1 2D / r
/* ----------------------------------------------------------------------------------------------- */
{ "vcvtss2si",      2, { R32,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F3 | VEX_0F | VEX_LIG | VEX_W0 | VEX_2OPND | EVEX),    (EVEX_W0 | EVEX_RND),			 4,  1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvtss2si",      2, { R32,  M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_F3 | VEX_0F | VEX_LIG | VEX_W0 | VEX_2OPND | EVEX),    (EVEX_W0),		             4,  1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtss2si",      2, { R32E, R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F3 | VEX_0F | VEX_LIG | VEX_W0 | VEX_2OPND | EVEX),    (EVEX_W0 | EVEX_RND),			 4,  1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvtss2si",      2, { R32E, M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_F3 | VEX_0F | VEX_LIG | VEX_W0 | VEX_2OPND | EVEX),    (EVEX_W0),		             4,  1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtss2si",      2, { R64,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F3 | VEX_0F | VEX_LIG | VEX_W1 | VEX_2OPND | EVEX),    (EVEX_W1 | EVEX_RND),			 4,  1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvtss2si",      2, { R64,  M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_F3 | VEX_0F | VEX_LIG | VEX_W1 | VEX_2OPND | EVEX),    (EVEX_W1),		             4,  1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtss2si",      2, { R64E, R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F3 | VEX_0F | VEX_LIG | VEX_W1 | VEX_2OPND | EVEX),    (EVEX_W1 | EVEX_RND),			 4,  1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvtss2si",      2, { R64E, M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_F3 | VEX_0F | VEX_LIG | VEX_W1 | VEX_2OPND | EVEX),    (EVEX_W1),		             4,  1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VCVTSI2SS xmm1, xmm2, r/m32     VEX.LIG.F3.0F.W0 2A /r
//VCVTSI2SS xmm1, xmm2, r/m64     VEX.LIG.F3.0F.W1 2A /r
//VCVTSI2SS xmm1, xmm2, r/m32{er} EVEX.LIG.F3.0F.W0 2A /r
//vcvtsi2ss xmm1, xmm2, r/m64{er} EVEX.LIG.F3.0F.W1 2A /r
/* ----------------------------------------------------------------------------------------------- */
{ "vcvtsi2ss",      3, { R_XMM,  R_XMM, R32           }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F3 | VEX_0F | VEX_LIG | VEX_W0 | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_RND),     4,  1, { 0x2a, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vcvtsi2ss",      3, { R_XMM,  R_XMM, R32E          }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F3 | VEX_0F | VEX_LIG | VEX_W0 | VEX_NDS | EVEX),            (EVEX_W0 | EVEX_RND),     4,  1, { 0x2a, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vcvtsi2ss",      3, { R_XMM,  R_XMM, M32           }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_F3 | VEX_0F | VEX_LIG | VEX_W0 | VEX_NDS | EVEX),            (EVEX_W0),                 4,  1, { 0x2a, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vcvtsi2ss",      3, { R_XMM,  R_XMM, R64           }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F3 | VEX_0F | VEX_LIG | VEX_W1 | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_RND),     2,  1, { 0x2a, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vcvtsi2ss",      3, { R_XMM,  R_XMM, R64E          }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F3 | VEX_0F | VEX_LIG | VEX_W1 | VEX_NDS | EVEX),            (EVEX_W1 | EVEX_RND),     2,  1, { 0x2a, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vcvtsi2ss",      3, { R_XMM,  R_XMM, M64           }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_F3 | VEX_0F | VEX_LIG | VEX_W1 | VEX_NDS | EVEX),            (EVEX_W1),                 2,  1, { 0x2a, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VCVTTPD2DQ xmm1, xmm2 / m128    VEX.128.66.0F.WIG E6 / r
//VCVTTPD2DQ xmm1, ymm2 / m256    VEX.256.66.0F.WIG E6 / r
//VCVTTPD2DQ xmm1{k1}{z},xmm2 / m128 / m64bcst         EVEX.128.66.0F.W1 E6 / r
//VCVTTPD2DQ xmm1{k1}{z}, ymm2 / m256 / m64bcst        EVEX.256.66.0F.W1 E6 / r
//VCVTTPD2DQ ymm1{k1}{z},zmm2 / m512 / m64bcst{sae}    EVEX.512.66.0F.W1 E6 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vcvttpd2dq",      2, { R_XMM,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),             (VEX | VEX_0F | VEX_66 | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1),					                       1,  1, { 0xe6, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvttpd2dq",      2, { R_XMM,  M128         }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_0F | VEX_66 | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1),		                             1,  1, { 0xe6, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvttpd2dq",      2, { R_XMM,  R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),             (VEX | VEX_0F | VEX_66 | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1),					                       1,  1, { 0xe6, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvttpd2dq",      2, { R_XMM,  M256         }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_0F | VEX_66 | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1),		                             4,  1, { 0xe6, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvttpd2dq",      2, { R_YMM,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),             (EVEX | VEX_0F | VEX_66 | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_SAE),					           1,  1, { 0xe6, 0x00, 0x00 }, 64, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvttpd2dq",      2, { R_YMM,  M512         }, EVX0, (F_MODRM | F_MODRM_REG),						              (EVEX | VEX_0F | VEX_66 | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),		                 1,  1, { 0xe6, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvttpd2dq",      2, { R_XMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_0F | VEX_66 | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),		                   2,  1, { 0xe6, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvttpd2dq",      2, { R_XMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_0F | VEX_66 | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),		                   4,  1, { 0xe6, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvttpd2dq",      2, { R_YMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						              (EVEX | VEX_0F | VEX_66 | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),	                   8,  1, { 0xe6, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VCVTTPS2DQ xmm1, xmm2 / m128                          VEX.128.F3.0F.WIG 5B / r
//VCVTTPS2DQ ymm1, ymm2 / m256                          VEX.256.F3.0F.WIG 5B / r
//VCVTTPS2DQ xmm1{k}{z},xmm2 / m128 / m32bcst          EVEX.128.F3.0F.W0  5B / r
//VCVTTPS2DQ ymm1{k1}{z},ymm2 / m256 / m32bcst         EVEX.256.F3.0F.W0  5B / r
//VCVTTPS2DQ zmm1{k1}{z},zmm2 / m512 / m32bcst{sae}    EVEX.512.F3.0F.W0  5B / r
/* ----------------------------------------------------------------------------------------------- */
{ "vcvttps2dq",      2, { R_XMM,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F3 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0),					                        1,  1, { 0x5b, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvttps2dq",      2, { R_XMM,  M128         }, AVX0, (F_MODRM | F_MODRM_REG),						             (VEX | VEX_F3 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0),		                              1,  1, { 0x5b, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvttps2dq",      2, { R_XMM,  M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						             (VEX | VEX_F3 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0 | EVEX_BRD),		                  4,  1, { 0x5b, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvttps2dq",      2, { R_YMM,  R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F3 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0),					                        1,  1, { 0x5b, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvttps2dq",      2, { R_YMM,  M256         }, AVX1, (F_MODRM | F_MODRM_REG),						             (VEX | VEX_F3 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0),		                              1,  1, { 0x5b, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvttps2dq",      2, { R_YMM,  M_ANY        }, AVX1, (F_MODRM | F_MODRM_REG),						             (VEX | VEX_F3 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0 | EVEX_BRD),		                  8,  1, { 0x5b, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvttps2dq",      2, { R_ZMM,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_F3 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0 | EVEX_SAE),					            1,  1, { 0x5b, 0x00, 0x00 }, 64, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvttps2dq",      2, { R_ZMM,  M512         }, EVX0, (F_MODRM | F_MODRM_REG),						             (EVEX | VEX_F3 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),	                              1,  1, { 0x5b, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvttps2dq",      2, { R_ZMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						             (EVEX | VEX_F3 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0 | EVEX_BRD),	                   16,  1, { 0x5b, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VCVTTSD2SI r32, xmm1 / m64          VEX.LIG.F2.0F.W0 2C / r 
//VCVTTSD2SI r64, xmm1 / m64          VEX.LIG.F2.0F.W1 2C / r 
//VCVTTSD2SI r32, xmm1 / m64{sae}    EVEX.LIG.F2.0F.W0 2C / r
//VCVTTSD2SI r64, xmm1 / m64{sae}    EVEX.LIG.F2.0F.W1 2C / r
/* ----------------------------------------------------------------------------------------------- */
{ "vcvtsd2si",      2, { R32,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),             (VEX | VEX_F2 | VEX_0F | VEX_LIG | VEX_W0 | VEX_2OPND | EVEX),    (EVEX_W0 | EVEX_SAE),			 4,  1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvtsd2si",      2, { R32,  M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_F2 | VEX_0F | VEX_LIG | VEX_W0 | VEX_2OPND | EVEX),    (EVEX_W0),		             4,  1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtsd2si",      2, { R32E, R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),             (VEX | VEX_F2 | VEX_0F | VEX_LIG | VEX_W0 | VEX_2OPND | EVEX),    (EVEX_W0 | EVEX_SAE),			 4,  1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvtsd2si",      2, { R32E, M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_F2 | VEX_0F | VEX_LIG | VEX_W0 | VEX_2OPND | EVEX),    (EVEX_W0),		             4,  1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtsd2si",      2, { R64,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),             (VEX | VEX_F2 | VEX_0F | VEX_LIG | VEX_W1 | VEX_2OPND | EVEX),    (EVEX_W1 | EVEX_SAE),			 4,  1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvtsd2si",      2, { R64,  M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_F2 | VEX_0F | VEX_LIG | VEX_W1 | VEX_2OPND | EVEX),    (EVEX_W1),		             4,  1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvtsd2si",      2, { R64E, R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),             (VEX | VEX_F2 | VEX_0F | VEX_LIG | VEX_W1 | VEX_2OPND | EVEX),    (EVEX_W1 | EVEX_SAE),			 4,  1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvtsd2si",      2, { R64E, M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_F2 | VEX_0F | VEX_LIG | VEX_W1 | VEX_2OPND | EVEX),    (EVEX_W1),		             4,  1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VCVTTSS2SI r32, xmm1/m32  VEX.LIG.F3.0F.W0 2C /r 1
//VCVTTSS2SI r64, xmm1/m32  VEX.LIG.F3.0F.W1 2C /r 1
//VCVTTSS2SI r32, xmm1/m32{sae}  EVEX.LIG.F3.0F.W0 2C /r
//VCVTTSS2SI r64, xmm1/m32{sae}  EVEX.LIG.F3.0F.W1 2C /r
/* ----------------------------------------------------------------------------------------------- */
{ "vcvttss2si",      2, { R32,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),             (VEX | VEX_F3 | VEX_0F | VEX_LIG | VEX_W0 | VEX_2OPND | EVEX),    (EVEX_W0 | EVEX_RND),			 4,  1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvttss2si",      2, { R32,  M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_F3 | VEX_0F | VEX_LIG | VEX_W0 | VEX_2OPND | EVEX),    (EVEX_W0),		             4,  1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvttss2si",      2, { R32E, R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),             (VEX | VEX_F3 | VEX_0F | VEX_LIG | VEX_W0 | VEX_2OPND | EVEX),    (EVEX_W0 | EVEX_RND),			 4,  1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvttss2si",      2, { R32E, M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_F3 | VEX_0F | VEX_LIG | VEX_W0 | VEX_2OPND | EVEX),    (EVEX_W0),		             4,  1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvttss2si",      2, { R64,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),             (VEX | VEX_F3 | VEX_0F | VEX_LIG | VEX_W1 | VEX_2OPND | EVEX),    (EVEX_W1 | EVEX_RND),			 4,  1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvttss2si",      2, { R64,  M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_F3 | VEX_0F | VEX_LIG | VEX_W1 | VEX_2OPND | EVEX),    (EVEX_W1),		             4,  1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vcvttss2si",      2, { R64E, R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),             (VEX | VEX_F3 | VEX_0F | VEX_LIG | VEX_W1 | VEX_2OPND | EVEX),    (EVEX_W1 | EVEX_RND),			 4,  1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vcvttss2si",      2, { R64E, M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_F3 | VEX_0F | VEX_LIG | VEX_W1 | VEX_2OPND | EVEX),    (EVEX_W1),		             4,  1, { 0x2c, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VDPPD xmm1, xmm2, xmm3 / m128, imm8 VEX.128.66.0F3A.WIG 41 / r ib
/* ----------------------------------------------------------------------------------------------- */
{ "vdppd",         4, { R_XMM,  R_XMM,  R_XMM,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_WIG | VEX_0F3A | VEX_66 | VEX_NDS), (NO_EVEX),             1,  1, { 0x41, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vdppd",         4, { R_XMM,  R_XMM,  M_ANY,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_WIG | VEX_0F3A | VEX_66 | VEX_NDS), (NO_EVEX),             1,  1, { 0x41, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VDPPS xmm1, xmm2, xmm3 / m128, imm8    VEX.128.66.0F3A.WIG 40 / r ib
//VDPPS ymm1, ymm2, ymm3 / m256, imm8    VEX.256.66.0F3A.WIG 40 / r ib
/* ----------------------------------------------------------------------------------------------- */
{ "vdpps",         4, { R_XMM,  R_XMM,  R_XMM,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_WIG | VEX_0F3A | VEX_66 | VEX_NDS), (NO_EVEX),             1,  1, { 0x40, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vdpps",         4, { R_XMM,  R_XMM,  M_ANY,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_WIG | VEX_0F3A | VEX_66 | VEX_NDS), (NO_EVEX),             1,  1, { 0x40, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,P_686 | P_AVX, 0, NULL },
{ "vdpps",         4, { R_YMM,  R_YMM,  R_YMM,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_WIG | VEX_0F3A | VEX_66 | VEX_NDS), (NO_EVEX),             1,  1, { 0x40, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vdpps",         4, { R_YMM,  R_YMM,  M_ANY,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_WIG | VEX_0F3A | VEX_66 | VEX_NDS), (NO_EVEX),             1,  1, { 0x40, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VEXTRACTPS reg / m32, xmm1, imm8    VEX.128.66.0F3A.WIG 17 / r ib
//VEXTRACTPS reg / m32, xmm1, imm8    EVEX.128.66.0F3A.WIG 17 / r ib
/* ----------------------------------------------------------------------------------------------- */
{ "vextractps",         3, { R32,     R_XMM,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_WIG | VEX_66 | VEX_0F3A | VEX_2OPND | EVEX), (EVEX),             4,  1, { 0x17, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), RM_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vextractps",         3, { R32E,    R_XMM,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_WIG | VEX_66 | VEX_0F3A | VEX_2OPND | EVEX), (EVEX),             4,  1, { 0x17, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), RM_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vextractps",         3, { M_ANY,   R_XMM,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_WIG | VEX_66 | VEX_0F3A | VEX_2OPND | EVEX), (EVEX),             4,  1, { 0x17, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_0,P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VINSERTPS xmm1, xmm2,xmm3 / m32, imm8    VEX.128.66.0F3A.WIG 21 / r ib
//VINSERTPS xmm1, xmm2,xmm3 / m32, imm8    EVEX.128.66.0F3A.W0 21 / r ib
/* ----------------------------------------------------------------------------------------------- */
{ "vinsertps",         4, { R_XMM,  R_XMM,  R_XMM,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_WIG | VEX_0F3A | VEX_66 | VEX_NDS | EVEX), (EVEX | EVEX_W0),             4,  1, { 0x21, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vinsertps",         4, { R_XMM,  R_XMM,  M_ANY,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_WIG | VEX_0F3A | VEX_66 | VEX_NDS | EVEX), (EVEX | EVEX_W0),             4,  1, { 0x21, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2,P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPERMILPD xmm1, xmm2, xmm3 / m128    VEX.128.66.0F38.W0 0D / r
//VPERMILPD ymm1, ymm2, ymm3 / m256    VEX.256.66.0F38.W0 0D / r
//VPERMILPD xmm1{k1}{z}, xmm2, xmm3 / m128 / m64bcst    EVEX.128.66.0F38.W1 0D / r
//VPERMILPD ymm1{k1}{z}, ymm2, ymm3 / m256 / m64bcst    EVEX.256.66.0F38.W1 0D / r
//VPERMILPD zmm1{k1}{z}, zmm2, zmm3 / m512 / m64bcst    EVEX.512.66.0F38.W1 0D / r
//VPERMILPD xmm1, xmm2 / m128, imm8    VEX.128.66.0F3A.W0 05 / r ib
//VPERMILPD ymm1, ymm2 / m256, imm8    VEX.256.66.0F3A.W0 05 / r ib
//VPERMILPD xmm1{k1}{z}, xmm2 / m128 / m64bcst, imm8    EVEX.128.66.0F3A.W1 05 / r ib
//VPERMILPD ymm1{k1}{z}, ymm2 / m256 / m64bcst, imm8    EVEX.256.66.0F3A.W1 05 / r ib
//VPERMILPD zmm1{k1}{z}, zmm2 / m512 / m64bcst, imm8    EVEX.512.66.0F3A.W1 05 / r ib
/* ----------------------------------------------------------------------------------------------- */
{ "vpermilpd",         3, { R_XMM,  R_XMM,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),               (VEX | VEX_W0 | VEX_66 | VEX_NDS | VEX_0F38 | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1),					                 2,  1, { 0x0D, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vpermilpd",         3, { R_XMM,  R_XMM,  M128         }, AVX0, (F_MODRM | F_MODRM_REG),						                (VEX | VEX_W0 | VEX_66 | VEX_NDS | VEX_0F38 | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),		           1,  1, { 0x0D, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vpermilpd",         3, { R_XMM,  R_XMM,  M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						                (VEX | VEX_W0 | VEX_66 | VEX_NDS | VEX_0F38 | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),		           2,  1, { 0x0D, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vpermilpd",         3, { R_YMM,  R_YMM,  R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),               (VEX | VEX_W0 | VEX_66 | VEX_NDS | VEX_0F38 | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1),					                 4,  1, { 0x0D, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vpermilpd",         3, { R_YMM,  R_YMM,  M256         }, AVX1, (F_MODRM | F_MODRM_REG),						                (VEX | VEX_W0 | VEX_66 | VEX_NDS | VEX_0F38 | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),		           1,  1, { 0x0D, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vpermilpd",         3, { R_YMM,  R_YMM,  M_ANY        }, AVX1, (F_MODRM | F_MODRM_REG),						                (VEX | VEX_W0 | VEX_66 | VEX_NDS | VEX_0F38 | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),		           4,  1, { 0x0D, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vpermilpd",         3, { R_ZMM,  R_ZMM,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),               (EVEX | VEX_66 | VEX_NDS | VEX_0F38),                   (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),					     8,  1, { 0x0D, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vpermilpd",         3, { R_ZMM,  R_ZMM,  M512         }, EVX0, (F_MODRM | F_MODRM_REG),						                (EVEX | VEX_66 | VEX_NDS | VEX_0F38),                   (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),	 1,  1, { 0x0D, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vpermilpd",         3, { R_ZMM,  R_ZMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						                (EVEX | VEX_66 | VEX_NDS | VEX_0F38),                   (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),	 8,  1, { 0x0D, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vpermilpd",         3, { R_XMM,  R_XMM,  IMM8         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,   (VEX | VEX_W0 | VEX_0F3A | VEX_66 | VEX_2OPND | EVEX),    (EVEX_W1 | EVEX_MASK | EVEX_Z),                        2,  1, { 0x05, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpermilpd",         3, { R_XMM,  M128,   IMM8         }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,                (VEX | VEX_W0 | VEX_0F3A | VEX_66 | VEX_2OPND | EVEX),    (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),             1,  1, { 0x05, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
{ "vpermilpd",         3, { R_XMM,  M_ANY,  IMM8         }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,                (VEX | VEX_W0 | VEX_0F3A | VEX_66 | VEX_2OPND | EVEX),    (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),             2,  1, { 0x05, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
{ "vpermilpd",         3, { R_YMM,  R_YMM,  IMM8         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,   (VEX | VEX_W0 | VEX_0F3A | VEX_66 | VEX_2OPND | EVEX),    (EVEX_W1 | EVEX_MASK | EVEX_Z),                        4,  1, { 0x05, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpermilpd",         3, { R_YMM,  M256,   IMM8         }, AVX1, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,                (VEX | VEX_W0 | VEX_0F3A | VEX_66 | VEX_2OPND | EVEX),    (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),             1,  1, { 0x05, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
{ "vpermilpd",         3, { R_YMM,  M_ANY,  IMM8         }, AVX1, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,                (VEX | VEX_W0 | VEX_0F3A | VEX_66 | VEX_2OPND | EVEX),    (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),             4,  1, { 0x05, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
{ "vpermilpd",         3, { R_ZMM,  R_ZMM,  IMM8         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,   (EVEX | VEX_0F3A | VEX_66 | VEX_2OPND),                   (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),            8,  1, { 0x05, 0x00, 0x00 }, 64, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpermilpd",         3, { R_ZMM,  M512,   IMM8         }, EVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,                (EVEX | VEX_0F3A | VEX_66 | VEX_2OPND),                   (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD), 1,  1, { 0x05, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
{ "vpermilpd",         3, { R_ZMM,  M_ANY,  IMM8         }, EVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,                (EVEX | VEX_0F3A | VEX_66 | VEX_2OPND),                   (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD), 8,  1, { 0x05, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPERMILPS xmm1, xmm2, xmm3 / m128    VEX.128.66.0F38.W0 0C / r
//VPERMILPS xmm1, xmm2 / m128, imm8    VEX.128.66.0F3A.W0 04 / r ib
//VPERMILPS ymm1, ymm2, ymm3 / m256    VEX.256.66.0F38.W0 0C / r
//VPERMILPS ymm1, ymm2 / m256, imm8    VEX.256.66.0F3A.W0 04 / r ib
//VPERMILPS xmm1{k1}{z}, xmm2,xmm3 / m128 / m32bcst    EVEX.128.66.0F38.W0 0C / r
//VPERMILPS ymm1{k1}{z}, ymm2,ymm3 / m256 / m32bcst    EVEX.256.66.0F38.W0 0C / r
//VPERMILPS zmm1{k1}{z}, zmm2,zmm3 / m512 / m32bcst    EVEX.512.66.0F38.W0 0C / r
//VPERMILPS xmm1{k1}{z},xmm2 / m128 / m32bcst, imm8    EVEX.128.66.0F3A.W0 04 / r ib
//VPERMILPS ymm1{k1}{z},ymm2 / m256 / m32bcst, imm8    EVEX.256.66.0F3A.W0 04 / r ib
//VPERMILPS zmm1{k1}{z},zmm2 / m512 / m32bcst, imm8    EVEX.512.66.0F3A.W0 04 / r ib
/* ----------------------------------------------------------------------------------------------- */
{ "vpermilps",         3, { R_XMM,  R_XMM,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),               (VEX | VEX_W0 | VEX_66 | VEX_NDS | VEX_0F38 | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0),					                 4,  1, { 0x0C, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vpermilps",         3, { R_XMM,  R_XMM,  M128         }, AVX0, (F_MODRM | F_MODRM_REG),						                (VEX | VEX_W0 | VEX_66 | VEX_NDS | VEX_0F38 | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0 | EVEX_BRD),		           1,  1, { 0x0C, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vpermilps",         3, { R_XMM,  R_XMM,  M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						                (VEX | VEX_W0 | VEX_66 | VEX_NDS | VEX_0F38 | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0 | EVEX_BRD),		           4,  1, { 0x0C, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vpermilps",         3, { R_YMM,  R_YMM,  M256         }, AVX1, (F_MODRM | F_MODRM_REG),						                (VEX | VEX_W0 | VEX_66 | VEX_NDS | VEX_0F38 | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0 | EVEX_BRD),		           1,  1, { 0x0C, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vpermilps",         3, { R_YMM,  R_YMM,  R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),               (VEX | VEX_W0 | VEX_66 | VEX_NDS | VEX_0F38 | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0),					                 8,  1, { 0x0C, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vpermilps",         3, { R_YMM,  R_YMM,  M_ANY        }, AVX1, (F_MODRM | F_MODRM_REG),						                (VEX | VEX_W0 | VEX_66 | VEX_NDS | VEX_0F38 | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0 | EVEX_BRD),		           8,  1, { 0x0C, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vpermilps",         3, { R_ZMM,  R_ZMM,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),               (EVEX | VEX_66 | VEX_NDS | VEX_0F38),                   (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),					     16, 1, { 0x0C, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vpermilps",         3, { R_ZMM,  R_ZMM,  M512         }, EVX0, (F_MODRM | F_MODRM_REG),						                (EVEX | VEX_66 | VEX_NDS | VEX_0F38),                   (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0 | EVEX_BRD),	 1,  1, { 0x0C, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vpermilps",         3, { R_ZMM,  R_ZMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						                (EVEX | VEX_66 | VEX_NDS | VEX_0F38),                   (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0 | EVEX_BRD),	 16, 1, { 0x0C, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vpermilps",         3, { R_XMM,  R_XMM,  IMM8         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,   (VEX | VEX_W0 | VEX_0F3A | VEX_66 | VEX_2OPND | EVEX),    (EVEX_W0 | EVEX_MASK | EVEX_Z),                        4,  1, { 0x04, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpermilps",         3, { R_XMM,  M128,   IMM8         }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,                (VEX | VEX_W0 | VEX_0F3A | VEX_66 | VEX_2OPND | EVEX),    (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),             1,  1, { 0x04, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
{ "vpermilps",         3, { R_XMM,  M_ANY,  IMM8         }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,                (VEX | VEX_W0 | VEX_0F3A | VEX_66 | VEX_2OPND | EVEX),    (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),             4,  1, { 0x04, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
{ "vpermilps",         3, { R_YMM,  R_YMM,  IMM8         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,   (VEX | VEX_W0 | VEX_0F3A | VEX_66 | VEX_2OPND | EVEX),    (EVEX_W0 | EVEX_MASK | EVEX_Z),                        8,  1, { 0x04, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpermilps",         3, { R_YMM,  M256,   IMM8         }, AVX1, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,                (VEX | VEX_W0 | VEX_0F3A | VEX_66 | VEX_2OPND | EVEX),    (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),             1,  1, { 0x04, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
{ "vpermilps",         3, { R_YMM,  M_ANY,  IMM8         }, AVX1, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,                (VEX | VEX_W0 | VEX_0F3A | VEX_66 | VEX_2OPND | EVEX),    (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),             8,  1, { 0x04, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
{ "vpermilps",         3, { R_ZMM,  R_ZMM,  IMM8         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,   (EVEX | VEX_0F3A | VEX_66 | VEX_2OPND),                   (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),            16, 1, { 0x04, 0x00, 0x00 }, 64, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpermilps",         3, { R_ZMM,  M512,   IMM8         }, EVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,                (EVEX | VEX_0F3A | VEX_66 | VEX_2OPND),                   (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD), 1,  1, { 0x04, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
{ "vpermilps",         3, { R_ZMM,  M_ANY,  IMM8         }, EVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,                (EVEX | VEX_0F3A | VEX_66 | VEX_2OPND),                   (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD), 16, 1, { 0x04, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
 //VPERMPD ymm1, ymm2 / m256, imm8     VEX.256.66.0F3A.W1 01 / r ib
 //VPERMPD ymm1{k1}{z},ymm2 / m256 / m64bcst, imm8     EVEX.256.66.0F3A.W1 01 / r ib
 //VPERMPD zmm1{k1}{z},zmm2 / m512 / m64bcst, imm8     EVEX.512.66.0F3A.W1 01 / r ib
 //VPERMPD ymm1{k1}{z}, ymm2,ymm3 / m256 / m64bcst     EVEX.256.66.0F38.W1 16 / r
 //VPERMPD zmm1{k1}{z}, zmm2,zmm3 / m512 / m64bcst     EVEX.512.66.0F38.W1 16 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpermpd",         3, { R_YMM,  R_YMM,  R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),               (VEX | VEX_W1 | VEX_66 | VEX_NDS | VEX_0F38 | EVEX),      (EVEX_MASK | EVEX_Z | EVEX_W1),					                 1,  1, { 0x16, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vpermpd",         3, { R_YMM,  R_YMM,  M256         }, AVX1, (F_MODRM | F_MODRM_REG),						                 (VEX | VEX_W1 | VEX_66 | VEX_NDS | VEX_0F38 | EVEX),      (EVEX_MASK | EVEX_Z | EVEX_W1),		                       1,  1, { 0x16, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vpermpd",         3, { R_YMM,  R_YMM,  M_ANY        }, AVX1, (F_MODRM | F_MODRM_REG),						                 (VEX | VEX_W1 | VEX_66 | VEX_NDS | VEX_0F38 | EVEX),      (EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),		             4,  1, { 0x16, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vpermpd",         3, { R_ZMM,  R_ZMM,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),               (EVEX | VEX_66 | VEX_NDS | VEX_0F38),                     (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),					     8,  1, { 0x16, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vpermpd",         3, { R_ZMM,  R_ZMM,  M512         }, EVX0, (F_MODRM | F_MODRM_REG),						                 (EVEX | VEX_66 | VEX_NDS | VEX_0F38),                     (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),	             1,  1, { 0x16, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vpermpd",         3, { R_ZMM,  R_ZMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						                 (EVEX | VEX_66 | VEX_NDS | VEX_0F38),                     (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),	   8,  1, { 0x16, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vpermpd",         3, { R_YMM,  R_YMM,  IMM8         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,   (VEX | VEX_W1 | VEX_0F3A | VEX_66 | VEX_2OPND | EVEX),    (EVEX_W1 | EVEX_MASK | EVEX_Z),                           4,  1, { 0x01, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpermpd",         3, { R_YMM,  M256,   IMM8         }, AVX1, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,                (VEX | VEX_W1 | VEX_0F3A | VEX_66 | VEX_2OPND | EVEX),    (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),                1,  1, { 0x01, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
{ "vpermpd",         3, { R_YMM,  M_ANY,  IMM8         }, AVX1, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,                (VEX | VEX_W1 | VEX_0F3A | VEX_66 | VEX_2OPND | EVEX),    (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),                4,  1, { 0x01, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
{ "vpermpd",         3, { R_ZMM,  R_ZMM,  IMM8         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,   (EVEX | VEX_0F3A | VEX_66 | VEX_2OPND),                   (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               8,  1, { 0x01, 0x00, 0x00 }, 64, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpermpd",         3, { R_ZMM,  M512,   IMM8         }, EVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,                (EVEX | VEX_0F3A | VEX_66 | VEX_2OPND),                   (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),    1,  1, { 0x01, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
{ "vpermpd",         3, { R_ZMM,  M_ANY,  IMM8         }, EVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,                (EVEX | VEX_0F3A | VEX_66 | VEX_2OPND),                   (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),    8,  1, { 0x01, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPERMPS ymm1, ymm2,ymm3 / m256                      VEX.256.66.0F38.W0 16 / r
//VPERMPS ymm1{k1}{z}, ymm2,ymm3 / m256 / m32bcst    EVEX.256.66.0F38.W0 16 / r
//VPERMPS zmm1{k1}{z}, zmm2,zmm3 / m512 / m32bcst    EVEX.512.66.0F38.W0 16 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpermps",         3, { R_YMM,  R_YMM,  R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),               (VEX | VEX_W0 | VEX_66 | VEX_NDS | VEX_0F38 | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0),					                 8,  1, { 0x16, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vpermps",         3, { R_YMM,  R_YMM,  M256         }, AVX1, (F_MODRM | F_MODRM_REG),						                (VEX | VEX_W0 | VEX_66 | VEX_NDS | VEX_0F38 | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0),		                       1,  1, { 0x16, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vpermps",         3, { R_YMM,  R_YMM,  M_ANY        }, AVX1, (F_MODRM | F_MODRM_REG),						                (VEX | VEX_W0 | VEX_66 | VEX_NDS | VEX_0F38 | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0 | EVEX_BRD),		           8,  1, { 0x16, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vpermps",         3, { R_ZMM,  R_ZMM,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),               (EVEX | VEX_66 | VEX_NDS | VEX_0F38),                   (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),					     16, 1, { 0x16, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vpermps",         3, { R_ZMM,  R_ZMM,  M512         }, EVX0, (F_MODRM | F_MODRM_REG),						                (EVEX | VEX_66 | VEX_NDS | VEX_0F38),                   (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),	             1,  1, { 0x16, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vpermps",         3, { R_ZMM,  R_ZMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						                (EVEX | VEX_66 | VEX_NDS | VEX_0F38),                   (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0 | EVEX_BRD),	 16, 1, { 0x16, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPERMQ ymm1, ymm2 / m256, imm8    VEX.256.66.0F3A.W1 00 / r ib
//VPERMQ ymm1{k1}{z},ymm2 / m256 / m64bcst, imm8    EVEX.256.66.0F3A.W1 00 / r ib
//VPERMQ zmm1{k1}{z},zmm2 / m512 / m64bcst, imm8    EVEX.512.66.0F3A.W1 00 / r ib
//VPERMQ ymm1{k1}{z}, ymm2,ymm3 / m256 / m64bcst    EVEX.256.66.0F38.W1 36 / r
//VPERMQ zmm1{k1}{z}, zmm2,zmm3 / m512 / m64bcst    EVEX.512.66.0F38.W1 36 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpermq",         3, { R_YMM,  R_YMM,  R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),               (VEX | VEX_W1 | VEX_66 | VEX_NDS | VEX_0F38 | EVEX),      (EVEX_MASK | EVEX_Z | EVEX_W1),					                 4,  1, { 0x36, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vpermq",         3, { R_YMM,  R_YMM,  M256         }, AVX1, (F_MODRM | F_MODRM_REG),						                 (VEX | VEX_W1 | VEX_66 | VEX_NDS | VEX_0F38 | EVEX),      (EVEX_MASK | EVEX_Z | EVEX_W1),		                       1,  1, { 0x36, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vpermq",         3, { R_YMM,  R_YMM,  M_ANY        }, AVX1, (F_MODRM | F_MODRM_REG),						                 (VEX | VEX_W1 | VEX_66 | VEX_NDS | VEX_0F38 | EVEX),      (EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),		             4,  1, { 0x36, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vpermq",         3, { R_ZMM,  R_ZMM,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),               (EVEX | VEX_66 | VEX_NDS | VEX_0F38),                     (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),					     8,  1, { 0x36, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vpermq",         3, { R_ZMM,  R_ZMM,  M512         }, EVX0, (F_MODRM | F_MODRM_REG),						                 (EVEX | VEX_66 | VEX_NDS | VEX_0F38),                     (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),	             1,  1, { 0x36, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vpermq",         3, { R_ZMM,  R_ZMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						                 (EVEX | VEX_66 | VEX_NDS | VEX_0F38),                     (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1 | EVEX_BRD),	   8,  1, { 0x36, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_2,    P_686 | P_AVX, 0, NULL },
{ "vpermq",         3, { R_YMM,  R_YMM,  IMM8         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,   (VEX | VEX_W1 | VEX_0F3A | VEX_66 | VEX_2OPND | EVEX),    (EVEX_W1 | EVEX_MASK | EVEX_Z),                           4,  1, { 0x00, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpermq",         3, { R_YMM,  M256,   IMM8         }, AVX1, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,                (VEX | VEX_W1 | VEX_0F3A | VEX_66 | VEX_2OPND | EVEX),    (EVEX_W1 | EVEX_MASK | EVEX_Z),                           1,  1, { 0x00, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
{ "vpermq",         3, { R_YMM,  M_ANY,  IMM8         }, AVX1, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,                (VEX | VEX_W1 | VEX_0F3A | VEX_66 | VEX_2OPND | EVEX),    (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),                4,  1, { 0x00, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
{ "vpermq",         3, { R_ZMM,  R_ZMM,  IMM8         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,   (EVEX | VEX_0F3A | VEX_66 | VEX_2OPND),                   (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               8,  1, { 0x00, 0x00, 0x00 }, 64, 1, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpermq",         3, { R_ZMM,  M512,   IMM8         }, EVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,                (EVEX | VEX_0F3A | VEX_66 | VEX_2OPND),                   (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0x00, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
{ "vpermq",         3, { R_ZMM,  M_ANY,  IMM8         }, EVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,                (EVEX | VEX_0F3A | VEX_66 | VEX_2OPND),                   (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),    8,  1, { 0x00, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1,P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VMOVHPD xmm2, xmm1, m64    VEX.128.66.0F.WIG 16 / r
//VMOVHPD xmm2, xmm1, m64    EVEX.128.66.0F.W1 16 / r
//VMOVHPD m64, xmm1          VEX.128.66.0F.WIG 17 / r
//VMOVHPD m64, xmm1          EVEX.128.66.0F.W1 17 / r
{ "vmovhpd",      3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_66 | VEX_0F | VEX_WIG | VEX_NDS | EVEX),            (EVEX_W1),                4,  1, { 0x16, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vmovhpd",      2, { M_ANY,   R_XMM               }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_66 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),	         (EVEX_W1),                4,  1, { 0x17, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VMOVHPS xmm2, xmm1, m64    VEX.128.0F.WIG 16 / r
//VMOVHPS xmm2, xmm1, m64    EVEX.128.0F.W0 16 / r
//VMOVHPS m64, xmm1          VEX.128.0F.WIG 17 / r
//VMOVHPS m64, xmm1          EVEX.128.0F.W0 17 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vmovhps",      3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_0F | VEX_WIG | VEX_NDS | EVEX),                      (EVEX_W0),                4,  1, { 0x16, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vmovhps",      2, { M_ANY,   R_XMM               }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),	                  (EVEX_W0),                4,  1, { 0x17, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VMOVLPD xmm2, xmm1, m64    VEX.128.66.0F.WIG 12 / r
//VMOVLPD xmm2, xmm1, m64    EVEX.128.66.0F.W1 12 / r
//VMOVLPD m64, xmm1    VEX.128.66.0F.WIG 13 / r
//VMOVLPD m64, xmm1    EVEX.128.66.0F.W1 13 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vmovlpd",      3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_66 | VEX_0F | VEX_WIG | VEX_NDS | EVEX),            (EVEX_W1),                2,  1, { 0x12, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vmovlpd",      2, { M_ANY,   R_XMM               }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_66 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),	         (EVEX_W1),                2,  1, { 0x13, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VMOVLPS xmm2, xmm1, m64    VEX.128.0F.WIG 12 / r
//VMOVLPS xmm2, xmm1, m64    EVEX.128.0F.W0 12 / r
//VMOVLPS m64, xmm1    VEX.128.0F.WIG 13 / r
//VMOVLPS m64, xmm1    EVEX.128.0F.W0 13 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vmovlps",      3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_0F | VEX_WIG | VEX_NDS | EVEX),                      (EVEX_W0),                2,  1, { 0x12, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vmovlps",      2, { M_ANY,   R_XMM               }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),	                  (EVEX_W0),                2,  1, { 0x13, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VMOVHLPS xmm1, xmm2, xmm3    VEX.128.0F.WIG 12 / r
//VMOVHLPS xmm1, xmm2, xmm3    EVEX.128.0F.W0 12 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vmovhlps",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0),                        1,  1, { 0x12, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VMOVLHPS xmm1, xmm2, xmm3    VEX.128.0F.WIG 16 / r
//VMOVLHPS xmm1, xmm2, xmm3    EVEX.128.0F.W0 16 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vmovlhps",  3, { R_XMM,  R_XMM, R_XMM             }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (EVEX_W0),                        1,  1, { 0x16, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0, 0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VMASKMOVDQU xmm1, xmm2    VEX.128.66.0F.WIG F7 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vmaskmovdqu",      2, { R_XMM,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),                   (VEX | VEX_66 | VEX_0F | VEX_WIG | VEX_2OPND),    (NO_EVEX),					           1,  1, { 0xf7, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VMOVDQA xmm1, xmm2 / m128    VEX.128.66.0F.WIG 6F / r
//VMOVDQA xmm2 / m128, xmm1    VEX.128.66.0F.WIG 7F / r
//VMOVDQA ymm1, ymm2 / m256    VEX.256.66.0F.WIG 6F / r
//VMOVDQA ymm2 / m256, ymm1    VEX.256.66.0F.WIG 7F / r
/* ----------------------------------------------------------------------------------------------- */
{ "vmovdqa",      2, { R_XMM,  R_XMME       }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_66 | VEX_0F | VEX_WIG | VEX_2OPND),    (NO_EVEX),          1,  1, { 0x7f, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), RM_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vmovdqa",      2, { R_XMM,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_66 | VEX_0F | VEX_WIG | VEX_2OPND),    (NO_EVEX),          1,  1, { 0x6f, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vmovdqa",      2, { R_XMM,  M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_66 | VEX_0F | VEX_WIG | VEX_2OPND),    (NO_EVEX),          1,  1, { 0x6f, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vmovdqa",      2, { M_ANY,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_66 | VEX_0F | VEX_WIG | VEX_2OPND),    (NO_EVEX),          1,  1, { 0x7f, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vmovdqa",      2, { R_YMM,  R_YMME       }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_66 | VEX_0F | VEX_WIG | VEX_2OPND),    (NO_EVEX),          1,  1, { 0x7f, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), RM_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vmovdqa",      2, { R_YMM,  R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_66 | VEX_0F | VEX_WIG | VEX_2OPND),    (NO_EVEX),          1,  1, { 0x6f, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vmovdqa",      2, { R_YMM,  M_ANY        }, AVX1, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_66 | VEX_0F | VEX_WIG | VEX_2OPND),    (NO_EVEX),          1,  1, { 0x6f, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vmovdqa",      2, { M_ANY,  R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_66 | VEX_0F | VEX_WIG | VEX_2OPND),    (NO_EVEX),          1,  1, { 0x7f, 0x00, 0x00 }, 32, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },

/* ----------------------------------------------------------------------------------------------- */
//VMOVDQA32 xmm1{k1}{z},xmm2 / m128    EVEX.128.66.0F.W0 6F / r
//VMOVDQA32 ymm1{k1}{z},ymm2 / m256    EVEX.256.66.0F.W0 6F / r
//VMOVDQA32 zmm1{k1}{z},zmm2 / m512    EVEX.512.66.0F.W0 6F / r
//VMOVDQA32 xmm2 / m128{k1}{z},xmm1    EVEX.128.66.0F.W0 7F / r
//VMOVDQA32 ymm2 / m256{k1}{z},ymm1    EVEX.256.66.0F.W0 7F / r
//VMOVDQA32 zmm2 / m512{k1}{z},zmm1    EVEX.512.66.0F.W0 7F / r
/* ----------------------------------------------------------------------------------------------- */
{ "vmovdqa32",      2, { R_XMM,  R_XMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),         1,  1, { 0x6f, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmovdqa32",      2, { R_XMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						             (EVEX | VEX_66 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),         1,  1, { 0x6f, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vmovdqa32",      2, { M_ANY,  R_XMM        }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),         1,  1, { 0x7f, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vmovdqa32",      2, { R_YMM,  R_YMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),         1,  1, { 0x6f, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmovdqa32",      2, { R_YMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						             (EVEX | VEX_66 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),         1,  1, { 0x6f, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vmovdqa32",      2, { M_ANY,  R_YMM        }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),         1,  1, { 0x7f, 0x00, 0x00 }, 32, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vmovdqa32",      2, { R_ZMM,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),         1,  1, { 0x6f, 0x00, 0x00 }, 64, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmovdqa32",      2, { R_ZMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						             (EVEX | VEX_66 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),	       1,  1, { 0x6f, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vmovdqa32",      2, { M_ANY,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),         1,  1, { 0x7f, 0x00, 0x00 }, 64, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VMOVDQA64 xmm1{k1}{z},xmm2 / m128    EVEX.128.66.0F.W1 6F / r
//VMOVDQA64 ymm1{k1}{z},ymm2 / m256    EVEX.256.66.0F.W1 6F / r
//VMOVDQA64 zmm1{k1}{z}, zmm2 / m512    EVEX.512.66.0F.W1 6F / r
//VMOVDQA64 xmm2 / m128{k1}{z},xmm1    EVEX.128.66.0F.W1 7F / r
//VMOVDQA64 ymm2 / m256{k1}{z},ymm1    EVEX.256.66.0F.W1 7F /r
//VMOVDQA64 zmm2 / m512{k1}{z},zmm1    EVEX.512.66.0F.W1 7F /r
/* ----------------------------------------------------------------------------------------------- */
{ "vmovdqa64",      2, { R_XMM,  R_XMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),         1,  1, { 0x6f, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmovdqa64",      2, { R_XMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						              (EVEX | VEX_66 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),         1,  1, { 0x6f, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vmovdqa64",      2, { M_ANY,  R_XMM        }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),         1,  1, { 0x7f, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vmovdqa64",      2, { R_YMM,  R_YMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),         1,  1, { 0x6f, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmovdqa64",      2, { R_YMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						              (EVEX | VEX_66 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),         1,  1, { 0x6f, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vmovdqa64",      2, { M_ANY,  R_YMM        }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),         1,  1, { 0x7f, 0x00, 0x00 }, 32, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vmovdqa64",      2, { R_ZMM,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),         1,  1, { 0x6f, 0x00, 0x00 }, 64, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmovdqa64",      2, { R_ZMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						              (EVEX | VEX_66 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),	        1,  1, { 0x6f, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vmovdqa64",      2, { M_ANY,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),         1,  1, { 0x7f, 0x00, 0x00 }, 64, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VMOVDQU xmm1, xmm2 / m128    VEX.128.F3.0F.WIG 6F / r
//VMOVDQU xmm2 / m128, xmm1    VEX.128.F3.0F.WIG 7F / r
//VMOVDQU ymm1, ymm2 / m256    VEX.256.F3.0F.WIG 6F / r
//VMOVDQU ymm2 / m256, ymm1    VEX.256.F3.0F.WIG 7F / r
/* ----------------------------------------------------------------------------------------------- */
{ "vmovdqu",      2, { R_XMM,  R_XMME       }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F3 | VEX_0F | VEX_WIG | VEX_2OPND),    (NO_EVEX),          1,  1, { 0x7f, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), RM_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vmovdqu",      2, { R_XMM,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F3 | VEX_0F | VEX_WIG | VEX_2OPND),    (NO_EVEX),          1,  1, { 0x6f, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vmovdqu",      2, { R_XMM,  M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_F3 | VEX_0F | VEX_WIG | VEX_2OPND),    (NO_EVEX),          1,  1, { 0x6f, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vmovdqu",      2, { M_ANY,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_F3 | VEX_0F | VEX_WIG | VEX_2OPND),    (NO_EVEX),          1,  1, { 0x7f, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vmovdqu",      2, { R_YMM,  R_YMME       }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F3 | VEX_0F | VEX_WIG | VEX_2OPND),    (NO_EVEX),          1,  1, { 0x7f, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), RM_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vmovdqu",      2, { R_YMM,  R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F3 | VEX_0F | VEX_WIG | VEX_2OPND),    (NO_EVEX),          1,  1, { 0x6f, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vmovdqu",      2, { R_YMM,  M_ANY        }, AVX1, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_F3 | VEX_0F | VEX_WIG | VEX_2OPND),    (NO_EVEX),          1,  1, { 0x6f, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,         P_686 | P_AVX, 0, NULL },
{ "vmovdqu",      2, { M_ANY,  R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_F3 | VEX_0F | VEX_WIG | VEX_2OPND),    (NO_EVEX),          1,  1, { 0x7f, 0x00, 0x00 }, 32, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VMOVDQU8 xmm1{k1}{z}, xmm2 / m128    EVEX.128.F2.0F.W0 6F / r
//VMOVDQU8 ymm1{k1}{z}, ymm2 / m256    EVEX.256.F2.0F.W0 6F / r
//VMOVDQU8 zmm1{k1}{z}, zmm2 / m512    EVEX.512.F2.0F.W0 6F / r
//VMOVDQU8 xmm2 / m128{k1}{z}, xmm1    EVEX.128.F2.0F.W0 7F / r
//VMOVDQU8 ymm2 / m256{k1}{z}, ymm1    EVEX.256.F2.0F.W0 7F / r
//VMOVDQU8 zmm2 / m512{k1}{z}, zmm1    EVEX.512.F2.0F.W0 7F / r
/* ----------------------------------------------------------------------------------------------- */
{ "vmovdqu8",      2, { R_XMM,  R_XMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_F2 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),         1,  1, { 0x6f, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmovdqu8",      2, { R_XMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						             (EVEX | VEX_F2 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),         1,  1, { 0x6f, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vmovdqu8",      2, { M_ANY,  R_XMM        }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_F2 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),         1,  1, { 0x7f, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vmovdqu8",      2, { R_YMM,  R_YMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_F2 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),         1,  1, { 0x6f, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmovdqu8",      2, { R_YMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						             (EVEX | VEX_F2 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),         1,  1, { 0x6f, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vmovdqu8",      2, { M_ANY,  R_YMM        }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_F2 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),         1,  1, { 0x7f, 0x00, 0x00 }, 32, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vmovdqu8",      2, { R_ZMM,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_F2 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),         1,  1, { 0x6f, 0x00, 0x00 }, 64, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmovdqu8",      2, { R_ZMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						             (EVEX | VEX_F2 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),	        1,  1, { 0x6f, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vmovdqu8",      2, { M_ANY,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_F2 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),         1,  1, { 0x7f, 0x00, 0x00 }, 64, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VMOVDQU16 xmm1{k1}{z}, xmm2 / m128    EVEX.128.F2.0F.W1 6F / r
//VMOVDQU16 ymm1{k1}{z}, ymm2 / m256    EVEX.256.F2.0F.W1 6F / r
//VMOVDQU16 zmm1{k1}{z}, zmm2 / m512    EVEX.512.F2.0F.W1 6F / r
//VMOVDQU16 xmm2 / m128{k1}{z}, xmm1    EVEX.128.F2.0F.W1 7F / r
//VMOVDQU16 ymm2 / m256{k1}{z}, ymm1    EVEX.256.F2.0F.W1 7F / r
//VMOVDQU16 zmm2 / m512{k1}{z}, zmm1    EVEX.512.F2.0F.W1 7F / r
/* ----------------------------------------------------------------------------------------------- */
{ "vmovdqu16",      2, { R_XMM,  R_XMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_F2 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),         1,  1, { 0x6f, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmovdqu16",      2, { R_XMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						              (EVEX | VEX_F2 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),         1,  1, { 0x6f, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vmovdqu16",      2, { M_ANY,  R_XMM        }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_F2 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),         1,  1, { 0x7f, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vmovdqu16",      2, { R_YMM,  R_YMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_F2 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),         1,  1, { 0x6f, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmovdqu16",      2, { R_YMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						              (EVEX | VEX_F2 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),         1,  1, { 0x6f, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vmovdqu16",      2, { M_ANY,  R_YMM        }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_F2 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),         1,  1, { 0x7f, 0x00, 0x00 }, 32, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vmovdqu16",      2, { R_ZMM,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_F2 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),         1,  1, { 0x6f, 0x00, 0x00 }, 64, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmovdqu16",      2, { R_ZMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						              (EVEX | VEX_F2 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),	        1,  1, { 0x6f, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vmovdqu16",      2, { M_ANY,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_F2 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),         1,  1, { 0x7f, 0x00, 0x00 }, 64, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VMOVDQU32 xmm1{k1}{z},xmm2 / mm128    EVEX.128.F3.0F.W0 6F / r
//VMOVDQU32 ymm1{k1}{z}, ymm2 / m256    EVEX.256.F3.0F.W0 6F / r
//VMOVDQU32 zmm1{k1}{z}, zmm2 / m512    EVEX.512.F3.0F.W0 6F / r
//VMOVDQU32 xmm2 / m128{k1}{z}, xmm1    EVEX.128.F3.0F.W0 7F / r
//VMOVDQU32 ymm2 / m256{k1}{z}, ymm1    EVEX.256.F3.0F.W0 7F / r
//VMOVDQU32 zmm2 / m512{k1}{z}, zmm1    EVEX.512.F3.0F.W0 7F / r
/* ----------------------------------------------------------------------------------------------- */
{ "vmovdqu32",      2, { R_XMM,  R_XMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_F3 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),         1,  1, { 0x6f, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmovdqu32",      2, { R_XMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						              (EVEX | VEX_F3 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),         1,  1, { 0x6f, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vmovdqu32",      2, { M_ANY,  R_XMM        }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_F3 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),         1,  1, { 0x7f, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vmovdqu32",      2, { R_YMM,  R_YMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_F3 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),         1,  1, { 0x6f, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmovdqu32",      2, { R_YMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						              (EVEX | VEX_F3 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),         1,  1, { 0x6f, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vmovdqu32",      2, { M_ANY,  R_YMM        }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_F3 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),         1,  1, { 0x7f, 0x00, 0x00 }, 32, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vmovdqu32",      2, { R_ZMM,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_F3 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),         1,  1, { 0x6f, 0x00, 0x00 }, 64, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmovdqu32",      2, { R_ZMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						              (EVEX | VEX_F3 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),	        1,  1, { 0x6f, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vmovdqu32",      2, { M_ANY,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_F3 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),         1,  1, { 0x7f, 0x00, 0x00 }, 64, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VMOVDQU64 xmm1{k1}{z}, xmm2 / m128    EVEX.128.F3.0F.W1 6F / r
//VMOVDQU64 ymm1{k1}{z}, ymm2 / m256    EVEX.256.F3.0F.W1 6F / r
//VMOVDQU64 zmm1{k1}{z}, zmm2 / m512    EVEX.512.F3.0F.W1 6F / r
//VMOVDQU64 xmm2 / m128{k1}{z}, xmm1    EVEX.256.F3.0F.W1 7F / r
//VMOVDQU64 ymm2 / m256{k1}{z}, ymm1    EVEX.256.F3.0F.W1 7F / r
//VMOVDQU64 zmm2 / m512{k1}{z}, zmm1    EVEX.512.F3.0F.W1 7F / r
/* ----------------------------------------------------------------------------------------------- */
{ "vmovdqu64",      2, { R_XMM,  R_XMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_F3 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),         1,  1, { 0x6f, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmovdqu64",      2, { R_XMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						              (EVEX | VEX_F3 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),         1,  1, { 0x6f, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vmovdqu64",      2, { M_ANY,  R_XMM        }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_F3 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),         1,  1, { 0x7f, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vmovdqu64",      2, { R_YMM,  R_YMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_F3 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),         1,  1, { 0x6f, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmovdqu64",      2, { R_YMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						              (EVEX | VEX_F3 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),         1,  1, { 0x6f, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vmovdqu64",      2, { M_ANY,  R_YMM        }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_F3 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),         1,  1, { 0x7f, 0x00, 0x00 }, 32, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vmovdqu64",      2, { R_ZMM,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_F3 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),         1,  1, { 0x6f, 0x00, 0x00 }, 64, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmovdqu64",      2, { R_ZMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						              (EVEX | VEX_F3 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),	        1,  1, { 0x6f, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vmovdqu64",      2, { M_ANY,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_F3 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),         1,  1, { 0x7f, 0x00, 0x00 }, 64, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VMOVUPD xmm1, xmm2 / m128             VEX.128.66.0F.WIG 10 / r
//VMOVUPD xmm2 / m128, xmm1             VEX.128.66.0F.WIG 11 / r
//VMOVUPD ymm1, ymm2 / m256             VEX.256.66.0F.WIG 10 / r
//VMOVUPD ymm2 / m256, ymm1             VEX.256.66.0F.WIG 11 / r
//VMOVUPD xmm1{k1}{z}, xmm2 / m128    EVEX.128.66.0F.W1 10 / r
//VMOVUPD xmm2 / m128{k1}{z}, xmm1    EVEX.128.66.0F.W1 11 / r
//VMOVUPD ymm1{k1}{z}, ymm2 / m256    EVEX.256.66.0F.W1 10 / r
//VMOVUPD ymm2 / m256{k1}{z}, ymm1    EVEX.256.66.0F.W1 11 / r
//VMOVUPD zmm1{k1}{z}, zmm2 / m512    EVEX.512.66.0F.W1 10 / r
//VMOVUPD zmm2 / m512{k1}{z}, zmm1    EVEX.512.66.0F.W1 11 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vmovupd",      2, { R_XMM,  R_XMME       }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_66 | VEX_0F | VEX_WIG | VEX_2OPND),    (NO_EVEX),                                      1,  1, { 0x11, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmovupd",      2, { R_XMM,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_66 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1),          1,  1, { 0x10, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmovupd",      2, { R_XMM,  M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_66 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1),          1,  1, { 0x10, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vmovupd",      2, { M_ANY,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_66 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1),          1,  1, { 0x11, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vmovupd",      2, { R_YMM,  R_YMME       }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_66 | VEX_0F | VEX_WIG | VEX_2OPND),    (NO_EVEX),                                      1,  1, { 0x11, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmovupd",      2, { R_YMM,  R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_66 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1),          1,  1, { 0x10, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmovupd",      2, { R_YMM,  M_ANY        }, AVX1, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_66 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1),          1,  1, { 0x10, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vmovupd",      2, { M_ANY,  R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_66 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W1),          1,  1, { 0x11, 0x00, 0x00 }, 32, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vmovupd",      2, { R_ZMM,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),         1,  1, { 0x10, 0x00, 0x00 }, 64, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmovupd",      2, { R_ZMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						              (EVEX | VEX_66 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),	        1,  1, { 0x10, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vmovupd",      2, { M_ANY,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W1),         1,  1, { 0x11, 0x00, 0x00 }, 64, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VMOVUPS xmm1, xmm2 / m128    VEX.128.0F.WIG 10 / r
//VMOVUPS xmm2 / m128, xmm1    VEX.128.0F.WIG 11 / r
//VMOVUPS ymm1, ymm2 / m256    VEX.256.0F.WIG 10 / r
//VMOVUPS ymm2 / m256, ymm1    VEX.256.0F.WIG 11 / r
//VMOVUPS xmm1{k1}{z}, xmm2 / m128    EVEX.128.0F.W0 10 / r
//VMOVUPS ymm1{k1}{z}, ymm2 / m256    EVEX.256.0F.W0 10 / r
//VMOVUPS zmm1{k1}{z}, zmm2 / m512    EVEX.512.0F.W0 10 / r
//VMOVUPS xmm2 / m128{k1}{z}, xmm1    EVEX.128.0F.W0 11 / r
//VMOVUPS ymm2 / m256{k1}{z}, ymm1    EVEX.256.0F.W0 11 / r
//VMOVUPS zmm2 / m512{k1}{z}, zmm1    EVEX.512.0F.W0 11 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vmovups",      2, { R_XMM,  R_XMME       }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_0F | VEX_WIG | VEX_2OPND),    (NO_EVEX),                                      1,  1, { 0x11, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmovups",      2, { R_XMM,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0),          1,  1, { 0x10, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmovups",      2, { R_XMM,  M_ANY        }, AVX0, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0),          1,  1, { 0x10, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vmovups",      2, { M_ANY,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0),          1,  1, { 0x11, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vmovups",      2, { R_YMM,  R_YMME       }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_0F | VEX_WIG | VEX_2OPND),    (NO_EVEX),                                      1,  1, { 0x11, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmovups",      2, { R_YMM,  R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0),          1,  1, { 0x10, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmovups",      2, { R_YMM,  M_ANY        }, AVX1, (F_MODRM | F_MODRM_REG),						              (VEX | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0),          1,  1, { 0x10, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vmovups",      2, { M_ANY,  R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_MASK | EVEX_Z | EVEX_W0),          1,  1, { 0x11, 0x00, 0x00 }, 32, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vmovups",      2, { R_ZMM,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),         1,  1, { 0x10, 0x00, 0x00 }, 64, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,        P_686 | P_AVX, 0, NULL },
{ "vmovups",      2, { R_ZMM,  M_ANY        }, EVX0, (F_MODRM | F_MODRM_REG),						              (EVEX | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),	       1,  1, { 0x10, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vmovups",      2, { M_ANY,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_MASK | EVEX_Z | EVEX_W0),         1,  1, { 0x11, 0x00, 0x00 }, 64, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VMOVMSKPD reg, xmm2    VEX.128.66.0F.WIG 50 / r
//VMOVMSKPD reg, ymm2    VEX.256.66.0F.WIG 50 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vmovmskpd",    2, { R32,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),             (VEX | VEX_66 | VEX_0F | VEX_LIG | VEX_WIG | VEX_2OPND),    (NO_EVEX),			 1,  1, { 0x50, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vmovmskpd",    2, { R32E, R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),             (VEX | VEX_66 | VEX_0F | VEX_LIG | VEX_WIG | VEX_2OPND),    (NO_EVEX),			 1,  1, { 0x50, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vmovmskpd",    2, { R64,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),             (VEX | VEX_66 | VEX_0F | VEX_LIG | VEX_WIG | VEX_2OPND),    (NO_EVEX),			 1,  1, { 0x50, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vmovmskpd",    2, { R64E, R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),             (VEX | VEX_66 | VEX_0F | VEX_LIG | VEX_WIG | VEX_2OPND),    (NO_EVEX),			 1,  1, { 0x50, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vmovmskpd",    2, { R32,  R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),             (VEX | VEX_66 | VEX_0F | VEX_LIG | VEX_WIG | VEX_2OPND),    (NO_EVEX),			 1,  1, { 0x50, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vmovmskpd",    2, { R32E, R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),             (VEX | VEX_66 | VEX_0F | VEX_LIG | VEX_WIG | VEX_2OPND),    (NO_EVEX),			 1,  1, { 0x50, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vmovmskpd",    2, { R64,  R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),             (VEX | VEX_66 | VEX_0F | VEX_LIG | VEX_WIG | VEX_2OPND),    (NO_EVEX),			 1,  1, { 0x50, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vmovmskpd",    2, { R64E, R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),             (VEX | VEX_66 | VEX_0F | VEX_LIG | VEX_WIG | VEX_2OPND),    (NO_EVEX),			 1,  1, { 0x50, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VMOVMSKPS reg, xmm2    VEX.128.0F.WIG 50 / r
//VMOVMSKPS reg, ymm2    VEX.256.0F.WIG 50 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vmovmskps",    2, { R32,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),             (VEX | VEX_0F | VEX_LIG | VEX_WIG | VEX_2OPND),    (NO_EVEX),			 1,  1, { 0x50, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vmovmskps",    2, { R32E, R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),             (VEX | VEX_0F | VEX_LIG | VEX_WIG | VEX_2OPND),    (NO_EVEX),			 1,  1, { 0x50, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vmovmskps",    2, { R64,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),             (VEX | VEX_0F | VEX_LIG | VEX_WIG | VEX_2OPND),    (NO_EVEX),			 1,  1, { 0x50, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vmovmskps",    2, { R64E, R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),             (VEX | VEX_0F | VEX_LIG | VEX_WIG | VEX_2OPND),    (NO_EVEX),			 1,  1, { 0x50, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vmovmskps",    2, { R32,  R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),             (VEX | VEX_0F | VEX_LIG | VEX_WIG | VEX_2OPND),    (NO_EVEX),			 1,  1, { 0x50, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vmovmskps",    2, { R32E, R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),             (VEX | VEX_0F | VEX_LIG | VEX_WIG | VEX_2OPND),    (NO_EVEX),			 1,  1, { 0x50, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vmovmskps",    2, { R64,  R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),             (VEX | VEX_0F | VEX_LIG | VEX_WIG | VEX_2OPND),    (NO_EVEX),			 1,  1, { 0x50, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vmovmskps",    2, { R64E, R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),             (VEX | VEX_0F | VEX_LIG | VEX_WIG | VEX_2OPND),    (NO_EVEX),			 1,  1, { 0x50, 0x00, 0x00 }, 32, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VMOVNTDQ m128, xmm1    VEX.128.66.0F.WIG E7 / r
//VMOVNTDQ m256, ymm1    VEX.256.66.0F.WIG E7 / r
//VMOVNTDQ m128, xmm1    EVEX.128.66.0F.W0 E7 / r
//VMOVNTDQ m256, ymm1    EVEX.256.66.0F.W0 E7 / r
//VMOVNTDQ m512, zmm1    EVEX.512.66.0F.W0 E7 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vmovntdq",      2, { M_ANY,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_66 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_W0),          1,  1, { 0xe7, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vmovntdq",      2, { M_ANY,  R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_66 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_W0),          1,  1, { 0xe7, 0x00, 0x00 }, 32, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vmovntdq",      2, { M_ANY,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_W0),         1,  1, { 0xe7, 0x00, 0x00 }, 64, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VMOVNTDQA xmm1, m128 VEX.128.66.0F38.WIG 2A / r
//VMOVNTDQA ymm1, m256 VEX.256.66.0F38.WIG 2A / r
//VMOVNTDQA xmm1, m128 EVEX.128.66.0F38.W0 2A / r
//VMOVNTDQA ymm1, m256 EVEX.256.66.0F38.W0 2A / r
//VMOVNTDQA zmm1, m512 EVEX.512.66.0F38.W0 2A / r
/* ----------------------------------------------------------------------------------------------- */
{ "vmovntdqa",      2, { R_XMM,  M_ANY       }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_66 | VEX_0F38 | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_W0),         1,  1, { 0x2a, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST,  NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vmovntdqa",      2, { R_YMM,  M_ANY       }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_66 | VEX_0F38 | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_W0),         1,  1, { 0x2a, 0x00, 0x00 }, 32, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST,  NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
{ "vmovntdqa",      2, { R_ZMM,  M_ANY       }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_2OPND),        (EVEX_ONLY | EVEX_W0),         1,  1, { 0x2a, 0x00, 0x00 }, 64, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST,  NO_PREFIX, NO_IMM, MEM_OPND_1,    P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VMOVNTPD m128, xmm1 VEX.128.66.0F.WIG 2B / r
//VMOVNTPD m256, ymm1 VEX.256.66.0F.WIG 2B / r
//VMOVNTPD m128, xmm1 EVEX.128.66.0F.W1 2B / r
//VMOVNTPD m256, ymm1 EVEX.256.66.0F.W1 2B / r
//VMOVNTPD m512, zmm1 EVEX.512.66.0F.W1 2B / r
/* ----------------------------------------------------------------------------------------------- */
{ "vmovntpd",      2, { M_ANY,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_66 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),     (EVEX_W1),          1,  1, { 0x2b, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vmovntpd",      2, { M_ANY,  R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_66 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),     (EVEX_W1),          1,  1, { 0x2b, 0x00, 0x00 }, 32, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vmovntpd",      2, { M_ANY,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_W1),          1,  1, { 0x2b, 0x00, 0x00 }, 64, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VMOVNTPS m128, xmm1  VEX.128.0F.WIG 2B / r
//VMOVNTPS m256, ymm1  VEX.256.0F.WIG 2B / r
//VMOVNTPS m128, xmm1  EVEX.128.0F.W0 2B / r
//VMOVNTPS m256, ymm1  EVEX.256.0F.W0 2B / r
//VMOVNTPS m512, zmm1  EVEX.512.0F.W0 2B / r
/* ----------------------------------------------------------------------------------------------- */
{ "vmovntps",      2, { M_ANY,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),     (EVEX_W0),          1,  1, { 0x2b, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vmovntps",      2, { M_ANY,  R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),     (EVEX_W0),          1,  1, { 0x2b, 0x00, 0x00 }, 32, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
{ "vmovntps",      2, { M_ANY,  R_ZMM        }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_0F | VEX_2OPND),         (EVEX_ONLY | EVEX_W0),          1,  1, { 0x2b, 0x00, 0x00 }, 64, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM, MEM_OPND_0,    P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
  //VMOVSD xmm1, xmm2, xmm3  VEX.LIG.F2.0F.WIG 10 / r
  //VMOVSD xmm1, m64  VEX.LIG.F2.0F.WIG 10 / r
  //VMOVSD xmm1, xmm2, xmm3  VEX.LIG.F2.0F.WIG 11 / r
  //VMOVSD m64, xmm1  VEX.LIG.F2.0F.WIG 11 / r
  //VMOVSD xmm1{k1}{z}, xmm2, xmm3  EVEX.LIG.F2.0F.W1 10 / r
  //VMOVSD xmm1{k1}{z}, m64  EVEX.LIG.F2.0F.W1 10 / r
  //VMOVSD xmm1{k1}{z}, xmm2, xmm3  EVEX.LIG.F2.0F.W1 11 / r
  //VMOVSD  m64{k1}, xmm1  EVEX.LIG.F2.0F.W1 11 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vmovsd",     3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_LIG | VEX_WIG | VEX_F2 | VEX_0F | VEX_NDS | EVEX),                     (EVEX_MASK | EVEX_Z | EVEX_W1),         1,  1, { 0x10, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmovsd",     2, { M_ANY,  R_XMM                }, AVX0, (F_MODRM | F_MODRM_REG),						                (VEX | VEX_LIG | VEX_WIG | VEX_F2 | VEX_0F | VEX_NDS | VEX_2OPND | EVEX),	        (EVEX_MASK | EVEX_W1),                  2,  1, { 0x11, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_686 | P_AVX, 0, NULL },
{ "vmovsd",     2, { R_XMM,  M_ANY                }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_LIG | VEX_WIG | VEX_F2 | VEX_0F | VEX_NDS | VEX_2OPND | EVEX),         (EVEX_MASK | EVEX_Z | EVEX_W1),         2,  1, { 0x10, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vmovsd",     2, { M_ANY,  R_XMM                }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_LIG | VEX_WIG | VEX_F2 | VEX_0F | VEX_NDS | VEX_2OPND | EVEX),         (EVEX_MASK | EVEX_W1),                  2,  1, { 0x11, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
  //VMOVSS xmm1, xmm2, xmm3  VEX.LIG.F3.0F.WIG 10 / r
  //VMOVSS xmm1, m32  VEX.LIG.F3.0F.WIG 10 / r
  //VMOVSS xmm2 / m32, xmm1  F3 0F 11 / r
  //VMOVSS xmm1, xmm2, xmm3  VEX.LIG.F3.0F.WIG 11 / r
  //VMOVSS m32, xmm1  VEX.LIG.F3.0F.WIG 11 / r
  //VMOVSS xmm1{k1}{z}, xmm2, xmm3  EVEX.LIG.F3.0F.W0 10 / r
  //VMOVSS xmm1{k1}{z}, m32  EVEX.LIG.F3.0F.W0 10 / r
  //VMOVSS xmm1{k1}{z}, xmm2, xmm3  EVEX.LIG.F3.0F.W0 11 / r
  //VMOVSS  m32{k1}, xmm1  EVEX.LIG.F3.0F.W0 11 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vmovss",     3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),              (VEX | VEX_LIG | VEX_WIG | VEX_F3 | VEX_0F | VEX_NDS | EVEX),                     (EVEX_MASK | EVEX_Z | EVEX_W0),         1,  1, { 0x10, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vmovss",     2, { M_ANY,  R_XMM                }, AVX0, (F_MODRM | F_MODRM_REG),						                (VEX | VEX_LIG | VEX_WIG | VEX_F3 | VEX_0F | VEX_NDS | VEX_2OPND | EVEX),	        (EVEX_MASK | EVEX_W0),                  4,  1, { 0x11, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_686 | P_AVX, 0, NULL },
{ "vmovss",     2, { R_XMM,  M_ANY                }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_LIG | VEX_WIG | VEX_F3 | VEX_0F | VEX_NDS | VEX_2OPND | EVEX),         (EVEX_MASK | EVEX_Z | EVEX_W0),         4,  1, { 0x10, 0x00, 0x00 }, 16, 1, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vmovss",     2, { M_ANY,  R_XMM                }, AVX0, (F_MODRM | F_MODRM_REG),                           (VEX | VEX_LIG | VEX_WIG | VEX_F3 | VEX_0F | VEX_NDS | VEX_2OPND | EVEX),         (EVEX_MASK | EVEX_W0),                  4,  1, { 0x11, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST,  NO_PREFIX, NO_IMM,     MEM_OPND_0, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPACKSSDW xmm1, xmm2, xmm3/m128                   VEX.128.66.0F.WIG 6B/r   B V/V AVX
//VPACKSSDW ymm1, ymm2, ymm3/m256                   VEX.256.66.0F.WIG 6B/r   B V/V AVX2
//VPACKSSDW xmm1{k1}{z}, xmm2, xmm3/m128/m32bcst    EVEX.128.66.0F.W0 6B/r   D V/V AVX512VL AVX512BW
//VPACKSSDW ymm1{k1}{z}, ymm2, ymm3/m256/m32bcst    EVEX.256.66.0F.W0 6B/r   D V/V AVX512VL AVX512BW
//VPACKSSDW zmm1{k1}{z}, zmm2, zmm3/m512/m32bcst    EVEX.512.66.0F.W0 6B/r   D V/V AVX512BW
/* ----------------------------------------------------------------------------------------------- */
{ "vpackssdw",      3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),  (EVEX_W0 | EVEX_MASK | EVEX_Z),                         1,  1, { 0x6b, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpackssdw",      3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),  (EVEX_W0 | EVEX_MASK | EVEX_Z),                         1,  1, { 0x6b, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpackssdw",      3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),  (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),              4,  1, { 0x6b, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpackssdw",      3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),  (EVEX_W0 | EVEX_MASK | EVEX_Z),                         1,  1, { 0x6b, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpackssdw",      3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),  (EVEX_W0 | EVEX_MASK | EVEX_Z),                         1,  1, { 0x6b, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpackssdw",      3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),  (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),              8,  1, { 0x6b, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpackssdw",      3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),                (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0x6b, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpackssdw",      3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),                (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0x6b, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpackssdw",      3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),                (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),    16, 1, { 0x6b, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPACKSSWB xmm1, xmm2, xmm3/m128                   VEX.128.66.0F.WIG 63/r   B V/V AVX
//VPACKSSWB ymm1, ymm2, ymm3/m256                   VEX.256.66.0F.WIG 63/r   B V/V AVX2
//VPACKSSWB xmm1{k1}{z}, xmm2, xmm3/m128            EVEX.128.66.0F.WIG 63/r  C V/V AVX512VL AVX512BW
//VPACKSSWB ymm1{k1}{z}, ymm2, ymm3/m256            EVEX.256.66.0F.WIG 63/r  C V/V AVX512VL AVX512BW
//VPACKSSWB zmm1{k1}{z}, zmm2, zmm3/m512            EVEX.512.66.0F.WIG 63/r  C V/V AVX512BW
/* ----------------------------------------------------------------------------------------------- */
{ "vpacksswb",      3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0x63, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpacksswb",      3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0x63, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpacksswb",      3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0x63, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpacksswb",      3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0x63, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpacksswb",      3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),               1,  1, { 0x63, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpacksswb",      3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),               1,  1, { 0x63, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPACKUSWB xmm1, xmm2, xmm3 / m128         VEX.128.66.0F.WIG 67 / r    B V / V AVX
//VPACKUSWB ymm1, ymm2, ymm3 / m256         VEX.256.66.0F.WIG 67 / r    B V / V AVX2
//VPACKUSWB xmm1{k1}{z}, xmm2, xmm3 / m128  EVEX.128.66.0F.WIG 67 / r   C V / V AVX512VL AVX512BW
//VPACKUSWB ymm1{k1}{z}, ymm2, ymm3 / m256  EVEX.256.66.0F.WIG 67 / r   C V / V AVX512VL AVX512BW
//VPACKUSWB zmm1{k1}{z}, zmm2, zmm3 / m512  EVEX.512.66.0F.WIG 67 / r   C V / V AVX512BW
/* ----------------------------------------------------------------------------------------------- */
{ "vpackuswb",      3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0x67, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpackuswb",      3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0x67, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpackuswb",      3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0x67, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpackuswb",      3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0x67, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpackuswb",      3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),               1,  1, { 0x67, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpackuswb",      3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),               1,  1, { 0x67, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPADDB xmm1, xmm2, xmm3 / m128                 VEX.128.66.0F.WIG FC / r       B V / V AVX                 Add packed byte integers from xmm2, and xmm3 / m128 and store in xmm1.
//VPADDB ymm1, ymm2, ymm3 / m256                 VEX.256.66.0F.WIG FC / r       B V / V AVX2                Add packed byte integers from ymm2, and ymm3 / m256 and store in ymm1.
//VPADDB xmm1{k1}{z}, xmm2, xmm3 / m128          EVEX.128.66.0F.WIG FC / r      C V / V AVX512VL AVX512BW   Add packed byte integers from xmm2, and xmm3 / m128 and store in xmm1 using writemask k1.
//VPADDB ymm1{k1}{z}, ymm2, ymm3 / m256          EVEX.256.66.0F.WIG FC / r      C V / V AVX512VL AVX512BW   Add packed byte integers from ymm2, and ymm3 / m256 and store in ymm1 using writemask k1.
//VPADDB zmm1{k1}{z}, zmm2, zmm3 / m512          EVEX.512.66.0F.WIG FC / r      C V / V AVX512BW            Add packed byte integers from zmm2, and zmm3 / m512 and store in zmm1 using writemask k1.
/* ----------------------------------------------------------------------------------------------- */
{ "vpaddb",      3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xfc, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpaddb",      3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xfc, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpaddb",      3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xfc, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpaddb",      3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xfc, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpaddb",      3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),               1,  1, { 0xfc, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpaddb",      3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),               1,  1, { 0xfc, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPADDW xmm1, xmm2, xmm3 / m128                 VEX.128.66.0F.WIG FD / r       B V / V AVX                 Add packed word integers from xmm2, xmm3 / m128 and store in xmm1.
//VPADDW ymm1, ymm2, ymm3 / m256                 VEX.256.66.0F.WIG FD / r       B V / V AVX2                Add packed word integers from ymm2, ymm3 / m256 and store in ymm1.
//VPADDW xmm1{k1}{z}, xmm2, xmm3 / m128          EVEX.128.66.0F.WIG FD / r      C V / V AVX512VL AVX512BW   Add packed word integers from xmm2, and xmm3 / m128 and store in xmm1 using writemask k1.
//VPADDW ymm1{k1}{z}, ymm2, ymm3 / m256          EVEX.256.66.0F.WIG FD / r      C V / V AVX512VL AVX512BW   Add packed word integers from ymm2, and ymm3 / m256 and store in ymm1 using writemask k1.
//VPADDW zmm1{k1}{z}, zmm2, zmm3 / m512          EVEX.512.66.0F.WIG FD / r      C V / V AVX512BW            Add packed word integers from zmm2, and zmm3 / m512 and store in zmm1 using writemask k1.
/* ----------------------------------------------------------------------------------------------- */
{ "vpaddw",      3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xfd, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpaddw",      3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z ),              1,  1, { 0xfd, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpaddw",      3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xfd, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpaddw",      3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xfd, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpaddw",      3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX| VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),       (EVEX_ONLY | EVEX_MASK | EVEX_Z),               1,  1, { 0xfd, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpaddw",      3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX| VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),       (EVEX_ONLY | EVEX_MASK | EVEX_Z),               1,  1, { 0xfd, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPADDD xmm1, xmm2, xmm3 / m128                 VEX.128.66.0F.WIG FE / r       B V / V AVX                 Add packed doubleword integers from xmm2, xmm3 / m128 and store in xmm1.
//VPADDD ymm1, ymm2, ymm3 / m256                 VEX.256.66.0F.WIG FE / r       B V / V AVX2                Add packed doubleword integers from ymm2, ymm3 / m256 and store in ymm1.
//VPADDD xmm1{k1}{z}, xmm2, xmm3 / m128 / m32bcst  EVEX.128.66.0F.W0 FE / r       D V / V AVX512VL AVX512F    Add packed doubleword integers from xmm2, and xmm3 / m128 / m32bcst and store in xmm1 using writemask k1.
//VPADDD ymm1{k1}{z}, ymm2, ymm3 / m256 / m32bcst  EVEX.256.66.0F.W0 FE / r       D V / V AVX512VL AVX512F    Add packed doubleword integers from ymm2, ymm3 / m256 / m32bcst and store in ymm1 using writemask k1.
//VPADDD zmm1{k1}{z}, zmm2, zmm3 / m512 / m32bcst  EVEX.512.66.0F.W0 FE / r       D V / V AVX512F             Add packed doubleword integers from zmm2, zmm3 / m512 / m32bcst and store in zmm1 using writemask k1.
/* ----------------------------------------------------------------------------------------------- */
{ "vpaddd",      3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),  (EVEX_W0 | EVEX_MASK | EVEX_Z),                         1,  1, { 0xfe, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpaddd",      3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),  (EVEX_W0 | EVEX_MASK | EVEX_Z),                         1,  1, { 0xfe, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpaddd",      3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),  (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),              4,  1, { 0xfe, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpaddd",      3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),  (EVEX_W0 | EVEX_MASK | EVEX_Z),                         1,  1, { 0xfe, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpaddd",      3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),  (EVEX_W0 | EVEX_MASK | EVEX_Z),                         1,  1, { 0xfe, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpaddd",      3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),  (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),              8,  1, { 0xfe, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpaddd",      3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),                (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0xfe, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpaddd",      3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),                (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0xfe, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpaddd",      3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),                (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),    16, 1, { 0xfe, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPADDQ xmm1, xmm2, xmm3 / m128                 VEX.128.66.0F.WIG D4 / r       B V / V AVX                 Add packed quadword integers from xmm2, xmm3 / m128 and store in xmm1.
//VPADDQ ymm1, ymm2, ymm3 / m256                 VEX.256.66.0F.WIG D4 / r       B V / V AVX2                Add packed quadword integers from ymm2, ymm3 / m256 and store in ymm1.
//VPADDQ xmm1{k1}{z}, xmm2, xmm3 / m128 / m64bcst  EVEX.128.66.0F.W1 D4 / r       D V / V AVX512VL AVX512F    Add packed quadword integers from xmm2, and xmm3 / m128 / m64bcst and store in xmm1 using writemask k1.
//VPADDQ ymm1{k1}{z}, ymm2, ymm3 / m256 / m64bcst  EVEX.256.66.0F.W1 D4 / r       D V / V AVX512VL AVX512F    Add packed quadword integers from ymm2, ymm3 / m256 / m64bcst and store in ymm1 using writemask k1.
//VPADDQ zmm1{k1}{z}, zmm2, zmm3 / m512 / m64bcst  EVEX.512.66.0F.W1 D4 / r       D V / V AVX512F             Add packed quadword integers from zmm2, zmm3 / m512 / m64bcst and store in zmm1 using writemask k1.
/* ----------------------------------------------------------------------------------------------- */
{ "vpaddq",      3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),  (EVEX_W0 | EVEX_MASK | EVEX_Z),                         1,  1, { 0xd4, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpaddq",      3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),  (EVEX_W0 | EVEX_MASK | EVEX_Z),                         1,  1, { 0xd4, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpaddq",      3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),  (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),              2,  1, { 0xd4, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpaddq",      3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),  (EVEX_W0 | EVEX_MASK | EVEX_Z),                         1,  1, { 0xd4, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpaddq",      3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),  (EVEX_W0 | EVEX_MASK | EVEX_Z),                         1,  1, { 0xd4, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpaddq",      3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),  (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),              4,  1, { 0xd4, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpaddq",      3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),                (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0xd4, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpaddq",      3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),                (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0xd4, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpaddq",      3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),                (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),    8,  1, { 0xd4, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPADDSB xmm1, xmm2, xmm3/m128            VEX.128.66.0F.WIG EC /r     B V/V AVX              
//VPADDSB ymm1, ymm2, ymm3/m256            VEX.256.66.0F.WIG EC /r     B V/V AVX2             
//VPADDSB xmm1 {k1}{z}, xmm2, xmm3/m128    EVEX.128.66.0F.WIG EC /r    C V/V AVX512VL AVX512BW
//VPADDSB ymm1 {k1}{z}, ymm2, ymm3/m256    EVEX.256.66.0F.WIG EC /r    C V/V AVX512VL AVX512BW
//VPADDSB zmm1 {k1}{z}, zmm2, zmm3/m512    EVEX.512.66.0F.WIG EC /r    C V/V AVX512BW         
/* ----------------------------------------------------------------------------------------------- */
{ "vpaddsb",     3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xec, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpaddsb",     3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xec, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpaddsb",     3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xec, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpaddsb",     3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xec, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpaddsb",     3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX| VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),       (EVEX_ONLY | EVEX_MASK | EVEX_Z),               1,  1, { 0xec, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpaddsb",     3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX| VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),       (EVEX_ONLY | EVEX_MASK | EVEX_Z),               1,  1, { 0xec, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPADDSW xmm1, xmm2, xmm3/m128            VEX.128.66.0F.WIG ED /r     B V/V AVX              
//VPADDSW ymm1, ymm2, ymm3/m256            VEX.256.66.0F.WIG ED /r     B V/V AVX2             
//VPADDSW xmm1 {k1}{z}, xmm2, xmm3/m128    EVEX.128.66.0F.WIG ED /r    C V/V AVX512VL AVX512BW
//VPADDSW ymm1 {k1}{z}, ymm2, ymm3/m256    EVEX.256.66.0F.WIG ED /r    C V/V AVX512VL AVX512BW
//VPADDSW zmm1 {k1}{z}, zmm2, zmm3/m512    EVEX.512.66.0F.WIG ED /r    C V/V AVX512BW         
/* ----------------------------------------------------------------------------------------------- */
{ "vpaddsw",     3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xed, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpaddsw",     3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xed, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpaddsw",     3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xed, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpaddsw",     3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xed, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpaddsw",     3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX| VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),       (EVEX_ONLY | EVEX_MASK | EVEX_Z),               1,  1, { 0xed, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpaddsw",     3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX| VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),       (EVEX_ONLY | EVEX_MASK | EVEX_Z),               1,  1, { 0xed, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPADDUSB xmm1, xmm2, xmm3/m128            VEX.128.660F.WIG DC /r    B V/V AVX               
//VPADDUSB ymm1, ymm2, ymm3/m256            VEX.256.66.0F.WIG DC /r   B V/V AVX2              
//VPADDUSB xmm1 {k1}{z}, xmm2, xmm3/m128    EVEX.128.66.0F.WIG DC /r  C V/V AVX512VL AVX512BW 
//VPADDUSB ymm1 {k1}{z}, ymm2, ymm3/m256    EVEX.256.66.0F.WIG DC /r  C V/V AVX512VL AVX512BW 
//VPADDUSB zmm1 {k1}{z}, zmm2, zmm3/m512    EVEX.512.66.0F.WIG DC /r  C V/V AVX512BW          
{ "vpaddusb",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xdc, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpaddusb",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xdc, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpaddusb",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xdc, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpaddusb",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xdc, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpaddusb",    3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX| VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),       (EVEX_ONLY | EVEX_MASK | EVEX_Z),               1,  1, { 0xdc, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpaddusb",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX| VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),       (EVEX_ONLY | EVEX_MASK | EVEX_Z),               1,  1, { 0xdc, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPADDUSW xmm1, xmm2, xmm3/m128            VEX.128.66.0F.WIG DD /r   B V/V AVX               
//VPADDUSW ymm1, ymm2, ymm3/m256            VEX.256.66.0F.WIG DD /r   B V/V AVX2              
//VPADDUSW xmm1 {k1}{z}, xmm2, xmm3/m128    EVEX.128.66.0F.WIG DD /r  C V/V AVX512VL AVX512BW 
//VPADDUSW ymm1 {k1}{z}, ymm2, ymm3/m256    EVEX.256.66.0F.WIG DD /r  C V/V AVX512VL AVX512BW
//VPADDUSW zmm1{k1}{z}, zmm2, zmm3 / m512   EVEX.512.66.0F.WIG DD / r C V/V AVX512BW
/* ----------------------------------------------------------------------------------------------- */
{ "vpaddusw",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xdd, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpaddusw",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xdd, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpaddusw",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xdd, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpaddusw",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xdd, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpaddusw",    3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX| VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),       (EVEX_ONLY | EVEX_MASK | EVEX_Z),               1,  1, { 0xdd, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpaddusw",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX| VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),       (EVEX_ONLY | EVEX_MASK | EVEX_Z),               1,  1, { 0xdd, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPAND xmm1, xmm2, xmm3/m128                    VEX.128.66.0F.WIG DB /r    B V/V AVX             
//VPAND ymm1, ymm2, ymm3/m256                    VEX.256.66.0F.WIG DB /r    B V/V AVX2            
/* ----------------------------------------------------------------------------------------------- */
{ "vpand",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),                           (NO_EVEX),              1,  1, { 0xdd, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpand",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),                           (NO_EVEX),              1,  1, { 0xdd, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpand",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),                           (NO_EVEX),              1,  1, { 0xdd, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpand",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),                           (NO_EVEX),              1,  1, { 0xdd, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPANDD xmm1 {k1}{z}, xmm2,xmm3/m128/m32bcst    EVEX.128.66.0F.W0 DB /r    C V/V AVX512VL AVX512F
//VPANDD ymm1 {k1}{z}, ymm2,ymm3/m256/m32bcst    EVEX.256.66.0F.W0 DB /r    C V/V AVX512VL AVX512F
//VPANDD zmm1 {k1}{z}, zmm2,zmm3/m512/m32bcst    EVEX.512.66.0F.W0 DB /r    C V/V AVX512F         
/* ----------------------------------------------------------------------------------------------- */
{ "vpandd",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0xdb, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpandd",    3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0xdb, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpandd",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),    4,  1, { 0xdb, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpandd",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0xdb, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpandd",    3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0xdb, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpandd",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),    8,  1, { 0xdb, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpandd",    3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0xdb, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpandd",    3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0xdb, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpandd",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),    16, 1, { 0xdb, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPANDQ xmm1 {k1}{z}, xmm2,xmm3/m128/m64bcst    EVEX.128.66.0F.W1 DB /r    C V/V AVX512VL AVX512F
//VPANDQ ymm1 {k1}{z}, ymm2,ymm3/m256/m64bcst    EVEX.256.66.0F.W1 DB /r    C V/V AVX512VL AVX512F
//VPANDQ zmm1 {k1}{z}, zmm2,zmm3/m512/m64bcst    EVEX.512.66.0F.W1 DB /r    C V/V AVX512F         
/* ----------------------------------------------------------------------------------------------- */
{ "vpandq",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0xdb, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpandq",    3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0xdb, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpandq",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),    2,  1, { 0xdb, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpandq",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0xdb, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpandq",    3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0xdb, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpandq",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),    4,  1, { 0xdb, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpandq",    3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0xdb, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpandq",    3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0xdb, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpandq",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),    8,  1, { 0xdb, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPANDN xmm1, xmm2, xmm3 / m128                  VEX.128.66.0F.WIG DF / r   B V / V AVX
//VPANDN ymm1, ymm2, ymm3 / m256                  VEX.256.66.0F.WIG DF / r   B V / V AVX2
/* ----------------------------------------------------------------------------------------------- */
{ "vpandn",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),                           (NO_EVEX),              1,  1, { 0xdf, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpandn",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),                           (NO_EVEX),              1,  1, { 0xdf, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpandn",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),                           (NO_EVEX),              1,  1, { 0xdf, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpandn",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),                           (NO_EVEX),              1,  1, { 0xdf, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPANDND xmm1{k1}{z}, xmm2, xmm3 / m128 / m32bcst  EVEX.128.66.0F.W0 DF / r   C V / V AVX512VL AVX512F
//VPANDND ymm1{k1}{z}, ymm2, ymm3 / m256 / m32bcst  EVEX.256.66.0F.W0 DF / r   C V / V AVX512VL AVX512F
//VPANDND zmm1{k1}{z}, zmm2, zmm3 / m512 / m32bcst  EVEX.512.66.0F.W0 DF / r   C V / V AVX512F
/* ----------------------------------------------------------------------------------------------- */
{ "vpandnd",   3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0xdf, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpandnd",   3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0xdf, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpandnd",   3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),    4,  1, { 0xdf, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpandnd",   3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0xdf, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpandnd",   3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0xdf, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpandnd",   3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),    8,  1, { 0xdf, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpandnd",   3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0xdf, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpandnd",   3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0xdf, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpandnd",   3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),    16, 1, { 0xdf, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPANDNQ xmm1{k1}{z}, xmm2, xmm3 / m128 / m64bcst  EVEX.128.66.0F.W1 DF / r   C V / V AVX512VL AVX512F
//VPANDNQ ymm1{k1}{z}, ymm2, ymm3 / m256 / m64bcst  EVEX.256.66.0F.W1 DF / r   C V / V AVX512VL AVX512F
//VPANDNQ zmm1{k1}{z}, zmm2, zmm3 / m512 / m64bcst  EVEX.512.66.0F.W1 DF / r   C V / V AVX512F
/* ----------------------------------------------------------------------------------------------- */
{ "vpandnq",   3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0xdf, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpandnq",   3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0xdf, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpandnq",   3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),    2,  1, { 0xdf, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpandnq",   3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0xdf, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpandnq",   3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0xdf, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpandnq",   3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),    4,  1, { 0xdf, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpandnq",   3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0xdf, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpandnq",   3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0xdf, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpandnq",   3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),    8,  1, { 0xdf, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPAVGB xmm1, xmm2, xmm3/m128              VEX.128.66.0F.WIG E0 /r      B V/V AVX              
//VPAVGB ymm1, ymm2, ymm3/m256              VEX.256.66.0F.WIG E0 /r      B V/V AVX2             
//VPAVGB xmm1 {k1}{z}, xmm2, xmm3/m128      EVEX.128.66.0F.WIG E0 /r     C V/V AVX512VL AVX512BW
//VPAVGB ymm1 {k1}{z}, ymm2, ymm3/m256      EVEX.256.66.0F.WIG E0 /r     C V/V AVX512VL AVX512BW
//VPAVGB zmm1 {k1}{z}, zmm2, zmm3/m512      EVEX.512.66.0F.WIG E0 /r     C V/V AVX512BW         
/* ----------------------------------------------------------------------------------------------- */
{ "vpavgb",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xe0, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpavgb",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xe0, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpavgb",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xe0, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpavgb",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xe0, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpavgb",    3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),               1,  1, { 0xe0, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpavgb",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),               1,  1, { 0xe0, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPAVGW xmm1, xmm2, xmm3/m128              VEX.128.66.0F.WIG E3 /r      B V/V AVX              
//VPAVGW ymm1, ymm2, ymm3/m256              VEX.256.66.0F.WIG E3 /r      B V/V AVX2             
//VPAVGW xmm1 {k1}{z}, xmm2, xmm3/m128      EVEX.128.66.0F.WIG E3 /r     C V/V AVX512VL AVX512BW
//VPAVGW ymm1 {k1}{z}, ymm2, ymm3/m256      EVEX.256.66.0F.WIG E3 /r     C V/V AVX512VL AVX512BW
//VPAVGW zmm1 {k1}{z}, zmm2, zmm3/m512      EVEX.512.66.0F.WIG E3 /r     C V/V AVX512BW         
/* ----------------------------------------------------------------------------------------------- */
{ "vpavgw",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xe3, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpavgw",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xe3, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpavgw",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xe3, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpavgw",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),               1,  1, { 0xe3, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpavgw",    3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),               1,  1, { 0xe3, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpavgw",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),               1,  1, { 0xe3, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPCMPEQB xmm1, xmm2, xmm3/m128                VEX.128.66.0F.WIG 74 /r  
//VPCMPEQB ymm1, ymm2, ymm3 /m256               VEX.256.66.0F.WIG 74 /r  
//VPCMPEQB k1 {k2}, xmm2, xmm3 /m128            EVEX.128.66.0F.WIG 74 /r 
//VPCMPEQB k1 {k2}, ymm2, ymm3 /m256            EVEX.256.66.0F.WIG 74 /r 
//VPCMPEQB k1 {k2}, zmm2, zmm3 /m512            EVEX.512.66.0F.WIG 74 /r 
/* ----------------------------------------------------------------------------------------------- */
{ "vpcmpeqb",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),            (NO_EVEX),                                   1,  1, { 0x74, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpcmpeqb",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),            (NO_EVEX),                                   1,  1, { 0x74, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpcmpeqb",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),            (NO_EVEX),                                   1,  1, { 0x74, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpcmpeqb",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),            (NO_EVEX),                                   1,  1, { 0x74, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpcmpeqb",    3, { R_K,    R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),     (EVEX_ONLY | EVEX_MASK),                           1,  1, { 0x74, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpcmpeqb",    3, { R_K,    R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),     (EVEX_ONLY | EVEX_MASK),                           1,  1, { 0x74, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpcmpeqb",    3, { R_K,    R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),     (EVEX_ONLY | EVEX_MASK),                           1,  1, { 0x74, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpcmpeqb",    3, { R_K,    R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),     (EVEX_ONLY | EVEX_MASK),                           1,  1, { 0x74, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpcmpeqb",    3, { R_K,    R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),     (EVEX_ONLY | EVEX_MASK),                           1,  1, { 0x74, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpcmpeqb",    3, { R_K,    R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),     (EVEX_ONLY | EVEX_MASK),                           1,  1, { 0x74, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPCMPEQW xmm1, xmm2, xmm3/m128                VEX.128.66.0F.WIG 75 /r  
//VPCMPEQW ymm1, ymm2, ymm3 /m256               VEX.256.66.0F.WIG 75 /r  
//VPCMPEQW k1 {k2}, xmm2, xmm3 /m128            EVEX.128.66.0F.WIG 75 /r 
//VPCMPEQW k1 {k2}, ymm2, ymm3 /m256            EVEX.256.66.0F.WIG 75 /r 
//VPCMPEQW k1 {k2}, zmm2, zmm3 /m512            EVEX.512.66.0F.WIG 75 /r 
/* ----------------------------------------------------------------------------------------------- */
{ "vpcmpeqw",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),            (NO_EVEX),                                   1,  1, { 0x75, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpcmpeqw",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),            (NO_EVEX),                                   1,  1, { 0x75, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpcmpeqw",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),            (NO_EVEX),                                   1,  1, { 0x75, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpcmpeqw",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),            (NO_EVEX),                                   1,  1, { 0x75, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpcmpeqw",    3, { R_K,    R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),     (EVEX_ONLY | EVEX_MASK),                           1,  1, { 0x75, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpcmpeqw",    3, { R_K,    R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),     (EVEX_ONLY | EVEX_MASK),                           1,  1, { 0x75, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpcmpeqw",    3, { R_K,    R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),     (EVEX_ONLY | EVEX_MASK),                           1,  1, { 0x75, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpcmpeqw",    3, { R_K,    R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),     (EVEX_ONLY | EVEX_MASK),                           1,  1, { 0x75, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpcmpeqw",    3, { R_K,    R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),     (EVEX_ONLY | EVEX_MASK),                           1,  1, { 0x75, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpcmpeqw",    3, { R_K,    R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),     (EVEX_ONLY | EVEX_MASK),                           1,  1, { 0x75, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPCMPEQD xmm1, xmm2, xmm3/m128                VEX.128.66.0F.WIG 76 /r  
//VPCMPEQD ymm1, ymm2, ymm3 /m256               VEX.256.66.0F.WIG 76 /r  
//VPCMPEQD k1 {k2}, xmm2, xmm3/m128/m32bcst     EVEX.128.66.0F.W0 76 /r  
//VPCMPEQD k1 {k2}, ymm2, ymm3/m256/m32bcst     EVEX.256.66.0F.W0 76 /r  
//VPCMPEQD k1 {k2}, zmm2, zmm3/m512/m32bcst     EVEX.512.66.0F.W0 76 /r  
/* ----------------------------------------------------------------------------------------------- */
{ "vpcmpeqd",     3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),           (NO_EVEX),                                    1,  1, { 0x76, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpcmpeqd",     3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),           (NO_EVEX),                                    1,  1, { 0x76, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpcmpeqd",     3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),           (NO_EVEX),                                    1,  1, { 0x76, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpcmpeqd",     3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),           (NO_EVEX),                                    1,  1, { 0x76, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpcmpeqd",     3, { R_K,    R_XMM, R_XMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0x76, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpcmpeqd",     3, { R_K,    R_XMM, M128          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0x76, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpcmpeqd",     3, { R_K,    R_XMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),    4,  1, { 0x76, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpcmpeqd",     3, { R_K,    R_YMM, R_YMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0x76, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpcmpeqd",     3, { R_K,    R_YMM, M256          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0x76, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpcmpeqd",     3, { R_K,    R_YMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),    8,  1, { 0x76, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpcmpeqd",     3, { R_K,    R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0x76, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpcmpeqd",     3, { R_K,    R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0x76, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpcmpeqd",     3, { R_K,    R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),    16, 1, { 0x76, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPEXTRW reg, xmm1, imm8       VEX.128.66.0F.W0 C5 / r ib     A V2 / V AVX
//VPEXTRW reg / m16, xmm2, imm8 VEX.128.66.0F3A.W0 15 / r ib   B V / V AVX
//VPEXTRW reg, xmm1, imm8       EVEX.128.66.0F.WIG C5 / r ib   A V / V AVX512BW
//VPEXTRW reg / m16, xmm2, imm8 EVEX.128.66.0F3A.WIG 15 / r ib C V / V AVX512BW
/* ----------------------------------------------------------------------------------------------- */
{ "vpextrw",         3, { R32,     R_XMM,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_W0 | VEX_66 | VEX_0F | VEX_2OPND | EVEX),   (EVEX | VEX_WIG),               8,  1, { 0xc5, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpextrw",         3, { R32E,    R_XMM,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_W0 | VEX_66 | VEX_0F | VEX_2OPND | EVEX),   (EVEX | VEX_WIG),               8,  1, { 0xc5, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpextrw",         3, { R64,     R_XMM,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_W1 | VEX_66 | VEX_0F | VEX_2OPND | EVEX),   (EVEX | VEX_W1),                8,  1, { 0xc5, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpextrw",         3, { R64E,    R_XMM,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_W1 | VEX_66 | VEX_0F | VEX_2OPND | EVEX),   (EVEX | VEX_W1),                8,  1, { 0xc5, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpextrw",         3, { M_ANY,   R_XMM,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_W0 | VEX_66 | VEX_0F3A | VEX_2OPND | EVEX), (EVEX | VEX_WIG),               8,  1, { 0x15, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_0, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPEXTRB reg / m8, xmm2, imm8    VEX.128.66.0F3A.W0 14 / r ib
//VPEXTRB reg / m8, xmm2, imm8   EVEX.128.66.0F3A.WIG 14 / r ib
/* ----------------------------------------------------------------------------------------------- */
{ "vpextrb",         3, { R32,     R_XMM,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_W0 | VEX_66 | VEX_0F3A | VEX_2OPND | EVEX),   (EVEX | VEX_WIG),             16,  1, { 0x14, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), RM_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpextrb",         3, { R32E,    R_XMM,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_W0 | VEX_66 | VEX_0F3A | VEX_2OPND | EVEX),   (EVEX | VEX_WIG),             16,  1, { 0x14, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), RM_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpextrb",         3, { R64,     R_XMM,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_W1 | VEX_66 | VEX_0F3A | VEX_2OPND | EVEX),   (EVEX | VEX_W1),              16,  1, { 0x14, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), RM_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpextrb",         3, { R64E,    R_XMM,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_W1 | VEX_66 | VEX_0F3A | VEX_2OPND | EVEX),   (EVEX | VEX_W1),              16,  1, { 0x14, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), RM_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpextrb",         3, { M_ANY,   R_XMM,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_W0 | VEX_66 | VEX_0F3A | VEX_2OPND | EVEX),   (EVEX | VEX_WIG),             16,  1, { 0x14, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_0, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPEXTRD r32 / m32, xmm2, imm8   VEX.128.66.0F3A.W0 16 / r ib
//VPEXTRD r32 / m32, xmm2, imm8  EVEX.128.66.0F3A.W0 16 / r ib
/* ----------------------------------------------------------------------------------------------- */
{ "vpextrd",         3, { R32,     R_XMM,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_W0 | VEX_66 | VEX_0F3A | VEX_2OPND | EVEX),   (EVEX | VEX_W0),              4,  1, { 0x16, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), RM_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpextrd",         3, { R32E,    R_XMM,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_W0 | VEX_66 | VEX_0F3A | VEX_2OPND | EVEX),   (EVEX | VEX_W0),              4,  1, { 0x16, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), RM_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpextrd",         3, { R64,     R_XMM,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_W0 | VEX_66 | VEX_0F3A | VEX_2OPND | EVEX),   (EVEX | VEX_W0),              4,  1, { 0x16, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), RM_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpextrd",         3, { R64E,    R_XMM,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_W0 | VEX_66 | VEX_0F3A | VEX_2OPND | EVEX),   (EVEX | VEX_W0),              4,  1, { 0x16, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), RM_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpextrd",         3, { M_ANY,   R_XMM,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_W0 | VEX_66 | VEX_0F3A | VEX_2OPND | EVEX),   (EVEX | VEX_W0),              4,  1, { 0x16, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_0, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPEXTRQ r64 / m64, xmm2, imm8   VEX.128.66.0F3A.W1 16 / r ib
//VPEXTRQ r64 / m64, xmm2, imm8  EVEX.128.66.0F3A.W1 16 / r ib
/* ----------------------------------------------------------------------------------------------- */
{ "vpextrq",         3, { R64,     R_XMM,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_W1 | VEX_66 | VEX_0F3A | VEX_2OPND | EVEX),   (EVEX | VEX_W1),              2,  1, { 0x16, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), RM_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpextrq",         3, { R64E,    R_XMM,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_W1 | VEX_66 | VEX_0F3A | VEX_2OPND | EVEX),   (EVEX | VEX_W1),              2,  1, { 0x16, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), RM_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpextrq",         3, { M_ANY,   R_XMM,  IMM8 }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_W1 | VEX_66 | VEX_0F3A | VEX_2OPND | EVEX),   (EVEX | VEX_W1),              2,  1, { 0x16, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_0, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPINSRW xmm1, xmm2, r32 / m16, imm8  VEX.128.66.0F.W0 C4 / r ib
//VPINSRW xmm1, xmm2, r32 / m16, imm8 EVEX.128.66.0F.WIG C4 / r ib
/* ----------------------------------------------------------------------------------------------- */
{ "vpinsrw",         4, { R_XMM,  R_XMM,  R32,     IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_W0 | VEX_66 | VEX_0F | VEX_NDS | EVEX),   (EVEX | VEX_WIG),               8,  1, { 0xc4, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpinsrw",         4, { R_XMM,  R_XMM,  R32E,    IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_W0 | VEX_66 | VEX_0F | VEX_NDS | EVEX),   (EVEX | VEX_WIG),               8,  1, { 0xc4, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpinsrw",         4, { R_XMM,  R_XMM,  R64,     IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_W1 | VEX_66 | VEX_0F | VEX_NDS | EVEX),   (EVEX | VEX_W1),                8,  1, { 0xc4, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpinsrw",         4, { R_XMM,  R_XMM,  R64E,    IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_W1 | VEX_66 | VEX_0F | VEX_NDS | EVEX),   (EVEX | VEX_W1),                8,  1, { 0xc4, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpinsrw",         4, { R_XMM,  R_XMM,  M_ANY,   IMM8 }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_W0 | VEX_66 | VEX_0F | VEX_NDS | EVEX),   (EVEX | VEX_WIG),               8,  1, { 0xc4, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPINSRB xmm1, xmm2, r32 / m8, imm8  VEX.128.66.0F3A.W0 20 / r ib   B V1 / V AVX
//VPINSRB xmm1, xmm2, r32 / m8, imm8  EVEX.128.66.0F3A.WIG 20 / r ib C V / V AVX512BW
/* ----------------------------------------------------------------------------------------------- */
{ "vpinsrb",         4, { R_XMM,  R_XMM,  R32,     IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_W0 | VEX_66 | VEX_0F3A | VEX_NDS | EVEX),   (EVEX | VEX_WIG),               16,  1, { 0x20, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpinsrb",         4, { R_XMM,  R_XMM,  R32E,    IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_W0 | VEX_66 | VEX_0F3A | VEX_NDS | EVEX),   (EVEX | VEX_WIG),               16,  1, { 0x20, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpinsrb",         4, { R_XMM,  R_XMM,  R64,     IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_W1 | VEX_66 | VEX_0F3A | VEX_NDS | EVEX),   (EVEX | VEX_W1),                16,  1, { 0x20, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpinsrb",         4, { R_XMM,  R_XMM,  R64E,    IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_W1 | VEX_66 | VEX_0F3A | VEX_NDS | EVEX),   (EVEX | VEX_W1),                16,  1, { 0x20, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpinsrb",         4, { R_XMM,  R_XMM,  M_ANY,   IMM8 }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_W0 | VEX_66 | VEX_0F3A | VEX_NDS | EVEX),   (EVEX | VEX_WIG),               16,  1, { 0x20, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPINSRD xmm1, xmm2, r32 / m32, imm8 EVEX.128.66.0F3A.W0 22 / r ib  C V / V AVX512DQ
//VPINSRD xmm1, xmm2, r / m32, imm8   VEX.128.66.0F3A.W0 22 / r ib   B V / V AVX
/* ----------------------------------------------------------------------------------------------- */
{ "vpinsrd",         4, { R_XMM,  R_XMM,  R32,     IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_W0 | VEX_66 | VEX_0F3A | VEX_NDS | EVEX),   (EVEX | VEX_WIG),               4,  1, { 0x22, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpinsrd",         4, { R_XMM,  R_XMM,  R32E,    IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_W0 | VEX_66 | VEX_0F3A | VEX_NDS | EVEX),   (EVEX | VEX_WIG),               4,  1, { 0x22, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpinsrd",         4, { R_XMM,  R_XMM,  M_ANY,   IMM8 }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_W0 | VEX_66 | VEX_0F3A | VEX_NDS | EVEX),   (EVEX | VEX_WIG),               4,  1, { 0x22, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPINSRQ xmm1, xmm2, r / m64, imm8   VEX.128.66.0F3A.W1 22 / r ib   B V / I2 AVX
//VPINSRQ xmm1, xmm2, r64 / m64, imm8 EVEX.128.66.0F3A.W1 22 / r ib  C V / N.E.2 AVX512DQ
/* ----------------------------------------------------------------------------------------------- */
{ "vpinsrq",         4, { R_XMM,  R_XMM,  R64,     IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_W1 | VEX_66 | VEX_0F3A | VEX_NDS | EVEX),   (EVEX | VEX_W1),                2,  1, { 0x22, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpinsrq",         4, { R_XMM,  R_XMM,  R64E,    IMM8 }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM) | IMM8_ONLY,  (VEX | VEX_W1 | VEX_66 | VEX_0F3A | VEX_NDS | EVEX),   (EVEX | VEX_W1),                2,  1, { 0x22, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3, NO_MEM,    P_686 | P_AVX, 0, NULL },
{ "vpinsrq",         4, { R_XMM,  R_XMM,  M_ANY,   IMM8 }, AVX0, (F_MODRM | F_MODRM_REG) | IMM8_ONLY,               (VEX | VEX_W0 | VEX_66 | VEX_0F3A | VEX_NDS | EVEX),   (EVEX | VEX_WIG),               2,  1, { 0x22, 0x00, 0x00 }, 16, 1, MOD_MEM_REG, 0, 0,  0, (X32 | X64), RM_DST, NO_PREFIX, IMM_OPND_3, MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPMADDWD xmm1, xmm2, xmm3 / m128           VEX.128.66.0F.WIG F5 / r     B V / V AVX
//VPMADDWD ymm1, ymm2, ymm3 / m256           VEX.256.66.0F.WIG F5 / r     B V / V AVX2
//VPMADDWD xmm1{k1}{z}, xmm2, xmm3 / m128 EVEX.128.66.0F.WIG F5 / r     C V / V AVX512VL AVX512BW
//VPMADDWD ymm1{k1}{z}, ymm2, ymm3 / m256 EVEX.256.66.0F.WIG F5 / r     C V / V AVX512VL AVX512BW
//VPMADDWD zmm1{k1}{z}, zmm2, zmm3 / m512 EVEX.512.66.0F.WIG F5 / r     C V / V AVX512BW
/* ----------------------------------------------------------------------------------------------- */
{ "vpmaddwd",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0xf5, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmaddwd",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0xf5, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmaddwd",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0xf5, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmaddwd",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0xf5, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmaddwd",    3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),          1,  1, { 0xf5, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmaddwd",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),          1,  1, { 0xf5, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPMAXSB xmm1, xmm2, xmm3 / m128                    VEX.128.66.0F38.WIG 3C / r    B V / V AVX
//VPMAXSB ymm1, ymm2, ymm3 / m256                    VEX.256.66.0F38.WIG 3C / r    B V / V AVX2
//VPMAXSB xmm1{k1}{z}, xmm2,xmm3 / m128             EVEX.128.66.0F38.WIG 3C / r   C V / V AVX512VL AVX512BW
//VPMAXSB ymm1{k1}{z}, ymm2,ymm3 / m256             EVEX.256.66.0F38.WIG 3C / r   C V / V AVX512VL AVX512BW
//VPMAXSB zmm1{k1}{z}, zmm2,zmm3 / m512             EVEX.512.66.0F38.WIG 3C / r   C V / V AVX512BW
/* ----------------------------------------------------------------------------------------------- */
{ "vpmaxsb",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0x3c, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmaxsb",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0x3c, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmaxsb",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0x3c, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmaxsb",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0x3c, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmaxsb",    3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),          1,  1, { 0x3c, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmaxsb",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),          1,  1, { 0x3c, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPMAXSW xmm1, xmm2, xmm3 / m128                    VEX.128.66.0F.WIG EE / r      B V / V AVX
//VPMAXSW ymm1, ymm2, ymm3 / m256                    VEX.256.66.0F.WIG EE / r      B V / V AVX2
//VPMAXSW xmm1{k1}{z}, xmm2,xmm3 / m128             EVEX.128.66.0F.WIG EE / r     C V / V AVX512VL AVX512BW
//VPMAXSW ymm1{k1}{z}, ymm2,ymm3 / m256             EVEX.256.66.0F.WIG EE / r     C V / V AVX512VL AVX512BW
//VPMAXSW zmm1{k1}{z}, zmm2,zmm3 / m512             EVEX.512.66.0F.WIG EE / r     C V / V AVX512BW
/* ----------------------------------------------------------------------------------------------- */
{ "vpmaxsw",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0xee, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmaxsw",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0xee, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmaxsw",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0xee, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmaxsw",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0xee, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmaxsw",    3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),          1,  1, { 0xee, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmaxsw",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),          1,  1, { 0xee, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPMAXSD xmm1, xmm2, xmm3 / m128                    VEX.128.66.0F38.WIG 3D / r    B V / V AVX
//VPMAXSD ymm1, ymm2, ymm3 / m256                    VEX.256.66.0F38.WIG 3D / r    B V / V AVX2
//VPMAXSD xmm1{k1}{z}, xmm2,xmm3 / m128 / m32bcst   EVEX.128.66.0F38.W0  3D / r    D V / V AVX512VL AVX512F
//VPMAXSD ymm1{k1}{z}, ymm2,ymm3 / m256 / m32bcst   EVEX.256.66.0F38.W0  3D / r    D V / V AVX512VL AVX512F
//VPMAXSD zmm1{k1}{z}, zmm2,zmm3 / m512 / m32bcst   EVEX.512.66.0F38.W0 3D / r    D V / V AVX512F
/* ----------------------------------------------------------------------------------------------- */
{ "vpmaxsd",     3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                           1,  1, { 0x3d, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmaxsd",     3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                           1,  1, { 0x3d, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmaxsd",     3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_W0 | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),    4,  1, { 0x3d, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmaxsd",     3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                           1,  1, { 0x3d, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmaxsd",     3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                           1,  1, { 0x3d, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmaxsd",     3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_W0 | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),    8,  1, { 0x3d, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmaxsd",     3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),                 (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0x3d, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmaxsd",     3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),                 (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0x3d, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmaxsd",     3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),                 (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),    16, 1, { 0x3d, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPMAXSQ xmm1{k1}{z}, xmm2,xmm3 / m128 / m64bcst   EVEX.128.66.0F38.W1 3D / r    D V / V AVX512VL AVX512F
//VPMAXSQ ymm1{k1}{z}, ymm2,ymm3 / m256 / m64bcst   EVEX.256.66.0F38.W1 3D / r    D V / V AVX512VL AVX512F
//VPMAXSQ zmm1{k1}{z}, zmm2,zmm3 / m512 / m64bcst   EVEX.512.66.0F38.W1 3D / r    D V / V AVX512F
/* ----------------------------------------------------------------------------------------------- */
{ "vpmaxsq",     3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0x3d, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmaxsq",     3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0x3d, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmaxsq",     3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),    2,  1, { 0x3d, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmaxsq",     3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0x3d, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmaxsq",     3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0x3d, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmaxsq",     3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),    4,  1, { 0x3d, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmaxsq",     3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0x3d, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmaxsq",     3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0x3d, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmaxsq",     3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),    8,  1, { 0x3d, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPMAXUB xmm1, xmm2, xmm3 / m128          VEX.128.66.0F DE / r        B V / V AVX
//VPMAXUB ymm1, ymm2, ymm3 / m256          VEX.256.66.0F DE / r        B V / V AVX2
//VPMAXUB xmm1{k1}{z}, xmm2,xmm3 / m128 EVEX.128.66.0F.WIG DE / r    C V / V AVX512VLAVX512BW
//VPMAXUB ymm1{k1}{z}, ymm2,ymm3 / m256 EVEX.256.66.0F.WIG DE / r    C V / V AVX512VLAVX512BW
//VPMAXUB zmm1{k1}{z}, zmm2,zmm3 / m512 EVEX.512.66.0F.WIG DE / r    C V / V AVX512BW
/* ----------------------------------------------------------------------------------------------- */
{ "vpmaxub",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0xde, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmaxub",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0xde, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmaxub",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0xde, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmaxub",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0xde, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmaxub",    3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),          1,  1, { 0xde, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmaxub",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),          1,  1, { 0xde, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPMAXUW xmm1, xmm2, xmm3 / m128          VEX.128.66.0F38 3E / r      B V / V AVX
//VPMAXUW ymm1, ymm2, ymm3 / m256          VEX.256.66.0F38 3E / r      B V / V AVX2
//VPMAXUW xmm1{k1}{z}, xmm2,xmm3 / m128 EVEX.128.66.0F38.WIG 3E / r  C V / V AVX512VLAVX512BW
//VPMAXUW ymm1{k1}{z}, ymm2,ymm3 / m256 EVEX.256.66.0F38.WIG 3E / r  C V / V AVX512VLAVX512BW
//VPMAXUW zmm1{k1}{z}, zmm2,zmm3 / m512 EVEX.512.66.0F38.WIG 3E / r  C V / V AVX512BW
/* ----------------------------------------------------------------------------------------------- */
{ "vpmaxuw",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0x3e, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmaxuw",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0x3e, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmaxuw",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0x3e, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmaxuw",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0x3e, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmaxuw",    3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),          1,  1, { 0x3e, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmaxuw",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),          1,  1, { 0x3e, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPMAXUD xmm1, xmm2, xmm3 / m128                    VEX.128.66.0F38.WIG 3F / r
//VPMAXUD ymm1, ymm2, ymm3 / m256                    VEX.256.66.0F38.WIG 3F / r
//VPMAXUD xmm1{k1}{z}, xmm2,xmm3 / m128 / m32bcst EVEX.128.66.0F38.W0 3F / r
//VPMAXUD ymm1{k1}{z}, ymm2,ymm3 / m256 / m32bcst EVEX.256.66.0F38.W0 3F / r
//VPMAXUD zmm1{k1}{z}, zmm2,zmm3 / m512 / m32bcst EVEX.512.66.0F38.W0 3F / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpmaxud",     3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                           1,  1, { 0x3f, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmaxud",     3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                           1,  1, { 0x3f, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmaxud",     3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_W0 | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),    4,  1, { 0x3f, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmaxud",     3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                           1,  1, { 0x3f, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmaxud",     3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                           1,  1, { 0x3f, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmaxud",     3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_W0 | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),    8,  1, { 0x3f, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmaxud",     3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),                 (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0x3f, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmaxud",     3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),                 (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0x3f, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmaxud",     3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),                 (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),    16, 1, { 0x3f, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPMAXUQ xmm1{k1}{z}, xmm2,xmm3 / m128 / m64bcst EVEX.128.66.0F38.W1 3F / r
//VPMAXUQ ymm1{k1}{z}, ymm2,ymm3 / m256 / m64bcst EVEX.256.66.0F38.W1 3F / r
//VPMAXUQ zmm1{k1}{z}, zmm2,zmm3 / m512 / m64bcst EVEX.512.66.0F38.W1 3F / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpmaxuq",     3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0x3f, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmaxuq",     3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0x3f, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmaxuq",     3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),    2,  1, { 0x3f, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmaxuq",     3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0x3f, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmaxuq",     3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0x3f, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmaxuq",     3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),    4,  1, { 0x3f, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmaxuq",     3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0x3f, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmaxuq",     3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0x3f, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmaxuq",     3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),    8,  1, { 0x3f, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPMINUB xmm1, xmm2, xmm3 / m128         VEX.128.66.0F DA / r
//VPMINUB ymm1, ymm2, ymm3 / m256         VEX.256.66.0F DA / r
//VPMINUB xmm1{k1}{z}, xmm2,xmm3 / m128  EVEX.128.66.0F DA / r
//VPMINUB ymm1{k1}{z}, ymm2,ymm3 / m256  EVEX.256.66.0F DA / r
//VPMINUB zmm1{k1}{z}, zmm2,zmm3 / m512  EVEX.512.66.0F DA / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpminub",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0xda, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpminub",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0xda, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpminub",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0xda, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpminub",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0xda, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpminub",    3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),          1,  1, { 0xda, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpminub",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),          1,  1, { 0xda, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPMINUW xmm1, xmm2, xmm3 / m128         VEX.128.66.0F38 3A / r
//VPMINUW ymm1, ymm2, ymm3 / m256         VEX.256.66.0F38 3A / r
//VPMINUW xmm1{k1}{z}, xmm2,xmm3 / m128  EVEX.128.66.0F38 3A / r
//VPMINUW ymm1{k1}{z}, ymm2,ymm3 / m256  EVEX.256.66.0F38 3A / r
//VPMINUW zmm1{k1}{z}, zmm2,zmm3 / m512  EVEX.512.66.0F38 3A / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpminuw",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0x3a, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpminuw",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0x3a, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpminuw",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0x3a, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpminuw",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0x3a, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpminuw",    3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),          1,  1, { 0x3a, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpminuw",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),          1,  1, { 0x3a, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPMINUD xmm1, xmm2,xmm3 / m128                     VEX.128.66.0F38.WIG 3B / r
//VPMINUD ymm1, ymm2,ymm3 / m256                     VEX.256.66.0F38.WIG 3B / r
//VPMINUD xmm1{k1}{z}, xmm2,xmm3 / m128 / m32bcst EVEX.128.66.0F38.W0 3B / r
//VPMINUD ymm1{k1}{z}, ymm2,ymm3 / m256 / m32bcst EVEX.256.66.0F38.W0 3B / r
//VPMINUD zmm1{k1}{z}, zmm2,zmm3 / m512 / m32bcst EVEX.512.66.0F38.W0 3B / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpminud",     3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                           1,  1, { 0x3b, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpminud",     3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                           1,  1, { 0x3b, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpminud",     3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_W0 | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),    4,  1, { 0x3b, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpminud",     3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                           1,  1, { 0x3b, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpminud",     3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                           1,  1, { 0x3b, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpminud",     3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_W0 | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),    8,  1, { 0x3b, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpminud",     3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),                 (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0x3b, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpminud",     3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),                 (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0x3b, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpminud",     3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),                 (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),    16, 1, { 0x3b, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPMINUQ xmm1{k1}{z}, xmm2,xmm3 / m128 / m64bcst EVEX.128.66.0F38.W1 3B / r
//VPMINUQ ymm1{k1}{z}, ymm2,ymm3 / m256 / m64bcst EVEX.256.66.0F38.W1 3B / r
//VPMINUQ zmm1{k1}{z}, zmm2,zmm3 / m512 / m64bcst EVEX.512.66.0F38.W1 3B / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpminuq",     3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0x3b, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpminuq",     3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0x3b, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpminuq",     3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),    2,  1, { 0x3b, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpminuq",     3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0x3b, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpminuq",     3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0x3b, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpminuq",     3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),    4,  1, { 0x3b, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpminuq",     3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0x3b, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpminuq",     3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0x3b, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpminuq",     3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),    8,  1, { 0x3b, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPMINSB xmm1, xmm2, xmm3 / m128VEX.128.66.0F38 38 / r
//VPMINSB ymm1, ymm2, ymm3 / m256VEX.256.66.0F38 38 / r
//VPMINSB xmm1{k1}{z}, xmm2,xmm3 / m128EVEX.128.66.0F38.WIG 38 / r
//VPMINSB ymm1{k1}{z}, ymm2,ymm3 / m256EVEX.256.66.0F38.WIG 38 / r
//VPMINSB zmm1{k1}{z}, zmm2,zmm3 / m512EVEX.512.66.0F38.WIG 38 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpminsb",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0x38, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpminsb",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0x38, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpminsb",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0x38, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpminsb",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0x38, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpminsb",    3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),          1,  1, { 0x38, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpminsb",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),          1,  1, { 0x38, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPMINSW xmm1, xmm2, xmm3 / m128VEX.128.66.0F EA / r
//VPMINSW ymm1, ymm2, ymm3 / m256VEX.256.66.0F EA / r
//VPMINSW xmm1{k1}{z}, xmm2,xmm3 / m128EVEX.128.66.0F.WIG EA / r
//VPMINSW ymm1{k1}{z}, ymm2,ymm3 / m256EVEX.256.66.0F.WIG EA / r
//VPMINSW zmm1{k1}{z}, zmm2,zmm3 / m512EVEX.512.66.0F.WIG EA / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpminsw",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0xea, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpminsw",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0xea, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpminsw",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0xea, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpminsw",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),          1,  1, { 0xea, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpminsw",    3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),          1,  1, { 0xea, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpminsw",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),          1,  1, { 0xea, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPMINSD xmm1, xmm2, xmm3/m128                 VEX.128.66.0F38.WIG 39 /r
//VPMINSD ymm1, ymm2, ymm3/m256                 VEX.256.66.0F38.WIG 39 /r
//VPMINSD xmm1 {k1}{z}, xmm2,xmm3/m128/m32bcst  EVEX.128.66.0F38.W0 39 /r
//VPMINSD ymm1 {k1}{z}, ymm2,ymm3/m256/m32bcst  EVEX.256.66.0F38.W0 39 /r
//VPMINSD zmm1 {k1}{z}, zmm2,zmm3/m512/m32bcst  EVEX.512.66.0F38.W0 39 /r
/* ----------------------------------------------------------------------------------------------- */
{ "vpminxsd",     3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                           1,  1, { 0x39, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpminxsd",     3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                           1,  1, { 0x39, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpminxsd",     3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_W0 | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),    4,  1, { 0x39, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpminxsd",     3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                           1,  1, { 0x39, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpminxsd",     3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F38 | VEX_NDS | EVEX), (EVEX_W0 | EVEX_MASK | EVEX_Z),                           1,  1, { 0x39, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpminxsd",     3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_W0 | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),    8,  1, { 0x39, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpminxsd",     3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),                 (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0x39, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpminxsd",     3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),                 (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),               1,  1, { 0x39, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpminxsd",     3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),                 (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),    16, 1, { 0x39, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPMINSQ xmm1 {k1}{z}, xmm2,xmm3/m128/m64bcst  EVEX.128.66.0F38.W1 39 /r
//VPMINSQ ymm1 {k1}{z}, ymm2,ymm3/m256/m64bcst  EVEX.256.66.0F38.W1 39 /r
//VPMINSQ zmm1 {k1}{z}, zmm2,zmm3/m512/m64bcst  EVEX.512.66.0F38.W1 39 /r
/* ----------------------------------------------------------------------------------------------- */
{ "vpminsq",     3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x39, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpminsq",     3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x39, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpminsq",     3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),      2,  1, { 0x39, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpminsq",     3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x39, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpminsq",     3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x39, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpminsq",     3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),      4,  1, { 0x39, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpminsq",     3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x39, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpminsq",     3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x39, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpminsq",     3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),      8,  1, { 0x39, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPMOVMSKB reg, xmm1 VEX.128.66.0F.WIG D7 / r
//VPMOVMSKB reg, ymm1 VEX.256.66.0F.WIG D7 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpmovmskb",      2, { R32,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F2 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_W0 | EVEX_RND),			                            4,  1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vpmovmskb",      2, { R32E, R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F2 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_W0 | EVEX_RND),			                            4,  1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vpmovmskb",      2, { R64,  R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F2 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_W1 | EVEX_RND),			                            4,  1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vpmovmskb",      2, { R64E, R_XMM        }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F2 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_W1 | EVEX_RND),			                            4,  1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vpmovmskb",      2, { R32,  R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F2 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_W0 | EVEX_RND),			                            4,  1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vpmovmskb",      2, { R32E, R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F2 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_W0 | EVEX_RND),			                            4,  1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vpmovmskb",      2, { R64,  R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F2 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_W1 | EVEX_RND),			                            4,  1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
{ "vpmovmskb",      2, { R64E, R_YMM        }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_F2 | VEX_0F | VEX_WIG | VEX_2OPND | EVEX),    (EVEX_W1 | EVEX_RND),			                            4,  1, { 0x2d, 0x00, 0x00 }, 16, 1, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM, NO_MEM,             P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//vpmulhuw xmm1, xmm2, xmm3 / m128           VEX.128.66.0F.WIG E4 / r
//VPMULHUW ymm1, ymm2, ymm3 / m256           VEX.256.66.0F.WIG E4 / r
//VPMULHUW xmm1{k1}{z}, xmm2, xmm3 / m128 EVEX.128.66.0F.WIG E4 / r
//VPMULHUW ymm1{k1}{z}, ymm2, ymm3 / m256 EVEX.256.66.0F.WIG E4 / r
//VPMULHUW zmm1{k1}{z}, zmm2, zmm3 / m512 EVEX.512.66.0F.WIG E4 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpmulhuw",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                     1,  1, { 0xe4, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmulhuw",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                     1,  1, { 0xe4, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmulhuw",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                     1,  1, { 0xe4, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmulhuw",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                     1,  1, { 0xe4, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmulhuw",    3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),                     1,  1, { 0xe4, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmulhuw",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),                     1,  1, { 0xe4, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPMULHW xmm1, xmm2, xmm3 / m128           VEX.128.66.0F.WIG E5 / r
//VPMULHW ymm1, ymm2, ymm3 / m256           VEX.256.66.0F.WIG E5 / r
//VPMULHW xmm1{k1}{z}, xmm2, xmm3 / m128  EVEX.128.66.0F.WIG E5 / r
//VPMULHW ymm1{k1}{z}, ymm2, ymm3 / m256  EVEX.256.66.0F.WIG E5 / r
//VPMULHW zmm1{k1}{z}, zmm2, zmm3 / m512  EVEX.512.66.0F.WIG E5 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpmulhw",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                      1,  1, { 0xe5, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmulhw",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                      1,  1, { 0xe5, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmulhw",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                      1,  1, { 0xe5, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmulhw",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                      1,  1, { 0xe5, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmulhw",    3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),                      1,  1, { 0xe5, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmulhw",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),                      1,  1, { 0xe5, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPMULLW
/* ----------------------------------------------------------------------------------------------- */
{ "vpmullw",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                      1,  1, { 0xd5, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmullw",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                      1,  1, { 0xd5, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmullw",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                      1,  1, { 0xd5, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmullw",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                      1,  1, { 0xd5, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmullw",    3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),                      1,  1, { 0xd5, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmullw",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),                      1,  1, { 0xd5, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPMULUDQ xmm1, xmm2, xmm3 / m128VEX.128.66.0F.WIG F4 / r
//VPMULUDQ ymm1, ymm2, ymm3 / m256VEX.256.66.0F.WIG F4 / r
//VPMULUDQ xmm1{k1}{z}, xmm2,xmm3 / m128 / m64bcstEVEX.128.66.0F.W1 F4 / r
//VPMULUDQ ymm1{k1}{z}, ymm2,ymm3 / m256 / m64bcstEVEX.256.66.0F.W1 F4 / r
//VPMULUDQ zmm1{k1}{z}, zmm2,zmm3 / m512 / m64bcstEVEX.512.66.0F.W1 F4 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpmuludq",     3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                1,  1, { 0xf4, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmuludq",     3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                1,  1, { 0xf4, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmuludq",     3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),     2,  1, { 0xf4, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmuludq",     3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                1,  1, { 0xf4, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmuludq",     3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                1,  1, { 0xf4, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmuludq",     3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),     4,  1, { 0xf4, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmuludq",     3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                1,  1, { 0xf4, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpmuludq",     3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                1,  1, { 0xf4, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpmuludq",     3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),     8,  1, { 0xf4, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPOR xmm1, xmm2, xmm3 / m128                      VEX.128.66.0F.WIG EB / r
//VPOR ymm1, ymm2, ymm3 / m256                      VEX.256.66.0F.WIG EB / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpor",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (NO_EVEX),                                    1,  1, { 0xeb, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpor",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (NO_EVEX),                                    1,  1, { 0xeb, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpor",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (NO_EVEX),                                    1,  1, { 0xeb, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpor",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (NO_EVEX),                                    1,  1, { 0xeb, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPORD xmm1{k1}{z}, xmm2, xmm3 / m128 / m32bcst  EVEX.128.66.0F.W0 EB / r
//VPORD ymm1{k1}{z}, ymm2, ymm3 / m256 / m32bcst  EVEX.256.66.0F.W0 EB / r
//VPORD zmm1{k1}{z}, zmm2, zmm3 / m512 / m32bcst  EVEX.512.66.0F.W0 EB / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpord",     3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                   1,  1, { 0xeb, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpord",     3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                   1,  1, { 0xeb, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpord",     3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),        4,  1, { 0xeb, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpord",     3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                   1,  1, { 0xeb, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpord",     3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                   1,  1, { 0xeb, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpord",     3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),        8,  1, { 0xeb, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpord",     3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                   1,  1, { 0xeb, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpord",     3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                   1,  1, { 0xeb, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpord",     3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),        16, 1, { 0xeb, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPORQ xmm1{k1}{z}, xmm2, xmm3 / m128 / m64bcst  EVEX.128.66.0F.W1 EB / r
//VPORQ ymm1{k1}{z}, ymm2, ymm3 / m256 / m64bcst  EVEX.256.66.0F.W1 EB / r
//VPORQ zmm1{k1}{z}, zmm2, zmm3 / m512 / m64bcst  EVEX.512.66.0F.W1 EB / r
/* ----------------------------------------------------------------------------------------------- */
{ "vporq",     3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                   1,  1, { 0xeb, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vporq",     3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                   1,  1, { 0xeb, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vporq",     3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),        2,  1, { 0xeb, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vporq",     3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                   1,  1, { 0xeb, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vporq",     3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                   1,  1, { 0xeb, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vporq",     3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),        4,  1, { 0xeb, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vporq",     3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                   1,  1, { 0xeb, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vporq",     3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                   1,  1, { 0xeb, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vporq",     3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F38 | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),        8,  1, { 0xeb, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPSADBW xmm1, xmm2, xmm3 / m128 VEX.128.66.0F.WIG F6 / r   B V / V AVX
//VPSADBW ymm1, ymm2, ymm3 / m256 VEX.256.66.0F.WIG F6 / r   B V / V AVX2
//VPSADBW xmm1, xmm2, xmm3 / m128 EVEX.128.66.0F.WIG F6 / r  C V / V AVX512VL AVX512BW
//VPSADBW ymm1, ymm2, ymm3 / m256 EVEX.256.66.0F.WIG F6 / r  C V / V AVX512VL AVX512BW
//VPSADBW zmm1, zmm2, zmm3 / m512 EVEX.512.66.0F.WIG F6 / r  C V / V AVX512BW
/* ----------------------------------------------------------------------------------------------- */
{ "vpsadbw",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX | VEX_WIG),                          1,  1, { 0xf6, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsadbw",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX | VEX_WIG),                          1,  1, { 0xf6, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsadbw",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX | VEX_WIG),                          1,  1, { 0xf6, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsadbw",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX | VEX_WIG),                          1,  1, { 0xf6, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsadbw",    3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),             (EVEX_ONLY | VEX_WIG),                          1,  1, { 0xf6, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsadbw",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),             (EVEX_ONLY | VEX_WIG),                          1,  1, { 0xf6, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPSLLW xmm1, xmm2, xmm3 / m128                    VEX.128.66.0F.WIG F1 / r
//VPSLLW xmm1, xmm2, imm8                           VEX.128.66.0F.WIG 71 / 6 ib
//VPSLLW ymm1, ymm2, xmm3 / m128                    VEX.256.66.0F.WIG F1 / r
//VPSLLW ymm1, ymm2, imm8                           VEX.256.66.0F.WIG 71 / 6 ib
//VPSLLW xmm1{k1}{z}, xmm2, xmm3 / m128           EVEX.128.66.0F.WIG F1 / r
//VPSLLW ymm1{k1}{z}, ymm2, xmm3 / m128           EVEX.256.66.0F.WIG F1 / r
//VPSLLW zmm1{k1}{z}, zmm2, xmm3 / m128           EVEX.512.66.0F.WIG F1 / r
//VPSLLW xmm1{k1}{z}, xmm2 / m128, imm8           EVEX.128.66.0F.WIG 71 / 6 ib
//VPSLLW ymm1{k1}{z}, ymm2 / m256, imm8           EVEX.256.66.0F.WIG 71 / 6 ib
//VPSLLW zmm1{k1}{z}, zmm2 / m512, imm8           EVEX.512.66.0F.WIG 71 / 6 ib
/* ----------------------------------------------------------------------------------------------- */
{ "vpsllw",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                       1,  1, { 0xf1, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsllw",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                       1,  1, { 0xf1, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsllw",    3, { R_YMM,  R_YMM, R_XMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                       1,  1, { 0xf1, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsllw",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                       1,  1, { 0xf1, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsllw",    3, { R_ZMM,  R_ZMM, R_XMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),                       1,  1, { 0xf1, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsllw",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),                       1,  1, { 0xf1, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsllw",    3, { R_XMM,  R_XMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_WIG | EVEX_MASK | EVEX_Z),                        1,  1, { 0x71, 0xf0, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsllw",    3, { R_XMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_WIG | EVEX_MASK | EVEX_Z),                        1,  1, { 0x71, 0x30, 0x00 }, 16, 2, 0x30,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsllw",    3, { R_YMM,  R_YMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_WIG | EVEX_MASK | EVEX_Z),                        1,  1, { 0x71, 0xf0, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsllw",    3, { R_YMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_WIG | EVEX_MASK | EVEX_Z),                        1,  1, { 0x71, 0x30, 0x00 }, 32, 2, 0x30,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsllw",    3, { R_ZMM,  R_ZMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (EVEX_ONLY | VEX_WIG | EVEX_MASK | EVEX_Z),            1,  1, { 0x71, 0xf0, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsllw",    3, { R_ZMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (EVEX_ONLY | VEX_WIG | EVEX_MASK | EVEX_Z),            1,  1, { 0x71, 0x30, 0x00 }, 64, 2, 0x30,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPSLLD xmm1, xmm2, xmm3 / m128                    VEX.128.66.0F.WIG F2 / r
//VPSLLD xmm1, xmm2, imm8                           VEX.128.66.0F.WIG 72 / 6 ib
//VPSLLD ymm1, ymm2, xmm3 / m128                    VEX.256.66.0F.WIG F2 / r
//VPSLLD ymm1, ymm2, imm8                           VEX.256.66.0F.WIG 72 / 6 ib
//VPSLLD xmm1{k1}{z}, xmm2, xmm3 / m128           EVEX.128.66.0F.W0 F2 / r
//VPSLLD ymm1{k1}{z}, ymm2, xmm3 / m128           EVEX.256.66.0F.W0 F2 / r
//VPSLLD zmm1{k1}{z}, zmm2, xmm3 / m128           EVEX.512.66.0F.W0 F2 / r
//VPSLLD xmm1{k1}{z}, xmm2 / m128 / m32bcst,imm8  EVEX.128.66.0F.W0 72 / 6 ib
//VPSLLD ymm1{k1}{z}, ymm2 / m256 / m32bcst,imm8  EVEX.256.66.0F.W0 72 / 6 ib
//VPSLLD zmm1{k1}{z}, zmm2 / m512 / m32bcst,imm8  EVEX.512.66.0F.W0 72 / 6 ib
/* ----------------------------------------------------------------------------------------------- */
{ "vpslld",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (VEX_W0 | EVEX_MASK | EVEX_Z),              1,  1, { 0xf2, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpslld",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (VEX_W0 | EVEX_MASK | EVEX_Z),              1,  1, { 0xf2, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpslld",    3, { R_YMM,  R_YMM, R_XMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (VEX_W0 | EVEX_MASK | EVEX_Z),              1,  1, { 0xf2, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpslld",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (VEX_W0 | EVEX_MASK | EVEX_Z),              1,  1, { 0xf2, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpslld",    3, { R_ZMM,  R_ZMM, R_XMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_W0 | VEX_66 | VEX_0F | VEX_NDS),       (EVEX_ONLY | VEX_W0 | EVEX_MASK | EVEX_Z),              1,  1, { 0xf2, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpslld",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_W0 | VEX_66 | VEX_0F | VEX_NDS),       (EVEX_ONLY | VEX_W0 | EVEX_MASK | EVEX_Z),              1,  1, { 0xf2, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpslld",    3, { R_XMM,  R_XMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W0 | EVEX_MASK | EVEX_Z),                         1,  1, { 0x72, 0xf0, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpslld",    3, { R_XMM,  M128,   IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W0 | EVEX_MASK | EVEX_Z),                         1,  1, { 0x72, 0x30, 0x00 }, 16, 2, 0x30,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpslld",    3, { R_XMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),              4,  1, { 0x72, 0x30, 0x00 }, 16, 2, 0x30,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpslld",    3, { R_YMM,  R_YMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W0 | EVEX_MASK | EVEX_Z),                         1,  1, { 0x72, 0xf0, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpslld",    3, { R_YMM,  M256,   IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W0 | EVEX_MASK | EVEX_Z),                         1,  1, { 0x72, 0x30, 0x00 }, 32, 2, 0x30,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpslld",    3, { R_YMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),              8,  1, { 0x72, 0x30, 0x00 }, 32, 2, 0x30,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpslld",    3, { R_ZMM,  R_ZMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (EVEX_ONLY | VEX_W0 | EVEX_MASK | EVEX_Z),             1,  1, { 0x72, 0xf0, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpslld",    3, { R_ZMM,  M512,   IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (EVEX_ONLY | VEX_W0 | EVEX_MASK | EVEX_Z),             1,  1, { 0x72, 0x30, 0x00 }, 64, 2, 0x30,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpslld",    3, { R_ZMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (EVEX_ONLY | VEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),  16, 1, { 0x72, 0x30, 0x00 }, 64, 2, 0x30,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPSLLQ xmm1, xmm2, xmm3 / m128                    VEX.128.66.0F.WIG F3 / r
//VPSLLQ xmm1, xmm2, imm8                           VEX.128.66.0F.WIG 73 / 6 ib
//VPSLLQ ymm1, ymm2, xmm3 / m128                    VEX.256.66.0F.WIG F3 / r
//VPSLLQ ymm1, ymm2, imm8                           VEX.256.66.0F.WIG 73 / 6 ib
//VPSLLQ xmm1{k1}{z}, xmm2, xmm3 / m128           EVEX.128.66.0F.W1 F3 / r
//VPSLLQ ymm1{k1}{z}, ymm2, xmm3 / m128           EVEX.256.66.0F.W1 F3 / r
//VPSLLQ zmm1{k1}{z}, zmm2, xmm3 / m128           EVEX.512.66.0F.W1 F3 / r
//VPSLLQ xmm1{k1}{z}, xmm2 / m128 / m64bcst,imm8  EVEX.128.66.0F.W1 73 / 6 ib
//VPSLLQ ymm1{k1}{z}, ymm2 / m256 / m64bcst,imm8  EVEX.256.66.0F.W1 73 / 6 ib
//VPSLLQ zmm1{k1}{z}, zmm2 / m512 / m64bcst,imm8  EVEX.512.66.0F.W1 73 / 6 ib
/* ----------------------------------------------------------------------------------------------- */
{ "vpsllq",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (VEX_W1 | EVEX_MASK | EVEX_Z),              1,  1, { 0xf3, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsllq",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (VEX_W1 | EVEX_MASK | EVEX_Z),              1,  1, { 0xf3, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsllq",    3, { R_YMM,  R_YMM, R_XMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (VEX_W1 | EVEX_MASK | EVEX_Z),              1,  1, { 0xf3, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsllq",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (VEX_W1 | EVEX_MASK | EVEX_Z),              1,  1, { 0xf3, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsllq",    3, { R_ZMM,  R_ZMM, R_XMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_W1 | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | VEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0xf3, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsllq",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_W1 | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | VEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0xf3, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsllq",    3, { R_XMM,  R_XMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W1 | EVEX_MASK | EVEX_Z),                         1,  1, { 0x73, 0xf0, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsllq",    3, { R_XMM,  M128,   IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W1 | EVEX_MASK | EVEX_Z),                         1,  1, { 0x73, 0x30, 0x00 }, 16, 2, 0x30,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsllq",    3, { R_XMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),              2,  1, { 0x73, 0x30, 0x00 }, 16, 2, 0x30,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsllq",    3, { R_YMM,  R_YMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W1 | EVEX_MASK | EVEX_Z),                         1,  1, { 0x73, 0xf0, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsllq",    3, { R_YMM,  M256,   IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W1 | EVEX_MASK | EVEX_Z),                         1,  1, { 0x73, 0x30, 0x00 }, 32, 2, 0x30,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsllq",    3, { R_YMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),              4,  1, { 0x73, 0x30, 0x00 }, 32, 2, 0x30,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsllq",    3, { R_ZMM,  R_ZMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (EVEX_ONLY | VEX_W1 | EVEX_MASK | EVEX_Z),             1,  1, { 0x73, 0xf0, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsllq",    3, { R_ZMM,  M512,   IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (EVEX_ONLY | VEX_W1 | EVEX_MASK | EVEX_Z),             1,  1, { 0x73, 0x30, 0x00 }, 64, 2, 0x30,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsllq",    3, { R_ZMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (EVEX_ONLY | VEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),  8,  1, { 0x73, 0x30, 0x00 }, 64, 2, 0x30,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPSRAW xmm1, xmm2, xmm3 / m128                   VEX.128.66.0F.WIG E1 / r
//VPSRAW xmm1, xmm2, imm8                          VEX.128.66.0F.WIG 71 / 4 ib
//VPSRAW ymm1, ymm2, xmm3 / m128                   VEX.256.66.0F.WIG E1 / r
//VPSRAW ymm1, ymm2, imm8                          VEX.256.66.0F.WIG 71 / 4 ib
//VPSRAW xmm1{k1}{z}, xmm2, xmm3 / m128           EVEX.128.66.0F.WIG E1 / r
//VPSRAW ymm1{k1}{z}, ymm2, xmm3 / m128           EVEX.256.66.0F.WIG E1 / r
//VPSRAW zmm1{k1}{z}, zmm2, xmm3 / m128           EVEX.512.66.0F.WIG E1 / r
//VPSRAW xmm1{k1}{z}, xmm2 / m128, imm8           EVEX.128.66.0F.WIG 71 / 4 ib
//VPSRAW ymm1{k1}{z}, ymm2 / m256, imm8           EVEX.256.66.0F.WIG 71 / 4 ib
//VPSRAW zmm1{k1}{z}, zmm2 / m512, imm8           EVEX.512.66.0F.WIG 71 / 4 ib
/* ----------------------------------------------------------------------------------------------- */
{ "vpsraw",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                       1,  1, { 0xe1, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsraw",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                       1,  1, { 0xe1, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsraw",    3, { R_YMM,  R_YMM, R_XMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                       1,  1, { 0xe1, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsraw",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                       1,  1, { 0xe1, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsraw",    3, { R_ZMM,  R_ZMM, R_XMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),                       1,  1, { 0xe1, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsraw",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),                       1,  1, { 0xe1, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsraw",    3, { R_XMM,  R_XMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_WIG | EVEX_MASK | EVEX_Z),                        1,  1, { 0x71, 0xe0, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsraw",    3, { R_XMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_WIG | EVEX_MASK | EVEX_Z),                        1,  1, { 0x71, 0x20, 0x00 }, 16, 2, 0x20,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsraw",    3, { R_YMM,  R_YMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_WIG | EVEX_MASK | EVEX_Z),                        1,  1, { 0x71, 0xe0, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsraw",    3, { R_YMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_WIG | EVEX_MASK | EVEX_Z),                        1,  1, { 0x71, 0x20, 0x00 }, 32, 2, 0x20,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsraw",    3, { R_ZMM,  R_ZMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (EVEX_ONLY | VEX_WIG | EVEX_MASK | EVEX_Z),            1,  1, { 0x71, 0xe0, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsraw",    3, { R_ZMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (EVEX_ONLY | VEX_WIG | EVEX_MASK | EVEX_Z),            1,  1, { 0x71, 0x20, 0x00 }, 64, 2, 0x20,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPSRAD xmm1, xmm2, xmm3 / m128VEX.128.66.0F.WIG E2 / r
//VPSRAD xmm1, xmm2, imm8VEX.128.66.0F.WIG 72 / 4 ib
//VPSRAD ymm1, ymm2, xmm3 / m128VEX.256.66.0F.WIG E2 / r
//VPSRAD ymm1, ymm2, imm8VEX.256.66.0F.WIG 72 / 4 ib
//VPSRAD xmm1{k1}{z}, xmm2, xmm3 / m128EVEX.128.66.0F.W0 E2 / r
//VPSRAD ymm1{k1}{z}, ymm2, xmm3 / m128EVEX.256.66.0F.W0 E2 / r
//VPSRAD zmm1{k1}{z}, zmm2, xmm3 / m128EVEX.512.66.0F.W0 E2 / r
//VPSRAD xmm1{k1}{z}, xmm2 / m128 / m32bcst,imm8EVEX.128.66.0F.W0 72 / 4 ib
//VPSRAD ymm1{k1}{z}, ymm2 / m256 / m32bcst,imm8EVEX.256.66.0F.W0 72 / 4 ib
//VPSRAD zmm1{k1}{z}, zmm2 / m512 / m32bcst,imm8EVEX.512.66.0F.W0 72 / 4 ib
/* ----------------------------------------------------------------------------------------------- */
{ "vpsrad",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (VEX_W0 | EVEX_MASK | EVEX_Z),              1,  1, { 0xe2, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsrad",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (VEX_W0 | EVEX_MASK | EVEX_Z),              1,  1, { 0xe2, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsrad",    3, { R_YMM,  R_YMM, R_XMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (VEX_W0 | EVEX_MASK | EVEX_Z),              1,  1, { 0xe2, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsrad",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (VEX_W0 | EVEX_MASK | EVEX_Z),              1,  1, { 0xe2, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsrad",    3, { R_ZMM,  R_ZMM, R_XMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_W0 | VEX_66 | VEX_0F | VEX_NDS),       (EVEX_ONLY | VEX_W0 | EVEX_MASK | EVEX_Z),              1,  1, { 0xe2, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsrad",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_W0 | VEX_66 | VEX_0F | VEX_NDS),       (EVEX_ONLY | VEX_W0 | EVEX_MASK | EVEX_Z),              1,  1, { 0xe2, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsrad",    3, { R_XMM,  R_XMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W0 | EVEX_MASK | EVEX_Z),                         1,  1, { 0x72, 0xe0, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsrad",    3, { R_XMM,  M128,   IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W0 | EVEX_MASK | EVEX_Z),                         1,  1, { 0x72, 0x20, 0x00 }, 16, 2, 0x20,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsrad",    3, { R_XMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),              4,  1, { 0x72, 0x20, 0x00 }, 16, 2, 0x20,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsrad",    3, { R_YMM,  R_YMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W0 | EVEX_MASK | EVEX_Z),                         1,  1, { 0x72, 0xe0, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsrad",    3, { R_YMM,  M256,   IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W0 | EVEX_MASK | EVEX_Z),                         1,  1, { 0x72, 0x20, 0x00 }, 32, 2, 0x20,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsrad",    3, { R_YMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),              8,  1, { 0x72, 0x20, 0x00 }, 32, 2, 0x20,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsrad",    3, { R_ZMM,  R_ZMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (EVEX_ONLY | VEX_W0 | EVEX_MASK | EVEX_Z),             1,  1, { 0x72, 0xe0, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsrad",    3, { R_ZMM,  M512,   IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (EVEX_ONLY | VEX_W0 | EVEX_MASK | EVEX_Z),             1,  1, { 0x72, 0x20, 0x00 }, 64, 2, 0x20,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsrad",    3, { R_ZMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (EVEX_ONLY | VEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),  16, 1, { 0x72, 0x20, 0x00 }, 64, 2, 0x20,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPSRAQ xmm1{k1}{z}, xmm2, xmm3 / m128EVEX.128.66.0F.W1 E2 / r
//VPSRAQ ymm1{k1}{z}, ymm2, xmm3 / m128EVEX.256.66.0F.W1 E2 / r
//VPSRAQ zmm1{k1}{z}, zmm2, xmm3 / m128EVEX.512.66.0F.W1 E2 / r
//VPSRAQ xmm1{k1}{z}, xmm2 / m128 / m64bcst,imm8EVEX.128.66.0F.W1 72 / 4 ib
//VPSRAQ ymm1{k1}{z}, ymm2 / m256 / m64bcst,imm8EVEX.256.66.0F.W1 72 / 4 ib
//VPSRAQ zmm1{k1}{z}, zmm2 / m512 / m64bcst,imm8EVEX.512.66.0F.W1 72 / 4 ib
/* ----------------------------------------------------------------------------------------------- */
{ "vpsraq",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (VEX_W1 | EVEX_MASK | EVEX_Z),              1,  1, { 0xe2, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsraq",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (VEX_W1 | EVEX_MASK | EVEX_Z),              1,  1, { 0xe2, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsraq",    3, { R_YMM,  R_YMM, R_XMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (VEX_W1 | EVEX_MASK | EVEX_Z),              1,  1, { 0xe2, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsraq",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (VEX_W1 | EVEX_MASK | EVEX_Z),              1,  1, { 0xe2, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsraq",    3, { R_ZMM,  R_ZMM, R_XMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_W1 | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | VEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0xe2, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsraq",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_W1 | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | VEX_W1 | EVEX_MASK | EVEX_Z),               1,  1, { 0xe2, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsraq",    3, { R_XMM,  R_XMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W1 | EVEX_MASK | EVEX_Z),                         1,  1, { 0x72, 0xe0, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsraq",    3, { R_XMM,  M128,   IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W1 | EVEX_MASK | EVEX_Z),                         1,  1, { 0x72, 0x20, 0x00 }, 16, 2, 0x20,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsraq",    3, { R_XMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),              2,  1, { 0x72, 0x20, 0x00 }, 16, 2, 0x20,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsraq",    3, { R_YMM,  R_YMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W1 | EVEX_MASK | EVEX_Z),                         1,  1, { 0x72, 0xe0, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsraq",    3, { R_YMM,  M256,   IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W1 | EVEX_MASK | EVEX_Z),                         1,  1, { 0x72, 0x20, 0x00 }, 32, 2, 0x20,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsraq",    3, { R_YMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),              4,  1, { 0x72, 0x20, 0x00 }, 32, 2, 0x20,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsraq",    3, { R_ZMM,  R_ZMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (EVEX_ONLY | VEX_W1 | EVEX_MASK | EVEX_Z),             1,  1, { 0x72, 0xe0, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsraq",    3, { R_ZMM,  M512,   IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (EVEX_ONLY | VEX_W1 | EVEX_MASK | EVEX_Z),             1,  1, { 0x72, 0x20, 0x00 }, 64, 2, 0x20,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsraq",    3, { R_ZMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (EVEX_ONLY | VEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),  8,  1, { 0x72, 0x20, 0x00 }, 64, 2, 0x20,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPSRLW xmm1, xmm2, xmm3 / m128VEX.128.66.0F.WIG D1 / r
//VPSRLW xmm1, xmm2, imm8VEX.128.66.0F.WIG 71 / 2 ib
//VPSRLW ymm1, ymm2, xmm3 / m128VEX.256.66.0F.WIG D1 / r
//VPSRLW ymm1, ymm2, imm8VEX.256.66.0F.WIG 71 / 2 ib
//VPSRLW xmm1{k1}{z}, xmm2, xmm3 / m128EVEX.128.66.0F.WIG D1 / r
//VPSRLW ymm1{k1}{z}, ymm2, xmm3 / m128EVEX.256.66.0F.WIG D1 / r
//VPSRLW zmm1{k1}{z}, zmm2, xmm3 / m128EVEX.512.66.0F.WIG D1 / r
//VPSRLW xmm1{k1}{z}, xmm2 / m128, imm8EVEX.128.66.0F.WIG 71 / 2 ib
//VPSRLW ymm1{k1}{z}, ymm2 / m256, imm8EVEX.256.66.0F.WIG 71 / 2 ib
//VPSRLW zmm1{k1}{z}, zmm2 / m512, imm8EVEX.512.66.0F.WIG 71 / 2 ib
/* ----------------------------------------------------------------------------------------------- */
{ "vpsrlw",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                       1,  1, { 0xd1, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsrlw",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                       1,  1, { 0xd1, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsrlw",    3, { R_YMM,  R_YMM, R_XMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                       1,  1, { 0xd1, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsrlw",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                       1,  1, { 0xd1, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsrlw",    3, { R_ZMM,  R_ZMM, R_XMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),                       1,  1, { 0xd1, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsrlw",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | EVEX_MASK | EVEX_Z),                       1,  1, { 0xd1, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsrlw",    3, { R_XMM,  R_XMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_WIG | EVEX_MASK | EVEX_Z),                        1,  1, { 0x71, 0xd0, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsrlw",    3, { R_XMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_WIG | EVEX_MASK | EVEX_Z),                        1,  1, { 0x71, 0x10, 0x00 }, 16, 2, 0x10,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsrlw",    3, { R_YMM,  R_YMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_WIG | EVEX_MASK | EVEX_Z),                        1,  1, { 0x71, 0xd0, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsrlw",    3, { R_YMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_WIG | EVEX_MASK | EVEX_Z),                        1,  1, { 0x71, 0x10, 0x00 }, 32, 2, 0x10,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsrlw",    3, { R_ZMM,  R_ZMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (EVEX_ONLY | VEX_WIG | EVEX_MASK | EVEX_Z),            1,  1, { 0x71, 0xd0, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsrlw",    3, { R_ZMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (EVEX_ONLY | VEX_WIG | EVEX_MASK | EVEX_Z),            1,  1, { 0x71, 0x10, 0x00 }, 64, 2, 0x10,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPSRLD xmm1, xmm2, xmm3 / m128VEX.128.66.0F.WIG D2 / r
//VPSRLD xmm1, xmm2, imm8VEX.128.66.0F.WIG 72 / 2 ib
//VPSRLD ymm1, ymm2, xmm3 / m128VEX.256.66.0F.WIG D2 / r
//VPSRLD ymm1, ymm2, imm8VEX.256.66.0F.WIG 72 / 2 ib
//VPSRLD xmm1{k1}{z}, xmm2, xmm3 / m128EVEX.128.66.0F.W0 D2 / r
//VPSRLD ymm1{k1}{z}, ymm2, xmm3 / m128EVEX.256.66.0F.W0 D2 / r
//VPSRLD zmm1{k1}{z}, zmm2, xmm3 / m128EVEX.512.66.0F.W0 D2 / r
//VPSRLD xmm1{k1}{z}, xmm2 / m128 / m32bcst,imm8EVEX.128.66.0F.W0 72 / 2 ib
//VPSRLD ymm1{k1}{z}, ymm2 / m256 / m32bcst,imm8EVEX.256.66.0F.W0 72 / 2 ib
//VPSRLD zmm1{k1}{z}, zmm2 / m512 / m32bcst,imm8EVEX.512.66.0F.W0 72 / 2 ib
/* ----------------------------------------------------------------------------------------------- */
{ "vpsrld",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (VEX_W0 | EVEX_MASK | EVEX_Z),            1,  1, { 0xd2, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsrld",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (VEX_W0 | EVEX_MASK | EVEX_Z),            1,  1, { 0xd2, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsrld",    3, { R_YMM,  R_YMM, R_XMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (VEX_W0 | EVEX_MASK | EVEX_Z),            1,  1, { 0xd2, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsrld",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (VEX_W0 | EVEX_MASK | EVEX_Z),            1,  1, { 0xd2, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsrld",    3, { R_ZMM,  R_ZMM, R_XMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_W0 | VEX_66 | VEX_0F | VEX_NDS),       (EVEX_ONLY | VEX_W0 | EVEX_MASK | EVEX_Z),            1,  1, { 0xd2, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsrld",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_W0 | VEX_66 | VEX_0F | VEX_NDS),       (EVEX_ONLY | VEX_W0 | EVEX_MASK | EVEX_Z),            1,  1, { 0xd2, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsrld",    3, { R_XMM,  R_XMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W0 | EVEX_MASK | EVEX_Z),                       1,  1, { 0x72, 0xd0, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsrld",    3, { R_XMM,  M128,   IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W0 | EVEX_MASK | EVEX_Z),                       1,  1, { 0x72, 0x10, 0x00 }, 16, 2, 0x10,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsrld",    3, { R_XMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),            4,  1, { 0x72, 0x10, 0x00 }, 16, 2, 0x10,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsrld",    3, { R_YMM,  R_YMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W0 | EVEX_MASK | EVEX_Z),                       1,  1, { 0x72, 0xd0, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsrld",    3, { R_YMM,  M256,   IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W0 | EVEX_MASK | EVEX_Z),                       1,  1, { 0x72, 0x10, 0x00 }, 32, 2, 0x10,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsrld",    3, { R_YMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),            8,  1, { 0x72, 0x10, 0x00 }, 32, 2, 0x10,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsrld",    3, { R_ZMM,  R_ZMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (EVEX_ONLY | VEX_W0 | EVEX_MASK | EVEX_Z),           1,  1, { 0x72, 0xd0, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsrld",    3, { R_ZMM,  M512,   IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (EVEX_ONLY | VEX_W0 | EVEX_MASK | EVEX_Z),           1,  1, { 0x72, 0x10, 0x00 }, 64, 2, 0x10,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsrld",    3, { R_ZMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (EVEX_ONLY | VEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),16, 1, { 0x72, 0x10, 0x00 }, 64, 2, 0x10,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPSRLQ xmm1, xmm2, xmm3 / m128VEX.128.66.0F.WIG D3 / r
//VPSRLQ xmm1, xmm2, imm8VEX.128.66.0F.WIG 73 / 2 ib
//VPSRLQ ymm1, ymm2, xmm3 / m128VEX.256.66.0F.WIG D3 / r
//VPSRLQ ymm1, ymm2, imm8VEX.256.66.0F.WIG 73 / 2 ib
//VPSRLQ xmm1{k1}{z}, xmm2, xmm3 / m128EVEX.128.66.0F.W1 D3 / r
//VPSRLQ ymm1{k1}{z}, ymm2, xmm3 / m128EVEX.256.66.0F.W1 D3 / r
//VPSRLQ zmm1{k1}{z}, zmm2, xmm3 / m128EVEX.512.66.0F.W1 D3 / r
//VPSRLQ xmm1{k1}{z}, xmm2 / m128 / m64bcst,imm8EVEX.128.66.0F.W1 73 / 2 ib
//VPSRLQ ymm1{k1}{z}, ymm2 / m256 / m64bcst,imm8EVEX.256.66.0F.W1 73 / 2 ib
//VPSRLQ zmm1{k1}{z}, zmm2 / m512 / m64bcst,imm8EVEX.512.66.0F.W1 73 / 2 ib
/* ----------------------------------------------------------------------------------------------- */
{ "vpsrlq",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (VEX_W1 | EVEX_MASK | EVEX_Z),            1,  1, { 0xd3, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsrlq",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (VEX_W1 | EVEX_MASK | EVEX_Z),            1,  1, { 0xd3, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsrlq",    3, { R_YMM,  R_YMM, R_XMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (VEX_W1 | EVEX_MASK | EVEX_Z),            1,  1, { 0xd3, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsrlq",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (VEX_W1 | EVEX_MASK | EVEX_Z),            1,  1, { 0xd3, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsrlq",    3, { R_ZMM,  R_ZMM, R_XMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_W1 | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | VEX_W1 | EVEX_MASK | EVEX_Z),             1,  1, { 0xd3, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsrlq",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_W1 | VEX_66 | VEX_0F | VEX_NDS),      (EVEX_ONLY | VEX_W1 | EVEX_MASK | EVEX_Z),             1,  1, { 0xd3, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsrlq",    3, { R_XMM,  R_XMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W1 | EVEX_MASK | EVEX_Z),                       1,  1, { 0x73, 0xd0, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsrlq",    3, { R_XMM,  M128,   IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W1 | EVEX_MASK | EVEX_Z),                       1,  1, { 0x73, 0x10, 0x00 }, 16, 2, 0x10,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsrlq",    3, { R_XMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),            2,  1, { 0x73, 0x10, 0x00 }, 16, 2, 0x10,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsrlq",    3, { R_YMM,  R_YMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W1 | EVEX_MASK | EVEX_Z),                       1,  1, { 0x73, 0xd0, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsrlq",    3, { R_YMM,  M256,   IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W1 | EVEX_MASK | EVEX_Z),                       1,  1, { 0x73, 0x10, 0x00 }, 32, 2, 0x10,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsrlq",    3, { R_YMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),            4,  1, { 0x73, 0x10, 0x00 }, 32, 2, 0x10,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsrlq",    3, { R_ZMM,  R_ZMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (EVEX_ONLY | VEX_W1 | EVEX_MASK | EVEX_Z),           1,  1, { 0x73, 0xd0, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsrlq",    3, { R_ZMM,  M512,   IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (EVEX_ONLY | VEX_W1 | EVEX_MASK | EVEX_Z),           1,  1, { 0x73, 0x10, 0x00 }, 64, 2, 0x10,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsrlq",    3, { R_ZMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (EVEX_ONLY | VEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),8,  1, { 0x73, 0x10, 0x00 }, 64, 2, 0x10,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPSLLDQ xmm1, xmm2, imm8         VEX.128.66.0F.WIG 73 / 7 ib
//VPSLLDQ ymm1, ymm2, imm8         VEX.256.66.0F.WIG 73 / 7 ib
//VPSLLDQ xmm1, xmm2 / m128, imm8 EVEX.128.66.0F.WIG 73 / 7 ib
//VPSLLDQ ymm1, ymm2 / m256, imm8 EVEX.256.66.0F.WIG 73 / 7 ib
//VPSLLDQ zmm1, zmm2 / m512, imm8 EVEX.512.66.0F.WIG 73 / 7 ib
/* ----------------------------------------------------------------------------------------------- */
{ "vpslldq",    3, { R_XMM,  R_XMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_WIG),                                           1,  1, { 0x73, 0xf8, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpslldq",    3, { R_XMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_WIG),                                           1,  1, { 0x73, 0x38, 0x00 }, 16, 2, 0x38,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpslldq",    3, { R_YMM,  R_YMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_WIG),                                           1,  1, { 0x73, 0xf8, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpslldq",    3, { R_YMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_WIG),                                           1,  1, { 0x73, 0x38, 0x00 }, 32, 2, 0x38,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpslldq",    3, { R_ZMM,  R_ZMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (EVEX_ONLY | VEX_WIG),                               1,  1, { 0x73, 0xf8, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpslldq",    3, { R_ZMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (EVEX_ONLY | VEX_WIG),                               1,  1, { 0x73, 0x38, 0x00 }, 64, 2, 0x38,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPSRLDQ xmm1, xmm2, imm8         VEX.128.66.0F.WIG 73 / 3 ib
//VPSRLDQ ymm1, ymm2, imm8         VEX.256.66.0F.WIG 73 / 3 ib
//VPSRLDQ xmm1, xmm2 / m128, imm8 EVEX.128.66.0F.WIG 73 / 3 ib
//VPSRLDQ ymm1, ymm2 / m256, imm8 EVEX.256.66.0F.WIG 73 / 3 ib
//VPSRLDQ zmm1, zmm2 / m512, imm8 EVEX.512.66.0F.WIG 73 / 3 ib
/* ----------------------------------------------------------------------------------------------- */
{ "vpsrldq",    3, { R_XMM,  R_XMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_WIG),                                           1,  1, { 0x73, 0xd8, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsrldq",    3, { R_XMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_WIG),                                           1,  1, { 0x73, 0x18, 0x00 }, 16, 2, 0x18,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsrldq",    3, { R_YMM,  R_YMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_WIG),                                           1,  1, { 0x73, 0xd8, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsrldq",    3, { R_YMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (VEX_WIG),                                           1,  1, { 0x73, 0x18, 0x00 }, 32, 2, 0x18,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
{ "vpsrldq",    3, { R_ZMM,  R_ZMM,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (EVEX_ONLY | VEX_WIG),                               1,  1, { 0x73, 0xd8, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsrldq",    3, { R_ZMM,  M_ANY,  IMM8         }, EVX0, (F_OPCODE2_REG2) | IMM8_ONLY,                    (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDD | EVEX), (EVEX_ONLY | VEX_WIG),                               1,  1, { 0x73, 0x18, 0x00 }, 64, 2, 0x18,        0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_2, MEM_OPND_1, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPSUBB xmm1, xmm2, xmm3 / m128             VEX.128.66.0F.WIG F8 / r
//VPSUBB ymm1, ymm2, ymm3 / m256             VEX.256.66.0F.WIG F8 / r
//VPSUBB xmm1{k1}{z}, xmm2, xmm3 / m128   EVEX.128.66.0F.WIG F8 / r
//VPSUBB ymm1{k1}{z}, ymm2, ymm3 / m256   EVEX.256.66.0F.WIG F8 / r
//VPSUBB zmm1{k1}{z}, zmm2, zmm3 / m512   EVEX.512.66.0F.WIG F8 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpsubb",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                       1,  1, { 0xf8, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsubb",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                       1,  1, { 0xf8, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsubb",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                       1,  1, { 0xf8, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsubb",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                       1,  1, { 0xf8, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsubb",    3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_ONLY | EVEX_MASK | EVEX_Z),           1,  1, { 0xf8, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsubb",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_ONLY | EVEX_MASK | EVEX_Z),           1,  1, { 0xf8, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPSUBW xmm1, xmm2, xmm3 / m128           VEX.128.66.0F.WIG F9 / r
//VPSUBW ymm1,ymm2, ymm3 / m256            VEX.256.66.0F.WIG F9 / r
//VPSUBW xmm1{k1}{z}, xmm2, xmm3 / m128   EVEX.128.66.0F.WIG F9 / r
//VPSUBW ymm1{k1}{z}, ymm2, ymm3 / m256   EVEX.256.66.0F.WIG F9 / r
//VPSUBW zmm1{k1}{z}, zmm2, zmm3 / m512   EVEX.512.66.0F.WIG F9 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpsubw",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                         1,  1, { 0xf9, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsubw",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                         1,  1, { 0xf9, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsubw",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                         1,  1, { 0xf9, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsubw",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                         1,  1, { 0xf9, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsubw",    3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_ONLY | EVEX_MASK | EVEX_Z),             1,  1, { 0xf9, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsubw",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_ONLY | EVEX_MASK | EVEX_Z),             1,  1, { 0xf9, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPSUBD xmm1, xmm2, xmm3 / m128                   VEX.128.66.0F.WIG FA / r
//VPSUBD ymm1, ymm2, ymm3 / m256                   VEX.256.66.0F.WIG FA / r
//VPSUBD xmm1{k1}{z}, xmm2, xmm3 / m128 / m32bcst EVEX.128.66.0F.W0 FA / r
//VPSUBD ymm1{k1}{z}, ymm2, ymm3 / m256 / m32bcst EVEX.256.66.0F.W0 FA / r
//VPSUBD zmm1{k1}{z}, zmm2, zmm3 / m512 / m32bcst EVEX.512.66.0F.W0 FA / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpsubd",     3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z),                       1,  1, { 0xfa, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsubd",     3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z),                       1,  1, { 0xfa, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsubd",     3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),            4,  1, { 0xfa, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsubd",     3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z),                       1,  1, { 0xfa, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsubd",     3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z),                       1,  1, { 0xfa, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsubd",     3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),            8,  1, { 0xfa, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsubd",     3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),                    1,  1, { 0xfa, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsubd",     3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),                    1,  1, { 0xfa, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsubd",     3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),         16, 1, { 0xfa, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPSUBQ xmm1, xmm2, xmm3 / m128VEX.128.66.0F.WIG FB / r
//VPSUBQ ymm1, ymm2, ymm3 / m256VEX.256.66.0F.WIG FB / r
//VPSUBQ xmm1{k1}{z}, xmm2, xmm3 / m128 / m64bcstEVEX.128.66.0F.W1 FB / r
//VPSUBQ ymm1{k1}{z}, ymm2, ymm3 / m256 / m64bcstEVEX.256.66.0F.W1 FB / r
//VPSUBQ zmm1{k1}{z}, zmm2, zmm3 / m512 / m64bcstEVEX.512.66.0F.W1 FB / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpsubq",     3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z),                       1,  1, { 0xfb, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsubq",     3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z),                       1,  1, { 0xfb, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsubq",     3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),            2,  1, { 0xfb, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsubq",     3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z),                       1,  1, { 0xfb, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsubq",     3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z),                       1,  1, { 0xfb, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsubq",     3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),            4,  1, { 0xfb, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsubq",     3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                    1,  1, { 0xfb, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsubq",     3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                    1,  1, { 0xfb, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsubq",     3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),         8,  1, { 0xfb, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPSUBSB xmm1, xmm2, xmm3 / m128           VEX.128.66.0F.WIG E8 / r
//VPSUBSB ymm1, ymm2, ymm3 / m256           VEX.256.66.0F.WIG E8 / r
//VPSUBSB xmm1{k1}{z}, xmm2, xmm3 / m128  EVEX.128.66.0F.WIG E8 / r
//VPSUBSB ymm1{k1}{z}, ymm2, ymm3 / m256  EVEX.256.66.0F.WIG E8 / r
//VPSUBSB zmm1{k1}{z}, zmm2, zmm3 / m512  EVEX.512.66.0F.WIG E8 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpsubsb",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                       1,  1, { 0xe8, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsubsb",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                       1,  1, { 0xe8, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsubsb",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                       1,  1, { 0xe8, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsubsb",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                       1,  1, { 0xe8, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsubsb",    3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_ONLY | EVEX_MASK | EVEX_Z),           1,  1, { 0xe8, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsubsb",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_ONLY | EVEX_MASK | EVEX_Z),           1,  1, { 0xe8, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPSUBSW xmm1, xmm2, xmm3 / m128           VEX.128.66.0F.WIG E9 / r
//VPSUBSW ymm1, ymm2, ymm3 / m256           VEX.256.66.0F.WIG E9 / r
//VPSUBSW xmm1{k1}{z}, xmm2, xmm3 / m128  EVEX.128.66.0F.WIG E9 / r
//VPSUBSW ymm1{k1}{z}, ymm2, ymm3 / m256  EVEX.256.66.0F.WIG E9 / r
//VPSUBSW zmm1{k1}{z}, zmm2, zmm3 / m512  EVEX.512.66.0F.WIG E9 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpsubsw",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                         1,  1, { 0xe9, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsubsw",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                         1,  1, { 0xe9, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsubsw",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                         1,  1, { 0xe9, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsubsw",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                         1,  1, { 0xe9, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsubsw",    3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_ONLY | EVEX_MASK | EVEX_Z),             1,  1, { 0xe9, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsubsw",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_ONLY | EVEX_MASK | EVEX_Z),             1,  1, { 0xe9, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPSUBUSB xmm1, xmm2, xmm3 / m128VEX.128.66.0F.WIG D8 / r
//VPSUBUSB ymm1, ymm2, ymm3 / m256VEX.256.66.0F.WIG D8 / r
//VPSUBUSB xmm1{k1}{z}, xmm2, xmm3 / m128EVEX.128.66.0F.WIG D8 / r
//VPSUBUSB ymm1{k1}{z}, ymm2, ymm3 / m256EVEX.256.66.0F.WIG D8 / r
//vpsubusb zmm1{k1}{z}, zmm2, zmm3 / m512EVEX.512.66.0F.WIG D8 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpsubusb",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                       1,  1, { 0xd8, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsubusb",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                       1,  1, { 0xd8, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsubusb",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                       1,  1, { 0xd8, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsubusb",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                       1,  1, { 0xd8, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsubusb",    3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_ONLY | EVEX_MASK | EVEX_Z),           1,  1, { 0xd8, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsubusb",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_ONLY | EVEX_MASK | EVEX_Z),           1,  1, { 0xd8, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPSUBUSW xmm1, xmm2, xmm3 / m128VEX.128.66.0F.WIG D9 / r
//VPSUBUSW ymm1, ymm2, ymm3 / m256VEX.256.66.0F.WIG D9 / r
//VPSUBUSW xmm1{k1}{z}, xmm2, xmm3 / m128EVEX.128.66.0F.WIG D9 / r
//VPSUBUSW ymm1{k1}{z}, ymm2, ymm3 / m256EVEX.256.66.0F.WIG D9 / r
//vpsubusw zmm1{k1}{z}, zmm2, zmm3 / m512EVEX.512.66.0F.WIG D9 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpsubusw",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                         1,  1, { 0xd9, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsubusw",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                         1,  1, { 0xd9, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsubusw",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                         1,  1, { 0xd9, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsubusw",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                         1,  1, { 0xd9, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpsubusw",    3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_ONLY | EVEX_MASK | EVEX_Z),             1,  1, { 0xd9, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpsubusw",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_ONLY | EVEX_MASK | EVEX_Z),             1,  1, { 0xd9, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPXOR xmm1, xmm2, xmm3 / m128 VEX.128.66.0F.WIG EF / r
//VPXOR ymm1, ymm2, ymm3 / m256 VEX.256.66.0F.WIG EF / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpxor",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (NO_EVEX),                                    1,  1, { 0xef, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpxor",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (NO_EVEX),                                    1,  1, { 0xef, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpxor",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (NO_EVEX),                                    1,  1, { 0xef, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpxor",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (NO_EVEX),                                    1,  1, { 0xef, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPXORD xmm1{k1}{z}, xmm2, xmm3 / m128 / m32bcst EVEX.128.66.0F.W0 EF / r
//VPXORD ymm1{k1}{z}, ymm2, ymm3 / m256 / m32bcst EVEX.256.66.0F.W0 EF / r
//VPXORD zmm1{k1}{z}, zmm2, zmm3 / m512 / m32bcst EVEX.512.66.0F.W0 EF / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpxord",     3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),                    1,  1, { 0xef, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpxord",     3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),                    1,  1, { 0xef, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpxord",     3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),         4,  1, { 0xef, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpxord",     3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),                    1,  1, { 0xef, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpxord",     3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),                    1,  1, { 0xef, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpxord",     3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),         8,  1, { 0xef, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpxord",     3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),                    1,  1, { 0xef, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpxord",     3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),                    1,  1, { 0xef, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpxord",     3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),         16, 1, { 0xef, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPXORQ xmm1{k1}{z}, xmm2, xmm3 / m128 / m64bcst EVEX.128.66.0F.W1 EF / r
//VPXORQ ymm1{k1}{z}, ymm2, ymm3 / m256 / m64bcst EVEX.256.66.0F.W1 EF / r
//VPXORQ zmm1{k1}{z}, zmm2, zmm3 / m512 / m64bcst EVEX.512.66.0F.W1 EF / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpxorq",     3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                    1,  1, { 0xef, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpxorq",     3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                    1,  1, { 0xef, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpxorq",     3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),         2,  1, { 0xef, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpxorq",     3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                    1,  1, { 0xef, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpxorq",     3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                    1,  1, { 0xef, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpxorq",     3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),         4,  1, { 0xef, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpxorq",     3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                    1,  1, { 0xef, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpxorq",     3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                    1,  1, { 0xef, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpxorq",     3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),         8,  1, { 0xef, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPUNPCKHBW xmm1, xmm2, xmm3 / m128         VEX.128.66.0F.WIG 68 / r
//VPUNPCKHBW ymm1, ymm2, ymm3 / m256         VEX.256.66.0F.WIG 68 / r
//VPUNPCKHBW xmm1{k1}{z}, xmm2, xmm3 / m128 EVEX.128.66.0F.WIG 68 / r
//VPUNPCKHBW ymm1{k1}{z}, ymm2, ymm3 / m256 EVEX.256.66.0F.WIG 68 / r
//vpunpckhbw zmm1{k1}{z}, zmm2, zmm3 / m512 EVEX.512.66.0F.WIG 68 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpunpckhbw",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                         1,  1, { 0x68, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpunpckhbw",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                         1,  1, { 0x68, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpunpckhbw",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                         1,  1, { 0x68, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpunpckhbw",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                         1,  1, { 0x68, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpunpckhbw",    3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_ONLY | EVEX_MASK | EVEX_Z),             1,  1, { 0x68, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpunpckhbw",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_ONLY | EVEX_MASK | EVEX_Z),             1,  1, { 0x68, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPUNPCKHWD xmm1, xmm2, xmm3 / m128         VEX.128.66.0F.WIG 69 / r
//VPUNPCKHWD ymm1, ymm2, ymm3 / m256         VEX.256.66.0F.WIG 69 / r
//VPUNPCKHWD xmm1{k1}{z}, xmm2, xmm3 / m128 EVEX.128.66.0F.WIG 69 / r
//VPUNPCKHWD ymm1{k1}{z}, ymm2, ymm3 / m256 EVEX.256.66.0F.WIG 69 / r
//vpunpckhwd zmm1{k1}{z}, zmm2, zmm3 / m512 EVEX.512.66.0F.WIG 69 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpunpckhwd",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                         1,  1, { 0x69, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpunpckhwd",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                         1,  1, { 0x69, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpunpckhwd",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                         1,  1, { 0x69, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpunpckhwd",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                         1,  1, { 0x69, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpunpckhwd",    3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_ONLY | EVEX_MASK | EVEX_Z),             1,  1, { 0x69, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpunpckhwd",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_ONLY | EVEX_MASK | EVEX_Z),             1,  1, { 0x69, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPUNPCKHDQ xmm1, xmm2, xmm3 / m128                   VEX.128.66.0F.WIG 6A / r
//VPUNPCKHDQ ymm1, ymm2, ymm3 / m256                   VEX.256.66.0F.WIG 6A / r
//VPUNPCKHDQ xmm1{k1}{z}, xmm2,xmm3 / m128 / m32bcst  EVEX.128.66.0F.W0 6A / r
//VPUNPCKHDQ ymm1{k1}{z}, ymm2,ymm3 / m256 / m32bcst  EVEX.256.66.0F.W0 6A / r
//vpunpckhdq zmm1{k1}{z}, zmm2,zmm3 / m512 / m32bcst  EVEX.512.66.0F.W0 6A / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpunpckhdq",     3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x6a, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpunpckhdq",     3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x6a, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpunpckhdq",     3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),      4,  1, { 0x6a, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpunpckhdq",     3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x6a, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpunpckhdq",     3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x6a, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpunpckhdq",     3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),      8,  1, { 0x6a, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpunpckhdq",     3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),                     1,  1, { 0x6a, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpunpckhdq",     3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),                     1,  1, { 0x6a, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpunpckhdq",     3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),          16, 1, { 0x6a, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPUNPCKHQDQ xmm1, xmm2, xmm3 / m128                  VEX.128.66.0F.WIG 6D / r
//VPUNPCKHQDQ ymm1, ymm2, ymm3 / m256                  VEX.256.66.0F.WIG 6D / r
//VPUNPCKHQDQ xmm1{k1}{z}, xmm2,xmm3 / m128 / m64bcst EVEX.128.66.0F.W1 6D / r
//VPUNPCKHQDQ ymm1{k1}{z}, ymm2,ymm3 / m256 / m64bcst EVEX.256.66.0F.W1 6D / r
//vpunpckhqdq zmm1{k1}{z}, zmm2,zmm3 / m512 / m64bcst EVEX.512.66.0F.W1 6D / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpunpckhqdq",     3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x6d, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpunpckhqdq",     3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x6d, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpunpckhqdq",     3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),      2,  1, { 0x6d, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpunpckhqdq",     3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x6d, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpunpckhqdq",     3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x6d, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpunpckhqdq",     3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),      4,  1, { 0x6d, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpunpckhqdq",     3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                     1,  1, { 0x6d, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpunpckhqdq",     3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                     1,  1, { 0x6d, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpunpckhqdq",     3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),          8,  1, { 0x6d, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPUNPCKLBW xmm1, xmm2, xmm3 / m128VEX.128.66.0F.WIG 60 / r
//VPUNPCKLBW ymm1, ymm2, ymm3 / m256VEX.256.66.0F.WIG 60 / r
//VPUNPCKLBW xmm1{k1}{z}, xmm2, xmm3 / m128EVEX.128.66.0F.WIG 60 / r
//VPUNPCKLBW ymm1{k1}{z}, ymm2, ymm3 / m256EVEX.256.66.0F.WIG 60 / r
//VPUNPCKLBW zmm1{k1}{z}, zmm2, zmm3 / m512EVEX.512.66.0F.WIG 60 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpunpcklbw",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                         1,  1, { 0x60, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpunpcklbw",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                         1,  1, { 0x60, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpunpcklbw",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                         1,  1, { 0x60, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpunpcklbw",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                         1,  1, { 0x60, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpunpcklbw",    3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_ONLY | EVEX_MASK | EVEX_Z),             1,  1, { 0x60, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpunpcklbw",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_ONLY | EVEX_MASK | EVEX_Z),             1,  1, { 0x60, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPUNPCKLWD xmm1, xmm2, xmm3 / m128VEX.128.66.0F.WIG 61 / r
//VPUNPCKLWD ymm1, ymm2, ymm3 / m256VEX.256.66.0F.WIG 61 / r
//VPUNPCKLWD xmm1{k1}{z}, xmm2, xmm3 / m128EVEX.128.66.0F.WIG 61 / r
//VPUNPCKLWD ymm1{k1}{z}, ymm2, ymm3 / m256EVEX.256.66.0F.WIG 61 / r
//VPUNPCKLWD zmm1{k1}{z}, zmm2, zmm3 / m512EVEX.512.66.0F.WIG 61 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpunpcklwd",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                         1,  1, { 0x61, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpunpcklwd",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                         1,  1, { 0x61, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpunpcklwd",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                         1,  1, { 0x61, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpunpcklwd",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_MASK | EVEX_Z),                         1,  1, { 0x61, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpunpcklwd",    3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_ONLY | EVEX_MASK | EVEX_Z),             1,  1, { 0x61, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpunpcklwd",    3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),            (EVEX_ONLY | EVEX_MASK | EVEX_Z),             1,  1, { 0x61, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPUNPCKLDQ xmm1, xmm2, xmm3 / m128VEX.128.66.0F.WIG 62 / r
//VPUNPCKLDQ ymm1, ymm2, ymm3 / m256VEX.256.66.0F.WIG 62 / r
//VPUNPCKLDQ xmm1{k1}{z}, xmm2,xmm3 / m128 / m32bcstEVEX.128.66.0F.W0 62 / r
//VPUNPCKLDQ ymm1{k1}{z}, ymm2,ymm3 / m256 / m32bcstEVEX.256.66.0F.W0 62 / r
//VPUNPCKLDQ zmm1{k1}{z}, zmm2,zmm3 / m512 / m32bcstEVEX.512.66.0F.W0 62 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpunpckldq",     3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x62, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpunpckldq",     3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x62, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpunpckldq",     3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),      4,  1, { 0x62, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpunpckldq",     3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x62, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpunpckldq",     3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x62, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpunpckldq",     3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),      8,  1, { 0x62, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpunpckldq",     3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),                     1,  1, { 0x62, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpunpckldq",     3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),                     1,  1, { 0x62, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpunpckldq",     3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),          16, 1, { 0x62, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VPUNPCKLQDQ xmm1, xmm2, xmm3 / m128VEX.128.66.0F.WIG 6C / r
//VPUNPCKLQDQ ymm1, ymm2, ymm3 / m256VEX.256.66.0F.WIG 6C / r
//VPUNPCKLQDQ xmm1{k1}{z}, xmm2,xmm3 / m128 / m64bcstEVEX.128.66.0F.W1 6C / r
//VPUNPCKLQDQ ymm1{k1}{z}, ymm2,ymm3 / m256 / m64bcstEVEX.256.66.0F.W1 6C / r
//vpunpcklqdq zmm1{k1}{z}, zmm2,zmm3 / m512 / m64bcstEVEX.512.66.0F.W1 6C / r
/* ----------------------------------------------------------------------------------------------- */
{ "vpunpcklqdq",     3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x6c, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpunpcklqdq",     3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x6c, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpunpcklqdq",     3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),      2,  1, { 0x6c, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpunpcklqdq",     3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x6c, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpunpcklqdq",     3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x6c, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpunpcklqdq",     3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),      4,  1, { 0x6c, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpunpcklqdq",     3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                     1,  1, { 0x6c, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vpunpcklqdq",     3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                     1,  1, { 0x6c, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vpunpcklqdq",     3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),          8,  1, { 0x6c, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VRCPPS xmm1, xmm2 / m128VEX.128.0F.WIG 53 / r
//VRCPPS ymm1, ymm2 / m256VEX.256.0F.WIG 53 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vrcpps",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (NO_EVEX),                                    1,  1, { 0x53, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vrcpps",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (NO_EVEX),                                    1,  1, { 0x53, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vrcpps",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (NO_EVEX),                                    1,  1, { 0x53, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vrcpps",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (NO_EVEX),                                    1,  1, { 0x53, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VRCPSS xmm1, xmm2, xmm3 / m32 VEX.LIG.F3.0F.WIG 53 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vrcpss",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_LIG | VEX_F3 | VEX_0F | VEX_NDS | EVEX),            (NO_EVEX),                                    1,  1, { 0x53, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vrcpss",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_LIG | VEX_F3 | VEX_0F | VEX_NDS | EVEX),            (NO_EVEX),                                    1,  1, { 0x53, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VRSQRTPS xmm1, xmm2 / m128VEX.128.0F.WIG 52 / r
//VRSQRTPS ymm1, ymm2 / m256VEX.256.0F.WIG 52 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vrcpps",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (NO_EVEX),                                    1,  1, { 0x52, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vrcpps",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (NO_EVEX),                                    1,  1, { 0x52, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vrcpps",    3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (NO_EVEX),                                    1,  1, { 0x52, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vrcpps",    3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),            (NO_EVEX),                                    1,  1, { 0x52, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VRSQRTSS xmm1, xmm2, xmm3 / m32 VEX.LIG.F3.0F.WIG 52 / r
/* ----------------------------------------------------------------------------------------------- */
{ "vrcpss",    3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_LIG | VEX_F3 | VEX_0F | VEX_NDS | EVEX),            (NO_EVEX),                 1,  1, { 0x52, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vrcpss",    3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_LIG | VEX_F3 | VEX_0F | VEX_NDS | EVEX),            (NO_EVEX),                 1,  1, { 0x52, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VSHUFPD xmm1, xmm2, xmm3 / m128,imm8  VEX.128.66.0F.WIG C6 / r ib
//VSHUFPD ymm1, ymm2, ymm3 / m256,imm8  VEX.256.66.0F.WIG C6 / r ib
//VSHUFPD xmm1{k1}{z}, xmm2,xmm3 / m128 / m64bcst, imm8 EVEX.128.66.0F.W1 C6 / r ib
//VSHUFPD ymm1{k1}{z}, ymm2,ymm3 / m256 / m64bcst, imm8 EVEX.256.66.0F.W1 C6 / r ib
//vshufpd zmm1{k1}{z}, zmm2,zmm3 / m512 / m64bcst, imm8 EVEX.512.66.0F.W1 C6 / r ib
/* ----------------------------------------------------------------------------------------------- */
{ "vshufpd",     4, { R_XMM,  R_XMM, R_XMM,  IMM8  }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | IMM8_ONLY),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z),                 1,  1, { 0xc6, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vshufpd",     4, { R_XMM,  R_XMM, M128,   IMM8  }, AVX0, (F_MODRM | F_MODRM_REG | IMM8_ONLY),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z),                 1,  1, { 0xc6, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vshufpd",     4, { R_XMM,  R_XMM, M_ANY,  IMM8  }, AVX0, (F_MODRM | F_MODRM_REG | IMM8_ONLY),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),      2,  1, { 0xc6, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vshufpd",     4, { R_YMM,  R_YMM, R_YMM,  IMM8  }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM | IMM8_ONLY),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z),                 1,  1, { 0xc6, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vshufpd",     4, { R_YMM,  R_YMM, M256,   IMM8  }, AVX1, (F_MODRM | F_MODRM_REG | IMM8_ONLY),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z),                 1,  1, { 0xc6, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vshufpd",     4, { R_YMM,  R_YMM, M_ANY,  IMM8  }, AVX1, (F_MODRM | F_MODRM_REG | IMM8_ONLY),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),      4,  1, { 0xc6, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vshufpd",     4, { R_ZMM,  R_ZMM, R_ZMM,  IMM8  }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | IMM8_ONLY),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                     1,  1, { 0xc6, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vshufpd",     4, { R_ZMM,  R_ZMM, M512,   IMM8  }, EVX0, (F_MODRM | F_MODRM_REG | IMM8_ONLY),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                     1,  1, { 0xc6, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vshufpd",     4, { R_ZMM,  R_ZMM, M_ANY,  IMM8  }, EVX0, (F_MODRM | F_MODRM_REG | IMM8_ONLY),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),          8,  1, { 0xc6, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VSHUFPS xmm1, xmm2,xmm3 / m128, imm8                   VEX.128.0F.WIG C6 / r ib
//VSHUFPS ymm1, ymm2,ymm3 / m256, imm8                   VEX.256.0F.WIG C6 / r ib
//VSHUFPS xmm1{k1}{z}, xmm2,xmm3 / m128 / m32bcst, imm8 EVEX.128.0F.W0 C6 / r ib
//VSHUFPS ymm1{k1}{z}, ymm2,ymm3 / m256 / m32bcst, imm8 EVEX.256.0F.W0 C6 / r ib
//VSHUFPS zmm1{k1}{z}, zmm2,zmm3 / m512 / m32bcst, imm8 EVEX.512.0F.W0 C6 / r ib
/* ----------------------------------------------------------------------------------------------- */
{ "vshufps",     4, { R_XMM,  R_XMM, R_XMM,  IMM8  }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | IMM8_ONLY),            (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z),                          1,  1, { 0xc6, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vshufps",     4, { R_XMM,  R_XMM, M128,   IMM8  }, AVX0, (F_MODRM | F_MODRM_REG | IMM8_ONLY),                         (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z),                          1,  1, { 0xc6, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vshufps",     4, { R_XMM,  R_XMM, M_ANY,  IMM8  }, AVX0, (F_MODRM | F_MODRM_REG | IMM8_ONLY),                         (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),               4,  1, { 0xc6, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vshufps",     4, { R_YMM,  R_YMM, R_YMM,  IMM8  }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM | IMM8_ONLY),            (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z),                          1,  1, { 0xc6, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vshufps",     4, { R_YMM,  R_YMM, M256,   IMM8  }, AVX1, (F_MODRM | F_MODRM_REG | IMM8_ONLY),                         (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z),                          1,  1, { 0xc6, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vshufps",     4, { R_YMM,  R_YMM, M_ANY,  IMM8  }, AVX1, (F_MODRM | F_MODRM_REG | IMM8_ONLY),                         (VEX | VEX_WIG | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),               8,  1, { 0xc6, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vshufps",     4, { R_ZMM,  R_ZMM, R_ZMM,  IMM8  }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM | IMM8_ONLY),            (EVEX | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),                              1,  1, { 0xc6, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vshufps",     4, { R_ZMM,  R_ZMM, M512,   IMM8  }, EVX0, (F_MODRM | F_MODRM_REG | IMM8_ONLY),                         (EVEX | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),                              1,  1, { 0xc6, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vshufps",     4, { R_ZMM,  R_ZMM, M_ANY,  IMM8  }, EVX0, (F_MODRM | F_MODRM_REG | IMM8_ONLY),                         (EVEX | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),                   16, 1, { 0xc6, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, IMM_OPND_3,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VUCOMISD xmm1, xmm2 / m64       VEX.LIG.66.0F.WIG 2E / r
//vucomisd xmm1, xmm2 / m64{sae} EVEX.LIG.66.0F.W1 2E / r
/* ----------------------------------------------------------------------------------------------- */
{ "vucomisd",      2, { R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_66 | VEX_0F | VEX_LIG | VEX_2OPND | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_SAE),     1,  1, { 0x2e, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vucomisd",      2, { R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_66 | VEX_0F | VEX_LIG | VEX_2OPND | EVEX),            (EVEX_W1 | EVEX_MASK | EVEX_Z),                8,  1, { 0x2e, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */

//VUCOMISS xmm1, xmm2/m32       VEX.LIG.0F.WIG 2E /r
//VUCOMISS xmm1, xmm2/m32{sae} EVEX.LIG.0F.W0 2E /r
/* ----------------------------------------------------------------------------------------------- */
{ "vucomiss",      2, { R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_66 | VEX_0F | VEX_LIG | VEX_2OPND | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_SAE),     1,  1, { 0x2e, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vucomiss",      2, { R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_66 | VEX_0F | VEX_LIG | VEX_2OPND | EVEX),            (EVEX_W0 | EVEX_MASK | EVEX_Z),                4,  1, { 0x2e, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */

//VUNPCKHPD xmm1,xmm2,xmm3/m128VEX.128.66.0F.WIG 15 /r
//VUNPCKHPD ymm1,ymm2,ymm3/m256VEX.256.66.0F.WIG 15 /r
//VUNPCKHPD xmm1 {k1}{z}, xmm2,xmm3/m128/m64bcstEVEX.128.66.0F.W1 15 /r
//VUNPCKHPD ymm1 {k1}{z}, ymm2,ymm3/m256/m64bcstEVEX.256.66.0F.W1 15 /r
//vunpckhpd zmm1 {k1}{z}, zmm2,zmm3/m512/m64bcstEVEX.512.66.0F.W1 15 /r
/* ----------------------------------------------------------------------------------------------- */
{ "vunpckhpd",     3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x15, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vunpckhpd",     3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x15, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vunpckhpd",     3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),      2,  1, { 0x15, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vunpckhpd",     3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x15, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vunpckhpd",     3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x15, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vunpckhpd",     3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),      4,  1, { 0x15, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vunpckhpd",     3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                     1,  1, { 0x15, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vunpckhpd",     3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                     1,  1, { 0x15, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vunpckhpd",     3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),          8,  1, { 0x15, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VUNPCKHPS xmm1, xmm2,xmm3/m128VEX.128.0F.WIG 15 /r
//VUNPCKHPS ymm1, ymm2,ymm3/m256VEX.256.0F.WIG 15 /r
//VUNPCKHPS xmm1 {k1}{z}, xmm2,xmm3/m128/m32bcstEVEX.128.0F.W0 15 /r
//VUNPCKHPS ymm1 {k1}{z}, ymm2,ymm3/m256/m32bcstEVEX.256.0F.W0 15 /r
//vunpckhps zmm1 {k1}{z}, zmm2,zmm3/m512/m32bcstEVEX.512.0F.W0 15 /r
/* ----------------------------------------------------------------------------------------------- */
{ "vunpckhps",     3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x15, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vunpckhps",     3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x15, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vunpckhps",     3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),      4,  1, { 0x15, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vunpckhps",     3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x15, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vunpckhps",     3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x15, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vunpckhps",     3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),      8,  1, { 0x15, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vunpckhps",     3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),                     1,  1, { 0x15, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vunpckhps",     3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),                     1,  1, { 0x15, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vunpckhps",     3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),          16, 1, { 0x15, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VUNPCKLPD xmm1,xmm2,xmm3/m128VEX.128.66.0F.WIG 14 /r
//VUNPCKLPD ymm1,ymm2,ymm3/m256VEX.256.66.0F.WIG 14 /r
//VUNPCKLPD xmm1 {k1}{z}, xmm2,xmm3/m128/m64bcstEVEX.128.66.0F.W1 14 /r
//VUNPCKLPD ymm1 {k1}{z}, ymm2,ymm3/m256/m64bcstEVEX.256.66.0F.W1 14 /r
//vunpcklpd zmm1 {k1}{z}, zmm2,zmm3/m512/m64bcstEVEX.512.66.0F.W1 14 /r
/* ----------------------------------------------------------------------------------------------- */
{ "vunpcklpd",     3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x14, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vunpcklpd",     3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x14, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vunpcklpd",     3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),      2,  1, { 0x14, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vunpcklpd",     3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x14, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vunpcklpd",     3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x14, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vunpcklpd",     3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),      4,  1, { 0x14, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vunpcklpd",     3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                     1,  1, { 0x14, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vunpcklpd",     3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z),                     1,  1, { 0x14, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vunpcklpd",     3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W1 | EVEX_MASK | EVEX_Z | EVEX_BRD),          8,  1, { 0x14, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */
//VUNPCKLPS xmm1,xmm2,xmm3/m128VEX.128.0F.WIG 14 /r
//VUNPCKLPSymm1,ymm2,ymm3/m256VEX.256.0F.WIG 14 /r
//VUNPCKLPS xmm1 {k1}{z}, xmm2,xmm3/m128/m32bcstEVEX.128.0F.W0 14 /r
//VUNPCKLPS ymm1 {k1}{z}, ymm2,ymm3/m256/m32bcstEVEX.256.0F.W0 14 /r
//vunpcklps zmm1 {k1}{z}, zmm2,zmm3/m512/m32bcstEVEX.512.0F.W0 14 /r
/* ----------------------------------------------------------------------------------------------- */
{ "vunpcklps",     3, { R_XMM,  R_XMM, R_XMM         }, AVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x14, 0x00, 0x00 }, 16, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vunpcklps",     3, { R_XMM,  R_XMM, M128          }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x14, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vunpcklps",     3, { R_XMM,  R_XMM, M_ANY         }, AVX0, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),      4,  1, { 0x14, 0x00, 0x00 }, 16, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vunpcklps",     3, { R_YMM,  R_YMM, R_YMM         }, AVX1, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x14, 0x00, 0x00 }, 32, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vunpcklps",     3, { R_YMM,  R_YMM, M256          }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z),                 1,  1, { 0x14, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vunpcklps",     3, { R_YMM,  R_YMM, M_ANY         }, AVX1, (F_MODRM | F_MODRM_REG),                         (VEX | VEX_WIG | VEX_66 | VEX_0F | VEX_NDS | EVEX),        (EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),      8,  1, { 0x14, 0x00, 0x00 }, 32, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vunpcklps",     3, { R_ZMM,  R_ZMM, R_ZMM         }, EVX0, (F_MODRM | F_MODRM_REG | F_MODRM_RM),            (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),                     1,  1, { 0x14, 0x00, 0x00 }, 64, 2, MOD_REG_REG, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     NO_MEM,     P_686 | P_AVX, 0, NULL },
{ "vunpcklps",     3, { R_ZMM,  R_ZMM, M512          }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z),                     1,  1, { 0x14, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
{ "vunpcklps",     3, { R_ZMM,  R_ZMM, M_ANY         }, EVX0, (F_MODRM | F_MODRM_REG),                         (EVEX | VEX_66 | VEX_0F | VEX_NDS),        (EVEX_ONLY | EVEX_W0 | EVEX_MASK | EVEX_Z | EVEX_BRD),          16, 1, { 0x14, 0x00, 0x00 }, 64, 2, MOD_REG_MEM, 0, 0,  0, (X32 | X64), REG_DST, NO_PREFIX, NO_IMM,     MEM_OPND_2, P_686 | P_AVX, 0, NULL },
/* ----------------------------------------------------------------------------------------------- */



  /*     P0  P[7:0]                            P1  P[15:8]                    P2 P[23:16      
  /* |--------------------------------| |---------------------------------| |-------------------------------| */
  /* | 7 | 6 | 5 | 4 | 3 | 2 | 1 | 0  | |  7 | 6 | 5 | 4 | 3 | 2 | 1 | 0  | | 7 | 6 | 5 | 4 | 3 | 2 | 1 | 0 |
  /* |---|---|---|---|---|---|---|----| |----|---|---|---|---|---|---|----| |---|---|---|---|---|---|---|---| */
  /* | R | X | B | R| 0 | 0 | m | m  | |  W | v | v | v | v | 1 | p | p  | | z | L| L | b | V| a | a | a |
  /* |---|----------------------------| |---------------------------------| |-------------------------------| */
//    1   0   1   1
//    1   1   1   0
//62 b1 7d a1 71 f6 04
//62 E1 7D A1 71 F6 04







//https://www.youtube.com/watch?v=AdCuP3KSEmA

//I am a walkimg talking mirakle magnet
//Great things come my way every single day
//I am a divine Source energy being
//Powerful limitless Source energy radiates and flows through every cell of my body
//All my desires exist already, I command the Universe to materialize them
//I am atracting great welth
//I am so happy and greatfull 
//large sooms of money come to me quiclky and easily

};
